<?php


require("../config/dbconn.php");
require('get-currency1.php');

class BookingDao

{


public static function save_page_views($dev,$pname,$method)
{
$data=0;
try
{
$db = Factory::getConnection();


$statement = $db->prepare("INSERT into page_views(
ip ,uid ,ua,ekey,esecret,method,page,tz) 
values(:ip ,:uid ,
:ua ,:ekey ,:esecret ,:method ,:page,:tz)");
$statement->execute(array(':ip'=>$dev->ip,':uid'=>$dev->uid ,
':ua'=>$dev->ua,
':tz'=>$dev->tz ,
':method'=>$method ,':esecret'=>$dev->esecret,':ekey'=>$dev->ekey,
':page'=>$pname));


$data=1;
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function getFinancialYear()
{
//$year = ( date('m') > 4) ? date('Y') + 1 : date('Y');
$year=date('Y');
return $year;
}


public static function get_invoice_list($c)
{

$data=false;
try
{
$db = Factory::getConnection();

$statement = $db->prepare("SELECT sub_ar_doc_number invoice_no,total_local_amt amt from mt_ship_ar_header 
  where sub_ar_status !='CANCELLED' and INSTR(order_no, '$c->order_no') > 0
  UNION 

  SELECT sub_ar_doc_number invoice_no,total_local_amt amt from mt_order_ar_header 
  where sub_ar_status !='CANCELLED' and INSTR(order_no, '$c->order_no') > 0
  ");

$statement->execute();
$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function getFinancialPeriod($doc_date)
{

//$year = ( date('m') > 4) ? date('Y') + 1 : date('Y');
//$period=4;
//return $period;
$data=false;
try
{
$db = Factory::getConnection();

//$aq=self::getRestrictionQuery($dev);
//$doc_date="2019-12-15";
$date=date_create($doc_date);
$m= date_format($date,"F");
$y= date_format($date,"Y");

$statement = $db->prepare("SELECT enumber from mt_period 
  where period=:period and year=:year and open_max='OPEN'");

$statement->execute(array(':period'=>$m,':year'=>$y));
$data=$statement->fetchAll(PDO::FETCH_ASSOC);
//var_dump($statement->debugDumpParams());
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  $p=-10;
  if(count($data)==1)
  {
    $p=$data[0]["enumber"];
  }
  return $p;
}

public static function setFourDigit($v)
{
  $len=strlen($v);

if($len==1)
{
  $v="000".$v;
}else if($len==2)
{
  $v="00".$v;
}else if($len==3)
{
  $v="0".$v;
}

return $v;
}

//generating sequence no for voucher doc type
public static function generate_voucher_no($db,$dev,$table,$temp_code)
{
$data=array();
$result=0;

$table=strtolower($table);
$statement = $db->prepare("INSERT into ".$table."(
  created_by,created_date,temp_code) 
values(:created_by,now(),:temp_code)");
$statement->execute(array(
  ':created_by'=>$dev->username ,
':temp_code'=>$temp_code
));

if ($statement->rowCount()){
  $data["status"]=1;
} else{
  $data["status"]=0;
}

/*$statement = $db->prepare("SELECT id from $table where created_by=:created_by and temp_code=:temp_code ");
$statement->execute(array(':temp_code'=>$temp_code,
  ':created_by'=>$dev->username));
$data["id"]=$statement->fetchAll(PDO::FETCH_ASSOC);
$result=$data["id"][0]["id"];*/

$statement = $db->prepare("SELECT COUNT(*)+1 rid FROM $table where id<(SELECT id from $table where created_by=:created_by and temp_code=:temp_code) ");
$statement->execute(array(':temp_code'=>$temp_code,
  ':created_by'=>$dev->username));
$data["id"]=$statement->fetchAll(PDO::FETCH_ASSOC);
$result=$data["id"][0]["rid"];
  
  return $result;
}


public static function save_voucher_preparation_payable_gst($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();
$db->beginTransaction();

$info=$c->info;
$vpds=$c->cd;
$h=$vpds[0];

$customer_code=$info->party_name;

$temp_code=uniqid($dev->uid);
$statement = $db->prepare("SELECT limit_amount,credit_days from mt_bp_credit where account_type in('ACCOUNTS PAYABLE','BOTH') and bp_id=(SELECT id from mt_business_partner 
  where code=:customer_code)");
$statement->execute(array(':customer_code'=>$customer_code));
$cls=$statement->fetchAll(PDO::FETCH_ASSOC);

$due_date=date('Y-m-d');
$lc=0;
if(count($cls)==1)
{
$due_date= date('Y-m-d', strtotime("+".$cls[0]["credit_days"]." day", strtotime($info->doc_date)));
$lc=$cls[0]["limit_amount"];
}


//vat cal
$igst=0;
$gst_percent=0;
//$gst_percent=$c->gst_percent;
$cds=$c->cd;

for($i=0;$i<count($cds);$i++)
{
  $cd=$cds[$i];
  if($cd->tax_percentage!='0')
  {
    $igst+=round($cd->cost_base_amount*$cd->tax_percentage/100,2);
    $gst_percent=$cd->tax_percentage;
  }
  
}
$data["igst"]=$igst;

//CALCULATE GST
$statement = $db->prepare("SELECT pan,gstin,tds_deductee_type from mt_business_partner 
  where code=:customer_code ");
$statement->execute(array(':customer_code'=>$customer_code));
$cdata=$statement->fetchAll(PDO::FETCH_ASSOC);
$billparty_gstin=$cdata[0]["gstin"];
$billparty_pan=$cdata[0]["pan"];
$tds_deductee_type=$cdata[0]["tds_deductee_type"];

$startString=getGSTINStartString($dev);
$len = strlen($startString);
$is_igst=true;

if(substr($billparty_gstin, 0, $len)==$startString)
{
  $c->cgst=round($igst/2,2);
  $c->sgst=round($igst/2,2);
  $c->igst=0;
  $is_igst=false;
}else{
  $c->igst=$igst;
  $c->cgst=0;
  $c->sgst=0;  
  $is_igst=true;
}


//1
$statement = $db->prepare("INSERT into mt_ap_header 
(aph_company,aph_code,aph_group,aph_document_base,aph_document_type,aph_limit_base,aph_document_date,aph_gl_date,aph_due_date,aph_other_reference,aph_currency,aph_exchange_rate,aph_foreign_amount,aph_local_amount,aph_narration,aph_post_date,aph_status,aph_notes,aph_loc_reference,
  ip,created_by ,ua,ekey,created_date,temp_code,company_id,location_id,child,lpo_order,tds_appl_amt) 
VALUES
( :company,:customer_code,:activity,:voucher_type,:doc_type,
  :limit_amount,
  :doc_date,:doc_date,:due_date,:ref,:currency,:ex_rate,:base_amt_dr,:local_amt_dr,:narration,:doc_date,'POSTED','',:ref_date,
  :ip ,:created_by ,:ua ,:ekey,now(),:temp_code,:company_id,:location_id,:child,:lpo_order,:tds_appl_amt)");

if($h->ex_rate=="")
{
  $h->ex_rate=null;
}
if($h->rate_cost=="")
{
  $h->rate_cost=null;
}
if($h->cost_base_amount=="")
{
  $h->cost_base_amount=null;
}

if($info->famt=="")
{
  $info->famt=null;
}

if($info->lamt=="")
{
  $info->lamt=null;
}


$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->username ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,

':company'=>$dev->company,
':customer_code'=>$customer_code,
':activity'=>'',
':voucher_type'=>'ACCOUNTS PAYABLE',
':doc_type'=>'LPO',

':limit_amount'=>$lc,
':doc_date'=>$info->doc_date,
':due_date'=>$due_date,
':ref'=>$info->ref,
':ref_date'=>$info->doc_date,
':currency'=>$h->currency,
':ex_rate'=>$h->ex_rate,
':base_amt_dr'=>$info->famt*(-1),
':local_amt_dr'=>$info->lamt*(-1),
':narration'=>$info->narration,

':temp_code'=>$temp_code,
':company_id'=>$dev->company,
':location_id'=>$dev->location,
':child'=>json_encode($vpds),
':lpo_order'=>$info->order_no,
':tds_appl_amt'=>$info->tds_appl_amt
));

if ($statement->rowCount()){
  $data["status"]=1;
} else{
  $data["status"]=0;
}

$statement = $db->prepare("SELECT id from mt_ap_header where created_by=:uid and temp_code=:temp_code");
$statement->execute(array(':temp_code'=>$temp_code,
  ':uid'=>$dev->username));
$op=$statement->fetchAll(PDO::FETCH_ASSOC);

$data["id"]=$op;

//set doc number
$fid=self::setFourDigit($op[0]["id"]);
$vgen=self::generate_voucher_no($db,$dev,'LPO',$temp_code);
$fid=self::setFourDigit($vgen);
$fid2=$op[0]["id"];

$vtype="LPO";


$on=$vtype."/".date("Y")."/".date('m')."/".$fid;

 $statement = $db->prepare("UPDATE mt_ap_header 
  SET aph_document_number=:ond where id=:id");
  $statement->execute(array(':id'=>$op[0]["id"],':ond'=>$on));
  
    if ($statement->rowCount()){
    $data["docid_status"]=1;
  } else{
    $data["docid_status"]=0;
  }

$data["doc_no"]=$on;

$doc_no=$on;

$child_count=0;
$child_status_count=0;
$child_order_status_count=0;
//query 2
for($i=0;$i<count($vpds);$i++)
{
$child_count+=1;

$r=$vpds[$i];
$temp_code=uniqid($dev->uid);
$q="";
$qv="";
$r->allocation='SHIP';
if($r->order_type=="SEA IMPORT" or $r->order_type=="SEA EXPORT")
{
  $r->allocation="ORDER";
}
//if order type sea order/ agency ship


if($r->allocation=="SHIP")
{
  $statement = $db->prepare("SELECT t1.voyage,t1.vessel,t1.liner,bl_no,t2.manifest_type,t1.port from mt_voyage t1, mt_manifest_entry t2 WHERE
  t1.voyage=t2.voyage and t2.order_no=:order_no");
  $statement->execute(array(':order_no'=>$info->order_no));
$bls=$statement->fetchAll(PDO::FETCH_ASSOC);
  
  if(count($bls)==1)
  {
    $ai=(object)$bls[0];
  $q="voyage,vessel,liner,bl_no,ship_activity";
  $qv="'$ai->voyage','$ai->vessel','$ai->liner','$ai->bl_no',''";
  }else{
      $q="voyage,vessel,liner,bl_no,ship_activity";
  $qv="'','','','',''";
  $ai=new stdClass();
  $ai->voyage='';
  $ai->vessel='';
  $ai->liner='';
  $ai->port='';
  $ai->bl_no='';
  $ai->manifest_type='';
  }
  
 //insert in the ship trans
  $fy=self::getFinancialYear();
  $fp=self::getFinancialPeriod($info->doc_date);


$statement->execute();
}

if($r->allocation=="ORDER")
{
  
  $q="order_type,order_no,order_activity";
  $qv="'$r->order_type','$info->order_no',''";
}


if($r->ex_rate=="")
{
  $r->ex_rate=null;
}

$statement = $db->prepare("INSERT into mt_ap_allocation_details 
(aloc_company,aloc_base_doc,aloc_doc_type,aloc_doc_number,aloc_allocation_type,aloc_foreign_amount,aloc_local_amount,
  aloc_narration,aloc_currency,aloc_ex_rate,
  reference,ref_date,
  aloc_detail_1, aloc_detail_5,expense_gl,
  $q,
ip,created_by ,ua,ekey,created_date,temp_code,location_id,company_id,tax_percentage,aloc_detail_2)
VALUES
(:company,:voucher_type,:doc_type,:doc_no,:allocation,
  :base_amt_cr,:local_amt_cr,
  :narration,:currency,:ex_rate,
:reference,:ref_date,
(SELECT expense_gl from mt_charge_group_detail 
  where code='$r->charge_desc'),(SELECT expense_gl from mt_charge_group_detail 
  where code='$r->charge_desc'),(SELECT expense_gl from mt_charge_group_detail 
  where code='$r->charge_desc'),
$qv,
  :ip ,:created_by ,:ua ,:ekey,now(),:temp_code,:location_id,:company_id,
  :tax_percentage,:aloc_detail_2)");

$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->username ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,
':temp_code'=>$temp_code,

':company'=>$dev->company,
':voucher_type'=>'ACCOUNTS PAYABLE',
':doc_type'=>'LPO',
':doc_no'=>$doc_no,

':aloc_detail_2'=>$r->qty,
':allocation'=>$r->allocation,
':local_amt_cr'=>$r->cost_base_amount*(-1), //cot base amt
':base_amt_cr'=>$r->rate_cost*(-1), //cost
':narration'=>$r->charge_desc, //charge desc
':currency'=>$r->currency,
':ex_rate'=>$r->ex_rate,

':reference'=>$info->ref,
':ref_date'=>$info->doc_date,

':location_id'=>$dev->location,
':company_id'=>$dev->company,
':tax_percentage'=>$r->tax_percentage

));

if ($statement->rowCount()){
  $data["ahd_status-".($i+1)]=1;
  $child_status_count+=1;

} else{
  $data["ahd_status-".($i+1)]=0;
}

if($data["ahd_status-".($i+1)]==1)
{
  $statement = $db->prepare("UPDATE mt_order_cost set inv_pay_no=:doc_no,invoiced=1
     where id=:id and inv_pay_no is null");
  $statement->execute(array(':doc_no'=>$doc_no,':id'=>$r->id));
  if ($statement->rowCount()){
  $child_order_status_count+=1;
  $data["cost_ahd_status-".($i+1)]=1;
} else{
  $data["cost_ahd_status-".($i+1)]=0;
}
}

}
//query 2 ends


$c->customer_name=$customer_code;
$c->order_no=$info->order_no;
$c->voucher_type="ACCOUNTS PAYABLE";
$c->amount_after_deduction=0;
$c->gst_percent=$gst_percent;
$c->ref_inv_no="";
$c->ref_inv_date="";
$c->trx_date="";

//cgst 2
//INPUT CGST 2-30-001-0001

if($c->cgst!=0){
  $statement = $db->prepare("INSERT into mt_ap_allocation_details 
  (aloc_company,aloc_base_doc,aloc_doc_type,aloc_doc_number,aloc_allocation_type,aloc_foreign_amount,aloc_local_amount,
    aloc_narration,aloc_currency,aloc_ex_rate,
    reference,ref_date,
    ref_inv_no, ref_inv_date,order_no,
    aloc_detail_1,aloc_detail_2,aloc_detail_3, 
    aloc_detail_5,amount_after_deduction,gst_percent,
    expense_gl,
  ip,created_by ,ua,ekey,created_date,temp_code,company_id,location_id)
  VALUES
  (:company,:voucher_type,'INPUT CGST',:doc_no,'INPUT CGST',
    :base_amt_cr,:local_amt_cr,
    :narration,'INR',1,
  :reference,:ref_date,
  :ref_inv_no, :ref_inv_date,:order_no,
  '2-30-001-0001','$c->customer_name','$c->order_no',
  '2-30-001-0001',:amount_after_deduction,:gst_percent,
  '2-30-001-0001',
    :ip ,:created_by ,:ua ,:ekey,now(),:temp_code,:company_id,:location_id) ");

  $statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->username ,
  ':ua'=>$dev->ua,
  ':ekey'=>$dev->ekey,
  ':temp_code'=>$temp_code,

  ':company'=>$dev->company,
  ':voucher_type'=>$c->voucher_type,
  ':doc_no'=>$doc_no,

  ':base_amt_cr'=>$c->cgst*(-1),
  ':local_amt_cr'=>$c->cgst*(-1),
  ':amount_after_deduction'=>$c->amount_after_deduction,
  ':narration'=>'INPUT CGST '.$c->gst_percent.'%',

  ':gst_percent'=>$c->gst_percent,

  ':order_no'=>$c->order_no,
  ':ref_inv_no'=>$c->ref_inv_no,
  ':ref_inv_date'=>$c->ref_inv_date,
  ':reference'=>$c->order_no,
  ':ref_date'=>$c->trx_date,

  ':company_id'=>$dev->company,
  ':location_id'=>$dev->location

  ));

  if ($statement->rowCount()){
    $data["cgst_status"]=1;
  } else{
    $data["cgst_status"]=0;
  }  
}
//cgst 2 ends

//sgst 2
//INPUT SGST 2-30-001-0005

if($c->sgst!=0){
  $statement = $db->prepare("INSERT into mt_ap_allocation_details 
  (aloc_company,aloc_base_doc,aloc_doc_type,aloc_doc_number,aloc_allocation_type,aloc_foreign_amount,aloc_local_amount,
    aloc_narration,aloc_currency,aloc_ex_rate,
    reference,ref_date,
    ref_inv_no, ref_inv_date,order_no,
    aloc_detail_1,aloc_detail_2,aloc_detail_3, 
    aloc_detail_5,amount_after_deduction,gst_percent,
    expense_gl,
  ip,created_by ,ua,ekey,created_date,temp_code,company_id,location_id)
  VALUES
  (:company,:voucher_type,'INPUT SGST',:doc_no,'INPUT SGST',
    :base_amt_cr,:local_amt_cr,
    :narration,'INR',1,
  :reference,:ref_date,
  :ref_inv_no, :ref_inv_date,:order_no,
  '2-30-001-0005','$c->customer_name','$c->order_no',
  '2-30-001-0005',:amount_after_deduction,:gst_percent,
  '2-30-001-0005',
    :ip ,:created_by ,:ua ,:ekey,now(),:temp_code,:company_id,:location_id) ");

  $statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->username ,
  ':ua'=>$dev->ua,
  ':ekey'=>$dev->ekey,
  ':temp_code'=>$temp_code,

  ':company'=>$dev->company,
  ':voucher_type'=>$c->voucher_type,
  ':doc_no'=>$doc_no,

  ':base_amt_cr'=>$c->sgst*(-1),
  ':local_amt_cr'=>$c->sgst*(-1),
  ':amount_after_deduction'=>$c->amount_after_deduction,
  ':narration'=>'INPUT SGST '.$c->gst_percent.'%',

  ':gst_percent'=>$c->gst_percent,

  ':order_no'=>$c->order_no,
  ':ref_inv_no'=>$c->ref_inv_no,
  ':ref_inv_date'=>$c->ref_inv_date,
  ':reference'=>$c->order_no,
  ':ref_date'=>$c->trx_date,

':company_id'=>$dev->company,
':location_id'=>$dev->location  

  ));

  if ($statement->rowCount()){
    $data["sgst_status"]=1;
  } else{
    $data["sgst_status"]=0;
  }  
}
//sgst 2 ends

//igst 2
//INPUT IGST  2-30-001-0003

if($c->igst!=0){
  $statement = $db->prepare("INSERT into mt_ap_allocation_details 
  (aloc_company,aloc_base_doc,aloc_doc_type,aloc_doc_number,aloc_allocation_type,aloc_foreign_amount,aloc_local_amount,
    aloc_narration,aloc_currency,aloc_ex_rate,
    reference,ref_date,
    ref_inv_no, ref_inv_date,order_no,
    aloc_detail_1,aloc_detail_2,aloc_detail_3, 
    aloc_detail_5,amount_after_deduction,gst_percent,
    expense_gl,
  ip,created_by ,ua,ekey,created_date,temp_code,company_id,location_id)
  VALUES
  (:company,:voucher_type,'INPUT IGST',:doc_no,'INPUT IGST',
    :base_amt_cr,:local_amt_cr,
    :narration,'INR',1,
  :reference,:ref_date,
  :ref_inv_no, :ref_inv_date,:order_no,
  '2-30-001-0003','$c->customer_name','$c->order_no',
  '2-30-001-0003',:amount_after_deduction,:gst_percent,
  '2-30-001-0003',
    :ip ,:created_by ,:ua ,:ekey,now(),:temp_code,:company_id,:location_id) ");

  $statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->username ,
  ':ua'=>$dev->ua,
  ':ekey'=>$dev->ekey,
  ':temp_code'=>$temp_code,

  ':company'=>$dev->company,
  ':voucher_type'=>$c->voucher_type,
  ':doc_no'=>$doc_no,

  ':base_amt_cr'=>$c->igst*(-1),
  ':local_amt_cr'=>$c->igst*(-1),
  ':amount_after_deduction'=>$c->amount_after_deduction,
  ':narration'=>'INPUT IGST '.$c->gst_percent.'%',

  ':gst_percent'=>$c->gst_percent,

  ':order_no'=>$c->order_no,
  ':ref_inv_no'=>$c->ref_inv_no,
  ':ref_inv_date'=>$c->ref_inv_date,

  ':reference'=>$c->order_no,
  ':ref_date'=>$c->trx_date,

':company_id'=>$dev->company,
':location_id'=>$dev->location  

  ));

  if ($statement->rowCount()){
    $data["igst_status"]=1;
  } else{
    $data["igst_status"]=0;
  }  
}
//igst 2 ends

$tds_todo=true;
$tds_percent=0;
$c->tds_appl_amt=$info->tds_appl_amt;
$ref_inv_date=date('Y-m-d');
if($c->tds_appl_amt!=0){
  //$c->tds_appl_after_deduction=($c->tds_appl_amt-$c->deduction);
  $c->tds_appl_after_deduction=$c->tds_appl_amt;
}else{
  $c->tds_appl_after_deduction=0;
}

//CALCULATE TDS
if($c->tds_appl_after_deduction!=0){

  //CHECK IF SPECIAL TDS EXISTS
  $statement = $db->prepare("SELECT lower_tax_tds 
  FROM mt_bp_tds_rate t1
  left join mt_business_partner t2
  on t1.bp_id=t2.id 
  where t2.code=:customer_code 
  and :ref_inv_date between t1.applicable_from and t1.applicable_to ");
  $statement->execute(array(':customer_code'=>$customer_code,
    ':ref_inv_date'=>$ref_inv_date));
  $sp_tdsdata=$statement->fetchAll(PDO::FETCH_ASSOC);

  if ($statement->rowCount()){
      $tds_percent=$sp_tdsdata[0]["lower_tax_tds"];
  }
  //echo $tds_percent;

  $statement = $db->prepare("SELECT 
  case when :deductee_type='P' or :deductee_type='H' THEN
  t1.p_or_h
  ELSE
  t1.others
  end as 'tds_percent',t2.ac_description 
  FROM mt_tds_master t1
  left join mt_ledger_tds_link_master t2
  on t1.section=t2.section 
  where :ref_inv_date between t1.applicable_from and t1.applicable_to ");
  $statement->execute(array(':deductee_type'=>$tds_deductee_type,':ref_inv_date'=>$c->ref_inv_date));
  $tdsdata=$statement->fetchAll(PDO::FETCH_ASSOC);
  //ASSIGN IF SPECIAL RATE NOT EXISTS
  if($tds_percent==0 && count($tdsdata)>=1){
    $tds_percent=$tdsdata[0]["tds_percent"];
    $ac_description=$tdsdata[0]["ac_description"];
  }
  //echo $tds_percent;
  //$ac_description=$tdsdata[0]["ac_description"];

  //ROUND TDS DECIMAL ZERO
  $c->tds=round(($c->tds_appl_after_deduction*$tds_percent)/100,2);

}else{
  $c->tds=0;
}
$data["tds_percent"]=$tds_percent;
$data["tds_amt"]=$c->tds;
if($tds_todo)
{
  //tdsquery 2
  //2-30-001-0031 - TDS On Contractor - 194C
  //2-30-001-0039 - TDS PAYABLE REVERSE - 194C

  $tds_lc="2-30-001-0031";
  $tds_desc="TDS PAYABLE";

  /*if ($c->doc_type=="DEBIT NOTE"){
    $tds_lc="2-30-001-0039";
    $tds_desc="TDS PAYABLE REVERSE";
  }*/

  if($c->tds!=0){
    $statement = $db->prepare("INSERT into mt_ap_allocation_details 
    (aloc_company,aloc_base_doc,aloc_doc_type,aloc_doc_number,aloc_allocation_type,aloc_foreign_amount,aloc_local_amount,
      aloc_narration,aloc_currency,aloc_ex_rate,
      reference,ref_date,
      ref_inv_no, ref_inv_date,order_no,
      aloc_detail_1,aloc_detail_2,aloc_detail_3, 
      aloc_detail_5,tds_appl_amt,tds_appl_after_deduction,gst_percent,
      expense_gl,
    ip,created_by ,ua,ekey,created_date,temp_code,company_id,location_id)
    VALUES
    (:company,:voucher_type,'$tds_desc',:doc_no,'$tds_desc',
      :base_amt_cr,:local_amt_cr,
      :narration,'INR',1,
    :reference,:ref_date,
    :ref_inv_no, :ref_inv_date,:order_no,
    '$tds_lc','$c->customer_name','$c->order_no',
    '$tds_lc',:tds_appl_amt,:tds_appl_after_deduction,:gst_percent,
    '$tds_lc',
      :ip ,:created_by ,:ua ,:ekey,now(),:temp_code,:company_id,:location_id) ");

    $statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->username ,
    ':ua'=>$dev->ua,
    ':ekey'=>$dev->ekey,
    ':temp_code'=>$temp_code,

    ':company'=>$dev->company,
    ':voucher_type'=>$c->voucher_type,
    ':doc_no'=>$doc_no,

    ':base_amt_cr'=>$c->tds,
    ':local_amt_cr'=>$c->tds,
    ':tds_appl_amt'=>$c->tds_appl_amt,
    ':tds_appl_after_deduction'=>$c->tds_appl_after_deduction,
    ':narration'=>$tds_desc,

    ':gst_percent'=>$c->gst_percent,

    ':order_no'=>$c->order_no,
    ':ref_inv_no'=>$c->ref_inv_no,
    ':ref_inv_date'=>$c->ref_inv_date,

    ':reference'=>$c->order_no,
    ':ref_date'=>$c->trx_date,

    ':company_id'=>$dev->company,
    ':location_id'=>$dev->location

    ));

    if ($statement->rowCount()){
      $data["tds_status"]=1;
    } else{
      $data["tds_status"]=0;
    }  
  }
}

//query 3
$statement = $db->prepare("INSERT into mt_ap_trans 
(apt_company,apt_code,
apt_base_type,apt_type,apt_number,apt_serial,apt_group,
apt_internal,apt_other_reference,
apt_doc_date,apt_gl_date,apt_year,apt_period,apt_age_date,apt_dp_date,
apt_currency,apt_ex_rate,apt_foreign_amount,
apt_local_amount,apt_foreign_balance,
apt_local_balance,apt_balance_status,
apt_description,apt_notes,
ip,created_by ,ua,ekey,created_date,temp_code,
location_id,company_id )

SELECT aph_company,'$c->customer_name',
'ACCOUNTS PAYABLE','LPO',aph_document_number,0,'SHIP',
0,aph_narration,
'$info->doc_date','$info->doc_date',".self::getFinancialYear().",".
self::getFinancialPeriod($info->doc_date).",'$info->doc_date','$info->doc_date',
'INR',aph_exchange_rate,aph_local_amount,
aph_local_amount,aph_local_amount,
aph_local_amount,'POSTED',
aph_narration,aph_notes,
ip,created_by,ua ,ekey,now(),'$temp_code',
location_id,company_id  
FROM mt_ap_header where aph_document_number=:doc_no
 ");

$statement->execute(array(':doc_no'=>$doc_no));

if ($statement->rowCount()){
  $data["ap_trans_status"]=1;
} else{
  $data["ap_trans_status"]=0;
}

//query 3b
$statement = $db->prepare("INSERT into mt_ap_trans 
(apt_company,apt_code,
apt_base_type,apt_type,apt_number,apt_serial,apt_group,
apt_internal,apt_other_reference,
apt_doc_date,apt_gl_date,apt_year,apt_period,apt_age_date,apt_dp_date,
apt_currency,apt_ex_rate,apt_foreign_amount,
apt_local_amount,apt_foreign_balance,
apt_local_balance,apt_balance_status,
apt_description,apt_notes,
ip,created_by ,ua,ekey,created_date,temp_code,
location_id,company_id )

SELECT aloc_company,'$c->customer_name',
aloc_base_doc,aloc_doc_type,aloc_doc_number,aloc_serial,aloc_allocation_type,
0,aloc_narration,
'$info->doc_date','$info->doc_date',".self::getFinancialYear().",".
self::getFinancialPeriod($info->doc_date).",'$info->doc_date','$info->doc_date',
aloc_currency,aloc_ex_rate,aloc_foreign_amount,
aloc_local_amount,aloc_foreign_amount,
aloc_local_amount,'POSTED',
aloc_detail_1,aloc_detail_2,
ip,created_by,ua ,ekey,now(),'$temp_code',
location_id,company_id  
FROM mt_ap_allocation_details where aloc_doc_number=:doc_no and aloc_doc_type in('INPUT CGST','INPUT SGST','INPUT IGST','TDS PAYABLE')
 ");

$statement->execute(array(':doc_no'=>$doc_no));

if ($statement->rowCount()){
  $data["ap_trans_status-b1"]=1;
} else{
  $data["ap_trans_status-b1"]=0;
}
//query 3 ends


//query 4 part2 child
$statement = $db->prepare("INSERT into mt_ap_gl_details
(pre_glt_company,pre_glt_code,pre_glt_doc_base,pre_glt_doc_type,
  pre_glt_doc_number,pre_glt_serial,pre_glt_doc_date,
  pre_glt_gl_date,pre_glt_year,pre_glt_period,
  pre_glt_other_reference,pre_glt_currency,
  pre_glt_ex_rate,pre_glt_foreign_amount,
  pre_glt_local_amount,pre_glt_narration,
  pre_glt_allocation_code,pre_glt_detail_1,
  pre_glt_detail_2,pre_glt_detail_3,
ip,created_by ,ua,ekey,created_date,temp_code,location_id,company_id,pre_glt_detail_10)
SELECT aloc_company,expense_gl,
aloc_base_doc,aloc_doc_type,
aloc_doc_number,aloc_serial,'$info->doc_date',
'$info->doc_date',".self::getFinancialYear().",".
self::getFinancialPeriod($info->doc_date).",aloc_narration,aloc_currency,
aloc_ex_rate,aloc_foreign_amount,
aloc_local_amount,aloc_narration,
aloc_allocation_type,aloc_detail_1,
aloc_detail_2,aloc_detail_3,
ip,created_by,ua ,ekey,now(),'$temp_code',location_id,company_id,aloc_detail_2  
FROM mt_ap_allocation_details where aloc_doc_number=:id
");

$statement->execute(array(':id'=>$doc_no));

if ($statement->rowCount()){
  $data["ah_gl_status2"]=1;
} else{
  $data["ah_gl_status2"]=0;
}
//query 4 part2 ends


//query 5
$statement = $db->prepare("INSERT into mt_ap_trans_balance
(apdm_company,apdm_code,apdm_doc_type,apdm_doc_number,
  apdm_serial,apdm_other_reference,apdm_date,apdm_currency,
  apdm_ex_rate,apdm_of_amount,apdm_ol_amount,apdm_bf_amount,
  apdm_bl_amount,apdm_pf_amount,apdm_pl_amount,apdm_status,
ip,created_by ,ua,ekey,created_date,temp_code,company_id,location_id)
SELECT apt_company,apt_code,apt_type,apt_number,
apt_serial,apt_other_reference,apt_gl_date,apt_currency,
apt_ex_rate,apt_foreign_amount,apt_local_amount,
apt_foreign_balance,apt_local_balance,
0,0,'PENDING',ip,created_by,ua,ekey,now(),'$temp_code',
'$dev->company','$dev->location'  
 from mt_ap_trans where apt_number=:doc_no
");

$statement->execute(array(':doc_no'=>$doc_no));

if ($statement->rowCount()){
  $data["tb_status"]=1;
} else{
  $data["tb_status"]=0;
}
//query 5 ends

//query 6
$statement = $db->prepare("INSERT into mt_ap_balance
( apb_company,apb_code,apb_year,apb_period,apb_debit,apb_credit,
  ip,created_by ,ua,ekey,
  created_date,temp_code,
  company_id,location_id) 
SELECT '$dev->company','$customer_code',".self::getFinancialYear().",".
self::getFinancialPeriod($info->doc_date).",sum(apt_local_amount),sum(apt_local_amount),
'$dev->ip','$dev->username' ,'$dev->ua','$dev->ekey',
now(),'$temp_code',
'$dev->company','$dev->location' 
 from mt_ap_trans where apt_number=:doc_no");

$statement->execute(array(':doc_no'=>$doc_no));

if ($statement->rowCount()){
  $data["ab_status"]=1;
} else{
  $data["ab_status"]=0;
}
//query 6 ends

$child_status=$child_count==$child_status_count && $child_count==$child_order_status_count;

//$child_status["a"]=2;
//$data["status"]=0;

$gst_status=0;
if($is_igst==true && $c->igst!=0)
{
  $gst_status=$data["igst_status"];
}else if($is_igst==true && $c->igst==0)
{
  $gst_status=1;
}else{
  if($c->cgst==0 && $c->sgst==0)
  {
    $gst_status=1;
  }
  else if($data["cgst_status"]==1 && $data["sgst_status"]==1)
  {
    $gst_status=1;
  }else{
    $gst_status=0;
  }
}

if($data["status"]==1 && $data["docid_status"]==1 && $data["ap_trans_status"]==1 && $data["ah_gl_status2"]==1 && $child_status && $gst_status==1)
{
  $db->commit();
}else{
  $db->rollBack();
  $data["status"]=0;
  $data["msg"]="Unable to save. Please try again";
}

$statement=null;
  }
  catch (Exception $e) {
    //print $e->getMessage();
    $data["emsg"]=$e->getMessage();
    $db->rollBack();
    $data["status"]=0;
    $data["msg"]="Exception caused. Unable to save. Please try again";
  }
  
  return $data;
}


public static function delete_erc_equip($c)
{
$data=array();
try
{
$db = Factory::getConnection();

$statement = $db->prepare("DELETE from mt_erc_equip_detail 
 where id=:id ");

$statement->execute(array(
':id'=>$c
));

if ($statement->rowCount()){
  $data["status"]=1;
} else{
  $data["status"]=0;
}

if($data["status"]==1)
{

  $statement = $db->prepare("DELETE from mt_order_landingcraft_detail  
 where erc_id=:id ");

$statement->execute(array(
':id'=>$c
));

if ($statement->rowCount()){
  $data["lc_status"]=1;
} else{
  $data["lc_status"]=0;
}

}


$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function update_erc_equip($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$statement = $db->prepare("UPDATE mt_erc_equip_detail SET 
equipment_type=:equipment_type,
qty=:qty,
status=:status,
remarks=:remarks
,ip=:ip,created_by=:created_by,ua=:ua,ekey=:ekey,created_date= now() where id=:id and erc_id=:erc_id");

$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->uid ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,

':equipment_type'=>$c->equipment_type,
':qty'=>$c->qty,
':status'=>$c->status,
':remarks'=>$c->remarks,

':erc_id'=>$c->erc_id,
':id'=>$c->id
));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';

} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}


$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}



public static function save_erc_equip($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$temp_code=uniqid($dev->uid);

$statement = $db->prepare("INSERT into mt_erc_equip_detail(equipment_type,qty,status,remarks,erc_id,created_by,created_date,ip,ua,ekey,temp_code) 
values(:equipment_type,:qty,:status,:remarks,:erc_id,
:created_by,now(),:ip,:ua,:ekey,
:temp_code)");

$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->uid ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,

':equipment_type'=>$c->equipment_type,
':qty'=>$c->qty,
':status'=>$c->status,
':remarks'=>$c->remarks,
':erc_id'=>$c->erc_id,

':temp_code'=>$temp_code
));

if ($statement->rowCount()){
  $data["status"]=1;
} else{
  $data["status"]=0;
}

$statement = $db->prepare("SELECT id from mt_erc_equip_detail where created_by=:uid and temp_code=:temp_code and erc_id=:erc_id");
$statement->execute(array(':temp_code'=>$temp_code,
	':uid'=>$dev->uid,':erc_id'=>$c->erc_id));
$data["id"]=$statement->fetchAll(PDO::FETCH_ASSOC);

if($data["status"]==1)
{

  //insert to the order lc
$statement = $db->prepare("INSERT into mt_order_landingcraft_detail(cargo_type,vehicle_type,vin_no,gr_wgt,nt_wgt,tt_wgt,
  commodity,reefer,oog,order_id,
  created_by,created_date,ip,ua,ekey,temp_code,erc_id) 
VALUES
('RORO',:container_type,:container_no,:gross_weight,
:net_weight,:tare_weight,:commodity,:reefer,:oog,
(SELECT id from mt_order_entry where order_no=:eorder),
:created_by,now(),:ip,:ua,:ekey,:temp_code,:erc_id)");
$cd=$c->cd;
$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->username,
  ':ua'=>$dev->ua,':ekey'=>$dev->ekey,
  ':temp_code'=>$temp_code,

':container_no'=>$cd->container_no,
':container_type'=>$cd->container_type,

':gross_weight'=>$cd->gross_weight,
':tare_weight'=>$cd->tare_weight,
':net_weight'=>$cd->net_weight,

':commodity'=>$cd->commodity,
':eorder'=>$c->eorder,

':oog'=>$cd->oog,
':reefer'=>$cd->reefer,
':erc_id'=>$data["id"][0]["id"]
)); 

if ($statement->rowCount()){
  $data["lc_status"]=1;
} else{
  $data["lc_status"]=0;
}

}

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function search_lpo($c)
{

$data=array();
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT id,(SELECT order_type from mt_order_entry where order_no=:order_no) order_type,
  charge_desc,basis_type,basis_uom,qty,
  currency,ex_rate,rate_cost,cost_base_amount 
from mt_order_cost 
WHERE billing_party=:billing_party and type='COST' and 
order_id=(SELECT id from mt_order_entry WHERE order_no=:order_no) and 
inv_pay_no is null");

$statement->execute(array(
':order_no'=>$c->order_no,
':billing_party'=>$c->vendor));

$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function get_lpo_info($code)
{

$data=array();
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT id, aph_document_number doc_no,aph_code code,aph_document_date doc_date,
aph_local_amount lamt,aph_narration narration,created_by,created_date,child,
(SELECT order_no from mt_order_entry where id=(SELECT order_id from mt_order_cost where inv_pay_no=aph_document_number limit 1)) order_no,aph_loc_reference ref,aph_foreign_amount famt,temp_code,tds_appl_amt FROM mt_ap_header where id=:no");


$statement->execute(array(':no'=>$code));

$data["info"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT id,tax_percentage,aloc_doc_number,aloc_narration charge_desc,(
SELECT description from mt_charge_group_detail WHERE code=aloc_narration limit 1) charge_description,aloc_currency currency,aloc_ex_rate ex_rate,aloc_foreign_amount rate_cost,aloc_local_amount cost_base_amount,aloc_detail_2 qty FROM mt_ap_allocation_details where aloc_doc_number=(SELECT aph_document_number 
from mt_ap_header where id=:no limit 1)");

$statement->execute(array(':no'=>$code));
$data["details"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function search_lpo_list($v)
{

$data=array();
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT id, aph_document_number doc_no,aph_code code,aph_document_date doc_date,
aph_local_amount lamt,aph_narration narration, created_by,created_date,
(SELECT order_no from mt_order_entry where id=(SELECT order_id from mt_order_cost where inv_pay_no=aph_document_number limit 1)) order_no
 FROM mt_ap_header where aph_document_number like'LPO%' and 
(aph_code like ? or aph_document_number like ?) order by id desc limit 50");

$statement ->bindValue(1, "%$v%", PDO::PARAM_STR);
$statement ->bindValue(2, "%$v%", PDO::PARAM_STR);

$statement->execute();
$data=$statement->fetchAll(PDO::FETCH_ASSOC);
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function get_lpo_list($code)
{

$data=array();
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT id,aph_status status, aph_document_number doc_no,aph_code code,aph_document_date doc_date,
aph_local_amount lamt,aph_narration narration, created_by,created_date,
(SELECT order_no from mt_order_entry where id=(SELECT order_id from mt_order_cost where inv_pay_no=aph_document_number limit 1)) order_no1,lpo_order order_no FROM mt_ap_header where aph_document_number like'LPO%' order by id desc limit :sta,50");

$statement->bindValue(':sta',(int) $code->start, PDO::PARAM_INT); 
$statement->execute();
$data=$statement->fetchAll(PDO::FETCH_ASSOC);
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function get_erc_info($code)
{

$data=array();
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT id,service_order,order_no,doc_date,valid_till,release_from,return_to,cut_off_date,van_location,van_date,instructions,additional_detail,send_mail,send_to,cc,temp_code from mt_erc where id=:id");

$statement->execute(array(':id'=>$code));

$data["info"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT id,erc_id,equipment_type,qty,status,remarks, '0' edit  
	from mt_erc_equip_detail
	where erc_id=:id");
$statement->execute(array(':id'=>$code));
$data["equip"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_container_acceptance_list()
{

$data=false;
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT container_no,event_code FROM mt_event_updation WHERE event_code='EIC' and cmove_event_code='CURRENT' order by id limit 50");

$statement->execute();
$data=$statement->fetchAll(PDO::FETCH_ASSOC);
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_erc_list($code)
{

$data=false;
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT id,service_order,order_no,valid_till,created_date,created_by,
modified_by,modified_date from mt_erc order by id limit :sta,50");

$statement->bindValue(':sta',(int) $code, PDO::PARAM_INT); 
$statement->execute();

$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function search_erc_list($v)
{

$data=false;
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT id,service_order,order_no,valid_till from mt_erc where service_order like ? or order_no like ? or valid_till like ? order by id limit 50");

$statement ->bindValue(1, "%$v%", PDO::PARAM_STR);
$statement ->bindValue(2, "%$v%", PDO::PARAM_STR);
$statement ->bindValue(3, "%$v%", PDO::PARAM_STR);

$statement->execute();

$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function save_erc($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$temp_code=uniqid($dev->uid);

$statement = $db->prepare("INSERT into mt_erc(service_order,order_no,doc_date,valid_till,release_from,return_to,cut_off_date,van_location,van_date,instructions,additional_detail,send_mail,send_to,cc,created_by,created_date,ip,ua,ekey,temp_code,company_id,location_id) 
values(:service_order,:order_no,:doc_date,:valid_till,:release_from,:return_to,:cut_off_date,:van_location,:van_date,:instructions,:additional_detail,:send_mail,:send_to,:cc,:created_by,now(),:ip,:ua,:ekey,
:temp_code,'$dev->company','$dev->location')");

$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->uid ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,

':service_order'=>$c->service_order,
':order_no'=>$c->order_no,
':doc_date'=>$c->doc_date,
':valid_till'=>$c->valid_till,
':release_from'=>$c->release_from,
':return_to'=>$c->return_to,
':cut_off_date'=>$c->cut_off_date,
':van_location'=>$c->van_location,
':van_date'=>$c->van_date,
':instructions'=>$c->instructions,
':additional_detail'=>$c->additional_detail,
':send_mail'=>$c->send_mail,
':send_to'=>$c->send_to,
':cc'=>$c->cc,


':temp_code'=>$temp_code
));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
  /*

  */
} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}

$statement = $db->prepare("SELECT id from mt_erc where created_by=:uid and temp_code=:temp_code");
$statement->execute(array(':temp_code'=>$temp_code,':uid'=>$dev->uid));
$data["id"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function update_erc($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$statement = $db->prepare("UPDATE mt_erc SET 
service_order=:service_order,
order_no=:order_no,
doc_date=:doc_date,
valid_till=:valid_till,
release_from=:release_from,
return_to=:return_to,
cut_off_date=:cut_off_date,
van_location=:van_location,
van_date=:van_date,
instructions=:instructions,
additional_detail=:additional_detail,
send_mail=:send_mail,
send_to=:send_to,
cc=:cc,
modified_by=:modified_by,
modified_date=now() 
where id=:id");

$statement->execute(array(':modified_by'=>$dev->uid ,

':service_order'=>$c->service_order,
':order_no'=>$c->order_no,
':doc_date'=>$c->doc_date,
':valid_till'=>$c->valid_till,
':release_from'=>$c->release_from,
':return_to'=>$c->return_to,
':cut_off_date'=>$c->cut_off_date,
':van_location'=>$c->van_location,
':van_date'=>$c->van_date,
':instructions'=>$c->instructions,
':additional_detail'=>$c->additional_detail,
':send_mail'=>$c->send_mail,
':send_to'=>$c->send_to,
':cc'=>$c->cc,

':id'=>$c->id
));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
  /*

  */
} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


}

?>