<?php


require("../config/dbconn.php");

class FinanceDao

{


public static function save_page_views($dev,$pname,$method)
{
$data=0;
try
{
$db = Factory::getConnection();


$statement = $db->prepare("INSERT into page_views(
ip ,uid ,ua,ekey,esecret,method,page,tz) 
values(:ip ,:uid ,
:ua ,:ekey ,:esecret ,:method ,:page,:tz)");
$statement->execute(array(':ip'=>$dev->ip,':uid'=>$dev->uid ,
':ua'=>$dev->ua,
':tz'=>$dev->tz ,
':method'=>$method ,':esecret'=>$dev->esecret,':ekey'=>$dev->ekey,
':page'=>$pname));


$data=1;
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function get_matching($db,$c)
{

$statement = $db->prepare("SELECT 2 FROM mt_ar_match_details
 WHERE (arm_t_number =:doc_no or arm_m_number=:doc_no) and 
 arm_status in ('PENDING','COMPLETED')
 UNION
 SELECT 2 FROM mt_ap_match_details
 WHERE (apm_t_number =:doc_no or apm_m_number=:doc_no) and 
 apm_status in ('PENDING','COMPLETED')
 UNION
 SELECT 2 FROM mt_arap_match_details
 WHERE (arm_t_number =:doc_no or arm_m_number=:doc_no) and 
 arm_status in ('PENDING','COMPLETED')
 ");
$statement->execute(array(
  ':doc_no'=>$c->doc_no));
$op=$statement->fetchAll(PDO::FETCH_ASSOC);

return $op;
}

public static function cancel_lpo($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();
$db->beginTransaction();

//check voucher matched or not
//if count is 1 or more then dont allow to cancel
//if 0 then there is no match so allow them to cancel
$op=self::get_matching($db,$c);
if(count($op)>=1)
{
  $data["status"]=0;
  $data["msg"]="Unable to Cancel. Voucher already matched. Please unmatch and try to cancel";
}else{

 //query 1
    $q="UPDATE mt_ap_header set aph_status='CANCELLED',aph_notes=:reason,modified_by=:modified_by,modified_date=now() where aph_document_number=:doc_no";
    $ar=array(':doc_no'=>$c->doc_no,
  ':reason'=>$c->notes,':modified_by'=>$dev->username);
    $data["status"]=self::cancel_voucher_queries($db,$q,$ar);
    if($data["status"]==0)
    {
  $data["msg"]="Unable to cancel the LPO";
    }else{
  $data["msg"]="LPO cancelled successfully.";
    }
     //query 2

         $statement = $db->prepare("UPDATE mt_order_cost 
        set inv_pay_no=NULL,invoiced=NULL,isdraft=0,
        lpo_draft_no=NULL where inv_pay_no=:doc_no");
        $statement->execute(array(':doc_no'=>$c->doc_no));
        if ($statement->rowCount()){
            $data["inv_cost_status"]=1;
          } else{
            $data["inv_cost_status"]=0;
          }


    //query 3
      $q="UPDATE mt_ap_trans set apt_balance_status='CANCELLED',
      modified_date=now(),modified_by=:modified_by 
      where apt_number=:doc_no";
    $ar=array(':doc_no'=>$c->doc_no,':modified_by'=>$dev->username);
    $data["ap_trans_status"]=self::cancel_voucher_queries($db,$q,$ar);

        //query 4
      $q="UPDATE mt_ap_gl_details set pre_glt_status='CANCELLED',
      modified_date=now(),modified_by=:modified_by 
      where pre_glt_doc_number=:doc_no";
    $ar=array(':doc_no'=>$c->doc_no,':modified_by'=>$dev->username);
    $data["gl_status"]=self::cancel_voucher_queries($db,$q,$ar);

        //query 5
      $q="UPDATE mt_ap_trans_balance set apdm_status='CANCELLED',
      modified_date=now(),modified_by=:modified_by 
      where apdm_doc_number=:doc_no";
    $ar=array(':doc_no'=>$c->doc_no,':modified_by'=>$dev->username);
    $data["tb_status"]=self::cancel_voucher_queries($db,$q,$ar);
    
     

    if($data["inv_cost_status"]==1 && $data["status"]==1 && $data["ap_trans_status"]==1 && $data["gl_status"]==1)
      {
        $db->commit();
      }else{
        $db->rollBack();
        $data["status"]=0;
        $data["msg"]="Unable to save. Please try again";
      }

    }


    $statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
    $db->rollBack();

  $data["status"]=0;
  $data["msg"]="Unable to save. Please try again";

  }
  
  return $data;
}

public static function cancel_voucher_queries($db,$query,$ar)
{
$data=10;
$statement = $db->prepare($query);
$statement->execute($ar);
if ($statement->rowCount()){
  $data=1;
} else{
  $data=0;
}
return $data;
}


public static function cancel_voucher_receipt($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();
$db->beginTransaction();

//check voucher matched or not
//if count is 1 or more then dont allow to cancel
//if 0 then there is no match so allow them to cancel
$op=self::get_matching($db,$c);
if(count($op)>=1)
{
  $data["status"]=0;
  $data["msg"]="Unable to Cancel. Voucher already matched. Please unmatch and try to cancel";
}else{

//query 1
    $q="UPDATE mt_receipt_header set rh_status='CANCELLED',rh_notes=:reason,modified_by=:modified_by,modified_date=now() where rh_doc_number=:doc_no";
    $ar=array(':doc_no'=>$c->doc_no,
  ':reason'=>$c->notes,':modified_by'=>$dev->username);

    $data["status"]=self::cancel_voucher_queries($db,$q,$ar);


      //query 3
      $q="UPDATE mt_ar_trans set art_balance_status='CANCELLED',
      modified_date=now(),modified_by=:modified_by 
      where art_number=:doc_no";
    $ar=array(':doc_no'=>$c->doc_no,':modified_by'=>$dev->username);
    $data["ar_trans_status"]=self::cancel_voucher_queries($db,$q,$ar);

    //query 4
      $q="UPDATE mt_receipt_gl_details 
      set pre_glt_status='CANCELLED',
      modified_date=now(),modified_by=:modified_by 
      where pre_glt_doc_number=:doc_no";
    $ar=array(':doc_no'=>$c->doc_no,':modified_by'=>$dev->username);
    $data["gl_status"]=self::cancel_voucher_queries($db,$q,$ar);

    //query 5
      $q="UPDATE mt_ar_trans_balance set ardm_status='CANCELLED',
      modified_date=now(),modified_by=:modified_by 
      where ardm_doc_number=:doc_no";
    $ar=array(':doc_no'=>$c->doc_no,':modified_by'=>$dev->username);
    $data["tb_status"]=self::cancel_voucher_queries($db,$q,$ar);

    //query 6
      $q="UPDATE mt_cash_book_details set cb_status='CANCELLED',
      modified_date=now(),modified_by=:modified_by 
      where cb_doc_number=:doc_no";
    $ar=array(':doc_no'=>$c->doc_no,':modified_by'=>$dev->username);
    $data["cb_status"]=self::cancel_voucher_queries($db,$q,$ar);

    //adding ap cancel also

    //query 3
      $q="UPDATE mt_ap_trans set apt_balance_status='CANCELLED',
      modified_date=now(),modified_by=:modified_by 
      where apt_number=:doc_no";
    $ar=array(':doc_no'=>$c->doc_no,':modified_by'=>$dev->username);
    $data["ap_trans_status"]=self::cancel_voucher_queries($db,$q,$ar);

    //query 5
      $q="UPDATE mt_ap_trans_balance set apdm_status='CANCELLED',
      modified_date=now(),modified_by=:modified_by 
      where apdm_doc_number=:doc_no";
    $ar=array(':doc_no'=>$c->doc_no,':modified_by'=>$dev->username);
    $data["ap_tb_status"]=self::cancel_voucher_queries($db,$q,$ar);

    //

    if($data["status"]==1 && $data["ar_trans_status"] && $data["gl_status"] && $data["cb_status"]==1)
    {
      $db->commit();
      $data["msg"]="Cancelled successfully.";

    }else{
      $db->rollBack();
      $data["msg"]="Unable to save. Please try again.";

    }

}

 $statement=null;
  }
  catch (Exception $e) {
  $data["emsg"]=$e->getMessage();  
  $db->rollBack();
  $data["status"]=0;
  $data["msg"]="Unable to save. Please try again. Exception occurred";

  }
  
  return $data;
}



public static function cancel_voucher_jv($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();
$db->beginTransaction();

//check voucher matched or not
//if count is 1 or more then dont allow to cancel
//if 0 then there is no match so allow them to cancel
$op=self::get_matching($db,$c);
if(count($op)>=1)
{
  $data["status"]=0;
  $data["msg"]="Unable to Cancel. Voucher already matched. Please unmatch and try to cancel";
}else{


/*
  ***************************************
  cancelling jv voucher
  ***************************************

  */

   //query 1
$statement = $db->prepare("UPDATE mt_jv_header 
  SET jvh_status='CANCELLED',jvh_notes=:reason,modified_date=now()  WHERE jvh_doc_number=:doc_no");
$statement->execute(array(
  ':doc_no'=>$c->doc_no,
  ':reason'=>$c->notes));
if ($statement->rowCount()){
  $data["status"]=1;
} else{
  $data["status"]=0;
}
//UPDATE mt_order_ar_header SET sub_ar_status='CANCELLED',sub_ar_notes='madhan requested' WHERE sub_ar_doc_number='IMP-INV/2020/03/DOHA/0018'

  //query 2
$statement = $db->prepare("UPDATE mt_ar_trans 
  SET art_balance_status='CANCELLED' 
WHERE art_number=:doc_no");
$statement->execute(array(
  ':doc_no'=>$c->doc_no));
if ($statement->rowCount()){
  $data["trans_status"]=1;
} else{
  $data["trans_status"]=0;
}
//UPDATE mt_ar_trans SET art_balance_status='CANCELLED' 
//WHERE art_number='IMP-INV/2020/03/DOHA/0018'

  //query 3
$statement = $db->prepare("UPDATE mt_ar_trans_balance SET ardm_status='CANCELLED'
WHERE ardm_doc_number=:doc_no");
$statement->execute(array(
  ':doc_no'=>$c->doc_no));
if ($statement->rowCount()){
  $data["tb_status"]=1;
} else{
  $data["tb_status"]=0;
}

  //query 4
$statement = $db->prepare("UPDATE mt_ap_trans 
  SET apt_balance_status='CANCELLED' 
WHERE apt_number=:doc_no");
$statement->execute(array(
  ':doc_no'=>$c->doc_no));
if ($statement->rowCount()){
  $data["ap_trans_status"]=1;
} else{
  $data["ap_trans_status"]=0;
}
//UPDATE mt_ar_trans SET art_balance_status='CANCELLED' 
//WHERE art_number='IMP-INV/2020/03/DOHA/0018'

  //query 5
$statement = $db->prepare("UPDATE mt_ap_trans_balance SET apdm_status='CANCELLED'
WHERE apdm_doc_number=:doc_no");
$statement->execute(array(
  ':doc_no'=>$c->doc_no));
if ($statement->rowCount()){
  $data["ap_tb_status"]=1;
} else{
  $data["ap_tb_status"]=0;
}

 //query 6
$statement = $db->prepare("UPDATE mt_jv_gl_details 
  SET pre_glt_status='CANCELLED',modified_by=:modified_by,modified_date=now() 
WHERE pre_glt_doc_number=:doc_no");
$statement->execute(array(
  ':doc_no'=>$c->doc_no,':modified_by'=>$dev->username));
if ($statement->rowCount()){
  $data["gl_status"]=1;
} else{
  $data["gl_status"]=0;
}

  if($data["status"]==1 && $data["gl_status"])
    {
      $db->commit();
      $data["msg"]="Cancelled successfully.";

    }else{
      $db->rollBack();
      $data["msg"]="Unable to save. Please try again.";

    }

}

 $statement=null;
  }
  catch (Exception $e) {
  $data["emsg"]=$e->getMessage();  
  $db->rollBack();
  $data["status"]=0;
  $data["msg"]="Unable to save. Please try again. Exception occurred";

  }
  
  return $data;
}


public static function cancel_voucher_invoice($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();
$db->beginTransaction();

//check voucher matched or not
//if count is 1 or more then dont allow to cancel
//if 0 then there is no match so allow them to cancel
$op=self::get_matching($db,$c);
if(count($op)>=1)
{
  $data["status"]=0;
  $data["msg"]="Unable to Cancel. Voucher already matched. Please unmatch and try to cancel";
}else{


/*
  ***************************************
  cancelling invoice
  ***************************************

  */
  //query 1
$statement = $db->prepare("UPDATE mt_ship_ar_header SET sub_ar_status='CANCELLED',sub_ar_notes=:reason,modified_by=:modified_by,modified_date=now() WHERE sub_ar_doc_number=:doc_no");
$statement->execute(array(
  ':doc_no'=>$c->doc_no,
  ':reason'=>$c->notes,
  ':modified_by'=>$dev->username));
if ($statement->rowCount()){
  $data["status"]=1;
} else{
  $data["status"]=0;
  $data["msg"]="Unable to cancel";
}

  //query 2 used to statement of account
//this query fails sometime
$statement = $db->prepare("UPDATE mt_ar_trans 
  SET art_balance_status='CANCELLED', modified_by=:modified_by,modified_date=now() 
WHERE art_number=:doc_no");
$statement->execute(array(
  ':doc_no'=>$c->doc_no,':modified_by'=>$dev->username));
if ($statement->rowCount()){
  $data["trans_status"]=1;
} else{
  $data["trans_status"]=0;
}

  //query 3
$statement = $db->prepare("UPDATE mt_ar_trans_balance SET ardm_status='CANCELLED',modified_by=:modified_by,modified_date=now() 
WHERE ardm_doc_number=:doc_no");
$statement->execute(array(
  ':doc_no'=>$c->doc_no,':modified_by'=>$dev->username));
if ($statement->rowCount()){
  $data["tb_status"]=1;
} else{
  $data["tb_status"]=0;
}

//get order no list
$statement = $db->prepare("SELECT order_no from mt_ship_ar_header where sub_ar_doc_number=:doc_no");
$statement->execute(
  array(':doc_no'=>$c->doc_no)
);

$rows=$statement->fetchAll(PDO::FETCH_ASSOC);
$cds=explode(',',$rows[0]["order_no"]);
for($i=0;$i<count($cds);$i++)
{
  $cd=$cds[$i];
  $data["ono".($i+1)]=$cd;
  
  if(strlen($cd)!=0)
  {
  //query 4
$statement = $db->prepare("UPDATE mt_order_cost set invoiced=null,
modified_by=:modified_by,modified_date=now() where  type='INCOME' and order_id= 
(select id from mt_order_entry where order_no=:order_no )
and charge_desc in 
(SELECT  
  charge_desc
  from mt_ship_ar_details 
  where sub_ard_doc_number=:doc_no
  and sub_ard_detail_6 !='ADDITIONAL') ");
$statement->execute(array(
  ':order_no'=>$cd,
  ':doc_no'=>$c->doc_no,':modified_by'=>$dev->username
));
if ($statement->rowCount()){
  $data["oc_status"]=1;
} else{
  $data["oc_status"]=0;
}

  //query 5
$statement = $db->prepare("UPDATE mt_order_entry 
  set status='OPEN',modified_by=:modified_by,modified_date=now() 
WHERE order_no=:order_no");
$statement->execute(array(
  ':order_no'=>$cd,':modified_by'=>$dev->username));
if ($statement->rowCount()){
  $data["o_status"]=1;
} else{
  $data["o_status"]=0;
}

}
}
  //query 6
$statement = $db->prepare("UPDATE ship_gl_details 
  SET pre_glt_status='CANCELLED',modified_by=:modified_by,modified_date=now() 
WHERE pre_glt_doc_number=:doc_no");
$statement->execute(array(
  ':doc_no'=>$c->doc_no,':modified_by'=>$dev->username));
if ($statement->rowCount()){
  $data["gl_status"]=1;
} else{
  $data["gl_status"]=0;
}

  //query 7
$statement = $db->prepare("UPDATE mt_ship_trans 
  SET st_status='CANCELLED',modified_by=:modified_by,
  modified_date=now() 
WHERE st_doc_number=:doc_no");
$statement->execute(array(
  ':doc_no'=>$c->doc_no,':modified_by'=>$dev->username));
if ($statement->rowCount()){
  $data["st_status"]=1;
} else{
  $data["st_status"]=0;
}

  if($data["status"]==1 && $data["trans_status"] && $data["gl_status"] && $data["st_status"]==1)
    {
      $db->commit();
      $data["msg"]="Cancelled successfully.";

    }else{
      $db->rollBack();
      $data["msg"]="Unable to save. Please try again.";

    }

}

 $statement=null;
  }
  catch (Exception $e) {
  $data["emsg"]=$e->getMessage();  
  $db->rollBack();
  $data["status"]=0;
  $data["msg"]="Unable to save. Please try again. Exception occurred";

  }
  
  return $data;
}



public static function cancel_voucher_forward($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();
$db->beginTransaction();

//check voucher matched or not
//if count is 1 or more then dont allow to cancel
//if 0 then there is no match so allow them to cancel
$op=self::get_matching($db,$c);
if(count($op)>=1)
{
  $data["status"]=0;
  $data["msg"]="Unable to Cancel. Voucher already matched. Please unmatch and try to cancel";
}else{


/*
  ***************************************
  cancelling forward invoice
  ***************************************

  */
  //query 1

  $isPro = false;

if (strpos($c->doc_no, 'PRO/') !== false) {
      $isPro = true;

}
$data["isPro"]=$isPro;

$statement = $db->prepare("UPDATE mt_order_ar_header SET sub_ar_status='CANCELLED',sub_ar_notes=:reason,modified_by=:modified_by,modified_date=now()  WHERE sub_ar_doc_number=:doc_no");
$statement->execute(array(
  ':doc_no'=>$c->doc_no,
  ':reason'=>$c->notes,
  ':modified_by'=>$dev->username
  ));
if ($statement->rowCount()){
  $data["status"]=1;
  $data["msg"]="Cancellation of Voucher is successful";

} else{
  $data["status"]=110;
  $data["msg"]="Unable to cancel";

}
//UPDATE mt_order_ar_header SET sub_ar_status='CANCELLED',sub_ar_notes='madhan requested' WHERE sub_ar_doc_number='IMP-INV/2020/03/DOHA/0018'

  //query 2
$statement = $db->prepare("UPDATE mt_ar_trans 
  SET art_balance_status='CANCELLED',modified_by=:modified_by,modified_date=now() 
WHERE art_number=:doc_no");
$statement->execute(array(
  ':doc_no'=>$c->doc_no,
':modified_by'=>$dev->username));
if ($statement->rowCount()){
  $data["trans_status"]=1;
} else{
  $data["trans_status"]=0;
}
//UPDATE mt_ar_trans SET art_balance_status='CANCELLED' 
//WHERE art_number='IMP-INV/2020/03/DOHA/0018'

  //query 3
$statement = $db->prepare("UPDATE mt_ar_trans_balance SET ardm_status='CANCELLED',modified_by=:modified_by,modified_date=now() 
WHERE ardm_doc_number=:doc_no");
$statement->execute(array(
  ':doc_no'=>$c->doc_no,
':modified_by'=>$dev->username));
if ($statement->rowCount()){
  $data["tb_status"]=1;
} else{
  $data["tb_status"]=0;
}
//UPDATE mt_ar_trans_balance SET ardm_status='CANCELLED'
//WHERE ardm_doc_number='IMP-INV/2020/03/DOHA/0018'

//get order no list
$statement = $db->prepare("SELECT order_no from mt_order_ar_header where sub_ar_doc_number=:doc_no");
$statement->execute(
  array(':doc_no'=>$c->doc_no)
);

$rows=$statement->fetchAll(PDO::FETCH_ASSOC);
$cds=explode(',',$rows[0]["order_no"]);
$order_entry_status_count=0;
$order_cost_status_count=0;
$order_id_count=0;

for($i=0;$i<count($cds);$i++)
{
  $cd=$cds[$i];
  $data["ono".($i+1)]=$cd;

  if(strlen($cd)!=0)
  {
    $order_id_count+=1;
  //query 4
$statement = $db->prepare("UPDATE mt_order_cost set invoiced=null,inv_pay_no=null,modified_by=:modified_by,modified_date=now() where  type='INCOME' and order_id= 
(select id from mt_order_entry where order_no=:order_no )
and id in 
(SELECT  
  charge_id
  from mt_order_ar_details 
  where sub_ard_doc_number=:doc_no
  and sub_ard_detail_6 !='ADDITIONAL') ");
$statement->execute(array(
  ':order_no'=>$cd,
  ':doc_no'=>$c->doc_no,
  ':modified_by'=>$dev->username
));
if ($statement->rowCount()){
  $order_cost_status_count+=1;
  $data["ord_cost_status"]=1;
} else{
  $data["ord_cost_status"]=0;
}
//UPDATE mt_order_cost set invoiced=null where  type='INCOME' and order_id= 
//(select id from mt_order_entry where order_no='SEA-I/2020/03/ITGOA/0953' )


  //query 5
$statement = $db->prepare("UPDATE mt_order_entry 
  set status='OPEN',modified_by=:modified_by,modified_date=now()
WHERE order_no=:order_no");
$statement->execute(array(
  ':order_no'=>$cd,
  ':modified_by'=>$dev->username
));
if ($statement->rowCount()){
  $order_entry_status_count+=1;
  $data["ord_entry_status"]=1;
} else{
  $data["ord_entry_status"]=0;
}

}
}
//UPDATE mt_order_entry set status='OPEN'
//WHERE order_no='SEA-I/2020/03/ITGOA/0953'

  //query 6
$statement = $db->prepare("UPDATE mt_order_gl_details 
  SET pre_glt_status='CANCELLED',modified_by=:modified_by,modified_date=now() 
WHERE pre_glt_doc_number=:doc_no");
$statement->execute(array(
  ':doc_no'=>$c->doc_no,
  ':modified_by'=>$dev->username
));
if ($statement->rowCount()){
  $data["gl_status"]=1;
} else{
  $data["gl_status"]=0;
}
/*THERE IS NO DATA IN mt_order_gl_details*/

  //query 7
$statement = $db->prepare("UPDATE mt_order_trans 
  SET ordt_status='CANCELLED',modified_by=:modified_by,modified_date=now() 
WHERE ordt_doc_number=:doc_no");
$statement->execute(array(
  ':doc_no'=>$c->doc_no,
  ':modified_by'=>$dev->username
));
if ($statement->rowCount()){
  $data["ord_trans_status"]=1;
} else{
  $data["ord_trans_status"]=0;
}

//$data["status"]=0;
$check_status=false;
if($isPro)
{
$check_status=$data["status"]==1 && $order_cost_status_count==$order_id_count && $order_entry_status_count==$order_id_count;
}else
{
$check_status=$data["status"]==1 && $data["trans_status"]==1 && $data["tb_status"]==1 && $order_cost_status_count==$order_id_count && $order_entry_status_count==$order_id_count && $data["gl_status"]==1 && $data["ord_trans_status"]=1;
}
if($check_status)
{
  $data["msg"]="Cancellation of Voucher is successful";
  $db->commit();
}else{
  $db->rollBack();
  $data["status"]=0;
  $data["msg"]="Unable to cancel. Please try again";
}

}

 $statement=null;
  }
  catch (Exception $e) {
  $data["emsg"]=$e->getMessage();  
  $db->rollBack();
  $data["status"]=0;
  $data["msg"]="Unable to save. Please try again. Exception occurred";

  }
  
  return $data;
}



public static function cancel_voucher_payment($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();
$db->beginTransaction();

//check voucher matched or not
//if count is 1 or more then dont allow to cancel
//if 0 then there is no match so allow them to cancel
$op=self::get_matching($db,$c);
if(count($op)>=1)
{
  $data["status"]=0;
  $data["msg"]="Unable to Cancel. Voucher already matched. Please unmatch and try to cancel";
}else{



  //query 1
    $q="UPDATE mt_payment_header set ph_status='CANCELLED',ph_notes=:reason,modified_by=:modified_by,modified_date=now() where ph_doc_number=:doc_no";
    $ar=array(':doc_no'=>$c->doc_no,
  ':reason'=>$c->notes,':modified_by'=>$dev->username);
  
    $data["status"]=self::cancel_voucher_queries($db,$q,$ar);
    if($data["status"]==0)
    {
  $data["msg"]="Unable to cancel";
      
    } 

    $data["original_status"]=$data["status"];
      //query 3
      $q="UPDATE mt_ap_trans set apt_balance_status='CANCELLED',
      modified_date=now(),modified_by=:modified_by 
      where apt_number=:doc_no";
    $ar=array(':doc_no'=>$c->doc_no,':modified_by'=>$dev->username);
    $data["ap_trans_status"]=self::cancel_voucher_queries($db,$q,$ar);

    //additional condition
    $statement = $db->prepare("SELECT * FROM mt_payment_allocation_details 
      WHERE aloc_doc_number=:doc_no and aloc_allocation_type='ACCOUNTS PAYABLE'");
    $statement->execute(array(':doc_no'=>$c->doc_no));
    $datas1=$statement->fetchAll(PDO::FETCH_ASSOC);
    if(count($datas1)==0)
    {
      $data["ap_trans_status"]=1;
      $data["no_ap_trans_status"]=1;
    }
    //query 4
      $q="UPDATE mt_payment_gl_details 
      set pre_glt_status='CANCELLED',
      modified_date=now(),modified_by=:modified_by 
      where pre_glt_doc_number=:doc_no";
    $ar=array(':doc_no'=>$c->doc_no,':modified_by'=>$dev->username);
    $data["gl_status"]=self::cancel_voucher_queries($db,$q,$ar);

    //query 5
      $q="UPDATE mt_ap_trans_balance set apdm_status='CANCELLED',
      modified_date=now(),modified_by=:modified_by 
      where apdm_doc_number=:doc_no";
    $ar=array(':doc_no'=>$c->doc_no,':modified_by'=>$dev->username);
    $data["tb_status"]=self::cancel_voucher_queries($db,$q,$ar);

    //query 6
      $q="UPDATE mt_cash_book_details set cb_status='CANCELLED',
      modified_date=now(),modified_by=:modified_by 
      where cb_doc_number=:doc_no";
    $ar=array(':doc_no'=>$c->doc_no,':modified_by'=>$dev->username);
    $data["cb_status"]=self::cancel_voucher_queries($db,$q,$ar);

    //adding ar trans also

    //query 3
      $q="UPDATE mt_ar_trans set art_balance_status='CANCELLED',
      modified_date=now(),modified_by=:modified_by 
      where art_number=:doc_no";
    $ar=array(':doc_no'=>$c->doc_no,':modified_by'=>$dev->username);
    $data["ar_trans_status"]=self::cancel_voucher_queries($db,$q,$ar);


    //query 5
      $q="UPDATE mt_ar_trans_balance set ardm_status='CANCELLED',
      modified_date=now(),modified_by=:modified_by 
      where ardm_doc_number=:doc_no";
    $ar=array(':doc_no'=>$c->doc_no,':modified_by'=>$dev->username);
    $data["ar_tb_status"]=self::cancel_voucher_queries($db,$q,$ar);

  if($data["status"]==1 && $data["ap_trans_status"] && $data["gl_status"] && $data["cb_status"]==1)
    {
      $db->commit();
      $data["msg"]="Cancelled successfully.";

    }else{
      $data["status"]=0;
      $db->rollBack();
      $data["msg"]="Unable to save. Please try again.";

    }

}

 $statement=null;
  }
  catch (Exception $e) {
  $data["emsg"]=$e->getMessage();  
  $db->rollBack();
  $data["status"]=0;
  $data["msg"]="Unable to save. Please try again. Exception occurred";

  }
  
  return $data;
}


public static function cancel_voucher_b2b($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();
$db->beginTransaction();

//check voucher matched or not
//if count is 1 or more then dont allow to cancel
//if 0 then there is no match so allow them to cancel
$op=self::get_matching($db,$c);
if(count($op)>=1)
{
  $data["status"]=0;
  $data["msg"]="Unable to Cancel. Voucher already matched. Please unmatch and try to cancel";
}else{



  //query 1
    $q="UPDATE mt_b2b_header set ph_status='CANCELLED',ph_notes=:reason,modified_by=:modified_by,modified_date=now() where ph_doc_number=:doc_no";
    $ar=array(':doc_no'=>$c->doc_no,
  ':reason'=>$c->notes,':modified_by'=>$dev->username);
  
    $data["status"]=self::cancel_voucher_queries($db,$q,$ar);
    if($data["status"]==0)
    {
  $data["msg"]="Unable to cancel";
      
    } 

    $data["original_status"]=$data["status"];
      //query 3
      $q="UPDATE mt_ap_trans set apt_balance_status='CANCELLED',
      modified_date=now(),modified_by=:modified_by 
      where apt_number=:doc_no";
    $ar=array(':doc_no'=>$c->doc_no,':modified_by'=>$dev->username);
    $data["ap_trans_status"]=self::cancel_voucher_queries($db,$q,$ar);

    //additional condition
    $statement = $db->prepare("SELECT * FROM mt_b2b_allocation_details 
      WHERE aloc_doc_number=:doc_no and aloc_allocation_type='ACCOUNTS PAYABLE'");
    $statement->execute(array(':doc_no'=>$c->doc_no));
    $datas1=$statement->fetchAll(PDO::FETCH_ASSOC);
    if(count($datas1)==0)
    {
      $data["ap_trans_status"]=1;
      $data["no_ap_trans_status"]=1;
    }
    //query 4
      $q="UPDATE mt_payment_gl_details 
      set pre_glt_status='CANCELLED',
      modified_date=now(),modified_by=:modified_by 
      where pre_glt_doc_number=:doc_no";
    $ar=array(':doc_no'=>$c->doc_no,':modified_by'=>$dev->username);
    $data["gl_status"]=self::cancel_voucher_queries($db,$q,$ar);

    //query 5
      $q="UPDATE mt_ap_trans_balance set apdm_status='CANCELLED',
      modified_date=now(),modified_by=:modified_by 
      where apdm_doc_number=:doc_no";
    $ar=array(':doc_no'=>$c->doc_no,':modified_by'=>$dev->username);
    $data["tb_status"]=self::cancel_voucher_queries($db,$q,$ar);

    //query 6
      $q="UPDATE mt_cash_book_details set cb_status='CANCELLED',
      modified_date=now(),modified_by=:modified_by 
      where cb_doc_number=:doc_no";
    $ar=array(':doc_no'=>$c->doc_no,':modified_by'=>$dev->username);
    $data["cb_status"]=self::cancel_voucher_queries($db,$q,$ar);

    //adding ar trans also

    //query 3
      $q="UPDATE mt_ar_trans set art_balance_status='CANCELLED',
      modified_date=now(),modified_by=:modified_by 
      where art_number=:doc_no";
    $ar=array(':doc_no'=>$c->doc_no,':modified_by'=>$dev->username);
    $data["ar_trans_status"]=self::cancel_voucher_queries($db,$q,$ar);


    //query 5
      $q="UPDATE mt_ar_trans_balance set ardm_status='CANCELLED',
      modified_date=now(),modified_by=:modified_by 
      where ardm_doc_number=:doc_no";
    $ar=array(':doc_no'=>$c->doc_no,':modified_by'=>$dev->username);
    $data["ar_tb_status"]=self::cancel_voucher_queries($db,$q,$ar);

  if($data["status"]==1 && $data["ap_trans_status"] && $data["gl_status"] && $data["cb_status"]==1)
    {
      $db->commit();
      $data["msg"]="Cancelled successfully.";

    }else{
      $data["status"]=0;
      $db->rollBack();
      $data["msg"]="Unable to save. Please try again.";

    }

}

 $statement=null;
  }
  catch (Exception $e) {
  $data["emsg"]=$e->getMessage();  
  $db->rollBack();
  $data["status"]=0;
  $data["msg"]="Unable to save. Please try again. Exception occurred";

  }
  
  return $data;
}


public static function cancel_voucher_payable($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();
$db->beginTransaction();

//check voucher matched or not
//if count is 1 or more then dont allow to cancel
//if 0 then there is no match so allow them to cancel
$op=self::get_matching($db,$c);
if(count($op)>=1)
{
  $data["status"]=0;
  $data["msg"]="Unable to Cancel. Voucher already matched. Please unmatch and try to cancel";
}else{


  //query 1
    $q="UPDATE mt_ap_header set aph_status='CANCELLED',aph_notes=:reason,modified_by=:modified_by,modified_date=now() where aph_document_number=:doc_no";
    $ar=array(':doc_no'=>$c->doc_no,
  ':reason'=>$c->notes,':modified_by'=>$dev->username);
    $data["status"]=self::cancel_voucher_queries($db,$q,$ar);
    if($data["status"]==0)
    {
  $data["msg"]="Unable to cancel";
      
    }
     //query 2
    $q="UPDATE mt_ship_trans set st_status='CANCELLED',modified_by=:modified_by,modified_date=now() 
    where st_doc_number=:doc_no";
    $ar=array(':doc_no'=>$c->doc_no,':modified_by'=>$dev->username);
    $data["st_status"]=self::cancel_voucher_queries($db,$q,$ar);

    //query 3
    $q="UPDATE mt_order_trans set ordt_status='CANCELLED',modified_by=:modified_by,modified_date=now() 
    where ordt_doc_number=:doc_no";
    $ar=array(':doc_no'=>$c->doc_no,':modified_by'=>$dev->username);
    $data["ot_status"]=self::cancel_voucher_queries($db,$q,$ar);

    //query 4
      $q="UPDATE mt_ap_trans set apt_balance_status='CANCELLED',
      modified_date=now(),modified_by=:modified_by 
      where apt_number=:doc_no";
    $ar=array(':doc_no'=>$c->doc_no,':modified_by'=>$dev->username);
    $data["ap_trans_status"]=self::cancel_voucher_queries($db,$q,$ar);

        //query 5
      $q="UPDATE mt_ap_gl_details set pre_glt_status='CANCELLED',
      modified_date=now(),modified_by=:modified_by 
      where pre_glt_doc_number=:doc_no";
    $ar=array(':doc_no'=>$c->doc_no,':modified_by'=>$dev->username);
    $data["gl_status"]=self::cancel_voucher_queries($db,$q,$ar);

        //query 6
      $q="UPDATE mt_ap_trans_balance set apdm_status='CANCELLED',
      modified_date=now(),modified_by=:modified_by 
      where apdm_doc_number=:doc_no";
    $ar=array(':doc_no'=>$c->doc_no,':modified_by'=>$dev->username);
    $data["tb_status"]=self::cancel_voucher_queries($db,$q,$ar);

    //query 7A IF AP-AR THEN CANCEL AR Also
      $q="UPDATE mt_ar_trans set art_balance_status='CANCELLED',
      modified_date=now(),modified_by=:modified_by 
      where art_number=:doc_no";
    $ar=array(':doc_no'=>$c->doc_no,':modified_by'=>$dev->username);
    $data["ar_trans_status"]=self::cancel_voucher_queries($db,$q,$ar);

        //query 7B
      $q="UPDATE mt_ar_trans_balance set ardm_status='CANCELLED',
      modified_date=now(),modified_by=:modified_by 
      where ardm_doc_number=:doc_no";
    $ar=array(':doc_no'=>$c->doc_no,':modified_by'=>$dev->username);
    $data["tb1_status"]=self::cancel_voucher_queries($db,$q,$ar);
    //AP-AR cancel ENDS

  if($data["status"]==1 && $data["ap_trans_status"] && $data["gl_status"])
    {
      $db->commit();
      $data["msg"]="Cancelled successfully.";

    }else{
      $db->rollBack();
      $data["msg"]="Unable to save. Please try again.";

    }

}

 $statement=null;
  }
  catch (Exception $e) {
  $data["emsg"]=$e->getMessage();  
  $db->rollBack();
  $data["status"]=0;
  $data["msg"]="Unable to save. Please try again. Exception occurred";

  }
  
  return $data;
}



public static function cancel_voucher_receivable($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();
$db->beginTransaction();

//check voucher matched or not
//if count is 1 or more then dont allow to cancel
//if 0 then there is no match so allow them to cancel
$op=self::get_matching($db,$c);
if(count($op)>=1)
{
  $data["status"]=0;
  $data["msg"]="Unable to Cancel. Voucher already matched. Please unmatch and try to cancel";
}else{

  //query 1
    $q="UPDATE mt_ar_header set arh_status='CANCELLED',arh_notes=:reason,modified_by=:modified_by,modified_date=now() where arh_document_number=:doc_no";
    $ar=array(':doc_no'=>$c->doc_no,
  ':reason'=>$c->notes,':modified_by'=>$dev->username);
    $data["status"]=self::cancel_voucher_queries($db,$q,$ar);
    if($data["status"]==0)
    {
  $data["msg"]="Unable to cancel";
    }else{
  $data["msg"]="Cancellation of Voucher is successful";
    } 
     //query 2
    
    $q="UPDATE mt_ship_trans set st_status='CANCELLED',modified_by=:modified_by,modified_date=now() 
    where st_doc_number=:doc_no";
    $ar=array(':doc_no'=>$c->doc_no,':modified_by'=>$dev->username);
    $data["ship_tr_status"]=self::cancel_voucher_queries($db,$q,$ar);

    //query 3
    $q="UPDATE mt_order_trans set ordt_status='CANCELLED',modified_by=:modified_by,modified_date=now() 
    where ordt_doc_number=:doc_no";
    $ar=array(':doc_no'=>$c->doc_no,':modified_by'=>$dev->username);
    $data["ord_trans_status"]=self::cancel_voucher_queries($db,$q,$ar);

    //query 4
      $q="UPDATE mt_ar_trans set art_balance_status='CANCELLED',
      modified_date=now(),modified_by=:modified_by 
      where art_number=:doc_no";
    $ar=array(':doc_no'=>$c->doc_no,':modified_by'=>$dev->username);
    $data["ar_trans_status"]=self::cancel_voucher_queries($db,$q,$ar);

        //query 5
      $q="UPDATE mt_ar_gl_details set pre_glt_status='CANCELLED',
      modified_date=now(),modified_by=:modified_by 
      where pre_glt_doc_number=:doc_no";
    $ar=array(':doc_no'=>$c->doc_no,':modified_by'=>$dev->username);
    $data["gl_status"]=self::cancel_voucher_queries($db,$q,$ar);

        //query 6
      $q="UPDATE mt_ar_trans_balance set ardm_status='CANCELLED',
      modified_date=now(),modified_by=:modified_by 
      where ardm_doc_number=:doc_no";
    $ar=array(':doc_no'=>$c->doc_no,':modified_by'=>$dev->username);
    $data["tb_status"]=self::cancel_voucher_queries($db,$q,$ar);

    //query 7A - IF voucher is AR-AP THEN cancel AP also
      $q="UPDATE mt_ap_trans set apt_balance_status='CANCELLED',
      modified_date=now(),modified_by=:modified_by 
      where apt_number=:doc_no";
    $ar=array(':doc_no'=>$c->doc_no,':modified_by'=>$dev->username);
    $data["ap_trans_status"]=self::cancel_voucher_queries($db,$q,$ar);

        //query 7B
      $q="UPDATE mt_ap_trans_balance set apdm_status='CANCELLED',
      modified_date=now(),modified_by=:modified_by 
      where apdm_doc_number=:doc_no";
    $ar=array(':doc_no'=>$c->doc_no,':modified_by'=>$dev->username);
    $data["tb1_status"]=self::cancel_voucher_queries($db,$q,$ar);
    //AR-AP cancel ENDS

  if($data["status"]==1 && $data["ar_trans_status"] && $data["gl_status"])
    {
      $db->commit();
      $data["msg"]="Cancelled successfully.";

    }else{
      $db->rollBack();
      $data["msg"]="Unable to save. Please try again.";

    }

}

 $statement=null;
  }
  catch (Exception $e) {
  $data["emsg"]=$e->getMessage();  
  $db->rollBack();
  $data["status"]=0;
  $data["msg"]="Unable to save. Please try again. Exception occurred";

  }
  
  return $data;
}





//end of class
}


?>