<?php

require("../config/dbconn.php");

class CustomerDao

{


public static function save_page_views($dev,$pname,$method)
{
$data=0;
try
{
$db = Factory::getConnection();


$statement = $db->prepare("INSERT into page_views(
ip ,uid ,ua,ekey,esecret,method,page,tz) 
values(:ip ,:uid ,
:ua ,:ekey ,:esecret ,:method ,:page,:tz)");
$statement->execute(array(':ip'=>$dev->ip,':uid'=>$dev->uid ,
':ua'=>$dev->ua,
':tz'=>$dev->tz ,
':method'=>$method ,':esecret'=>$dev->esecret,':ekey'=>$dev->ekey,
':page'=>$pname));


$data=1;
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function search_customer_list($v)
{

$data=false;
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT id,code,name,username,ucreated_by,ucreated_by,ucreated_date,umodified_by,umodified_date from mt_business_partner t1 where username is not null order by id and
(where code like ? or name like ? or username like ?) limit 50");

$statement ->bindValue(1, "$v%", PDO::PARAM_STR);
$statement ->bindValue(2, "$v%", PDO::PARAM_STR);
$statement ->bindValue(3, "$v%", PDO::PARAM_STR);
$statement->execute();
$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_customer_info($uid)
{
$data=array();
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT id,username,'dummyS@PASS123' password,email,code,name,case when deactivate=0 then '' else deactivate end deactivate from mt_business_partner 
 where id=:uid");
$statement->execute(array(':uid'=>$uid));

$data["info"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function save_customer($dev,$c)
{

$data=array();
try
{
$db = Factory::getConnection();
$options = [
    'cost' => 11  
];

$pass_hash=password_hash($c->password, PASSWORD_BCRYPT, $options);

$statement = $db->prepare("UPDATE mt_business_partner 
	set username=:username,password=:password,email=:email,
	verified=1,deactivate=0,ucreated_date=now(),
	ucreated_by=:username1 where code=:code");

$statement->execute(array(':username'=>$c->username,
':password'=>$pass_hash,
':email'=>$c->email,
':username1'=>$dev->username,
':code'=>$c->code));

if ($statement->rowCount()){
  $data["status"]=1;
} else{
  $data["status"]=0;
}

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function update_customer($dev,$c)
{

$data=array();
try
{
$db = Factory::getConnection();
$options = [
    'cost' => 11  
];

if($c->deactivate=="")
{
  $c->deactivate=0;
}
$pass_hash=password_hash($c->password, PASSWORD_BCRYPT, $options);

if($user->password!='dummyS@PASS123')
{
$statement = $db->prepare("UPDATE mt_business_partner 
	set password=:password,email=:email,deactivate=:deactivate,umodified_date=now(),
	umodified_by=:username1 where code=:code");

$statement->execute(array(
':password'=>$pass_hash,
':email'=>$c->email,
':username1'=>$dev->username,
':code'=>$c->code,
':deactivate'=>$c->deactivate));

if ($statement->rowCount()){
  $data["status"]=1;
} else{
  $data["status"]=0;
}

}else{

$statement = $db->prepare("UPDATE mt_business_partner 
	set email=:email,deactivate=:deactivate,umodified_date=now(),
	umodified_by=:username1 where code=:code");

$statement->execute(array(
':email'=>$c->email,
':username1'=>$dev->username,
':code'=>$c->code,
':deactivate'=>$c->deactivate));

if ($statement->rowCount()){
  $data["status"]=1;
} else{
  $data["status"]=0;
}

}

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_customer_list($code)
{

$data=false;
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT id,code,name,username,ucreated_by,ucreated_by,ucreated_date,umodified_by,umodified_date from mt_business_partner t1 where username is not null order by id limit :sta,50");

$statement->bindValue(':sta',(int) $code->start, PDO::PARAM_INT); 
$statement->execute();

$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}



}

?>