<?php

require("../config/dbconn.php");
require("../pdf/cargo-arrival-notice-generate-email.php");
require('../booking/get-currency.php');
require("func-list.php");

class DocumentationDao

{


public static function save_page_views($dev,$pname,$method)
{
$data=0;
try
{
$db = Factory::getConnection();


$statement = $db->prepare("INSERT into page_views(
ip ,uid ,ua,ekey,esecret,method,page,tz) 
values(:ip ,:uid ,
:ua ,:ekey ,:esecret ,:method ,:page,:tz)");
$statement->execute(array(':ip'=>$dev->ip,':uid'=>$dev->uid ,
':ua'=>$dev->ua,
':tz'=>$dev->tz ,
':method'=>$method ,':esecret'=>$dev->esecret,':ekey'=>$dev->ekey,
':page'=>$pname));


$data=1;
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}




public static function save_order_cargo_info($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$temp_code=uniqid($dev->uid);

$statement = $db->prepare("INSERT into mt_manifest_entry_cargo(
  main_commodity,equipment_serial,package_type,no_of_packages,gross_weight,weight_uom,volume,volume_uom,dangerous,reefer,oversize,mnf_entry_pk,created_by,created_date,ip,ua,ekey,temp_code) 
values(:main_commodity,:equipment_serial,:package_type,:no_of_packages,:gross_weight,:weight_uom,:volume,:volume_uom,:dangerous,
:reefer,:oversize,
:mnf_entry_pk,:created_by,now(),:ip,:ua,:ekey,
:temp_code)");

if($c->no_of_packages=="")
{
  $c->no_of_packages=null;
}

if($c->gross_weight=="")
{
  $c->gross_weight=null;
}

if($c->volume=="")
{
  $c->volume=null;
}


$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->uid ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,

':main_commodity'=>$c->main_commodity,
':equipment_serial'=>$c->equipment_serial,
':package_type'=>$c->package_type,
':no_of_packages'=>$c->no_of_packages,
':gross_weight'=>$c->gross_weight,
':weight_uom'=>$c->weight_uom,
':volume'=>$c->volume,
':volume_uom'=>$c->volume_uom,
':dangerous'=>$c->dangerous,
':reefer'=>$c->reefer,
':oversize'=>$c->oversize,


':mnf_entry_pk'=>$c->mnf_entry_pk,
':temp_code'=>$temp_code
));

if ($statement->rowCount()){
  $data["status"]=1;

} else{
  $data["status"]=0;
}

$statement = $db->prepare("SELECT id from mt_manifest_entry_cargo
 where created_by=:uid and temp_code=:temp_code and 
 mnf_entry_pk=:mnf_entry_pk");
$statement->execute(array(':temp_code'=>$temp_code,
  ':uid'=>$dev->uid,':mnf_entry_pk'=>$c->mnf_entry_pk));
$data["id"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function update_order_cargo($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$temp_code=uniqid($dev->uid);

$statement = $db->prepare("UPDATE mt_manifest_entry_cargo SET 
  main_commodity=:main_commodity,
equipment_serial=:equipment_serial,
package_type=:package_type,
no_of_packages=:no_of_packages,
gross_weight=:gross_weight,
weight_uom=:weight_uom,
volume=:volume,
volume_uom=:volume_uom,
dangerous=:dangerous,
reefer=:reefer,
oversize=:oversize,
ip=:ip,created_by=:created_by,ua=:ua,ekey=:ekey,created_date= now() where id=:id and mnf_entry_pk=:mnf_entry_pk");

$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->uid ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,

':main_commodity'=>$c->main_commodity,
':equipment_serial'=>$c->equipment_serial,
':package_type'=>$c->package_type,
':no_of_packages'=>$c->no_of_packages,
':gross_weight'=>$c->gross_weight,
':weight_uom'=>$c->weight_uom,
':volume'=>$c->volume,
':volume_uom'=>$c->volume_uom,
':dangerous'=>$c->dangerous,
':reefer'=>$c->reefer,
':oversize'=>$c->oversize,

':mnf_entry_pk'=>$c->mnf_entry_pk,
':id'=>$c->id
));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}


$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function delete_order_cargo_info($c)
{
$data=array();
try
{
$db = Factory::getConnection();

$statement = $db->prepare("DELETE FROM mt_manifest_entry_cargo
 where id=:id");

$statement->execute(array(
':id'=>$c
));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function get_manifestentry_cargo_list($code)
{

$data=array();
try
{
$db = Factory::getConnection();
//1

$statement = $db->prepare("SELECT id,mnf_entry_pk,main_commodity,equipment_serial,package_type,no_of_packages,gross_weight,weight_uom,volume,volume_uom,dangerous,reefer,oversize, '0' edit from mt_manifest_entry_cargo 
  where mnf_entry_pk=:id");
$statement->execute(array(':id'=>$code));
$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function update_manifestentry_marks($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();


$statement = $db->prepare("UPDATE mt_manifest_entry_marks SET 
 marks=:marks,
description=:description
 where id=:id and mnf_entry_pk=:mnf_entry_pk");

$statement->execute(array(':marks'=>$c->marks,
':description'=>$c->description,

':mnf_entry_pk'=>$c->mnf_entry_pk,
':id'=>$c->id
));

if ($statement->rowCount()){
  $data["status"]=1;

} else{
  $data["status"]=0;
}
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function get_cargo_arrival_notice_detail_info_pdf($id,$bl_no)
{
$data=array();
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT t1.id,
t1.voyage,
(SELECT vessel from mt_voyage where voyage=t1.voyage) vessel,
(SELECT eta from mt_voyage where voyage=t1.voyage) eta,
t1.bl_no,
t1.order_no,
(select port_name from mt_port_master where port_code=t2.poo) poo, 
(select port_name from mt_port_master where port_code=t2.pol) pol, 
(select port_name from mt_port_master where port_code=t2.pod) pod,  
(select port_name from mt_port_master where port_code=t2.pof) pof, 
(select name from mt_business_partner where code=(select party_name from mt_manifest_entry_party 
  where party_type='SHIPPER' and mnf_entry_pk=t1.id)) shipper,
t3.party_name consignee ,t3.email consignee_email,
  
  (select name from mt_business_partner where code=(select party_name from mt_manifest_entry_party 
  where party_type='NOTIFY PARTY' and mnf_entry_pk=t1.id)) notify,
  (select email from mt_manifest_entry_party 
  where party_type='NOTIFY PARTY' and mnf_entry_pk=t1.id)
  notify_email,

(SELECT last_advice_date from mt_cargo_arrival_notice_detail where bl_no=t1.bl_no order by last_advice_date desc limit 1) add1,
'' add2,
'' add3  
from mt_manifest_entry t1, mt_manifest_entry_route t2 ,
(select (select name from mt_business_partner where code=t5.party_name) party_name,email,mnf_entry_pk from mt_manifest_entry_party t5
  where party_type='CONSIGNEE') t3
where t1.id=t2.mnf_entry_pk and 
t1.id=t3.mnf_entry_pk  
and  t1.id=:id and t1.bl_no=:bl_no ");
$statement->execute(array(':id'=>$id,':bl_no'=>$bl_no));
$data["info"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT 
(select name from mt_business_partner where code=t1.party_name) party_name,
(select address from mt_bp_address where type='HQ' and bp_id=(select id from mt_business_partner where code=t1.party_name)) address,
email, telephone 
from mt_manifest_entry_party t1 
where party_type='CONSIGNEE'  
 and mnf_entry_pk=:id");
$statement->execute(array(':id'=>$id));
$data["consignee"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT  container_no, type, gr_wgt, 
  tt_wgt, commodity,reefer
from mt_manifest_entry_container 
 where mnf_entry_pk=:id UNION
 SELECT  vin_no container_no,vehicle_type `type`, gr_wgt, 
  tt_wgt, commodity,reefer
from mt_manifest_entry_landingcraft 
 where mnf_entry_pk=:id");
$statement->execute(array(':id'=>$id));
$data["container"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_blprint_search_list($code)
{

$data=array();
try
{
$db = Factory::getConnection();

 $q="";
$ar=array();

if(strlen($code->bl_no)!=0)
{
$q=$q." and t1.bl_no=:bl_no ";
$ar[':bl_no']=$code->bl_no;

}

// if(strlen($code->voyage)!=0)
// {
// $q=$q."  and t1.voyage=:voyage ";
// $ar[':voyage']=$code->voyage;

// }

$statement = $db->prepare("SELECT '' selected,
  t1.order_no,t1.bl_no,t2.poo,t2.pol,t2.pod,t2.pof,
(select party_name from mt_manifest_entry_party where party_type='SHIPPER' and mnf_entry_pk=t1.id) shipper,
(select party_name from mt_manifest_entry_party where party_type='CONSIGNEE' and mnf_entry_pk=t1.id) consignee, 
(select party_name from mt_manifest_entry_party where party_type='NOTIFY PARTY' and mnf_entry_pk=t1.id) notify,
t1.manifest_type,
t2.vessel,
t2.voyage,
t1.status,
(select count(container_no) from mt_manifest_entry_container where mnf_entry_pk=t1.id) containers, t1.id,t1.temp_code 
 from mt_manifest_entry t1, mt_manifest_entry_route t2 where t1.id=t2.mnf_entry_pk ".$q);

$statement->execute($ar);
$data["bls"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function copy_order_to_export_manifest($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();
$temp_code=uniqid($dev->uid);

//query 1
$statement = $db->prepare("SELECT id, 'DUMMY' principal,cargo_type, order_type, order_no, quote, enquiry_reference,
  (select voyage from mt_order_route where order_id=t1.id) voyage, shipment_terms, shipment_from, shipment_to   
from mt_order_entry t1
where order_no=:order_no and bl_no is null");

$statement->execute(array(':order_no'=>$c->order_no));
$orders=$statement->fetchAll(PDO::FETCH_ASSOC);
$olen=count($orders);
if($olen>=1)
{
$ord=$orders[0];
$order_id=$ord["id"];

//
$statement = $db->prepare("INSERT into mt_manifest_entry(
voyage,
status,
manifest_type,
bl_classification,
cargo_type,
order_no,
so_no,
quotation,
copy_bl_from,
enquiry,
master_bl_no,
free_days,
shipment_terms,
bl_date,
bl_issue_place,
bl_issue_agent,
no_of_original,
no_of_non_neg,
board_status,
sob_rfs_date,
remarks,
to_order,
telex_release,
tsp_bl,
company_id,location_id,ip,created_by, ua,ekey,created_date,temp_code,delivery_agent) 
values(
:voyage,
:status,
:manifest_type,
:bl_classification,
:cargo_type,
:order_no,
:so_no,
:quotation,
:copy_bl_from,
:enquiry,
:master_bl_no,
:free_days,
:shipment_terms,
:bl_date,
:bl_issue_place,
:bl_issue_agent,
:no_of_original,
:no_of_non_neg,
:board_status,
:sob_rfs_date,
:remarks,
:to_order,
:telex_release,
:tsp_bl,
:company_id,:location_id,:ip ,:uid ,:ua ,:ekey,now(),:temp_code,:delivery_agent)");
if($c->bl_date=="")
{
  $c->bl_date=null;
}
if($c->sob_rfs_date=="")
{
  $c->sob_rfs_date=null;
}
$statement->execute(array(':ip'=>$dev->ip,':uid'=>$dev->username ,
  ':ua'=>$dev->ua,':ekey'=>$dev->ekey,

':voyage'=>$ord["voyage"],
':status'=>'CREATED',
':manifest_type'=>$ord["order_type"],
':bl_classification'=>$c->bl_classification,
':cargo_type'=>'CONTAINER',
':order_no'=>$c->order_no,
':so_no'=>$c->so_no,
':quotation'=>$ord["quote"],
':copy_bl_from'=>$c->copy_bl_from,
':enquiry'=>$ord["enquiry_reference"],
':master_bl_no'=>$c->master_bl_no,
':free_days'=>$c->free_days,
':shipment_terms'=>$ord["shipment_terms"],
':bl_date'=>$c->bl_date,
':bl_issue_place'=>$c->bl_issue_place,
':bl_issue_agent'=>$c->bl_issue_agent,
':no_of_original'=>$c->no_of_original,
':no_of_non_neg'=>$c->no_of_non_neg,
':board_status'=>$c->board_status,
':sob_rfs_date'=>$c->sob_rfs_date,
':remarks'=>$c->remarks,
':to_order'=>$c->to_order,
':telex_release'=>$c->telex_release,
':tsp_bl'=>$c->tsp_bl,

':temp_code'=>$temp_code,

':company_id'=>$dev->company,
':location_id'=>$dev->location,
':delivery_agent'=>$c->delivery_agent
));

//
if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}
//query 1 ends

$data["temp_code"]=$temp_code;

//create bl no
$statement = $db->prepare("SELECT id from mt_manifest_entry where created_by=:uid and temp_code=:temp_code");
$statement->execute(array(':temp_code'=>$temp_code,':uid'=>$dev->username));
$op=$statement->fetchAll(PDO::FETCH_ASSOC);

$mnf_entry_pk=$op[0]["id"];

$data["id"]=$op;


$principal=$ord["principal"];
$order_no=$ord["order_no"];

//Generate BL Number
$on=gen_no_for_bl($db,$dev,$order_no,$principal,$ord);

 $statement = $db->prepare("UPDATE mt_manifest_entry 
  SET bl_no=:ond where id=:id");
  $statement->execute(array(':id'=>$mnf_entry_pk,':ond'=>$on));
  
    if ($statement->rowCount()){
    $data["blid_status"]=1;
      //echo 'Success: At least 1 row was affected.';
  } else{
    $data["blid_status"]=0;
      //echo 'Failure: 0 rows were affected.';
  }

$data["bl_no"]=$on;

//query 20
//save cargo
$temp_code=uniqid($dev->uid);
$statement = $db->prepare("INSERT into mt_manifest_entry_cargo(
mnf_entry_pk,
main_commodity,
equipment_serial,
package_type,
no_of_packages,
gross_weight,
weight_uom,
volume,
volume_uom,
dangerous,
reefer,
oversize,
ip,created_by, ua,ekey,created_date,temp_code)
SELECT '$mnf_entry_pk',
main_commodity,
equipment_serial,
package_type,
no_of_packages,
gross_weight,
weight_uom,
volume,
volume_uom,
dangerous,
reefer,
oversize,
'$dev->ip','$dev->username', '$dev->ua',
'$dev->ekey',now(),'$temp_code' 
from mt_order_cargo
where order_id=:order_id");

$statement->execute(array(':order_id'=>$order_id));

if ($statement->rowCount()){
  $data["cargo_status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data["cargo_status"]=0;
    //echo 'Failure: 0 rows were affected.';
}
//query 20 ends

//query 2
//save container
$temp_code=uniqid($dev->uid);
$statement = $db->prepare("INSERT into mt_manifest_entry_container(
mnf_entry_pk,container_no,seal_no,type,package_type,no_of_pkgs,volume,gr_wgt,nt_wgt,tt_wgt,commodity,cargo_desc,reefer,min_temp,max_temp,oog,oh,ow,ol,haz,un_no,flash_type,
ip,created_by, ua,ekey,created_date,temp_code)
SELECT '$mnf_entry_pk',container_no,'' seal_no,type,package_type,no_of_pkgs,volume,gr_wgt,nt_wgt,tt_wgt,commodity,cargo_desc,reefer,min_temp,max_temp,oog,oh,ow,ol,haz,un_no,flash_type,
'$dev->ip','$dev->username', '$dev->ua',
'$dev->ekey',now(),'$temp_code' 
from mt_order_container_detail
where order_id=:order_id");

$statement->execute(array(':order_id'=>$order_id));

if ($statement->rowCount()){
  $data["container_status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data["container_status"]=0;
    //echo 'Failure: 0 rows were affected.';
}
//query 2 ends


//query 3
//landing craft
$temp_code=uniqid($dev->uid);
$statement = $db->prepare("INSERT into mt_manifest_entry_landingcraft(
mnf_entry_pk,cargo_type,vehicle_type,vin_no,chassis_no,package_type,no_of_pkgs,volume,gr_wgt,nt_wgt,tt_wgt,commodity,cargo_desc,reefer,min_temp,max_temp,oog,oh,ow,ol,haz,un_no,flash_type,
ip,created_by, ua,ekey,created_date,temp_code)
SELECT '$mnf_entry_pk',cargo_type,vehicle_type,vin_no,chassis_no,package_type,no_of_pkgs,volume,gr_wgt,nt_wgt,tt_wgt,commodity,cargo_desc,reefer,min_temp,max_temp,oog,oh,ow,ol,haz,un_no,flash_type,
'$dev->ip','$dev->username', '$dev->ua',
'$dev->ekey',now(),'$temp_code' 
from mt_order_landingcraft_detail
where order_id=:order_id");

$statement->execute(array(':order_id'=>$order_id));

if ($statement->rowCount()){
  $data["lc_status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data["lc_status"]=0;
    //echo 'Failure: 0 rows were affected.';
}
//query 3 ends


//query 4
//route
$temp_code=uniqid($dev->uid);
$statement = $db->prepare("INSERT into mt_manifest_entry_route(
mnf_entry_pk,voyage,eline,poo,pol,pod,pof,tsp1,tsp2,tsp3,tsp4,tsp5,
vessel,
eta,
etd,
ip,created_by, ua,ekey,created_date,temp_code
)
SELECT '$mnf_entry_pk',
voyage,provider,efrom,efrom,eto,eto,'' tsp1,'' tsp2,'' tsp3,'' tsp4,'' tsp5,
vessel,
eta,
etd,
'$dev->ip','$dev->username', '$dev->ua',
'$dev->ekey',now(),'$temp_code' 
from mt_order_route
where order_id=:order_id");

$statement->execute(array(':order_id'=>$order_id));

if ($statement->rowCount()){
  $data["route_status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data["route_status"]=0;
    //echo 'Failure: 0 rows were affected.';
}
//query 4 ends

//query 5
//rate
//MISSING COLUMNS
//selling_amount,cost_base_amount,selling_base_amount,
$temp_code=uniqid($dev->uid);
$statement = $db->prepare("INSERT into mt_manifest_entry_rate(
mnf_entry_pk,type,charge_desc,pay_at_location,basis_type,basis_uom,qty,currency,ex_rate,rate,cost,cost_base_amount,payment_mode,commodity,remarks,
ip,created_by, ua,ekey,created_date,temp_code
)
SELECT  '$mnf_entry_pk',type,charge_desc,pay_at_location,basis_type,basis_uom,qty,currency,ex_rate,rate_cost,rate_selling,cost_amount,mode_of_pay,commodity,remarks,
'$dev->ip','$dev->username', '$dev->ua',
'$dev->ekey',now(),'$temp_code' 
from mt_order_cost
where order_id=:order_id");

$statement->execute(array(':order_id'=>$order_id));

if ($statement->rowCount()){
  $data["rate_status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data["rate_status"]=0;
    //echo 'Failure: 0 rows were affected.';
}
//query 5 ends

//query 6
//party
$temp_code=uniqid($dev->uid);
$statement = $db->prepare("INSERT into mt_manifest_entry_party(
mnf_entry_pk,party_type,party_name,address,telephone,email,poc,
ip,created_by, ua,ekey,created_date,temp_code
)
SELECT  '$mnf_entry_pk',party_type,party_name,address,tel,email,poc,
'$dev->ip','$dev->username', '$dev->ua',
'$dev->ekey',now(),'$temp_code' 
from mt_order_parties
where order_id=:order_id");

$statement->execute(array(':order_id'=>$order_id));

if ($statement->rowCount()){
  $data["party_status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data["party_status"]=0;
    //echo 'Failure: 0 rows were affected.';
}
//query 6 ends

//query 7
$statement = $db->prepare("UPDATE mt_order_entry 
  set bl_no=:bl_no where id=:order_id");
$statement->execute(array(':order_id'=>$order_id,
':bl_no'=>$on));
if ($statement->rowCount()){
  $data["obl_status"]=1;
} else{
  $data["obl_status"]=0;
}
//query 7 ends
}else{
  $data["status"]=2;
}

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

//

public static function copy_bl($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();
$temp_code=uniqid($dev->uid);

$statement = $db->prepare("INSERT into mt_manifest_entry(

voyage,
bl_no,
status,
manifest_type,
bl_classification,
cargo_type,


quotation,
copy_bl_from,
enquiry,
master_bl_no,
commission,
shipment_terms,
bl_date,


remarks,
to_order,
telex_release,
tsp_bl,

company_id,location_id,ip,created_by, ua,ekey,created_date,temp_code,customer) 

SELECT voyage, '$c->bl_no', 'CREATED', manifest_type, bl_classification, cargo_type, quotation, bl_no, enquiry, master_bl_no, commission, shipment_terms, bl_date, remarks, to_order, telex_release, tsp_bl, '$dev->company','$dev->location',
'$dev->ip','$dev->username', '$dev->ua',
'$dev->ekey',now(),'$temp_code',customer from mt_manifest_entry 
where id=:id 
");

$statement->execute(array(':id'=>$c->id));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}

$statement = $db->prepare("SELECT id from mt_manifest_entry where created_by=:uid and temp_code=:temp_code");
$statement->execute(array(':temp_code'=>$temp_code,':uid'=>$dev->username));
$data["id"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$mnf_entry_pk=$data["id"][0]["id"];

/*
//1 container
$statement = $db->prepare("INSERT into mt_manifest_entry_container( mnf_entry_pk, container_no, type, package_type, no_of_pkgs, volume, gr_wgt, nt_wgt, tt_wgt, commodity, cargo_desc, reefer, min_temp, max_temp, oog, oh, ow, ol, haz, un_no, flash_type, company_id,location_id,ip,uid, ua,ekey,created_date) 
  SELECT $mnf_entry_pk, container_no, type, package_type, no_of_pkgs, volume, gr_wgt, nt_wgt, tt_wgt, commodity, cargo_desc, reefer, min_temp, max_temp, oog, oh, ow, ol, haz, un_no, flash_type,
  '','',
  '$dev->ip','$dev->username','$dev->ua','$dev->ekey',now() 
  from mt_manifest_entry_container where mnf_entry_pk=:mnf_entry_pk");
$statement->execute(array(':mnf_entry_pk'=>$c->id));
if ($statement->rowCount()){
  $data["container_status"]=1;
} else{
  $data["container_status"]=0;
}

// 2 lc

$statement = $db->prepare("INSERT into mt_manifest_entry_landingcraft( mnf_entry_pk, cargo_type, vehicle_type, vin_no, chassis_no, package_type, no_of_pkgs, volume, gr_wgt, nt_wgt, tt_wgt, commodity, cargo_desc, reefer, min_temp, max_temp, oog, oh, ow, ol, haz, un_no, flash_type, company_id,location_id,ip,created_by, ua,ekey,created_date)
  SELECT $mnf_entry_pk, cargo_type, vehicle_type, vin_no, chassis_no, package_type, no_of_pkgs, volume, gr_wgt, nt_wgt, tt_wgt, commodity, cargo_desc, reefer, min_temp, max_temp, oog, oh, ow, ol, haz, un_no, flash_type,
  '','',
  '$dev->ip','$dev->username','$dev->ua','$dev->ekey',now() 
  from mt_manifest_entry_landingcraft where mnf_entry_pk=:mnf_entry_pk
  ");
$statement->execute(array(':mnf_entry_pk'=>$c->id));
if ($statement->rowCount()){
  $data["lc_status"]=1;
} else{
  $data["lc_status"]=0;
}
*/
//3 route

$statement = $db->prepare("INSERT into mt_manifest_entry_route( mnf_entry_pk, voyage, vessel, eline, port, service, eta, etd, poo, pol, pod, pof, tsp1, tsp2, tsp3, tsp4, tsp5, company_id,location_id,ip,uid, ua,ekey,created_date)
  SELECT $mnf_entry_pk, voyage, vessel, eline, port, service, eta, etd, poo, pol, pod, pof, tsp1, tsp2, tsp3, tsp4, tsp5, 
  '','',
  '$dev->ip','$dev->username','$dev->ua','$dev->ekey',now() 
  from mt_manifest_entry_route where mnf_entry_pk=:mnf_entry_pk");
$statement->execute(array(':mnf_entry_pk'=>$c->id));
if ($statement->rowCount()){
  $data["route_status"]=1;
} else{
  $data["route_status"]=0;
}

//4 rate


$statement = $db->prepare("INSERT into mt_manifest_entry_rate( mnf_entry_pk, type, charge_desc, pay_at_location, basis_type, basis_uom, qty, currency, ex_rate, rate, cost, cost_base_amount, container, payment_mode, charge_print, commodity, remarks, status, company_id,location_id,ip,uid, ua,ekey,created_date)
  SELECT $mnf_entry_pk, type, charge_desc, pay_at_location, basis_type, basis_uom, qty, currency, ex_rate, rate, cost, cost_base_amount, container, payment_mode, charge_print, commodity, remarks, status, 
  '','',
  '$dev->ip','$dev->username','$dev->ua','$dev->ekey',now() 
  from mt_manifest_entry_rate where mnf_entry_pk=:mnf_entry_pk");
$statement->execute(array(':mnf_entry_pk'=>$c->id));
if ($statement->rowCount()){
  $data["rate_status"]=1;
} else{
  $data["rate_status"]=0;
}

//5 party
/*
$statement = $db->prepare("INSERT into mt_manifest_entry_party( mnf_entry_pk, party_type, party_name, address, telephone, email, poc, address_on_bl, status, company_id,location_id,ip,uid, ua,ekey,created_date) 
  SELECT $mnf_entry_pk, party_type, party_name, address, telephone, email, poc, address_on_bl, status,
  '','',
  '$dev->ip','$dev->username','$dev->ua','$dev->ekey',now() 
  from mt_manifest_entry_party where mnf_entry_pk=:mnf_entry_pk");
$statement->execute(array(':mnf_entry_pk'=>$c->id));
if ($statement->rowCount()){
  $data["party_status"]=1;
} else{
  $data["party_status"]=0;
}
*/
//6 marks

$statement = $db->prepare("INSERT into mt_manifest_entry_marks( mnf_entry_pk, marks, description, status, company_id,location_id,ip,uid, ua,ekey,created_date)
  SELECT $mnf_entry_pk, marks, description, status,
  '','',
  '$dev->ip','$dev->username','$dev->ua','$dev->ekey',now() 
  from mt_manifest_entry_marks where mnf_entry_pk=:mnf_entry_pk");
$statement->execute(array(':mnf_entry_pk'=>$c->id));
if ($statement->rowCount()){
  $data["marks_status"]=1;
} else{
  $data["marks_status"]=0;
}


$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function get_order_info_byno($id)
{


$data=array();
try
{
$db = Factory::getConnection();

$statement = $db->prepare("SELECT id from mt_order_entry 
  where order_no=:id");
$statement->execute(array(':id'=>$id));
$temp=$statement->fetchAll(PDO::FETCH_ASSOC);
$code=$temp[0]["id"];
//1

$statement = $db->prepare("SELECT id,order_id,container_no,type,package_type,no_of_pkgs,volume,gr_wgt,nt_wgt,tt_wgt,commodity,cargo_desc,reefer,min_temp,max_temp,oog,oh,ow,ol,haz,un_no,flash_type, '0' edit from mt_order_container_detail 
  where order_id=:id");
$statement->execute(array(':id'=>$code));
$data["container_detail"]=$statement->fetchAll(PDO::FETCH_ASSOC);

//2

$statement = $db->prepare("SELECT id,order_id,cargo_type,vehicle_type,vin_no,chassis_no,package_type,no_of_pkgs,volume,gr_wgt,nt_wgt,tt_wgt,commodity,cargo_desc,reefer,min_temp,max_temp,oog,oh,ow,ol,haz,un_no,flash_type, '0' edit from mt_order_landingcraft_detail 
  where order_id=:id");
$statement->execute(array(':id'=>$code));
$data["craft"]=$statement->fetchAll(PDO::FETCH_ASSOC);

//3
$statement = $db->prepare("SELECT id,order_id,routing_transport_leg,mode,on_accounts,provider eline,
  efrom port,efrom poo,efrom pol,eto pod,eto pof,tsp1,tsp2,tsp3,tsp4,tsp5,transport_reference,departure_date,duration, '0' edit from mt_order_route 
  where order_id=:id");
$statement->execute(array(':id'=>$code));
$data["route"]=$statement->fetchAll(PDO::FETCH_ASSOC);


//4

$statement = $db->prepare("SELECT id,order_id,route,type,charge_desc,pay_at_location,mode_of_pay payment_mode,basis_type,basis_uom,commodity,qty,currency,ex_rate,rate_cost rate,qty*rate_cost cost,qty*rate_cost cost_base_amount,'' container,'' charge_print,remarks,status,'0' edit from mt_order_cost 
  where order_id=:id");
$statement->execute(array(':id'=>$code));
$data["cost"]=$statement->fetchAll(PDO::FETCH_ASSOC);

//5
$statement = $db->prepare("SELECT id,order_id,party_type,party_name,address,tel telephone,email,poc,'' address_on_bl,controlling_party,status, '0' edit from mt_order_parties  
  where order_id=:id");
$statement->execute(array(':id'=>$code));
$data["parties"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;

}

public static function update_cargo_arrival_notice($dev,$c)
{
$data=0;
try
{
$db = Factory::getConnection();


$statement = $db->prepare("UPDATE mt_cargo_arrival_notice_detail set 
bl_no=:bl_no,
port_of_loading=:port_of_loading,
port_of_discharge=:port_of_discharge,
final_destination=:final_destination,
shipper_name=:shipper_name,
consignee_code=:consignee_code,
consignee_name=:consignee_name,
consignee_email=:consignee_email,
notify_name=:notify_name,
notify_email=:notify_email,
last_advice_date=:last_advice_date,
additional_email=:additional_email,
ip=:ip,uid=:uid,ua=:ua,ekey=:ekey,created_date= now() where id=:id");
$statement->execute(array(
  ':id'=>$c->id,
 ':bl_no'=>$c->bl_no,
':port_of_loading'=>$c->port_of_loading,
':port_of_discharge'=>$c->port_of_discharge,
':final_destination'=>$c->final_destination,
':shipper_name'=>$c->shipper_name,
':consignee_code'=>$c->consignee_code,
':consignee_name'=>$c->consignee_name,
':consignee_email'=>$c->consignee_email,
':notify_name'=>$c->notify_name,
':notify_email'=>$c->notify_email,
':last_advice_date'=>$c->last_advice_date,
':additional_email'=>$c->additional_email
));

if ($statement->rowCount()){
  $data=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data=0;
    //echo 'Failure: 0 rows were affected.';
}

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function send_mail($to,$sub,$msg,$url,$temp_code,$cc)
{


$fields = array
('code'=>'NVOCC-MT-PR-007',
  'msg'=>$msg,
  'to'=>$to,
  'sub'=>$sub,
  'url'=>$url,
  'temp_code'=>$temp_code,
  'cc'=>$cc
);
//$cargo_data=(array)$data;
//$fields=$fields+$cargo_data;

//$payload = json_encode($fields);

$headers = array();


//$ch = curl_init('http://mtest.in/email/email.php');
$ch = curl_init('http://mtest.in/email/ea1.php');

curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
curl_setopt($ch, CURLOPT_POSTFIELDS, $fields);

// execute!
$response = curl_exec($ch);

// close the connection, release resources used
curl_close($ch);

// do anything you want with your response
return $temp_code." op from ".$response;

}

public static function save_cargo_arrival_notice($dev,$cargo)
{
$data=array();
try
{
$db = Factory::getConnection();

$c=$cargo->info;
if($c->eta=="")
{
  $c->eta=null;
}
$h=$c;

$statement = $db->prepare("INSERT into mt_cargo_arrival_notice(
voyage,
eline,
vessel,
port,
eta,
port_of_loading,
port_of_discharge,
final_destination,
consignee,
cargo_type,
bl_no,
first_arrival,
delivery_party,
delivery_mode,
delivery_type,
company_id,
location_id,
  ip,uid, ua,ekey,created_date) 
values(
:voyage,
:eline,
:vessel,
:port,
:eta,
:port_of_loading,
:port_of_discharge,
:final_destination,
:consignee,
:cargo_type,
:bl_no,
:first_arrival,
:delivery_party,
:delivery_mode,
:delivery_type,
'',
'',
:ip ,:uid ,:ua ,:ekey,now())");
$statement->execute(array(':ip'=>$dev->ip,':uid'=>$dev->uid ,':ua'=>$dev->ua,':ekey'=>$dev->ekey,

':voyage'=>$c->voyage,
':eline'=>$c->eline,
':vessel'=>$c->vessel,
':port'=>$c->port,
':eta'=>$c->eta,
':port_of_loading'=>$c->port_of_loading,
':port_of_discharge'=>$c->port_of_discharge,
':final_destination'=>$c->final_destination,
':consignee'=>$c->consignee,
':cargo_type'=>$c->cargo_type,
':bl_no'=>$c->bl_no,
':first_arrival'=>$c->first_arrival,
':delivery_party'=>$c->delivery_party,
':delivery_mode'=>$c->delivery_mode,
':delivery_type'=>$c->delivery_type
));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}

//detail
$message = '<html><body>';
$message .= '<h5 style="color:#f40;">Dear Sir/Madam,</h5>';
$message .= '<p style="color:#080;">Please find the attached pdf.</p>';
$message .= '<p style="color:#080;">This is a system generated pdf.</p>';

$message .= '</body></html>';

$cd=$cargo->cd;
for($i=0;$i<count($cd);$i++)
{
  $c=$cd[$i];
$statement = $db->prepare("INSERT into mt_cargo_arrival_notice_detail(

bl_no,
port_of_loading,
port_of_discharge,
final_destination,
shipper_name,

consignee_name,
consignee_email,
notify_name,
notify_email,
last_advice_date,
additional_email,
company_id,
location_id,
  ip,uid, ua,ekey,created_date) 
values(

:bl_no,
:port_of_loading,
:port_of_discharge,
:final_destination,
:shipper_name,

:consignee_name,
:consignee_email,
:notify_name,
:notify_email,
now(),
:additional_email,
'',
'',
:ip ,:uid ,:ua ,:ekey,now())");
$statement->execute(array(':ip'=>$dev->ip,':uid'=>$dev->uid ,':ua'=>$dev->ua,':ekey'=>$dev->ekey,

':bl_no'=>$c->bl_no,
':port_of_loading'=>$c->pol,
':port_of_discharge'=>$c->pod,
':final_destination'=>$c->pof,
':shipper_name'=>$c->shipper,

':consignee_name'=>$c->consignee,
':consignee_email'=>$c->consignee_email,
':notify_name'=>$c->notify,
':notify_email'=>$c->notify_email,

':additional_email'=>$c->add2
));


$temp_code=uniqid($dev->uid);
if ($statement->rowCount()){

  //mbl hbl

  $to=$c->consignee_email.",".$c->notify_email;
if($c->add2)
{
  $to=$to.",".$c->add2;
}

//get mbl hbl
$dtv="'DUMMY'";
if($c->hbl==true)
{
  $dtv="'HBL'";
}

if($c->mbl==true)
{
  $dtv="'MBL'";
}

if($c->hbl==true and $c->mbl==true)
{
  $dtv="'HBL','MBL'";
}

$data["dtv"]=$dtv;

$statement = $db->prepare("SELECT file_name,file_url from mt_manifest_entry_attach where mnf_entry_pk=:id and doc_type in ($dtv)");
$statement->execute(array(':id'=>$c->id));
$murls=$statement->fetchAll(PDO::FETCH_ASSOC);
//var_dump($murls);

$aurls="";
$ip="http://139.162.55.40/api/";
if(count($murls)==1)
{
$aurls=$ip.$murls[0]["file_url"];
}else if(count($murls)==2){

$aurls=$ip.$murls[0]["file_url"].",";
$aurls=$aurls.$ip.$murls[1]["file_url"];

}
// mbl hbl ends

  $data["dt_status".($i+1)]=1;
    //echo 'Success: At least 1 row was affected.';
  $cads=self::get_cargo_arrival_notice_detail_info_pdf($c->id,$c->bl_no);
  //var_dump($cads);
  
  $pdf=gen_pdf($cads);
  //var_dump($pdf);

  $data["pdf_status".($i+1)]=$pdf;
  $url="http://139.162.55.40/api/files/cargo-arrival-notice/"."cargo-arrival-notice-bl-".$c->bl_no.".pdf";
  if(count($murls)!=0)
  {
    $url=$url.','.$aurls;
  }
  
  $data["url"]=$url;
  $cc="mohamed@falconshipping.com, aurangzaib@falconshipping.com";
  $data["dt_cemail_status".($i+1)]=self::send_mail($to,'Cargo Arrival Notice '.$c->bl_no,$message,$url,$temp_code,$cc);
    //$data["dt_nemail_status".($i+1)]=self::send_mail($c->notify_email,'Cargo Arrival Notice '.$c->bl_no,$message,$c);
} else{
  $data["dt_status".($i+1)]=0;
    //echo 'Failure: 0 rows were affected.';
}

}

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function save_cargo_arrival_notice_detail($dev,$c)
{
$data=0;
try
{
$db = Factory::getConnection();


$statement = $db->prepare("INSERT into mt_cargo_arrival_notice_detail(
  id,
bl_no,
port_of_loading,
port_of_discharge,
final_destination,
shipper_name,
consignee_code,
consignee_name,
consignee_email,
notify_name,
notify_email,
last_advice_date,
additional_email,
company_id,
location_id,
  ip,uid, ua,ekey,created_date) 
values(
:id,
:bl_no,
:port_of_loading,
:port_of_discharge,
:final_destination,
:shipper_name,
:consignee_code,
:consignee_name,
:consignee_email,
:notify_name,
:notify_email,
:last_advice_date,
:additional_email,
'',
'',
:ip ,:uid ,:ua ,:ekey,now())");
$statement->execute(array(':ip'=>$dev->ip,':uid'=>$dev->uid ,':ua'=>$dev->ua,':ekey'=>$dev->ekey,
':id'=>$c->id,
':bl_no'=>$c->bl_no,
':port_of_loading'=>$c->port_of_loading,
':port_of_discharge'=>$c->port_of_discharge,
':final_destination'=>$c->final_destination,
':shipper_name'=>$c->shipper_name,
':consignee_code'=>$c->consignee_code,
':consignee_name'=>$c->consignee_name,
':consignee_email'=>$c->consignee_email,
':notify_name'=>$c->notify_name,
':notify_email'=>$c->notify_email,
':last_advice_date'=>$c->last_advice_date,
':additional_email'=>$c->additional_email
));

if ($statement->rowCount()){
  $data=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data=0;
    //echo 'Failure: 0 rows were affected.';
}

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function delete_manifestentry_container($c)
{
$data=array();
try
{
$db = Factory::getConnection();

$statement = $db->prepare("DELETE FROM mt_manifest_entry_container 
  where id=:id");
$statement->execute(array(':id'=>$c));

if ($statement->rowCount()){
  $data["status"]=1;
} else{
  $data["status"]=0;
}
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  return $data;
}

public static function delete_manifestentry_lc($c)
{
$data=array();
try
{
$db = Factory::getConnection();

$statement = $db->prepare("DELETE FROM mt_manifest_entry_landingcraft  
  where id=:id");
$statement->execute(array(':id'=>$c));

if ($statement->rowCount()){
  $data["status"]=1;
} else{
  $data["status"]=0;
}
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  return $data;
}

public static function delete_manifestentry_route($c)
{
$data=array();
try
{
$db = Factory::getConnection();

$statement = $db->prepare("DELETE FROM mt_manifest_entry_route
  where id=:id");
$statement->execute(array(':id'=>$c));

if ($statement->rowCount()){
  $data["status"]=1;
} else{
  $data["status"]=0;
}
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  return $data;
}

public static function delete_manifestentry_marks($c)
{
$data=array();
try
{
$db = Factory::getConnection();

$statement = $db->prepare("DELETE FROM mt_manifest_entry_marks
  where id=:id");
$statement->execute(array(':id'=>$c));

if ($statement->rowCount()){
  $data["status"]=1;
} else{
  $data["status"]=0;
}
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  return $data;
}

public static function delete_manifestentry_rate($c)
{
$data=array();
try
{
$db = Factory::getConnection();

$statement = $db->prepare("DELETE FROM mt_manifest_entry_rate 
  where id=:id");
$statement->execute(array(':id'=>$c));

if ($statement->rowCount()){
  $data["status"]=1;
} else{
  $data["status"]=0;
}
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  return $data;
}

public static function delete_manifestentry_party($c)
{
$data=array();
try
{
$db = Factory::getConnection();

$statement = $db->prepare("DELETE FROM mt_manifest_entry_party 
  where id=:id");
$statement->execute(array(':id'=>$c));

if ($statement->rowCount()){
  $data["status"]=1;
} else{
  $data["status"]=0;
}
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  return $data;
}

public static function delete_cargo_arrival_notice($dev,$id)
{
$data=0;
try
{
$db = Factory::getConnection();


$statement = $db->prepare("DELETE FROM mt_cargo_arrival_notice_detail
  where id=:id");

$statement->execute(array(
':id'=>$id
));

if ($statement->rowCount()){
  $data=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data=0;
    //echo 'Failure: 0 rows were affected.';
}

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_cargo_arrival_notice_info($id)
{
$data=false;
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT id,
liner eline,
vessel,
voyage,
port,
eta,
'' port_of_loading,
'' port_of_discharge,
'' final_destination,
'' consignee,
'' cargo_type,
'' bl_no,
'' first_arrival,
'' delivery_party,
'' delivery_mode,
'' delivery_type
 from mt_voyage where voyage=:id");
$statement->execute(array(':id'=>$id));
$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_cargo_arrival_notice_detail_info($code)
{
$data=false;
try
{
$q='';
$ar=array();
$isFound=0;
$db = Factory::getConnection();

if(strlen($code->bl_no)!=0)
{
$q=$q." and t1.bl_no=:bl_no ";
$ar[':bl_no']=$code->bl_no;
$isFound=1;
}

if(strlen($code->voyage)!=0)
{
$q=$q."  and t1.voyage=:voyage ";
$ar[':voyage']=$code->voyage;
$isFound=1;
}

if($isFound==1)
{

/* old query
SELECT t1.id,
t1.voyage,
t1.bl_no,
pol,
pod,
pof,
(select party_name from mt_manifest_entry_party 
  where party_type='SHIPPER' and mnf_entry_pk=t1.id) shipper,
t3.party_name consignee ,t3.email consignee_email,
  t4.party_name notify,t4.email notify_email,
(SELECT last_advice_date from mt_cargo_arrival_notice_detail where bl_no=t1.bl_no order by last_advice_date desc limit 1) add1,
'' add2,
'' add3,
t1.temp_code , '' mbl,'' hbl    
from mt_manifest_entry t1, mt_manifest_entry_route t2 ,
(select party_name,email,mnf_entry_pk from mt_manifest_entry_party 
  where party_type='CONSIGNEE') t3,
  (select party_name,email,mnf_entry_pk from mt_manifest_entry_party 
  where party_type='NOTIFY PARTY') t4
  
where t1.id=t2.mnf_entry_pk and 
t1.id=t3.mnf_entry_pk and
t1.id=t4.mnf_entry_pk $q 
*/
$statement = $db->prepare("SELECT t1.id,
t1.voyage,
t1.bl_no,
pol,
pod,
pof,
(select party_name from mt_manifest_entry_party 
  where party_type='SHIPPER' and mnf_entry_pk=t1.id) shipper,
t3.party_name consignee ,t3.email consignee_email,
    (select party_name from mt_manifest_entry_party 
  where party_type='NOTIFY PARTY' and mnf_entry_pk=t1.id) notify,
  (select email from mt_manifest_entry_party 
  where party_type='NOTIFY PARTY' and mnf_entry_pk=t1.id)
  notify_email,
(SELECT last_advice_date from mt_cargo_arrival_notice_detail where bl_no=t1.bl_no order by last_advice_date desc limit 1) add1,
'' add2,
'' add3,
t1.temp_code , '' mbl,'' hbl    
from mt_manifest_entry t1, mt_manifest_entry_route t2 ,
(select party_name,email,mnf_entry_pk from mt_manifest_entry_party 
  where party_type='CONSIGNEE') t3

where t1.id=t2.mnf_entry_pk and 
t1.id=t3.mnf_entry_pk $q ");
$statement->execute($ar);
$data=$statement->fetchAll(PDO::FETCH_ASSOC);
$statement=null;
}else{
  $data=[];
}


  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


//********************************************************************************************
//MANIFEST ENTRY 
//********************************************************************************************

public static function get_manifest_export_list($code)
{
$data=false;
try
{
$db = Factory::getConnection();


$statement = $db->prepare("SELECT 
t1.id,
t1.vessel,
t1.voyage,
t1.bl_no,
(SELECT GROUP_CONCAT(poo) from mt_manifest_entry_route where mnf_entry_pk=t1.id) poo,
(SELECT GROUP_CONCAT(pol) from mt_manifest_entry_route where mnf_entry_pk=t1.id) pol,
(SELECT GROUP_CONCAT(pod) from mt_manifest_entry_route where mnf_entry_pk=t1.id) pod,
(SELECT GROUP_CONCAT(pof) from mt_manifest_entry_route where mnf_entry_pk=t1.id) pof,


(select name from mt_business_partner where code=(select party_name from mt_manifest_entry_party where party_type='CONSIGNEE' and mnf_entry_pk=t1.id limit 1)) consignee, 
(select party_name from mt_manifest_entry_party where party_type='NOTIFY PARTY' and mnf_entry_pk=t1.id limit 1) notify,

t1.manifest_type,
t1.bl_classification,
t1.shipment_terms,
t1.bl_date,
t1.to_order,
t1.order_no,
t1.master_bl_no,

t1.status,
t1.created_date,
t1.created_by,
t1.modified_by,
t1.modified_date 
  from mt_manifest_entry t1   
  WHERE  t1.manifest_type in('SEA EXPORT') 
  order by id desc limit :sta,50");
$statement->bindValue(':sta',(int) $code, PDO::PARAM_INT);
$statement->execute();
$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function search_manifest_export_list($q)
{
$data=false;
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT 
t1.id,
t1.vessel,
t1.voyage,
t1.bl_no,
'' poo,
(SELECT GROUP_CONCAT(pol) from mt_manifest_entry_route where mnf_entry_pk=t1.id) pol,
(SELECT GROUP_CONCAT(pod) from mt_manifest_entry_route where mnf_entry_pk=t1.id) pod,
'' pof,


(select party_name from mt_manifest_entry_party where party_type='CONSIGNEE' and mnf_entry_pk=t1.id limit 1) consignee, 
'' notify,

t1.manifest_type,
t1.bl_classification,
t1.shipment_terms,
t1.bl_date,
t1.to_order,
t1.order_no,
t1.master_bl_no,

t1.status,
t1.created_date,
t1.created_by,
t1.modified_by,
t1.modified_date 
  from mt_manifest_entry t1 
  where t1.manifest_type in('SEA EXPORT') 
  and (t1.manifest_type like ? or 
  t1.voyage like ? or t1.bl_no like ?) order by id desc LIMIT 20");

$statement ->bindValue(1, "%$q%", PDO::PARAM_STR);
$statement ->bindValue(2, "%$q%", PDO::PARAM_STR);
$statement ->bindValue(3, "%$q%", PDO::PARAM_STR);

$statement->execute();
$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function search_manifestentry_list($q)
{
$data=false;
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT 
t1.id,
(SELECT vessel from mt_voyage where voyage=t1.voyage) vessel,
t1.voyage,
t1.bl_no,
'' poo,
(SELECT GROUP_CONCAT(DISTINCT pol) from mt_manifest_entry_route where mnf_entry_pk=t1.id) pol,
(SELECT GROUP_CONCAT(DISTINCT pod) from mt_manifest_entry_route where mnf_entry_pk=t1.id) pod,
'' pof,

(select party_name from mt_manifest_entry_party where party_type='CONSIGNEE' and mnf_entry_pk=t1.id limit 1) consignee, 
'' notify,

t1.manifest_type,
t1.bl_classification,
t1.shipment_terms,
t1.bl_date,
t1.to_order,
t1.order_no,
t1.master_bl_no,

t1.status,
t1.created_date,
t1.created_by,
t1.modified_by,
t1.modified_date 
  from mt_manifest_entry t1  
  where t1.manifest_type in('AGENCY IMPORT','NVOCC IMPORT') 
  and (t1.manifest_type like ? or 
  t1.voyage like ? or t1.bl_no like ?) order by id desc LIMIT 20");

$statement ->bindValue(1, "%$q%", PDO::PARAM_STR);
$statement ->bindValue(2, "%$q%", PDO::PARAM_STR);
$statement ->bindValue(3, "%$q%", PDO::PARAM_STR);
/*
old query

SELECT 
t1.id,
(SELECT vessel from mt_voyage where voyage=t1.voyage) vessel,
t1.voyage,
t1.bl_no,
(SELECT GROUP_CONCAT(DISTINCT poo) from mt_manifest_entry_route where mnf_entry_pk=t1.id) poo,
(SELECT GROUP_CONCAT(DISTINCT pol) from mt_manifest_entry_route where mnf_entry_pk=t1.id) pol,
(SELECT GROUP_CONCAT(DISTINCT pod) from mt_manifest_entry_route where mnf_entry_pk=t1.id) pod,
(SELECT GROUP_CONCAT(DISTINCT pof) from mt_manifest_entry_route where mnf_entry_pk=t1.id) pof,

(select party_name from mt_manifest_entry_party where party_type='CONSIGNEE' and mnf_entry_pk=t1.id limit 1) consignee, 
(select party_name from mt_manifest_entry_party where party_type='NOTIFY PARTY' and mnf_entry_pk=t1.id limit 1) notify,

t1.manifest_type,
t1.bl_classification,
t1.shipment_terms,
t1.bl_date,
t1.to_order,
t1.order_no,
t1.master_bl_no,

t1.status,
t1.created_date,
t1.created_by,
t1.modified_by,
t1.modified_date 
  from mt_manifest_entry t1  
  where t1.manifest_type in('AGENCY IMPORT','SEA IMPORT') 
  and (t1.manifest_type like ? or 
  t1.voyage like ? or t1.bl_no like ?) order by id LIMIT 20

*/
$statement->execute();
$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_manifestentry_list($dev,$code)
{
$data=false;
try
{
$db = Factory::getConnection();
$aq=Factory::getRestrictionQuery1($dev,"t1");
$statement = $db->prepare("SELECT 
t1.id,
(SELECT vessel from mt_voyage where voyage=t1.voyage) vessel,
t1.voyage,
t1.bl_no,
'' poo,
(SELECT GROUP_CONCAT(DISTINCT pol) from mt_manifest_entry_route where mnf_entry_pk=t1.id) pol,
(SELECT GROUP_CONCAT(DISTINCT pod) from mt_manifest_entry_route where mnf_entry_pk=t1.id) pod,
'' pof,

(select party_name from mt_manifest_entry_party where party_type='CONSIGNEE' and mnf_entry_pk=t1.id limit 1) consignee, 
'' notify,

t1.manifest_type,
t1.bl_classification,
t1.shipment_terms,
t1.bl_date,
t1.to_order,
t1.order_no,
t1.master_bl_no,

t1.status,
t1.created_date,
t1.created_by,
t1.modified_by,
t1.modified_date 
  from mt_manifest_entry t1
where $aq and t1.manifest_type in('AGENCY IMPORT','SEA IMPORT','NVOCC IMPORT') 
order by id desc limit :sta,100");
$statement->bindValue(':sta',(int) $code, PDO::PARAM_INT);
/*
old query
SELECT 
t1.id,
(SELECT vessel from mt_voyage where voyage=t1.voyage) vessel,
t1.voyage,
t1.bl_no,
t2.poo,
t2.pol,
t2.pod,
t2.pof,

(select (select name from mt_business_partner where code=party_name) from mt_manifest_entry_party where party_type='CONSIGNEE' and mnf_entry_pk=t1.id limit 1) consignee, 
(select party_name from mt_manifest_entry_party where party_type='NOTIFY PARTY' and mnf_entry_pk=t1.id limit 1) notify,

t1.manifest_type,
t1.bl_classification,
t1.shipment_terms,
t1.bl_date,
t1.to_order,
t1.order_no,
t1.master_bl_no,

t1.status,
t1.created_date,
t1.created_by,
t1.modified_by,
t1.modified_date 
  from mt_manifest_entry t1 LEFT JOIN mt_manifest_entry_route t2 
ON t1.id=t2.mnf_entry_pk 
where $aq and t1.manifest_type in('AGENCY IMPORT','SEA IMPORT') 
order by id desc limit :sta,100
*/
$statement->execute();
$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_manifestentry_container_list($id)
{
$data=false;
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT 
id,
mnf_entry_pk,
equipment_serial,
container_no,
seal_no,
type,
package_type,
no_of_pkgs,
volume,
gr_wgt,
nt_wgt,
tt_wgt,
commodity,
cargo_desc,
reefer,
min_temp,
max_temp,
oog,
oh,
ow,
ol,
haz,
un_no,
flash_type,
company_id,
location_id,
'0' edit
  from mt_manifest_entry_container where mnf_entry_pk=:id");
$statement->execute(array(':id'=>$id));
$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_manifestentry_landingcraft_list($id)
{
$data=false;
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT 
id,
mnf_entry_pk,
cargo_type,
vehicle_type,
vin_no,
chassis_no,
package_type,
no_of_pkgs,
volume,
gr_wgt,
nt_wgt,
tt_wgt,
commodity,
cargo_desc,
reefer,
min_temp,
max_temp,
oog,
oh,
ow,
ol,
haz,
un_no,
flash_type,
company_id,
location_id,
'0' edit
  from mt_manifest_entry_landingcraft where mnf_entry_pk=:id");
$statement->execute(array(':id'=>$id));
$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_manifestentry_route_list($id)
{
$data=false;
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT 
id,
mnf_entry_pk,
voyage,
vessel,
eline,
port,
service,
eta,
etd,
poo,
pol,
pod,
pof,
tsp1,
tsp2,
tsp3,
tsp4,
tsp5,
company_id,
location_id,
'0' edit
  from mt_manifest_entry_route where mnf_entry_pk=:id");
$statement->execute(array(':id'=>$id));
$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_manifestentry_rate_list($id)
{
$data=false;
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT 
id,
mnf_entry_pk,
type,
charge_desc,
pay_at_location,
basis_type,
basis_uom,
qty,
currency,
ex_rate,
rate,
cost,
cost_base_amount,
container,
payment_mode,
charge_print,
commodity,
remarks,
status,
company_id,
location_id,
'0' edit
  from mt_manifest_entry_rate where mnf_entry_pk=:id");
$statement->execute(array(':id'=>$id));
$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_manifestentry_party_list($id)
{
$data=false;
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT 
id,
mnf_entry_pk,
equipment_serial,
party_type,
party_name,
address,
telephone,
email,
poc,
address_on_bl,
status,
company_id,
location_id,
'0' edit
  from mt_manifest_entry_party where mnf_entry_pk=:id");
$statement->execute(array(':id'=>$id));
$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_manifestentry_marks_list($id)
{
$data=false;
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT 
id,
mnf_entry_pk,
marks,
description,
status,
company_id,
location_id,
'0' edit
  from mt_manifest_entry_marks where mnf_entry_pk=:id");
$statement->execute(array(':id'=>$id));
$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_manifestentry_clause_list($id)
{
$data=false;
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT 
id,
mnf_entry_pk,
clause_code,
print_on_bl,
description,
status,
company_id,
location_id,
'0' edit
  from mt_manifest_entry_clause where mnf_entry_pk=:id");
$statement->execute(array(':id'=>$id));
$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_manifestentry_export_info($id)
{
$data=false;
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT 
t1.id,
t1.voyage,
t1.bl_no,
t1.status,
t1.manifest_type,
t1.bl_classification,
t1.cargo_type,
t1.order_no,
t1.so_no,
t1.quotation,
t1.copy_bl_from,
t1.enquiry,
t1.master_bl_no,
t1.free_days,
t1.shipment_terms,
t1.bl_date,
t1.bl_issue_place,
t1.bl_issue_agent,
t1.no_of_original,
t1.no_of_hbls,
t1.no_of_non_neg,
t1.board_status,
t1.sob_rfs_date,
t1.remarks,
t1.remarks2,
t1.to_order,
t1.telex_release,
t1.tsp_bl,
t1.mnf_corrector_no,
t1.mnf_corrector_status,
t1.mnf_bl_type,
t1.mnf_bl_no,
t1.mnf_corrector_date,
t1.mnf_corrector_version,
t1.mnf_corrector_type,
t1.mnf_corrector_reference,
t1.mnf_corrector_remarks,
t1.temp_code,
(select call_type from mt_voyage where voyage=t1.voyage) call_type,
delivery_agent 
from mt_manifest_entry t1 where id=:id");
$statement->execute(array(':id'=>$id));
$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_manifestentry_info1($id)
{
$data=false;
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT 
t1.id,
t1.voyage,
t1.bl_no,
t1.status,
t1.manifest_type,
t1.bl_classification,
t1.cargo_type,
t1.order_no,
t1.so_no,
t1.quotation,
t1.copy_bl_from,
t1.enquiry,
t1.master_bl_no,
t1.commission,
t1.shipment_terms,
t1.bl_date,
t1.bl_issue_place,
t1.bl_issue_agent,
t1.no_of_original,
t1.no_of_non_neg,
t1.board_status,
t1.sob_rfs_date,
t1.remarks,
t1.to_order,
t1.telex_release,
t1.tsp_bl,
t1.mnf_corrector_no,
t1.mnf_corrector_status,
t1.mnf_bl_type,
t1.mnf_bl_no,
t1.mnf_corrector_date,
t1.mnf_corrector_version,
t1.mnf_corrector_type,
t1.mnf_corrector_reference,
t1.mnf_corrector_remarks,
empty_bl_no,
t1.temp_code,customer,
(select call_type from mt_voyage where voyage=t1.voyage limit 1) call_type
from mt_manifest_entry t1 where id=:id");
$statement->execute(array(':id'=>$id));
$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_manifestentry_info($id)
{
$data=false;
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT 
t1.id,
t1.voyage,
t1.bl_no,
t1.status,
t1.manifest_type,
t1.bl_classification,
t1.cargo_type,
t1.order_no,
t1.so_no,
t1.quotation,
t1.copy_bl_from,
t1.enquiry,
t1.master_bl_no,
t1.commission,
t1.shipment_terms,
t1.bl_date,
t1.bl_issue_place,
t1.bl_issue_agent,
t1.no_of_original,
t1.no_of_non_neg,
t1.board_status,
t1.sob_rfs_date,
t1.remarks,
t1.to_order,
t1.telex_release,
t1.tsp_bl,
t1.mnf_corrector_no,
t1.mnf_corrector_status,
t1.mnf_bl_type,
t1.mnf_bl_no,
t1.mnf_corrector_date,
t1.mnf_corrector_version,
t1.mnf_corrector_type,
t1.mnf_corrector_reference,
t1.mnf_corrector_remarks,
t1.temp_code,customer,
(select call_type from mt_voyage where voyage=t1.voyage limit 1) call_type
from mt_manifest_entry t1 where id=:id");
$statement->execute(array(':id'=>$id));
$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


//

public static function update_manifestentry_status($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();


$statement = $db->prepare("UPDATE mt_manifest_entry set 
status=:status,
modified_by=:modified_by,modified_date= now() where id=:id");
$statement->execute(array(
':id'=>$c->id,
':modified_by'=>$dev->username,
':status'=>$c->status
));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

//
public static function update_manifestentry_export($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();


$statement = $db->prepare("UPDATE mt_manifest_entry set 
voyage=:voyage,
bl_no=:bl_no,

manifest_type=:manifest_type,
bl_classification=:bl_classification,
cargo_type=:cargo_type,
order_no=:order_no,

bl_issue_place=:bl_issue_place,
bl_issue_agent=:bl_issue_agent,
no_of_original=:no_of_original,
no_of_hbls=:no_of_hbls,
board_status=:board_status,
sob_rfs_date=:sob_rfs_date,
no_of_non_neg=:no_of_non_neg,

quotation=:quotation,
copy_bl_from=:copy_bl_from,
enquiry=:enquiry,
master_bl_no=:master_bl_no,
free_days=:free_days,
shipment_terms=:shipment_terms,
bl_date=:bl_date,


remarks=:remarks,
remarks2=:remarks2,
to_order=:to_order,
telex_release=:telex_release,
tsp_bl=:tsp_bl,
modified_by=:modified_by,modified_date= now(),
delivery_agent=:delivery_agent where id=:id");
$statement->execute(array(
':id'=>$c->id,
':modified_by'=>$dev->username ,

':voyage'=>$c->voyage,
':bl_no'=>$c->bl_no,

':manifest_type'=>$c->manifest_type,
':bl_classification'=>$c->bl_classification,
':cargo_type'=>$c->cargo_type,
':order_no'=>$c->order_no,

':quotation'=>$c->quotation,
':copy_bl_from'=>$c->copy_bl_from,
':enquiry'=>$c->enquiry,
':master_bl_no'=>$c->master_bl_no,
':free_days'=>$c->free_days,
':shipment_terms'=>$c->shipment_terms,
':bl_date'=>$c->bl_date,

':remarks'=>$c->remarks,
':remarks2'=>$c->remarks2,
':to_order'=>$c->to_order,
':telex_release'=>$c->telex_release,
':tsp_bl'=>$c->tsp_bl,

':bl_issue_place'=>$c->bl_issue_place,
':bl_issue_agent'=>$c->bl_issue_agent,
':no_of_original'=>$c->no_of_original,
':no_of_hbls'=>$c->no_of_hbls,
':board_status'=>$c->board_status,
':sob_rfs_date'=>$c->sob_rfs_date,
':no_of_non_neg'=>$c->no_of_non_neg,
':delivery_agent'=>$c->delivery_agent

));

if ($statement->rowCount()){
  $data["status"]=1;
  $data["msg"]="Saved";

    //echo 'Success: At least 1 row was affected.';
} else{
  $data["status"]=0;
  $data["msg"]="Some error occurred. Please try again...";

    //echo 'Failure: 0 rows were affected.';
}

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}
//GET ENDS

public static function update_manifestentry1($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

if($c->status=='DO ISSUED')
{

if($c->status=='DO ISSUED' && ($dev->username='raja' ||$dev->username='admin'))
{

//update all field by admin and raja
$statement = $db->prepare("UPDATE mt_manifest_entry set 
voyage=:voyage,

manifest_type=:manifest_type,
bl_classification=:bl_classification,
cargo_type=:cargo_type,
order_no=:order_no,

bl_issue_place=:bl_issue_place,
bl_issue_agent=:bl_issue_agent,
no_of_original=:no_of_original,
board_status=:board_status,
sob_rfs_date=:sob_rfs_date,
no_of_non_neg=:no_of_non_neg,

quotation=:quotation,
copy_bl_from=:copy_bl_from,
enquiry=:enquiry,
master_bl_no=:master_bl_no,
commission=:commission,
shipment_terms=:shipment_terms,
bl_date=:bl_date,


remarks=:remarks,
to_order=:to_order,
telex_release=:telex_release,
tsp_bl=:tsp_bl,
modified_by=:modified_by,modified_date= now(),
empty_bl_no=:empty_bl_no,
customer=:customer where id=:id");
$statement->execute(array(
':id'=>$c->id,
':modified_by'=>$dev->username ,

':voyage'=>$c->voyage,

':manifest_type'=>$c->manifest_type,
':bl_classification'=>$c->bl_classification,
':cargo_type'=>$c->cargo_type,
':order_no'=>$c->order_no,

':quotation'=>$c->quotation,
':copy_bl_from'=>$c->copy_bl_from,
':enquiry'=>$c->enquiry,
':master_bl_no'=>$c->master_bl_no,
':commission'=>$c->commission,
':shipment_terms'=>$c->shipment_terms,
':bl_date'=>$c->bl_date,

':remarks'=>$c->remarks,
':to_order'=>$c->to_order,
':telex_release'=>$c->telex_release,
':tsp_bl'=>$c->tsp_bl,

':bl_issue_place'=>$c->bl_issue_place,
':bl_issue_agent'=>$c->bl_issue_agent,
':no_of_original'=>$c->no_of_original,
':board_status'=>$c->board_status,
':sob_rfs_date'=>$c->sob_rfs_date,
':no_of_non_neg'=>$c->no_of_non_neg,

':customer'=>$c->customer,
':empty_bl_no'=>$c->empty_bl_no
));

if ($statement->rowCount()){
  $data["status"]=1;
  $data["msg"]="Updated";

    //echo 'Success: At least 1 row was affected.';
} else{
  $data["status"]=0;
  $data["msg"]="Some error occurred. Please try again...";

    //echo 'Failure: 0 rows were affected.';
}

if(strlen($c->order_no)!=0)
{
$statement = $db->prepare("UPDATE mt_order_entry set bl_no=:bl_no where order_no=:order_no");
$statement->execute(array(':order_no'=>$c->order_no,':bl_no'=>$c->bl_no));
  if ($statement->rowCount()){
  $data["ord_status"]=1;

    //echo 'Success: At least 1 row was affected.';
} else{
  $data["ord_status"]=0;
    //echo 'Failure: 0 rows were affected.';
}
}

}else{

//limited update to other users

$statement = $db->prepare("UPDATE mt_manifest_entry set 

manifest_type=:manifest_type,
bl_classification=:bl_classification,
cargo_type=:cargo_type,

bl_issue_place=:bl_issue_place,
bl_issue_agent=:bl_issue_agent,
no_of_original=:no_of_original,
board_status=:board_status,
sob_rfs_date=:sob_rfs_date,
no_of_non_neg=:no_of_non_neg,

quotation=:quotation,
copy_bl_from=:copy_bl_from,
enquiry=:enquiry,
master_bl_no=:master_bl_no,
commission=:commission,
shipment_terms=:shipment_terms,
bl_date=:bl_date,

remarks=:remarks,
to_order=:to_order,
telex_release=:telex_release,
tsp_bl=:tsp_bl,
modified_by=:modified_by,modified_date= now(),
empty_bl_no=:empty_bl_no where id=:id");
$statement->execute(array(
':id'=>$c->id,
':modified_by'=>$dev->username ,

':manifest_type'=>$c->manifest_type,
':bl_classification'=>$c->bl_classification,
':cargo_type'=>$c->cargo_type,

':quotation'=>$c->quotation,
':copy_bl_from'=>$c->copy_bl_from,
':enquiry'=>$c->enquiry,
':master_bl_no'=>$c->master_bl_no,
':commission'=>$c->commission,
':shipment_terms'=>$c->shipment_terms,
':bl_date'=>$c->bl_date,

':remarks'=>$c->remarks,
':to_order'=>$c->to_order,
':telex_release'=>$c->telex_release,
':tsp_bl'=>$c->tsp_bl,

':bl_issue_place'=>$c->bl_issue_place,
':bl_issue_agent'=>$c->bl_issue_agent,
':no_of_original'=>$c->no_of_original,
':board_status'=>$c->board_status,
':sob_rfs_date'=>$c->sob_rfs_date,
':no_of_non_neg'=>$c->no_of_non_neg,

':empty_bl_no'=>$c->empty_bl_no
));

if ($statement->rowCount()){
  $data["status"]=1;
  $data["msg"]="Updated";

} else{
  $data["status"]=0;
  $data["msg"]="Some error occurred. Please try again...";

}



//**************************
}

} else{


$statement = $db->prepare("UPDATE mt_manifest_entry set 
voyage=:voyage,

manifest_type=:manifest_type,
bl_classification=:bl_classification,
cargo_type=:cargo_type,
order_no=:order_no,

bl_issue_place=:bl_issue_place,
bl_issue_agent=:bl_issue_agent,
no_of_original=:no_of_original,
board_status=:board_status,
sob_rfs_date=:sob_rfs_date,
no_of_non_neg=:no_of_non_neg,

quotation=:quotation,
copy_bl_from=:copy_bl_from,
enquiry=:enquiry,
master_bl_no=:master_bl_no,
commission=:commission,
shipment_terms=:shipment_terms,
bl_date=:bl_date,


remarks=:remarks,
to_order=:to_order,
telex_release=:telex_release,
tsp_bl=:tsp_bl,
modified_by=:modified_by,modified_date= now(),
empty_bl_no=:empty_bl_no,
customer=:customer where id=:id");
$statement->execute(array(
':id'=>$c->id,
':modified_by'=>$dev->username ,

':voyage'=>$c->voyage,

':manifest_type'=>$c->manifest_type,
':bl_classification'=>$c->bl_classification,
':cargo_type'=>$c->cargo_type,
':order_no'=>$c->order_no,

':quotation'=>$c->quotation,
':copy_bl_from'=>$c->copy_bl_from,
':enquiry'=>$c->enquiry,
':master_bl_no'=>$c->master_bl_no,
':commission'=>$c->commission,
':shipment_terms'=>$c->shipment_terms,
':bl_date'=>$c->bl_date,

':remarks'=>$c->remarks,
':to_order'=>$c->to_order,
':telex_release'=>$c->telex_release,
':tsp_bl'=>$c->tsp_bl,

':bl_issue_place'=>$c->bl_issue_place,
':bl_issue_agent'=>$c->bl_issue_agent,
':no_of_original'=>$c->no_of_original,
':board_status'=>$c->board_status,
':sob_rfs_date'=>$c->sob_rfs_date,
':no_of_non_neg'=>$c->no_of_non_neg,

':customer'=>$c->customer,
':empty_bl_no'=>$c->empty_bl_no
));

if ($statement->rowCount()){
  $data["status"]=1;
  $data["msg"]="Updated";

    //echo 'Success: At least 1 row was affected.';
} else{
  $data["status"]=0;
  $data["msg"]="Some error occurred. Please try again...";

    //echo 'Failure: 0 rows were affected.';
}

if(strlen($c->order_no)!=0)
{
$statement = $db->prepare("UPDATE mt_order_entry set bl_no=:bl_no where order_no=:order_no");
$statement->execute(array(':order_no'=>$c->order_no,':bl_no'=>$c->bl_no));
  if ($statement->rowCount()){
  $data["ord_status"]=1;

    //echo 'Success: At least 1 row was affected.';
} else{
  $data["ord_status"]=0;
    //echo 'Failure: 0 rows were affected.';
}
}

}
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function update_manifestentry($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();


$statement = $db->prepare("UPDATE mt_manifest_entry set 
voyage=:voyage,

manifest_type=:manifest_type,
bl_classification=:bl_classification,
cargo_type=:cargo_type,
order_no=:order_no,

bl_issue_place=:bl_issue_place,
bl_issue_agent=:bl_issue_agent,
no_of_original=:no_of_original,
board_status=:board_status,
sob_rfs_date=:sob_rfs_date,
no_of_non_neg=:no_of_non_neg,

quotation=:quotation,
copy_bl_from=:copy_bl_from,
enquiry=:enquiry,
master_bl_no=:master_bl_no,
commission=:commission,
shipment_terms=:shipment_terms,
bl_date=:bl_date,


remarks=:remarks,
to_order=:to_order,
telex_release=:telex_release,
tsp_bl=:tsp_bl,
modified_by=:modified_by,modified_date= now(),
customer=:customer where id=:id");
$statement->execute(array(
':id'=>$c->id,
':modified_by'=>$dev->username ,

':voyage'=>$c->voyage,

':manifest_type'=>$c->manifest_type,
':bl_classification'=>$c->bl_classification,
':cargo_type'=>$c->cargo_type,
':order_no'=>$c->order_no,

':quotation'=>$c->quotation,
':copy_bl_from'=>$c->copy_bl_from,
':enquiry'=>$c->enquiry,
':master_bl_no'=>$c->master_bl_no,
':commission'=>$c->commission,
':shipment_terms'=>$c->shipment_terms,
':bl_date'=>$c->bl_date,

':remarks'=>$c->remarks,
':to_order'=>$c->to_order,
':telex_release'=>$c->telex_release,
':tsp_bl'=>$c->tsp_bl,

':bl_issue_place'=>$c->bl_issue_place,
':bl_issue_agent'=>$c->bl_issue_agent,
':no_of_original'=>$c->no_of_original,
':board_status'=>$c->board_status,
':sob_rfs_date'=>$c->sob_rfs_date,
':no_of_non_neg'=>$c->no_of_non_neg,

':customer'=>$c->customer
));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}

if(strlen($c->order_no)!=0)
{
$statement = $db->prepare("UPDATE mt_order_entry set bl_no=:bl_no where order_no=:order_no");
$statement->execute(array(':order_no'=>$c->order_no,':bl_no'=>$c->bl_no));
  if ($statement->rowCount()){
  $data["ord_status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data["ord_status"]=0;
    //echo 'Failure: 0 rows were affected.';
}
}
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function update_manifestentry_container($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();


$statement = $db->prepare("UPDATE mt_manifest_entry_container SET 
 container_no=:container_no,type=:type,
 seal_no=:seal_no,
 package_type=:package_type,no_of_pkgs=:no_of_pkgs,volume=:volume,gr_wgt=:gr_wgt,nt_wgt=:nt_wgt,tt_wgt=:tt_wgt,commodity=:commodity,cargo_desc=:cargo_desc,reefer=:reefer,min_temp=:min_temp,max_temp=:max_temp,oog=:oog,oh=:oh,ow=:ow,ol=:ol,haz=:haz,un_no=:un_no,flash_type=:flash_type,
  ip=:ip,created_by=:created_by,ua=:ua,ekey=:ekey,created_date= now() where id=:id and mnf_entry_pk=:mnf_entry_pk");

$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->uid ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,

':container_no'=>$c->container_no,
':type'=>$c->type,
':seal_no'=>$c->seal_no,
':package_type'=>$c->package_type,
':no_of_pkgs'=>$c->no_of_pkgs,
':volume'=>$c->volume,
':gr_wgt'=>$c->gr_wgt,
':nt_wgt'=>$c->nt_wgt,
':tt_wgt'=>$c->tt_wgt,
':commodity'=>$c->commodity,
':cargo_desc'=>$c->cargo_desc,
':reefer'=>$c->reefer,
':min_temp'=>$c->min_temp,
':max_temp'=>$c->max_temp,
':oog'=>$c->oog,
':oh'=>$c->oh,
':ow'=>$c->ow,
':ol'=>$c->ol,
':haz'=>$c->haz,
':un_no'=>$c->un_no,
':flash_type'=>$c->flash_type,

':mnf_entry_pk'=>$c->mnf_entry_pk,
':id'=>$c->id
));

if ($statement->rowCount()){
  $data["status"]=1;

} else{
  $data["status"]=0;
}
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function update_manifestentry_lc($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();


$statement = $db->prepare("UPDATE mt_manifest_entry_landingcraft  SET 
cargo_type=:cargo_type,
vehicle_type=:vehicle_type,
vin_no=:vin_no,
chassis_no=:chassis_no,
package_type=:package_type,
no_of_pkgs=:no_of_pkgs,
volume=:volume,
gr_wgt=:gr_wgt,
nt_wgt=:nt_wgt,
tt_wgt=:tt_wgt,
commodity=:commodity,
cargo_desc=:cargo_desc,
reefer=:reefer,
min_temp=:min_temp,
max_temp=:max_temp,
oog=:oog,
oh=:oh,
ow=:ow,
ol=:ol,
haz=:haz,
un_no=:un_no,
flash_type=:flash_type,
  ip=:ip,created_by=:created_by,ua=:ua,ekey=:ekey,created_date= now() where id=:id and mnf_entry_pk=:mnf_entry_pk");

$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->uid ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,

':cargo_type'=>$c->cargo_type,
':vehicle_type'=>$c->vehicle_type,
':vin_no'=>$c->vin_no,
':chassis_no'=>$c->chassis_no,
':package_type'=>$c->package_type,
':no_of_pkgs'=>$c->no_of_pkgs,
':volume'=>$c->volume,
':gr_wgt'=>$c->gr_wgt,
':nt_wgt'=>$c->nt_wgt,
':tt_wgt'=>$c->tt_wgt,
':commodity'=>$c->commodity,
':cargo_desc'=>$c->cargo_desc,
':reefer'=>$c->reefer,
':min_temp'=>$c->min_temp,
':max_temp'=>$c->max_temp,
':oog'=>$c->oog,
':oh'=>$c->oh,
':ow'=>$c->ow,
':ol'=>$c->ol,
':haz'=>$c->haz,
':un_no'=>$c->un_no,
':flash_type'=>$c->flash_type,

':mnf_entry_pk'=>$c->mnf_entry_pk,
':id'=>$c->id
));

if ($statement->rowCount()){
  $data["status"]=1;

} else{
  $data["status"]=0;
}
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function update_manifestentry_route($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();


$statement = $db->prepare("UPDATE mt_manifest_entry_route SET    
 voyage=:voyage,
vessel=:vessel,
eline=:eline,
port=:port,
service=:service,
eta=:eta,
etd=:etd,
poo=:poo,
pol=:pol,
pod=:pod,
pof=:pof,
tsp1=:tsp1,
tsp2=:tsp2,
tsp3=:tsp3,
tsp4=:tsp4,
tsp5=:tsp5,
  ip=:ip,created_by=:created_by,ua=:ua,ekey=:ekey,created_date= now() where id=:id and mnf_entry_pk=:mnf_entry_pk");

$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->uid ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,

':voyage'=>$c->voyage,
':vessel'=>$c->vessel,
':eline'=>$c->eline,
':port'=>$c->port,
':service'=>$c->service,
':eta'=>$c->eta,
':etd'=>$c->etd,
':poo'=>$c->poo,
':pol'=>$c->pol,
':pod'=>$c->pod,
':pof'=>$c->pof,
':tsp1'=>$c->tsp1,
':tsp2'=>$c->tsp2,
':tsp3'=>$c->tsp3,
':tsp4'=>$c->tsp4,
':tsp5'=>$c->tsp5,

':mnf_entry_pk'=>$c->mnf_entry_pk,
':id'=>$c->id
));

if ($statement->rowCount()){
  $data["status"]=1;

} else{
  $data["status"]=0;
}

//UPDATE BASICS->Voyage
$statement = $db->prepare("UPDATE mt_manifest_entry  
SET voyage=:voyage, 
    vessel=:vessel  
where id=:id");
$statement->execute(array(':voyage'=>$c->voyage,':vessel'=>$c->vessel,':id'=>$c->mnf_entry_pk));

if ($statement->rowCount()){
  $data["voyage_upd_status"]=1;
} else{
  $data["voyage_upd_status"]=0;
}


$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function update_manifestentry_rate($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();


$statement = $db->prepare("UPDATE mt_manifest_entry_rate SET  
type=:type,
charge_desc=:charge_desc,
pay_at_location=:pay_at_location,
basis_type=:basis_type,
basis_uom=:basis_uom,
qty=:qty,
currency=:currency,
ex_rate=:ex_rate,
rate=:rate,
cost=:cost,
cost_base_amount=:cost_base_amount,
container=:container,
payment_mode=:payment_mode,
charge_print=:charge_print,
commodity=:commodity,
remarks=:remarks,
status=:status,
  ip=:ip,created_by=:created_by,ua=:ua,ekey=:ekey,created_date= now() where id=:id and mnf_entry_pk=:mnf_entry_pk");

$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->uid ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,

':type'=>$c->type,
':charge_desc'=>$c->charge_desc,
':pay_at_location'=>$c->pay_at_location,
':basis_type'=>$c->basis_type,
':basis_uom'=>$c->basis_uom,
':qty'=>$c->qty,
':currency'=>$c->currency,
':ex_rate'=>$c->ex_rate,
':rate'=>$c->rate,
':cost'=>$c->cost,
':cost_base_amount'=>$c->cost_base_amount,
':container'=>$c->container,
':payment_mode'=>$c->payment_mode,
':charge_print'=>$c->charge_print,
':commodity'=>$c->commodity,
':remarks'=>$c->remarks,
':status'=>$c->status,

':mnf_entry_pk'=>$c->mnf_entry_pk,
':id'=>$c->id
));

if ($statement->rowCount()){
  $data["status"]=1;

} else{
  $data["status"]=0;
}
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function update_manifestentry_party($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();


$statement = $db->prepare("UPDATE mt_manifest_entry_party SET equipment_serial=:equipment_serial,
 party_type=:party_type,
party_name=:party_name,
address=:address,
telephone=:telephone,
email=:email,
poc=:poc,
address_on_bl=:address_on_bl,
status=:status,
  ip=:ip,created_by=:created_by,ua=:ua,ekey=:ekey,created_date= now() where id=:id and mnf_entry_pk=:mnf_entry_pk");

$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->uid ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,

':equipment_serial'=>$c->equipment_serial,
':party_type'=>$c->party_type,
':party_name'=>$c->party_name,
':address'=>$c->address,
':telephone'=>$c->telephone,
':email'=>$c->email,
':poc'=>$c->poc,
':address_on_bl'=>$c->address_on_bl,
':status'=>$c->status,

':mnf_entry_pk'=>$c->mnf_entry_pk,
':id'=>$c->id
));

if ($statement->rowCount()){
  $data["status"]=1;

} else{
  $data["status"]=0;
}
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

// UPDATE ENDS

public static function save_manifestentry1($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();
$temp_code=uniqid($dev->uid);

$statement = $db->prepare("INSERT into mt_manifest_entry(

voyage,
bl_no,
status,
manifest_type,
bl_classification,
cargo_type,
order_no,

quotation,
copy_bl_from,
enquiry,
master_bl_no,
shipment_terms,
bl_date,


remarks,
to_order,
telex_release,
tsp_bl,

company_id,location_id,ip,created_by, ua,ekey,
created_date,temp_code,customer,empty_bl_no) 
values(

:voyage,
:bl_no,
:status,
:manifest_type,
:bl_classification,
:cargo_type,
:order_no,

:quotation,
:copy_bl_from,
:enquiry,
:master_bl_no,
:shipment_terms,
:bl_date,


:remarks,
:to_order,
:telex_release,
:tsp_bl,

:company_id,:location_id,:ip ,:uid ,:ua ,:ekey,
now(),:temp_code,:customer,:empty_bl_no)");
$statement->execute(array(
  ':ip'=>$dev->ip,
  ':uid'=>$dev->username ,
  ':ua'=>$dev->ua,
  ':ekey'=>$dev->ekey,

':voyage'=>$c->voyage,
':bl_no'=>$c->bl_no,
':status'=>$c->status,
':manifest_type'=>$c->manifest_type,
':bl_classification'=>$c->bl_classification,
':cargo_type'=>$c->cargo_type,
':order_no'=>$c->order_no,

':quotation'=>$c->quotation,
':copy_bl_from'=>$c->copy_bl_from,
':enquiry'=>$c->enquiry,
':master_bl_no'=>$c->master_bl_no,
':shipment_terms'=>$c->shipment_terms,
':bl_date'=>$c->bl_date,


':remarks'=>$c->remarks,
':to_order'=>$c->to_order,
':telex_release'=>$c->telex_release,
':tsp_bl'=>$c->tsp_bl,

':temp_code'=>$temp_code,
':company_id'=>$dev->company,
':location_id'=>$dev->location,

':customer'=>$c->customer,
':empty_bl_no'=>$c->empty_bl_no
));

if ($statement->rowCount()){
  $data["status"]=1;
  $data["msg"]="Saved";
    //echo 'Success: At least 1 row was affected.';
  /*

  */
} else{
  $data["status"]=0;
  $data["msg"]="Some error occurred. Please try again...";
  
    //echo 'Failure: 0 rows were affected.';
}

$statement = $db->prepare("SELECT id from mt_manifest_entry where created_by=:uid and temp_code=:temp_code");
$statement->execute(array(':temp_code'=>$temp_code,':uid'=>$dev->username));
$data["id"]=$statement->fetchAll(PDO::FETCH_ASSOC);

//update bl on order
if(strlen($c->order_no)!=0)
{
$statement = $db->prepare("UPDATE mt_order_entry set bl_no=:bl_no where order_no=:order_no");
$statement->execute(array(':order_no'=>$c->order_no,':bl_no'=>$c->bl_no));
  if ($statement->rowCount()){
  $data["ord_status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data["ord_status"]=0;
    //echo 'Failure: 0 rows were affected.';
}
}

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function save_manifestentry($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();
$temp_code=uniqid($dev->uid);

$statement = $db->prepare("INSERT into mt_manifest_entry(

voyage,
bl_no,
status,
manifest_type,
bl_classification,
cargo_type,
order_no,

quotation,
copy_bl_from,
enquiry,
master_bl_no,
commission,
shipment_terms,
bl_date,


remarks,
to_order,
telex_release,
tsp_bl,

company_id,location_id,ip,created_by, ua,ekey,created_date,temp_code,customer) 
values(

:voyage,
:bl_no,
:status,
:manifest_type,
:bl_classification,
:cargo_type,
:order_no,

:quotation,
:copy_bl_from,
:enquiry,
:master_bl_no,
:commission,
:shipment_terms,
:bl_date,


:remarks,
:to_order,
:telex_release,
:tsp_bl,

:company_id,:location_id,:ip ,:uid ,:ua ,:ekey,now(),:temp_code,:customer)");
$statement->execute(array(
  ':ip'=>$dev->ip,
  ':uid'=>$dev->username ,
  ':ua'=>$dev->ua,
  ':ekey'=>$dev->ekey,

':voyage'=>$c->voyage,
':bl_no'=>$c->bl_no,
':status'=>$c->status,
':manifest_type'=>$c->manifest_type,
':bl_classification'=>$c->bl_classification,
':cargo_type'=>$c->cargo_type,
':order_no'=>$c->order_no,

':quotation'=>$c->quotation,
':copy_bl_from'=>$c->copy_bl_from,
':enquiry'=>$c->enquiry,
':master_bl_no'=>$c->master_bl_no,
':commission'=>$c->commission,
':shipment_terms'=>$c->shipment_terms,
':bl_date'=>$c->bl_date,


':remarks'=>$c->remarks,
':to_order'=>$c->to_order,
':telex_release'=>$c->telex_release,
':tsp_bl'=>$c->tsp_bl,

':temp_code'=>$temp_code,
':company_id'=>$dev->company,
':location_id'=>$dev->location,

':customer'=>$c->customer
));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
  /*

  */
} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}

$statement = $db->prepare("SELECT id from mt_manifest_entry where created_by=:uid and temp_code=:temp_code");
$statement->execute(array(':temp_code'=>$temp_code,':uid'=>$dev->username));
$data["id"]=$statement->fetchAll(PDO::FETCH_ASSOC);

//update bl on order
if(strlen($c->order_no)!=0)
{
$statement = $db->prepare("UPDATE mt_order_entry set bl_no=:bl_no where order_no=:order_no");
$statement->execute(array(':order_no'=>$c->order_no,':bl_no'=>$c->bl_no));
  if ($statement->rowCount()){
  $data["ord_status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data["ord_status"]=0;
    //echo 'Failure: 0 rows were affected.';
}
}

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function save_manifest_export_entry($dev,$code)
{
$data=array();
$c=$code->info;
try
{
$db = Factory::getConnection();
$temp_code=uniqid($dev->uid);

$statement = $db->prepare("INSERT into mt_manifest_entry(
id,
voyage,
bl_no,
status,
manifest_type,
bl_classification,
cargo_type,
order_no,
so_no,
quotation,
copy_bl_from,
enquiry,
master_bl_no,
commission,
shipment_terms,
bl_date,
bl_issue_place,
bl_issue_agent,
no_of_original,
no_of_hbls,
no_of_non_neg,
board_status,
sob_rfs_date,
remarks,
remarks2,
to_order,
telex_release,
tsp_bl,
mnf_corrector_no,
mnf_corrector_status,
mnf_bl_type,
mnf_bl_no,
mnf_corrector_date,
mnf_corrector_version,
mnf_corrector_type,
mnf_corrector_reference,
mnf_corrector_remarks,
company_id,location_id,ip,created_by, ua,ekey,created_date,temp_code,
delivery_agent) 
values(
:id,
:voyage,
:bl_no,
:status,
:manifest_type,
:bl_classification,
:cargo_type,
:order_no,
:so_no,
:quotation,
:copy_bl_from,
:enquiry,
:master_bl_no,
:commission,
:shipment_terms,
:bl_date,
:bl_issue_place,
:bl_issue_agent,
:no_of_original,
:no_of_hbls,
:no_of_non_neg,
:board_status,
:sob_rfs_date,
:remarks,
:remarks2,
:to_order,
:telex_release,
:tsp_bl,
:mnf_corrector_no,
:mnf_corrector_status,
:mnf_bl_type,
:mnf_bl_no,
:mnf_corrector_date,
:mnf_corrector_version,
:mnf_corrector_type,
:mnf_corrector_reference,
:mnf_corrector_remarks,
:company_id,:location_id,:ip ,:uid ,:ua ,:ekey,now(),:temp_code,
:delivery_agent)");
$statement->execute(array(':ip'=>$dev->ip,':uid'=>$dev->uid ,':ua'=>$dev->ua,':ekey'=>$dev->ekey,
':id'=>$c->id,
':voyage'=>$c->voyage,
':bl_no'=>$c->bl_no,
':status'=>$c->status,
':manifest_type'=>$c->manifest_type,
':bl_classification'=>$c->bl_classification,
':cargo_type'=>$c->cargo_type,
':order_no'=>$c->order_no,
':so_no'=>$c->so_no,
':quotation'=>$c->quotation,
':copy_bl_from'=>$c->copy_bl_from,
':enquiry'=>$c->enquiry,
':master_bl_no'=>$c->master_bl_no,
':commission'=>$c->commission,
':shipment_terms'=>$c->shipment_terms,
':bl_date'=>$c->bl_date,
':bl_issue_place'=>$c->bl_issue_place,
':bl_issue_agent'=>$c->bl_issue_agent,
':no_of_original'=>$c->no_of_original,
':no_of_hbls'=>$c->no_of_hbls,
':no_of_non_neg'=>$c->no_of_non_neg,
':board_status'=>$c->board_status,
':sob_rfs_date'=>$c->sob_rfs_date,
':remarks'=>$c->remarks,
':remarks2'=>$c->remarks2,
':to_order'=>$c->to_order,
':telex_release'=>$c->telex_release,
':tsp_bl'=>$c->tsp_bl,
':mnf_corrector_no'=>$c->mnf_corrector_no,
':mnf_corrector_status'=>$c->mnf_corrector_status,
':mnf_bl_type'=>$c->mnf_bl_type,
':mnf_bl_no'=>$c->mnf_bl_no,
':mnf_corrector_date'=>$c->mnf_corrector_date,
':mnf_corrector_version'=>$c->mnf_corrector_version,
':mnf_corrector_type'=>$c->mnf_corrector_type,
':mnf_corrector_reference'=>$c->mnf_corrector_reference,
':mnf_corrector_remarks'=>$c->mnf_corrector_remarks,
':temp_code'=>$temp_code,

':company_id'=>$dev->company,
':location_id'=>$dev->location,
':delivery_agent'=>$c->delivery_agent
));

if ($statement->rowCount()){
  $data["status"]=1;

} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}

$statement = $db->prepare("SELECT id from mt_manifest_entry where created_by=:uid and temp_code=:temp_code");
$statement->execute(array(':temp_code'=>$temp_code,':uid'=>$dev->uid));
$op=$statement->fetchAll(PDO::FETCH_ASSOC);

$data["id"]=$op;

$fid=self::setFourDigit($op[0]["id"]);

$bl_no='BL/'.date('Y').'/'.date('m').'/'.$c->bl_issue_place.'/'.$fid;


   $statement = $db->prepare("UPDATE mt_manifest_entry 
  SET bl_no=:bl_no where id=:id");
  $statement->execute(array(':id'=>$op[0]["id"],':bl_no'=>$bl_no));
  
    if ($statement->rowCount()){
    $data["blid_status"]=1;
    $data["bl_no"]=$bl_no;
      //echo 'Success: At least 1 row was affected.';
  } else{
    $data["blid_status"]=0;
      //echo 'Failure: 0 rows were affected.';
  }

//1
for($i=0;$i<count($code->container);$i++)
{
  $container=$code->container[$i];
  $container->mnf_entry_pk=$data["id"][0]["id"];
  self::save_manifestentry_container($dev,$container);
}
//2
for($i=0;$i<count($code->lc);$i++)
{
  $lc=$code->lc[$i];
  $lc->mnf_entry_pk=$data["id"][0]["id"];
  self::save_manifestentry_lc($dev,$lc);
}
//3
for($i=0;$i<count($code->route);$i++)
{
  $route=$code->route[$i];
  $route->mnf_entry_pk=$data["id"][0]["id"];
  self::save_manifestentry_route($dev,$route);
}
//4
for($i=0;$i<count($code->rate);$i++)
{
  $rate=$code->rate[$i];
  $rate->mnf_entry_pk=$data["id"][0]["id"];
  self::save_manifestentry_rate($dev,$rate);
}
//5
for($i=0;$i<count($code->party);$i++)
{
  $party=$code->party[$i];
  $party->mnf_entry_pk=$data["id"][0]["id"];
  self::save_manifestentry_party($dev,$party);
}

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}



public static function save_manifestentry_container($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$temp_code=uniqid($dev->uid);

$statement = $db->prepare("INSERT into mt_manifest_entry_container(
mnf_entry_pk,
container_no,
type,
seal_no,
package_type,
no_of_pkgs,
volume,
gr_wgt,
nt_wgt,
tt_wgt,
commodity,
cargo_desc,
reefer,
min_temp,
max_temp,
oog,
oh,
ow,
ol,
haz,
un_no,
flash_type,
company_id,location_id,ip,created_by, ua,ekey,created_date,temp_code) 
values(
:mnf_entry_pk,
:container_no,
:type,
:seal_no,
:package_type,
:no_of_pkgs,
:volume,
:gr_wgt,
:nt_wgt,
:tt_wgt,
:commodity,
:cargo_desc,
:reefer,
:min_temp,
:max_temp,
:oog,
:oh,
:ow,
:ol,
:haz,
:un_no,
:flash_type,
'','',:ip ,:created_by ,:ua ,:ekey,now(),:temp_code)");
$statement->execute(array(':ip'=>$dev->ip,
  ':created_by'=>$dev->username ,
  ':ua'=>$dev->ua,':ekey'=>$dev->ekey,
':mnf_entry_pk'=>$c->mnf_entry_pk,
':container_no'=>$c->container_no,
':type'=>$c->type,
':seal_no'=>$c->seal_no,
':package_type'=>$c->package_type,
':no_of_pkgs'=>$c->no_of_pkgs,
':volume'=>$c->volume,
':gr_wgt'=>$c->gr_wgt,
':nt_wgt'=>$c->nt_wgt,
':tt_wgt'=>$c->tt_wgt,
':commodity'=>$c->commodity,
':cargo_desc'=>$c->cargo_desc,
':reefer'=>$c->reefer,
':min_temp'=>$c->min_temp,
':max_temp'=>$c->max_temp,
':oog'=>$c->oog,
':oh'=>$c->oh,
':ow'=>$c->ow,
':ol'=>$c->ol,
':haz'=>$c->haz,
':un_no'=>$c->un_no,
':flash_type'=>$c->flash_type,
':temp_code'=>$temp_code
));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}

$statement = $db->prepare("SELECT id from mt_manifest_entry_container where created_by=:created_by and temp_code=:temp_code and mnf_entry_pk=:mnf_entry_pk");
$statement->execute(array(':temp_code'=>$temp_code,
  ':created_by'=>$dev->username,':mnf_entry_pk'=>$c->mnf_entry_pk));
$data["id"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function save_manifestentry_lc($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$temp_code=uniqid($dev->uid);

$statement = $db->prepare("INSERT into mt_manifest_entry_landingcraft(
mnf_entry_pk,
cargo_type,
vehicle_type,
vin_no,
chassis_no,
package_type,
no_of_pkgs,
volume,
gr_wgt,
nt_wgt,
tt_wgt,
commodity,
cargo_desc,
reefer,
min_temp,
max_temp,
oog,
oh,
ow,
ol,
haz,
un_no,
flash_type,
company_id,location_id,ip,created_by, ua,ekey,created_date,temp_code,
d_l_flag) 
values(
:mnf_entry_pk,
:cargo_type,
:vehicle_type,
:vin_no,
:chassis_no,
:package_type,
:no_of_pkgs,
:volume,
:gr_wgt,
:nt_wgt,
:tt_wgt,
:commodity,
:cargo_desc,
:reefer,
:min_temp,
:max_temp,
:oog,
:oh,
:ow,
:ol,
:haz,
:un_no,
:flash_type,
'','',:ip ,:created_by ,:ua ,:ekey,now(),:temp_code,'N')");
$statement->execute(array(':ip'=>$dev->ip,
  ':created_by'=>$dev->username ,
  ':ua'=>$dev->ua,':ekey'=>$dev->ekey,
':mnf_entry_pk'=>$c->mnf_entry_pk,
':cargo_type'=>$c->cargo_type,
':vehicle_type'=>$c->vehicle_type,
':vin_no'=>$c->vin_no,
':chassis_no'=>$c->chassis_no,
':package_type'=>$c->package_type,
':no_of_pkgs'=>$c->no_of_pkgs,
':volume'=>$c->volume,
':gr_wgt'=>$c->gr_wgt,
':nt_wgt'=>$c->nt_wgt,
':tt_wgt'=>$c->tt_wgt,
':commodity'=>$c->commodity,
':cargo_desc'=>$c->cargo_desc,
':reefer'=>$c->reefer,
':min_temp'=>$c->min_temp,
':max_temp'=>$c->max_temp,
':oog'=>$c->oog,
':oh'=>$c->oh,
':ow'=>$c->ow,
':ol'=>$c->ol,
':haz'=>$c->haz,
':un_no'=>$c->un_no,
':flash_type'=>$c->flash_type,
':temp_code'=>$temp_code

));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
  /*

  */
} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}

$statement = $db->prepare("SELECT id from mt_manifest_entry_landingcraft where created_by=:created_by and temp_code=:temp_code and mnf_entry_pk=:mnf_entry_pk");
$statement->execute(array(':temp_code'=>$temp_code,
  ':created_by'=>$dev->username,':mnf_entry_pk'=>$c->mnf_entry_pk));
$data["id"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function save_manifestentry_route($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$temp_code=uniqid($dev->uid);

$statement = $db->prepare("INSERT into mt_manifest_entry_route(
mnf_entry_pk,
voyage,
vessel,
eline,
port,
service,
eta,
etd,
poo,
pol,
pod,
pof,
tsp1,
tsp2,
tsp3,
tsp4,
tsp5,
company_id,location_id,ip,created_by, ua,ekey,created_date,temp_code) 
values(
:mnf_entry_pk,
:voyage,
:vessel,
:eline,
:port,
:service,
:eta,
:etd,
:poo,
:pol,
:pod,
:pof,
:tsp1,
:tsp2,
:tsp3,
:tsp4,
:tsp5,
'','',:ip ,:created_by ,:ua ,:ekey,now(),:temp_code)");
$statement->execute(array(':ip'=>$dev->ip,
  ':created_by'=>$dev->username ,
  ':ua'=>$dev->ua,':ekey'=>$dev->ekey,
':mnf_entry_pk'=>$c->mnf_entry_pk,
':voyage'=>$c->voyage,
':vessel'=>$c->vessel,
':eline'=>$c->eline,
':port'=>$c->port,
':service'=>'',
':eta'=>$c->eta,
':etd'=>$c->etd,
':poo'=>$c->poo,
':pol'=>$c->pol,
':pod'=>$c->pod,
':pof'=>$c->pof,
':tsp1'=>$c->tsp1,
':tsp2'=>$c->tsp2,
':tsp3'=>$c->tsp3,
':tsp4'=>$c->tsp4,
':tsp5'=>$c->tsp5,
':temp_code'=>$temp_code

));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
  /*

  */
} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}

$statement = $db->prepare("SELECT id from mt_manifest_entry_route where created_by=:created_by and temp_code=:temp_code and mnf_entry_pk=:mnf_entry_pk");
$statement->execute(array(':temp_code'=>$temp_code,
  ':created_by'=>$dev->username,':mnf_entry_pk'=>$c->mnf_entry_pk));
$data["id"]=$statement->fetchAll(PDO::FETCH_ASSOC);

//UPDATE BASICS->Voyage
$statement = $db->prepare("UPDATE mt_manifest_entry  
SET voyage=:voyage, 
    vessel=:vessel  
where id=:id");
$statement->execute(array(':voyage'=>$c->voyage,':vessel'=>$c->vessel,':id'=>$c->mnf_entry_pk));

if ($statement->rowCount()){
  $data["voyage_upd_status"]=1;
} else{
  $data["voyage_upd_status"]=0;
}

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function save_manifestentry_rate($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$temp_code=uniqid($dev->uid);

$statement = $db->prepare("INSERT into mt_manifest_entry_rate(
mnf_entry_pk,
type,
charge_desc,
pay_at_location,
basis_type,
basis_uom,
qty,
currency,
ex_rate,
rate,
cost,
cost_base_amount,
container,
payment_mode,
charge_print,
commodity,
remarks,
status,
company_id,location_id,ip,created_by, ua,ekey,created_date,temp_code) 
values(
:mnf_entry_pk,
:type,
:charge_desc,
:pay_at_location,
:basis_type,
:basis_uom,
:qty,
:currency,
:ex_rate,
:rate,
:cost,
:cost_base_amount,
:container,
:payment_mode,
:charge_print,
:commodity,
:remarks,
:status,
'','',:ip ,:created_by ,:ua ,:ekey,now(),:temp_code)");

if($c->qty=="")
{
  $c->qty=null;
}
if($c->ex_rate=="")
{
  $c->ex_rate=null;
}
if($c->rate=="")
{
  $c->rate=null;
}
if($c->cost=="")
{
  $c->cost=null;
}
if($c->cost_base_amount=="")
{
  $c->cost_base_amount=null;
}
$statement->execute(array(':ip'=>$dev->ip,
  ':created_by'=>$dev->username ,':ua'=>$dev->ua,':ekey'=>$dev->ekey,
':mnf_entry_pk'=>$c->mnf_entry_pk,
':type'=>$c->type,
':charge_desc'=>$c->charge_desc,
':pay_at_location'=>$c->pay_at_location,
':basis_type'=>$c->basis_type,
':basis_uom'=>$c->basis_uom,
':qty'=>$c->qty,
':currency'=>$c->currency,
':ex_rate'=>$c->ex_rate,
':rate'=>$c->rate,
':cost'=>$c->cost,
':cost_base_amount'=>$c->cost_base_amount,
':container'=>$c->container,
':payment_mode'=>$c->payment_mode,
':charge_print'=>$c->charge_print,
':commodity'=>$c->commodity,
':remarks'=>$c->remarks,
':status'=>$c->status,
':temp_code'=>$temp_code

));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';

} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}

$statement = $db->prepare("SELECT id from mt_manifest_entry_rate where created_by=:created_by and temp_code=:temp_code and mnf_entry_pk=:mnf_entry_pk");
$statement->execute(array(':temp_code'=>$temp_code,
  ':created_by'=>$dev->username,':mnf_entry_pk'=>$c->mnf_entry_pk));
$data["id"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function save_manifestentry_party($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$temp_code=uniqid($dev->uid);
$statement = $db->prepare("SELECT * from mt_manifest_entry_party where mnf_entry_pk=:id and party_type=:party_type");
$statement->execute(array(':party_type'=>$c->party_type,
  ':id'=>$c->mnf_entry_pk));
$ops=$statement->fetchAll(PDO::FETCH_ASSOC);
//if(count($ops)==0)
//{
$statement = $db->prepare("INSERT into mt_manifest_entry_party(
mnf_entry_pk,
party_type,
party_name,
address,
telephone,
email,
poc,
address_on_bl,
status,
company_id,location_id,ip,created_by, ua,ekey,created_date,temp_code) 
values(
:mnf_entry_pk,
:party_type,
:party_name,
:address,
:telephone,
:email,
:poc,
:address_on_bl,
:status,
'','',:ip ,:created_by ,:ua ,:ekey,now(),:temp_code)");
$statement->execute(array(':ip'=>$dev->ip,
  ':created_by'=>$dev->username ,
  ':ua'=>$dev->ua,':ekey'=>$dev->ekey,
':mnf_entry_pk'=>$c->mnf_entry_pk,
':party_type'=>$c->party_type,
':party_name'=>$c->party_name,
':address'=>$c->address,
':telephone'=>$c->telephone,
':email'=>$c->email,
':poc'=>$c->poc,
':address_on_bl'=>$c->address_on_bl,
':status'=>$c->status,
':temp_code'=>$temp_code

));

if ($statement->rowCount()){
  $data["status"]=1;
} else{
  $data["status"]=0;
}

$statement = $db->prepare("SELECT id from mt_manifest_entry_party where created_by=:created_by and temp_code=:temp_code and mnf_entry_pk=:mnf_entry_pk");
$statement->execute(array(':temp_code'=>$temp_code,
  ':created_by'=>$dev->username,':mnf_entry_pk'=>$c->mnf_entry_pk));
$data["id"]=$statement->fetchAll(PDO::FETCH_ASSOC);
// }else{
//   $data["status"]=2;
// }

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

// get info method begins
public static function get_import_manifest_attachment($id)
{
$data=false;
try
{
$db = Factory::getConnection();

$statement = $db->prepare("SELECT id,
mnf_entry_pk,doc_type,file_name,file_url,
'0' edit 
from mt_manifest_entry_attach where mnf_entry_pk=:mnf_entry_pk");
$statement->execute(array(':mnf_entry_pk'=>$id));
$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function delete_import_manifest_attachment($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();
$temp_code=uniqid($dev->uid);
$statement = $db->prepare("DELETE from mt_manifest_entry_attach
   where id=:id");
$statement->execute(array(
  ':id'=>$c->id
));

if ($statement->rowCount()){
  $data["status"]=1;
} else{
  $data["status"]=0;
}

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function update_import_manifest_attachment($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();
$temp_code=uniqid($dev->uid);
$statement = $db->prepare("UPDATE mt_manifest_entry_attach 
SET doc_type=:doc_type,file_name=:file_name,
file_url=:file_url,
modified_by=:username,modified_date=now()
where id=:id");
$statement->execute(array(
':username'=>$dev->username ,

':doc_type'=>$c->doc_type,
':file_name'=>$c->file_name,
':file_url'=>$c->file_url,
':id'=>$c->id
));

if ($statement->rowCount()){
  $data["status"]=1;
} else{
  $data["status"]=0;
}

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function save_import_manifest_attachment($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();
$temp_code=uniqid($dev->uid);
$statement = $db->prepare("INSERT into mt_manifest_entry_attach(
mnf_entry_pk,doc_type,
file_name,file_url,
company_id,location_id,ip,created_by, ua,ekey,created_date,temp_code) 
values(
:mnf_entry_pk,
:doc_type,
:file_name,:file_url,
:company_id,:location_id,
:ip,:created_by,:ua,:ekey,now(),:temp_code)");
$statement->execute(array(':ip'=>$dev->ip,
  ':created_by'=>$dev->username ,
  ':ua'=>$dev->ua,':ekey'=>$dev->ekey,

':mnf_entry_pk'=>$c->mnf_entry_pk,
':doc_type'=>$c->doc_type,

':temp_code'=>$temp_code,
':company_id'=>$dev->company,
':location_id'=>$dev->location,
':file_name'=>$c->file_name,
':file_url'=>$c->file_url
));

if ($statement->rowCount()){
  $data["status"]=1;
} else{
  $data["status"]=0;
}

$statement = $db->prepare("SELECT id from mt_manifest_entry_attach where created_by=:created_by and temp_code=:temp_code and mnf_entry_pk=:mnf_entry_pk");
$statement->execute(array(':temp_code'=>$temp_code,
  ':created_by'=>$dev->username,':mnf_entry_pk'=>$c->mnf_entry_pk));
$data["id"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function save_manifestentry_marks($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$temp_code=uniqid($dev->uid);

$statement = $db->prepare("INSERT into mt_manifest_entry_marks(
mnf_entry_pk,
marks,
description,
status,
company_id,location_id,ip,created_by, ua,ekey,created_date,temp_code) 
values(
:mnf_entry_pk,
:marks,
:description,
:status,
'','',:ip ,:created_by ,:ua ,:ekey,now(),:temp_code)");
$statement->execute(array(':ip'=>$dev->ip,
  ':created_by'=>$dev->username ,
  ':ua'=>$dev->ua,':ekey'=>$dev->ekey,
':mnf_entry_pk'=>$c->mnf_entry_pk,
':marks'=>$c->marks,
':description'=>$c->description,
':status'=>$c->status,
':temp_code'=>$temp_code

));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
  /*

  */
} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}

$statement = $db->prepare("SELECT id from mt_manifest_entry_marks where created_by=:created_by and temp_code=:temp_code and mnf_entry_pk=:mnf_entry_pk");
$statement->execute(array(':temp_code'=>$temp_code,
  ':created_by'=>$dev->username,':mnf_entry_pk'=>$c->mnf_entry_pk));
$data["id"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function save_manifestentry_clause($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$temp_code=uniqid($dev->uid);

$statement = $db->prepare("INSERT into mt_manifest_entry_clause(
mnf_entry_pk,
clause_code,
print_on_bl,
description,
status,
company_id,location_id,ip,uid, ua,ekey,created_date,temp_code) 
values(
:mnf_entry_pk,
:clause_code,
:print_on_bl,
:description,
:status,
'','',:ip ,:uid ,:ua ,:ekey,now(),:temp_code)");
$statement->execute(array(':ip'=>$dev->ip,':uid'=>$dev->uid ,':ua'=>$dev->ua,':ekey'=>$dev->ekey,
':mnf_entry_pk'=>$c->mnf_entry_pk,
':clause_code'=>$c->clause_code,
':print_on_bl'=>$c->print_on_bl,
':description'=>$c->description,
':status'=>$c->status,
':temp_code'=>$temp_code

));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
  /*

  */
} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}

$statement = $db->prepare("SELECT id from mt_manifest_entry_clause where created_by=:uid and temp_code=:temp_code and mnf_entry_pk=:mnf_entry_pk");
$statement->execute(array(':temp_code'=>$temp_code,
  ':uid'=>$dev->uid,':mnf_entry_pk'=>$c->mnf_entry_pk));
$data["id"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

// SAVE ENDS

public static function save_roboticchargesentry($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();


$statement = $db->prepare("INSERT into mt_robotic_charges_entry(
id,
shipment_type,
voyage,
vessel,
eline,
port,
eta,
etd,
bl_no,
order_no,
company_id,location_id,ip,uid, ua,ekey,created_date) 
values(
:id,
:shipment_type,
:voyage,
:vessel,
:eline,
:port,
:eta,
:etd,
:bl_no,
:order_no,
'','',:ip ,:uid ,:ua ,:ekey,now())");
$statement->execute(array(':ip'=>$dev->ip,':uid'=>$dev->uid ,':ua'=>$dev->ua,':ekey'=>$dev->ekey,
':id'=>$c->id,
':shipment_type'=>$c->shipment_type,
':voyage'=>$c->voyage,
':vessel'=>$c->vessel,
':eline'=>$c->eline,
':port'=>$c->port,
':eta'=>$c->eta,
':etd'=>$c->etd,
':bl_no'=>$c->bl_no,
':order_no'=>$c->order_no
));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}
// SAVE ROBOTIC CHARGES ENTRY ENDS

//****************************************************************************************
//MANIFEST TO ORDERS
//***************************************************************************************

public static function get_manifesttoorders_list_bymt($dev,$c)
{
$data=false;
try
{
$db = Factory::getConnection();
$aq=Factory::getRestrictionQuery1($dev,"t1");

$statement = $db->prepare("SELECT 
t1.id,
t1.voyage,
t1.bl_no,
t2.poo, 
t2.pol, 
t2.pod, 
t2.pof,
t1.order_no,
length(IFNULL(t1.order_no,'')) is_ordered,
(select party_name from mt_manifest_entry_party where party_type='SHIPPER' and mnf_entry_pk=t1.id limit 1) shipper,
(select party_name from mt_manifest_entry_party where party_type='CONSIGNEE' and mnf_entry_pk=t1.id limit 1) consignee, 
(select party_name from mt_manifest_entry_party where party_type='NOTIFY PARTY' and mnf_entry_pk=t1.id limit 1) notify,
t1.company_id,
t1.location_id,
'' selected,
manifest_type,
t1.cargo_type  
 from 
mt_manifest_entry t1 ,
mt_manifest_entry_route t2 WHERE $aq and 
t2.mnf_entry_pk=t1.id AND order_no is null and manifest_type=:type order by t1.created_date desc limit 200
");
$statement->execute(array(':type'=>$c));
$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_robotic_charges_list($c)
{
$data=false;
try
{
  $q="";
  $ar=array();
  if(strlen($c->voyage)!=0)
  {
    $q=$q." and t1.voyage=:voyage ";
    $ar["voyage"]=$c->voyage;
  }

    if(strlen($c->order_no)!=0)
  {
    $q=$q." and t1.order_no=:order_no ";
    $ar["order_no"]=$c->order_no;
  }

    if(strlen($c->bl_no)!=0)
  {
    $q=$q." and t1.bl_no=:bl_no ";
    $ar["bl_no"]=$c->bl_no;
  }

$db = Factory::getConnection();
$statement = $db->prepare("SELECT 
t1.bl_date,
t1.id,
t1.bl_no,
t2.poo, 
t2.pol, 
t2.pod, 
t2.pof,
t1.order_no,
length(t1.order_no) is_ordered,
(select party_name from mt_manifest_entry_party where party_type='SHIPPER' and mnf_entry_pk=t1.id) shipper,
(select party_name from mt_manifest_entry_party where party_type='CONSIGNEE' and mnf_entry_pk=t1.id) consignee, 
(select party_name from mt_manifest_entry_party where party_type='NOTIFY PARTY' and mnf_entry_pk=t1.id) notify,
t1.company_id,
t1.location_id,
'' selected,
manifest_type 
 from 
mt_manifest_entry t1,
mt_manifest_entry_route t2 WHERE 
t2.mnf_entry_pk=t1.id
".$q);
$statement->execute($ar);
$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function get_manifesttoorders_list($dev)
{
$data=false;
try
{
$db = Factory::getConnection();
$aq=Factory::getRestrictionQuery1($dev,"t1");

$statement = $db->prepare("SELECT 
t1.id,
t1.bl_no,
t1.voyage,
t2.poo, 
t2.pol, 
t2.pod, 
t2.pof,
t1.order_no,
length(IFNULL(t1.order_no,'')) is_ordered,
(select party_name from mt_manifest_entry_party where party_type='SHIPPER' and mnf_entry_pk=t1.id limit 1) shipper,
ifnull(customer,(select party_name from mt_manifest_entry_party where party_type='CONSIGNEE' and mnf_entry_pk=t1.id limit 1)) consignee, 
(select party_name from mt_manifest_entry_party where party_type='NOTIFY PARTY' and mnf_entry_pk=t1.id limit 1) notify,
t1.company_id,
t1.location_id,
'' selected,
manifest_type,
t1.cargo_type  
 from 
mt_manifest_entry t1,
mt_manifest_entry_route t2 WHERE $aq and 
t2.mnf_entry_pk=t1.id AND length(IFNULL(t1.order_no,''))=0  order by t1.created_date desc limit 100
");
$statement->execute();
$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function setFourDigit($v)
{
  $len=strlen($v);

if($len==1)
{
  $v="000".$v;
}else if($len==2)
{
  $v="00".$v;
}else if($len==3)
{
  $v="0".$v;
}

return $v;
}

public static function save_robotic_charges($dev,$code)
{
$data=array();
try
{
$db = Factory::getConnection();

$c=$code[0];
$loc='';
$mop='';
$q="SELECT basis_type, coc_soc, charge, rate, currency FROM mt_rates_fixed_charges WHERE activity=:activity 
and ";

if($c->manifest_type=="AGENCY IMPORT" or $c->manifest_type=="SEA IMPORT")
{
  $q=$q." port_of_discharge=:loc ";
  $loc=$c->pod;
  $mop="COLLECT";
}else{
    $q=$q." port_of_load=:loc ";
    $loc=$c->pol;
    $mop="PREPAID";
}
$q=$q." and :bl_date between from_date and to_date ";
$statement = $db->prepare($q);
$statement->execute(array(
  ':loc'=>$loc,
  ':activity'=>$c->manifest_type,
  ':bl_date'=>$c->bl_date
));

$op=$statement->fetchAll(PDO::FETCH_ASSOC);

//var_dump($op);

//get order id from order_no
$statement = $db->prepare("SELECT id from mt_order_entry 
  where order_no=:order_no");
$statement->execute(array(':order_no'=>$c->order_no));

$temp=$statement->fetchAll(PDO::FETCH_ASSOC);
$order_id=$temp[0]["id"];


for($i=0;$i<count($op);$i++)
{
  $ch=$op[$i];
  $temp_code=uniqid($dev->uid);
$qty=0;
if($ch["basis_type"]!="BL")
{

$statement = $db->prepare("SELECT count(*) c FROM mt_manifest_entry_container WHERE mnf_entry_pk=:id 
  AND type=:basis_type");
  $statement->execute(array(
    ':id'=>$c->id,
    ':basis_type'=>$ch["basis_type"]
  ));
$nonbls=$statement->fetchAll(PDO::FETCH_ASSOC);
$qty=$nonbls[0]["c"];
 }else{
  $qty=1;
 }
 echo $qty."==".$ch["basis_type"]."==".$ch["rate"]; 
 $statement = $db->prepare("INSERT INTO mt_order_cost (order_id,route,type,charge_desc,pay_at_location,mode_of_pay,basis_type,basis_uom,commodity,qty,currency,ex_rate,rate_cost,rate_selling,cost_amount,selling_amount,cost_base_amount,selling_base_amount,remarks,billing_party,all_in,status,ip,created_by ,ua,ekey,created_date,temp_code)

VALUES(:order_id,'','INCOME',:charge,:loc,:mop,'','','',:qty,
:currency,'1',:rate,:rate,:rate,:rate,:rate,:rate,'','','','ACTIVE',
:ip ,:created_by ,
:ua ,:ekey,now(),:temp_code)");

  $statement->execute(array(
    ':ip'=>$dev->ip,':created_by'=>$dev->uid ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,

    ':order_id'=>$order_id,
    ':charge'=>$ch["charge"],
    ':loc'=>$loc,

    ':mop'=>$mop,
    ':currency'=>$ch["currency"],
    ':qty'=>$qty,
    ':rate'=>$ch["rate"]*$qty,

    ':temp_code'=>$temp_code
  ));
    if ($statement->rowCount()){
    $data["cost_status"]=1;
      //echo 'Success: At least 1 row was affected.';
  } else{
    $data["cost_status"]=0;
      //echo 'Failure: 0 rows were affected.';
  }

}

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function save_manifesttoorder($dev,$code)
{
$data=array();
try
{
$db = Factory::getConnection();
$c=$code->nd;
$ot=$code->ot;
for($i=0;$i<count($c);$i++)
{
  $nr=$c[$i];

  $temp_code=uniqid($dev->uid);
$base_currency=getCurrency($dev);
//insert order

  $statement = $db->prepare("INSERT into mt_order_entry(status,order_type,quote,copy_from,bl_no,customer,expected_date,order_executive,shipment_from,shipment_to,requested_office,enquiry_reference,vendor_service_base_currency,vendor_service_total_selling,vendor_service_total_cost,vendor_service_profit,created_by,created_date,ip,ua,ekey,temp_code,cargo_type,company_id,location_id,to_invoice) 
  values('OPEN',:order_type,'','',:bl_no,:customer,now(),:created_by,:shipment_from,:shipment_to,'','','$base_currency',null,null,null,:created_by,now(),:ip,:ua,:ekey,:temp_code,:cargo_type,:company_id,:location_id,'1')");

/*
if($c->vendor_service_total_selling=="")
{
$c->vendor_service_total_selling=null;
}

if($c->vendor_service_total_cost=="")
{
  $c->vendor_service_total_cost=null;
}

if($c->vendor_service_profit=="")
{
  $c->vendor_service_profit=null;
}
*/

  $statement->execute(array(':ip'=>$dev->ip,
  ':created_by'=>$dev->username,
  ':ua'=>$dev->ua,
  ':ekey'=>$dev->ekey,
  
  ':order_type'=>$nr->manifest_type,
  ':bl_no'=>$nr->bl_no,
  ':customer'=>$nr->consignee,
  ':shipment_from'=>$nr->pol,
  ':shipment_to'=>$nr->pod,
  ':cargo_type'=>$nr->cargo_type,
  ':temp_code'=>$temp_code,

  ':company_id'=>$dev->company,
  ':location_id'=>$dev->location
  ));

  if ($statement->rowCount()){
    $data["status"]=1;
      //echo 'Success: At least 1 row was affected.';
  } else{
    $data["status"]=0;
      //echo 'Failure: 0 rows were affected.';
  }

  //get new order no.
  $statement = $db->prepare("SELECT id from mt_order_entry where created_by=:uid and temp_code=:temp_code and bl_no=:bl_no LIMIT 1");
  $statement->execute(array(':temp_code'=>$temp_code,
    ':uid'=>$dev->username,':bl_no'=>$nr->bl_no));
  $op=$statement->fetchAll(PDO::FETCH_ASSOC);

  $fid=self::setFourDigit($op[0]["id"]);

  //order id type gen
  $ot='';
  $order_type=$nr->manifest_type;
if($order_type=="SEA IMPORT")
{
  $ot="SEA-I/";
}else if($order_type=="SEA EXPORT")
{
  $ot="SEA-E/";
} else if($order_type=="AGENCY EXPORT")
{
  $ot="AEG-E/";
}
else if($order_type=="AGENCY IMPORT")
{
  $ot="AEG-I/";
}
else if($order_type=="AIR IMPORT")
{
  $ot="AIR-I/";
}else if($order_type=="AIR EXPORT")
{
  $ot="AIR-E/";
}else if($order_type=="LCL IMPORT")
{
  $ot="LCL-I/";
}else if($order_type=="LCL EXPORT")
{
  $ot="LCL-E/";
}else if($order_type=="RORO IMPORT")
{
  $ot="RORO-I/";
}else if($order_type=="RORO EXPORT")
{
  $ot="RORO-E/";
}

  $on=$ot.date("Y")."/".date('m')."/".$nr->pod."/".$fid;

 $statement = $db->prepare("UPDATE mt_order_entry 
  SET order_no=:ond where id=:id");
  $statement->execute(array(':id'=>$op[0]["id"],':ond'=>$on));
  
    if ($statement->rowCount()){
    $data["oid_status"]=1;
      //echo 'Success: At least 1 row was affected.';
  } else{
    $data["oid_status"]=0;
      //echo 'Failure: 0 rows were affected.';
  }

   $statement = $db->prepare("UPDATE mt_manifest_entry 
  SET order_no=:ond where id=:id");
  $statement->execute(array(':id'=>$nr->id,':ond'=>$on));
  
    if ($statement->rowCount()){
    $data["moid_status"]=1;
      //echo 'Success: At least 1 row was affected.';
  } else{
    $data["moid_status"]=0;
      //echo 'Failure: 0 rows were affected.';
  }

  //insert order cost
  $statement = $db->prepare("INSERT INTO mt_order_cost (order_id,route,type,type1,charge_desc,pay_at_location,mode_of_pay,basis_type,basis_uom,commodity,calc_method,qty,currency,ex_rate,
    rate_selling,selling_amount,selling_base_amount,
    rate_cost,cost_amount,cost_base_amount,
    remarks,billing_party,all_in,status) 
  SELECT ".$op[0]["id"].",'1', type,type, charge_desc, pay_at_location, payment_mode, basis_type, basis_uom, commodity, '', qty, currency, ex_rate,

case when type='INCOME' then rate ELSE '' end rate_selling,
case when type='INCOME' then cost ELSE '' end selling_amount,
case when type='INCOME' then cost_base_amount ELSE '' end selling_base_amount,
case when type='COST' then rate ELSE '' end rate_cost,
case when type='COST' then cost ELSE '' end cost_amount,
case when type='COST' then cost_base_amount ELSE '' end cost_base_amount,

   remarks, '".$nr->consignee."', '', status
  FROM mt_manifest_entry_rate
  where mnf_entry_pk=:id");
  
  //$statement->execute(array(':order_id'=>$data["id"]->id,':bl_no'=>$nr->bl_no));
  $statement->execute(array(':id'=>$nr->id));
    if ($statement->rowCount()){
    $data["cost_status"]=1;
      //echo 'Success: At least 1 row was affected.';
  } else{
    $data["cost_status"]=0;
      //echo 'Failure: 0 rows were affected.';
  }

//2

$statement = $db->prepare("INSERT INTO mt_order_parties(order_id,party_type,party_name,address,tel,email,poc) 
  SELECT ".$op[0]["id"].",party_type,party_name,address,telephone,email,poc FROM  mt_manifest_entry_party where mnf_entry_pk=:id");
  $statement->execute(array(':id'=>$nr->id));

  if ($statement->rowCount()){
    $data["parties_status"]=1;
  } else{
    $data["parties_status"]=0;

  }

//3
  $statement = $db->prepare("INSERT INTO mt_order_landingcraft_detail(
     order_id, cargo_type, vehicle_type, vin_no, chassis_no, package_type, no_of_pkgs, volume, gr_wgt, nt_wgt, tt_wgt, commodity, cargo_desc, reefer, min_temp, max_temp, oog, oh, ow, ol, haz, un_no, flash_type) 
  SELECT ".$op[0]["id"].", cargo_type, vehicle_type, vin_no, chassis_no, package_type, no_of_pkgs, volume, gr_wgt, nt_wgt, tt_wgt, commodity, cargo_desc, reefer, min_temp, max_temp, oog, oh, ow, ol, haz, un_no, flash_type FROM mt_manifest_entry_landingcraft  where mnf_entry_pk=:id");
  $statement->execute(array(':id'=>$nr->id));

  if ($statement->rowCount()){
    $data["lc_status"]=1;
      //echo 'Success: At least 1 row was affected.';
  } else{
    $data["lc_status"]=0;
      //echo 'Failure: 0 rows were affected.';
  }

//4
  $statement = $db->prepare("INSERT INTO mt_order_container_detail(
     order_id, container_no,type,package_type,no_of_pkgs,volume,gr_wgt,nt_wgt,tt_wgt,commodity,cargo_desc,reefer,min_temp,max_temp,oog,oh,ow,ol,haz,un_no,flash_type) 
  SELECT ".$op[0]["id"].", container_no, type, package_type, no_of_pkgs, volume, gr_wgt, nt_wgt, tt_wgt, commodity, cargo_desc, reefer, min_temp, max_temp, oog, oh, ow, ol, haz, un_no, flash_type FROM mt_manifest_entry_container  where mnf_entry_pk=:id");
  $statement->execute(array(':id'=>$nr->id));

  if ($statement->rowCount()){
    $data["container_status"]=1;
  } else{
    $data["container_status"]=0;
  }

//5
  $statement = $db->prepare("INSERT INTO mt_order_route(
     order_id, routing_transport_leg,provider,efrom,eto,vessel,voyage,via,fpod,eta,etd) 
  SELECT ".$op[0]["id"].", 
'1',
'',
pol,
pod,
vessel,
voyage,
'',
pof,
eta,
etd FROM mt_manifest_entry_route  where mnf_entry_pk=:id");
   $statement->execute(array(':id'=>$nr->id));

  if ($statement->rowCount()){
    $data["container_status"]=1;
  } else{
    $data["container_status"]=0;
  }

//6
  $statement = $db->prepare("INSERT INTO mt_order_cargo(
     order_id,
main_commodity,
package_type,
no_of_packages,
gross_weight,
weight_uom,
volume,
volume_uom,
dangerous,
reefer,
oversize) 
  SELECT ".$op[0]["id"].", 
main_commodity,
package_type,
no_of_packages,
gross_weight,
weight_uom,
volume,
volume_uom,
dangerous,
reefer,
oversize 
 FROM mt_manifest_entry_cargo  where mnf_entry_pk=:id");
   $statement->execute(array(':id'=>$nr->id));

  if ($statement->rowCount()){
    $data["cargo_status_".($i+1)]=1;
  } else{
    $data["cargo_status_".($i+1)]=0;
  }


}
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function create_order_from_igm($dev2,$code)
{
$data=array();
try
{
$db = Factory::getConnection();


  //CHECK IF ALL IGM DETAIL DATA INPUTTED
  $igm_percent=20;
  $igm_percent_msg="";
  $igm_percent_msg1="";

  //IGM ROUTE
  $statement = $db->prepare("SELECT voyage from mt_manifest_entry_route 
  where mnf_entry_pk=(select id from mt_manifest_entry where id=:id) ");
  $statement->execute(array(':id'=>$code->nd[0]->id));
  $irlist=$statement->fetchAll(PDO::FETCH_ASSOC);    
  if(count($irlist)>=1)
  {  
    $igm_percent=$igm_percent+20;
  }else{
    $igm_percent_msg="Route";
  }

  //IGM CARGO
  $statement = $db->prepare("SELECT main_commodity from mt_manifest_entry_cargo  
  where mnf_entry_pk=(select id from mt_manifest_entry where id=:id) ");
  $statement->execute(array(':id'=>$code->nd[0]->id));
  $iclist=$statement->fetchAll(PDO::FETCH_ASSOC);    
  if(count($iclist)>=1)
  {  
    $igm_percent=$igm_percent+20;
  }else{
    if(strlen($igm_percent_msg)>0){
      $igm_percent_msg=$igm_percent_msg." / Cargo";
    }else{
      $igm_percent_msg=$igm_percent_msg."Cargo";
    }
  }
  //IGM CONTAINER
  $statement = $db->prepare("SELECT t1.container_no  from mt_manifest_entry_container t1 
  where mnf_entry_pk=(select id from mt_manifest_entry where id=:id) ");
  $statement->execute(array(':id'=>$code->nd[0]->id));
  $icolist=$statement->fetchAll(PDO::FETCH_ASSOC);   
  if(count($icolist)>=1)
  {  
    $igm_percent=$igm_percent+20;
  }else{
    if(strlen($igm_percent_msg)>0){
      $igm_percent_msg=$igm_percent_msg." / Container";
    }else{
      $igm_percent_msg=$igm_percent_msg."Container";
    }
  }
  //IGM PARTY
  $statement = $db->prepare("SELECT party_type from mt_manifest_entry_party   
  where mnf_entry_pk=(select id from mt_manifest_entry where id=:id) 
  group by party_type ");
  $statement->execute(array(':id'=>$code->nd[0]->id));
  $iptlist=$statement->fetchAll(PDO::FETCH_ASSOC);    
  if(count($iptlist)>=4)
  {  
    $igm_percent=$igm_percent+20;
  }else{
    if(strlen($igm_percent_msg)>0){
      $igm_percent_msg=$igm_percent_msg." / Parties";
    }else{
      $igm_percent_msg=$igm_percent_msg."Parties";
    }
  }

  if($igm_percent!=100)
  {  
    $data["status"]=3;
    $data["msg"]="Please input ".$igm_percent_msg." detail.";
  }else
  {

    $statement = $db->prepare("SELECT id,
    mnf_entry_pk,
    voyage,
    vessel,
    pol,
    pod 
      from mt_manifest_entry_route where mnf_entry_pk=(select id from mt_manifest_entry where id=:id) ");
    $statement->execute(array(':id'=>$code->nd[0]->id));
    $dataBL=$statement->fetchAll(PDO::FETCH_ASSOC);

    //ASSIGN IGM VALUES
    $code->nd[0]->consignee=$code->nd[0]->customer;
    $code->nd[0]->vessel=$dataBL[0]["vessel"];
    $code->nd[0]->pol=$dataBL[0]["pol"];
    $code->nd[0]->pod=$dataBL[0]["pod"];

    $data=self::save_manifesttoorder($dev2,$code);

  }

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

}
?>