<?php


require("../config/dbconn.php");
require('../settings/get-settings.php');

class FinanceBulkDao

{


public static function save_page_views($dev,$pname,$method)
{
$data=0;
try
{
$db = Factory::getConnection();


$statement = $db->prepare("INSERT into page_views(
ip ,uid ,ua,ekey,esecret,method,page,tz) 
values(:ip ,:uid ,
:ua ,:ekey ,:esecret ,:method ,:page,:tz)");
$statement->execute(array(':ip'=>$dev->ip,':uid'=>$dev->uid ,
':ua'=>$dev->ua,
':tz'=>$dev->tz ,
':method'=>$method ,':esecret'=>$dev->esecret,':ekey'=>$dev->ekey,
':page'=>$pname));


$data=1;
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function get_bulk_ar_trans_list($v)
{
$data=false;
try
{
$db = Factory::getConnection();
//$aq=self::getRestrictionQuery($dev);
$statement = $db->prepare("  SELECT  id, art_type ardm_doc_type, art_number ardm_doc_number, art_gl_date ardm_date, round(art_local_amount) ardm_ol_amount,'' matched_amt,
round(art_local_balance,2) ardm_bl_amount,
round(art_local_balance,2) ardm_bl_amount1,

case when art_type='TDS RECEIVABLE' then
(select rh_narration from mt_receipt_header where rh_doc_number=art_number)
else
  ' '
END as other_reference,'' selected

from mt_ar_trans_copy1

where art_balance_status!='CANCELLED' 
and art_code=:code 
and art_type in 
(SELECT to_doc_type from mt_match_setup 
  where from_doc_type=:fdc 
  and status='ACTIVE') 
and art_local_balance!=0 
order by id desc 
");
$statement->execute(array(
  ':code'=>$v->art_code,
  ':fdc'=>$v->receipt_mode));
$data=$statement->fetchAll(PDO::FETCH_ASSOC);
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  return $data;
}


public static function save_bulk_ar_match($dev,$code)
{
$data=array();
try
{
$db = Factory::getConnection();
$db->beginTransaction();

$c=$code->info;
$cds=$code->dt;
$lb=0;
$lb2=0;
$match_status_count=0;
$ar_status_count=0;


//CREATE RECEIPT VOUCHER
save_voucher_preparation_bank_receipt_bulk($dev,$c,$data);
$c->art_number=$data["doc_no"];

for($i=0;$i<count($cds);$i++)
{
  $cd=$cds[$i];
  $lb=$lb+(float)$cd->ardm_bl_amount;
  $lb2=$lb2+(float)$cd->matched_amt;

  $statement = $db->prepare("INSERT INTO mt_ar_match_details(
ARM_M_AR,
ARM_M_TYPE,
ARM_M_NUMBER,
ARM_M_AMOUNT,
ARM_T_TYPE,
ARM_T_NUMBER,
ARM_T_DATE,
ARM_T_AMOUNT,
ARM_T_BALANCE,
ARM_MATCH_REFERENCE,ip,ua,ekey,created_by,created_date,arm_status,arm_t_id)
VALUES(:ARM_M_AR,:ARM_M_TYPE,:ARM_M_NUMBER,:ARM_M_AMOUNT,:ARM_T_TYPE,:ARM_T_NUMBER,:ARM_T_DATE,:ARM_T_AMOUNT,:ARM_T_BALANCE,:ARM_MATCH_REFERENCE,:ip,:ua,:ekey,:created_by,now(),:status,:arm_t_id)");
$ps='PENDING';
if($cd->ardm_bl_amount==0)
{
  $ps='COMPLETED';
}
$statement->execute(array(':ip'=>$dev->ip,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,
':created_by'=>$dev->username,
':ARM_M_AR'=>$c->art_code,
':ARM_M_TYPE'=>$c->art_base_type,
':ARM_M_NUMBER'=>$c->art_number,
':ARM_M_AMOUNT'=>$c->art_local_balance,
':ARM_T_TYPE'=>$cd->ardm_doc_type,
':ARM_T_NUMBER'=>$cd->ardm_doc_number,
':ARM_T_DATE'=>$cd->ardm_date,
':ARM_T_AMOUNT'=>$cd->matched_amt,
':ARM_T_BALANCE'=>$cd->ardm_bl_amount,
':ARM_MATCH_REFERENCE'=>$cd->other_reference,
':status'=>$ps,
':arm_t_id'=>$cd->id
));

if ($statement->rowCount()){
  $match_status_count+=1;
  $data["match_status".($i+1)]=1;
} else{
  $data["match_status".($i+1)]=0;
}

$data["bl"]=$cd->ardm_bl_amount;


//update ind trans
$ibs='A';
if($cd->ardm_bl_amount==0)
{
  $ibs='C'; //completed
}
$statement = $db->prepare("UPDATE mt_ar_trans 
  set modified_date=now(),art_local_balance=:amt, art_balance_status=:ibs where art_number=:no and art_code=:art_code and art_type=:art_type and id=:id");
$statement->execute(array(':no'=>$cd->ardm_doc_number,
  ':ibs'=>$ibs,
  ':amt'=>$cd->ardm_bl_amount,
  ':art_code'=>$c->art_code,
  ':art_type'=>$cd->ardm_doc_type,
  ':id'=>$cd->id
));


if ($statement->rowCount()){
  $ar_status_count+=1;
  $data["trans_status".($i+1)]=1;
} else{
  $data["trans_status".($i+1)]=0;
}

}
//end of for loop
//update main trans
//$aq=self::getRestrictionQuery($dev);
$bs='A';
if($lb==0)
{
  $bs='C'; //completed
}
$bs2='A';
$temp=(float)abs($c->art_local_balance)-$lb2;
$data["lb2"]=$lb2;
$data["temp"]=$temp;

if($temp==0)
{
  $bs='C'; //completed
}

$statement = $db->prepare("UPDATE mt_ar_trans 
  set art_local_balance=:lb, art_balance_status=:bs,
  modified_by=:modified_by,modified_date=now()
    where art_number=:no and art_code=:art_code and 
    abs(art_local_amount)=:lamt and art_type=:art_type");
$statement->execute(array(
  ':no'=>$c->art_number,
  ':lb'=>-0,
  ':bs'=>'C',
  ':modified_by'=>$dev->username,
':art_code'=>$c->art_code,
':lamt'=>abs($c->art_local_balance),
':art_type'=>$c->art_base_type ));

if ($statement->rowCount()){
  $data["status"]=1;
} else{
  $data["status"]=0;
}


$data["status"]=0;

$cr_count=count($cds);
$child_status=$ar_status_count==$cr_count &&  $match_status_count==$cr_count;

if($data["status"]==1 && $child_status)
{
  $db->commit();
}else{
    $db->rollBack();
    $data["status"]=0;
    $data["msg"]="Unable to save. Please try again";
}
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
    $db->rollBack();
    $data["status"]=0;
    $data["msg"]="Unable to save. Please try again";
  }
  return $data;
}


//bank receipt voucher bulk
public static function save_voucher_preparation_bank_receipt_bulk($dev,$c,$data)
{
//$data=array();
try
{

//CHEQUE SAVING STARTS //If CHEQUE, NO POSTING TO FIN TABLES
if($c->info->doc_type=="CHEQUE")
{

$db = Factory::getConnection();
$db->beginTransaction();

$info=$c->info;
$vpds=$c->vpd;
$h=$vpds[0];

$customer_code=$h->add_info->bank_name;
$bank=$h->add_info;

$temp_code=uniqid($dev->uid);

//query 1
$statement = $db->prepare("INSERT into mt_receipt_header ( rh_company, rh_base_doc_type, rh_doc_type, rh_doc_date, rh_gl_date, rh_cash_bank_code, rh_currency, rh_exchange_rate, rh_foreign_amount, rh_local_amount, rh_other_reference, rh_cheque_number, rh_cheque_date, rh_narration, rh_notes, rh_status, rh_gl_account,
  ip,ua,ekey,created_by,created_date,temp_code,child,company_id,location_id ) VALUES (:company,:voucher_type,:doc_type,:doc_date,:doc_date,
  :bank_name,:currency,:ex_rate,:base_amt_dr,:local_amt_dr,:ref,
  :cheque_no,:cheque_date,:narration,'','AWAITING CONFIRMATION',(SELECT account_no from mt_bank_list where bank_code=:bank_name limit 1),
:ip,:ua,:ekey,:created_by,now(),:temp_code,:child,:company_id,:location_id)");

if($bank->cheque_date=="" or $bank->cheque_date=='NaN-NaN-NaN')
{
  $bank->cheque_date=null;
}
$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->username,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,

':company'=>$dev->company,
':voucher_type'=>$h->voucher_type,
':doc_type'=>$info->doc_type,
':doc_date'=>$info->doc_date,

':bank_name'=>$bank->bank_name,
':cheque_no'=>$bank->cheque_no,
':cheque_date'=>$bank->cheque_date,

':ref'=>$h->ref,
':currency'=>$h->currency,
':ex_rate'=>$h->ex_rate,
':base_amt_dr'=>$h->base_amt_dr,
':local_amt_dr'=>$h->local_amt_dr,
':narration'=>$h->narration,

':temp_code'=>$temp_code,
':company_id'=>$dev->company,
':location_id'=>$dev->location,

':child'=>json_encode($vpds)
));

if ($statement->rowCount()){
  $data["status"]=1;
  $data["msg"]="Saved";

} else{
  $data["status"]=0;
  $data["msg"]="Unable to save. Please try again";

}
$data["temp_code"]=$temp_code;
$statement = $db->prepare("SELECT id from mt_receipt_header where created_by=:uid and temp_code=:temp_code");
$statement->execute(array(':temp_code'=>$temp_code,
  ':uid'=>$dev->username));
$op=$statement->fetchAll(PDO::FETCH_ASSOC);

$data["id"]=$op;

//set doc number

$fid=self::setFourDigit($op[0]["id"]);
$fid1=$op[0]["id"];

$vtype="PV";
$prefix="";
if($info->doc_type=="CASH")
{
$prefix="RCH";
}else if($info->doc_type=="CHEQUE")
{
$prefix="RBC";
}else if($info->doc_type=="ONLINE TRANSFER")
{
$prefix="ROT";
}else if($info->doc_type=="CARD")
{
$prefix="RCT";
}

$fid=self::generate_voucher_no1($db,$dev,$prefix,$temp_code);
$fid=self::setFourDigit($fid);
$fid1=$fid;

$on=$prefix."/".date("Y")."/".date('m')."/".$fid;

 $statement = $db->prepare("UPDATE mt_receipt_header 
  SET rh_doc_number=:ond where id=:id");
  $statement->execute(array(':id'=>$op[0]["id"],':ond'=>$on));
  
    if ($statement->rowCount()){
    $data["pay_id_status"]=1;
  } else{
    $data["pay_id_status"]=0;
  }

$data["doc_no"]=$on;

$doc_no=$on;

//query 1 ends

//exclude header in child table
//query 2
$child_rd_status_count=0;

for($i=1;$i<count($vpds);$i++)
{

$r=$vpds[$i];
$temp_code=uniqid($dev->uid);
$q="";
$qv="";

$gls=self::get_gl_link($dev,'RECEIVABLE');
//$gl_code=$gls[0]["gl_account"];
$gl_code='';
if(count($gls)>=1)
{
$gl_code=$gls[0]["gl_account"];
}


if($r->allocation=="BANK")
{
  $ai=$r->add_info;
  $q="aloc_detail_1,aloc_detail_2,aloc_detail_3";
  $qv="'$ai->bank_name','$ai->cheque_no','$ai->cheque_date'";
}


if($r->base_amt_cr=="")
{
  $r->base_amt_cr=null;
}
if($r->local_amt_cr=="")
{
  $r->local_amt_cr=null;
}

if($r->ex_rate=="")
{
  $r->ex_rate=null;
}



$statement = $db->prepare("INSERT into mt_receipt_allocation_details 
(aloc_company,aloc_base_doc,aloc_doc_type,aloc_doc_number,aloc_allocation_type,aloc_foreign_amount,aloc_local_amount,aloc_narration,
  aloc_notes,aloc_detail_5,aloc_account,aloc_currency,aloc_ex_rate,$q,
ip,created_by ,ua,ekey,created_date,temp_code,location_id,company_id)
VALUES
(:company,:voucher_type,:doc_type,:doc_no,:allocation,
  :base_amt_cr,:local_amt_cr,
  :narration,'',:ref,'$gl_code',:currency,:ex_rate,$qv,
  :ip,:created_by,:ua ,:ekey,now(),:temp_code,:location_id,:company_id)");

$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->username ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,
':temp_code'=>$temp_code,

':company'=>$dev->company,
':voucher_type'=>$r->voucher_type,
':doc_type'=>$info->doc_type,
':doc_no'=>$doc_no,

':allocation'=>$r->allocation,
':base_amt_cr'=>$r->base_amt_cr*(-1),
':local_amt_cr'=>$r->local_amt_cr*(-1),
':narration'=>$r->narration,
':currency'=>$r->currency,
':ex_rate'=>$r->ex_rate,

':ref'=>$r->ref,
':location_id'=>$dev->location,
':company_id'=>$dev->company
//':ref_date'=>$r->ref_date

));

if ($statement->rowCount()){
  $child_rd_status_count+=1;
  $data["ahd_status-".($i+1)]=1;
} else{
  $data["ahd_status-".($i+1)]=0;
}

}

$child_status=$child_rd_status_count==(count($vpds)-1);
//$data["status"]=0;
if($data["status"]==1 && $data["pay_id_status"]==1 && $child_status)
{
  $db->commit();

}else{
  $db->rollBack();
  $data["status"]=0;
  $data["msg"]="Unable to save. Please try again";
}

$statement=null;
//query 2 ends
// CHEQUE SAVING ENDS
}
else
{
//FINANCE POSTING STARTS FOR OTHER RECEIPTS
$db = Factory::getConnection();
$db->beginTransaction();

$info=$c->info;
$vpds=$c->vpd;
$h=$vpds[0];

$customer_code=$h->add_info->bank_name;
$bank=$h->add_info;

$temp_code=uniqid($dev->uid);

//query 1
$statement = $db->prepare("INSERT into mt_receipt_header ( rh_company, rh_base_doc_type, rh_doc_type, rh_doc_date, rh_gl_date, rh_cash_bank_code, rh_currency, rh_exchange_rate, rh_foreign_amount, rh_local_amount, rh_other_reference, rh_cheque_number, rh_cheque_date, rh_narration, rh_notes, rh_status, rh_gl_account,
  ip,ua,ekey,created_by,created_date,temp_code,child,company_id,location_id ) VALUES (:company,:voucher_type,:doc_type,:doc_date,:doc_date,
  :bank_name,:currency,:ex_rate,:base_amt_dr,:local_amt_dr,:ref,
  :cheque_no,:cheque_date,:narration,'','POSTED',(SELECT account_no from mt_bank_list where bank_code=:bank_name limit 1),
:ip,:ua,:ekey,:created_by,now(),:temp_code,:child,:company_id,:location_id)");

if($bank->cheque_date=="" or $bank->cheque_date=='NaN-NaN-NaN')
{
  $bank->cheque_date=null;
}
$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->username,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,

':company'=>$dev->company,
':voucher_type'=>$h->voucher_type,
':doc_type'=>$info->doc_type,
':doc_date'=>$info->doc_date,

':bank_name'=>$bank->bank_name,
':cheque_no'=>$bank->cheque_no,
':cheque_date'=>$bank->cheque_date,

':ref'=>$h->ref,
':currency'=>$h->currency,
':ex_rate'=>$h->ex_rate,
':base_amt_dr'=>$h->base_amt_dr,
':local_amt_dr'=>$h->local_amt_dr,
':narration'=>$h->narration,

':temp_code'=>$temp_code,
':company_id'=>$dev->company,
':location_id'=>$dev->location,

':child'=>json_encode($vpds)
));

if ($statement->rowCount()){
  $data["status"]=1;
  $data["msg"]="Saved";
} else{
  $data["status"]=0;
  $data["msg"]="Unable to save. Please try again";
}
$data["temp_code"]=$temp_code;
$statement = $db->prepare("SELECT id from mt_receipt_header where created_by=:uid and temp_code=:temp_code");
$statement->execute(array(':temp_code'=>$temp_code,
  ':uid'=>$dev->username));
$op=$statement->fetchAll(PDO::FETCH_ASSOC);

$data["id"]=$op;

//set doc number

$fid=self::setFourDigit($op[0]["id"]);
$fid_n1=$op[0]["id"];

$vtype="PV";
$prefix="";
if($info->doc_type=="CASH")
{
$prefix="RCH";
}else if($info->doc_type=="CHEQUE")
{
$prefix="RBC";
}else if($info->doc_type=="ONLINE TRANSFER")
{
$prefix="ROT";
}else if($info->doc_type=="CARD")
{
$prefix="RCT";
}

$fid=self::generate_voucher_no1($db,$dev,$prefix,$temp_code);
$fid=self::setFourDigit($fid);
$fid1=$fid;

$on=$prefix."/".date("Y")."/".date('m')."/".$fid;

 $statement = $db->prepare("UPDATE mt_receipt_header 
  SET rh_doc_number=:ond where id=:id");
  $statement->execute(array(':id'=>$op[0]["id"],':ond'=>$on));
  
    if ($statement->rowCount()){
    $data["pay_id_status"]=1;
  } else{
    $data["pay_id_status"]=0;
  }

$data["doc_no"]=$on;

$doc_no=$on;

//query 1 ends

//exclude header in child table
//query 2
$child_rd_status_count=0;
$child_cc_count=0;
$child_cc_status_count=0;
$child_bank_count=0;

for($i=1;$i<count($vpds);$i++)
{

$r=$vpds[$i];
$temp_code=uniqid($dev->uid);
$q="";
$qv="";

$gls=self::get_gl_link($dev,'RECEIVABLE');
//$gl_code=$gls[0]["gl_account"];
$gl_code='';
if(count($gls)>=1)
{
$gl_code=$gls[0]["gl_account"];
}

if($r->allocation=="BANK")
{
  $child_bank_count+=1;
  $ai=$r->add_info;
  $q="aloc_detail_1,aloc_detail_2,aloc_detail_3";
  $qv="'$ai->bank_name','$ai->cheque_no','$ai->cheque_date'";
}


if($r->base_amt_cr=="")
{
  $r->base_amt_cr=null;
}
if($r->local_amt_cr=="")
{
  $r->local_amt_cr=null;
}

if($r->ex_rate=="")
{
  $r->ex_rate=null;
}



$statement = $db->prepare("INSERT into mt_receipt_allocation_details 
(aloc_company,aloc_base_doc,aloc_doc_type,aloc_doc_number,aloc_allocation_type,aloc_foreign_amount,aloc_local_amount,aloc_narration,
  aloc_notes,aloc_detail_5,aloc_account,aloc_currency,aloc_ex_rate,$q,
ip,created_by ,ua,ekey,created_date,temp_code,location_id,company_id)
VALUES
(:company,:voucher_type,:doc_type,:doc_no,:allocation,
  :base_amt_cr,:local_amt_cr,
  :narration,'',:ref,'$gl_code',:currency,:ex_rate,$qv,
  :ip,:created_by,:ua ,:ekey,now(),:temp_code,:location_id,:company_id)");

$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->username ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,
':temp_code'=>$temp_code,

':company'=>$dev->company,
':voucher_type'=>$r->voucher_type,
':doc_type'=>$info->doc_type,
':doc_no'=>$doc_no,

':allocation'=>$r->allocation,
':base_amt_cr'=>$r->base_amt_cr*(-1),
':local_amt_cr'=>$r->local_amt_cr*(-1),
':narration'=>$r->narration,
':currency'=>$r->currency,
':ex_rate'=>$r->ex_rate,

':ref'=>$r->ref,
':location_id'=>$dev->location,
':company_id'=>$dev->company
//':ref_date'=>$r->ref_date

));

if ($statement->rowCount()){
  $child_rd_status_count+=1;
  $data["ahd_status-".($i+1)]=1;
} else{
  $data["ahd_status-".($i+1)]=0;
}

//query - cost center
if($r->cost_center!="")
{
  $child_cc_count+=1;
  $statement = $db->prepare("INSERT INTO mt_cost_center
  (cost_gl_code, cost_glt_company, cost_glt_doc_base, cost_glt_doc_type, cost_glt_number, cost_glt_doc_date, cost_glt_gl_date, cost_glt_other_reference,  cost_glt_currency,  cost_glt_ex_rate,  
    cost_glt_foreign_amount, cost_glt_local_amount, cost_glt_narration,  cost_glt_aloc_type, 
  ip,  ua,  ekey,  created_by,  created_date)
  VALUES
  (:cost_gl_code, :company, :voucher_type, :doc_type, :doc_no, :doc_date, :gl_date,
    :ref, :currency, :ex_rate, 
    :base_amt_cr, :local_amt_cr,  :narration, :allocation,
    :ip, :ua, :ekey, :created_by, now()) ");

  $statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->username ,
  ':ua'=>$dev->ua,
  ':ekey'=>$dev->ekey,

  ':cost_gl_code'=>$r->cost_center,
  ':company'=>$dev->company,
  ':voucher_type'=>$r->voucher_type,
  ':doc_type'=>$info->doc_type,
  ':doc_no'=>$doc_no,
  ':doc_date'=>$info->doc_date,
  ':gl_date'=>$info->doc_date,

  ':ref'=>$r->ref,
  ':currency'=>$r->currency,
  ':ex_rate'=>$r->ex_rate,
  ':base_amt_cr'=>$r->base_amt_cr*(-1),
  ':local_amt_cr'=>$r->local_amt_cr*(-1),
  ':narration'=>$r->narration,
  ':allocation'=>$r->allocation

  ));

  if ($statement->rowCount()){
    $child_cc_status_count+=1;
    $data["cc_status"]=1;
  } else{
    $data["cc_status"]=0;
  }
}
//query - cost center ends

}
//query 2 ends


//query 3
$statement = $db->prepare("INSERT into mt_ar_trans 
(art_company,art_code,art_type,art_number,art_serial,art_group,
art_base_type,art_internal,art_other_reference,art_doc_date,
art_gl_date,art_year,art_period,art_age_date,
art_dp_date,art_currency,art_ex_rate,art_foreign_amount,
art_local_amount,art_foreign_balance,
art_local_balance,art_balance_status,
art_description,art_notes,
ip,created_by ,ua,ekey,created_date,temp_code,company_id,location_id)
SELECT aloc_company,aloc_detail_2,aloc_doc_type,aloc_doc_number,
1,aloc_detail_1,aloc_base_doc,0,
aloc_detail_5,
'$info->doc_date','$info->doc_date',".self::getFinancialYear().",".self::getFinancialPeriod($info->doc_date).",
'$info->doc_date','$info->doc_date',aloc_currency,aloc_ex_rate,
aloc_foreign_amount,aloc_local_amount,aloc_foreign_amount,
aloc_local_amount,'A',
aloc_narration,aloc_detail_3,
ip,created_by,ua ,ekey,now(),'$temp_code',
'$dev->company','$dev->location'   
FROM mt_receipt_allocation_details where aloc_doc_number=:id");

$statement->execute(array(':id'=>$doc_no
));

if ($statement->rowCount()){
  $data["ar_trans_status"]=1;
} else{
  $data["ar_trans_status"]=0;
}
//query 3 ends


//query 4 part1 header
$gls=self::get_gl_link($dev,'RECEIVABLE');
//$pcode=$gls[0]["gl_account"];
  $pcode='';
  if(count($gls)>=1)
  {
    $pcode=$gls[0]["gl_account"];
  }
$statement = $db->prepare("INSERT into mt_receipt_gl_details
(pre_glt_company,pre_glt_code,pre_glt_doc_base,pre_glt_doc_type,
  pre_glt_doc_number,pre_glt_serial,pre_glt_doc_date,
  pre_glt_gl_date,pre_glt_year,pre_glt_period,
  pre_glt_other_reference,pre_glt_currency,
  pre_glt_ex_rate,pre_glt_foreign_amount,
  pre_glt_local_amount,pre_glt_narration,
ip,created_by ,ua,ekey,created_date,temp_code)
SELECT rh_company,
'$pcode',
rh_base_doc_type,rh_doc_type,
rh_doc_number,rh_internal_number,rh_doc_date,
rh_gl_date,".self::getFinancialYear().",".
self::getFinancialPeriod($info->doc_date).",rh_other_reference,rh_currency,
rh_exchange_rate,rh_foreign_amount,
rh_local_amount,rh_narration,
ip,created_by,ua ,ekey,now(),'$temp_code'  
FROM mt_receipt_header where rh_doc_number=:rh_doc_number");

$statement->execute(array(':rh_doc_number'=>$doc_no));

if ($statement->rowCount()){
  $data["ah_gl_status"]=1;
} else{
  $data["ah_gl_status"]=0;
}
//query 4 ends


//query 4 part2 child
$statement = $db->prepare("INSERT into mt_receipt_gl_details
(pre_glt_company,pre_glt_code,pre_glt_doc_base,pre_glt_doc_type,
  pre_glt_doc_number,pre_glt_serial,pre_glt_doc_date,
  pre_glt_gl_date,pre_glt_year,pre_glt_period,
  pre_glt_other_reference,pre_glt_currency,
  pre_glt_ex_rate,pre_glt_foreign_amount,
  pre_glt_local_amount,pre_glt_narration,
  pre_glt_allocation_code,pre_glt_detail_1,
  pre_glt_detail_2,pre_glt_detail_3,
ip,created_by ,ua,ekey,created_date,temp_code)
SELECT aloc_company,'$pcode',
aloc_base_doc,aloc_doc_type,
aloc_doc_number,aloc_serial,'$info->doc_date',
'$info->doc_date',".self::getFinancialYear().",".
self::getFinancialPeriod($info->doc_date).",aloc_narration,aloc_currency,
aloc_ex_rate,aloc_foreign_amount,
aloc_local_amount,aloc_narration,
aloc_allocation_type,aloc_detail_1,
aloc_detail_2,aloc_detail_3,
ip,created_by,ua ,ekey,now(),'$temp_code'  
FROM mt_receipt_allocation_details where aloc_doc_number=:aloc_doc_number");

$statement->execute(array(':aloc_doc_number'=>$doc_no));

if ($statement->rowCount()){
  $data["ah_gl_status2"]=1;
} else{
  $data["ah_gl_status2"]=0;
}
//query 4 part2 ends


//query 6
$statement = $db->prepare("INSERT into mt_cash_book_details 
( cb_company,cb_doc_type,cb_doc_number,cb_internal_number,cb_base_doc_type,cb_code,cb_type,cb_gl_date,cb_doc_date,cb_due_pay_date,cb_year,cb_period,cb_currency,cb_ex_rate,cb_foreign_amount,cb_local_amount,cb_cheque_number,cb_cheque_date,cb_account,cb_status,
  ip,created_by ,ua,ekey,
  created_date,temp_code) 
SELECT rh_company,rh_doc_type,rh_doc_number,rh_internal_number,
rh_base_doc_type,rh_cash_bank_code,rh_type,
rh_gl_date,rh_doc_date,rh_doc_date,".self::getFinancialYear().",".
self::getFinancialPeriod($info->doc_date).",rh_currency,rh_exchange_rate,
rh_foreign_amount,rh_local_amount,
rh_cheque_number,rh_cheque_date,rh_gl_account,'POSTED',
'$dev->ip','$dev->username' ,'$dev->ua','$dev->ekey',
now(),'$temp_code'
 from mt_receipt_header where rh_doc_number=:doc_no");

$statement->execute(array(':doc_no'=>$doc_no));

if ($statement->rowCount()){
  $data["cb_status"]=1;
} else{
  $data["cb_status"]=0;
}
//query 6 ends

//add in the cash book details for reporting
$doc_date=$info->doc_date;
$statement = $db->prepare("INSERT into mt_cash_book_details 
( cb_company,cb_doc_type,cb_doc_number,cb_internal_number,cb_base_doc_type,
  cb_code,cb_type,cb_gl_date,cb_doc_date,cb_due_pay_date,cb_year,cb_period,cb_currency,
  cb_ex_rate,cb_foreign_amount,cb_local_amount,cb_account,cb_cheque_number,cb_cheque_date,
  cb_status,
  ip,created_by ,ua,ekey,
  created_date,temp_code) 
SELECT aloc_company,aloc_doc_type,
aloc_doc_number,aloc_serial,aloc_base_doc,aloc_detail_1,aloc_allocation_type,
'$doc_date','$doc_date','$doc_date',".self::getFinancialYear().",".
self::getFinancialPeriod($doc_date).",aloc_currency,
aloc_ex_rate,aloc_foreign_amount,
aloc_local_amount,aloc_detail_1,
aloc_detail_2,aloc_detail_3,'POSTED',
ip,created_by,ua ,ekey,now(),'$temp_code'  
FROM mt_receipt_allocation_details where aloc_doc_number=:doc_no and aloc_allocation_type='BANK' ");

$statement->execute(array(':doc_no'=>$doc_no));

if ($statement->rowCount()){
  $data["cb_status2"]=1;
} else{
  $data["cb_status2"]=0;
}


$child_cb_status2=true;

if($child_bank_count!=0)
{
  if($data["cb_status2"]==0)
  {
  $child_cb_status2=false;
  }
}

$child_status=$child_cc_count==$child_cc_status_count && $child_rd_status_count==(count($vpds)-1) && $child_cb_status2;

$data["status"]=0;

if($data["status"]==1 && $data["pay_id_status"]==1 && $child_status && $data["ar_trans_status"]==1 && $data["ah_gl_status"]==1 && $data["ah_gl_status2"]==1 && $data["cb_status"]==1)
{
  $db->commit();
  
}else{
  $db->rollBack();
  $data["status"]=0;
  $data["msg"]="Unable to save. Please try again";
}

$statement=null;
}
//FINANCE POSTING ENDS

  }
  catch (PDOException $e) {
    print $e->getMessage();
    $db->rollBack();
    $data["status"]=0;
    $data["msg"]="Unable to save. Please try again";
  }
  
  return $data;
}


}
?>