<?php


require("../config/dbconn.php");
require("voucher-no-gen.php");

class FinanceDao

{


public static function save_page_views($dev,$pname,$method)
{
$data=0;
try
{
$db = Factory::getConnection();
$statement = $db->prepare("INSERT into page_views(
ip ,uid ,ua,ekey,esecret,method,page,tz) 
values(:ip ,:uid ,
:ua ,:ekey ,:esecret ,:method ,:page,:tz)");
$statement->execute(array(':ip'=>$dev->ip,':uid'=>$dev->uid ,
':ua'=>$dev->ua,
':tz'=>$dev->tz ,
':method'=>$method ,':esecret'=>$dev->esecret,':ekey'=>$dev->ekey,
':page'=>$pname));
$data=1;
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  return $data;
}



public static function get_jv_info($dev,$code)
{
$data=array();
try
{
$db = Factory::getConnection();

$statement = $db->prepare("SELECT 
id,
jvh_doc_number,
jvh_doc_type,
jvh_date,
jvh_narration,
jvh_currency,
jvh_status,
temp_code  
 from mt_jv_header where id=:id");

$statement->execute(array(':id'=>$code));
$data["info"]=$statement->fetchAll(PDO::FETCH_ASSOC);
$doc_no=$data["info"][0]["jvh_doc_number"];

$statement = $db->prepare("SELECT 
id,
aloc_doc_number,
aloc_amount,
aloc_currency,
aloc_ex_rate,
aloc_local_amount,
aloc_narration,
aloc_detail_1,
aloc_detail_2,
aloc_detail_3,
aloc_detail_31,

'0' edit 
 from mt_jv_allocation_details where aloc_doc_number=:id");

$statement->execute(array(':id'=>$doc_no));
$data["detail"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT pre_glt_doc_number from mt_jv_gl_details 
      WHERE pre_glt_doc_number=:doc_no");
$statement->execute(array(':doc_no'=>$doc_no));
$datas=$statement->fetchAll(PDO::FETCH_ASSOC);
$data["posted"]=count($datas);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_jv_list($dev,$code)
{
$data=array();
try
{
$db = Factory::getConnection();


$statement = $db->prepare("SELECT id,
jvh_doc_number,
jvh_base_doc,
jvh_doc_type,
jvh_date,
jvh_gl_date,
jvh_narration,
jvh_currency,
jvh_ex_rate,
jvh_foreign_amount,
jvh_local_amount,
jvh_status,
created_by,created_date from mt_jv_header 
WHERE jvh_status!='CANCELLED' order by id desc limit :sta,50");
$statement->bindValue(':sta',(int) $code, PDO::PARAM_INT); 
$statement->execute();
$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_jv_cancelled_list($dev,$code)
{
$data=array();
try
{
$db = Factory::getConnection();


$statement = $db->prepare("SELECT id,
jvh_doc_number,
jvh_base_doc,
jvh_doc_type,
jvh_date,
jvh_gl_date,
jvh_narration,
jvh_currency,
jvh_ex_rate,
jvh_foreign_amount,
jvh_local_amount,
jvh_status,
created_by,created_date from mt_jv_header 
WHERE jvh_status='CANCELLED' order by id desc limit :sta,50");
$statement->bindValue(':sta',(int) $code, PDO::PARAM_INT); 
$statement->execute();
$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function search_jv_list($dev,$code)
{
$data=array();
try
{
$db = Factory::getConnection();


$saq='';
$query='';
if(is_object($code))
{
  if($code->cancelled)
  {
  $saq="jvh_status='CANCELLED' and ";
  }else{
  $saq="jvh_status!='CANCELLED' and ";
  }
  $query=$code->q;
}else{
  $saq="jvh_status!='CANCELLED' and ";
  $query=$code;
}

$statement = $db->prepare("SELECT id,
jvh_doc_number,
jvh_base_doc,
jvh_doc_type,
jvh_date,
jvh_gl_date,
jvh_narration,
jvh_currency,
jvh_ex_rate,
jvh_foreign_amount,
jvh_local_amount,
jvh_status,
created_by,created_date from mt_jv_header 
where $saq jvh_doc_number like ? order by id desc limit 50");
$i=1;
$statement ->bindValue($i++, "%$query%", PDO::PARAM_STR);
$statement->execute();
$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function setFourDigit($v)
{
  $len=strlen($v);

if($len==1)
{
  $v="000".$v;
}else if($len==2)
{
  $v="00".$v;
}else if($len==3)
{
  $v="0".$v;
}

return $v;
}

public static function getFinancialYear()
{
//$year = ( date('m') > 4) ? date('Y') + 1 : date('Y');
$year=date('Y');
return $year;
}

public static function getFinancialPeriod($doc_date)
{

//$year = ( date('m') > 4) ? date('Y') + 1 : date('Y');
//$period=4;
//return $period;
$data=false;
try
{
$db = Factory::getConnection();

//$aq=self::getRestrictionQuery($dev);
//$doc_date="2019-12-15";
$date=date_create($doc_date);
$m= date_format($date,"F");
$y= date_format($date,"Y");

$statement = $db->prepare("SELECT enumber from mt_period 
  where period=:period and year=:year and open_max='OPEN'");

$statement->execute(array(':period'=>$m,':year'=>$y));
$data=$statement->fetchAll(PDO::FETCH_ASSOC);
//var_dump($statement->debugDumpParams());
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  $p=-10;
  if(count($data)==1)
  {
    $p=$data[0]["enumber"];
  }
  return $p;
}

public static function get_posted_status($code)
{


$data=0;
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT pre_glt_doc_number from mt_jv_gl_details 
      WHERE pre_glt_doc_number=:doc_no");
$statement->execute(array(':doc_no'=>$code->info->jvh_doc_number));
$datas=$statement->fetchAll(PDO::FETCH_ASSOC);
$data=count($datas);
$statement=null;
  }
  catch (Exception $e) {
  }
 
  return $data;
}

public static function save_jv_draft($dev,$code)
{
$result=array();
if($code->info->jvh_doc_number!='')
{

$posted_count=self::get_posted_status($code);

if($posted_count==0 && $code->info->jvh_status=='POSTED')
{
    $result=self::update_jv_draft($dev,$code);
    if($result["status"]==1)
    {
      $result=self::post_jv($dev,$code);
    }else{
      $result["add_msg"]="Update failed before posting";
    }
}if($posted_count!=0 && $code->info->jvh_status=='POSTED')
{
  $result["add_msg"]="Trying to Update already posted";
  $result["status"]=0;
  $result["msg"]="Voucher already posted to finance";
}else if($posted_count==0 && $code->info->jvh_status=='DRAFT')
{
    $result=self::update_jv_draft($dev,$code);
}

return $result;

}else if($code->info->jvh_status=='POSTED')
{
    $data=array();
  $data["status"]=0;
  $data["msg"]="Please select status to draft and try save.";
  return $data;
}else
{
$data=array();
$data["ts"]=$code->info->jvh_doc_number!='';
try
{
$db = Factory::getConnection();
$db->beginTransaction();

$cds=$code->cds;
$c=$code->info;

$temp_code=uniqid($dev->uid);

$statement = $db->prepare("INSERT into mt_jv_header(
jvh_base_doc,
jvh_doc_type,
jvh_date,
jvh_gl_date,
jvh_narration,
jvh_currency,
jvh_ex_rate,
jvh_foreign_amount,
jvh_local_amount,
jvh_status,
location_id,
company_id,
created_by,
created_date,
ip,
ua,
ekey,
temp_code
) 
values(
:jvh_base_doc,
:jvh_doc_type,
:jvh_date,
:jvh_gl_date,
:jvh_narration,
:jvh_currency,
:jvh_ex_rate,
:jvh_foreign_amount,
:jvh_local_amount,
:jvh_status,
:location_id,
:company_id,
:created_by,
now(),
:ip,
:ua,
:ekey,
:temp_code
)");
$c->jvh_status='DRAFT';
$statement->execute(array(
':jvh_base_doc'=>$c->jvh_doc_type,
':jvh_doc_type'=>$c->jvh_doc_type,
':jvh_date'=>$c->jvh_date,
':jvh_gl_date'=>$c->jvh_date,
':jvh_narration'=>$c->jvh_narration,
':jvh_currency'=>$c->jvh_currency,
':jvh_ex_rate'=>'1',
':jvh_foreign_amount'=>$code->dr,
':jvh_local_amount'=>$code->dr,
':jvh_status'=>$c->jvh_status,
':location_id'=>$dev->location,
':company_id'=>$dev->company,
':created_by'=>$dev->username,
':ip'=>$dev->ip,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,
':temp_code'=>$temp_code
));

if ($statement->rowCount()){
  $data["status"]=1;
  $data["msg"]="Saved.";
} else{
  $data["status"]=0;
  $data["msg"]="Unable to save.";
}

$statement = $db->prepare("SELECT id from mt_jv_header where created_by=:uid and temp_code=:temp_code");
$statement->execute(array(':temp_code'=>$temp_code,
  ':uid'=>$dev->username));
$data["id"]=$statement->fetchAll(PDO::FETCH_ASSOC);
$data["temp_code"]=$temp_code;

$four_id=self::setFourDigit($data["id"][0]["id"]);
$fid1=$data["id"][0]["id"];

$prefix="";
if($c->jvh_doc_type=="JV")
{
$prefix="JV";
}else
{
$prefix="OBJV";
}

$doc_date1=$c->jvh_date;
$doc_no=generate_voucher_no1($db,$dev,$prefix,$temp_code,$doc_date1);

//$doc_no=$prefix."/".date("Y")."/".date('m')."/".$four_id;

$statement = $db->prepare("UPDATE mt_jv_header  
  SET jvh_doc_number=:ond where id=:id");
  $statement->execute(array(':id'=>$fid1,':ond'=>$doc_no));
  
    if ($statement->rowCount()){
    $data["jid_status"]=1;
  } else{
    $data["jid_status"]=0;
  }

$data["doc_no"]=$doc_no;

//query 2 child entry
$len=count($cds);
$ch_status_count=0;


for($i=0;$i<$len;$i++)
{
$cd=$cds[$i];
$r=$cd;

$statement = $db->prepare("INSERT into mt_jv_allocation_details 
(
aloc_doc_number,
aloc_amount,
aloc_currency,
aloc_ex_rate,
aloc_local_amount,
aloc_narration,
aloc_detail_1,
aloc_detail_2,
aloc_detail_3,
location_id,
company_id,
created_by,
created_date,
ip,
ua,
ekey
)
VALUES
(
:aloc_doc_number,
:aloc_amount,
:aloc_currency,
:aloc_ex_rate,
:aloc_local_amount,
:aloc_narration,
:aloc_detail_1,
:aloc_detail_2,
:aloc_detail_3,
:location_id,
:company_id,
:created_by,
now(),
:ip,
:ua,
:ekey
)");
  $statement->execute(array(
':aloc_doc_number'=>$doc_no,
':aloc_amount'=>$r->aloc_amount,
':aloc_currency'=>$r->aloc_currency,
':aloc_ex_rate'=>$r->aloc_ex_rate,
':aloc_local_amount'=>$r->aloc_local_amount,
':aloc_narration'=>$r->aloc_narration,
':aloc_detail_1'=>$r->aloc_detail_1,
':aloc_detail_2'=>$r->aloc_detail_2,
':aloc_detail_3'=>$r->aloc_detail_3,
':location_id'=>$dev->location,
':company_id'=>$dev->company,
':created_by'=>$dev->username,
':ip'=>$dev->ip,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey
  ));
  
    if ($statement->rowCount()){
    $ch_status_count+=1;
    $data["ch_status".($i+1)]=1;
  } else{
    $data["ch_status".($i+1)]=0;
  }

}
//end of loop

$cr_count=count($cds);
$child_status=$ch_status_count==$cr_count;

//$data["status"]=0;


if($data["status"]==1 && $child_status)
{
  $db->commit();
}else{
    $db->rollBack();
    $data["status"]=0;
    $data["msg"]="Unable to save. Please try again";
}

$statement=null;
  }
  catch (Exception $e) {
    $data["emsg"]=$e->getMessage();
    $db->rollBack();
    $data["status"]=0;
    $data["msg"]="Unable to save.Exception. Please try again";
  }
  
  return $data;
  }
}


public static function update_jv_draft($dev,$code)
{
$data=array();
try
{
$db = Factory::getConnection();
$db->beginTransaction();

$cds=$code->cds;
$c=$code->info;

$temp_code=uniqid($dev->uid);


$statement = $db->prepare("UPDATE mt_jv_header
SET 
jvh_base_doc=:jvh_base_doc,
jvh_doc_type=:jvh_doc_type,
jvh_date=:jvh_date,
jvh_gl_date=:jvh_gl_date,
jvh_narration=:jvh_narration,
jvh_currency=:jvh_currency,
jvh_ex_rate=:jvh_ex_rate,
jvh_foreign_amount=:jvh_foreign_amount,
jvh_local_amount=:jvh_local_amount,

modified_date=now(),
modified_by=:modified_by
WHERE id=:id");

$statement->execute(array(
':jvh_base_doc'=>$c->jvh_doc_type,
':jvh_doc_type'=>$c->jvh_doc_type,
':jvh_date'=>$c->jvh_date,
':jvh_gl_date'=>$c->jvh_date,
':jvh_narration'=>$c->jvh_narration,
':jvh_currency'=>$c->jvh_currency,
':jvh_ex_rate'=>'1',
':jvh_foreign_amount'=>$code->dr,
':jvh_local_amount'=>$code->dr,

':id'=>$c->id,
':modified_by'=>$dev->username,

));

if ($statement->rowCount()){
  $data["status"]=1;
  $data["msg"]="Updated successfully.";
} else{
  $data["status"]=0;
  $data["msg"]="Unable to update. Please try again.";
}


$doc_no=$c->jvh_doc_number;

//delete child data
$statement = $db->prepare("DELETE FROM mt_jv_allocation_details 
  WHERE aloc_doc_number=:aloc_doc_number");
$statement->execute(array(':aloc_doc_number'=>$doc_no));
if ($statement->rowCount()){
  $data["del_status"]=1;
} else{
  $data["del_status"]=0;
}


//query 2 child entry
$len=count($cds);
$ch_status_count=0;


for($i=0;$i<$len;$i++)
{
$cd=$cds[$i];
$r=$cd;

$statement = $db->prepare("INSERT into mt_jv_allocation_details 
(
aloc_doc_number,
aloc_amount,
aloc_currency,
aloc_ex_rate,
aloc_local_amount,
aloc_narration,
aloc_detail_1,
aloc_detail_2,
aloc_detail_3,
location_id,
company_id,
created_by,
created_date,
ip,
ua,
ekey
)
VALUES
(
:aloc_doc_number,
:aloc_amount,
:aloc_currency,
:aloc_ex_rate,
:aloc_local_amount,
:aloc_narration,
:aloc_detail_1,
:aloc_detail_2,
:aloc_detail_3,
:location_id,
:company_id,
:created_by,
now(),
:ip,
:ua,
:ekey
)");
  $statement->execute(array(
':aloc_doc_number'=>$doc_no,
':aloc_amount'=>$r->aloc_amount,
':aloc_currency'=>$r->aloc_currency,
':aloc_ex_rate'=>$r->aloc_ex_rate,
':aloc_local_amount'=>$r->aloc_local_amount,
':aloc_narration'=>$r->aloc_narration,
':aloc_detail_1'=>$r->aloc_detail_1,
':aloc_detail_2'=>$r->aloc_detail_2,
':aloc_detail_3'=>$r->aloc_detail_3,
':location_id'=>$dev->location,
':company_id'=>$dev->company,
':created_by'=>$dev->username,
':ip'=>$dev->ip,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey
  ));
  
    if ($statement->rowCount()){
    $ch_status_count+=1;
    $data["ch_status".($i+1)]=1;
  } else{
    $data["ch_status".($i+1)]=0;
  }

}
//end of loop

$cr_count=count($cds);
$child_status=$ch_status_count==$cr_count;

//$data["status"]=0;


if($data["status"]==1 && $child_status && $data["del_status"]==1)
{
  $db->commit();
}else{
    $db->rollBack();
    $data["status"]=0;
    $data["msg"]="Unable to save. Please try again";
}

$statement=null;
  }
  catch (Exception $e) {
    $data["emsg"]=$e->getMessage();
    $db->rollBack();
    $data["status"]=0;
    $data["msg"]="Unable to save.Exception. Please try again";
  }
  
  return $data;

}

public static function post_jv($dev,$code)
{
$data=array();
try
{
$db = Factory::getConnection();
$db->beginTransaction();

$c=$code->info;

$temp_code=uniqid($dev->uid);

$statement = $db->prepare("INSERT into mt_jv_gl_details  
(
pre_glt_company,
pre_glt_code,
pre_glt_doc_base,
pre_glt_doc_type,
pre_glt_doc_number,
pre_glt_doc_date,
pre_glt_gl_date,
pre_glt_year,
pre_glt_period,
pre_glt_currency,
pre_glt_ex_rate,
pre_glt_foreign_amount,
pre_glt_local_amount,
pre_glt_narration,
aloc_detail_1,
aloc_detail_2,
aloc_detail_3,
location_id,
company_id,
created_by,
created_date,
ip,
ua,
ekey,
temp_code
)
SELECT 

company_id,
aloc_detail_1,
'$c->jvh_doc_type',
'$c->jvh_doc_type',
aloc_doc_number,
'$c->jvh_date',
'$c->jvh_date',
".self::getFinancialYear().",
".self::getFinancialPeriod($c->jvh_date).",
aloc_currency,
aloc_ex_rate,
aloc_amount,
aloc_local_amount,
aloc_narration,
aloc_detail_1,
aloc_detail_2,
aloc_detail_3,
location_id,
company_id,
created_by,
now(),
ip,
ua,
ekey,
'$temp_code'
 
FROM mt_jv_allocation_details where aloc_doc_number=:id");

$statement->execute(array(':id'=>$c->jvh_doc_number));

if ($statement->rowCount()){
  $data["jv_gl_status"]=1;
} else{
  $data["jv_gl_status"]=0;
}


$statement = $db->prepare("INSERT into mt_ar_trans 
(
art_company,
art_code,
art_type,
art_number,
art_group,
art_base_type,
art_doc_date,
art_gl_date,
art_year,
art_period,
art_currency,
art_ex_rate,
art_foreign_amount,
art_local_amount,
art_foreign_balance,
art_local_balance,
art_balance_status,
art_description,
location_id,
company_id,
created_by,
created_date,
ip,
ua,
ekey,
temp_code
)
SELECT 
pre_glt_company,
aloc_detail_3,
pre_glt_doc_type,
pre_glt_doc_number,
pre_glt_code,
pre_glt_doc_base,
pre_glt_doc_date,
pre_glt_gl_date,
pre_glt_year,
pre_glt_period,
pre_glt_currency,
pre_glt_ex_rate,
pre_glt_foreign_amount,
pre_glt_local_amount,
'0',
'0',
'A',
pre_glt_narration,
location_id,
company_id,
created_by,
now(),
ip,
ua,
ekey,
temp_code 
FROM mt_jv_gl_details  
WHERE pre_glt_code=(select gl_account from mt_gl_link where name='RECEIVABLE' limit 1) 
and pre_glt_doc_number=:id");

$statement->execute(array(':id'=>$c->jvh_doc_number));

if ($statement->rowCount()){
  $data["ar_trans_status"]=1;
} else{
  $data["ar_trans_status"]=0;
}


$statement = $db->prepare("INSERT into mt_ap_trans 
(
apt_company,
apt_code,
apt_type,
apt_number,
apt_group,
apt_base_type,
apt_doc_date,
apt_gl_date,
apt_year,
apt_period,
apt_currency,
apt_ex_rate,
apt_foreign_amount,
apt_local_amount,
apt_foreign_balance,
apt_local_balance,
apt_balance_status,
apt_description,
location_id,
company_id,
created_by,
created_date,
ip,
ua,
ekey,
temp_code
)
SELECT 
pre_glt_company,
aloc_detail_3,
pre_glt_doc_type,
pre_glt_doc_number,
pre_glt_code,
pre_glt_doc_base,
pre_glt_doc_date,
pre_glt_gl_date,
pre_glt_year,
pre_glt_period,
pre_glt_currency,
pre_glt_ex_rate,
pre_glt_foreign_amount,
pre_glt_local_amount,
'0',
'0',
'A',
pre_glt_narration,
location_id,
company_id,
created_by,
now(),
ip,
ua,
ekey,
temp_code 
FROM mt_jv_gl_details  
WHERE pre_glt_code=(select gl_account from mt_gl_link where name='PAYABLE' limit 1) 
and pre_glt_doc_number=:id");

$statement->execute(array(':id'=>$c->jvh_doc_number));

if ($statement->rowCount()){
  $data["ap_trans_status"]=1;
} else{
  $data["ap_trans_status"]=0;
}

//get payable count
$statement = $db->prepare("SELECT * FROM mt_jv_allocation_details 
  WHERE aloc_detail_1=(select gl_account from mt_gl_link where name='PAYABLE' limit 1) 
and aloc_doc_number=:id");
$statement->execute(array(':id'=>$c->jvh_doc_number));
$datas1=$statement->fetchAll(PDO::FETCH_ASSOC);

//get receivable count
$statement = $db->prepare("SELECT * FROM mt_jv_allocation_details 
  WHERE aloc_detail_1=(select gl_account from mt_gl_link where name='RECEIVABLE' limit 1) 
and aloc_doc_number=:id");
$statement->execute(array(':id'=>$c->jvh_doc_number));
$datas2=$statement->fetchAll(PDO::FETCH_ASSOC);

if(count($datas1)==0)
{
$data["ap_trans_status"]=1;
$data["ap_trans_status_add"]="No payable";
}

if(count($datas2)==0)
{
$data["ar_trans_status"]=1;
$data["ar_trans_status_add"]="No receivable";
}


$temp_code=uniqid($dev->uid);

$statement = $db->prepare("UPDATE mt_jv_header  
  SET jvh_status='POSTED', modified_date=now(),
  temp_code2=:temp_code 
   where jvh_doc_number=:id");
$statement->execute(array(':id'=>$c->jvh_doc_number,
':temp_code'=>$temp_code));
  
if ($statement->rowCount()){
$data["status"]=1;
} else{
$data["status"]=0;
}

//$data["status"]=0;
$data["posted"]=2;


if($data["status"]==1 && $data["jv_gl_status"]=1 && $data["ar_trans_status"]=1 && $data["ap_trans_status"]=1 )
{
  $data["msg"]="Posted Voucher successfully";
  $db->commit();
}else{
    $db->rollBack();
    $data["status"]=0;
    $data["msg"]="Unable to save. Please try again";
}

$statement=null;
  }
  catch (Exception $e) {
    $data["emsg"]=$e->getMessage();
    $db->rollBack();
    $data["status"]=0;
    $data["msg"]="Unable to save. Exception. Please try again";
  }
  
  return $data;
}

//

public static function get_gl_link($dev,$c)
{
$data=array();
try
{

$db = Factory::getConnection();

$statement = $db->prepare("SELECT gl_account from mt_gl_link where name=:name limit 1");

$statement->execute(array(':name'=>$c));
$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
}
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}



public static function search_bp_jv($v)
{
$data=array();
try
{
$db = Factory::getConnection();

$statement = $db->prepare("SELECT id,code,name, 
case when tag in ('CONSIGNEE','SHIPPER') then 
(select gl_account from mt_gl_link where name='RECEIVABLE' limit 1)
else 
(select gl_account from mt_gl_link where name='PAYABLE' limit 1)
end 'gl_code',

case when tag in ('CONSIGNEE','SHIPPER') then 
(select ac_description from mt_general_ledger where code=(select gl_account from mt_gl_link where name='RECEIVABLE' limit 1) limit 1)
else 
(select ac_description from mt_general_ledger where code=(select gl_account from mt_gl_link where name='PAYABLE' limit 1) limit 1)
end 'ac_description'

from mt_business_partner where (code like ? or name like ?) order by id limit 50");
$statement ->bindValue(1, "%$v%", PDO::PARAM_STR);
$statement ->bindValue(2, "%$v%", PDO::PARAM_STR);

$statement->execute();
$data=$statement->fetchAll(PDO::FETCH_ASSOC);
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function get_gl_finance($dev)
{
$data=array();
try
{
$db = Factory::getConnection();

$statement = $db->prepare("SELECT gl_account,'ACCOUNTS RECEIVABLE' ac_description from mt_gl_link where name='RECEIVABLE' 
  UNION ALL 
  SELECT gl_account,'ACCOUNTS PAYABLE' ac_description 
  from mt_gl_link where name='PAYABLE'");
$statement->execute();
$data=$statement->fetchAll(PDO::FETCH_ASSOC);
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function search_bp_finance($dev,$v)
{
$data=array();
try
{
$db = Factory::getConnection();

$aq='';
if($v->type=="AR")
{
  $aq="account_type in('ACCOUNTS RECEIVABLE','BOTH') ";
}else if($v->type=="AP")
{
  $aq="account_type in('ACCOUNTS PAYABLE','BOTH') ";
}else if($v->type=="BOTH")
{
  $aq="account_type in('ACCOUNTS RECEIVABLE','ACCOUNTS PAYABLE','BOTH') ";
}

$statement = $db->prepare("SELECT id,code,name,account_type 
  from mt_business_partner where $aq and (code like ? or name like ?) order by id limit 20");
$statement ->bindValue(1, "%$v->q%", PDO::PARAM_STR);
$statement ->bindValue(2, "%$v->q%", PDO::PARAM_STR);

$statement->execute();
$data=$statement->fetchAll(PDO::FETCH_ASSOC);
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function search_cash_bank($dev,$v)
{
$data=array();
try
{
$db = Factory::getConnection();

$statement = $db->prepare("SELECT currency,bank_code,description from mt_bank_list 
  where country=(select country from user_master where username='$dev->username') and (bank_code like ? or description like ? ) order by id 
 limit 50");
$statement ->bindValue(1, "$v%", PDO::PARAM_STR);
$statement ->bindValue(2, "$v%", PDO::PARAM_STR);

$statement->execute();
$data=$statement->fetchAll(PDO::FETCH_ASSOC);
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function search_bank_glcode($v)
{
$data=array();
try
{
$db = Factory::getConnection();

$statement = $db->prepare("SELECT id,code,ac_description FROM mt_general_ledger 
  WHERE account_type='ASSETS' and type='CONTROL'
 and (ac_description like ? or  code like ? ) order by ac_description 
  limit 20");
$statement ->bindValue(1, "%$v%", PDO::PARAM_STR);
$statement ->bindValue(2, "%$v%", PDO::PARAM_STR);
$statement->execute();
$data=$statement->fetchAll(PDO::FETCH_ASSOC);
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function get_bank_list($dev,$code)
{
$data=array();
try
{
$db = Factory::getConnection();


$statement = $db->prepare("SELECT id,
bank_code,
gl_code,
description,
account_no,
swift_code,
country,
currency,
ifsc_code,
'0' edit,
created_by,created_date from mt_bank_list order by id desc limit 50");
$statement->execute();
$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function save_bank_master($dev,$c)
{

$data=array();
try
{
$db = Factory::getConnection();
$db->beginTransaction();

$temp_code=uniqid($dev->uid);

$statement = $db->prepare("INSERT INTO mt_bank_list 
(
bank_code,
gl_code,
description,
account_no,
swift_code,
country,
currency,
ifsc_code,
ip,ua,ekey,created_by,created_date,company_id,location_id,temp_code
) 
VALUES
(
:bank_code,
:gl_code,
:description,
:account_no,
:swift_code,
:country,
:currency,
:ifsc_code,
:ip,:ua,:ekey,:created_by,now(),:company_id,:location_id,:temp_code)
  ");
$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->username,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,

':bank_code'=>$c->bank_code,
':gl_code'=>$c->gl_code,
':description'=>$c->description,
':account_no'=>$c->account_no,

':swift_code'=>$c->swift_code,
':country'=>$c->country,
':currency'=>$c->currency,
':ifsc_code'=>$c->ifsc_code,

':temp_code'=>$temp_code,
':company_id'=>$dev->company,
':location_id'=>$dev->location
));
if ($statement->rowCount()){
  $data["status"]=1;
  $data["msg"]="Saved";

} else{
  $data["status"]=0;
  $data["msg"]="Unable to save. Please try again";

}

$statement = $db->prepare("SELECT id from mt_bank_list  
WHERE created_by=:created_by and temp_code=:temp_code");
$statement->execute(array(':created_by'=>$dev->username,':temp_code'=>$temp_code));
$data["id"]=$statement->fetchAll(PDO::FETCH_ASSOC);


if($data["status"]==1 )
{
  $db->commit();
}else{
  $db->rollBack();
  $data["status"]=0;
  $data["msg"]="Unable to save. Please try again";
}

$statement=null;
  }
  catch (Exception $e) {
    $data["emsg"]=$e->getMessage();
    $db->rollBack();
    $data["status"]=0;
    $data["msg"]="Unable to save. Exception. Please try again";
  }
  
  return $data;
}


public static function update_bank_master($dev,$c)
{

$data=array();
try
{
$db = Factory::getConnection();
$temp_code=uniqid($dev->uid);

$statement = $db->prepare("UPDATE mt_bank_list SET modified_by=:created_by,modified_date=now() 
  WHERE id=:id");
$statement->execute(array(
':created_by'=>$dev->username,
':id'=>$c->id
));
if ($statement->rowCount()){
  $data["status"]=1;
  $data["msg"]="Updated";

} else{
  $data["status"]=0;
  $data["msg"]="Unable to update. Please try again";

}

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}



}
?>