<?php


require("../config/dbconn.php");

class FinanceDao

{


public static function save_page_views($dev,$pname,$method)
{
$data=0;
try
{
$db = Factory::getConnection();


$statement = $db->prepare("INSERT into page_views(
ip ,uid ,ua,ekey,esecret,method,page,tz) 
values(:ip ,:uid ,
:ua ,:ekey ,:esecret ,:method ,:page,:tz)");
$statement->execute(array(':ip'=>$dev->ip,':uid'=>$dev->uid ,
':ua'=>$dev->ua,
':tz'=>$dev->tz ,
':method'=>$method ,':esecret'=>$dev->esecret,':ekey'=>$dev->ekey,
':page'=>$pname));


$data=1;
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function download_coa($dev)
{

$data=false;
try
{



$db = Factory::getConnection();
$statement = $db->prepare("SELECT 
id,
account_type,
account_group,
account_sub_group,
code,
ac_description,
type 
from mt_general_ledger order by code");
$statement->execute();
$data=$statement->fetchAll(PDO::FETCH_ASSOC);
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function download_charge_master($dev)
{

$data=false;
try
{



$db = Factory::getConnection();
$statement = $db->prepare("SELECT 
code,
description,
income_gl,
expense_gl 
from mt_charge_group_detail order by code ");
$statement->execute();
$data=$statement->fetchAll(PDO::FETCH_ASSOC);
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_gl_list($dev,$code)
{

$data=false;
try
{

$v=$code;
if(is_object($code))
{
  if (property_exists($code, 'start')) 
{
  $v=$code->start;
}

}


$db = Factory::getConnection();
$statement = $db->prepare("SELECT 
id,
account_type,
account_group,
account_sub_group,
account_serial,
code,
ac_description,
ac_maintype,
ac_nature,
type,
old_account,
language,
language_desc,
posting_allow,
secure_input,
secure_output,
budget_required,
parent_gl_code,
parent_gl_desc,
status,
'0' edit
   from mt_general_ledger order by id limit :sta,20");

$statement->bindValue(':sta',(int) $v, PDO::PARAM_INT); 
$statement->execute();

$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function search_gl_list($dev,$v)
{

$data=false;
try
{
$db = Factory::getConnection();

$spv=explode(',',$v);

if(count($spv)>=1)
{
  //need to implement logics
}

$statement = $db->prepare("SELECT 
id,
account_type,
account_group,
account_sub_group,
account_serial,
code,
ac_description,
ac_maintype,
ac_nature,
type,
old_account,
language,
language_desc,
posting_allow,
secure_input,
secure_output,
budget_required,
parent_gl_code,
parent_gl_desc,
status,
'0' edit 
from mt_general_ledger 
WHERE code LIKE ? or ac_description LIKE ? or account_sub_group LIKE ? or account_group LIKE ? or account_type LIKE ? 
order by id limit 20");

$statement ->bindValue(1, "%$v%", PDO::PARAM_STR);
$statement ->bindValue(2, "%$v%", PDO::PARAM_STR);
$statement ->bindValue(3, "%$v%", PDO::PARAM_STR);
$statement ->bindValue(4, "%$v%", PDO::PARAM_STR);
$statement ->bindValue(5, "%$v%", PDO::PARAM_STR);


$statement->execute();

$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function get_gl_prefix($db,$v)
{

$data=array();
try
{
$gl_code='';

//get main code
if($v->account_type=='ASSETS')
{
 $gl_code='1'; 
}else if($v->account_type=='LIABILITIES')
{
 $gl_code='2'; 
}else if($v->account_type=='INCOME')
{
 $gl_code='3'; 
}else if($v->account_type=='EXPENSES')
{
 $gl_code='4'; 
}

//get group code

$statement = $db->prepare("SELECT code FROM gl_groups WHERE account_type=:account_type and account_group=:account_group");
$statement->execute(array(':account_type'=>$v->account_type,':account_group'=>$v->account_group));
$datas1=$statement->fetchAll(PDO::FETCH_ASSOC);

$gl_code=$gl_code.'-'.$datas1[0]["code"];

$statement = $db->prepare("SELECT code FROM gl_subgroups WHERE account_type=:account_type and account_group=:account_group and account_sub_group=:account_sub_group");
$statement->execute(array(':account_type'=>$v->account_type,':account_group'=>$v->account_group,':account_sub_group'=>$v->account_sub_group));
$datas2=$statement->fetchAll(PDO::FETCH_ASSOC);

$gl_code=$gl_code.'-'.$datas2[0]["code"];
$data["gl_code"]=$gl_code;
$data["status"]=1;

$statement=null;
  }
  catch (Exception $e) {
$data["status"]=0;
    
  }
  
  return $data;
}



public static function save_gl_code($dev,$c)
{

$data=array();
try
{
$db = Factory::getConnection();
$db->beginTransaction();

$temp_code=uniqid($dev->uid);

$statement = $db->prepare("INSERT INTO mt_general_ledger(account_type,account_group,account_sub_group,account_serial,code,ac_description,type,ip,ua,ekey,created_by,created_date,company_id,location_id,temp_code,group_id,sub_group_id) 
VALUES(:account_type,:account_group,:account_sub_group,:account_serial,:code,:ac_description,:type,:ip,:ua,:ekey,:created_by,now(),:company_id,:location_id,:temp_code,:group_id,:sub_group_id)
  ");
$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->username,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,

':account_type'=>$c->account_type,
':account_group'=>$c->account_group,
':account_sub_group'=>$c->account_sub_group,
':account_serial'=>$c->account_serial,

':code'=>$c->code,
':ac_description'=>$c->ac_description,
':type'=>$c->type,
':group_id'=>$c->group_id,
':sub_group_id'=>$c->sub_group_id,


':temp_code'=>$temp_code,
':company_id'=>$dev->company,
':location_id'=>$dev->location
));
if ($statement->rowCount()){
  $data["status"]=1;
  $data["msg"]="Saved";

} else{
  $data["status"]=0;
  $data["msg"]="Unable to save. Please try again";

}

$statement = $db->prepare("SELECT id from mt_general_ledger 
WHERE created_by=:created_by and temp_code=:temp_code");
$statement->execute(array(':created_by'=>$dev->username,':temp_code'=>$temp_code));
$data["id"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT count(*) total1 FROM mt_general_ledger WHERE account_type=:account_type and account_group=:account_group and account_sub_group=:account_sub_group and id<:id");
$statement->execute(array(':account_type'=>$c->account_type,':account_group'=>$c->account_group,':account_sub_group'=>$c->account_sub_group,':id'=>$data["id"][0]["id"]));
$datas2=$statement->fetchAll(PDO::FETCH_ASSOC);
$fid=self::setFourDigit($datas2[0]["total1"]+1);
$datas3=self::get_gl_prefix($db,$c);
$data["datas3"]=$datas3;
if($datas3["status"]==1)
{
  $gl_code=$datas3["gl_code"].'-'.$fid;
  $data["gl_code"]=$gl_code;
  $statement = $db->prepare("UPDATE mt_general_ledger SET code=:glcode
WHERE id=:id");
$statement->execute(array(':glcode'=>$gl_code,':id'=>$data["id"][0]["id"]));
      if ($statement->rowCount()){
        $data["code_status"]=1;
      } else{
        $data["code_status"]=0;
      }
}else{
  $data["code_status"]=0;
  $data["code"]=$datas3;
}

if($data["status"]==1 && $data["code_status"]==1 )
{
  $db->commit();
}else{
  $db->rollBack();
  $data["status"]=0;
  $data["msg"]="Unable to save. Please try again";
}

$statement=null;
  }
  catch (Exception $e) {
    $data["emsg"]=$e->getMessage();
    $db->rollBack();
    $data["status"]=0;
    $data["msg"]="Unable to save. Exception. Please try again";
  }
  
  return $data;
}


public static function update_gl_code($dev,$c)
{

$data=array();
try
{
$db = Factory::getConnection();
$temp_code=uniqid($dev->uid);

$statement = $db->prepare("UPDATE mt_general_ledger 
  SET ac_description=:ac_description,
  type=:type,
modified_by=:created_by,modified_date=now() 
  WHERE id=:id");
$statement->execute(array(
':created_by'=>$dev->username,
':id'=>$c->id,
':ac_description'=>$c->ac_description,
':type'=>$c->type
));
if ($statement->rowCount()){
  $data["status"]=1;
  $data["msg"]="Updated";

} else{
  $data["status"]=0;
  $data["msg"]="Unable to update. Please try again";

}

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function get_gl_groups($dev,$code)
{
$data=array();
try
{
$db = Factory::getConnection();


$statement = $db->prepare("SELECT id,account_type,account_group,code,'0' edit FROM gl_groups WHERE account_type=:account_type");

$statement->execute(array(':account_type'=>$code));
$data["info"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function delete_gl_groups($dev,$code)
{
$data=array();
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT id from gl_subgroups where account_type=:account_type and account_group=:account_group");
$statement->execute(array(':account_type'=>$code->account_type,
  ':account_group'=>$code->account_group));
$datas=$statement->fetchAll(PDO::FETCH_ASSOC);
if(count($datas)>=1)
{
$data["status"]=0;
$data["msg"]="Sub groups are created. So delete sub groups then delete this group";
}else{

  $statement = $db->prepare("DELETE FROM gl_groups WHERE id=:id");

$statement->execute(array(
':id'=>$code->id
));

if ($statement->rowCount()){
  $data["status"]=1;
  $data["msg"]="Deleted.";
} else{
  $data["status"]=0;
  $data["msg"]="Unable to delete. Please try again.";
}
}

}catch (Exception $e) {
  $data["emsg"]=$e->getMessage();
    $data["status"]=0;
    $data["msg"]="Unable to save. Exception. Please try again";
  }
  return $data;
}


public static function update_gl_groups($dev,$code)
{
$data=array();
try
{
$db = Factory::getConnection();
$db->beginTransaction();

$code->account_group=trim($code->account_group);

//find subgroup
$statement = $db->prepare("SELECT id from gl_subgroups where group_id=:group_id");
$statement->execute(array(':group_id'=>$code->id));
$subgroups=$statement->fetchAll(PDO::FETCH_ASSOC);
$subgroups=count($subgroups);

$statement = $db->prepare("SELECT code from mt_general_ledger 
  where group_id=:group_id");
$statement->execute(array(':group_id'=>$code->id));
$gls=$statement->fetchAll(PDO::FETCH_ASSOC);
$gls=count($gls);

/*
if(count($datas)>=1)
{
$data["status"]=0;
$data["msg"]="Sub groups are created. So delete sub groups then update this group";
}else{*/

$statement = $db->prepare("UPDATE gl_groups SET account_group=:account_group,
    modified_by=:modified_by,
    modified_date=now() 
    WHERE id=:id");

$stmt_rowcount=$statement->execute(array(
':id'=>$code->id,
':account_group'=>$code->account_group,
':modified_by'=>$dev->username
));

if ($stmt_rowcount){
  $data["status"]=1;
  $data["msg"]="Updated.";
} else{
  $data["status"]=0;
  $data["msg"]="Unable to update. Please try again.";
}

//update sub groups
$statement = $db->prepare("UPDATE gl_subgroups SET account_group=:account_group,
    modified_by=:modified_by,
    modified_date=now() 
    WHERE group_id=:group_id");

$stmt_rowcount=$statement->execute(array(
':group_id'=>$code->id,
':account_group'=>$code->account_group,
':modified_by'=>$dev->username
));

if ($stmt_rowcount){
  $data["sub_status"]=1;
} else{
  $data["sub_status"]=0;
}

$statement = $db->prepare("UPDATE mt_general_ledger SET account_group=:account_group,
    modified_by=:modified_by,
    modified_date=now() 
    WHERE group_id=:group_id");

$stmt_rowcount=$statement->execute(array(
':group_id'=>$code->id,
':account_group'=>$code->account_group,
':modified_by'=>$dev->username
));

if ($stmt_rowcount){
  $data["gen_status"]=1;
} else{
  $data["gen_status"]=0;
}

if($subgroups==0)
{
$data["sub_status"]=1;
$data["sub_status_add_msg"]="No sub groups";
}

if($gls==0)
{
$data["gen_status"]=1;
$data["gen_status_add_msg"]="No sub gen ledgers";
}

if($data["status"]==1 && $data["gen_status"]==1 && $data["sub_status"])
{
  $db->commit();
  
}else{
  $db->rollBack();
    $data["status"]=0;
    $data["msg"]="Unable to save. Please try again";
}

//}

}catch (Exception $e) {
    $db->rollBack();
    $data["emsg"]=$e->getMessage();
    $data["status"]=0;
    $data["msg"]="Unable to save. Exception. Please try again";
  }
  return $data;
}


public static function update_gl_subgroups($dev,$code)
{
$data=array();
try
{
$db = Factory::getConnection();
$db->beginTransaction();

//find gls
$statement = $db->prepare("SELECT code from mt_general_ledger 
  where sub_group_id=:sub_group_id");
$statement->execute(array(':sub_group_id'=>$code->id));
$gls=$statement->fetchAll(PDO::FETCH_ASSOC);
$gls=count($gls);

  $statement = $db->prepare("UPDATE gl_subgroups 
    SET account_sub_group=:account_sub_group,
    modified_date=now(),
    modified_by=:modified_by 
    WHERE id=:id");

$statement->execute(array(
':id'=>$code->id,
':account_sub_group'=>$code->account_sub_group,
':modified_by'=>$dev->username
));

if ($statement->rowCount()){
  $data["status"]=1;
  $data["msg"]="Updated.";
} else{
  $data["status"]=0;
  $data["msg"]="Unable to update. Please try again.";
}


$statement = $db->prepare("UPDATE mt_general_ledger SET account_sub_group=:account_sub_group,
    modified_by=:modified_by,
    modified_date=now() 
    WHERE sub_group_id=:sub_group_id");

$stmt_rowcount=$statement->execute(array(
':sub_group_id'=>$code->id,
':account_sub_group'=>$code->account_sub_group,
':modified_by'=>$dev->username
));

if ($stmt_rowcount){
  $data["gen_status"]=1;
} else{
  $data["gen_status"]=0;
}


if($gls==0)
{
$data["gen_status"]=1;
$data["gen_status_add_msg"]="No sub gen ledgers";
}

if($data["status"]==1 && $data["gen_status"]==1)
{
  $db->commit();
  
}else{
  $db->rollBack();
    $data["status"]=0;
    $data["msg"]="Unable to save. Please try again";
}

}catch (Exception $e) {
    $db->rollBack();
    $data["emsg"]=$e->getMessage();
    $data["status"]=0;
    $data["msg"]="Unable to save. Exception. Please try again";
  }
  return $data;
}

public static function save_gl_groups($dev,$code)
{
$data=array();
try
{
$db = Factory::getConnection();
$db->beginTransaction();

$temp_code=uniqid($dev->uid);
$code->account_group=trim($code->account_group);

$statement = $db->prepare("INSERT INTO gl_groups(account_type,account_group,ip,ua,ekey,created_by,created_date,temp_code) VALUES(:account_type,:account_group,:ip,:ua,
  :ekey,:created_by,now(),:temp_code) ");

$statement->execute(array(
':ip'=>$dev->ip,
':created_by'=>$dev->username ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,
':account_type'=>$code->account_type,
':account_group'=>$code->account_group,
':temp_code'=>$temp_code
));

if ($statement->rowCount()){
  $data["status"]=1;
  $data["msg"]="Saved.";
} else{
  $data["status"]=0;
  $data["msg"]="Unable to save.";
}

$statement = $db->prepare("SELECT id from gl_groups where created_by=:uid and temp_code=:temp_code");
$statement->execute(array(':temp_code'=>$temp_code,
  ':uid'=>$dev->username));
$data["id"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT count(*) total1 FROM gl_groups 
  WHERE account_type=:account_type");
$statement->execute(array(':account_type'=>$code->account_type));
$data1=$statement->fetchAll(PDO::FETCH_ASSOC);

$group_code=(((int)$data1[0]["total1"]))*10;
$data["total1"]=$data1[0]["total1"];
$data["group_code"]=$group_code;

$statement = $db->prepare("UPDATE gl_groups SET code=:code where id=:id");
$statement->execute(array(':id'=>$data["id"][0]["id"],':code'=>$group_code));
if ($statement->rowCount()){
  $data["id_status"]=1;
  }else{
  $data["id_status"]=0;

  }

if($data["status"]==1 && $data["id_status"]==1)
{
  $db->commit();
}else{
  $db->rollBack();
  $data["status"]=0;
  $data["msg"]="Unable to save. Please try again";
}

$statement=null;
  }
  catch (Exception $e) {
    $data["emsg"]=$e->getMessage();
    $db->rollBack();
    $data["status"]=0;
    $data["msg"]="Unable to save. Exception. Please try again";
  }
  
  return $data;
}


public static function save_gl_subgroups($dev,$code)
{
$data=array();
try
{
$db = Factory::getConnection();
$db->beginTransaction();

$temp_code=uniqid($dev->uid);
$code->account_sub_group=trim($code->account_sub_group);

$statement = $db->prepare("INSERT INTO gl_subgroups(account_type,account_group,account_sub_group,ip,ua,ekey,created_by,created_date,temp_code,group_id) 
  VALUES(:account_type,:account_group,:account_sub_group,:ip,:ua,
  :ekey,:created_by,now(),:temp_code,:group_id) ");

$statement->execute(array(
':ip'=>$dev->ip,
':created_by'=>$dev->username ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,
':account_type'=>$code->account_type,
':account_group'=>$code->account_group,
':account_sub_group'=>$code->account_sub_group,
':temp_code'=>$temp_code,
':group_id'=>$code->group_id
));

if ($statement->rowCount()){
  $data["status"]=1;
  $data["msg"]="Saved.";
} else{
  $data["status"]=0;
  $data["msg"]="Unable to save.";
}

$statement = $db->prepare("SELECT id from gl_subgroups where created_by=:uid and temp_code=:temp_code");
$statement->execute(array(':temp_code'=>$temp_code,
  ':uid'=>$dev->username));
$data["id"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT count(*) total1 FROM gl_subgroups 
  WHERE account_type=:account_type and account_group=:account_group
   order by id desc");
$statement->execute(array(':account_type'=>$code->account_type,':account_group'=>$code->account_group));
$data1=$statement->fetchAll(PDO::FETCH_ASSOC);

$group_code=$data1[0]["total1"];
$group_code=self::setThreeDigit($group_code);
$data["group_code"]=$group_code;


$statement = $db->prepare("UPDATE gl_subgroups SET code=:code where id=:id");
$statement->execute(array(':id'=>$data["id"][0]["id"],':code'=>$group_code));
if ($statement->rowCount()){
  $data["id_status"]=1;
  }else{
  $data["id_status"]=0;

  }

if($data["status"]==1 && $data["id_status"]==1)
{
  $db->commit();
}else{
  $db->rollBack();
  $data["status"]=0;
  $data["msg"]="Unable to save. Please try again";
}

$statement=null;
  }
  catch (Exception $e) {
    $data["emsg"]=$e->getMessage();
    $db->rollBack();
    $data["status"]=0;
    $data["msg"]="Unable to save. Exception. Please try again";
  }
  
  return $data;
}

public static function setThreeDigit($v)
{
  $len=strlen($v);

if($len==1)
{
  $v="00".$v;
}else if($len==2)
{
  $v="0".$v;
}

return $v;
}


public static function setFourDigit($v)
{
  $len=strlen($v);

if($len==1)
{
  $v="000".$v;
}else if($len==2)
{
  $v="00".$v;
}else if($len==3)
{
  $v="0".$v;
}

return $v;
}

public static function get_gl_subgroups($dev,$code)
{
$data=array();
try
{
$db = Factory::getConnection();

$statement = $db->prepare("SELECT id,account_type,account_group,code,'0' edit FROM gl_groups WHERE account_type=:account_type and account_group=:account_group");

$statement->execute(array(':account_type'=>$code->account_type,
':account_group'=>$code->account_group));
$datas=$statement->fetchAll(PDO::FETCH_ASSOC);
$group_code=$datas[0]["code"];
$statement = $db->prepare("SELECT id,account_type,account_group,'$group_code' group_code,account_sub_group,code,'0' edit  FROM gl_subgroups WHERE account_type=:account_type and account_group=:account_group");

$statement->execute(array(':account_type'=>$code->account_type,
  'account_group'=>$code->account_group));
$data["info"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

}
?>