<?php


require("../config/dbconn.php");

class GRNDao
{


public static function save_auth_token_response($token,$app_key,$encrypted_app_key)
{
$data=array();
try
{
$db = Factory::getConnection();


$statement = $db->prepare("INSERT into auth_token_response(
app_key,encrypted_app_key,auth_token_response,expiry_time,created_date) 
values(:app_key,:encrypted_app_key,:auth_token_response,:expiry_time,now())");
$statement->execute(array(
':app_key'=>$app_key,
':encrypted_app_key'=>$encrypted_app_key,
':auth_token_response'=>json_encode($token),
':expiry_time'=>$token->Data->TokenExpiry
));

if ($statement->rowCount()){
  $data["status"]=1;
} else{
  $data["status"]=0;
}

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function save_page_views($dev,$pname,$method)
{
$data=0;
try
{
$db = Factory::getConnection();


$statement = $db->prepare("INSERT into page_views(
ip ,uid ,ua,ekey,esecret,method,page,tz) 
values(:ip ,:uid ,
:ua ,:ekey ,:esecret ,:method ,:page,:tz)");
$statement->execute(array(':ip'=>$dev->ip,':uid'=>$dev->uid ,
':ua'=>$dev->ua,
':tz'=>$dev->tz ,
':method'=>$method ,':esecret'=>$dev->esecret,':ekey'=>$dev->ekey,
':page'=>$pname));


$data=1;
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function save_irn0_response($dev,$c,$grn_response)
{
$data=array();
try
{
$db = Factory::getConnection();

$statement = $db->prepare("UPDATE mt_order_ar_header 
  SET irn_resp0=:irn_resp0,
  irn_resp0_time=now() 
  WHERE id=:id ");
$temp_code=uniqid($dev->uid);
$statement->execute(array(':id'=>$c->id,':irn_resp0'=>$grn_response));

    if ($statement->rowCount()){
    $data["upd_irn0_status"]=1;
  } else{
    $data["upd_irn0_status"]=0;
  }

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function save_irn1_response($dev,$c,$grn_response,$sqc,$irn,$ackdt,$ackno)
{
$data=array();
try
{
$db = Factory::getConnection();

$statement = $db->prepare("UPDATE mt_order_ar_header 
  SET irn_resp1=:irn_resp1,
  irn_resp1_time=now(),
  irn_no=:irn_no,
  ack_dt=:ack_dt,
  ack_no=:ack_no,
  qr_str=:qr_str
  WHERE id=:id ");
$temp_code=uniqid($dev->uid);
$statement->execute(array(':id'=>$c->id,':irn_resp1'=>$grn_response,':irn_no'=>$irn,':ack_dt'=>$ackdt,':ack_no'=>$ackno,':qr_str'=>$sqc));

    if ($statement->rowCount()){
    $data["upd_irn1_status"]=1;
  } else{
    $data["upd_irn1_status"]=0;
  }

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function save_irn0_response_cndn($dev,$c,$grn_response)
{
$data=array();
try
{
$db = Factory::getConnection();

$statement = $db->prepare("UPDATE mt_ar_trans  
  SET irn_resp0=:irn_resp0,
  irn_resp0_time=now() 
  WHERE id=:id ");
$temp_code=uniqid($dev->uid);
$statement->execute(array(':id'=>$c->id,':irn_resp0'=>$grn_response));

    if ($statement->rowCount()){
    $data["upd_irn0_status"]=1;
  } else{
    $data["upd_irn0_status"]=0;
  }

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function save_irn1_response_cndn($dev,$c,$grn_response,$sqc,$irn,$ackdt,$ackno)
{
$data=array();
try
{
$db = Factory::getConnection();

$statement = $db->prepare("UPDATE mt_ar_trans 
  SET irn_resp1=:irn_resp1,
  irn_resp1_time=now(),
  irn_no=:irn_no,
  ack_dt=:ack_dt,
  ack_no=:ack_no,
  qr_str=:qr_str
  WHERE id=:id ");
$temp_code=uniqid($dev->uid);
$statement->execute(array(':id'=>$c->id,':irn_resp1'=>$grn_response,':irn_no'=>$irn,':ack_dt'=>$ackdt,':ack_no'=>$ackno,':qr_str'=>$sqc));

    if ($statement->rowCount()){
    $data["upd_irn1_status"]=1;
  } else{
    $data["upd_irn1_status"]=0;
  }

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_einvoice_data($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$statement = $db->prepare("SELECT  
t1.id, DATE_FORMAT(t1.sub_ar_date, '%d/%m%/%Y') sub_ar_date, 
t1.sub_ar_doc_number,
t1.order_no,
t1.sub_ar_code,
t1.gst_percent,
(SELECT name from mt_business_partner where code=t1.sub_ar_code) customer,
(SELECT pan from mt_business_partner where code=t1.sub_ar_code) customer_pan,
(SELECT gstin from mt_business_partner where code=t1.sub_ar_code) customer_gstin,
(SELECT name from mt_business_partner where code=t1.sub_ar_code) customer,
(select address from mt_bp_address where bp_id=(select id from mt_business_partner where code=t1.sub_ar_code) and type='HQ') customer_address,
t1.sub_ar_currency, t1.sub_ar_l_amount, location_id, company_id, igst, cgst, sgst, bl_no 
from mt_order_ar_header t1
where t1.irn_resp1 is null
and id=:id ");
$statement->execute(array(':id'=>$c->id));
$data["dList"]=$statement->fetchAll(PDO::FETCH_ASSOC);
//and t1.gst_percent!=0

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function get_einvoice_data1($c)
{
$data=array();
try
{
$db = Factory::getConnection();

$statement = $db->prepare("SELECT  
t1.id, DATE_FORMAT(t1.sub_ar_date, '%d/%m%/%Y') sub_ar_date, 
t1.sub_ar_doc_number,
t1.order_no,
t1.sub_ar_code,
t1.gst_percent,
(SELECT name from mt_business_partner where code=t1.sub_ar_code) customer,
(SELECT pan from mt_business_partner where code=t1.sub_ar_code) customer_pan,
(SELECT gstin from mt_business_partner where code=t1.sub_ar_code) customer_gstin,
(SELECT name from mt_business_partner where code=t1.sub_ar_code) customer,
(select address from mt_bp_address where bp_id=(select id from mt_business_partner where code=t1.sub_ar_code) and type='HQ') customer_address,
t1.sub_ar_currency, t1.sub_ar_l_amount, location_id, company_id, igst, cgst, sgst, bl_no 
from mt_order_ar_header t1
where t1.irn_resp1 is null 
and sub_ar_doc_number=:id ");
$statement->execute(array(':id'=>$c));
$data["dList"]=$statement->fetchAll(PDO::FETCH_ASSOC);
//and t1.gst_percent!=0

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_gst_state($code)
{
$data=array();
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT state_name from gst_states where gst_code=:code");
$statement->execute(array(':code'=>$code));
$data["ginfo"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_customer_pincode($gstin)
{
$data=array();
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT zip from mt_bp_address where bp_id=(select id from mt_business_partner where gstin=:gstin AND status='ACTIVE') and type='HQ' ");
$statement->execute(array(':gstin'=>$gstin));
$data["ginfo"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_auth_token()
{
$data=array();
try
{
$db = Factory::getConnection();


$statement = $db->prepare("SELECT * from auth_token_response 
	where expiry_time>now() order by id desc");
$statement->execute();
$data=$statement->fetchAll(PDO::FETCH_ASSOC);
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function get_egrldinv_data($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$statement = $db->prepare("SELECT DATE_FORMAT(t1.grld_inv_date, '%d/%m%/%Y') cn_date,
t1.id,
t2.exl_upd_pk,
t2.status,
t2.f_no,
t2.l_date,
t2.ref,
t2.v_code,
t1.grld_inv_no cn_no,
t2.v_date,
t2.consignor,
t2.origin,
t1.payment_party consignee_code,
(select name from mt_business_partner where code=t1.payment_party) consignee,
(select legal_name from mt_business_partner where code=t1.payment_party) cln,
(select legal_name from mt_business_partner where code=t1.payment_party) sln,
t2.cd,
t2.dn,
t2.destination,
t2.description,
t2.truck_no,
t2.container_no,
t2.wt,
t2.freight1,
t2.size,
t2.ebox,
t2.sel_no,
t2.in_no,
t2.in_rs,
t2.transporter,
t2.vessel,
t2.emaster,
t2.pick_up,
t2.pol,
t2.pod,
t2.lr_no,
t2.lr_date,
t2.broker_name,
t2.nonagri_or_agri,
t2.consignor_pan_no,
t2.consignor_gstin,
(select address from mt_bp_address where bp_id=(select id from mt_business_partner where code=t2.consignor) and type='HQ') consignor_address,
t2.consignee_pan_no,
t2.consignee_gstin,
(select address from mt_bp_address where bp_id=(select id from mt_business_partner where code=t2.consignee) and type='HQ') consignee_address,
t2.ewaybill_date,
t2.ewaybill_no,
t2.bcg_no,
t2.bcg_date,
t2.bl_no,
t2.gta_mode,
t2.consignor_or_consignee,
t2.emode,
t2.hold_remarks,
t2.vessel_report_rate,
t2.gst_remarks,
t2.bill_remarks,
'CONSIGNEE' payment_from,
t2.order_from,
t2.collection_dn,
t2.collection_remarks,
t2.payment_terms_ksg,
t2.vreport_gujarat_transport,
t2.vreport_south_transport,
t2.vreport_other_charges_amt,
t2.vreport_other_charges_amt_remarks,
t2.pllp_or_jbm,
t2.tol,
t2.tod,
t2.freight2,
t2.gt,
t2.prefix_srno,
t2.principal_rate,
t2.ntsf,
t2.ttl_principal_rate,
(ifnull(t1.gr,0)+ifnull(t1.ld,0)) basic_amt,
t1.igst,
t1.cgst,
t1.sgst,
t2.pllp_final_invoice_amt,
t2.builty_rate,
t2.actual_receivable_rate,
t2.location_id,
t2.created_by,
t2.created_date,
t2.ip,
t2.ua,
t2.ekey,
t2.uid,
t2.temp_code,
'18' gst_percent,
t2.pol_upd_datetime,
t2.pol_remarks,
t2.pod_upd_datetime,
t2.pod_remarks,
t2.inv_pro,
t2.modified_date,
t2.modified_by,
t2.train_no,
t2.rtol,
t2.rtod,
t2.bill_party,
t2.bulk_cn_no,
t2.consignor_name,
t2.ewaybill_assignto,
'0' extra_transport,
t2.prodp_cn_no,
t2.order_no,
t2.pro_cn_no,
t2.del_date,
t2.tr_mode,
t2.cx_email_sent_date,
t2.cx_email_msg,
t2.cx_email_sent  
 FROM mt_delivery_planning t1
 left join mt_invoice_preparation t2
 on t1.cn_no=t2.cn_no 
 WHERE t1.id=:id ");
$statement->execute(array(':id'=>$c->id));
$data["dList"]=$statement->fetchAll(PDO::FETCH_ASSOC);


$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function get_ecndninv_data($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$statement = $db->prepare("SELECT DATE_FORMAT(art_doc_date, '%d/%m%/%Y') cn_date,
id,
art_company,
art_code consignee_code,
(select name from mt_business_partner where code=art_code) consignee,
(select legal_name from mt_business_partner where code=art_code) cln,
(select legal_name from mt_business_partner where code=art_code) sln,
'' consignor_pan_no,
'' consignor_gstin,
'' consignor_address,
(select pan from mt_business_partner where code=art_code) consignee_pan_no,
(select gstin from mt_business_partner where code=art_code) consignee_gstin,
(select address from mt_bp_address where bp_id=(select id from mt_business_partner where code=art_code) and type='HQ') consignee_address,
'CONSIGNEE' payment_from,
art_type,
art_number cn_no,
art_serial,
art_group,
art_base_type,
art_internal,
art_other_reference,
art_doc_date,
art_gl_date,
art_year,
art_period,
art_age_date,
art_dp_date,
art_currency,
art_ex_rate,
art_foreign_amount,
abs(art_local_amount) basic_amt,
art_foreign_balance,
art_local_balance,
art_balance_status,
art_description,
art_notes,
art_pdc_flag,
art_total_tax,
art_total_discount,
art_created_by,
art_created_on,
art_posted_by,
art_posted_on,
art_detail_1,
art_detail_2,
art_detail_3,
art_detail_4,
art_detail_5,
art_detail_6,
art_detail_7,
art_detail_8,
art_detail_9,
art_detail_10,

ifnull((select abs(aloc_local_amount) from mt_ar_allocation_details where aloc_doc_number=art_number and aloc_doc_type='OUTPUT IGST'),0) igst,
ifnull((select abs(aloc_local_amount) from mt_ar_allocation_details where aloc_doc_number=art_number and aloc_doc_type='OUTPUT SGST'),0) sgst,
ifnull((select abs(aloc_local_amount) from mt_ar_allocation_details where aloc_doc_number=art_number and aloc_doc_type='OUTPUT CGST'),0) cgst,
(select gst_percent from mt_ar_allocation_details where aloc_doc_number=art_number and aloc_doc_type in ('CREDIT NOTE','DEBIT NOTE') ) gst_percent,

order_no,
ref_inv_no,
ref_inv_date,
'0' extra_transport

 FROM mt_ar_trans
 WHERE id=:id ");
$statement->execute(array(':id'=>$c->id));
$data["dList"]=$statement->fetchAll(PDO::FETCH_ASSOC);


$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function save_irn1_response_grld($dev,$c,$grn_response,$sqc,$irn,$ackdt,$ackno)
{
$data=array();
try
{
$db = Factory::getConnection();

$statement = $db->prepare("UPDATE mt_delivery_planning  
  SET irn_resp1=:irn_resp1,
  irn_resp1_time=now(),
  irn_no=:irn_no,
  ack_dt=:ack_dt,
  ack_no=:ack_no,
  qr_str=:qr_str
  WHERE id=:id ");
$temp_code=uniqid($dev->uid);
$statement->execute(array(':id'=>$c->id,':irn_resp1'=>$grn_response,':irn_no'=>$irn,':ack_dt'=>$ackdt,':ack_no'=>$ackno,':qr_str'=>$sqc));

    if ($statement->rowCount()){
    $data["upd_irn1_status"]=1;
  } else{
    $data["upd_irn1_status"]=0;
  }

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function save_irn0_response_grld($dev,$c,$grn_response)
{
$data=array();
try
{
$db = Factory::getConnection();

$statement = $db->prepare("UPDATE mt_delivery_planning  
  SET irn_resp0=:irn_resp0,
  irn_resp0_time=now() 
  WHERE id=:id ");
$temp_code=uniqid($dev->uid);
$statement->execute(array(':id'=>$c->id,':irn_resp0'=>$grn_response));

    if ($statement->rowCount()){
    $data["upd_irn0_status"]=1;
  } else{
    $data["upd_irn0_status"]=0;
  }

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


}
?>