<?php

require("../config/dbconn.php");

class InvoiceDao

{


public static function save_page_views($dev,$pname,$method)
{
$data=0;
try
{
$db = Factory::getConnection();


$statement = $db->prepare("INSERT into page_views(
ip ,uid ,ua,ekey,esecret,method,page,tz) 
values(:ip ,:uid ,
:ua ,:ekey ,:esecret ,:method ,:page,:tz)");
$statement->execute(array(':ip'=>$dev->ip,':uid'=>$dev->uid ,
':ua'=>$dev->ua,
':tz'=>$dev->tz ,
':method'=>$method ,':esecret'=>$dev->esecret,':ekey'=>$dev->ekey,
':page'=>$pname));


$data=1;
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function update_excel_upload($dev,$c,$voyage,$pod)
{
$data=array();
try
{
$db = Factory::getConnection();


$statement = $db->prepare("UPDATE mt_excel_upload1 SET
  status='CONVERTED',
  voyage=:voyage,
  pod=:pod,
  no_of_containers_updt=(SELECT COUNT(*) from mt_invoice_preparation1 where exl_upd_pk=:id)
  where id=:id");

$statement->execute(array(':id'=>$c->file_id, ':voyage'=>$voyage, ':pod'=>$pod));

    if ($statement->rowCount()){
    $data["status"]=1;
  } else{
    $data["status"]=0;
  }

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function update_excel_upload_error($dev,$c,$error_containers)
{
$data=array();
try
{
$db = Factory::getConnection();


$statement = $db->prepare("UPDATE mt_excel_upload1 SET
  status='ERROR',
  remarks=:remarks,
  no_of_containers_updt=(SELECT COUNT(*) from mt_invoice_preparation1 where exl_upd_pk=:id)
  where id=:id");

$statement->execute(array(':id'=>$c->file_id,':remarks'=>$error_containers));

    //if ($statement->rowCount()){
    //$data["status"]=1;
  //} else{
    $data["status"]=0;
  //}

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function save_excel_upload($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();


$statement = $db->prepare("INSERT into mt_excel_upload1(

file_name,file_url,uploaded_by,status,
location_id,
  ip,uid, ua,ekey,created_by,created_date,temp_code) 
values(

:file_name,:file_url,:uploaded_by,'UPLOADED',
'$dev->location',
:ip ,:uid ,:ua ,:ekey,'$dev->username',now(),:temp_code)");
$temp_code=uniqid($dev->uid);
$statement->execute(array(':ip'=>$dev->ip,':uid'=>$dev->uid ,':ua'=>$dev->ua,':ekey'=>$dev->ekey,

':file_name'=>$c["file_name"],
':file_url'=>$c["file_url"],

':uploaded_by'=>$dev->username,

':temp_code'=>$temp_code
));

    if ($statement->rowCount()){
    $data["status"]=1;
  } else{
    $data["status"]=0;
  }
$data["temp_code"]=$temp_code;

  $statement = $db->prepare("SELECT id from mt_excel_upload1 where 
    uid=:uid and temp_code=:temp_code");
  $statement->execute(array(':temp_code'=>$temp_code,
    ':uid'=>$dev->uid));
  $op=$statement->fetchAll(PDO::FETCH_ASSOC);

  $fid=self::setFourDigit($op[0]["id"]);

$on="FILE/".$dev->username."/".date("Y")."/".date('m')."/".$fid; //$c->from_port."/".$fid;

 $statement = $db->prepare("UPDATE mt_excel_upload1 
  SET doc_no=:ond where id=:id");
  $statement->execute(array(':id'=>$op[0]["id"],':ond'=>$on));
  
    if ($statement->rowCount()){
    $data["eid_status"]=1;
  } else{
    $data["eid_status"]=0;
  }

$data["file_no"]=$on;


$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function setFourDigit($v)
{
  $len=strlen($v);

if($len==1)
{
  $v="000".$v;
}else if($len==2)
{
  $v="00".$v;
}else if($len==3)
{
  $v="0".$v;
}

return $v;
}

public static function setFiveDigit($v)
{
  $len=strlen($v);

if($len==1)
{
  $v="0000".$v;
}else if($len==2)
{
  $v="000".$v;
}else if($len==3)
{
  $v="00".$v;
}else if($len==4)
{
  $v="0".$v;
}

return $v;
}

public static function check_containers_invoiced($dev,$c,$cnt)
{
$data=array();
try
{
$db = Factory::getConnection();

//Get no.of consignees
$statement = $db->prepare("SELECT * from mt_invoice_preparation
where container_no=:container_no and vessel=:vessel and status='FINAL' ");
$statement->execute(array(':container_no'=>$cnt->container_no,':vessel'=>$cnt->vessel));
$data["countList"]=$statement->fetchAll(PDO::FETCH_ASSOC);

if(count($data["countList"])!=0)
{
  $data["error_status"]=1;
}
else
{
  $data["error_status"]=0;
}

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function check_containers_gatein_complete($dev,$c,$cnt)
{
$data=array();
try
{
$db = Factory::getConnection();

//Get no.of consignees
$statement = $db->prepare("SELECT consignee from mt_loaded_gatein_party
where lg_pk=(select t1.id from mt_loaded_gatein t1 
             left join mt_order t2 
             on t1.order_no=t2.order_no
             left join mt_enquiry t3
             on t2.enquiry_no=t3.enq_no where t1.container_no=:container_no and t3.pod=:pod
             order by t1.id desc limit 1 ) 
group by consignee ");
$statement->execute(array(':container_no'=>$cnt->container_no,':pod'=>$cnt->pod));
$data["countList"]=$statement->fetchAll(PDO::FETCH_ASSOC);

if(count($data["countList"])==0)
{
  $data["error_status"]=1;
}
else
{
  $data["error_status"]=0;
}

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function check_voyage_entry_complete($dev,$c,$cnt)
{
$data=array();
try
{
$db = Factory::getConnection();

//Get voyage entry
$statement = $db->prepare("SELECT * from 
( SELECT :vessel vessel, t2.pol, t3.pod, t4.liner FROM mt_loaded_gatein t1
left join mt_order t2
on t1.order_no=t2.order_no
left join mt_enquiry t3
on t2.enquiry_no=t3.enq_no
left join mt_loading_receipt t4
on t4.lr_no=t1.lr_no
where t1.container_no=:container_no ) ot1
left join mt_voyage ot2
on ot1.vessel=ot2.voyage
where ot1.pol=ot2.port and ot1.pod=ot2.next_port and ot1.liner=ot2.liner ");
$statement->execute(array(':vessel'=>$cnt->vessel,':container_no'=>$cnt->container_no));
$data["voyageList"]=$statement->fetchAll(PDO::FETCH_ASSOC);

if(count($data["voyageList"])==0)
{
  $data["error_status"]=1;
}
else
{
  $data["error_status"]=0;
}

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function check_ledger_code($dev,$c,$cnt)
{
$data=array();
try
{
$db = Factory::getConnection();

//Get voyage entry
$statement = $db->prepare(" SELECT t1.id, t2.tr_mode, t3.gst_remarks  
             from mt_loaded_gatein t1 
             left join mt_order t2 
             on t1.order_no=t2.order_no
             left join mt_enquiry t3
             on t2.enquiry_no=t3.enq_no 
             where t1.container_no=:container_no and t3.pod=:pod
             order by t1.id desc limit 1 ");
$statement->execute(array(':container_no'=>$cnt->container_no,':pod'=>$cnt->pod));
$data["info"]=$statement->fetchAll(PDO::FETCH_ASSOC);
$tr_mode=$data["info"][0]["tr_mode"];
$gst_remarks=$data["info"][0]["gst_remarks"];

$statement = $db->prepare("SELECT code, ac_description  from mt_general_ledger  
  where tr_mode=:tr_mode and gst_remarks=:gst_remarks ");
$statement->execute(array(':tr_mode'=>$tr_mode, ':gst_remarks'=>$gst_remarks));
$data["ledgerList"]=$statement->fetchAll(PDO::FETCH_ASSOC);

if(count($data["ledgerList"])==0)
{
  $data["error_status"]=1;
}
else
{
  $data["error_status"]=0;
}

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function save_excel_upload_data($dev,$c,$cnt)
{
$data=array();
try
{
$db = Factory::getConnection();

//Get no.of consignees
$statement = $db->prepare("SELECT consignee from mt_loaded_gatein_party
where lg_pk=(select t1.id from mt_loaded_gatein t1 
             left join mt_order t2 
             on t1.order_no=t2.order_no
             left join mt_enquiry t3
             on t2.enquiry_no=t3.enq_no where t1.container_no=:container_no and t3.pod=:pod 
             order by t1.id desc limit 1) 
group by consignee ");
$statement->execute(array(':container_no'=>$cnt->container_no,':pod'=>$cnt->pod));
$data["countList"]=$statement->fetchAll(PDO::FETCH_ASSOC);
//echo 'q1';

  for($i=0;$i<count($data["countList"]);$i++)
  {
    $cng=$data["countList"][$i]["consignee"];
    $loaded_weight=0;
    $shipper="";
    $consignor_pan_no="";
    $consignor_gstin="";
    $consignor_address="";
    $consignor_name="";

    $consignee_pan_no="";
    $consignee_gstin="";
    $consignee_address="";  
    $consignee_name="";

    $ref_inv_no="";
    $ref_inv_amount=0;
    $no_of_pkgs=0;
    $ewaybill_no="";
    $ewaybill_date="";
    $ewaybill_assignto="";
    $extra_transport=0;

    //Get ewb detail
    $statement = $db->prepare("SELECT t1.ewb_no ewaybill_no,
        date_format(STR_TO_DATE(t2.validupto, '%d/%m/%Y'),'%d-%m-%Y') ewaybill_validity,
        t3.name ewaybill_assignto    
        from mt_loaded_gatein_ewb t1
        left join mt_ewb_master t2
        on t1.ewb_no=t2.ewbno
        left join mt_business_partner t3
        on t1.ewb_assignto=t3.code
        where t1.lg_pk=(select t1.id from mt_loaded_gatein t1 
             left join mt_order t2 
             on t1.order_no=t2.order_no
             left join mt_enquiry t3
             on t2.enquiry_no=t3.enq_no where t1.container_no=:container_no and t3.pod=:pod 
             order by t1.id desc limit 1) ");
    $statement->execute(array(':container_no'=>$cnt->container_no, ':pod'=>$cnt->pod ));
    $data["ewbList"]=$statement->fetchAll(PDO::FETCH_ASSOC);

      for($e=0;$e<count($data["ewbList"]);$e++)
      {
        $ewb=$data["ewbList"][$e];
        if($e==0)
        {
          $ewaybill_no=$ewb["ewaybill_no"];
          $ewaybill_date=$ewb["ewaybill_validity"];
          $ewaybill_assignto=$ewb["ewaybill_assignto"];
        }
        else
        {
          $ewaybill_no=$ewaybill_no.'/'.$ewb["ewaybill_no"];          
          $ewaybill_date=$ewaybill_date.'/'.$ewb["ewaybill_validity"];          
          $ewaybill_assignto=$ewaybill_assignto.'/'.$ewb["ewaybill_assignto"];
        }
      }
    //END ewb detail

    //Get each consignee wise group detail
    $statement = $db->prepare("SELECT t1.consignee,t2.pan cpan,t2.gstin cgstin,(select address from mt_bp_address where bp_id=t2.id and type='HQ') caddress,t2.name cname,
  t1.loaded_weight,t1.shipper,t3.pan span,t3.gstin sgstin,(select address from mt_bp_address where bp_id=t3.id and type='HQ') saddress, t3.name sname,
      ref_inv_no, ref_inv_amount,no_of_pkgs,ewaybill_no,
      date_format(ewaybill_validity,'%d-%m-%Y') ewaybill_validity,
       t4.name ewaybill_assignto   
      from mt_loaded_gatein_party t1
      left join mt_business_partner t2
      on t1.consignee=t2.code
      left join mt_business_partner t3
      on t1.shipper=t3.code
      left join mt_business_partner t4
      on t1.ewaybill_assignto=t4.code      
    where lg_pk=(select t1.id from mt_loaded_gatein t1 
             left join mt_order t2 
             on t1.order_no=t2.order_no
             left join mt_enquiry t3
             on t2.enquiry_no=t3.enq_no where t1.container_no=:container_no and t3.pod=:pod 
             order by t1.id desc limit 1) 
    and consignee=:consignee ");
    $statement->execute(array(':container_no'=>$cnt->container_no, ':consignee'=>$cng,':pod'=>$cnt->pod ));
    $data["cngList"]=$statement->fetchAll(PDO::FETCH_ASSOC);
//echo 'q2';

      for($j=0;$j<count($data["cngList"]);$j++)
      {
        $r=$data["cngList"][$j];
        $loaded_weight=$loaded_weight+(float)$r["loaded_weight"];
        $ref_inv_amount=$ref_inv_amount+(int)$r["ref_inv_amount"];
        $no_of_pkgs=$no_of_pkgs+(int)$r["no_of_pkgs"];

        $consignee_pan_no=$r["cpan"];
        $consignee_gstin=$r["cgstin"];
        $consignee_address=$r["caddress"];
        $consignee_name=$r["cname"];

        if($j==0)
        {
          $shipper=$r["shipper"];
          $consignor_pan_no=$r["span"];
          $consignor_gstin=$r["sgstin"];
          $consignor_address=$r["saddress"];
          $consignor_name=$r["sname"];

          $ref_inv_no=$r["ref_inv_no"];         
          //$ewaybill_no=$r["ewaybill_no"];
          //$ewaybill_date=$r["ewaybill_validity"];
          //$ewaybill_assignto=$r["ewaybill_assignto"];
        }
        else
        {
          $shipper=$shipper.'/'.$r["shipper"];
          $consignor_pan_no=$consignor_pan_no.'/'.$r["span"];
          $consignor_gstin=$consignor_gstin.'/'.$r["sgstin"];
          $consignor_address=$consignor_address.'/'.$r["saddress"];
          $consignor_name=$consignor_name.'/'.$r["sname"];

          $ref_inv_no=$ref_inv_no.'/'.$r["ref_inv_no"];         
          //$ewaybill_no=$ewaybill_no.'/'.$r["ewaybill_no"];          
          //$ewaybill_date=$ewaybill_date.'/'.$r["ewaybill_validity"];          
          //$ewaybill_assignto=$ewaybill_assignto.'/'.$r["ewaybill_assignto"];
        }
      }

    //FETCH STD BUILTY RATE
    $frate1=0;
    $frate2=0;
    $std_builty=0;

    $statement = $db->prepare(" SELECT std_builty from mt_business_partner where code=:code");
    $statement->execute(array(':code'=>$cng));
    $op=$statement->fetchAll(PDO::FETCH_ASSOC);

    if ($statement->rowCount()){
      if (is_null($op[0]["std_builty"])){
      $std_builty=0;
      }else {
      $std_builty=(int)$op[0]["std_builty"];
      }

    }

    //Fetch data for weight based rate1,rate2
    $statement = $db->prepare(" SELECT t1.rate,t1.rate2, t1.payment_from, 
      (select sum(loaded_weight) from mt_loaded_gatein_party where lg_pk=t3.id) total_weight 
      from mt_enquiry t1
      left join mt_order t2
      on t1.enq_no=t2.enquiry_no
      left join mt_loaded_gatein t3
      on t2.order_no=t3.order_no
      where t3.container_no=:container_no and t1.pod=:pod 
      order by t3.id desc limit 1 ");
    $statement->execute(array(':container_no'=>$cnt->container_no,':pod'=>$cnt->pod ));
    $data["rateList"]=$statement->fetchAll(PDO::FETCH_ASSOC);
    $rate1=$data["rateList"][0]["rate"];
    $rate2=$data["rateList"][0]["rate2"];
    $total_weight=$data["rateList"][0]["total_weight"];
    $payment_from=$data["rateList"][0]["payment_from"];
//echo 'q3';

    //CHECK BILL PARTY
    $bill_party=$consignee_name;
    if($payment_from=='SHIPPER'){
      $bill_party=$consignor_name;
    }

    //APPLY STD BUILTY RATE
    if($std_builty>0){
      $frate1=$std_builty;
      $frate2=$rate1-$std_builty;
    }else {
      $frate1=$rate1;
      $frate2=$rate2;
    }

    //CALCULATE Weight based Rate1, Rate2
    $rate1_perton=(float)$frate1/$total_weight;
    $crate1=(float)$loaded_weight*$rate1_perton;

    $rate2_perton=(float)$frate2/$total_weight;
    $crate2=(float)$loaded_weight*$rate2_perton;

// echo 'loaded_weight: '.$loaded_weight;
// echo 'rate1_perton: '.$rate1_perton;
// echo 'rate2_perton: '.$rate2_perton;
// echo 'std_builty: '.$std_builty;
// echo 'frate1: '.$frate1;
// echo 'frate2: '.$frate2;
// echo 'crate1: '.$crate1;
// echo 'crate2: '.$crate2;

    //FETCH OLD PROFORM NO 
    $pro_cn_no="";
    $statement = $db->prepare(" SELECT cn_no from mt_invoice_preparation
    where container_no=:container_no and vessel=:vessel 
    and consignee=:consignee 
    and status='PROFORMA' and cn_no is not null 
    order by id desc ");
    $statement->execute(array(':container_no'=>$cnt->container_no,
      ':vessel'=>$cnt->vessel,
      ':consignee'=>$cng ));
    $data["proList"]=$statement->fetchAll(PDO::FETCH_ASSOC);
    if ($statement->rowCount()){
          if (is_null($data["proList"][0]["cn_no"])){
          $pro_cn_no="";
          }else {
          $pro_cn_no=$data["proList"][0]["cn_no"];
          }

        } 

    //UPDATE OLD RECORDS CLOSED - SAME CONTAINER/SAME VESSEL/SAME CONSIGNEE
    $statement = $db->prepare("UPDATE mt_invoice_preparation1 
    SET status='CLOSED'  
    where container_no=:container_no and vessel=:vessel and consignee=:consignee 
    and status!='FINAL' ");
    $statement->execute(array(':container_no'=>$cnt->container_no,
      ':vessel'=>$cnt->vessel,
      ':consignee'=>$cng));

    if ($statement->rowCount()){
    $data["upd_closed_status"]=1;
    } else{
      $data["upd_closed_status"]=0;
    }

    //FETCH PROFORM NO WITH DEL_PLAN
    $prodp_cn_no="";
    $statement = $db->prepare(" SELECT cn_no from mt_delivery_planning
    where container_no=:container_no and vessel=:vessel 
    and consignee=:consignee ");
    $statement->execute(array(':container_no'=>$cnt->container_no,
      ':vessel'=>$cnt->vessel,
      ':consignee'=>$cng ));
    $data["prodpList"]=$statement->fetchAll(PDO::FETCH_ASSOC);
    if ($statement->rowCount()){
          if (is_null($data["prodpList"][0]["cn_no"])){
          $prodp_cn_no="";
          }else {
          $prodp_cn_no=$data["prodpList"][0]["cn_no"];
          }

        }    

    //EXTRA TRANSPORT    
    $statement = $db->prepare(" SELECT sum(rate_cost) extra_transport from mt_order_cost where order_id=(select id from mt_order where order_no=(select t1.order_no from mt_loaded_gatein t1 
             left join mt_order t2 
             on t1.order_no=t2.order_no
             left join mt_enquiry t3
             on t2.enquiry_no=t3.enq_no where t1.container_no=:container_no and t3.pod=:pod  order by t1.id desc limit 1)) and charge_desc in ('3PL', 'ETC') ");
    $statement->execute(array(':container_no'=>$cnt->container_no,':pod'=>$cnt->pod ));
    $data["transportList"]=$statement->fetchAll(PDO::FETCH_ASSOC);
    if ($statement->rowCount()){
          if (is_null($data["transportList"][0]["extra_transport"])){
          $extra_transport=0;
          }else {
          $extra_transport=(int)$data["transportList"][0]["extra_transport"];
          }

        }
//echo 'q4';

    //Insert each consignee one row
    $statement = $db->prepare("INSERT into mt_invoice_preparation1(
    exl_upd_pk, status, container_no, vessel, pod, 
    consignor, consignee, bill_party, wt, in_no, in_rs, ebox, ewaybill_no, ewaybill_date, 
    ewaybill_assignto, 
    consignor_pan_no,
    consignor_gstin,
    consignor_address,
    consignor_name,
    consignee_pan_no,
    consignee_gstin,
    consignee_address,
    freight1,
    freight2,
    extra_transport,
    prodp_cn_no,
    pro_cn_no,
     location_id, ip,uid, ua,ekey,created_by,created_date,temp_code) 
    values(:exl_upd_pk,'DRAFT',:container_no, :vessel, :pod, 
    :consignor, :consignee,:bill_party, :wt, :in_no, :in_rs, :ebox, :ewaybill_no, :ewaybill_date,
    :ewaybill_assignto,
    :consignor_pan_no,
    :consignor_gstin,
    :consignor_address,
    :consignor_name,
    :consignee_pan_no,
    :consignee_gstin,
    :consignee_address,
    :freight1,
    :freight2,
    :extra_transport,
    :prodp_cn_no,
    :pro_cn_no,
    '$dev->location',:ip,:uid,:ua,:ekey,'$dev->username',now(),:temp_code)");
    $temp_code=uniqid($dev->uid);
    
    //var_dump($statement->debugDumpParams());

    $statement->execute(array(':ip'=>$dev->ip,':uid'=>$dev->uid,':ua'=>$dev->ua,':ekey'=>$dev->ekey,
    ':exl_upd_pk'=>$c->file_id,
    ':container_no'=>$cnt->container_no,
    ':vessel'=>$cnt->vessel,
    ':pod'=>$cnt->pod,
    ':consignor'=>$shipper,
    ':consignee'=>$cng,
    ':bill_party'=>$bill_party,
    ':wt'=>$loaded_weight,
    ':in_no'=>$ref_inv_no,
    ':in_rs'=>$ref_inv_amount,
    ':ebox'=>$no_of_pkgs,
    ':ewaybill_no'=>$ewaybill_no,
    ':ewaybill_date'=>$ewaybill_date,
    ':ewaybill_assignto'=>$ewaybill_assignto,
    ':consignor_pan_no'=>$consignor_pan_no,
    ':consignor_gstin'=>$consignor_gstin,
    ':consignor_address'=>$consignor_address,
    ':consignor_name'=>$consignor_name,
    ':consignee_pan_no'=>$consignee_pan_no,
    ':consignee_gstin'=>$consignee_gstin,
    ':consignee_address'=>$consignee_address,

    ':freight1'=>$crate1,
    ':freight2'=>$crate2,
    ':extra_transport'=>$extra_transport,
    ':prodp_cn_no'=>$prodp_cn_no,
    ':pro_cn_no'=>$pro_cn_no,

    ':temp_code'=>$temp_code));
    //var_dump($statement->debugDumpParams());

        if ($statement->rowCount()){
        $data["status"]=1;
      } else{
        $data["status"]=0;
      }
  }




$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_excel_download_data($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$statement = $db->prepare("SELECT 
id, exl_upd_pk, status, container_no, vessel, pod, 
    consignor, 
    consignor_pan_no,
    consignor_gstin,
    consignor_address,
    consignor_name,

    consignee,
    consignee_pan_no,
    consignee_gstin,
    consignee_address,
    bill_party, wt, in_no, in_rs, ebox, ewaybill_no, ewaybill_date, ewaybill_assignto   
 FROM mt_invoice_preparation1 
 WHERE exl_upd_pk=:exl_upd_pk");
$statement->execute(array(':exl_upd_pk'=>$c->file_id));
$data["dList"]=$statement->fetchAll(PDO::FETCH_ASSOC);

//echo 'select 1';

  for($i=0;$i<count($data["dList"]);$i++)
  {
    $r=$data["dList"][$i];

    //get t1,t2,t3 data
    $statement = $db->prepare("SELECT 
  t1.id,
    t1.form_no, 
    t3.assign_date, 
    t1.portin_date, 
    t4.shipper, 
    t3.origin, 
    t4.consignee, 
    t3.destination, 
    t1.cargo_desc, 
    t2.truck_no, 
    t5.loaded_weight,
    t2.container_size_type, 
    t2.seal_no, 
    t5.ref_inv_no shipper_invoice_no,
    t5.ref_inv_amount shipper_invoice_amount, 
    ifnull((select name from mt_business_partner where code=t2.transporter limit 1),t2.transporter) transporter,
    t2.liner,
    t3.pol, 
    t4.pod, 
    t2.lr_no, 
    t2.mt_pickup_datetime,
    t5.ewaybill_validity,
    t5.ewaybill_no,
    t5.ewaybill_assignto,
    t4.credit_days,
    t4.salesman,
    t4.rate,
    t4.rate2,
    t4.gst_remarks,
    t5.no_of_pkgs,
    t2.liner,
    t2.lr_no,
    t2.mt_pickup_datetime,
    t3.broker,
    t4.payment_from,
    t1.train_no,
    t1.rtol,
    t1.rtod,
    t3.order_no,
    t3.tr_mode         
    FROM mt_loaded_gatein t1
    left join mt_loading_receipt t2
    on t1.lr_no=t2.lr_no
    left join mt_order t3
    on t2.order_no=t3.order_no
    left join mt_enquiry t4 
    on t3.enquiry_no=t4.enq_no 
    left join mt_loaded_gatein_party t5
    on t5.lg_pk=t1.id
    WHERE t2.container_no=:container_no and t4.pod=:pod 
    order by t1.id desc limit 1 ");

    $statement->execute(array(':container_no'=>$r["container_no"],':pod'=>$r["pod"]));
    $data["t1t2t3"]=$statement->fetchAll(PDO::FETCH_ASSOC);

//echo 'select 2';

    if ($statement->rowCount()){
  
    $data["select_status"]=1;
 
    $r1=$data["t1t2t3"][0];
    //update invoice preparation
    $oq="UPDATE mt_invoice_preparation1 
    SET f_no=:f_no,
    l_date=:l_date,
    consignor=:consignor,
    origin=:origin,
    consignee=:consignee,
    bill_party=:bill_party,
    destination=:destination,
    description=:description,
    truck_no=:truck_no,
    wt=:wt,
    size=:size,
    sel_no=:sel_no,
    in_no=:in_no,
    in_rs=:in_rs,
    transporter=:transporter,
    pol=:pol,
    pod=:pod,
    ewaybill_date=:ewaybill_date,
    ewaybill_no=:ewaybill_no,
    ewaybill_assignto=:ewaybill_assignto,
    emaster=:emaster,
    cd=:cd,
    collection_dn=:collection_dn,

    builty_rate=:builty_rate,
    actual_receivable_rate=:actual_receivable_rate,
    gst_remarks=:gst_remarks,
    ebox=:ebox,
    lr_no=:lr_no,
    lr_date=:lr_date,
    broker_name=:broker_name,
    payment_from=:payment_from,
    train_no=:train_no,
    rtol=:rtol,
    rtod=:rtod,
    order_no=:order_no, 
    tr_mode=:tr_mode  
    WHERE id=:id";
//    freight1=:freight1,
//    freight2=:freight2,

      $statement = $db->prepare($oq);
      $statement->execute(array(
      ':f_no'=>$r1["form_no"],
      ':l_date'=>$r1["assign_date"],
      ':consignor'=>$r["consignor"],
      ':origin'=>$r1["origin"],
      ':consignee'=>$r["consignee"],
      ':bill_party'=>$r["bill_party"],
      ':destination'=>$r1["destination"],
      ':description'=>$r1["cargo_desc"],
      ':truck_no'=>$r1["truck_no"],
      ':wt'=>$r["wt"],
      ':size'=>$r1["container_size_type"],
      ':sel_no'=>$r1["seal_no"],
      ':in_no'=>$r["in_no"],
      ':in_rs'=>$r["in_rs"],
      ':transporter'=>$r1["transporter"],
      ':pol'=>$r1["pol"],
      ':pod'=>$r1["pod"],

      ':ewaybill_date'=>$r["ewaybill_date"],
      ':ewaybill_no'=>$r["ewaybill_no"],
      ':ewaybill_assignto'=>$r["ewaybill_assignto"],
      ':emaster'=>$r1["liner"],
      ':cd'=>$r1["credit_days"],
      ':collection_dn'=>$r1["salesman"],

      ':builty_rate'=>$r1["rate"],
      ':actual_receivable_rate'=>$r1["rate2"],
      ':gst_remarks'=>$r1["gst_remarks"],
      ':ebox'=>$r["ebox"],
      ':lr_no'=>$r1["lr_no"],
      ':lr_date'=>$r1["mt_pickup_datetime"],
      ':broker_name'=>$r1["broker"],
      ':payment_from'=>$r1["payment_from"],
      ':train_no'=>$r1["train_no"],
      ':rtol'=>$r1["rtol"],
      ':rtod'=>$r1["rtod"],
      ':order_no'=>$r1["order_no"],
      ':tr_mode'=>$r1["tr_mode"],
      ':id'=>$r["id"]
      ));

        if ($statement->rowCount()){
          $data["upd_status"]=1;
        } else{
          $data["upd_status"]=0;
        }
     } 
     //      ':freight1'=>$r1["rate"],
     // ':freight2'=>$r1["rate2"],
      //$data["upd_status"]=$statement->fetchAll(PDO::FETCH_ASSOC);
//echo 'update 1';

  }

//Get updated invoice preparation data
$statement = $db->prepare("SELECT 
id, exl_upd_pk, container_no, vessel, pol, pod, f_no,
    date_format(l_date,'%d-%m-%Y') l_date,
    consignor,
    origin,
    consignee,
    destination,
    description,
    truck_no,
    wt,
    size,
    sel_no,
    in_no,
    in_rs,
    transporter,
    consignor_pan_no,
    consignor_gstin,
    consignor_address,
    consignee_pan_no,
    consignee_gstin,
    consignee_address,
    ewaybill_date,
    ewaybill_no,
    '' inv_pro,
    '' gst_percent,
    emaster,
    cd,
    collection_dn,
    freight1 rate1,
    freight2 rate2,
    gst_remarks,
    ebox,
    lr_no,
    date_format(lr_date,'%d-%m-%Y') lr_date,
    broker_name,
    payment_from,
    train_no,
    rtol,
    rtod,
    bcg_no,
    date_format(bcg_date,'%d-%m-%Y') bcg_date,
    bill_party,
    consignor_name, 
    (SELECT name from mt_business_partner where code=t1.consignee) consignee_name,
    order_no,
    (SELECT rate_cost FROM mt_order_cost
    where order_id=(select id from mt_order where order_no=t1.order_no) and inc_in_builty=1 and charge_desc='FMC' limit 1) 'FMC',
    (SELECT rate_cost FROM mt_order_cost
    where order_id=(select id from mt_order where order_no=t1.order_no) and inc_in_builty=1 and charge_desc='SMC' limit 1) 'SMC',
    (SELECT rate_cost FROM mt_order_cost
    where order_id=(select id from mt_order where order_no=t1.order_no) and inc_in_builty=1 and charge_desc='3PL' limit 1) '3PL',    
    '' del_date,
    tr_mode,
    case when t1.payment_from='CONSIGNEE' THEN
 (select email1 from mt_bp_address where bp_id=(select id from mt_business_partner where code=t1.consignee) and type='HQ')
 ELSE
 (select email1 from mt_bp_address where bp_id=(select id from mt_business_partner where code=t1.consignor) and type='HQ')
 end as 'bp_email',
 ewaybill_assignto              
 FROM mt_invoice_preparation1 t1
 WHERE exl_upd_pk=:exl_upd_pk");
$statement->execute(array(':exl_upd_pk'=>$c->file_id));
$data["dList"]=$statement->fetchAll(PDO::FETCH_ASSOC);

//echo 'select 3';

  if ($statement->rowCount()){
    $data["status"]=1;
  } else{
    $data["status"]=0;
  }

//echo  $data["status"];
//echo $data;

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_excel_upload_list()
{
$data=false;
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT 
id,
doc_no,
file_name,
file_url,
uploaded_by,
uploaded_date,
no_of_containers_updt,
liner,
voyage,
pol,
pod,
status,
no_of_proformas,
no_of_finals,
remarks
  from mt_excel_upload1 
  where status in ('UPLOADED','ERROR','CONVERTED')
  and uploaded_date > (DATE(NOW()) - INTERVAL 7 DAY) 
  order by id desc ");
$statement->execute();
$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_verified_excel_upload_list()
{
$data=false;
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT 
id,
id doc_no,
file_name,
uploaded_by,
uploaded_date,
no_of_containers_updt,
liner,
voyage,
pol,
pod,
status,
no_of_proformas,
no_of_finals,
no_of_bulk,
remarks,
email_date,
pro_status,  
bulk_status   
  from mt_excel_upload
  where status in ('VERIFIED','INVOICED')
  and uploaded_date > (DATE(NOW()) - INTERVAL 7 DAY) 
   order by id desc ");
$statement->execute();
$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function search_invoice_list($dev,$v)
{
$data=false;
try
{
$db = Factory::getConnection();

//FETCH USER RIGHTS
$view_type="";
$location_id="";
$addl_location_id="";

$statement = $db->prepare(" SELECT view_type,location_id,addl_location_id FROM user_master 
WHERE username=:username ");
$statement->execute(array(':username'=>$dev->username));
$op=$statement->fetchAll(PDO::FETCH_ASSOC);

$view_type=$op[0]["view_type"];
$location_id=$op[0]["location_id"];
$addl_location_id=$op[0]["addl_location_id"];

$aq='';
if($view_type=='USER'){
  $aq=" AND (t1.pod='$location_id' or t1.location_id='$location_id' 
  or t1.pod in ($addl_location_id) or t2.location_id='$location_id' ) 
   AND (t1.payment_from='CONSIGNEE' or (t1.payment_from='SHIPPER' and t1.pol='$location_id') ) ";
}else if($view_type=='RSTD_USER'){
  $aq=" AND t1.pod in ($addl_location_id)  AND t1.payment_from='CONSIGNEE' ";
 // echo 'if rstd_user';
}else {
  $aq=" ";
  //echo 'if admin';
}

$statement = $db->prepare("SELECT 
t1.id,
t1.temp_code,
t1.exl_upd_pk,
t1.cn_no,
t1.order_no,
t1.container_no,
t1.bill_party consignee,
t1.pol,
t1.pod,
t1.emaster,
t1.vessel,
t1.gst_percent,
'FREIGHT' invoice_type  
  from mt_invoice_preparation t1
  left join mt_loading_receipt t2
  on t1.lr_no=t2.lr_no  
  where t1.status='FINAL' and 
  (t1.cn_no like ? or 
  t1.bill_party like ? or 
  t1.pol like ? or t1.pod like ? or t1.emaster like ? or t1.vessel like ? or t1.container_no like ?)  
      $aq 
  order by t1.id desc
  limit 100 ");
$statement ->bindValue(1, "%$v%", PDO::PARAM_STR);
$statement ->bindValue(2, "%$v%", PDO::PARAM_STR);
$statement ->bindValue(3, "%$v%", PDO::PARAM_STR);
$statement ->bindValue(4, "%$v%", PDO::PARAM_STR);
$statement ->bindValue(5, "%$v%", PDO::PARAM_STR);
$statement ->bindValue(6, "%$v%", PDO::PARAM_STR);
$statement ->bindValue(7, "%$v%", PDO::PARAM_STR);

$statement->execute();
$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_invoice_list($dev)
{
$data=false;
try
{
$db = Factory::getConnection();

//FETCH USER RIGHTS
$view_type="";
$location_id="";
$addl_location_id="";

$statement = $db->prepare(" SELECT view_type,location_id,addl_location_id FROM user_master 
WHERE username=:username ");
$statement->execute(array(':username'=>$dev->username));
$op=$statement->fetchAll(PDO::FETCH_ASSOC);

$view_type=$op[0]["view_type"];
$location_id=$op[0]["location_id"];
$addl_location_id=$op[0]["addl_location_id"];

$aq='';
if($view_type=='USER'){
  $aq=" AND (t1.pod='$location_id' or t1.location_id='$location_id' 
  or t1.pod in ($addl_location_id) or t2.location_id='$location_id' ) 
   AND (t1.payment_from='CONSIGNEE' or (t1.payment_from='SHIPPER' and t1.pol='$location_id') ) ";
}else if($view_type=='RSTD_USER'){
  $aq=" AND t1.pod in ($addl_location_id) AND t1.payment_from='CONSIGNEE' ";
 // echo 'if rstd_user';
}else {
  $aq=" ";
  //echo 'if admin';
}

$statement = $db->prepare("SELECT 
t1.id,
t1.temp_code,
t1.exl_upd_pk,
t1.cn_no,
t1.order_no,
t1.container_no,
bill_party consignee,
t1.pol,
t1.pod,
t1.emaster,
t1.vessel,
t1.gst_percent,
'FREIGHT' invoice_type  
  from mt_invoice_preparation t1
  left join mt_loading_receipt t2
  on t1.lr_no=t2.lr_no 
  where t1.status='FINAL' 
    $aq 
  order by t1.id desc limit 100 ");
$statement->execute();
$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function search_bulk_invoice_list($dev,$v)
{
$data=false;
try
{
$db = Factory::getConnection();

$statement = $db->prepare("SELECT 
id,
temp_code,
bulk_cn_no,
vessel, 
 ifnull((select name from mt_business_partner where code=consignee limit 1),consignee) consignee,
 ifnull((select name from mt_business_partner where code=consignor limit 1),consignor) consignor,
'0' gst_percent,
'FREIGHT' invoice_type,
(select count(bulk_cn_no) from mt_invoice_preparation where bulk_cn_no=t1.bulk_cn_no) 'no_of_cont'   
  from mt_bulk_invoice_header  t1 
  where (bulk_cn_no like ? or vessel like ?) 
  and status!='CANCELLED'  
  order by id desc
  limit 100 ");
$statement ->bindValue(1, "%$v%", PDO::PARAM_STR);
$statement ->bindValue(2, "%$v%", PDO::PARAM_STR);

$statement->execute();
$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function get_bulk_invoice_list()
{
$data=false;
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT 
id,
temp_code,
bulk_cn_no,
vessel, 
 ifnull((select name from mt_business_partner where code=consignee limit 1),consignee) consignee,
 ifnull((select name from mt_business_partner where code=consignor limit 1),consignor) consignor,
'0' gst_percent,
'FREIGHT' invoice_type,
(select count(bulk_cn_no) from mt_invoice_preparation where bulk_cn_no=t1.bulk_cn_no) 'no_of_cont'   
  from mt_bulk_invoice_header t1 
  where status!='CANCELLED'  
  order by id desc ");
$statement->execute();
$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function search_proforma_list($dev,$v)
{
$data=false;
try
{
$db = Factory::getConnection();

//FETCH USER RIGHTS
$view_type="";
$location_id="";
$addl_location_id="";

$statement = $db->prepare(" SELECT view_type,location_id,addl_location_id FROM user_master 
WHERE username=:username ");
$statement->execute(array(':username'=>$dev->username));
$op=$statement->fetchAll(PDO::FETCH_ASSOC);

$view_type=$op[0]["view_type"];
$location_id=$op[0]["location_id"];
$addl_location_id=$op[0]["addl_location_id"];

$aq='';
if($view_type=='USER'){
  $aq=" AND (t1.pod='$location_id' or t1.location_id='$location_id'  
  or t1.pod in ($addl_location_id) ) ";
}else if($view_type=='RSTD_USER'){
  $aq=" AND t1.pod in ($addl_location_id) ";
 // echo 'if rstd_user';
}else {
  $aq=" ";
  //echo 'if admin';
}

$statement = $db->prepare("SELECT 
id,
temp_code,
exl_upd_pk,
vessel,
emaster,
cn_no,
container_no,
 ifnull((select name from mt_business_partner where code=consignee limit 1),consignee) consignee,
consignor_name consignor,
pol,
pod,
gst_percent,
'' selected,
'' selected1    
  from mt_invoice_preparation t1
  where status='PROFORMA' and 
  (cn_no like ? or consignee like ? or pol like ? or pod like ? or emaster like ? or vessel like ? or container_no like ?)  
      $aq 
  order by id desc 
  limit 20 ");
$statement ->bindValue(1, "%$v%", PDO::PARAM_STR);
$statement ->bindValue(2, "%$v%", PDO::PARAM_STR);
$statement ->bindValue(3, "%$v%", PDO::PARAM_STR);
$statement ->bindValue(4, "%$v%", PDO::PARAM_STR);
$statement ->bindValue(5, "%$v%", PDO::PARAM_STR);
$statement ->bindValue(6, "%$v%", PDO::PARAM_STR);
$statement ->bindValue(7, "%$v%", PDO::PARAM_STR);

$statement->execute();
$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_proforma_list($dev)
{
$data=false;
try
{
$db = Factory::getConnection();

//FETCH USER RIGHTS
$view_type="";
$location_id="";
$addl_location_id="";

$statement = $db->prepare(" SELECT view_type,location_id,addl_location_id FROM user_master 
WHERE username=:username ");
$statement->execute(array(':username'=>$dev->username));
$op=$statement->fetchAll(PDO::FETCH_ASSOC);

$view_type=$op[0]["view_type"];
$location_id=$op[0]["location_id"];
$addl_location_id=$op[0]["addl_location_id"];

$aq='';
if($view_type=='USER'){
  $aq=" AND (t1.pod='$location_id' or t1.location_id='$location_id'  
  or t1.pod in ($addl_location_id) ) ";
}else if($view_type=='RSTD_USER'){
  $aq=" AND t1.pod in ($addl_location_id) ";
 // echo 'if rstd_user';
}else {
  $aq=" ";
  //echo 'if admin';
}

$statement = $db->prepare("SELECT 
id,
temp_code,
(select count(*) from mt_delivery_planning where cn_no=t1.cn_no and del_date is not null) delivered,
exl_upd_pk,
vessel,
emaster,
cn_no,
container_no,
 ifnull((select name from mt_business_partner where code=consignee limit 1),consignee) consignee,
consignor_name consignor,
pol,
pod,
gst_percent,
gst_remarks,
'' selected,  
'' selected1   
  from mt_invoice_preparation t1 
  where status='PROFORMA' 
    $aq 
  order by id desc ");
$statement->execute();
$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function search_ewaybill_list($dev,$v)
{
$data=false;
try
{
$db = Factory::getConnection();

//FETCH USER RIGHTS
$view_type="";
$location_id="";
$addl_location_id="";

$statement = $db->prepare(" SELECT view_type,location_id,addl_location_id FROM user_master 
WHERE username=:username ");
$statement->execute(array(':username'=>$dev->username));
$op=$statement->fetchAll(PDO::FETCH_ASSOC);

$view_type=$op[0]["view_type"];
$location_id=$op[0]["location_id"];
$addl_location_id=$op[0]["addl_location_id"];

$aq='';
if($view_type=='USER'){
  $aq=" AND (t1.pod='$location_id' or t1.location_id='$location_id'  
  or t1.pod in ($addl_location_id) ) ";
}else if($view_type=='RSTD_USER'){
  $aq=" AND t1.pod in ($addl_location_id) ";
 // echo 'if rstd_user';
}else {
  $aq=" ";
  //echo 'if admin';
}

$statement = $db->prepare("SELECT 
id,
exl_upd_pk,
cn_no,
ewaybill_date,
ewaybill_no,
ifnull((select name from mt_business_partner where code=ewaybill_assignto),ewaybill_assignto) ewaybill_assignto,
pol_upd_datetime,
pol_remarks,
pod_upd_datetime,
pod_remarks,
bcg_no,
bcg_date,
vessel   
  from mt_invoice_preparation t1
  where status in ('FINAL', 'PROFORMA')   and 
  (cn_no like ? or ewaybill_no like ? or vessel like ?)  
      $aq   
  order by id desc
  limit 300 ");
$statement ->bindValue(1, "%$v%", PDO::PARAM_STR);
$statement ->bindValue(2, "%$v%", PDO::PARAM_STR);
$statement ->bindValue(3, "%$v%", PDO::PARAM_STR);

$statement->execute();
$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_ewaybill_list($dev)
{
$data=false;
try
{
$db = Factory::getConnection();

//FETCH USER RIGHTS
$view_type="";
$location_id="";
$addl_location_id="";

$statement = $db->prepare(" SELECT view_type,location_id,addl_location_id FROM user_master 
WHERE username=:username ");
$statement->execute(array(':username'=>$dev->username));
$op=$statement->fetchAll(PDO::FETCH_ASSOC);

$view_type=$op[0]["view_type"];
$location_id=$op[0]["location_id"];
$addl_location_id=$op[0]["addl_location_id"];

$aq='';
if($view_type=='USER'){
  $aq=" AND (t1.pod='$location_id' or t1.location_id='$location_id'  
  or t1.pod in ($addl_location_id) ) ";
}else if($view_type=='RSTD_USER'){
  $aq=" AND t1.pod in ($addl_location_id) ";
 // echo 'if rstd_user';
}else {
  $aq=" ";
  //echo 'if admin';
}

$statement = $db->prepare("SELECT 
id,
exl_upd_pk,
cn_no,
ewaybill_date,
ewaybill_no,
ifnull((select name from mt_business_partner where code=ewaybill_assignto),ewaybill_assignto) ewaybill_assignto,
pol_upd_datetime,
pol_remarks,
pod_upd_datetime,
pod_remarks,
bcg_no,
bcg_date,
pol,
vessel   
  from mt_invoice_preparation t1 
  where status in ('FINAL', 'PROFORMA')   
    $aq   
  order by id desc limit 100 ");
$statement->execute();
$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_ewaybill_list_excel($dev)
{
$data=false;
try
{
$db = Factory::getConnection();

//FETCH USER RIGHTS
$view_type="";
$location_id="";
$addl_location_id="";

$statement = $db->prepare(" SELECT view_type,location_id,addl_location_id FROM user_master 
WHERE username=:username ");
$statement->execute(array(':username'=>$dev->username));
$op=$statement->fetchAll(PDO::FETCH_ASSOC);

$view_type=$op[0]["view_type"];
$location_id=$op[0]["location_id"];
$addl_location_id=$op[0]["addl_location_id"];

$aq='';
if($view_type=='USER'){
  $aq=" AND (t1.pod='$location_id' or t1.location_id='$location_id'  
  or t1.pod in ($addl_location_id) ) ";
}else if($view_type=='RSTD_USER'){
  $aq=" AND t1.pod in ($addl_location_id) ";
 // echo 'if rstd_user';
}else {
  $aq=" ";
  //echo 'if admin';
}

$statement = $db->prepare("SELECT 
id,
exl_upd_pk,
cn_no,
ewaybill_date,
ewaybill_no,
ifnull((select name from mt_business_partner where code=ewaybill_assignto),ewaybill_assignto) ewaybill_assignto,
pol_upd_datetime,
pol_remarks,
pod_upd_datetime,
pod_remarks,
bcg_no,
bcg_date,
pol,
vessel   
  from mt_invoice_preparation t1 
  where status in ('FINAL', 'PROFORMA')   
    $aq   
  order by id desc limit 1000 ");
$statement->execute();
$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function update_ewaybill_data($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$statement = $db->prepare("UPDATE mt_invoice_preparation set 
pol_upd_datetime=:pol_upd_datetime,
pol_remarks=:pol_remarks,
pod_upd_datetime=:pod_upd_datetime,
pod_remarks=:pod_remarks 
 where id=:id");
$statement->execute(array(
  ':id'=>$c->id,
':pol_upd_datetime'=>$c->pol_upd_datetime,
':pol_remarks'=>$c->pol_remarks,
':pod_upd_datetime'=>$c->pod_upd_datetime,
':pod_remarks'=>$c->pod_remarks
));

if ($statement->rowCount()){
  $data["ewb_status"]=1;
} else{
  $data["ewb_status"]=0;
}


$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function convert_proforma_final($dev,$code)
{
  $data=array();
  try
  {
  $db = Factory::getConnection();

    for($i=0;$i<count($code);$i++)
    {
        $c=$code[$i];

        //inv. no. autogen starts
        $statement = $db->prepare("INSERT into mt_invno_autogen (temp_code) 
        values(:temp_code)");
        $temp_code=uniqid($dev->uid);
        $statement->execute(array(':temp_code'=>$temp_code));

            if ($statement->rowCount()){
            $data["autogen_status"]=1;
          } else{
            $data["autogen_status"]=0;
          }

         $statement = $db->prepare("SELECT id from mt_invno_autogen where 
            temp_code=:temp_code");
          $statement->execute(array(':temp_code'=>$temp_code));
          $op=$statement->fetchAll(PDO::FETCH_ASSOC);

        $fid=self::setFiveDigit($op[0]["id"]);
        $on="INV/".date("y")."/".date('m')."/".$fid; 

        //UPDATE INVOICE NO. & STATUS
        $statement = $db->prepare("UPDATE mt_invoice_preparation 
        SET cn_no=:cn_no, 
        status='FINAL',
        cn_date=now() 
        where id=:id");
        $statement->execute(array(':id'=>$c->id,':cn_no'=>$on));

        if ($statement->rowCount()){
        $data["status".($i+1)]=1;
        $data["status"]=1;
        } else{
          $data["status".($i+1)]=0;
          $data["status"]=0;
        }
    }

    $statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function bulk_billing($dev,$code)
{
  $data=array();
  try
  {
  $db = Factory::getConnection();

    //inv. no. autogen starts
    $on="";

    if($c->gst_remarks=="EXEMPTED"){
        //0%
        $statement = $db->prepare("INSERT into mt_invno_0_autogen (temp_code) 
        values(:temp_code)");
        $temp_code=uniqid($dev->uid);
        $statement->execute(array(':temp_code'=>$temp_code));

            if ($statement->rowCount()){
            $data["autogen_0_status"]=1;
          } else{
            $data["autogen_0_status"]=0;
          }

         $statement = $db->prepare("SELECT id from mt_invno_0_autogen where 
            temp_code=:temp_code");
          $statement->execute(array(':temp_code'=>$temp_code));
          $op=$statement->fetchAll(PDO::FETCH_ASSOC);

        $fid=self::setFiveDigit($op[0]["id"]);
        $on="EXM/".date("y")."/".date('m')."/".$fid; 
    }else if($c->gst_remarks=="PLUS 5%"){

    }else if($c->gst_remarks=="PLUS 12%" or $c->gst_remarks=="INCLUDING"){
        //12%
        $statement = $db->prepare("INSERT into mt_invno_autogen (temp_code) 
        values(:temp_code)");
        $temp_code=uniqid($dev->uid);
        $statement->execute(array(':temp_code'=>$temp_code));

            if ($statement->rowCount()){
            $data["autogen_status"]=1;
          } else{
            $data["autogen_status"]=0;
          }

         $statement = $db->prepare("SELECT id from mt_invno_autogen where 
            temp_code=:temp_code");
          $statement->execute(array(':temp_code'=>$temp_code));
          $op=$statement->fetchAll(PDO::FETCH_ASSOC);

        $fid=self::setFiveDigit($op[0]["id"]);
        $on="INV/".date("y")."/".date('m')."/".$fid; //$c->from_port."/".$fid;
     }

echo 'gst remarks: '.$c->gst_remarks;
echo 'gst percent: '.$c->gst_percent;
echo 'on: '.$on;

    for($i=0;$i<count($code);$i++)
    {
        $c=$code[$i];

        //UPDATE INVOICE NO. & STATUS
        $statement = $db->prepare("UPDATE mt_invoice_preparation 
        SET bulk_cn_no=:cn_no, 
        status='BULK FINAL',
        cn_date=now() 
        where id=:id");
        $statement->execute(array(':id'=>$c->id,':cn_no'=>$on));

        if ($statement->rowCount()){
        $data["status".($i+1)]=1;
        $data["status"]=1;
        } else{
          $data["status".($i+1)]=0;
          $data["status"]=0;
        }
    }

    //Insert each consignee one row
    $statement = $db->prepare("INSERT into mt_bulk_invoice_header (
    bulk_cn_no, vessel, consignor, consignee, bill_party, 
    status, location_id, ip,uid, ua,ekey,created_date,temp_code) 
    values(:bulk_cn_no, :vessel, :consignor, :consignee,:bill_party,
    'FINAL', '$dev->location',:ip ,:uid ,:ua ,:ekey,now(),:temp_code)");
    $temp_code=uniqid($dev->uid);
    $statement->execute(array(':ip'=>$dev->ip,':uid'=>$dev->uid ,':ua'=>$dev->ua,':ekey'=>$dev->ekey,
    ':bulk_cn_no'=>$on,
    ':vessel'=>$c->vessel,
    ':consignor'=>$c->consignor,
    ':consignee'=>$c->consignee,
    ':bill_party'=>$c->consignee,

    ':temp_code'=>$temp_code));

        if ($statement->rowCount()){
        $data["status"]=1;
      } else{
        $data["status"]=0;
      }

    $statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

}
?>