<?php


require("../config/dbconn.php");

class LPODao

{


public static function save_page_views($dev,$pname,$method)
{
$data=0;
try
{
$db = Factory::getConnection();
$statement = $db->prepare("INSERT into page_views(
ip ,uid ,ua,ekey,esecret,method,page,tz) 
values(:ip ,:uid ,
:ua ,:ekey ,:esecret ,:method ,:page,:tz)");
$statement->execute(array(':ip'=>$dev->ip,':uid'=>$dev->uid ,
':ua'=>$dev->ua,
':tz'=>$dev->tz ,
':method'=>$method ,':esecret'=>$dev->esecret,':ekey'=>$dev->ekey,
':page'=>$pname));
$data=1;
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  return $data;
}

public static function search_lpo_list($code)
{

$data=array();
try
{
$db = Factory::getConnection();

$saq='';
$query='';
if(is_object($code))
{
  if($code->cancelled)
  {
  $saq="aph_status='CANCELLED' and ";
  }else{
  $saq="aph_status!='CANCELLED' and ";
  }
  $query=$code->q;
}else{
  $saq="aph_status!='CANCELLED' and ";
  $query=$code;
}

$statement = $db->prepare("SELECT id,aph_other_reference ref,aph_status status, aph_document_number doc_no,aph_code code,aph_document_date doc_date,
aph_local_amount lamt,aph_narration narration, created_by,created_date,
order_no
 FROM mt_ap_header where $saq (aph_document_number like'LPO%' or 
  aph_document_number like'SIN%') and 
(aph_code like ? or aph_document_number like ? or order_no like ? or aph_other_reference like ?) order by id desc limit 50");

$v=$query;
$statement ->bindValue(1, "%$v%", PDO::PARAM_STR);
$statement ->bindValue(2, "%$v%", PDO::PARAM_STR);
$statement ->bindValue(3, "%$v%", PDO::PARAM_STR);
$statement ->bindValue(4, "%$v%", PDO::PARAM_STR);


/*
(SELECT order_no from mt_order_entry where id=(SELECT order_id from mt_order_cost where inv_pay_no=aph_document_number limit 1)) 
*/
$statement->execute();
$data=$statement->fetchAll(PDO::FETCH_ASSOC);
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function get_lpo_cancelled_list($code)
{

$data=array();
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT id,aph_other_reference ref,aph_status status, aph_document_number doc_no,aph_code code,aph_document_date doc_date,
aph_local_amount lamt,aph_narration narration, created_by,created_date,
(SELECT order_no from mt_order_entry where id=(SELECT order_id from mt_order_cost where inv_pay_no=aph_document_number limit 1)) order_no1,lpo_order order_no FROM mt_ap_header where aph_status='CANCELLED' and (aph_document_number like'LPO%' or 
  aph_document_number like'SIN%') order by id desc limit :sta,50");

$statement->bindValue(':sta',(int) $code->start, PDO::PARAM_INT); 
$statement->execute();
$data=$statement->fetchAll(PDO::FETCH_ASSOC);
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_lpo_list($code)
{

$data=array();
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT id,aph_other_reference ref,aph_status status, aph_document_number doc_no,aph_code code,aph_document_date doc_date,
aph_local_amount lamt,aph_narration narration, created_by,created_date,
(SELECT order_no from mt_order_entry where id=(SELECT order_id from mt_order_cost where inv_pay_no=aph_document_number limit 1)) order_no1,lpo_order order_no FROM mt_ap_header where aph_status!='CANCELLED' and (aph_document_number like'LPO%' or 
  aph_document_number like'SIN%') order by id desc limit :sta,50");

$statement->bindValue(':sta',(int) $code->start, PDO::PARAM_INT); 
$statement->execute();
$data=$statement->fetchAll(PDO::FETCH_ASSOC);
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function search_lpo($c)
{

$data=array();
try
{
$db = Factory::getConnection();
$q="SELECT 0 selected,id,(SELECT order_type from mt_order_entry where order_no=:order_no) order_type,
  charge_desc,(
SELECT description from mt_charge_group_detail WHERE code=charge_desc limit 1) charge_description,basis_type,basis_uom,qty,
  currency,ex_rate,rate_cost,cost_base_amount,cost_base_amount cost_amt1,0 edit 
from mt_order_cost 
WHERE billing_party=:billing_party and type='COST' and 
order_id=(SELECT id from mt_order_entry WHERE order_no=:order_no) and 
inv_pay_no is null and isdraft=0";

if($c->isEdit==1)
{
  $q=$q." UNION ALL 

  SELECT 1 selected,id,(SELECT order_type from mt_order_entry where order_no=:order_no) order_type,
  charge_desc,(
SELECT description from mt_charge_group_detail WHERE code=charge_desc limit 1) charge_description,basis_type,basis_uom,qty,
  currency,ex_rate,rate_cost,cost_base_amount,cost_base_amount cost_amt1,0 edit 
from mt_order_cost 
WHERE billing_party=:billing_party and type='COST' and 
order_id=(SELECT id from mt_order_entry WHERE order_no=:order_no) and 
lpo_draft_no='$c->doc_no'";
}

$statement = $db->prepare($q);

$statement->execute(array(
':order_no'=>$c->order_no,
':billing_party'=>$c->vendor));

$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function get_ap_info($dev,$code)
{
$data=array();
try
{
$db = Factory::getConnection();

$statement = $db->prepare("SELECT 
id,
aph_code party_code,
(SELECT name FROM mt_business_partner WHERE code=aph_code limit 1) party_name,
aph_document_number doc_number,
aph_document_date doc_date,
aph_other_reference ref,
aph_currency,
abs(aph_local_amount) lamt,
abs(aph_local_amount) famt,
aph_narration narration,
aph_status status,
temp_code,
0 tds_appl_amt,order_no,
(select order_type from mt_order_entry where order_no=order_no limit 1) order_type     
 from mt_ap_header where id=:id");

$statement->execute(array(':id'=>$code));
$data["info"]=$statement->fetchAll(PDO::FETCH_ASSOC);
$doc_no=$data["info"][0]["doc_number"];

$statement = $db->prepare("SELECT 
charge_id id,
1 selected,
aloc_detail_4 charge_desc,
aloc_detail_2 charge_description,
tax_percentage,
aloc_detail_5 basis_type,
qty,
aloc_local_amount cost_amt1,
aloc_ex_rate ex_rate,
aloc_currency currency,
cost_base_amount,
aloc_foreign_amount rate_cost,
'0' edit 
 from mt_ap_allocation_details where aloc_doc_number=:id");

$statement->execute(array(':id'=>$doc_no));
$data["detail"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT pre_glt_doc_number from mt_ap_gl_details 
      WHERE pre_glt_doc_number=:doc_no");
$statement->execute(array(':doc_no'=>$doc_no));
$datas=$statement->fetchAll(PDO::FETCH_ASSOC);
$data["posted"]=count($datas);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_ap_list($dev,$code)
{
$data=array();
try
{
$db = Factory::getConnection();


$statement = $db->prepare("SELECT id,
aph_code,
aph_document_number,
aph_document_type,
aph_document_date,
aph_currency,
aph_local_amount,
aph_narration,
aph_status,
created_by,created_date from mt_ap_header order by id desc limit :sta,50");
$statement->bindValue(':sta',(int) $code, PDO::PARAM_INT); 
$statement->execute();
$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function search_ap_list($dev,$code)
{
$data=array();
try
{
$db = Factory::getConnection();


$statement = $db->prepare("SELECT id,
aph_code,
aph_document_number,
aph_document_type,
aph_document_date,
aph_currency,
aph_local_amount,
aph_narration,
aph_status,
created_by,created_date from mt_ap_header where aph_document_number like ? order by id desc limit 50");
$i=1;
$statement ->bindValue($i++, "%$code%", PDO::PARAM_STR);
$statement->execute();
$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function setFourDigit($v)
{
  $len=strlen($v);

if($len==1)
{
  $v="000".$v;
}else if($len==2)
{
  $v="00".$v;
}else if($len==3)
{
  $v="0".$v;
}

return $v;
}


public static function generate_voucher_no($db,$dev,$table,$temp_code)
{
$data=array();
$result=0;

$table=strtolower($table);
$statement = $db->prepare("INSERT into ".$table."(
  created_by,created_date,temp_code) 
values(:created_by,now(),:temp_code)");
$statement->execute(array(
  ':created_by'=>$dev->username ,
':temp_code'=>$temp_code
));

if ($statement->rowCount()){
  $data["status"]=1;
} else{
  $data["status"]=0;
}


$statement = $db->prepare("SELECT COUNT(*)+1 rid FROM $table where id<(SELECT id from $table where created_by=:created_by and temp_code=:temp_code) ");
$statement->execute(array(':temp_code'=>$temp_code,
  ':created_by'=>$dev->username));
$data["id"]=$statement->fetchAll(PDO::FETCH_ASSOC);
$result=$data["id"][0]["rid"];
  
  return $result;
}

public static function getFinancialYear()
{
//$year = ( date('m') > 4) ? date('Y') + 1 : date('Y');
$year=date('Y');
return $year;
}

public static function getFinancialPeriod($doc_date)
{

//$year = ( date('m') > 4) ? date('Y') + 1 : date('Y');
//$period=4;
//return $period;
$data=false;
try
{
$db = Factory::getConnection();

//$aq=self::getRestrictionQuery($dev);
//$doc_date="2019-12-15";
$date=date_create($doc_date);
$m= date_format($date,"F");
$y= date_format($date,"Y");

$statement = $db->prepare("SELECT enumber from mt_period 
  where period=:period and year=:year and open_max='OPEN'");

$statement->execute(array(':period'=>$m,':year'=>$y));
$data=$statement->fetchAll(PDO::FETCH_ASSOC);
//var_dump($statement->debugDumpParams());
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  $p=-10;
  if(count($data)==1)
  {
    $p=$data[0]["enumber"];
  }
  return $p;
}

public static function get_posted_status($code)
{


$data=0;
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT pre_glt_doc_number from mt_ap_gl_details 
      WHERE pre_glt_doc_number=:doc_no");
$statement->execute(array(':doc_no'=>$code->info->doc_number));
$datas=$statement->fetchAll(PDO::FETCH_ASSOC);
$data=count($datas);
$statement=null;
  }
  catch (Exception $e) {
  }
 
  return $data;
}


public static function get_currency($dev)
{


$data=0;
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT * FROM location_master WHERE cname=:company_id and loc_name=:location_id limit 1");
$statement->execute(array(':company_id'=>$dev->company,
':location_id'=>$dev->location));
$tax_datas=$statement->fetchAll(PDO::FETCH_ASSOC);
$data=$tax_datas[0]["currency"];
$statement=null;
  }
  catch (Exception $e) {
  }
 
  return $data;
}



public static function save_ap_draft($dev,$code)
{

$result=array();
if($code->info->doc_number!='')
{

$posted_count=self::get_posted_status($code);

if($posted_count==0 && $code->info->status=='POSTED')
{
    $result=self::update_ap_draft($dev,$code);
    if($result["status"]==1)
    {
      //check tax percentage exist or not
      $cds=$code->cds;
      $missed_tax_count=0;
      $tax_perc_list=array();
      $igst=0;
      for($i=0;$i<count($cds);$i++)
      {
        $cd=$cds[$i];
        if(property_exists($cd, 'tax_percentage')) 
          {
            if($cd->tax_percentage)
            {
            if($cd->tax_percentage!='0')
            {
              $tax_amt=round($cd->cost_amt1*$cd->tax_percentage/100,2);
              $igst+=$tax_amt;
              $gst_percent=$cd->tax_percentage;

              //check tax percent not ther
              $isFound=0;
              for($n1=0;$n1<count($tax_perc_list);$n1++)
              {
                if($tax_perc_list[$n1]["tax"]==$cd->tax_percentage)
                {
                  $isFound=1;
                  $tax_perc_list[$n1]["tax_amt"]+=$tax_amt;
                  break;
                }
              }
              if($isFound==0)
              {
              array_push($tax_perc_list,array('tax'=>$gst_percent,'tax_amt'=>$tax_amt));
              }
            }
          }else{
              
              //allowing zero tax
              if($cd->tax_percentage!='0')
                {
                $missed_tax_count+=1;
                }
          }
          }else{
            $missed_tax_count+=1;
          }
  
        }

          if($missed_tax_count!=0)
          {
          $result["status"]=0;
          $result["msg"]="Please select tax percentage";
          }else{
            $result=self::post_ap($dev,$code,$tax_perc_list,$igst);
          }
      //**************
    }else{
      $result["add_msg"]="Update failed before posting";
    }
}if($posted_count!=0 && $code->info->status=='POSTED')
{
  $result["add_msg"]="Trying to Update already posted";
  $result["status"]=0;
  $result["msg"]="Voucher already posted to finance";
}else if($posted_count==0 && $code->info->status=='DRAFT')
{
    $result=self::update_ap_draft($dev,$code);
}

return $result;

}else
{
$data=array();
try
{
$db = Factory::getConnection();
$db->beginTransaction();

$cds=$code->cds;
$c=$code->info;

$temp_code=uniqid($dev->uid);
$c->status='DRAFT';
$statement = $db->prepare("INSERT into mt_ap_header(
aph_code,
aph_document_base,
aph_document_type,
aph_document_date,
aph_gl_date,
aph_other_reference,
aph_currency,
aph_exchange_rate,
aph_foreign_amount,
aph_local_amount,
aph_narration,
aph_status,
location_id,
company_id,
created_by,
created_date,
ip,
ua,
ekey,
temp_code,
lpo_order,order_no
) 
values(
:aph_code,
:aph_document_base,
:aph_document_type,
:aph_document_date,
:aph_gl_date,
:aph_other_reference,
:aph_currency,
:aph_exchange_rate,
:aph_foreign_amount,
:aph_local_amount,
:aph_narration,
:aph_status,
:location_id,
:company_id,
:created_by,
now(),
:ip,
:ua,
:ekey,
:temp_code,:order_no,:order_no)");


$c->aph_document_base="PAYABLE VOUCHER";
$c->aph_document_type='SIN';
$c->aph_document_date=$c->doc_date;
$c->aph_other_reference=$c->ref;
$c->currency=self::get_currency($dev);
$header_amount=abs($code->total)*(-1);

$statement->execute(array(
':aph_code'=>$c->party_code,
':aph_document_base'=>$c->aph_document_base,
':aph_document_type'=>$c->aph_document_type,
':aph_document_date'=>$c->aph_document_date,
':aph_gl_date'=>$c->aph_document_date,
':aph_other_reference'=>$c->aph_other_reference,
':aph_narration'=>$c->narration,
':aph_currency'=>$c->currency,
':order_no'=>$code->v->order_no,
':aph_exchange_rate'=>'1',
':aph_foreign_amount'=>$header_amount,
':aph_local_amount'=>$header_amount,
':aph_status'=>$c->status,
':location_id'=>$dev->location,
':company_id'=>$dev->company,
':created_by'=>$dev->username,
':ip'=>$dev->ip,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,
':temp_code'=>$temp_code
));

if ($statement->rowCount()){
  $data["status"]=1;
  $data["msg"]="Saved.";
} else{
  $data["status"]=0;
  $data["msg"]="Unable to save.";
}

$statement = $db->prepare("SELECT id from mt_ap_header where created_by=:uid and temp_code=:temp_code");
$statement->execute(array(':temp_code'=>$temp_code,
  ':uid'=>$dev->username));
$data["id"]=$statement->fetchAll(PDO::FETCH_ASSOC);
$data["temp_code"]=$temp_code;

$fid1=$data["id"][0]["id"];

$vgen=self::generate_voucher_no($db,$dev,'LPO',$temp_code);
$fid=self::setFourDigit($vgen);

$doc_no="SIN/".date("Y")."/".date('m')."/".$fid;

$statement = $db->prepare("UPDATE mt_ap_header  
  SET aph_document_number=:ond where id=:id");
  $statement->execute(array(':id'=>$fid1,':ond'=>$doc_no));
  
    if ($statement->rowCount()){
    $data["jid_status"]=1;
  } else{
    $data["jid_status"]=0;
  }

$data["doc_no"]=$doc_no;

//query 2 child entry
$len=count($cds);
$ch_status_count=0;
$oid_status_count=0;

for($i=0;$i<$len;$i++)
{
$cd=$cds[$i];
$r=$cd;
$tax_percentage=NULL;
if (property_exists($r, 'tax_percentage')) 
{
$tax_percentage=$r->tax_percentage;
}
$statement = $db->prepare("INSERT into mt_ap_allocation_details 
(
aloc_base_doc,
aloc_doc_type,
aloc_doc_number,
aloc_foreign_amount,
aloc_currency,
aloc_ex_rate,
aloc_local_amount,
aloc_narration,
aloc_detail_1,
aloc_detail_2,
aloc_detail_3,
aloc_detail_4,
aloc_detail_5,
cost_base_amount,
qty,
location_id,
company_id,
created_by,
created_date,
ip,
ua,
ekey,tax_percentage,charge_id
)
VALUES
(
:aloc_base_doc,
:aloc_doc_type,
:aloc_doc_number,
:aloc_foreign_amount,
:aloc_currency,
:aloc_ex_rate,
:aloc_local_amount,
:aloc_narration,
(SELECT expense_gl FROM mt_charge_group_detail WHERE code=:charge_desc limit 1),
:aloc_detail_2,
:aloc_detail_3,
:aloc_detail_4,
:aloc_detail_5,
:cost_base_amount,
:qty,
:location_id,
:company_id,
:created_by,
now(),
:ip,
:ua,
:ekey,:tax_percentage,:charge_id)");
  $statement->execute(array(
':aloc_base_doc'=>$c->aph_document_base,
':aloc_doc_type'=>$c->aph_document_type,
':aloc_doc_number'=>$doc_no,
':aloc_foreign_amount'=>$r->rate_cost,
':qty'=>$r->qty,
':aloc_currency'=>$r->currency,
':aloc_ex_rate'=>$r->ex_rate,
':aloc_local_amount'=>$r->cost_amt1,
':cost_base_amount'=>$r->cost_base_amount,
':aloc_narration'=>$c->narration,
':tax_percentage'=>$tax_percentage,
':aloc_detail_2'=>$r->charge_description,
':aloc_detail_4'=>$r->charge_desc,
':aloc_detail_5'=>$r->basis_type,

':charge_desc'=>$r->charge_desc,
':charge_id'=>$r->id,


':aloc_detail_3'=>$c->party_code,
':location_id'=>$dev->location,
':company_id'=>$dev->company,
':created_by'=>$dev->username,
':ip'=>$dev->ip,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey
  ));
  
    if ($statement->rowCount()){
    $ch_status_count+=1;
    $data["ch_status".($i+1)]=1;
  } else{
    $data["ch_status".($i+1)]=0;
  }


  //update order id
  if($r->id)
  {
  $statement = $db->prepare("UPDATE mt_order_cost SET isdraft=1,modified_by=:modified_by,lpo_draft_no=:doc_no WHERE id=:id and isdraft=0");
  $statement->execute(array(
':id'=>$r->id,
':doc_no'=>$doc_no,
':modified_by'=>$dev->username,

  ));
  
    if ($statement->rowCount()){
    $oid_status_count+=1;
    $data["oid_status".($i+1)]=1;
  } else{
    $data["oid_status".($i+1)]=0;
  }
  }else{
    $oid_status_count+=1;
  }

  

}
//end of loop

$cr_count=count($cds);
$child_status=$ch_status_count==$cr_count && $oid_status_count==$cr_count;

//$data["status"]=0;


if($data["status"]==1 && $child_status)
{
  $db->commit();
}else{
    $db->rollBack();
    $data["status"]=0;
    $data["msg"]="Unable to save. Please try again";
}

$statement=null;
  }
  catch (Exception $e) {
    $data["emsg"]=$e->getMessage();
    $db->rollBack();
    $data["status"]=0;
    $data["msg"]="Unable to save.Exception. Please try again";
  }
  
  return $data;
}
}


public static function update_ap_draft($dev,$code)
{
$data=array();
try
{
$db = Factory::getConnection();
$db->beginTransaction();

$cds=$code->cds;
$c=$code->info;

$temp_code=uniqid($dev->uid);

$statement = $db->prepare("UPDATE mt_ap_header
SET 
aph_code=:aph_code,
aph_document_base=:aph_document_base,
aph_document_type=:aph_document_type,
aph_document_date=:aph_document_date,
aph_gl_date=:aph_gl_date,
aph_other_reference=:aph_other_reference,
aph_currency=:aph_currency,
aph_exchange_rate=:aph_exchange_rate,
aph_foreign_amount=:aph_foreign_amount,
aph_local_amount=:aph_local_amount,
aph_narration=:aph_narration,
modified_by=:modified_by,
modified_date=now()
WHERE id=:id");

$c->aph_document_base="PAYABLE VOUCHER";
$c->aph_document_type='SIN';
$c->aph_document_date=$c->doc_date;
$c->aph_other_reference=$c->ref;
$c->currency=self::get_currency($dev);
$header_amount=abs($code->total)*(-1);

$statement->execute(array(
':aph_code'=>$c->party_code,
':aph_document_base'=>$c->aph_document_base,
':aph_document_type'=>$c->aph_document_type,
':aph_document_date'=>$c->aph_document_date,
':aph_gl_date'=>$c->aph_document_date,
':aph_other_reference'=>$c->aph_other_reference,
':aph_narration'=>$c->narration,
':aph_currency'=>$c->currency,
':aph_exchange_rate'=>'1',
':aph_foreign_amount'=>$header_amount,
':aph_local_amount'=>$header_amount,

':modified_by'=>$dev->username,
':id'=>$c->id
));

if ($statement->rowCount()){
  $data["status"]=1;
  $data["msg"]="Updated.";
} else{
  $data["status"]=0;
  $data["msg"]="Unable to update. Please try again.";
}

$doc_no=$c->doc_number;

//delete child data
$statement = $db->prepare("DELETE FROM mt_ap_allocation_details 
  WHERE aloc_doc_number=:aloc_doc_number");
$statement->execute(array(':aloc_doc_number'=>$doc_no));
if ($statement->rowCount()){
  $data["del_status"]=1;
} else{
  $data["del_status"]=0;
}


$statement = $db->prepare("UPDATE mt_order_cost 
  SET isdraft=0,modified_by=:modified_by,lpo_draft_no=NULL WHERE lpo_draft_no=:lpo_draft_no");
$stmt_rowcount=$statement->execute(array(
':lpo_draft_no'=>$doc_no,
':modified_by'=>$dev->username
  ));
  if ($stmt_rowcount){
    $data["update_oid_status"]=1;
  } else{
    $data["update_oid_status"]=0;
  }

//query 2 child entry
$len=count($cds);
$ch_status_count=0;
$oid_status_count=0;

for($i=0;$i<$len;$i++)
{
$cd=$cds[$i];
$r=$cd;

$tax_percentage=NULL;
if (property_exists($r, 'tax_percentage')) 
{
$tax_percentage=$r->tax_percentage;
}
$statement = $db->prepare("INSERT into mt_ap_allocation_details 
(
aloc_base_doc,
aloc_doc_type,
aloc_doc_number,
aloc_foreign_amount,
aloc_currency,
aloc_ex_rate,
aloc_local_amount,
aloc_narration,
aloc_detail_1,
aloc_detail_2,
aloc_detail_3,
aloc_detail_4,
aloc_detail_5,
cost_base_amount,
qty,
location_id,
company_id,
created_by,
created_date,
ip,
ua,
ekey,tax_percentage,charge_id
)
VALUES
(
:aloc_base_doc,
:aloc_doc_type,
:aloc_doc_number,
:aloc_foreign_amount,
:aloc_currency,
:aloc_ex_rate,
:aloc_local_amount,
:aloc_narration,
(SELECT expense_gl FROM mt_charge_group_detail WHERE code=:charge_desc limit 1),
:aloc_detail_2,
:aloc_detail_3,
:aloc_detail_4,
:aloc_detail_5,
:cost_base_amount,
:qty,
:location_id,
:company_id,
:created_by,
now(),
:ip,
:ua,
:ekey,:tax_percentage,:charge_id)");
  $statement->execute(array(
':aloc_base_doc'=>$c->aph_document_base,
':aloc_doc_type'=>$c->aph_document_type,
':aloc_doc_number'=>$doc_no,
':aloc_foreign_amount'=>$r->rate_cost,
':qty'=>$r->qty,
':aloc_currency'=>$r->currency,
':aloc_ex_rate'=>$r->ex_rate,
':aloc_local_amount'=>$r->cost_amt1,
':cost_base_amount'=>$r->cost_base_amount,
':aloc_narration'=>$c->narration,
':tax_percentage'=>$tax_percentage,
':aloc_detail_2'=>$r->charge_description,
':aloc_detail_4'=>$r->charge_desc,
':aloc_detail_5'=>$r->basis_type,

':charge_desc'=>$r->charge_desc,
':charge_id'=>$r->id,


':aloc_detail_3'=>$c->party_code,
':location_id'=>$dev->location,
':company_id'=>$dev->company,
':created_by'=>$dev->username,
':ip'=>$dev->ip,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey
  ));
  
    if ($statement->rowCount()){
    $ch_status_count+=1;
    $data["ch_status".($i+1)]=1;
  } else{
    $data["ch_status".($i+1)]=0;
  }


  //update order id
  if($r->id)
  {
  $statement = $db->prepare("UPDATE mt_order_cost SET isdraft=1,modified_by=:modified_by,modified_date=now(),lpo_draft_no=:doc_no WHERE id=:id");
  $stmt_rowcount=$statement->execute(array(
':id'=>$r->id,
':doc_no'=>$doc_no,
':modified_by'=>$dev->username,

  ));
  
    if ($stmt_rowcount){
    $oid_status_count+=1;
    $data["oid_status".($i+1)]=1;
  } else{
    $data["oid_status".($i+1)]=0;
  }
  }else{
    $oid_status_count+=1;
  }

  

}
//end of loop

$cr_count=count($cds);
$child_status=$ch_status_count==$cr_count && $oid_status_count==$cr_count;

//$data["status"]=0;


if($data["status"]==1 && $child_status && $data["del_status"]==1 && $data["update_oid_status"]==1)
{
  $db->commit();
}else{
    $db->rollBack();
    $data["status"]=0;
    $data["msg"]="Unable to save. Please try again";
}

$statement=null;
  }
  catch (Exception $e) {
    $data["emsg"]=$e->getMessage();
    $db->rollBack();
    $data["status"]=0;
    $data["msg"]="Unable to save.Exception. Please try again";
  }
  
  return $data;
}

public static function post_ap($dev,$code,$tax_perc_list,$total_tax_amt)
{
$data=array();
try
{
$db = Factory::getConnection();
$db->beginTransaction();

$c=$code->info;

$temp_code=uniqid($dev->uid);

$header_amount=abs($code->total)*(-1);

$header_amount=$header_amount+$total_tax_amt*(-1);

$c->aph_document_base="PAYABLE VOUCHER";
$c->aph_document_type='SIN';
$c->aph_document_date=$c->doc_date;
$c->aph_other_reference=$c->ref;

//calc tax percentage
$tax_rows=array();
$statement = $db->prepare("SELECT pan,gstin from mt_business_partner 
  where code=:customer_code limit 1");
$statement->execute(array(':customer_code'=>$code->info->party_code));
$cus_data=$statement->fetchAll(PDO::FETCH_ASSOC);
$billparty_gstin=$cus_data[0]["gstin"];
$billparty_pan=$cus_data[0]["pan"];

$two_digit=substr($billparty_gstin,0,2);

$statement = $db->prepare("SELECT * FROM location_master WHERE cname=:company_id and loc_name=:location_id limit 1");
$statement->execute(array(':company_id'=>$dev->company,
':location_id'=>$dev->location));
$tax_datas=$statement->fetchAll(PDO::FETCH_ASSOC);
$tax_type=$tax_datas[0]["tax_type"];
$startString=$tax_datas[0]["tax_num"];
$c->currency=$tax_datas[0]["currency"];

if(count($tax_datas)==0)
{
  $data["status"]=0;
  $data["msg"]="No tax info found. Please update location master to proceed";
}else if($tax_type=="INDIA GST")
{
          if(is_numeric($two_digit))
          {
              $isIGST=0;
              if($two_digit==$startString)
              {

              }else{
              $isIGST=1;
              }

              $data["status"]=1;


              if($isIGST==1)
              {
                for($i=0;$i<count($tax_perc_list);$i++)
                    {
                      $tax_perc_list[$i]["tax_type"]="INPUT IGST";
                      $tax_perc_list[$i]["tax_gl"]="1-10-004-0003";
                    }
              }else{
                $tax_perc_list1=array();
                for($i=0;$i<count($tax_perc_list);$i++)
                    {

                    $temp_ar=$tax_perc_list[$i];
                    $csgst_amt=round($tax_perc_list[$i]["tax_amt"]/2,2);
                    $csgst_tax=$tax_perc_list[$i]["tax"]/2;

                    $temp_ar["tax_type"]="INPUT CGST";
                    $temp_ar["tax_gl"]="1-10-004-0002";
                    $temp_ar["tax_amt"]=$csgst_amt;
                    $temp_ar["tax"]=$csgst_tax;

                    array_push($tax_perc_list1,$temp_ar);

                    $temp_ar=$tax_perc_list[$i];
                    $temp_ar["tax_type"]="INPUT SGST";
                    $temp_ar["tax_gl"]="1-10-004-0001";
                    $temp_ar["tax_amt"]=$csgst_amt;
                    $temp_ar["tax"]=$csgst_tax;

                    array_push($tax_perc_list1,$temp_ar);

                    

                    }
              $tax_perc_list=$tax_perc_list1;
              }
            //write later

            /*
                      INPUT CGST
          2-30-001-0001

          INPUT SGST 2-30-001-0005

          INPUT IGST  2-30-001-0003

          INPUT VAT - 2-30-001-0021
            */

          }else{
              $data["status"]=0;
            $data["msg"]="Please enter valid GST Number for this party";
          }
}
else if($tax_type=="UAE VAT"){

}else if($tax_type=="SAUDI VAT"){

  for($i=0;$i<count($tax_perc_list);$i++)
  {
    $tax_perc_list[$i]["tax_type"]="INPUT VAT";
    $tax_perc_list[$i]["tax_gl"]="2-30-001-0021";
  }
  $data["status"]=1;

}else if($tax_type=="NO TAX"){

}

if($data["status"]==1)
{
//reset status
$data["status"]=0;

$tax_status_count=0;
//update header tax amount
for($i=0;$i<count($tax_perc_list);$i++)
{
$statement = $db->prepare("INSERT INTO sin_taxes(doc_number,tax_percent,tax_amount,ip,ua,ekey,created_by,created_date) VALUES(:doc_number,:tax_percent,:tax_amount,:ip,:ua,:ekey,:created_by,now())");
$stmt_rowcount=$statement->execute(array(
  ':created_by'=>$dev->username,
':ip'=>$dev->ip,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,
':doc_number'=>$c->doc_number,
':tax_percent'=>$tax_perc_list[$i]["tax"],
':tax_amount'=>$tax_perc_list[$i]["tax_amt"],
));
if($stmt_rowcount)
{
$tax_status_count+=1;
$data["tax_status_ins".($i+1)]=1;
}else{
$data["tax_status_ins".($i+1)]=0;
}

}

$statement = $db->prepare("INSERT into mt_ap_gl_details  
(
pre_glt_company,
pre_glt_code,
pre_glt_doc_base,
pre_glt_doc_type,
pre_glt_doc_number,
pre_glt_doc_date,
pre_glt_gl_date,
pre_glt_year,
pre_glt_period,
pre_glt_other_reference,
pre_glt_currency,
pre_glt_ex_rate,
pre_glt_foreign_amount,
pre_glt_local_amount,
pre_glt_narration,
pre_glt_detail_1,
pre_glt_detail_2,
pre_glt_detail_3,
location_id,
company_id,
created_by,
created_date,
ip,
ua,
ekey,
temp_code
)
SELECT 
company_id,
(select gl_account from mt_gl_link where name='PAYABLE' limit 1),
'$c->aph_document_base',
'$c->aph_document_type',
aph_document_number,
'$c->aph_document_date',
'$c->aph_document_date',
".self::getFinancialYear().",
".self::getFinancialPeriod($c->aph_document_date).",
aph_other_reference,
aph_currency,
aph_exchange_rate,
'$header_amount',
'$header_amount',
aph_narration,
(select gl_account from mt_gl_link where name='PAYABLE' limit 1),
'PAYABLE',
aph_code,
location_id,
company_id,
created_by,
now(),
ip,
ua,
ekey,
'$temp_code'
 
FROM mt_ap_header where aph_document_number=:id");

$statement->execute(array(':id'=>$c->doc_number));

if ($statement->rowCount()){
  $data["aph_gl_status"]=1;
} else{
  $data["aph_gl_status"]=0;
}

$statement = $db->prepare("INSERT into mt_ap_gl_details  
(
pre_glt_company,
pre_glt_code,
pre_glt_doc_base,
pre_glt_doc_type,
pre_glt_doc_number,
pre_glt_doc_date,
pre_glt_gl_date,
pre_glt_year,
pre_glt_period,
pre_glt_other_reference,
pre_glt_currency,
pre_glt_ex_rate,
pre_glt_foreign_amount,
pre_glt_local_amount,
pre_glt_narration,
pre_glt_detail_1,
pre_glt_detail_2,
pre_glt_detail_3,
location_id,
company_id,
created_by,
created_date,
ip,
ua,
ekey,
temp_code
)
SELECT 

company_id,
aloc_detail_1,
'$c->aph_document_base',
'$c->aph_document_type',
aloc_doc_number,
'$c->aph_document_date',
'$c->aph_document_date',
".self::getFinancialYear().",
".self::getFinancialPeriod($c->aph_document_date).",
'$c->ref',
aloc_currency,
aloc_ex_rate,
aloc_foreign_amount,
aloc_local_amount,
aloc_narration,
aloc_detail_1,
aloc_detail_2,
aloc_detail_3,
location_id,
company_id,
created_by,
now(),
ip,
ua,
ekey,
'$temp_code'
 
FROM mt_ap_allocation_details where aloc_doc_number=:id");

$statement->execute(array(':id'=>$c->doc_number));

if ($statement->rowCount()){
  $data["ap_gl_status"]=1;
} else{
  $data["ap_gl_status"]=0;
}

//insert tax to gl

$tax_gl_status_count=0;
//update header tax amount
for($i=0;$i<count($tax_perc_list);$i++)
{

$statement = $db->prepare("INSERT into mt_ap_gl_details  
(
pre_glt_company,
pre_glt_code,
pre_glt_doc_base,
pre_glt_doc_type,
pre_glt_doc_number,
pre_glt_doc_date,
pre_glt_gl_date,
pre_glt_year,
pre_glt_period,
pre_glt_other_reference,
pre_glt_currency,
pre_glt_ex_rate,
pre_glt_foreign_amount,
pre_glt_local_amount,
pre_glt_narration,
pre_glt_detail_1,
pre_glt_detail_2,
pre_glt_detail_3,
location_id,
company_id,
created_by,
created_date,
ip,
ua,
ekey
)
VALUES(
'$dev->company',
:aloc_detail_1,
'$c->aph_document_base',
:tax_type,
:aloc_doc_number,
'$c->aph_document_date',
'$c->aph_document_date',
".self::getFinancialYear().",
".self::getFinancialPeriod($c->aph_document_date).",
'$c->ref',
:aloc_currency,
1,
:aloc_local_amount,
:aloc_local_amount,
:aloc_narration,
:aloc_detail_1,
:aloc_detail_2,
:aloc_detail_3,
'$dev->location',
'$dev->company',
'$dev->username',
now(),
'$dev->ip',
'$dev->ua',
'$dev->ekey')");

$statement->execute(array(
  ':aloc_detail_1'=>$tax_perc_list[$i]["tax_gl"],
  ':tax_type'=>$tax_perc_list[$i]["tax_type"],
  ':aloc_doc_number'=>$c->doc_number,
  ':aloc_currency'=>$c->currency,
  ':aloc_local_amount'=>$tax_perc_list[$i]["tax_amt"],
  ':aloc_detail_2'=>$tax_perc_list[$i]["tax_type"]." ".$tax_perc_list[$i]["tax"]."%",
  ':aloc_narration'=>$tax_perc_list[$i]["tax_type"]." ".$tax_perc_list[$i]["tax"]."%",
  ':aloc_detail_3'=>$c->party_code

));

if ($statement->rowCount()){
  $tax_gl_status_count+=1;
  $data["ap_gl_tax_status".($i+1)]=1;
} else{
    $data["ap_gl_tax_status".($i+1)]=0;

}

}



$statement = $db->prepare("INSERT into mt_ap_trans 
(
apt_company,
apt_code,
apt_type,
apt_number,
apt_group,
apt_base_type,
apt_doc_date,
apt_gl_date,
apt_year,
apt_period,
apt_other_reference,
apt_currency,
apt_ex_rate,
apt_foreign_amount,
apt_local_amount,
apt_foreign_balance,
apt_local_balance,
apt_balance_status,
apt_description,
location_id,
company_id,
created_by,
created_date,
ip,
ua,
ekey,
temp_code
)
SELECT 
pre_glt_company,
pre_glt_detail_3,
pre_glt_doc_type,
pre_glt_doc_number,
pre_glt_code,
pre_glt_doc_base,
pre_glt_doc_date,
pre_glt_gl_date,
pre_glt_year,
pre_glt_period,
pre_glt_other_reference,
pre_glt_currency,
pre_glt_ex_rate,
pre_glt_foreign_amount,
pre_glt_local_amount,
pre_glt_foreign_amount,
pre_glt_local_amount,
'A',
pre_glt_narration,
location_id,
company_id,
created_by,
now(),
ip,
ua,
ekey,
temp_code 
FROM mt_ap_gl_details  
WHERE pre_glt_code=(select gl_account from mt_gl_link where name='PAYABLE' limit 1) 
and pre_glt_doc_number=:id");

$statement->execute(array(':id'=>$c->doc_number));

if ($statement->rowCount()){
  $data["ap_trans_status"]=1;
} else{
  $data["ap_trans_status"]=0;
}



$statement = $db->prepare("UPDATE mt_order_cost 
  SET isdraft=2,modified_by=:modified_by,invoiced=1,inv_pay_no=:lpo_draft_no WHERE lpo_draft_no=:lpo_draft_no");
$stmt_rowcount=$statement->execute(array(
':lpo_draft_no'=>$c->doc_number,
':modified_by'=>$dev->username
  ));
  if ($stmt_rowcount){
    $data["update_oid_status1"]=1;
  } else{
    $data["update_oid_status1"]=0;
  }


$data["posted"]=2;

$temp_code=uniqid($dev->uid);
$statement = $db->prepare("UPDATE mt_ap_header  
  SET aph_status='POSTED',modified_date=now(),temp_code=:temp_code 
  where aph_document_number=:id");
$stmt_rowcount=$statement->execute(array(':id'=>$c->doc_number,':temp_code'=>$temp_code));
  
if ($stmt_rowcount){
$data["status"]=1;
} else{
$data["status"]=0;
}

//$data["status"]=0;

$data["tax_gl_status"]=0;
$data["tax_status"]=0;

if(count($tax_perc_list)>0)
{
  if(count($tax_perc_list)==$tax_gl_status_count)
  {
    $data["tax_gl_status"]=1;
    $data["tax_gl_status_add"]="all tax inserted";
  }else{
    $data["tax_gl_status"]=0;
    $data["tax_gl_status_add"]="tax insert row missing";
  }

  if(count($tax_perc_list)==$tax_status_count)
  {
    $data["tax_status"]=1;
    $data["tax_status_add"]="all tax inserted";
  }else{
    $data["tax_status"]=0;
    $data["tax_status_add"]="tax insert row missing on sin taxes";
  }

}else{
$data["tax_gl_status"]=1;
$data["tax_status"]=1;
$data["tax_gl_status_add"]="No Tax";
}

if($data["status"]==1 && $data["aph_gl_status"]==1 && $data["ap_gl_status"]==1 && $data["ap_trans_status"]==1 && $data["tax_gl_status"]==1 && $data["tax_status"]==1 && $data["update_oid_status1"]==1)
{
  $db->commit();
  $data["msg"]="Posted Voucher Successfully";

}else{
    $db->rollBack();
    $data["status"]=0;
    $data["msg"]="Unable to save. Please try again";
}

$statement=null;
}
  }
  catch (Exception $e) {
    $data["emsg"]=$e->getMessage();
    $db->rollBack();
    $data["status"]=0;
    $data["msg"]="Unable to save.Exception. Please try again";
  }
  
  return $data;
}



}
?>