<?php

require("../config/dbconn.php");

class MasterDao

{


public static function save_page_views($dev,$pname,$method)
{
$data=0;
try
{
$db = Factory::getConnection();


$statement = $db->prepare("INSERT into page_views(
ip ,uid ,ua,ekey,esecret,method,page,tz) 
values(:ip ,:uid ,
:ua ,:ekey ,:esecret ,:method ,:page,:tz)");
$statement->execute(array(':ip'=>$dev->ip,':uid'=>$dev->uid ,
':ua'=>$dev->ua,
':tz'=>$dev->tz ,
':method'=>$method ,':esecret'=>$dev->esecret,':ekey'=>$dev->ekey,
':page'=>$pname));


$data=1;
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}





public static function update_clause($dev,$c)
{
$data=0;
try
{
$db = Factory::getConnection();


$statement = $db->prepare("UPDATE mt_clause_master SET 
  code=:code,
description=:description,
liner_code=:liner_code,
clause_type=:clause_type,
status=:status,
clause_text=:clause_text,
  ip=:ip,uid=:uid,ua=:ua,ekey=:ekey,created_date= now() where id=:id");

$statement->execute(array(
  ':id'=>$c->id,
  ':ip'=>$dev->ip,':uid'=>$dev->uid ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,
':code'=>$c->code,
':description'=>$c->description,
':liner_code'=>$c->liner_code,
':clause_type'=>$c->clause_type,
':status'=>$c->status,
':clause_text'=>$c->clause_text));

if ($statement->rowCount()){
  $data=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data=0;
    //echo 'Failure: 0 rows were affected.';
}

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function search_dgcargo_list($v)
{
$data=array();
try
{
$db = Factory::getConnection();

$statement = $db->prepare("SELECT id,un_no,class,proper_ship_name from mt_dg_cargo_master where un_no like ? or class like ? or proper_ship_name like ?");
$statement ->bindValue(1, "$v%", PDO::PARAM_STR);
$statement ->bindValue(2, "$v%", PDO::PARAM_STR);
$statement ->bindValue(3, "$v%", PDO::PARAM_STR);

$statement->execute();
$data=$statement->fetchAll(PDO::FETCH_ASSOC);
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function search_clause_list($v)
{
$data=array();
try
{
$db = Factory::getConnection();

$statement = $db->prepare("SELECT id,code,description,liner_code from mt_clause_master where code like ? or description like ? or liner_code like ?");
$statement ->bindValue(1, "$v%", PDO::PARAM_STR);
$statement ->bindValue(2, "$v%", PDO::PARAM_STR);
$statement ->bindValue(3, "$v%", PDO::PARAM_STR);

$statement->execute();
$data=$statement->fetchAll(PDO::FETCH_ASSOC);
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function save_clause($dev,$c)
{
$data=0;
try
{
$db = Factory::getConnection();


$statement = $db->prepare("INSERT into mt_clause_master(code,description,liner_code,clause_type,status,clause_text,ip,uid ,ua,ekey,created_date) 
values(:code,:description,:liner_code,:clause_type,:status,:clause_text,
:ip ,:uid ,
:ua ,:ekey,now())");
$statement->execute(array(':ip'=>$dev->ip,':uid'=>$dev->uid ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,
':code'=>$c->code,
':description'=>$c->description,
':liner_code'=>$c->liner_code,
':clause_type'=>$c->clause_type,
':status'=>$c->status,
':clause_text'=>$c->clause_text));

if ($statement->rowCount()){
	$data=1;
    //echo 'Success: At least 1 row was affected.';
} else{
	$data=0;
    //echo 'Failure: 0 rows were affected.';
}

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function get_dgcargo_info($code)
{
$data=false;
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT id,un_no,class,flash_point,proper_ship_name,packing_group,class_division,subsidiary_risk,clear_living_quarters,source_heat,food_stuff,extended_stowage,extended_segregation,marine_pollutant,spl_provision,packing_instruction,packing_provision,ibc_instruction,task_instruction_imo,task_instruction_un,task_instruction_provision,ems,mfag,stowage_segregation,properties_observation,general_remarks,limited_qty,limited_qty_units,extended_segregation2,page_no,status 
  from mt_dg_cargo_master where id=:id");

$statement->execute(array(':id'=>$code));

$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function get_dgcargo_list($code)
{
$data=false;
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT id,un_no,class,proper_ship_name 
  from mt_dg_cargo_master order by id limit :sta,20");

$statement->bindValue(':sta',(int) $code->start, PDO::PARAM_INT); 
$statement->execute();

$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}



public static function get_clause_list($code)
{
$data=false;
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT id,code,description,liner_code 
  from mt_clause_master order by id limit :sta,20");

$statement->bindValue(':sta',(int) $code->start, PDO::PARAM_INT); 
$statement->execute();

$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


//
public static function update_clause_details($dev,$c)
{
$data=0;
try
{
$db = Factory::getConnection();


$statement = $db->prepare("UPDATE mt_clause_details SET 
  country=:country,
location=:location,
type=:type,
status=:status,
  ip=:ip,uid=:uid,ua=:ua,ekey=:ua,created_date=now()
  where id=:id and clause_id=:clause_id");

$statement->execute(array(':ip'=>$dev->ip,':uid'=>$dev->uid ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,
':country'=>$c->country,
':location'=>$c->location,
':type'=>$c->type,
':status'=>$c->status,
':clause_id'=>$c->clause_id,
':id'=>$c->id
));

if ($statement->rowCount()){
  $data=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data=0;
    //echo 'Failure: 0 rows were affected.';
}

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function update_dgcargo($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();


$statement = $db->prepare("UPDATE mt_dg_cargo_master SET un_no=:un_no,
class=:class,
flash_point=:flash_point,
proper_ship_name=:proper_ship_name,
packing_group=:packing_group,
class_division=:class_division,
subsidiary_risk=:subsidiary_risk,
clear_living_quarters=:clear_living_quarters,
source_heat=:source_heat,
food_stuff=:food_stuff,
extended_stowage=:extended_stowage,
extended_segregation=:extended_segregation,
marine_pollutant=:marine_pollutant,
spl_provision=:spl_provision,
packing_instruction=:packing_instruction,
packing_provision=:packing_provision,
ibc_instruction=:ibc_instruction,
task_instruction_imo=:task_instruction_imo,
task_instruction_un=:task_instruction_un,
task_instruction_provision=:task_instruction_provision,
ems=:ems,
mfag=:mfag,
stowage_segregation=:stowage_segregation,
properties_observation=:properties_observation,
general_remarks=:general_remarks,
limited_qty=:limited_qty,
limited_qty_units=:limited_qty_units,
extended_segregation2=:extended_segregation2,
page_no=:page_no,
status=:status,ip=:ip,uid=:uid,ua=:ua,ekey=:ekey,created_date= now() where id=:id");

$statement->execute(array(':ip'=>$dev->ip,':uid'=>$dev->uid ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,
':un_no'=>$c->un_no,
':class'=>$c->class,
':flash_point'=>$c->flash_point,
':proper_ship_name'=>$c->proper_ship_name,
':packing_group'=>$c->packing_group,
':class_division'=>$c->class_division,
':subsidiary_risk'=>$c->subsidiary_risk,
':clear_living_quarters'=>$c->clear_living_quarters,
':source_heat'=>$c->source_heat,
':food_stuff'=>$c->food_stuff,
':extended_stowage'=>$c->extended_stowage,
':extended_segregation'=>$c->extended_segregation,
':marine_pollutant'=>$c->marine_pollutant,
':spl_provision'=>$c->spl_provision,
':packing_instruction'=>$c->packing_instruction,
':packing_provision'=>$c->packing_provision,
':ibc_instruction'=>$c->ibc_instruction,
':task_instruction_imo'=>$c->task_instruction_imo,
':task_instruction_un'=>$c->task_instruction_un,
':task_instruction_provision'=>$c->task_instruction_provision,
':ems'=>$c->ems,
':mfag'=>$c->mfag,
':stowage_segregation'=>$c->stowage_segregation,
':properties_observation'=>$c->properties_observation,
':general_remarks'=>$c->general_remarks,
':limited_qty'=>$c->limited_qty,
':limited_qty_units'=>$c->limited_qty_units,
':extended_segregation2'=>$c->extended_segregation2,
':page_no'=>$c->page_no,
':status'=>$c->status,
':id'=>$c->id
));

if ($statement->rowCount()){
  $data=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data=0;
    //echo 'Failure: 0 rows were affected.';
}


$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function save_dgcargo($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();


$statement = $db->prepare("INSERT into mt_dg_cargo_master(un_no,class,flash_point,proper_ship_name,packing_group,class_division,subsidiary_risk,clear_living_quarters,source_heat,food_stuff,extended_stowage,extended_segregation,marine_pollutant,spl_provision,packing_instruction,packing_provision,ibc_instruction,task_instruction_imo,task_instruction_un,task_instruction_provision,ems,mfag,stowage_segregation,properties_observation,general_remarks,limited_qty,limited_qty_units,extended_segregation2,page_no,status,ip,uid ,ua,ekey,created_date) 
values(:un_no,:class,:flash_point,:proper_ship_name,:packing_group,:class_division,:subsidiary_risk,:clear_living_quarters,:source_heat,:food_stuff,:extended_stowage,:extended_segregation,:marine_pollutant,:spl_provision,:packing_instruction,:packing_provision,:ibc_instruction,:task_instruction_imo,:task_instruction_un,:task_instruction_provision,:ems,:mfag,:stowage_segregation,:properties_observation,:general_remarks,:limited_qty,:limited_qty_units,:extended_segregation2,:page_no,:status,:ip ,:uid ,
:ua ,:ekey,now())");

$statement->execute(array(':ip'=>$dev->ip,':uid'=>$dev->uid ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,
':un_no'=>$c->un_no,
':class'=>$c->class,
':flash_point'=>$c->flash_point,
':proper_ship_name'=>$c->proper_ship_name,
':packing_group'=>$c->packing_group,
':class_division'=>$c->class_division,
':subsidiary_risk'=>$c->subsidiary_risk,
':clear_living_quarters'=>$c->clear_living_quarters,
':source_heat'=>$c->source_heat,
':food_stuff'=>$c->food_stuff,
':extended_stowage'=>$c->extended_stowage,
':extended_segregation'=>$c->extended_segregation,
':marine_pollutant'=>$c->marine_pollutant,
':spl_provision'=>$c->spl_provision,
':packing_instruction'=>$c->packing_instruction,
':packing_provision'=>$c->packing_provision,
':ibc_instruction'=>$c->ibc_instruction,
':task_instruction_imo'=>$c->task_instruction_imo,
':task_instruction_un'=>$c->task_instruction_un,
':task_instruction_provision'=>$c->task_instruction_provision,
':ems'=>$c->ems,
':mfag'=>$c->mfag,
':stowage_segregation'=>$c->stowage_segregation,
':properties_observation'=>$c->properties_observation,
':general_remarks'=>$c->general_remarks,
':limited_qty'=>$c->limited_qty,
':limited_qty_units'=>$c->limited_qty_units,
':extended_segregation2'=>$c->extended_segregation2,
':page_no'=>$c->page_no,
':status'=>$c->status
));

if ($statement->rowCount()){
  $data=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data=0;
    //echo 'Failure: 0 rows were affected.';
}


$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function save_clause_details($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();
$temp_code=uniqid($dev->uid);

$statement = $db->prepare("INSERT into mt_clause_details(
  country,
location,
type,
status,ip,uid ,ua,ekey,created_date,clause_id,temp_code) 
values(:country,
:location,
:type,
:status,:ip ,:uid ,
:ua ,:ekey,now(),:clause_id,:temp_code)");

$statement->execute(array(':ip'=>$dev->ip,':uid'=>$dev->uid ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,
':country'=>$c->country,
':location'=>$c->location,
':type'=>$c->type,
':status'=>$c->status,
':clause_id'=>$c->clause_id,
':temp_code'=>$temp_code
));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}
$statement = $db->prepare("SELECT id from mt_clause_details where uid=:uid and temp_code=:temp_code and clause_id=:clause_id");
$statement->execute(array(':temp_code'=>$temp_code,
  ':uid'=>$dev->uid,':clause_id'=>$c->clause_id));
$data["id"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function delete_clause_details($id)
{
$data=0;
try
{
$db = Factory::getConnection();


$statement = $db->prepare("DELETE FROM mt_clause_details 
  where id=:id");

$statement->execute(array(
':id'=>$id
));

if ($statement->rowCount()){
  $data=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data=0;
    //echo 'Failure: 0 rows were affected.';
}

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function get_clause_info($id)
{
$data=array();
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT id,code,description,liner_code,clause_type,status,clause_text from mt_clause_master where id=:id");
$statement->execute(array(':id'=>$id));
$data["cinfo"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT id,clause_id,country,location,type,status,'0' edit 
  from mt_clause_details where clause_id=:id");
$statement->execute(array(':id'=>$id));
$data["clist"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


}

?>