<?php

require("../config/dbconn.php");

class BoxControlDao
{


public static function save_page_views($dev,$pname,$method)
{
$data=0;
try
{
$db = Factory::getConnection();


$statement = $db->prepare("INSERT into page_views(
ip ,uid ,ua,ekey,esecret,method,page,tz) 
values(:ip ,:uid ,
:ua ,:ekey ,:esecret ,:method ,:page,:tz)");
$statement->execute(array(':ip'=>$dev->ip,':uid'=>$dev->uid ,
':ua'=>$dev->ua,
':tz'=>$dev->tz ,
':method'=>$method ,':esecret'=>$dev->esecret,':ekey'=>$dev->ekey,
':page'=>$pname));


$data=1;
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function search_charge_group_detail($mc,$v)
{
$data=array();
try
{
$db = Factory::getConnection();

$statement = $db->prepare("SELECT id,code,description from mt_charge_group_detail where cg_id=(SELECT id from mt_charge_group where code=? limit 1) and (description like ? or  code like ?) order by code
  limit 50");
$statement ->bindValue(1, "$mc", PDO::PARAM_STR);
$statement ->bindValue(2, "%$v%", PDO::PARAM_STR);
$statement ->bindValue(3, "%$v%", PDO::PARAM_STR);
$statement->execute();
$data=$statement->fetchAll(PDO::FETCH_ASSOC);
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function search_eventupdation_list($v)
{
$data=false;
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT t1.id,
container_no,
event_code,
event_date,
t2.driver_name,
t2.customer,
t2.id  pk,
sig_name,sig_url 
from mt_event_updation t1, mt_event_updation_inspection t2 
where t1.id =t2.event_upd_pk and t1.event_code in ('EIS','EIC')
and (container_no like ? or t2.driver_name like ? 
or t2.customer like ? or event_date like ?)
order by t1.id desc limit 20");

$statement ->bindValue(1, "%$v%", PDO::PARAM_STR);
$statement ->bindValue(2, "%$v%", PDO::PARAM_STR);
$statement ->bindValue(3, "%$v%", PDO::PARAM_STR);
$statement ->bindValue(4, "%$v%", PDO::PARAM_STR); 

$statement->execute();
$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_eventupdation_list($code)
{
$data=false;
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT t1.id,
container_no,
event_code,
event_date,
t2.driver_name,
(SELECT name from mt_business_partner where code=t2.customer) customer,
t2.id  pk,
sig_name,sig_url 
from mt_event_updation t1, mt_event_updation_inspection t2 
where t1.id =t2.event_upd_pk and t1.event_code in ('EIS','EIC')
order by t1.id desc limit :sta,20");
$statement->bindValue(':sta',(int) $code, PDO::PARAM_INT); 
$statement->execute();
$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_gie_event_updation_list()
{
$data=false;
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT id,
container_no,
event_code,
event_date
 from mt_event_updation where event_code='GIE' and cmove_event_code='CURRENT' order by id desc");
$statement->execute();
$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function search_container($code)
{
$data=array();
try
{
$db = Factory::getConnection();
$q="";

if($code->type=="EIS")
{
$q="SELECT container_no,voyage,vessel FROM mt_event_updation
where event_code='EQD' and cmove_event_code='CURRENT'  and
  container_no like ? order by container_no limit 50 ";
}
else if($code->type=="EIC"){
$q="SELECT container_no,voyage,vessel FROM mt_event_updation
where event_code='EIS' and cmove_event_code='CURRENT' 
and container_no like ? order by container_no limit 50";
}
else if($code->type=="GIE"){
$q="SELECT container_no,voyage,vessel FROM mt_event_updation
where event_code='EIC' and cmove_event_code='CURRENT' 
and container_no like ? order by container_no limit 50";
}
$statement = $db->prepare($q);
$statement ->bindValue(1, "%$code->q%", PDO::PARAM_STR);
$statement->execute();
$data=$statement->fetchAll(PDO::FETCH_ASSOC);
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function save_error($c)
{
$data=array();
try
{
$db = Factory::getConnection();
//$temp_code=uniqid($dev->uid);
$statement = $db->prepare("INSERT into mt_error(etype,evalue) 
  values('MOBILE IMG UPLOAD',:evalue)");
$statement->execute(array(':evalue'=>$c));

if ($statement->rowCount()){
  $data["status"]=1;
} else{
  $data["status"]=0;
}
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  return $data;
}

public static function save_signature($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();
$temp_code=uniqid($dev->uid);

//UPDATE CURRENT TO HISTORY
$statement = $db->prepare("UPDATE mt_event_updation_inspection  
set sig_name=:name,sig_url=:url 
WHERE id=:id ");
$statement->execute(array(':id'=>$c->pk,':name'=>$c->file_name,
':url'=>$c->file_url));

if ($statement->rowCount()){
  $data["status"]=1;
} else{
  $data["status"]=0;
}

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function update_mobile_upload_event_updation($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

//UPDATE CURRENT TO HISTORY
$statement = $db->prepare("UPDATE mt_event_updation_inspection  
set driver_name=:driver_name,driver_id=:driver_id,truck_no=:truck_no,
modified_by=:modified_by,modified_date=now(),mobile_no=:mobile_no,
new_ty_no=:new_ty_no,old_ty_no=:old_ty_no,
chase_no=:chase_no,generator=:generator,
gen_battery=:gen_battery,gps=:gps,
tyre1_lhs_serial_no=:tyre1_lhs_serial_no,
tyre2_lhs_serial_no=:tyre2_lhs_serial_no,
tyre3_lhs_serial_no=:tyre3_lhs_serial_no,
left_side_light=:left_side_light,
right_side_light=:right_side_light,
door_condition=:door_condition,
door_lock=:door_lock,
spare_tyre=:spare_tyre,
spare_tyre_sr_no=:spare_tyre_sr_no,
remarks=:remarks,
min_temp=:min_temp,max_temp=:max_temp,
actual_temp=:max_temp,gen_repair_amt=:gen_repair_amt 
WHERE id=:id");
$statement->execute(array(':id'=>$c->id,
':modified_by'=>$dev->uid,
':mobile_no'=>$c->mobile_no,
':driver_name'=>$c->driver_name,
':driver_id'=>$c->driver_id,
':truck_no'=>$c->truck_no,

':new_ty_no'=>$c->new_ty_no,
':old_ty_no'=>$c->old_ty_no,
':chase_no'=>$c->chase_no,
':generator'=>$c->generator,
':gen_battery'=>$c->gen_battery,
':gps'=>$c->gps,
':tyre1_lhs_serial_no'=>$c->tyre1_lhs_serial_no,
':tyre2_lhs_serial_no'=>$c->tyre2_lhs_serial_no,
':tyre3_lhs_serial_no'=>$c->tyre3_lhs_serial_no,
':left_side_light'=>$c->left_side_light,
':right_side_light'=>$c->right_side_light,
':door_condition'=>$c->door_condition,
':door_lock'=>$c->door_lock,
':spare_tyre'=>$c->spare_tyre,
':spare_tyre_sr_no'=>$c->spare_tyre_sr_no,
':remarks'=>$c->remarks,
':min_temp'=>$c->min_temp,
':max_temp'=>$c->max_temp,
':actual_temp'=>$c->actual_temp,
':gen_repair_amt'=>$c->gen_repair_amt
));

if ($statement->rowCount()){
  $data["status"]=1;
} else{
  $data["status"]=0;
}

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_image_list($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT attachment_1 from  mt_event_updation_inspection  WHERE id=:id");
$statement->execute(array(
  ':id'=>$c->id
));
$data=$statement->fetchAll(PDO::FETCH_ASSOC);
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  return $data;
}

public static function update_image($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$statement = $db->prepare("UPDATE mt_event_updation_inspection 
  SET attachment_1=CONCAT(IFNULL(attachment_1,''),'".$c->attachment_1."'),modified_date=now() WHERE id=:id");
$statement->execute(array(
  ':id'=>$c->id
));
if ($statement->rowCount()){
  $data=1;
} else{
  $data=0;
}

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function save_mobile_upload_event_updation($dev,$c,$f2,$acs)
{
$data=array();
try
{
$db = Factory::getConnection();
$temp_code=uniqid($dev->uid);


//UPDATE CURRENT TO HISTORY
$statement = $db->prepare("UPDATE mt_event_updation 
set cmove_event_code='HISTORY' 
WHERE id=:id");
$statement->execute(array(':id'=>$f2->id));

if ($statement->rowCount()){
  $data["history_status"]=1;
} else{
  $data["history_status"]=0;
}
$statement = $db->prepare("SELECT * from mt_event_updation 
WHERE container_no=:container_no and voyage=:voyage and 
event_code=:event_code");
$statement->execute(array(':container_no'=>$c->container_no,
':voyage'=>$f2->voyage,':event_code'=>$c->event_code));
$opts=$statement->fetchAll(PDO::FETCH_ASSOC);

if(count($opts)==0)
{
//insert starts
$statement = $db->prepare("INSERT into mt_event_updation(container_no,event_code,event_date,
  container_type,owner_status,location,terminal,depot,mafi_type,mafi_no,voyage,eline,origin,load_port,discharge_port,final_destination,erelease,eorder,bl_no,vgm_weight,gross_weight,tare_weight,net_weight,cargo_weight,commodity,customer_category,feeder_voyage,truck_no,transporter,customer,do_no,train_no,oog,reefer,imco,stowage,batch_no,batch_date,entry_type,remarks,cmove_event_code,cmove_event_date,cmove_entry_type,cmove_location,cargo_type,
  location_id,company_id,ip,uid,ua,ekey,created_date,temp_code,vessel,created_by) 
values(:container_no,:event_code,curdate(),
:container_type,:owner_status,:location,:terminal,:depot,:mafi_type,:mafi_no,:voyage,:eline,:origin,:load_port,:discharge_port,:final_destination,:erelease,:eorder,:bl_no,:vgm_weight,:gross_weight,:tare_weight,:net_weight,:cargo_weight,:commodity,:customer_category,:feeder_voyage,:truck_no,:transporter,:customer,:do_no,:train_no,:oog,:reefer,:imco,:stowage,:batch_no,:batch_date,:entry_type,:remarks,:cmove_event_code,:cmove_event_date,:cmove_entry_type,:cmove_location,:cargo_type,
'',0,:ip ,:uid ,:ua ,:ekey,now(), :temp_code,:vessel,:created_by)");

$statement->execute(array(':ip'=>$dev->ip,':uid'=>$dev->uid ,':ua'=>$dev->ua,':ekey'=>$dev->ekey,
':container_no'=>$c->container_no,
':event_code'=>$c->event_code,

':container_type'=>$f2->container_type,
':owner_status'=>$f2->owner_status,
':location'=>$f2->location,
':terminal'=>$f2->terminal,
':depot'=>$f2->depot,
':mafi_type'=>$f2->mafi_type,
':mafi_no'=>$f2->mafi_no,
':voyage'=>$f2->voyage,
':eline'=>$f2->eline,
':origin'=>$f2->origin,
':load_port'=>$f2->load_port,
':discharge_port'=>$f2->discharge_port,
':final_destination'=>$f2->final_destination,
':erelease'=>$f2->erelease,
':eorder'=>$f2->eorder,
':bl_no'=>$f2->bl_no,
':vgm_weight'=>$f2->vgm_weight,
':gross_weight'=>$f2->gross_weight,
':tare_weight'=>$f2->tare_weight,
':net_weight'=>$f2->net_weight,
':cargo_weight'=>$f2->cargo_weight,
':commodity'=>$f2->commodity,
':customer_category'=>$f2->customer_category,
':feeder_voyage'=>$f2->feeder_voyage,
':truck_no'=>$f2->truck_no,
':transporter'=>$f2->transporter,
':customer'=>$f2->customer,
':do_no'=>$f2->do_no,
':train_no'=>$f2->train_no,
':oog'=>$f2->oog,
':reefer'=>$f2->reefer,
':imco'=>$f2->imco,
':stowage'=>$f2->stowage,
':batch_no'=>$f2->batch_no,
':batch_date'=>$f2->batch_date,
':entry_type'=>$f2->entry_type,
':remarks'=>$f2->remarks,
':cmove_event_code'=>'CURRENT',
':cmove_event_date'=>$f2->cmove_event_date,
':cmove_entry_type'=>$f2->cmove_entry_type,
':cmove_location'=>$f2->cmove_location,
':cargo_type'=>$f2->cargo_type,

':temp_code'=>$temp_code,
':vessel'=>$f2->vessel,
':created_by'=>'TESTUSER'
));

if ($statement->rowCount()){
  $data["eveupd_status"]=1;
  $data["status"]=1;
} else{
  $data["eveupd_status"]=0;
  $data["status"]=0;

}

//Get PK
$statement = $db->prepare("SELECT id from mt_event_updation where uid=:uid and temp_code=:temp_code");
$statement->execute(array(':temp_code'=>$temp_code,':uid'=>$dev->uid));
$event_upd_pk=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;

$statement = $db->prepare("INSERT INTO mt_event_updation_inspection
(event_upd_pk,inspection_date,valid_till,customer,vessel,eta,re_export_vessel,bl_no,pol,new_ty_no,truck_no,driver_name,driver_id,mobile_no,old_ty_no,chase_no,generator,gen_battery,gps,tyre1_lhs_serial_no,tyre2_lhs_serial_no,tyre3_lhs_serial_no,left_side_light,right_side_light,door_condition,door_lock,spare_tyre,spare_tyre_sr_no,remarks,attachment_1,
location_id,company_id,
  ip,uid ,ua,ekey,created_date,min_temp,max_temp,actual_temp,gen_repair_amt)
VALUES
(:event_upd_pk,now(),:valid_till,:customer,:vessel,:eta,:re_export_vessel,:bl_no,:pol,:new_ty_no,:truck_no,:driver_name,:driver_id,:mobile_no,:old_ty_no,:chase_no,:generator,:gen_battery,:gps,:tyre1_lhs_serial_no,:tyre2_lhs_serial_no,:tyre3_lhs_serial_no,:left_side_light,:right_side_light,:door_condition,:door_lock,:spare_tyre,:spare_tyre_sr_no,:remarks,:attachment_1,'',0,
:ip ,:uid ,:ua ,:ekey,now(),:min_temp,:max_temp,:actual_temp,:gen_repair_amt)");

$statement->execute(array(':ip'=>$dev->ip,':uid'=>$dev->uid ,':ua'=>$dev->ua,':ekey'=>$dev->ekey,
':event_upd_pk'=>$event_upd_pk[0]["id"],
':valid_till'=>$c->valid_till,
':customer'=>$c->customer,
':vessel'=>$c->vessel,
':eta'=>$c->eta,
':re_export_vessel'=>$c->re_export_vessel,
':bl_no'=>$c->bl_no,
':pol'=>$c->pol,
':new_ty_no'=>$c->new_ty_no,
':truck_no'=>$c->truck_no,
':driver_name'=>$c->driver_name,
':driver_id'=>$c->driver_id,
':mobile_no'=>$c->mobile_no,
':old_ty_no'=>$c->old_ty_no,
':chase_no'=>$c->chase_no,
':generator'=>$c->generator,
':gen_battery'=>$c->gen_battery,
':gps'=>$c->gps,
':tyre1_lhs_serial_no'=>$c->tyre1_lhs_serial_no,
':tyre2_lhs_serial_no'=>$c->tyre2_lhs_serial_no,
':tyre3_lhs_serial_no'=>$c->tyre3_lhs_serial_no,
':left_side_light'=>$c->left_side_light,
':right_side_light'=>$c->right_side_light,
':door_condition'=>$c->door_condition,
':door_lock'=>$c->door_lock,
':spare_tyre'=>$c->spare_tyre,
':spare_tyre_sr_no'=>$c->spare_tyre_sr_no,
':remarks'=>$c->remarks,
':attachment_1'=>$c->attachment_1,
':min_temp'=>$c->min_temp,
':max_temp'=>$c->max_temp,
':actual_temp'=>$c->actual_temp,
':gen_repair_amt'=>$c->gen_repair_amt
));

if ($statement->rowCount()){
  $data["eveupd_ins_status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data["eveupd_ins_status"]=0;
    //echo 'Failure: 0 rows were affected.';
}

for($i=0;$i<count($acs);$i++)
{
  $r=$acs[$i];
//insert charges in the order cost
$statement = $db->prepare("INSERT INTO mt_order_cost (order_id ,  route,type ,charge_desc ,pay_at_location ,mode_of_pay ,     commodity ,qty ,currency ,ex_rate ,rate_selling ,   selling_amount ,selling_base_amount,  billing_party ,ip ,ua ,  created_by ,  created_date, inspec_charge) 
VALUES ( (SELECT id from mt_order_entry where order_no='$f2->eorder'), '1', 'INCOME',:charge_desc,:pay_at_location, 'COLLECT',  :commodity,'1','QAR','1',:amount,:amount,
:amount,:customer,:ip,:ua,:created_by,now(),'YES')");

$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->username ,':ua'=>$dev->ua,':ekey'=>$dev->ekey,
':amount'=>$r->amt,':customer'=>$f2->customer,
':commodity'=>$f2->commodity,
':pay_at_location'=>$f2->location,
':charge_desc'=>$r->charge));
if ($statement->rowCount()){
  $data["ord_cost_status".($i+1)]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data["ord_cost_status".($i+1)]=0;
    //echo 'Failure: 0 rows were affected.';
}

}

}else{
  $data["status"]=2;
}
//end of order cost
//insert ends

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function save_gie_eventupdation($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();
$temp_code=uniqid($dev->uid);

//GET CURRENT RECORD
$statement = $db->prepare("SELECT id, container_no,event_code,event_date,container_type,owner_status,location,terminal,depot,mafi_type,mafi_no,vessel,voyage,eline,origin,load_port,
discharge_port,final_destination,erelease,eorder,bl_no,vgm_weight,gross_weight,tare_weight,net_weight,cargo_weight,commodity,customer_category,
feeder_voyage,truck_no,transporter,customer,do_no,train_no,oog,reefer,imco,stowage,batch_no,batch_date,entry_type,remarks,cmove_event_code,
cmove_event_date,cmove_entry_type,cmove_location,cargo_type
FROM mt_event_updation 
WHERE event_code='EIC' and cmove_event_code='CURRENT' and container_no=:container_no");
$statement->execute(array(':container_no'=>$c->container_no));
$data["prev"]=$statement->fetchAll(PDO::FETCH_ASSOC);

//UPDATE CURRENT TO HISTORY
$statement = $db->prepare("UPDATE mt_event_updation 
set cmove_event_code='HISTORY' 
WHERE id=:id");
$statement->execute(array(':id'=>$data["prev"][0]["id"]));

if ($statement->rowCount()){
  $data["history_status"]=1;
} else{
  $data["history_status"]=0;
}

$nc=$data["prev"][0];
//INSERT CURRENT RECORD
$statement = $db->prepare("INSERT into mt_event_updation(container_no,event_code,event_date,
  container_type,owner_status,location,terminal,depot,mafi_type,mafi_no,voyage,eline,origin,load_port,discharge_port,final_destination,erelease,eorder,bl_no,vgm_weight,gross_weight,tare_weight,net_weight,cargo_weight,commodity,customer_category,feeder_voyage,truck_no,transporter,customer,do_no,train_no,oog,reefer,imco,stowage,batch_no,batch_date,entry_type,remarks,cmove_event_code,cmove_event_date,cmove_entry_type,cmove_location,cargo_type,
  location_id,company_id,ip,uid,ua,ekey,created_date,temp_code,vessel,created_by) 
values(:container_no,:event_code,curdate(),
:container_type,:owner_status,:location,:terminal,:depot,:mafi_type,:mafi_no,:voyage,:eline,:origin,:load_port,:discharge_port,:final_destination,:erelease,:eorder,:bl_no,:vgm_weight,:gross_weight,:tare_weight,:net_weight,:cargo_weight,:commodity,:customer_category,:feeder_voyage,:truck_no,:transporter,:customer,:do_no,:train_no,:oog,:reefer,:imco,:stowage,:batch_no,:batch_date,:entry_type,:remarks,'CURRENT', :cmove_event_date,:cmove_entry_type,:cmove_location,:cargo_type,
'',0,:ip ,:uid ,:ua ,:ekey,now(), :temp_code,:vessel,:created_by)");

$statement->execute(array(':ip'=>$dev->ip,':uid'=>$dev->uid ,':ua'=>$dev->ua,':ekey'=>$dev->ekey,
':container_no'=>$c->container_no,
':event_code'=>$c->event_code,

':container_type'=>$nc["container_type"],
':owner_status'=>$nc["owner_status"],
':location'=>$nc["location"],
':terminal'=>$nc["terminal"],
':depot'=>$nc["depot"],
':mafi_type'=>$nc["mafi_type"],
':mafi_no'=>$nc["mafi_no"],
':voyage'=>$nc["voyage"],
':eline'=>$nc["eline"],
':origin'=>$nc["origin"],
':load_port'=>$nc["load_port"],
':discharge_port'=>$nc["discharge_port"],
':final_destination'=>$nc["final_destination"],
':erelease'=>$nc["erelease"],
':eorder'=>$nc["eorder"],
':bl_no'=>$nc["bl_no"],
':vgm_weight'=>$nc["vgm_weight"],
':gross_weight'=>$nc["gross_weight"],
':tare_weight'=>$nc["tare_weight"],
':net_weight'=>$nc["net_weight"],
':cargo_weight'=>$nc["cargo_weight"],
':commodity'=>$nc["commodity"],
':customer_category'=>$nc["customer_category"],
':feeder_voyage'=>$nc["feeder_voyage"],
':truck_no'=>$nc["truck_no"],
':transporter'=>$nc["transporter"],
':customer'=>$nc["customer"],
':do_no'=>$nc["do_no"],
':train_no'=>$nc["train_no"],
':oog'=>$nc["oog"],
':reefer'=>$nc["reefer"],
':imco'=>$nc["imco"],
':stowage'=>$nc["stowage"],
':batch_no'=>$nc["batch_no"],
':batch_date'=>$nc["batch_date"],
':entry_type'=>$nc["entry_type"],
':remarks'=>$nc["remarks"],
':cmove_event_date'=>$nc["cmove_event_date"],
':cmove_entry_type'=>$nc["cmove_entry_type"],
':cmove_location'=>$nc["cmove_location"],
':cargo_type'=>$nc["cargo_type"],

':temp_code'=>$temp_code,
':vessel'=>$nc["vessel"],
':created_by'=>'TESTUSER'
));

if ($statement->rowCount()){
  $data["eveupd_status"]=1;
} else{
  $data["eveupd_status"]=0;
}

//Get PK
$statement = $db->prepare("SELECT id from mt_event_updation where uid=:uid and temp_code=:temp_code");
$statement->execute(array(':temp_code'=>$temp_code,':uid'=>$dev->uid));
$event_upd_pk=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

//
public static function save_gie_eventupdation1($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();
$temp_code=uniqid($dev->uid);

//GET CURRENT RECORD
$statement = $db->prepare("SELECT id, container_no,event_code,event_date,container_type,owner_status,location,terminal,depot,mafi_type,mafi_no,vessel,voyage,eline,origin,load_port,
discharge_port,final_destination,erelease,eorder,bl_no,vgm_weight,gross_weight,tare_weight,net_weight,cargo_weight,commodity,customer_category,
feeder_voyage,truck_no,transporter,customer,do_no,train_no,oog,reefer,imco,stowage,batch_no,batch_date,entry_type,remarks,cmove_event_code,
cmove_event_date,cmove_entry_type,cmove_location,cargo_type
FROM mt_event_updation 
WHERE event_code='EIC' and cmove_event_code='CURRENT' and container_no=:container_no");
$statement->execute(array(':container_no'=>$c->container_no));
$data["prev"]=$statement->fetchAll(PDO::FETCH_ASSOC);

//UPDATE CURRENT TO HISTORY
$statement = $db->prepare("UPDATE mt_event_updation 
set cmove_event_code='HISTORY' 
WHERE id=:id");
$statement->execute(array(':id'=>$data["prev"][0]["id"]));

if ($statement->rowCount()){
  $data["history_status"]=1;
} else{
  $data["history_status"]=0;
}

$nc=$data["prev"][0];
//INSERT CURRENT RECORD
$statement = $db->prepare("INSERT into mt_event_updation(container_no,event_code,event_date,
  container_type,owner_status,location,terminal,depot,mafi_type,mafi_no,voyage,eline,origin,load_port,discharge_port,final_destination,erelease,eorder,bl_no,vgm_weight,gross_weight,tare_weight,net_weight,cargo_weight,commodity,customer_category,feeder_voyage,truck_no,transporter,customer,do_no,train_no,oog,reefer,imco,stowage,batch_no,batch_date,entry_type,remarks,cmove_event_code,cmove_event_date,cmove_entry_type,cmove_location,cargo_type,
  location_id,company_id,ip,uid,ua,ekey,created_date,temp_code,vessel,created_by,parking,agent_name) 
values(:container_no,:event_code,curdate(),
:container_type,:owner_status,:location,:terminal,:depot,:mafi_type,:mafi_no,:voyage,:eline,:origin,:load_port,:discharge_port,:final_destination,:erelease,:eorder,:bl_no,:vgm_weight,:gross_weight,:tare_weight,:net_weight,:cargo_weight,:commodity,:customer_category,:feeder_voyage,:truck_no,:transporter,:customer,:do_no,:train_no,:oog,:reefer,:imco,:stowage,:batch_no,:batch_date,:entry_type,:remarks,'CURRENT', :cmove_event_date,:cmove_entry_type,:cmove_location,:cargo_type,
'',0,:ip ,:uid ,:ua ,:ekey,now(), :temp_code,:vessel,:created_by,:parking,:agent_name)");

$statement->execute(array(':ip'=>$dev->ip,':uid'=>$dev->uid ,':ua'=>$dev->ua,':ekey'=>$dev->ekey,
':container_no'=>$c->container_no,
':event_code'=>$c->event_code,

':container_type'=>$nc["container_type"],
':owner_status'=>$nc["owner_status"],
':location'=>$nc["location"],
':terminal'=>$nc["terminal"],
':depot'=>$nc["depot"],
':mafi_type'=>$nc["mafi_type"],
':mafi_no'=>$nc["mafi_no"],
':voyage'=>$nc["voyage"],
':eline'=>$nc["eline"],
':origin'=>$nc["origin"],
':load_port'=>$nc["load_port"],
':discharge_port'=>$nc["discharge_port"],
':final_destination'=>$nc["final_destination"],
':erelease'=>$nc["erelease"],
':eorder'=>$nc["eorder"],
':bl_no'=>$nc["bl_no"],
':vgm_weight'=>$nc["vgm_weight"],
':gross_weight'=>$nc["gross_weight"],
':tare_weight'=>$nc["tare_weight"],
':net_weight'=>$nc["net_weight"],
':cargo_weight'=>$nc["cargo_weight"],
':commodity'=>$nc["commodity"],
':customer_category'=>$nc["customer_category"],
':feeder_voyage'=>$nc["feeder_voyage"],
':truck_no'=>$nc["truck_no"],
':transporter'=>$nc["transporter"],
':customer'=>$nc["customer"],
':do_no'=>$nc["do_no"],
':train_no'=>$nc["train_no"],
':oog'=>$nc["oog"],
':reefer'=>$nc["reefer"],
':imco'=>$nc["imco"],
':stowage'=>$nc["stowage"],
':batch_no'=>$nc["batch_no"],
':batch_date'=>$nc["batch_date"],
':entry_type'=>$nc["entry_type"],
':remarks'=>$c->remarks,
':cmove_event_date'=>$nc["cmove_event_date"],
':cmove_entry_type'=>$nc["cmove_entry_type"],
':cmove_location'=>$nc["cmove_location"],
':cargo_type'=>$nc["cargo_type"],

':temp_code'=>$temp_code,
':vessel'=>$nc["vessel"],
':created_by'=>'TESTUSER',

':parking'=>$c->parking,
':agent_name'=>$c->agent_name
));

if ($statement->rowCount()){
  $data["eveupd_status"]=1;
} else{
  $data["eveupd_status"]=0;
}

//Get PK
$statement = $db->prepare("SELECT id from mt_event_updation where uid=:uid and temp_code=:temp_code");
$statement->execute(array(':temp_code'=>$temp_code,':uid'=>$dev->uid));
$event_upd_pk=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

//

public static function get_info($code)
{
$data=false;
try
{
$db = Factory::getConnection();
$q="SELECT id,valid_till,customer,vessel,eta,re_export_vessel,bl_no,pol,new_ty_no,truck_no,driver_name,driver_id,mobile_no,old_ty_no,chase_no,generator,gen_battery,gps,tyre1_lhs_serial_no,tyre2_lhs_serial_no,tyre3_lhs_serial_no,left_side_light,right_side_light,door_condition,door_lock,spare_tyre,spare_tyre_sr_no,remarks,min_temp,max_temp,actual_temp,gen_repair_amt from mt_event_updation_inspection where id=:id";

$statement = $db->prepare($q);
$statement->execute(array(':id'=>$code));
$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function get_eventupdation_inspection_info1($code)
{
$data=false;
try
{
$db = Factory::getConnection();
$q="";
if($code->type=="EIS")
{
  $q="SELECT id,'' event_upd_pk,container_no,container_type,owner_status,location,terminal,depot,mafi_type,mafi_no,voyage,vessel,
(select eta from mt_voyage where voyage=t1.voyage) eta,
eline,origin,load_port,discharge_port,final_destination,erelease,eorder,bl_no,vgm_weight,gross_weight,tare_weight,net_weight,cargo_weight,commodity,customer_category,feeder_voyage,truck_no,transporter,customer,do_no,train_no,oog,reefer,imco,stowage,batch_no,batch_date,entry_type,remarks,cmove_event_code,cmove_event_date,cmove_entry_type,cmove_location,cargo_type 
from  mt_event_updation t1  
 where container_no=:c_no and voyage=:voyage and event_code='EQD' limit 1 ";
}else if($code->type=="EIC")
{
  $q="SELECT t2.id,t1.event_upd_pk,t1.valid_till,t1.customer,t1.vessel,t1.eta,t1.re_export_vessel,t1.bl_no,t1.pol,t1.new_ty_no,t1.truck_no,t1.driver_name,
t1.driver_id,t1.mobile_no,t1.old_ty_no,t1.chase_no,t1.generator,t1.gen_battery,t1.gps,t1.tyre1_lhs_serial_no,t1.tyre2_lhs_serial_no,t1.tyre3_lhs_serial_no,
t1.left_side_light,t1.right_side_light,t1.door_condition,t1.door_lock,t1.spare_tyre,t1.spare_tyre_sr_no,t1.remarks, 
t2.container_no,t2.container_type,t2.owner_status,t2.location,t2.terminal,t2.depot,t2.mafi_type,t2.mafi_no,t2.voyage,t2.vessel,
(select eta from mt_voyage where voyage=t2.voyage) eta,t2.eline,t2.origin,t2.load_port,t2.discharge_port,
t2.final_destination,t2.erelease,t2.eorder,t2.bl_no,t2.vgm_weight,t2.gross_weight,t2.tare_weight,t2.net_weight,t2.cargo_weight,t2.commodity,
t2.customer_category,t2.feeder_voyage,t2.truck_no,t2.transporter,t2.customer,t2.do_no,t2.train_no,t2.oog,t2.reefer,t2.imco,t2.stowage,
t2.batch_no,t2.batch_date,t2.entry_type,t2.remarks,t2.cmove_event_code,t2.cmove_event_date,t2.cmove_entry_type,t2.cmove_location,t2.cargo_type
from mt_event_updation_inspection t1, mt_event_updation t2  
where t2.id=t1.event_upd_pk and t2.container_no=:c_no and t2.cmove_event_code='CURRENT' and t2.voyage=:voyage";
}
$statement = $db->prepare($q);
$statement->execute(array(':c_no'=>$code->c_no,
  ':voyage'=>$code->voyage));
$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_eventupdation_inspection_info($code)
{
$data=false;
try
{
$db = Factory::getConnection();
$q="";
if($code->type=="EIS")
{
  $q="SELECT id,'' event_upd_pk,container_no,container_type,owner_status,location,terminal,depot,mafi_type,mafi_no,voyage,vessel,
(select eta from mt_voyage where voyage=t1.voyage) eta,
eline,origin,load_port,discharge_port,final_destination,erelease,eorder,bl_no,vgm_weight,gross_weight,tare_weight,net_weight,cargo_weight,commodity,customer_category,feeder_voyage,truck_no,transporter,customer,do_no,train_no,oog,reefer,imco,stowage,batch_no,batch_date,entry_type,remarks,cmove_event_code,cmove_event_date,cmove_entry_type,cmove_location,cargo_type 
from  mt_event_updation t1  
 where container_no=:c_no and event_code='EQD' limit 1 ";
}else if($code->type=="EIC")
{
  $q="SELECT t2.id,t1.event_upd_pk,t1.valid_till,t1.customer,t1.vessel,t1.eta,t1.re_export_vessel,t1.bl_no,t1.pol,t1.new_ty_no,t1.truck_no,t1.driver_name,
t1.driver_id,t1.mobile_no,t1.old_ty_no,t1.chase_no,t1.generator,t1.gen_battery,t1.gps,t1.tyre1_lhs_serial_no,t1.tyre2_lhs_serial_no,t1.tyre3_lhs_serial_no,
t1.left_side_light,t1.right_side_light,t1.door_condition,t1.door_lock,t1.spare_tyre,t1.spare_tyre_sr_no,t1.remarks, 
t2.container_no,t2.container_type,t2.owner_status,t2.location,t2.terminal,t2.depot,t2.mafi_type,t2.mafi_no,t2.voyage,t2.vessel,
(select eta from mt_voyage where voyage=t2.voyage) eta,t2.eline,t2.origin,t2.load_port,t2.discharge_port,
t2.final_destination,t2.erelease,t2.eorder,t2.bl_no,t2.vgm_weight,t2.gross_weight,t2.tare_weight,t2.net_weight,t2.cargo_weight,t2.commodity,
t2.customer_category,t2.feeder_voyage,t2.truck_no,t2.transporter,t2.customer,t2.do_no,t2.train_no,t2.oog,t2.reefer,t2.imco,t2.stowage,
t2.batch_no,t2.batch_date,t2.entry_type,t2.remarks,t2.cmove_event_code,t2.cmove_event_date,t2.cmove_entry_type,t2.cmove_location,t2.cargo_type
from mt_event_updation_inspection t1, mt_event_updation t2  
where t2.id=t1.event_upd_pk and t2.container_no=:c_no and t2.cmove_event_code='CURRENT' ";
}
$statement = $db->prepare($q);
$statement->execute(array(':c_no'=>$code->c_no));
$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}






}

?>