<?php


require("../config/dbconn.php");

class QuoteDao

{


public static function save_page_views($dev,$pname,$method)
{
$data=0;
try
{
$db = Factory::getConnection();


$statement = $db->prepare("INSERT into page_views(
ip ,uid ,ua,ekey,esecret,method,page,tz) 
values(:ip ,:uid ,
:ua ,:ekey ,:esecret ,:method ,:page,:tz)");
$statement->execute(array(':ip'=>$dev->ip,':uid'=>$dev->uid ,
':ua'=>$dev->ua,
':tz'=>$dev->tz ,
':method'=>$method ,':esecret'=>$dev->esecret,':ekey'=>$dev->ekey,
':page'=>$pname));


$data=1;
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function get_quote_details($temp_code,$id,$quote_no)
{
$data=array();
try
{

$db = Factory::getConnection();
$statement = $db->prepare("SELECT (SELECT name from mt_business_partner where code=requested_by limit 1) customer, address, quote_date,quote_no,valid_to,status, remarks, services,location_id,company_id,temp_code   
 FROM mt_quote_list where id=:id and temp_code=:temp_code 
 and quote_no=:quote_no");
$statement->execute(array(':temp_code'=>$temp_code,
  ':id'=>$id,':quote_no'=>$quote_no));
$data["info"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$quote_id=$id;

$statement = $db->prepare("SELECT 
  (select port_name from mt_port_master where port_code=t1.origin) origin, 
  (select port_name from mt_port_master where port_code=t1.destination) destination, 
  provider, route_mode, duration FROM 
mt_quote_route t1 where quote_id=:quote_id");
$statement->execute(array(':quote_id'=>$quote_id));
$data["route"]=$statement->fetchAll(PDO::FETCH_ASSOC);


$statement = $db->prepare("SELECT 
(select description from mt_charge_group_detail where code=t1.charge_description) charge_description,
basis_type,base_unit,currency,qty,
Rate,ex_rate,foreign_amount,local_amount
FROM mt_quote_rate t1 where quote_id=:quote_id and rate_type='INCOME'");
$statement->execute(array(':quote_id'=>$quote_id));
$data["charge"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT 
display_name, mobile, email
from user_master
where username in (select prepared_by from mt_quote_list where id=:quote_id)");
$statement->execute(array(':quote_id'=>$quote_id));
$data["salesman"]=$statement->fetchAll(PDO::FETCH_ASSOC);

//updating email status

$statement = $db->prepare("UPDATE mt_quote_list set status='SENT' 
  where id=:id");
$statement->execute(array(
  ':id'=>$id));

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_quote_info($code)
{

$data=false;
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT id,status,quote_no,
prepared_by,
quote_date,
valid_to,
requested_by,
address,
base_currency,
sales_ops_ref,
shipment_mode,
origin,
destination,
remarks,
services,temp_code,enquiry_reference from mt_quote_list where id=:id");

$statement->execute(array(':id'=>$code));

$data["info"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT id,quote_id,
commodity,container_type,type_qty,gross_weight,
gw_uom,gross_volume,dangerous_cargo,reefer,oog,'0' edit 
from mt_quote_commodity where quote_id=:quote_id");
$statement->execute(array(':quote_id'=>$code));
$data["commodity"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT id,quote_id,
route_mode,provider,origin,destination,transit1,duration,currency,
buying_rate,selling_rate,terms,type,'0' edit 
from mt_quote_route where quote_id=:quote_id");
$statement->execute(array(':quote_id'=>$code));
$data["route"]=$statement->fetchAll(PDO::FETCH_ASSOC);


$statement = $db->prepare("SELECT id,quote_id,
rate_provider,rate_type,charge_description,pay_at_location,
basis_type,rate,base_unit,commodity,currency,qty,
ex_rate,foreign_amount,local_amount,
'0' edit 
from mt_quote_rate where quote_id=:quote_id");
$statement->execute(array(':quote_id'=>$code));
$data["rate"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_quote_list($dev,$code)
{

$data=false;
try
{
$db = Factory::getConnection();
$aq=Factory::getRestrictionQuery($dev);
$statement = $db->prepare("SELECT id,quote_no, quote_date,valid_to, requested_by,shipment_mode,
sales_ops_ref, origin, destination, prepared_by,status,created_by,
created_date,modified_date,modified_by from mt_quote_list 
where $aq order by id desc limit :sta,50");

$statement->bindValue(':sta',(int) $code, PDO::PARAM_INT); 
$statement->execute();

$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function search_quote_list($v)
{
$data=array();
try
{
$db = Factory::getConnection();

$statement = $db->prepare("SELECT id,quote_no, quote_date,valid_to, requested_by,shipment_mode,
sales_ops_ref, origin, destination, prepared_by,status,created_by,
modified_date,modified_by from mt_quote_list where requested_by like ? or valid_to like ? or quote_no like ? order by id desc limit 50");
$statement ->bindValue(1, "%$v%", PDO::PARAM_STR);
$statement ->bindValue(2, "%$v%", PDO::PARAM_STR);
$statement ->bindValue(3, "%$v%", PDO::PARAM_STR);

$statement->execute();
$data=$statement->fetchAll(PDO::FETCH_ASSOC);
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


//copy quote


public static function copy_quote($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$temp_code=uniqid($dev->uid);

$statement = $db->prepare("INSERT into mt_quote_list(
status,
prepared_by,
quote_date,
valid_to,
requested_by,
address,
base_currency,
sales_ops_ref,
shipment_mode,
origin,
destination,
remarks,
services,
location_id,
company_id,
ip,created_by ,ua,ekey,created_date,temp_code) 

SELECT 'DRAFT',
prepared_by,
CURDATE(),
NULL,
requested_by,
address,
base_currency,
sales_ops_ref,
shipment_mode,
origin,
destination,
remarks,
services,
'$dev->location',
'$dev->company',
'$dev->ip','$dev->username','$dev->ua','$dev->ekey',now(),'$temp_code' from mt_quote_list where id=:id");
$statement->execute(array(':id'=>$c->id));

if ($statement->rowCount()){
  $data["status"]=1;

} else{
  $data["status"]=0;
}

$data["temp_code"]=$temp_code;

$statement = $db->prepare("SELECT id,origin from mt_quote_list where created_by=:uid and temp_code=:temp_code");
$statement->execute(array(':temp_code'=>$temp_code,':uid'=>$dev->username));
$op=$statement->fetchAll(PDO::FETCH_ASSOC);

$data["id"]=$op;

$fid=self::setFourDigit($op[0]["id"]);

$on="QUOTE/".date("Y")."/".date('m')."/".$op[0]["origin"]."/".$fid;

 $statement = $db->prepare("UPDATE mt_quote_list 
  SET quote_no=:ond where id=:id");
  $statement->execute(array(':id'=>$op[0]["id"],':ond'=>$on));
  
    if ($statement->rowCount()){
    $data["qid_status"]=1;
      //echo 'Success: At least 1 row was affected.';
  } else{
    $data["qid_status"]=0;
      //echo 'Failure: 0 rows were affected.';
  }

$data["quote_no"]=$on;

$quote_id=$fid;
//copy commodity

$statement = $db->prepare("INSERT into mt_quote_commodity(
commodity,container_type,type_qty,gross_weight,gw_uom,gross_volume,dangerous_cargo,reefer,oog,quote_id,
ip,created_by ,ua,ekey,created_date) 
SELECT commodity,container_type,type_qty,gross_weight,gw_uom,gross_volume,dangerous_cargo,reefer,oog,$quote_id,
'$dev->ip','$dev->username','$dev->ua','$dev->ekey',now() from mt_quote_commodity where quote_id=:id");

$statement->execute(array(':id'=>$c->id));
    if ($statement->rowCount()){
    $data["com_status"]=1;
      //echo 'Success: At least 1 row was affected.';
  } else{
    $data["com_status"]=0;
      //echo 'Failure: 0 rows were affected.';
  }
//copy route

$statement = $db->prepare("INSERT into mt_quote_route(route_mode,provider,origin,destination,transit1,duration,currency,buying_rate,selling_rate,terms,type,quote_id,
ip,created_by ,ua,ekey,created_date) 
SELECT route_mode,provider,origin,destination,transit1,duration,currency,buying_rate,selling_rate,terms,type,$quote_id,
'$dev->ip','$dev->username','$dev->ua','$dev->ekey',now() from mt_quote_route where quote_id=:id");

$statement->execute(array(':id'=>$c->id));
    if ($statement->rowCount()){
    $data["route_status"]=1;
      //echo 'Success: At least 1 row was affected.';
  } else{
    $data["route_status"]=0;
      //echo 'Failure: 0 rows were affected.';
  }

//copy rate

$statement = $db->prepare("INSERT into mt_quote_rate(rate_provider,rate_type,charge_description,pay_at_location,basis_type,rate,base_unit,commodity,currency,qty,ex_rate,foreign_amount,local_amount,quote_id,
ip,created_by ,ua,ekey,created_date) 
SELECT rate_provider,rate_type,charge_description,pay_at_location,basis_type,rate,base_unit,commodity,currency,qty,ex_rate,foreign_amount,local_amount,$quote_id,
'$dev->ip','$dev->username','$dev->ua','$dev->ekey',now() from mt_quote_rate where quote_id=:id");

$statement->execute(array(':id'=>$c->id));
    if ($statement->rowCount()){
    $data["rate_status"]=1;
      //echo 'Success: At least 1 row was affected.';
  } else{
    $data["rate_status"]=0;
      //echo 'Failure: 0 rows were affected.';
  }

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function update_quote($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();


$statement = $db->prepare("UPDATE mt_quote_list SET 
  status=:status,
prepared_by=:prepared_by,
quote_date=:quote_date,
valid_to=:valid_to,
requested_by=:requested_by,
address=:address,
base_currency=:base_currency,
sales_ops_ref=:sales_ops_ref,
shipment_mode=:shipment_mode,
origin=:origin,
destination=:destination,
remarks=:remarks,
services=:services, modified_by=:modified_by,
modified_date=now(),
enquiry_reference=:enquiry_reference,
valid_to=:valid_to 
where id=:id");

$statement->execute(array(
':modified_by'=>$dev->username,

':status'=>$c->status,
':prepared_by'=>$c->prepared_by,
':quote_date'=>$c->quote_date,
':valid_to'=>$c->valid_to,
':requested_by'=>$c->requested_by,
':address'=>$c->address,
':base_currency'=>$c->base_currency,
':sales_ops_ref'=>$c->sales_ops_ref,
':shipment_mode'=>$c->shipment_mode,
':origin'=>$c->origin,
':destination'=>$c->destination,
':remarks'=>$c->remarks,
':services'=>$c->services,
':valid_to'=>$c->valid_to,

':id'=>$c->id,
':enquiry_reference'=>$c->enquiry_reference
));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
  /*

  */
} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}


$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function delete_quote_rate($c)
{
$data=array();
try
{
$db = Factory::getConnection();

$statement = $db->prepare("DELETE FROM mt_quote_rate 
  where id=:id");
$statement->execute(array(':id'=>$c));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  return $data;
}

public static function delete_quote_route($c)
{
$data=array();
try
{
$db = Factory::getConnection();

$statement = $db->prepare("DELETE FROM mt_quote_route 
  where id=:id");
$statement->execute(array(':id'=>$c));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  return $data;
}

public static function delete_quote_commodity($c)
{
$data=array();
try
{
$db = Factory::getConnection();


$statement = $db->prepare("DELETE FROM mt_quote_commodity 
  where id=:id");

$statement->execute(array(':id'=>$c));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
  /*

  */
} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}


$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function update_quote_commodity($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$statement = $db->prepare("UPDATE mt_quote_commodity SET 
  commodity=:commodity,
container_type=:container_type,
type_qty=:type_qty,
gross_weight=:gross_weight,
gw_uom=:gw_uom,
gross_volume=:gross_volume,
dangerous_cargo=:dangerous_cargo,
reefer=:reefer,
oog=:oog,
  ip=:ip,created_by=:created_by,ua=:ua,ekey=:ekey,created_date= now() where id=:id and quote_id=:quote_id
  ");

$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->uid ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,

':commodity'=>$c->commodity,
':container_type'=>$c->container_type,
':type_qty'=>$c->type_qty,
':gross_weight'=>$c->gross_weight,
':gw_uom'=>$c->gw_uom,
':gross_volume'=>$c->gross_volume,
':dangerous_cargo'=>$c->dangerous_cargo,
':reefer'=>$c->reefer,
':oog'=>$c->oog,

':quote_id'=>$c->quote_id,
':id'=>$c->id
));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
  /*

  */
} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}


$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function update_quote_rate($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();


$statement = $db->prepare("UPDATE mt_quote_rate SET 
  rate_provider=:rate_provider,
rate_type=:rate_type,
charge_description=:charge_description,
pay_at_location=:pay_at_location,
basis_type=:basis_type,
rate=:rate,
base_unit=:base_unit,
commodity=:commodity,
currency=:currency,
qty=:qty,
ex_rate=:ex_rate,
foreign_amount=:foreign_amount,
local_amount=:local_amount,
  ip=:ip,created_by=:created_by,ua=:ua,ekey=:ekey,created_date= now() where id=:id and quote_id=:quote_id");

$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->uid ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,

':rate_provider'=>$c->rate_provider,
':rate_type'=>$c->rate_type,
':charge_description'=>$c->charge_description,
':pay_at_location'=>$c->pay_at_location,
':basis_type'=>$c->basis_type,
':rate'=>$c->rate,
':base_unit'=>$c->base_unit,
':commodity'=>$c->commodity,
':currency'=>$c->currency,
':qty'=>$c->qty,
':ex_rate'=>$c->ex_rate,
':foreign_amount'=>$c->foreign_amount,
':local_amount'=>$c->local_amount,

':quote_id'=>$c->quote_id,
':id'=>$c->id
));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';

} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function save_quote_rate($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$temp_code=uniqid($dev->uid);

$statement = $db->prepare("INSERT into mt_quote_rate(rate_provider,rate_type,charge_description,pay_at_location,basis_type,rate,base_unit,commodity,currency,qty,ex_rate,foreign_amount,local_amount,quote_id,
ip,created_by ,ua,ekey,created_date,temp_code) 
values(:rate_provider,:rate_type,:charge_description,:pay_at_location,:basis_type,:rate,:base_unit,:commodity,:currency,:qty,:ex_rate,:foreign_amount,:local_amount,:quote_id,
:ip ,:created_by ,
:ua ,:ekey,now(),:temp_code)");

$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->uid ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,

':rate_provider'=>$c->rate_provider,
':rate_type'=>$c->rate_type,
':charge_description'=>$c->charge_description,
':pay_at_location'=>$c->pay_at_location,
':basis_type'=>$c->basis_type,
':rate'=>$c->rate,
':base_unit'=>$c->base_unit,
':commodity'=>$c->commodity,
':currency'=>$c->currency,
':qty'=>$c->qty,
':ex_rate'=>$c->ex_rate,
':foreign_amount'=>$c->foreign_amount,
':local_amount'=>$c->local_amount,

':quote_id'=>$c->quote_id,
':temp_code'=>$temp_code
));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
  /*

  */
} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}

$statement = $db->prepare("SELECT id from mt_quote_rate where created_by=:uid and temp_code=:temp_code and quote_id=:quote_id");
$statement->execute(array(':temp_code'=>$temp_code,
  ':uid'=>$dev->uid,':quote_id'=>$c->quote_id));
$data["id"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function update_quote_route($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$statement = $db->prepare("UPDATE mt_quote_route SET 

    route_mode=:route_mode,
provider=:provider,
origin=:origin,
destination=:destination,
transit1=:transit1,
duration=:duration,
currency=:currency,
buying_rate=:buying_rate,
selling_rate=:selling_rate,
terms=:terms,
type=:type,
ip=:ip,created_by=:created_by,ua=:ua,ekey=:ekey,created_date= now() where id=:id and quote_id=:quote_id");

if($c->buying_rate=="")
{
  $c->buying_rate=null;
}
if($c->selling_rate=="")
{
  $c->selling_rate=null;
}


$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->uid ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,

':route_mode'=>$c->route_mode,
':provider'=>$c->provider,
':origin'=>$c->origin,
':destination'=>$c->destination,
':transit1'=>$c->transit1,
':duration'=>$c->duration,
':currency'=>$c->currency,
':buying_rate'=>$c->buying_rate,
':selling_rate'=>$c->selling_rate,
':terms'=>$c->terms,
':type'=>$c->type,

':quote_id'=>$c->quote_id,
':id'=>$c->id
));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';

} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}


$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function save_quote_route($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$temp_code=uniqid($dev->uid);

$statement = $db->prepare("INSERT into mt_quote_route(route_mode,provider,origin,destination,transit1,duration,currency,buying_rate,selling_rate,terms,type,quote_id,
ip,created_by ,ua,ekey,created_date,temp_code) 
values(
:route_mode,:provider,:origin,:destination,:transit1,:duration,:currency,:buying_rate,:selling_rate,:terms,:type,:quote_id,
:ip ,:created_by ,
:ua ,:ekey,now(),:temp_code)");
if($c->buying_rate=="")
{
  $c->buying_rate=null;
}
if($c->selling_rate=="")
{
  $c->selling_rate=null;
}
$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->uid ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,

':route_mode'=>$c->route_mode,
':provider'=>$c->provider,
':origin'=>$c->origin,
':destination'=>$c->destination,
':transit1'=>$c->transit1,
':duration'=>$c->duration,
':currency'=>$c->currency,
':buying_rate'=>$c->buying_rate,
':selling_rate'=>$c->selling_rate,
':terms'=>$c->terms,
':type'=>$c->type,

':quote_id'=>$c->quote_id,
':temp_code'=>$temp_code
));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
  /*

  */
} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}

$statement = $db->prepare("SELECT id from mt_quote_route where created_by=:uid and temp_code=:temp_code and quote_id=:quote_id");
$statement->execute(array(':temp_code'=>$temp_code,
  ':uid'=>$dev->uid,':quote_id'=>$c->quote_id));
$data["id"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function save_quote_commodity($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$temp_code=uniqid($dev->uid);

$statement = $db->prepare("INSERT into mt_quote_commodity(
commodity,container_type,type_qty,gross_weight,gw_uom,gross_volume,dangerous_cargo,reefer,oog,quote_id,
ip,created_by ,ua,ekey,created_date,temp_code) 
values(
:commodity,
:container_type,
:type_qty,
:gross_weight,
:gw_uom,
:gross_volume,
:dangerous_cargo,
:reefer,
:oog,:quote_id,
:ip ,:created_by ,
:ua ,:ekey,now(),:temp_code)");
if($c->gross_weight=="")
{
  $c->gross_weight=null;
}
$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->uid ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,

':commodity'=>$c->commodity,
':container_type'=>$c->container_type,
':type_qty'=>$c->type_qty,
':gross_weight'=>$c->gross_weight,
':gw_uom'=>$c->gw_uom,
':gross_volume'=>$c->gross_volume,
':dangerous_cargo'=>$c->dangerous_cargo,
':reefer'=>$c->reefer,
':oog'=>$c->oog,

':quote_id'=>$c->quote_id,
':temp_code'=>$temp_code
));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
  /*

  */
} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}

$statement = $db->prepare("SELECT id from mt_quote_commodity where created_by=:uid and temp_code=:temp_code and quote_id=:quote_id");
$statement->execute(array(':temp_code'=>$temp_code,
  ':uid'=>$dev->uid,':quote_id'=>$c->quote_id));
$data["id"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function save_quote($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$temp_code=uniqid($dev->uid);

$statement = $db->prepare("INSERT into mt_quote_list(
status,
prepared_by,
quote_date,
valid_to,
requested_by,
address,
base_currency,
sales_ops_ref,
shipment_mode,
origin,
destination,
remarks,
services,
ip,created_by ,ua,ekey,created_date,temp_code,
company_id,location_id,enquiry_reference) 
values(
:status,
:prepared_by,
:quote_date,
:valid_to,
:requested_by,
:address,
:base_currency,
:sales_ops_ref,
:shipment_mode,
:origin,
:destination,
:remarks,
:services,:ip ,:created_by ,
:ua ,:ekey,now(),:temp_code,
:company_id,:location_id,:enquiry_reference)");

$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->username ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,

':status'=>$c->status,
':prepared_by'=>$c->prepared_by,
':quote_date'=>$c->quote_date,
':valid_to'=>$c->valid_to,
':requested_by'=>$c->requested_by,
':address'=>$c->address,
':base_currency'=>$c->base_currency,
':sales_ops_ref'=>$c->sales_ops_ref,
':shipment_mode'=>$c->shipment_mode,
':origin'=>$c->origin,
':destination'=>$c->destination,
':remarks'=>$c->remarks,
':services'=>$c->services,

':temp_code'=>$temp_code,

':company_id'=>$dev->company,
':location_id'=>$dev->location,
':enquiry_reference'=>$c->enquiry_reference
));

if ($statement->rowCount()){
  $data["status"]=1;

} else{
  $data["status"]=0;
}
$data["temp_code"]=$temp_code;

$statement = $db->prepare("SELECT id from mt_quote_list where created_by=:uid and temp_code=:temp_code");
$statement->execute(array(':temp_code'=>$temp_code,':uid'=>$dev->username));
$op=$statement->fetchAll(PDO::FETCH_ASSOC);

$data["id"]=$op;

$fid=self::setFourDigit($op[0]["id"]);

$on="QUOTE/".date("Y")."/".date('m')."/".$c->origin."/".$fid;

 $statement = $db->prepare("UPDATE mt_quote_list 
  SET quote_no=:ond where id=:id");
  $statement->execute(array(':id'=>$op[0]["id"],':ond'=>$on));
  
    if ($statement->rowCount()){
    $data["qid_status"]=1;
      //echo 'Success: At least 1 row was affected.';
  } else{
    $data["qid_status"]=0;
      //echo 'Failure: 0 rows were affected.';
  }

$data["quote_no"]=$on;

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function setFourDigit($v)
{
  $len=strlen($v);

if($len==1)
{
  $v="000".$v;
}else if($len==2)
{
  $v="00".$v;
}else if($len==3)
{
  $v="0".$v;
}

return $v;
}


}

?>