<?php


require("../config/dbconn.php");

class RatesDao

{


public static function save_page_views($dev,$pname,$method)
{
$data=0;
try
{
$db = Factory::getConnection();


$statement = $db->prepare("INSERT into page_views(
ip ,uid ,ua,ekey,esecret,method,page,tz) 
values(:ip ,:uid ,
:ua ,:ekey ,:esecret ,:method ,:page,:tz)");
$statement->execute(array(':ip'=>$dev->ip,':uid'=>$dev->uid ,
':ua'=>$dev->ua,
':tz'=>$dev->tz ,
':method'=>$method ,':esecret'=>$dev->esecret,':ekey'=>$dev->ekey,
':page'=>$pname));


$data=1;
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function update_fixed_charges($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$c->from_date=date('Y-m-d', strtotime($c->from_date));
$c->to_date=date('Y-m-d', strtotime($c->to_date));

$statement = $db->prepare("UPDATE mt_rates_fixed_charges SET 

category=:category,
activity=:activity,
charge=:charge,
place_of_receipt=:place_of_receipt,
port_of_load=:port_of_load,
port_of_discharge=:port_of_discharge,
place_of_delivery=:place_of_delivery,
liner=:liner,
basis_type=:basis_type,
uom=:uom,
coc_soc=:coc_soc,
hazardous=:hazardous,
commodity=:commodity,
oog=:oog,
business_name=:business_name,
from_date=:from_date,
to_date=:to_date,
currency=:currency,
calc_method=:calc_method,
rate=:rate,
status=:status,
service=:service,
applied_for=:applied_for,

modified_by=:modified_by,
modified_date=now() 
where id=:id");

$statement->execute(array(':modified_by'=>$dev->username,

':category'=>$c->category,
':activity'=>$c->activity,
':charge'=>$c->charge,
':place_of_receipt'=>$c->place_of_receipt,
':port_of_load'=>$c->port_of_load,
':port_of_discharge'=>$c->port_of_discharge,
':place_of_delivery'=>$c->place_of_delivery,
':liner'=>$c->liner,
':basis_type'=>$c->basis_type,
':uom'=>$c->uom,
':coc_soc'=>$c->coc_soc,
':hazardous'=>$c->hazardous,
':commodity'=>$c->commodity,

':oog'=>$c->oog,
':business_name'=>$c->business_name,
':from_date'=>$c->from_date,
':to_date'=>$c->to_date,
':currency'=>$c->currency,
':calc_method'=>$c->calc_method,
':rate'=>$c->rate,
':status'=>$c->status,
':service'=>$c->service,
':applied_for'=>$c->applied_for,
':id'=>$c->id
));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
  /*

  */
} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function update_detention($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$c->valid_from=date('Y-m-d', strtotime($c->valid_from));
$c->valid_to=date('Y-m-d', strtotime($c->valid_to));

$statement = $db->prepare("UPDATE mt_rates_detention SET 

partner_name=:partner_name,
charge_type=:charge_type,
business_type=:business_type,
liner=:liner,
location=:location,
manifest_type=:manifest_type,
special_cargo_type=:special_cargo_type,
tariff_type=:tariff_type,
container_type=:container_type,
basis_type=:basis_type,
currency=:currency,
valid_from=:valid_from,
valid_to=:valid_to,
status=:status,
reference_no=:reference_no,
reference_date=:reference_date,
remarks=:remarks,
document_no=:document_no,


modified_by=:modified_by,
modified_date=now() 
where id=:id");

$statement->execute(array(':modified_by'=>$dev->username ,

':partner_name'=>$c->partner_name,
':charge_type'=>$c->charge_type,
':business_type'=>$c->business_type,
':liner'=>$c->liner,
':location'=>$c->location,
':manifest_type'=>$c->manifest_type,
':special_cargo_type'=>$c->special_cargo_type,
':tariff_type'=>$c->tariff_type,
':container_type'=>$c->container_type,
':basis_type'=>$c->basis_type,
':currency'=>$c->currency,
':valid_from'=>$c->valid_from,
':valid_to'=>$c->valid_to,
':status'=>$c->status,
':reference_no'=>$c->reference_no,
':reference_date'=>$c->reference_date,
':remarks'=>$c->remarks,
':document_no'=>$c->document_no,

':id'=>$c->id
));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
  /*

  */
} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function update_rate($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$statement = $db->prepare("UPDATE mt_rates SET 
  tariff_no=:tariff_no,
business_type=:business_type,
business_name=:business_name,
tariff_type=:tariff_type,
tariff_party=:tariff_party,
is_revision=:is_revision,
tariff_terms=:tariff_terms,
valid_from=:valid_from,
valid_to=:valid_to,
tariff_description=:tariff_description,
remarks=:remarks,
contract_number=:contract_number,
modified_by=:modified_by,
modified_date=now() 
where id=:id");

$statement->execute(array(':modified_by'=>$dev->uid ,
':tariff_no'=>$c->tariff_no,
':business_type'=>$c->business_type,
':business_name'=>$c->business_name,
':tariff_type'=>$c->tariff_type,
':tariff_party'=>$c->tariff_party,
':is_revision'=>$c->is_revision,
':tariff_terms'=>$c->tariff_terms,
':valid_from'=>$c->valid_from,
':valid_to'=>$c->valid_to,
':tariff_description'=>$c->tariff_description,
':remarks'=>$c->remarks,
':contract_number'=>$c->contract_number,
':id'=>$c->id
));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
  /*

  */
} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function delete_detention_slabs($c)
{
$data=array();
try
{
$db = Factory::getConnection();

$statement = $db->prepare("DELETE FROM mt_rates_detention_slabs
 where id=:id");

$statement->execute(array(':id'=>$c));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function delete_rate_charge($c)
{
$data=array();
try
{
$db = Factory::getConnection();

$statement = $db->prepare("DELETE FROM mt_rates_charge where id=:id");

$statement->execute(array(':id'=>$c));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function delete_rate_route($c)
{
$data=array();
try
{
$db = Factory::getConnection();

$statement = $db->prepare("DELETE FROM mt_rates_route where id=:id");

$statement->execute(array(
':id'=>$c
));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
  /*

  */
} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function update_rate_charge($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$statement = $db->prepare("UPDATE mt_rates_charge SET tariff_charge_type=:tariff_charge_type,
tariff_charge=:tariff_charge,
pay_at_location=:pay_at_location,
basis_type=:basis_type,
base_unit=:base_unit,
commodity=:commodity,
currency=:currency,
rate=:rate,
percentage=:percentage,
foreign_amount=:foreign_amount,
local_amount=:local_amount, ip=:ip,created_by=:created_by,ua=:ua,ekey=:ekey,created_date= now() where id=:id and rate_id=:rate_id");

$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->uid ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,

':tariff_charge_type'=>$c->tariff_charge_type,
':tariff_charge'=>$c->tariff_charge,
':pay_at_location'=>$c->pay_at_location,
':basis_type'=>$c->basis_type,
':base_unit'=>$c->base_unit,
':commodity'=>$c->commodity,
':currency'=>$c->currency,
':rate'=>$c->rate,
':percentage'=>$c->percentage,
':foreign_amount'=>$c->foreign_amount,
':local_amount'=>$c->local_amount,

':rate_id'=>$c->rate_id,
':id'=>$c->id
));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
  /*

  */
} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function update_rate_route($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$statement = $db->prepare("UPDATE mt_rates_route SET route_sequence=:route_sequence,origin=:origin,destination=:destination,transit1=:transit1,transit2=:transit2,transit3=:transit3,transit4=:transit4,transit5=:transit5,distance=:distance, ip=:ip,created_by=:created_by,ua=:ua,ekey=:ekey,created_date= now() where id=:id and rate_id=:rate_id");

$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->uid ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,
':route_sequence'=>$c->route_sequence,
':origin'=>$c->origin,
':destination'=>$c->destination,
':transit1'=>$c->transit1,
':transit2'=>$c->transit2,
':transit3'=>$c->transit3,
':transit4'=>$c->transit4,
':transit5'=>$c->transit5,
':distance'=>$c->distance,

':rate_id'=>$c->rate_id,
':id'=>$c->id
));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
  /*

  */
} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function save_rate_charge($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$temp_code=uniqid($dev->uid);

$statement = $db->prepare("INSERT into mt_rates_charge(tariff_charge_type,tariff_charge,pay_at_location,basis_type,base_unit,commodity,currency,rate,percentage,foreign_amount,local_amount,
  rate_id,created_by,created_date,ip,ua,ekey,temp_code) 
values(:tariff_charge_type,:tariff_charge,:pay_at_location,:basis_type,:base_unit,:commodity,:currency,:rate,:percentage,:foreign_amount,
:local_amount,:rate_id,:created_by,now(),:ip,:ua,:ekey,
:temp_code)");

$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->uid ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,

':tariff_charge_type'=>$c->tariff_charge_type,
':tariff_charge'=>$c->tariff_charge,
':pay_at_location'=>$c->pay_at_location,
':basis_type'=>$c->basis_type,
':base_unit'=>$c->base_unit,
':commodity'=>$c->commodity,
':currency'=>$c->currency,
':rate'=>$c->rate,
':percentage'=>$c->percentage,
':foreign_amount'=>$c->foreign_amount,
':local_amount'=>$c->local_amount,

':rate_id'=>$c->rate_id,
':temp_code'=>$temp_code
));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
  /*

  */
} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}

$statement = $db->prepare("SELECT id from mt_rates_charge where uid=:uid and temp_code=:temp_code and rate_id=:rate_id");
$statement->execute(array(':temp_code'=>$temp_code,
  ':uid'=>$dev->uid,':rate_id'=>$c->rate_id));
$data["id"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function update_detention_slabs($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$statement = $db->prepare("UPDATE mt_rates_detention_slabs SET 
ctype=:ctype,
slab_order=:slab_order,
slab_from=:slab_from,
slab_to=:slab_to,
rate=:rate , modified_by=:modified_by
modified_date= now() 
where id=:id and detention_id=:detention_id");

$statement->execute(array(':modified_by'=>$dev->username ,

':ctype'=>$c->ctype,
':slab_order'=>$c->slab_order,
':slab_from'=>$c->slab_from,
':slab_to'=>$c->slab_to,
':rate'=>$c->rate,

':detention_id'=>$c->detention_id,
':id'=>$c->id
));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
  /*

  */
} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}


$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function save_detention_slabs($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$temp_code=uniqid($dev->uid);

$statement = $db->prepare("INSERT into mt_rates_detention_slabs(slab_order,ctype,slab_from,slab_to,rate,
  detention_id,created_by,created_date,ip,ua,ekey,temp_code) 
values(:slab_order,:ctype,:slab_from,:slab_to,:rate,
:detention_id,:created_by,now(),:ip,:ua,:ekey,:temp_code)");

$statement->execute(array(':ip'=>$dev->ip,
  ':created_by'=>$dev->username ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,
':ctype'=>$c->ctype,
':slab_order'=>$c->slab_order,
':slab_from'=>$c->slab_from,
':slab_to'=>$c->slab_to,
':rate'=>$c->rate,

':detention_id'=>$c->detention_id,
':temp_code'=>$temp_code
));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
  /*

  */
} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}

$statement = $db->prepare("SELECT id from mt_rates_detention_slabs where created_by=:uid and temp_code=:temp_code and detention_id=:detention_id");
$statement->execute(array(':temp_code'=>$temp_code,
  ':uid'=>$dev->username,':detention_id'=>$c->detention_id));
$data["id"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function save_rate_route($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$temp_code=uniqid($dev->uid);

$statement = $db->prepare("INSERT into mt_rates_route(route_sequence,origin,destination,transit1,transit2,transit3,transit4,transit5,distance,
  rate_id,created_by,created_date,ip,ua,ekey,temp_code) 
values(:route_sequence,:origin,:destination,:transit1,:transit2,:transit3,:transit4,:transit5,:distance,:rate_id,:created_by,now(),:ip,:ua,:ekey,
:temp_code)");

$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->uid ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,
':route_sequence'=>$c->route_sequence,
':origin'=>$c->origin,
':destination'=>$c->destination,
':transit1'=>$c->transit1,
':transit2'=>$c->transit2,
':transit3'=>$c->transit3,
':transit4'=>$c->transit4,
':transit5'=>$c->transit5,
':distance'=>$c->distance,
':rate_id'=>$c->rate_id,
':temp_code'=>$temp_code
));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
  /*

  */
} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}

$statement = $db->prepare("SELECT id from mt_rates_route where uid=:uid and temp_code=:temp_code and rate_id=:rate_id");
$statement->execute(array(':temp_code'=>$temp_code,
  ':uid'=>$dev->uid,':rate_id'=>$c->rate_id));
$data["id"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function save_fixed_charges($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$c->from_date=date('Y-m-d', strtotime($c->from_date));
$c->to_date=date('Y-m-d', strtotime($c->to_date));

$statement = $db->prepare("INSERT into mt_rates_fixed_charges(category,activity,charge,place_of_receipt,port_of_load,port_of_discharge,place_of_delivery,liner,basis_type,uom,coc_soc,hazardous,commodity,oog,business_name,from_date,to_date,currency,calc_method,rate,status,service,applied_for,created_by,created_date,ip,ua,ekey) 
values(:category,:activity,:charge,:place_of_receipt,:port_of_load,:port_of_discharge,:place_of_delivery,:liner,:basis_type,:uom,:coc_soc,:hazardous,:commodity,:oog,:business_name,
:from_date,:to_date,:currency,:calc_method,:rate,:status,:service,:applied_for,
:created_by,now(),:ip,:ua,:ekey)");

$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->username ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,

':category'=>$c->category,
':activity'=>$c->activity,
':charge'=>$c->charge,
':place_of_receipt'=>$c->place_of_receipt,
':port_of_load'=>$c->port_of_load,
':port_of_discharge'=>$c->port_of_discharge,
':place_of_delivery'=>$c->place_of_delivery,
':liner'=>$c->liner,
':basis_type'=>$c->basis_type,
':uom'=>$c->uom,
':coc_soc'=>$c->coc_soc,
':hazardous'=>$c->hazardous,
':commodity'=>$c->commodity,
':oog'=>$c->oog,
':business_name'=>$c->business_name,
':from_date'=>$c->from_date,
':to_date'=>$c->to_date,
':currency'=>$c->currency,
':calc_method'=>$c->calc_method,
':rate'=>$c->rate,
':status'=>$c->status,
':service'=>$c->service,
':applied_for'=>$c->applied_for
));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
  /*

  */
} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function save_detention($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$temp_code=uniqid($dev->uid);

$c->valid_from=date('Y-m-d', strtotime($c->valid_from));
$c->valid_to=date('Y-m-d', strtotime($c->valid_to));

$statement = $db->prepare("INSERT into mt_rates_detention(partner_name,charge_type,business_type,liner,location,manifest_type,special_cargo_type,tariff_type,container_type,basis_type,currency,valid_from,valid_to,status,reference_no,reference_date,remarks,document_no,created_by,created_date,ip,ua,ekey,temp_code) 
values(:partner_name,:charge_type,:business_type,:liner,:location,:manifest_type,:special_cargo_type,:tariff_type,:container_type,:basis_type,:currency,:valid_from,:valid_to,:status,:reference_no,:reference_date,:remarks,:document_no,:created_by,now(),:ip,:ua,:ekey,
:temp_code)");

if($c->reference_date=="")
{
  $c->reference_date=null;
}
$statement->execute(array(':ip'=>$dev->ip,
  ':created_by'=>$dev->username,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,

':partner_name'=>$c->partner_name,
':charge_type'=>$c->charge_type,
':business_type'=>$c->business_type,
':liner'=>$c->liner,
':location'=>$c->location,
':manifest_type'=>$c->manifest_type,
':special_cargo_type'=>$c->special_cargo_type,
':tariff_type'=>$c->tariff_type,
':container_type'=>$c->container_type,
':basis_type'=>$c->basis_type,
':currency'=>$c->currency,
':valid_from'=>$c->valid_from,
':valid_to'=>$c->valid_to,
':status'=>$c->status,
':reference_no'=>$c->reference_no,
':reference_date'=>$c->reference_date,
':remarks'=>$c->remarks,
':document_no'=>$c->document_no,


':temp_code'=>$temp_code
));

if ($statement->rowCount()){
  $data["status"]=1;
} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}

$statement = $db->prepare("SELECT id from mt_rates_detention where created_by=:uid and temp_code=:temp_code");
$statement->execute(array(':temp_code'=>$temp_code,':uid'=>$dev->username));
$op=$statement->fetchAll(PDO::FETCH_ASSOC);

$data["id"]=$op;

$fid=self::setFourDigit($op[0]["id"]);

$on="DET/".date("Y")."/".date('m')."/".$c->location."/".$fid;

 $statement = $db->prepare("UPDATE mt_rates_detention 
  SET det_no=:ond where id=:id");
  $statement->execute(array(':id'=>$op[0]["id"],':ond'=>$on));
  
    if ($statement->rowCount()){
    $data["did_status"]=1;
      //echo 'Success: At least 1 row was affected.';
  } else{
    $data["did_status"]=0;
      //echo 'Failure: 0 rows were affected.';
  }

$data["det_no"]=$on;

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function setFourDigit($v)
{
  $len=strlen($v);

if($len==1)
{
  $v="000".$v;
}else if($len==2)
{
  $v="00".$v;
}else if($len==3)
{
  $v="0".$v;
}

return $v;
}

public static function save_rate($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$temp_code=uniqid($dev->uid);

$statement = $db->prepare("INSERT into mt_rates(tariff_no,business_type,business_name,tariff_type,tariff_party,is_revision,tariff_terms,valid_from,valid_to,tariff_description,remarks,contract_number,created_by,created_date,ip,ua,ekey,temp_code) 
values(:tariff_no,:business_type,:business_name,:tariff_type,:tariff_party,:is_revision,:tariff_terms,:valid_from,:valid_to,:tariff_description,:remarks,:contract_number,:created_by,now(),:ip,:ua,:ekey,
:temp_code)");

$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->uid ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,
':tariff_no'=>$c->tariff_no,
':business_type'=>$c->business_type,
':business_name'=>$c->business_name,
':tariff_type'=>$c->tariff_type,
':tariff_party'=>$c->tariff_party,
':is_revision'=>$c->is_revision,
':tariff_terms'=>$c->tariff_terms,
':valid_from'=>$c->valid_from,
':valid_to'=>$c->valid_to,
':tariff_description'=>$c->tariff_description,
':remarks'=>$c->remarks,
':contract_number'=>$c->contract_number,
':temp_code'=>$temp_code
));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
  /*

  */
} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}

$statement = $db->prepare("SELECT id from mt_rates where uid=:uid and temp_code=:temp_code");
$statement->execute(array(':temp_code'=>$temp_code,':uid'=>$dev->uid));
$data["id"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function search_detention_list($v)
{
$data=array();
try
{
$db = Factory::getConnection();

$statement = $db->prepare("SELECT id,det_no,charge_type,business_type,liner,location,
  tariff_type,partner_name,container_type,currency,
  reference_date,valid_from,valid_to,status,created_date,created_by,
  modified_date,modified_by from mt_rates_detention where charge_type like ? or business_type like ? or liner like ? 
  or location like ? or basis_type like ? or det_no like ? order by id limit 50");
$statement ->bindValue(1, "%$v%", PDO::PARAM_STR);
$statement ->bindValue(2, "%$v%", PDO::PARAM_STR);
$statement ->bindValue(3, "%$v%", PDO::PARAM_STR);

$statement ->bindValue(4, "%$v%", PDO::PARAM_STR);
$statement ->bindValue(5, "%$v%", PDO::PARAM_STR);
$statement ->bindValue(6, "%$v%", PDO::PARAM_STR);

$statement->execute();
$data=$statement->fetchAll(PDO::FETCH_ASSOC);
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function search_fixed_charges_list($v)
{
$data=array();
try
{
$db = Factory::getConnection();

$statement = $db->prepare("SELECT id,category,activity,
  place_of_receipt,port_of_load,port_of_discharge,place_of_delivery,
  liner,basis_type,business_name,from_date,to_date,currency,
  rate,status,coc_soc,hazardous,oog,commodity,created_date,created_by,
  modified_date,modified_by
  from mt_rates_fixed_charges where charge like ? or commodity like ? or rate like ? or activity like ? or port_of_load like ? or port_of_discharge like ? or basis_type like ? order by id limit 50");
$statement ->bindValue(1, "%$v%", PDO::PARAM_STR);
$statement ->bindValue(2, "%$v%", PDO::PARAM_STR);
$statement ->bindValue(3, "%$v%", PDO::PARAM_STR);

$statement ->bindValue(4, "%$v%", PDO::PARAM_STR);
$statement ->bindValue(5, "%$v%", PDO::PARAM_STR);
$statement ->bindValue(6, "%$v%", PDO::PARAM_STR);
$statement ->bindValue(7, "%$v%", PDO::PARAM_STR);

$statement->execute();
$data=$statement->fetchAll(PDO::FETCH_ASSOC);
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function search_rate_list($v)
{
$data=array();
try
{
$db = Factory::getConnection();

$statement = $db->prepare("SELECT id,tariff_no,business_type,business_name from mt_rates where business_type like ? or business_name like ? order by id limit 50");
$statement ->bindValue(1, "%$v%", PDO::PARAM_STR);
$statement ->bindValue(2, "%$v%", PDO::PARAM_STR);
//$statement ->bindValue(3, "%$v%", PDO::PARAM_STR);

$statement->execute();
$data=$statement->fetchAll(PDO::FETCH_ASSOC);
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function get_rate_charge_list($code)
{

$data=false;
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT id,rate_id,tariff_charge_type,tariff_charge,pay_at_location,basis_type,base_unit,commodity,currency,rate,percentage,foreign_amount,local_amount from mt_rates_charge  where rate_id=:id");

$statement->execute(array(':id'=>$code));

$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function get_rate_route_list($code)
{

$data=false;
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT id,rate_id,route_sequence,origin,destination,transit1,transit2,transit3,transit4,transit5,distance from mt_rates_route  where rate_id=:id");

$statement->execute(array(':id'=>$code));

$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_fixed_charges_list($code)
{

$data=false;
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT id,category,activity,
  place_of_receipt,port_of_load,port_of_discharge,place_of_delivery,
  liner,basis_type,business_name,from_date,to_date,currency,
  rate,status,coc_soc,hazardous,oog,commodity,created_date,created_by,
  modified_date,modified_by from mt_rates_fixed_charges  order by id limit :sta,20");

$statement->bindValue(':sta',(int) $code, PDO::PARAM_INT); 
$statement->execute();

$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function get_detention_list($code)
{

$data=false;
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT id,det_no,charge_type,business_type,liner,location,
  tariff_type,partner_name,container_type,currency,
  reference_date,valid_from,valid_to,status,created_date,created_by,
  modified_date,modified_by 
  from mt_rates_detention order by id limit :sta,20");

$statement->bindValue(':sta',(int) $code, PDO::PARAM_INT); 
$statement->execute();

$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function get_rate_list($code)
{

$data=false;
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT id,tariff_no,business_type,business_name from mt_rates order by id limit :sta,20");

$statement->bindValue(':sta',(int) $code->start, PDO::PARAM_INT); 
$statement->execute();

$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_fixed_charges_info($code)
{

$data=false;
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT id,category,activity,charge,place_of_receipt,port_of_load,port_of_discharge,place_of_delivery,liner,basis_type,uom,coc_soc,hazardous,commodity,oog,business_name,from_date,to_date,currency,calc_method,rate,status,service,applied_for from mt_rates_fixed_charges where id=:id");

$statement->execute(array(':id'=>$code));

$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_rate_info($code)
{

$data=false;
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT id,tariff_no,business_type,business_name,tariff_type,tariff_party,is_revision,tariff_terms,valid_from,valid_to,tariff_description,remarks,contract_number from mt_rates where id=:id");

$statement->bindValue(':sta',(int) $code->start, PDO::PARAM_INT); 
$statement->execute();

$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function get_detention_info($code)
{

$data=array();
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT id,charge_type,business_type,liner,location,manifest_type,special_cargo_type,tariff_type,container_type,basis_type,currency,valid_from,valid_to,status,reference_no,reference_date,remarks,document_no,partner_name from mt_rates_detention where id=:id");

$statement->execute(array("id"=>$code));

$data["info"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT id,detention_id,
  slab_order,ctype,slab_from,slab_to,rate,'0' edit from mt_rates_detention_slabs where detention_id=:id");
$statement->execute(array("id"=>$code));

$data["slabs"]=$statement->fetchAll(PDO::FETCH_ASSOC);
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


}

?>