<?php


require("../config/dbconn.php");
require("voucher-no-gen.php");

class ReceivableDao

{


public static function save_page_views($dev,$pname,$method)
{
$data=0;
try
{
$db = Factory::getConnection();
$statement = $db->prepare("INSERT into page_views(
ip ,uid ,ua,ekey,esecret,method,page,tz) 
values(:ip ,:uid ,
:ua ,:ekey ,:esecret ,:method ,:page,:tz)");
$statement->execute(array(':ip'=>$dev->ip,':uid'=>$dev->uid ,
':ua'=>$dev->ua,
':tz'=>$dev->tz ,
':method'=>$method ,':esecret'=>$dev->esecret,':ekey'=>$dev->ekey,
':page'=>$pname));
$data=1;
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  return $data;
}



public static function get_ar_info($dev,$code)
{
$data=array();
try
{
$db = Factory::getConnection();

$statement = $db->prepare("SELECT 
id,
arh_code,
arh_name,
arh_document_number,
arh_document_type,
arh_document_date,
arh_other_reference,
arh_currency,
abs(arh_local_amount) arh_local_amount,
arh_foreign_amount,
arh_exchange_rate,
arh_narration,
arh_status,
temp_code  
 from mt_ar_header where id=:id");

$statement->execute(array(':id'=>$code));
$data["info"]=$statement->fetchAll(PDO::FETCH_ASSOC);
$doc_no=$data["info"][0]["arh_document_number"];

$statement = $db->prepare("SELECT 
id,
aloc_doc_number,
aloc_foreign_amount,
aloc_currency,
aloc_ex_rate,
aloc_local_amount,
aloc_narration,
aloc_other_reference,
aloc_detail_1,
aloc_detail_2,
aloc_detail_3,
aloc_detail_31,

'0' edit 
 from mt_ar_allocation_details where aloc_doc_number=:id");

$statement->execute(array(':id'=>$doc_no));
$data["detail"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT pre_glt_doc_number from mt_ar_gl_details 
      WHERE pre_glt_doc_number=:doc_no");
$statement->execute(array(':doc_no'=>$doc_no));
$datas=$statement->fetchAll(PDO::FETCH_ASSOC);
$data["posted"]=count($datas);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_ar_list($dev,$code)
{
$data=array();
try
{
$db = Factory::getConnection();


$statement = $db->prepare("SELECT id,
arh_code,
arh_document_number,
arh_document_type,
arh_document_date,
arh_currency,
arh_local_amount,
arh_narration,
arh_status,
created_by,created_date from mt_ar_header 
WHERE arh_status!='CANCELLED' order by id desc limit :sta,50");
$statement->bindValue(':sta',(int) $code, PDO::PARAM_INT); 
$statement->execute();
$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_ar_cancelled_list($dev,$code)
{
$data=array();
try
{
$db = Factory::getConnection();


$statement = $db->prepare("SELECT id,
arh_code,
arh_document_number,
arh_document_type,
arh_document_date,
arh_currency,
arh_local_amount,
arh_narration,
arh_status,
created_by,created_date from mt_ar_header 
WHERE arh_status='CANCELLED' order by id desc limit :sta,50");
$statement->bindValue(':sta',(int) $code, PDO::PARAM_INT); 
$statement->execute();
$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function search_ar_list($dev,$code)
{
$data=array();
try
{
$db = Factory::getConnection();

$saq='';
$query='';
if(is_object($code))
{
  if($code->cancelled)
  {
  $saq="arh_status='CANCELLED' and ";
  }else{
  $saq="arh_status!='CANCELLED' and ";
  }
  $query=$code->q;
}else{
  $saq="arh_status!='CANCELLED' and ";
  $query=$code;
}

$statement = $db->prepare("SELECT id,
arh_code,
arh_document_number,
arh_document_type,
arh_document_date,
arh_currency,
arh_local_amount,
arh_narration,
arh_status,
created_by,created_date from mt_ar_header 
where $saq arh_document_number like ? order by id desc limit 50");
$i=1;
$statement ->bindValue($i++, "%$query%", PDO::PARAM_STR);
$statement->execute();
$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function setFourDigit($v)
{
  $len=strlen($v);

if($len==1)
{
  $v="000".$v;
}else if($len==2)
{
  $v="00".$v;
}else if($len==3)
{
  $v="0".$v;
}

return $v;
}

public static function getFinancialYear()
{
//$year = ( date('m') > 4) ? date('Y') + 1 : date('Y');
$year=date('Y');
return $year;
}

public static function getFinancialPeriod($doc_date)
{

//$year = ( date('m') > 4) ? date('Y') + 1 : date('Y');
//$period=4;
//return $period;
$data=false;
try
{
$db = Factory::getConnection();

//$aq=self::getRestrictionQuery($dev);
//$doc_date="2019-12-15";
$date=date_create($doc_date);
$m= date_format($date,"F");
$y= date_format($date,"Y");

$statement = $db->prepare("SELECT enumber from mt_period 
  where period=:period and year=:year and open_max='OPEN'");

$statement->execute(array(':period'=>$m,':year'=>$y));
$data=$statement->fetchAll(PDO::FETCH_ASSOC);
//var_dump($statement->debugDumpParams());
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  $p=-10;
  if(count($data)==1)
  {
    $p=$data[0]["enumber"];
  }
  return $p;
}

public static function get_posted_status($code)
{


$data=0;
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT pre_glt_doc_number from mt_ar_gl_details 
      WHERE pre_glt_doc_number=:doc_no");
$statement->execute(array(':doc_no'=>$code->info->arh_document_number));
$datas=$statement->fetchAll(PDO::FETCH_ASSOC);
$data=count($datas);
$statement=null;
  }
  catch (Exception $e) {
  }
 
  return $data;
}

public static function save_ar_draft($dev,$code)
{

$result=array();
if($code->info->arh_document_number!='')
{

$posted_count=self::get_posted_status($code);

if($posted_count==0 && $code->info->arh_status=='POSTED')
{
    $result=self::update_ar_draft($dev,$code);
    if($result["status"]==1)
    {
      $result=self::post_ar($dev,$code);
    }else{
      $result["add_msg"]="Update failed before posting";
    }
}if($posted_count!=0 && $code->info->arh_status=='POSTED')
{
  $result["add_msg"]="Trying to Update already posted";
  $result["status"]=0;
  $result["msg"]="Voucher already posted to finance";
}else if($posted_count==0 && $code->info->arh_status=='DRAFT')
{
    $result=self::update_ar_draft($dev,$code);
}

return $result;

}else if($code->info->arh_status=='POSTED')
{
    $data=array();
  $data["status"]=0;
  $data["msg"]="Please select status to draft and try save.";
  return $data;
}else
{
$data=array();
try
{
$db = Factory::getConnection();
$db->beginTransaction();

$cds=$code->cds;
$c=$code->info;

$temp_code=uniqid($dev->uid);

$statement = $db->prepare("INSERT into mt_ar_header(
arh_code,
arh_name,
arh_document_base,
arh_document_type,
arh_document_date,
arh_gl_date,
arh_other_reference,
arh_currency,
arh_exchange_rate,
arh_foreign_amount,
arh_local_amount,
arh_narration,
arh_status,
location_id,
company_id,
created_by,
created_date,
ip,
ua,
ekey,
temp_code
) 
values(
:arh_code,
:arh_name,
:arh_document_base,
:arh_document_type,
:arh_document_date,
:arh_gl_date,
:arh_other_reference,
:arh_currency,
:arh_exchange_rate,
:arh_foreign_amount,
:arh_local_amount,
:arh_narration,
:arh_status,
:location_id,
:company_id,
:created_by,
now(),
:ip,
:ua,
:ekey,
:temp_code
)");

$c->arh_document_base="RECEIVABLE VOUCHER";
$c->arh_local_amount=abs($c->arh_local_amount);
if($c->arh_document_type=="CREDIT NOTE"){
$header_amount=$c->arh_local_amount*(-1);
}else{
$header_amount=$c->arh_local_amount;
}

$c->arh_status='DRAFT';

$statement->execute(array(
':arh_code'=>$c->arh_code,
':arh_name'=>$c->arh_name,

':arh_document_base'=>$c->arh_document_base,
':arh_document_type'=>$c->arh_document_type,
':arh_document_date'=>$c->arh_document_date,
':arh_gl_date'=>$c->arh_document_date,
':arh_other_reference'=>$c->arh_other_reference,
':arh_narration'=>$c->arh_narration,
':arh_currency'=>$c->arh_currency,
':arh_exchange_rate'=>$c->arh_exchange_rate,
':arh_foreign_amount'=>$c->arh_foreign_amount,
':arh_local_amount'=>$header_amount,
':arh_status'=>$c->arh_status,
':location_id'=>$dev->location,
':company_id'=>$dev->company,
':created_by'=>$dev->username,
':ip'=>$dev->ip,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,
':temp_code'=>$temp_code
));

if ($statement->rowCount()){
  $data["status"]=1;
  $data["msg"]="Saved.";
} else{
  $data["status"]=0;
  $data["msg"]="Unable to save.";
}

$statement = $db->prepare("SELECT id from mt_ar_header where created_by=:uid and temp_code=:temp_code");
$statement->execute(array(':temp_code'=>$temp_code,
  ':uid'=>$dev->username));
$data["id"]=$statement->fetchAll(PDO::FETCH_ASSOC);
$data["temp_code"]=$temp_code;

$four_id=self::setFourDigit($data["id"][0]["id"]);
$fid1=$data["id"][0]["id"];


if($c->arh_document_type=="GENERAL INVOICE")
{
  $prefix="RGN";
}else if($c->arh_document_type=="CREDIT NOTE")
{
  $prefix="RCN";
}


$doc_date1=$c->arh_document_date;
$doc_no=generate_voucher_no1($db,$dev,$prefix,$temp_code,$doc_date1);

//$voucher_no=generate_voucher_no1($db,$dev,$prefix,$temp_code,$doc_date1);
//$four_id=self::setFourDigit($voucher_no);
//$doc_no=$prefix."/".date("Y")."/".date('m')."/".$four_id;

$statement = $db->prepare("UPDATE mt_ar_header  
  SET arh_document_number=:ond where id=:id");
  $statement->execute(array(':id'=>$fid1,':ond'=>$doc_no));
  
    if ($statement->rowCount()){
    $data["jid_status"]=1;
  } else{
    $data["jid_status"]=0;
  }

$data["doc_no"]=$doc_no;

//query 2 child entry
$len=count($cds);
$ch_status_count=0;


for($i=0;$i<$len;$i++)
{
$cd=$cds[$i];
$r=$cd;

$statement = $db->prepare("INSERT into mt_ar_allocation_details 
(
aloc_base_doc,
aloc_doc_type,
aloc_doc_number,
aloc_foreign_amount,
aloc_currency,
aloc_ex_rate,
aloc_local_amount,
aloc_narration,
aloc_other_reference,
aloc_detail_1,
aloc_detail_2,
aloc_detail_3,
aloc_detail_31,
location_id,
company_id,
created_by,
created_date,
ip,
ua,
ekey
)
VALUES
(
:aloc_base_doc,
:aloc_doc_type,
:aloc_doc_number,
:aloc_foreign_amount,
:aloc_currency,
:aloc_ex_rate,
:aloc_local_amount,
:aloc_narration,
:aloc_other_reference,
:aloc_detail_1,
:aloc_detail_2,
:aloc_detail_3,
:aloc_detail_31,
:location_id,
:company_id,
:created_by,
now(),
:ip,
:ua,
:ekey
)");
  $statement->execute(array(
':aloc_base_doc'=>$c->arh_document_base,
':aloc_doc_type'=>$c->arh_document_type,
':aloc_doc_number'=>$doc_no,
':aloc_foreign_amount'=>$r->aloc_foreign_amount,
':aloc_currency'=>$r->aloc_currency,
':aloc_ex_rate'=>$r->aloc_ex_rate,
':aloc_local_amount'=>$r->aloc_local_amount,
':aloc_narration'=>$r->aloc_narration,
':aloc_other_reference'=>$c->arh_other_reference,
':aloc_detail_1'=>$r->aloc_detail_1,
':aloc_detail_2'=>$r->aloc_detail_2,
':aloc_detail_3'=>$r->aloc_detail_3,
':aloc_detail_31'=>$r->aloc_detail_31,

':location_id'=>$dev->location,
':company_id'=>$dev->company,
':created_by'=>$dev->username,
':ip'=>$dev->ip,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey
  ));
  
    if ($statement->rowCount()){
    $ch_status_count+=1;
    $data["ch_status".($i+1)]=1;
  } else{
    $data["ch_status".($i+1)]=0;
  }

}
//end of loop

$cr_count=count($cds);
$child_status=$ch_status_count==$cr_count;

//$data["status"]=0;


if($data["status"]==1 && $child_status)
{
  $db->commit();
}else{
    $db->rollBack();
    $data["status"]=0;
    $data["msg"]="Unable to save. Please try again";
}

$statement=null;
  }
  catch (Exception $e) {
    $data["emsg"]=$e->getMessage();
    $db->rollBack();
    $data["status"]=0;
    $data["msg"]="Unable to save.Exception. Please try again";
  }
  
  return $data;
  }
}

public static function update_ar_draft($dev,$code)
{
$data=array();
try
{
$db = Factory::getConnection();
$db->beginTransaction();

$cds=$code->cds;
$c=$code->info;

$temp_code=uniqid($dev->uid);

$statement = $db->prepare("UPDATE mt_ar_header
SET 
arh_code=:arh_code,
arh_name=:arh_name,
arh_document_base=:arh_document_base,
arh_document_type=:arh_document_type,
arh_document_date=:arh_document_date,
arh_gl_date=:arh_gl_date,
arh_other_reference=:arh_other_reference,
arh_currency=:arh_currency,
arh_exchange_rate=:arh_exchange_rate,
arh_foreign_amount=:arh_foreign_amount,
arh_local_amount=:arh_local_amount,
arh_narration=:arh_narration,
modified_by=:modified_by,
modified_date=now()
WHERE id=:id");

$c->arh_local_amount=abs($c->arh_local_amount);
$c->arh_document_base="RECEIVABLE VOUCHER";

if($c->arh_document_type=="CREDIT NOTE"){
$header_amount=$c->arh_local_amount*(-1);
}else{
$header_amount=$c->arh_local_amount;
}


$statement->execute(array(
':arh_code'=>$c->arh_code,
':arh_name'=>$c->arh_name,

':arh_document_base'=>$c->arh_document_base,
':arh_document_type'=>$c->arh_document_type,
':arh_document_date'=>$c->arh_document_date,
':arh_gl_date'=>$c->arh_document_date,
':arh_other_reference'=>$c->arh_other_reference,
':arh_narration'=>$c->arh_narration,
':arh_currency'=>$c->arh_currency,
':arh_exchange_rate'=>$c->arh_exchange_rate,
':arh_foreign_amount'=>$c->arh_foreign_amount,
':arh_local_amount'=>$header_amount,

':modified_by'=>$dev->username,
':id'=>$c->id
));

if ($statement->rowCount()){
  $data["status"]=1;
  $data["msg"]="Updated.";
} else{
  $data["status"]=0;
  $data["msg"]="Unable to update. Please try again.";
}

$doc_no=$c->arh_document_number;

//delete child data
$statement = $db->prepare("DELETE FROM mt_ar_allocation_details 
  WHERE aloc_doc_number=:aloc_doc_number");
$statement->execute(array(':aloc_doc_number'=>$doc_no));
if ($statement->rowCount()){
  $data["del_status"]=1;
} else{
  $data["del_status"]=0;
}

//query 2 child entry
$len=count($cds);
$ch_status_count=0;


for($i=0;$i<$len;$i++)
{
$cd=$cds[$i];
$r=$cd;

$statement = $db->prepare("INSERT into mt_ar_allocation_details 
(
aloc_base_doc,
aloc_doc_type,
aloc_doc_number,
aloc_foreign_amount,
aloc_currency,
aloc_ex_rate,
aloc_local_amount,
aloc_narration,
aloc_other_reference,
aloc_detail_1,
aloc_detail_2,
aloc_detail_3,
aloc_detail_31,
location_id,
company_id,
created_by,
created_date,
ip,
ua,
ekey
)
VALUES
(
:aloc_base_doc,
:aloc_doc_type,
:aloc_doc_number,
:aloc_foreign_amount,
:aloc_currency,
:aloc_ex_rate,
:aloc_local_amount,
:aloc_narration,
:aloc_other_reference,
:aloc_detail_1,
:aloc_detail_2,
:aloc_detail_3,
:aloc_detail_31,
:location_id,
:company_id,
:created_by,
now(),
:ip,
:ua,
:ekey
)");
  $statement->execute(array(
':aloc_base_doc'=>$c->arh_document_base,
':aloc_doc_type'=>$c->arh_document_type,
':aloc_doc_number'=>$doc_no,
':aloc_foreign_amount'=>$r->aloc_foreign_amount,
':aloc_currency'=>$r->aloc_currency,
':aloc_ex_rate'=>$r->aloc_ex_rate,
':aloc_local_amount'=>$r->aloc_local_amount,
':aloc_narration'=>$r->aloc_narration,
':aloc_other_reference'=>$c->arh_other_reference,
':aloc_detail_1'=>$r->aloc_detail_1,
':aloc_detail_2'=>$r->aloc_detail_2,
':aloc_detail_3'=>$r->aloc_detail_3,
':aloc_detail_31'=>$r->aloc_detail_31,

':location_id'=>$dev->location,
':company_id'=>$dev->company,
':created_by'=>$dev->username,
':ip'=>$dev->ip,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey
  ));
  
    if ($statement->rowCount()){
    $ch_status_count+=1;
    $data["ch_status".($i+1)]=1;
  } else{
    $data["ch_status".($i+1)]=0;
  }

}
//end of loop

$cr_count=count($cds);
$child_status=$ch_status_count==$cr_count;

//$data["status"]=0;


if($data["status"]==1 && $child_status && $data["del_status"]==1)
{
  $db->commit();
}else{
    $db->rollBack();
    $data["status"]=0;
    $data["msg"]="Unable to save. Please try again";
}

$statement=null;
  }
  catch (Exception $e) {
    $data["emsg"]=$e->getMessage();
    $db->rollBack();
    $data["status"]=0;
    $data["msg"]="Unable to save.Exception. Please try again";
  }
  
  return $data;
  }

public static function post_ar($dev,$code)
{
$data=array();
try
{
$db = Factory::getConnection();
$db->beginTransaction();

$c=$code->info;

$temp_code=uniqid($dev->uid);

$c->arh_document_base="RECEIVABLE VOUCHER";

$statement = $db->prepare("INSERT into mt_ar_gl_details  
(
pre_glt_company,
pre_glt_code,
pre_glt_doc_base,
pre_glt_doc_type,
pre_glt_doc_number,
pre_glt_doc_date,
pre_glt_gl_date,
pre_glt_year,
pre_glt_period,
pre_glt_other_reference,
pre_glt_currency,
pre_glt_ex_rate,
pre_glt_foreign_amount,
pre_glt_local_amount,
pre_glt_narration,
pre_glt_detail_1,
pre_glt_detail_2,
pre_glt_detail_3,
location_id,
company_id,
created_by,
created_date,
ip,
ua,
ekey,
temp_code
)
SELECT 
company_id,
(select gl_account from mt_gl_link where name='RECEIVABLE' limit 1),
'$c->arh_document_base',
'$c->arh_document_type',
arh_document_number,
'$c->arh_document_date',
'$c->arh_document_date',
".self::getFinancialYear().",
".self::getFinancialPeriod($c->arh_document_date).",
arh_other_reference,
arh_currency,
arh_exchange_rate,
arh_foreign_amount,
arh_local_amount,
arh_narration,
(select gl_account from mt_gl_link where name='RECEIVABLE' limit 1),
'RECEIVABLE',
arh_code,
location_id,
company_id,
created_by,
now(),
ip,
ua,
ekey,
'$temp_code'
 
FROM mt_ar_header where arh_document_number=:id");

$statement->execute(array(':id'=>$c->arh_document_number));

if ($statement->rowCount()){
  $data["arh_gl_status"]=1;
} else{
  $data["arh_gl_status"]=0;
}

$statement = $db->prepare("INSERT into mt_ar_gl_details  
(
pre_glt_company,
pre_glt_code,
pre_glt_doc_base,
pre_glt_doc_type,
pre_glt_doc_number,
pre_glt_doc_date,
pre_glt_gl_date,
pre_glt_year,
pre_glt_period,
pre_glt_other_reference,
pre_glt_currency,
pre_glt_ex_rate,
pre_glt_foreign_amount,
pre_glt_local_amount,
pre_glt_narration,
pre_glt_detail_1,
pre_glt_detail_2,
pre_glt_detail_3,
location_id,
company_id,
created_by,
created_date,
ip,
ua,
ekey,
temp_code
)
SELECT 

company_id,
aloc_detail_1,
'$c->arh_document_base',
'$c->arh_document_type',
aloc_doc_number,
'$c->arh_document_date',
'$c->arh_document_date',
".self::getFinancialYear().",
".self::getFinancialPeriod($c->arh_document_date).",
aloc_other_reference,
aloc_currency,
aloc_ex_rate,
aloc_foreign_amount,
aloc_local_amount,
aloc_narration,
aloc_detail_1,
aloc_detail_2,
aloc_detail_3,
location_id,
company_id,
created_by,
now(),
ip,
ua,
ekey,
'$temp_code'
 
FROM mt_ar_allocation_details where aloc_doc_number=:id");

$statement->execute(array(':id'=>$c->arh_document_number));

if ($statement->rowCount()){
  $data["ar_gl_status"]=1;
} else{
  $data["ar_gl_status"]=0;
}


$statement = $db->prepare("INSERT into mt_ar_trans 
(
art_company,
art_code,
art_type,
art_number,
art_group,
art_base_type,
art_doc_date,
art_gl_date,
art_year,
art_period,
art_other_reference,
art_currency,
art_ex_rate,
art_foreign_amount,
art_local_amount,
art_foreign_balance,
art_local_balance,
art_balance_status,
art_description,
location_id,
company_id,
created_by,
created_date,
ip,
ua,
ekey,
temp_code
)
SELECT 

pre_glt_company,
pre_glt_detail_3,
pre_glt_doc_type,
pre_glt_doc_number,
pre_glt_code,
pre_glt_doc_base,
pre_glt_doc_date,
pre_glt_gl_date,
pre_glt_year,
pre_glt_period,
pre_glt_other_reference,
pre_glt_currency,
pre_glt_ex_rate,
pre_glt_foreign_amount,
pre_glt_local_amount,
pre_glt_foreign_amount,
pre_glt_local_amount,
'A',
pre_glt_narration,
location_id,
company_id,
created_by,
now(),
ip,
ua,
ekey,
temp_code 
FROM mt_ar_gl_details  
WHERE pre_glt_code=(select gl_account from mt_gl_link where name='RECEIVABLE' limit 1) 
and pre_glt_doc_number=:id");

$statement->execute(array(':id'=>$c->arh_document_number));

if ($statement->rowCount()){
  $data["ar_trans_status"]=1;
} else{
  $data["ar_trans_status"]=0;
}


$statement = $db->prepare("INSERT into mt_ap_trans 
(
apt_company,
apt_code,
apt_type,
apt_number,
apt_group,
apt_base_type,
apt_doc_date,
apt_gl_date,
apt_year,
apt_period,
apt_other_reference,
apt_currency,
apt_ex_rate,
apt_foreign_amount,
apt_local_amount,
apt_foreign_balance,
apt_local_balance,
apt_balance_status,
apt_description,
location_id,
company_id,
created_by,
created_date,
ip,
ua,
ekey,
temp_code
)
SELECT 
pre_glt_company,
pre_glt_detail_3,
pre_glt_doc_type,
pre_glt_doc_number,
pre_glt_code,
pre_glt_doc_base,
pre_glt_doc_date,
pre_glt_gl_date,
pre_glt_year,
pre_glt_period,
pre_glt_other_reference,
pre_glt_currency,
pre_glt_ex_rate,
pre_glt_foreign_amount,
pre_glt_local_amount,
'0',
'0',
'A',
pre_glt_narration,
location_id,
company_id,
created_by,
now(),
ip,
ua,
ekey,
temp_code 
FROM mt_ar_gl_details  
WHERE pre_glt_code=(select gl_account from mt_gl_link where name='PAYABLE' limit 1) 
and pre_glt_doc_number=:id");

$statement->execute(array(':id'=>$c->arh_document_number));

if ($statement->rowCount()){
  $data["ap_trans_status"]=1;
} else{
  $data["ap_trans_status"]=0;
}


//get payable count
$statement = $db->prepare("SELECT * FROM mt_ar_allocation_details 
  WHERE aloc_detail_1=(select gl_account from mt_gl_link where name='PAYABLE' limit 1) 
and aloc_doc_number=:id");
$statement->execute(array(':id'=>$c->arh_document_number));
$datas1=$statement->fetchAll(PDO::FETCH_ASSOC);

//get receivable count
$statement = $db->prepare("SELECT * FROM mt_ar_allocation_details 
  WHERE aloc_detail_1=(select gl_account from mt_gl_link where name='RECEIVABLE' limit 1) 
and aloc_doc_number=:id");
$statement->execute(array(':id'=>$c->arh_document_number));
$datas2=$statement->fetchAll(PDO::FETCH_ASSOC);

if(count($datas1)==0)
{
$data["ap_trans_status"]=1;
$data["ap_trans_status_add"]="No payable";
}

if(count($datas2)==0)
{
$data["ar_trans_status"]=1;
$data["ar_trans_status_add"]="No receivable";
}

//update header
$temp_code=uniqid($dev->uid);
$statement = $db->prepare("UPDATE mt_ar_header  
  SET arh_status='POSTED',modified_date=now(),temp_code2=:temp_code 
  where arh_document_number=:id");
$exec_status=$statement->execute(array(':id'=>$c->arh_document_number,':temp_code'=>$temp_code));
  
if ($statement->rowCount()){
$data["status"]=1;
} else{
$data["status"]=0;
}

//$data["status"]=1;
$data["posted"]=2;

//$data["status"]=0;


if($data["status"]==1 && $data["arh_gl_status"]==1 && $data["ar_gl_status"]==1 && $data["ar_trans_status"]==1 && $data["ap_trans_status"]==1 )
{
  $db->commit();
  $data["msg"]="Posted Voucher Successfully";
  
}else{
    $db->rollBack();
    $data["status"]=0;
    $data["msg"]="Unable to save. Please try again";
}

$statement=null;
  }
  catch (Exception $e) {
    $data["emsg"]=$e->getMessage();
    $db->rollBack();
    $data["status"]=0;
    $data["msg"]="Unable to save.Exception. Please try again";
  }
  
  return $data;
}



}
?>