<?php

require("../config/dbconn.php");

class SalesDao

{


public static function save_page_views($dev,$pname,$method)
{
$data=0;
try
{
$db = Factory::getConnection();


$statement = $db->prepare("INSERT into page_views(
ip ,uid ,ua,ekey,esecret,method,page,tz) 
values(:ip ,:uid ,
:ua ,:ekey ,:esecret ,:method ,:page,:tz)");
$statement->execute(array(':ip'=>$dev->ip,':uid'=>$dev->uid ,
':ua'=>$dev->ua,
':tz'=>$dev->tz ,
':method'=>$method ,':esecret'=>$dev->esecret,':ekey'=>$dev->ekey,
':page'=>$pname));


$data=1;
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function get_port_info($p1,$p2,$dev)
{
$data=array();
try
{
$db = Factory::getConnection();

$statement = $db->prepare("SELECT port_code,port_name from mt_port_master 
  where port_code in('$p1','$p2')");
$statement->execute();
$data["port"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT email from user_master 
  where username=:username");
$statement->execute(array(
  ':username'=>$dev->username
));

$data["user"]=$statement->fetchAll(PDO::FETCH_ASSOC);
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function update_enquiry($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();


$statement = $db->prepare("UPDATE mt_enquiry set 
edate=:edate,
status=:status,
service_category=:service_category,
name=:name,
company=:company,
from_port=:from_port,
to_port=:to_port,
weight=:weight,
volume=:volume,
country=:country,
city=:city,
email=:email,
phone=:phone,
assigned_to=:assigned_to,
validity=:validity,
send_to_client=:send_to_client,
service_detail=:service_detail,
modified_date= now(),modified_by=:modified_by where id=:id");
$statement->execute(array(
  ':id'=>$c->id,

  ':modified_by'=>$dev->username ,

':edate'=>$c->edate,
':status'=>$c->status,
':service_category'=>$c->service_category,
':name'=>$c->name,
':company'=>$c->company,
':from_port'=>$c->from_port,
':to_port'=>$c->to_port,
':weight'=>$c->weight,
':volume'=>$c->volume,
':country'=>$c->country,
':city'=>$c->city,
':email'=>$c->email,
':phone'=>$c->phone,
':assigned_to'=>$c->assigned_to,
':validity'=>$c->validity,
':send_to_client'=>$c->send_to_client,
':service_detail'=>$c->service_detail
));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function save_enquiry($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();


$statement = $db->prepare("INSERT into mt_enquiry(

edate,
status,
service_category,
name,
company,
from_port,
to_port,
weight,
volume,
country,
city,
email,
phone,
assigned_to,
validity,
send_to_client,
service_detail,
company_id,
location_id,
	ip,uid, ua,ekey,created_date,temp_code) 
values(

:edate,
:status,
:service_category,
:name,
:company,
:from_port,
:to_port,
:weight,
:volume,
:country,
:city,
:email,
:phone,
:assigned_to,
:validity,
:send_to_client,
:service_detail,
:company_id,
:location_id,
:ip ,:uid ,:ua ,:ekey,now(),:temp_code)");
$temp_code=uniqid($dev->uid);
$statement->execute(array(':ip'=>$dev->ip,':uid'=>$dev->username ,':ua'=>$dev->ua,':ekey'=>$dev->ekey,

':edate'=>$c->edate,
':status'=>$c->status,
':service_category'=>$c->service_category,
':name'=>$c->name,
':company'=>$c->company,
':from_port'=>$c->from_port,
':to_port'=>$c->to_port,
':weight'=>$c->weight,
':volume'=>$c->volume,
':country'=>$c->country,
':city'=>$c->city,
':email'=>$c->email,
':phone'=>$c->phone,
':assigned_to'=>$c->assigned_to,
':validity'=>$c->validity,
':send_to_client'=>$c->send_to_client,
':service_detail'=>$c->service_detail,
':temp_code'=>$temp_code,

':company_id'=>$dev->company,
':location_id'=>$dev->location
));

    if ($statement->rowCount()){
    $data["status"]=1;
      //echo 'Success: At least 1 row was affected.';
  } else{
    $data["status"]=0;
      //echo 'Failure: 0 rows were affected.';
  }

  $statement = $db->prepare("SELECT id from mt_enquiry where 
    uid=:uid and temp_code=:temp_code");
  $statement->execute(array(':temp_code'=>$temp_code,
    ':uid'=>$dev->username));
  $op=$statement->fetchAll(PDO::FETCH_ASSOC);

  $fid=self::setFourDigit($op[0]["id"]);

$on="ENQ/".date("Y")."/".date('m')."/".$c->from_port."/".$fid;

 $statement = $db->prepare("UPDATE mt_enquiry 
  SET enq_no=:ond where id=:id");
  $statement->execute(array(':id'=>$op[0]["id"],':ond'=>$on));
  
    if ($statement->rowCount()){
    $data["eid_status"]=1;
      //echo 'Success: At least 1 row was affected.';
  } else{
    $data["eid_status"]=0;
      //echo 'Failure: 0 rows were affected.';
  }

$data["enq_no"]=$on;


$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function setFourDigit($v)
{
  $len=strlen($v);

if($len==1)
{
  $v="000".$v;
}else if($len==2)
{
  $v="00".$v;
}else if($len==3)
{
  $v="0".$v;
}

return $v;
}

public static function search_enquiry_list($dev,$v)
{
$data=false;
try
{
$db = Factory::getConnection();

$aq=self::getRestrictionQuery($dev);

$statement = $db->prepare("SELECT 
id,
enq_no,
name,company,from_port,to_port,edate,
assigned_to,
validity,phone,email,status,created_date,uid created_by,
modified_date,modified_by
  from mt_enquiry where (enq_no like ? 
  or name like ? or assigned_to like ? ) and $aq 
  order by id desc limit 50");

$statement ->bindValue(1, "$v%", PDO::PARAM_STR);
$statement ->bindValue(2, "$v%", PDO::PARAM_STR);
$statement ->bindValue(3, "$v%", PDO::PARAM_STR);

$statement->execute();
$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function getRestrictionQuery($dev)
{
  $q="";
  if($dev->view_type=="USER")
  {
    $q=" company_id='$dev->company' and location_id='$dev->location' ";
  }else  if($dev->view_type=="ADMIN")
  {
    $q=" company_id='$dev->company' ";
  }else  if($dev->view_type=="SUPER ADMIN")
  {
    $q=" 1=1 ";
  }
  return $q; 
}
public static function get_enquiry_list($dev,$code)
{
$data=false;
try
{
$db = Factory::getConnection();

$aq=Factory::getRestrictionQuery($dev);

$statement = $db->prepare("SELECT 
id,
enq_no,
name,company,from_port,to_port,edate,
assigned_to,
validity,phone,email,status,created_date,uid created_by,
modified_date,modified_by
  from mt_enquiry WHERE $aq order by id desc limit :sta,50");
$statement->bindValue(':sta',(int) $code->start, PDO::PARAM_INT); 

$statement->execute();
$data=$statement->fetchAll(PDO::FETCH_ASSOC);

//var_dump($statement->debugDumpParams());

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function delete_enquiry($dev,$id)
{
$data=0;
try
{
$db = Factory::getConnection();


$statement = $db->prepare("DELETE FROM mt_enquiry
  where id=:id");

$statement->execute(array(
':id'=>$id
));

if ($statement->rowCount()){
  $data=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data=0;
    //echo 'Failure: 0 rows were affected.';
}

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}
public static function get_enquiry_info($id)
{
$data=false;
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT id,
  enq_no,
edate,
status,
service_category,
name,
company,
from_port,
to_port,
weight,
volume,
country,
city,
email,
phone,
assigned_to,
validity,
send_to_client,
service_detail from mt_enquiry where id=:id");
$statement->execute(array(':id'=>$id));
$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}
}
?>