<?php


require("../config/dbconn.php");

class UsersDao

{


public static function save_page_views($dev,$pname,$method)
{
$data=0;
try
{
$db = Factory::getConnection();


$statement = $db->prepare("INSERT into page_views(
ip ,uid ,ua,ekey,esecret,method,page,tz) 
values(:ip ,:uid ,
:ua ,:ekey ,:esecret ,:method ,:page,:tz)");
$statement->execute(array(':ip'=>$dev->ip,':uid'=>$dev->uid ,
':ua'=>$dev->ua,
':tz'=>$dev->tz ,
':method'=>$method ,':esecret'=>$dev->esecret,':ekey'=>$dev->ekey,
':page'=>$pname));


$data=1;
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_access_rights_user($dev)
{
$data=array();
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT pid id,module_name,module_url,page_name,page_url,page_icon,menu_icon, add_edit addRights,view viewRights,approve_cancel approve,
 cancel,editr,deleter 
 from access_rights_master t1
 left join page_list t2
 on t1.pid=t2.id 
 where role=(select role from user_master where username=:id) 
    order by t2.subcat ");
$statement->execute(array(':id'=>$dev->username));
$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function get_page_list()
{
$data=false;
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT t1.*,
  '' addRights,'' cancel,'' approve,'' viewRights,'' editr,
  '' deleter from page_list t1 order by cat,subcat");

$statement->execute();
$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_access_rights_list($role)
{
$data=false;
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT pid id,module_name,module_url,page_name,page_url,page_icon,menu_icon, add_edit addRights,view viewRights,approve_cancel approve,
 cancel,editr,deleter from access_rights_master t1, page_list t2
  where t1.role=:role and t1.pid=t2.id");
$statement->execute(array(':role'=>$role));
$data=$statement->fetchAll(PDO::FETCH_ASSOC);

//var_dump($statement->debugDumpParams());
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_role_list()
{
$data=false;
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT id,name from role_master order by id");

$statement->execute();
$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function get_user_list($code)
{
$data=false;
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT id,username,role,company,location from user_master where deleted=0 order by id limit :sta,50");
$statement->bindValue(':sta',(int) $code, PDO::PARAM_INT); 

$statement->execute();
$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function search_user_list($v)
{

$data=false;
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT id,username,role,company,location from user_master where username like ? or location like ? or company like ? order by id limit 50");

$statement ->bindValue(1, "%$v%", PDO::PARAM_STR);
$statement ->bindValue(2, "%$v%", PDO::PARAM_STR);
$statement ->bindValue(3, "%$v%", PDO::PARAM_STR);

$statement->execute();

$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_user_info($uid)
{
$data=array();
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT id,username,'dummyS@PASS123' password,role,company,location,
email,view_type,CASE when deactivate=0 THEN '' ELSE 1 END deactivate,mobile,display_name from user_master 
 where id=:uid and deleted=0");
$statement->execute(array(':uid'=>$uid));

$data["info"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function update_user_master($dev,$user)
{
$data=array();
try
{
$db = Factory::getConnection();

$options = [
    'cost' => 11  
];

if($user->deactivate=="")
{
  $user->deactivate=0;
}
$pass_hash=password_hash($user->password, PASSWORD_BCRYPT, $options);
$is_pass_changed=0;
if($user->password=='dummyS@PASS123')
{
$statement = $db->prepare("UPDATE user_master set 
  role=:role,email=:email,
modified_by=:modified_by,
modified_date=now(),
deactivate=:deactivate,
view_type=:view_type,
display_name=:display_name,
user_id=:user_id,
mobile=:mobile,
company=:company,
location=:location where id=:id");

$statement->execute(array(
  ':role'=>$user->role,
  ':email'=>$user->email,
  ':modified_by'=>$dev->username,
  ':deactivate'=>$user->deactivate,
  ':view_type'=>$user->view_type,
  ':id'=>$user->id,
  ':display_name'=>$user->display_name,
  ':mobile'=>$user->mobile,
  ':user_id'=>$user->username,
   ':company'=>$user->company,
  ':location'=>$user->location
  ));
}
else
{
$is_pass_changed=1;
 
 $statement = $db->prepare("UPDATE user_master set 
  password=:password,
  role=:role,
  email=:email,
modified_by=:modified_by,
modified_date=now(),
deactivate=:deactivate,
view_type=:view_type,
user_id=:user_id,
mobile=:mobile,
company=:company,
location=:location,
display_name=:display_name where id=:id");
$statement->execute(array(
  ':password'=>$pass_hash,
  
  ':role'=>$user->role,
  ':email'=>$user->email,
  ':modified_by'=>$dev->username,
  ':deactivate'=>$user->deactivate,
  ':view_type'=>$user->view_type,
  ':id'=>$user->id,
  ':display_name'=>$user->display_name,
  ':mobile'=>$user->mobile,
  ':user_id'=>$user->username,
   ':company'=>$user->company,
  ':location'=>$user->location
  ));

}

if ($statement->rowCount()){
  $data["status"]=1;
  $data["pass"]=$user->password;
} else{
  $data["status"]=0;
}

//delete login verify entry
if($is_pass_changed==1)
{

$statement = $db->prepare("DELETE FROM user_loggedin_verify
 where uid=:uid");
$statement->execute(array(
  ':uid'=>$dev->uid
  ));

if ($statement->rowCount()){
  $data["loginv_status"]=1;
} else{
  $data["loginv_status"]=0;
}

}
//end of verify login

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function save_user_master($dev,$user)
{
$data=array();
try
{
$db = Factory::getConnection();

$statement = $db->prepare("SELECT count(*) c from user_master");
$statement->execute();
$cts=$statement->fetchAll(PDO::FETCH_ASSOC);
//4 dummy users for test purpose
if($cts[0]["c"]<24)
{
$options = [
    'cost' => 11  
];

$temp_code=uniqid($dev->uid);
$pass_hash=password_hash($user->password, PASSWORD_BCRYPT, $options);


$statement = $db->prepare("INSERT into user_master(display_name,mobile,username,user_id,view_type,password,
  role,company,location,email,created_by,created_date,verified,ip,ua,ekey,deactivate) 
values(:display_name,:mobile,:username,:username,:view_type,:password,:role,:company,:location,:email,:created_by, now(),1,:ip,:ua,:ekey,0)");
$statement->execute(array(
  ':display_name'=>$user->display_name,
  ':mobile'=>$user->mobile,
  ':username'=>$user->username,
  ':view_type'=>$user->view_type,

  ':password'=>$pass_hash,
  ':role'=>$user->role,
  ':company'=>$user->company,
  ':location'=>$user->location,
  ':email'=>$user->email,
  ':created_by'=>$dev->username,
  
  ':ip'=>$dev->ip,
  ':ua'=>$dev->ua,
  ':ekey'=>$dev->ekey
));

if ($statement->rowCount()){
  $data["status"]=1;
} else{
  $data["status"]=0;
}

}else{
  $data["status"]=2;
  $data["msg"]="Maximum user limit reached. Please contact sales team.";
}

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function bool_convert($inp)
{
  if($inp)
  {
    return 'true';
  }else
  {
    return 'false';
  }
}


public static function save_access_rights_list($dev,$code)
{
$data=0;
try
{
$db = Factory::getConnection();

$role=$code->role;
$rights=$code->rights;

$statement = $db->prepare("DELETE from access_rights_master where role=:role");
$statement->execute(array(':role'=>$role));

$statement = $db->prepare("INSERT into access_rights_master(
pid ,add_edit ,view,approve_cancel,role,cancel,editr,deleter) 
values(:pid ,:add_edit ,
:view ,:approve_cancel ,:role,:cancel,:editr,:deleter)");

for($i=0;$i<count($rights);$i++)
{

  $r=$rights[$i];
  $statement->execute(array(':pid'=>$r->id,
    ':add_edit'=>self::bool_convert($r->addRights) ,
':view'=>self::bool_convert($r->viewRights),
':approve_cancel'=>self::bool_convert($r->approve),
':role'=>$role,
':cancel'=>$r->cancel,
':editr'=>self::bool_convert($r->editr),
':deleter'=>self::bool_convert($r->deleter)
));

}

if ($statement->rowCount()){
    $data=1;
} else{
   $data=0;
}




$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function delete_user_master($dev,$code)
{
$data=array();
try
{
$db = Factory::getConnection();
$statement = $db->prepare("UPDATE user_master SET deleted=1,
  modified_by=:username, modified_by=now where id=:id");


$statement->execute(array(':username'=>$dev->username,
  ':id'=>$code));

if ($statement->rowCount()){
    $data["status"]=1;
} else{
     $data["status"]=0;
}

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function save_role_master($dev,$role)
{
$data=array();
try
{
$db = Factory::getConnection();
$statement = $db->prepare("INSERT into role_master(name,ip,ua,ekey,created_by,created_date) values(:name,
:ip,:ua,:ekey,:created_by,now() )");


$statement->execute(array(':name'=>$role,
  ':ip'=>$dev->ip,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,
':created_by'=>$dev->username));

if ($statement->rowCount()){
    $data["status"]=1;
} else{
     $data["status"]=0;
}

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function get_role_master()
{
$data=false;
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT * from role_master");
$statement->execute();
$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function save_rate($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$temp_code=uniqid($dev->uid);

$statement = $db->prepare("INSERT into mt_rates(created_by,created_date,ip,ua,ekey,temp_code) 
values(:created_by,now(),:ip,:ua,:ekey,
:temp_code)");

$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->uid ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,




':temp_code'=>$temp_code
));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
  /*

  */
} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}

$statement = $db->prepare("SELECT id from mt_erc where created_by=:uid and temp_code=:temp_code");
$statement->execute(array(':temp_code'=>$temp_code,':uid'=>$dev->uid));
$data["id"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function update_rate($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$statement = $db->prepare("UPDATE mt_rates SET 

modified_by=:modified_by,
modified_date=now() 
where id=:id");

$statement->execute(array(':modified_by'=>$dev->uid ,

':id'=>$c->id
));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
  /*

  */
} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

}

?>