<?php


require("../config/dbconn.php");

class VesselOpsDao

{


public static function save_page_views($dev,$pname,$method)
{
$data=0;
try
{
$db = Factory::getConnection();


$statement = $db->prepare("INSERT into page_views(
ip ,uid ,ua,ekey,esecret,method,page,tz) 
values(:ip ,:uid ,
:ua ,:ekey ,:esecret ,:method ,:page,:tz)");
$statement->execute(array(':ip'=>$dev->ip,':uid'=>$dev->uid ,
':ua'=>$dev->ua,
':tz'=>$dev->tz ,
':method'=>$method ,':esecret'=>$dev->esecret,':ekey'=>$dev->ekey,
':page'=>$pname));


$data=1;
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function update_pda_fda($dev,$code)
{
$data=array();
try
{
$db = Factory::getConnection();


$statement = $db->prepare("UPDATE mt_vessel_fda 
	SET status=:status
	where id=:id");

$statement->execute(array(':id'=>$code->id,
':status'=>$code->status));

if ($statement->rowCount()){
  $data["status"]=1;

} else{
  $data["status"]=0;
}

$statement = $db->prepare("UPDATE mt_vessel_quote_rate set invoiced=0
	where id in(SELECT qr_id from mt_vessel_fda_details where fda_no=:fda_no)");
$statement->execute(array(':fda_no'=>$code->fda_no));

if ($statement->rowCount()){
  $data["ch_status"]=1;

} else{
  $data["ch_status"]=0;
}

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function save_pda_fda($dev,$code)
{
$data=array();
try
{
$db = Factory::getConnection();

$temp_code=uniqid($dev->uid);
$c=$code->info;

$statement = $db->prepare("INSERT into mt_vessel_fda(
quote_no,ch_agr_no,fda_date,f_amt,l_amt,status,customer,
ip,created_by ,ua,ekey,created_date,temp_code,
company_id,location_id) 
values(
:quote_no,:ch_agr_no,:fda_date,:f_amt,:l_amt,:status,:customer,
:ip,:created_by,
:ua,:ekey,now(),:temp_code,
:company_id,:location_id)");

$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->username ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,
//
':quote_no'=>$c->quote_no,
':ch_agr_no'=>$c->ch_agr_no,
':fda_date'=>$c->fda_date,
':f_amt'=>$c->f_amt,
':l_amt'=>$c->l_amt,
':status'=>$c->status,
':customer'=>$c->customer,
//
':temp_code'=>$temp_code,
':company_id'=>$dev->company,
':location_id'=>$dev->location,
));

if ($statement->rowCount()){
  $data["status"]=1;

} else{
  $data["status"]=0;
}
$data["temp_code"]=$temp_code;

$statement = $db->prepare("SELECT id from mt_vessel_fda where created_by=:uid and temp_code=:temp_code");
$statement->execute(array(':temp_code'=>$temp_code,':uid'=>$dev->username));
$op=$statement->fetchAll(PDO::FETCH_ASSOC);

$data["id"]=$op;

$fid=self::setFourDigit($op[0]["id"]);

$on="FDA/".date("Y")."/".date('m')."/".$fid;

 $statement = $db->prepare("UPDATE mt_vessel_fda 
  SET fda_no=:ond where id=:id");
  $statement->execute(array(':id'=>$op[0]["id"],':ond'=>$on));
  
    if ($statement->rowCount()){
    $data["fid_status"]=1;
  } else{
    $data["fid_status"]=0;
  }

$data["fda_no"]=$on;

$cds=$code->cds;
//loop charges
for($i=0;$i<count($cds);$i++)
{
	$cd=$cds[$i];

	$statement=$db->prepare("INSERT into mt_vessel_fda_details(ch_agr_no,quote_no,fda_no,fda_date,provider,type,charge_desc,rate,pay_at_location,basis_type,base_uom,commodity,currency,qty,ex_rate,foreign_amount,local_amount,ip,ua,ekey,created_by,created_date,company_id,location_id,qr_id) SELECT '$c->ch_agr_no','$c->quote_no','$on',
		'$c->fda_date',rate_provider,rate_type,charge_description,rate,pay_at_location,basis_type,base_unit,commodity,currency,qty,ex_rate,foreign_amount,local_amount,'$dev->ip','$dev->ua','$dev->ekey',
		'$dev->username',now(),'$dev->company',
		'$dev->location',$cd->id from mt_vessel_quote_rate 
		where id=:id");
$statement->execute(array(':id'=>$cd->id));
  
    if ($statement->rowCount()){
    $data["cid_status".($i+1)]=1;
  } else{
    $data["cid_status".($i+1)]=0;
  }

  $statement=$db->prepare("UPDATE mt_vessel_quote_rate 
  	set invoiced=1, fda_no=:fda_no where id=:id");
$statement->execute(array(':id'=>$cd->id,':fda_no'=>$on));
  
    if ($statement->rowCount()){
    $data["cidq_status".($i+1)]=1;
  } else{
    $data["cidq_status".($i+1)]=0;
  }

}
//loop charges end
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function get_vessel_info_auto($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT '' id,'' ch_agr_no,vessel_name,year_built,flag,'' port_of_reg,vessel_type,sdwt,loa,beam,sbt,cbm,draft_sw,gt_nt,panama_gt_nt,suez_gt_nt,lbp,geared,moulded_depth,lloyds_imo_no,standard_name,active_from,active_to from mt_vessel  
  where vessel_name=:id");
$statement->execute(array(':id'=>$c));
$data["vessel_info"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  return $data;
}

public static function get_vessel_info($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT id,ch_agr_no,vessel_name,year_built,flag,port_of_reg,vessel_type,sdwt,loa,beam,sbt,cbm,draft_sw,gt_nt,panama_gt_nt,suez_gt_nt,lbp,geared,moulded_depth,lloyds_imo_no,standard_name,active_from,active_to from mt_vessel_ops  
  where id=:id");
$statement->execute(array(':id'=>$c));
$data["vessel_info"]=$statement->fetchAll(PDO::FETCH_ASSOC);
if(count($data["vessel_info"])>0)
{
//$vessel_id=$data["vessel_info"][0]["id"];

//vessel capacity
$statement = $db->prepare("SELECT id,vessel_ops_pk,weight,uom,
	volume,units,teus,reefer20,reefer40,'0' edit from mt_vessel_ops_capacity where vessel_ops_pk=:id");
$statement->execute(array(':id'=>$c));
$data["vessel_capacity"]=$statement->fetchAll(PDO::FETCH_ASSOC);

//vessel crew
$statement = $db->prepare("SELECT id,vessel_ops_pk,crew_name,designation,passport_no,signin_date,signout_date,signin_location,signout_location,file_name,file_url,'0' edit,ship_manager from mt_vessel_ops_crew 
where vessel_ops_pk=:id");
$statement->execute(array(':id'=>$c));
$data["vessel_crew"]=$statement->fetchAll(PDO::FETCH_ASSOC);

}
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  return $data;
}

public static function get_charter_agreement_info($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT id,ch_agr_no,owner,vessel,load_port,disc_port,dead_wgt_cargo,exp_ready_to_load,freight_rate,load_disc_cost,demurrage_rate,agreement_date,place_of_business,charter,ch_place_of_business,grt_nrt,present_position,freight_payment,laytime,laytime_load,laytime_disc,total_laydays,cancel_date,terms,
  temp_code,charter_type from mt_charter_agreement  
  where id=:id");
$statement->execute(array(':id'=>$c));
$data=$statement->fetchAll(PDO::FETCH_ASSOC);
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  return $data;
}


public static function search_charter_no($dev,$code)
{
$data=false;
try
{
$db = Factory::getConnection();

$aq=Factory::getRestrictionQuery($dev);

$statement = $db->prepare("SELECT 
id,ch_agr_no,owner,vessel
  from mt_charter_agreement WHERE ch_agr_no like ? order by id desc limit 50");
$i=1;
$statement ->bindValue($i++, "%$code%", PDO::PARAM_STR); 
$statement->execute();
$data=$statement->fetchAll(PDO::FETCH_ASSOC);
//var_dump($statement->debugDumpParams());
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function search_lb_list($dev,$code)
{
$data=false;
try
{
$db = Factory::getConnection();

$aq=Factory::getRestrictionQuery($dev);

$statement = $db->prepare("SELECT 
id,ch_agr_no,owner,vessel,load_port,disc_port,dead_wgt_cargo,exp_ready_to_load,freight_rate,load_disc_cost,demurrage_rate,agreement_date,place_of_business,charter,ch_place_of_business,grt_nrt,present_position,freight_payment,laytime,laytime_load,laytime_disc,total_laydays,cancel_date,terms,created_date,created_by,
modified_date,modified_by
  from mt_charter_agreement WHERE (ch_agr_no like ? or owner like ? or vessel like ?) and $aq order by id desc limit :sta,50");
$i=1;
$statement ->bindValue($i++, "%$code%", PDO::PARAM_STR); 
$statement ->bindValue($i++, "%$code%", PDO::PARAM_STR); 
$statement ->bindValue($i++, "%$code%", PDO::PARAM_STR); 

$statement->execute();
$data=$statement->fetchAll(PDO::FETCH_ASSOC);

//var_dump($statement->debugDumpParams());

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function get_lb_list($dev,$code)
{
$data=false;
try
{
$db = Factory::getConnection();

$aq=Factory::getRestrictionQuery($dev);

$statement = $db->prepare("SELECT 
id,ch_agr_no,owner,vessel,load_port,disc_port,dead_wgt_cargo,exp_ready_to_load,freight_rate,load_disc_cost,demurrage_rate,agreement_date,place_of_business,charter,ch_place_of_business,grt_nrt,present_position,freight_payment,laytime,laytime_load,laytime_disc,total_laydays,cancel_date,terms,created_date,created_by,
modified_date,modified_by
  from mt_charter_agreement WHERE $aq order by id desc limit :sta,50");
$statement->bindValue(':sta',(int) $code->start, PDO::PARAM_INT); 

$statement->execute();
$data=$statement->fetchAll(PDO::FETCH_ASSOC);

//var_dump($statement->debugDumpParams());

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function update_charter_agreement($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();


$statement = $db->prepare("UPDATE mt_charter_agreement SET 
owner=:owner,
vessel=:vessel,
load_port=:load_port,
disc_port=:disc_port,
dead_wgt_cargo=:dead_wgt_cargo,
exp_ready_to_load=:exp_ready_to_load,
freight_rate=:freight_rate,
load_disc_cost=:load_disc_cost,
demurrage_rate=:demurrage_rate,
agreement_date=:agreement_date,
place_of_business=:place_of_business,
charter=:charter,
ch_place_of_business=:ch_place_of_business,
grt_nrt=:grt_nrt,
present_position=:present_position,
freight_payment=:freight_payment,
laytime=:laytime,
laytime_load=:laytime_load,
laytime_disc=:laytime_disc,
total_laydays=:total_laydays,
cancel_date=:cancel_date,
terms=:terms,modified_by=:modified_by,modified_date=now(),
charter_type=:charter_type  
where id=:id");

$statement->execute(array(
//
':owner'=>$c->owner,
':vessel'=>$c->vessel,
':load_port'=>$c->load_port,
':disc_port'=>$c->disc_port,
':dead_wgt_cargo'=>$c->dead_wgt_cargo,
':exp_ready_to_load'=>$c->exp_ready_to_load,
':freight_rate'=>$c->freight_rate,
':load_disc_cost'=>$c->load_disc_cost,
':demurrage_rate'=>$c->demurrage_rate,
':agreement_date'=>$c->agreement_date,
':place_of_business'=>$c->place_of_business,
':charter'=>$c->charter,
':ch_place_of_business'=>$c->ch_place_of_business,
':grt_nrt'=>$c->grt_nrt,
':present_position'=>$c->present_position,
':freight_payment'=>$c->freight_payment,
':laytime'=>$c->laytime,
':laytime_load'=>$c->laytime_load,
':laytime_disc'=>$c->laytime_disc,
':total_laydays'=>$c->total_laydays,
':cancel_date'=>$c->cancel_date,
':terms'=>$c->terms,
//
':id'=>$c->id,
':modified_by'=>$dev->username,
':charter_type'=>$c->charter_type
));

  if ($statement->rowCount()){
    $data["status"]=1;
  } else{
    $data["status"]=0;
  }


$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function save_charter_agreement($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();


$statement = $db->prepare("INSERT into mt_charter_agreement(owner,vessel,load_port,disc_port,dead_wgt_cargo,exp_ready_to_load,freight_rate,load_disc_cost,demurrage_rate,agreement_date,place_of_business,charter,ch_place_of_business,grt_nrt,present_position,freight_payment,laytime,laytime_load,laytime_disc,total_laydays,cancel_date,terms,company_id,
location_id,ip,created_by, ua,ekey,created_date,temp_code,
charter_type) 
values(:owner,:vessel,:load_port,:disc_port,:dead_wgt_cargo,:exp_ready_to_load,:freight_rate,:load_disc_cost,:demurrage_rate,:agreement_date,:place_of_business,:charter,:ch_place_of_business,:grt_nrt,:present_position,:freight_payment,:laytime,:laytime_load,:laytime_disc,
:total_laydays,:cancel_date,:terms,
:company_id,
:location_id,
:ip,:uid,:ua,:ekey,now(),:temp_code,:charter_type)");
$temp_code=uniqid($dev->uid);
$statement->execute(array(':ip'=>$dev->ip,':uid'=>$dev->username ,':ua'=>$dev->ua,':ekey'=>$dev->ekey,
//
':owner'=>$c->owner,
':vessel'=>$c->vessel,
':load_port'=>$c->load_port,
':disc_port'=>$c->disc_port,
':dead_wgt_cargo'=>$c->dead_wgt_cargo,
':exp_ready_to_load'=>$c->exp_ready_to_load,
':freight_rate'=>$c->freight_rate,
':load_disc_cost'=>$c->load_disc_cost,
':demurrage_rate'=>$c->demurrage_rate,
':agreement_date'=>$c->agreement_date,
':place_of_business'=>$c->place_of_business,
':charter'=>$c->charter,
':ch_place_of_business'=>$c->ch_place_of_business,
':grt_nrt'=>$c->grt_nrt,
':present_position'=>$c->present_position,
':freight_payment'=>$c->freight_payment,
':laytime'=>$c->laytime,
':laytime_load'=>$c->laytime_load,
':laytime_disc'=>$c->laytime_disc,
':total_laydays'=>$c->total_laydays,
':cancel_date'=>$c->cancel_date,
':terms'=>$c->terms,

//
':temp_code'=>$temp_code,
':company_id'=>$dev->company,
':location_id'=>$dev->location,
':charter_type'=>$c->charter_type
));

    if ($statement->rowCount()){
    $data["status"]=1;
  } else{
    $data["status"]=0;
  }

  $statement = $db->prepare("SELECT id from mt_charter_agreement 
  	where created_by=:uid and temp_code=:temp_code");
  $statement->execute(array(':temp_code'=>$temp_code,
    ':uid'=>$dev->username));
  $op=$statement->fetchAll(PDO::FETCH_ASSOC);

$data["id"]=$op;

  $fid=self::setFourDigit($op[0]["id"]);

$on="CHAR/".date("Y")."/".date('m')."/".$fid;

 $statement = $db->prepare("UPDATE mt_charter_agreement  
  SET ch_agr_no=:ond where id=:id");
  $statement->execute(array(':id'=>$op[0]["id"],':ond'=>$on));
  
  if ($statement->rowCount()){
    $data["id_status"]=1;
  } else{
    $data["id_status"]=0;
  }

$data["char_no"]=$on;


$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function delete_vessel_capacity($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$statement = $db->prepare("DELETE from mt_vessel_ops_capacity
	WHERE id=:id");
$statement->execute(array(
':id'=>$c
));
if ($statement->rowCount()){
  $data["status"]=1;
} else{
  $data["status"]=0;
}
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function update_vessel_capacity($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$statement = $db->prepare("UPDATE mt_vessel_ops_capacity SET 
	weight=:weight,uom=:uom,
	volume=:volume,units=:units,teus=:teus,reefer20=:reefer20,
	reefer40=:reefer40,modified_by=:modified_by,modified_date=now() WHERE id=:id");
$statement->execute(array(
':modified_by'=>$dev->username,
//
':weight'=>$c->weight,
':uom'=>$c->uom,
':volume'=>$c->volume,
':units'=>$c->units,
':teus'=>$c->teus,
':reefer20'=>$c->reefer20,
':reefer40'=>$c->reefer40,
//
':id'=>$c->id
));

if ($statement->rowCount()){
  $data["status"]=1;
} else{
  $data["status"]=0;
}

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


//save method begins
public static function save_vessel_capacity($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$temp_code=uniqid($dev->uid);

$statement = $db->prepare("INSERT into mt_vessel_ops_capacity(vessel_ops_pk,weight,uom,volume,units,teus,reefer20,reefer40,
ip,uid, ua,ekey,created_date,created_by,
temp_code,company_id,location_id) 
values(
:vessel_ops_pk,:weight,:uom,:volume,:units,:teus,:reefer20,:reefer40,
:ip,:uid,:ua,:ekey,now(),:created_by,
:temp_code,:company_id,:location_id)");
$statement->execute(array(':ip'=>$dev->ip,':uid'=>$dev->uid ,':ua'=>$dev->ua,':ekey'=>$dev->ekey,
':created_by'=>$dev->username,
//
':vessel_ops_pk'=>$c->vessel_ops_pk,
':weight'=>$c->weight,
':uom'=>$c->uom,
':volume'=>$c->volume,
':units'=>$c->units,
':teus'=>$c->teus,
':reefer20'=>$c->reefer20,
':reefer40'=>$c->reefer40,
//
':temp_code'=>$temp_code,
':company_id'=>$dev->company,
':location_id'=>$dev->location
));

if ($statement->rowCount()){
  $data["status"]=1;
} else{
  $data["status"]=0;
}

$statement = $db->prepare("SELECT id from mt_vessel_ops_capacity
 where created_by=:uid and temp_code=:temp_code ");
$statement->execute(array(':temp_code'=>$temp_code,
  ':uid'=>$dev->username));
$data["id"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function save_vessel_crew($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();
$temp_code=uniqid($dev->uid);
$statement = $db->prepare("INSERT into mt_vessel_ops_crew(vessel_ops_pk,crew_name,designation,passport_no,signin_date,signout_date,signin_location,signout_location,
file_name,file_url,
company_id,location_id,ip,created_by, ua,ekey,created_date,temp_code,ship_manager) 
values(:vessel_ops_pk,:crew_name,:designation,:passport_no,:signin_date,:signout_date,:signin_location,:signout_location,
:file_name,:file_url,
:company_id,:location_id,
:ip,:created_by,:ua,:ekey,now(),:temp_code,:ship_manager)");
$statement->execute(array(':ip'=>$dev->ip,
  ':created_by'=>$dev->username ,
  ':ua'=>$dev->ua,':ekey'=>$dev->ekey,
//
':vessel_ops_pk'=>$c->vessel_ops_pk,
':crew_name'=>$c->crew_name,
':designation'=>$c->designation,
':passport_no'=>$c->passport_no,
':signin_date'=>$c->signin_date,
':signout_date'=>$c->signout_date,
':signin_location'=>$c->signin_location,
':signout_location'=>$c->signout_location,
//
':temp_code'=>$temp_code,
':company_id'=>$dev->company,
':location_id'=>$dev->location,
':file_name'=>$c->file_name,
':file_url'=>$c->file_url,
':ship_manager'=>$c->ship_manager
));

if ($statement->rowCount()){
  $data["status"]=1;
} else{
  $data["status"]=0;
}

$statement = $db->prepare("SELECT id from mt_vessel_ops_crew 
	where created_by=:created_by and temp_code=:temp_code and vessel_ops_pk=:vessel_ops_pk");
$statement->execute(array(':temp_code'=>$temp_code,
  ':created_by'=>$dev->username,':vessel_ops_pk'=>$c->vessel_ops_pk));
$data["id"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

//save method begins
public static function save_vessel($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$temp_code=uniqid($dev->uid);

$statement = $db->prepare("INSERT into mt_vessel_ops(
ch_agr_no,vessel_name,year_built,flag,port_of_reg,vessel_type,sdwt,loa,beam,sbt,cbm,draft_sw,gt_nt,panama_gt_nt,suez_gt_nt,lbp,geared,moulded_depth,lloyds_imo_no,standard_name,active_from,active_to,
ip,uid,ua,ekey,created_date,created_by,temp_code,
company_id,location_id) 
values(:ch_agr_no,:vessel_name,:year_built,:flag,:port_of_reg,:vessel_type,:sdwt,:loa,:beam,:sbt,:cbm,:draft_sw,:gt_nt,:panama_gt_nt,:suez_gt_nt,:lbp,:geared,:moulded_depth,:lloyds_imo_no,:standard_name,:active_from,:active_to,
:ip,:uid,:ua,:ekey,now(),:created_by,
:temp_code,:company_id,:location_id)");
$statement->execute(array(':ip'=>$dev->ip,':uid'=>$dev->uid ,':ua'=>$dev->ua,':ekey'=>$dev->ekey,
':created_by'=>$dev->username,
//
':ch_agr_no'=>$c->ch_agr_no,
':vessel_name'=>$c->vessel_name,
':year_built'=>$c->year_built,
':flag'=>$c->flag,
':port_of_reg'=>$c->port_of_reg,
':vessel_type'=>$c->vessel_type,
':sdwt'=>$c->sdwt,
':loa'=>$c->loa,
':beam'=>$c->beam,
':sbt'=>$c->sbt,
':cbm'=>$c->cbm,
':draft_sw'=>$c->draft_sw,
':gt_nt'=>$c->gt_nt,
':panama_gt_nt'=>$c->panama_gt_nt,
':suez_gt_nt'=>$c->suez_gt_nt,
':lbp'=>$c->lbp,
':geared'=>$c->geared,
':moulded_depth'=>$c->moulded_depth,
':lloyds_imo_no'=>$c->lloyds_imo_no,
':standard_name'=>$c->standard_name,
':active_from'=>$c->active_from,
':active_to'=>$c->active_to,
//
':temp_code'=>$temp_code,
':company_id'=>$dev->company,
':location_id'=>$dev->location
));

if ($statement->rowCount()){
  $data["status"]=1;
} else{
  $data["status"]=0;
}

$statement = $db->prepare("SELECT id from mt_vessel_ops where created_by=:uid and temp_code=:temp_code ");
$statement->execute(array(':temp_code'=>$temp_code,
  ':uid'=>$dev->username));
$data["id"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function update_vessel_crew($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();
$statement = $db->prepare("UPDATE mt_vessel_ops_crew  
SET 
crew_name=:crew_name,
designation=:designation,
passport_no=:passport_no,
signin_date=:signin_date,
signout_date=:signout_date,
signin_location=:signin_location,
signout_location=:signout_location,

file_name=:file_name,
file_url=:file_url,
modified_by=:username,modified_date=now(),
ship_manager=:ship_manager where id=:id");
$statement->execute(array(
':username'=>$dev->username ,
//
':crew_name'=>$c->crew_name,
':designation'=>$c->designation,
':passport_no'=>$c->passport_no,
':signin_date'=>$c->signin_date,
':signout_date'=>$c->signout_date,
':signin_location'=>$c->signin_location,
':signout_location'=>$c->signout_location,
//
':file_name'=>$c->file_name,
':file_url'=>$c->file_url,
':id'=>$c->id,
':ship_manager'=>$c->ship_manager
));

if ($statement->rowCount()){
  $data["status"]=1;
} else{
  $data["status"]=0;
}
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  return $data;
}


public static function delete_vessel_crew($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();
$statement = $db->prepare("DELETE from mt_vessel_ops_crew
   where id=:id");
$statement->execute(array(
  ':id'=>$c->id
));
if ($statement->rowCount()){
  $data["status"]=1;
} else{
  $data["status"]=0;
}
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  return $data;
}


public static function update_vessel($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$statement = $db->prepare("UPDATE mt_vessel_ops set 
vessel_name=:vessel_name,
year_built=:year_built,
flag=:flag,
port_of_reg=:port_of_reg,
vessel_type=:vessel_type,
sdwt=:sdwt,
loa=:loa,
beam=:beam,
sbt=:sbt,
cbm=:cbm,
draft_sw=:draft_sw,
gt_nt=:gt_nt,
panama_gt_nt=:panama_gt_nt,
suez_gt_nt=:suez_gt_nt,
lbp=:lbp,
geared=:geared,
moulded_depth=:moulded_depth,
lloyds_imo_no=:lloyds_imo_no,
standard_name=:standard_name,
active_from=:active_from,
active_to=:active_to,
modified_by=:modified_by,modified_date=now() where id=:id");
$statement->execute(array(
  ':id'=>$c->id, 
':modified_by'=>$dev->username ,
//
':vessel_name'=>$c->vessel_name,
':year_built'=>$c->year_built,
':flag'=>$c->flag,
':port_of_reg'=>$c->port_of_reg,
':vessel_type'=>$c->vessel_type,
':sdwt'=>$c->sdwt,
':loa'=>$c->loa,
':beam'=>$c->beam,
':sbt'=>$c->sbt,
':cbm'=>$c->cbm,
':draft_sw'=>$c->draft_sw,
':gt_nt'=>$c->gt_nt,
':panama_gt_nt'=>$c->panama_gt_nt,
':suez_gt_nt'=>$c->suez_gt_nt,
':lbp'=>$c->lbp,
':geared'=>$c->geared,
':moulded_depth'=>$c->moulded_depth,
':lloyds_imo_no'=>$c->lloyds_imo_no,
':standard_name'=>$c->standard_name,
':active_from'=>$c->active_from,
':active_to'=>$c->active_to,

));

if ($statement->rowCount()){
  $data["status"]=1;
} else{
  $data["status"]=0;
}

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}




public static function setFourDigit($v)
{
  $len=strlen($v);

if($len==1)
{
  $v="000".$v;
}else if($len==2)
{
  $v="00".$v;
}else if($len==3)
{
  $v="0".$v;
}

return $v;
}



//quote


public static function save_quote_rate($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$temp_code=uniqid($dev->uid);

$statement = $db->prepare("INSERT into mt_vessel_quote_rate(rate_provider,rate_type,charge_description,pay_at_location,basis_type,rate,base_unit,commodity,currency,qty,ex_rate,foreign_amount,local_amount,quote_id,
ip,created_by ,ua,ekey,created_date,temp_code) 
values(:rate_provider,:rate_type,:charge_description,:pay_at_location,:basis_type,:rate,:base_unit,:commodity,:currency,:qty,:ex_rate,:foreign_amount,:local_amount,:quote_id,
:ip ,:created_by ,
:ua ,:ekey,now(),:temp_code)");

$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->uid ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,

':rate_provider'=>$c->rate_provider,
':rate_type'=>$c->rate_type,
':charge_description'=>$c->charge_description,
':pay_at_location'=>$c->pay_at_location,
':basis_type'=>$c->basis_type,
':rate'=>$c->rate,
':base_unit'=>$c->base_unit,
':commodity'=>$c->commodity,
':currency'=>$c->currency,
':qty'=>$c->qty,
':ex_rate'=>$c->ex_rate,
':foreign_amount'=>$c->foreign_amount,
':local_amount'=>$c->local_amount,

':quote_id'=>$c->quote_id,
':temp_code'=>$temp_code
));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
  /*

  */
} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}

$statement = $db->prepare("SELECT id from mt_vessel_quote_rate where created_by=:uid and temp_code=:temp_code and quote_id=:quote_id");
$statement->execute(array(':temp_code'=>$temp_code,
  ':uid'=>$dev->uid,':quote_id'=>$c->quote_id));
$data["id"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function update_quote_route($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$statement = $db->prepare("UPDATE mt_vessel_quote_route SET 

    route_mode=:route_mode,
provider=:provider,
origin=:origin,
destination=:destination,
transit1=:transit1,
duration=:duration,
currency=:currency,
buying_rate=:buying_rate,
selling_rate=:selling_rate,
terms=:terms,
type=:type,
ip=:ip,created_by=:created_by,ua=:ua,ekey=:ekey,created_date= now() where id=:id and quote_id=:quote_id");

if($c->buying_rate=="")
{
  $c->buying_rate=null;
}
if($c->selling_rate=="")
{
  $c->selling_rate=null;
}


$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->uid ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,

':route_mode'=>$c->route_mode,
':provider'=>$c->provider,
':origin'=>$c->origin,
':destination'=>$c->destination,
':transit1'=>$c->transit1,
':duration'=>$c->duration,
':currency'=>$c->currency,
':buying_rate'=>$c->buying_rate,
':selling_rate'=>$c->selling_rate,
':terms'=>$c->terms,
':type'=>$c->type,

':quote_id'=>$c->quote_id,
':id'=>$c->id
));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';

} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}


$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function delete_ne($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$temp_code=uniqid($dev->uid);

$statement = $db->prepare("DELETE from mt_vessel_noon_entry  
	WHERE id=:id");
$statement->execute(array(
':id'=>$c
));

if ($statement->rowCount()){
  $data["status"]=1;
} else{
  $data["status"]=0;
}

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function update_ne($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$temp_code=uniqid($dev->uid);

$statement = $db->prepare("UPDATE mt_vessel_noon_entry SET 
	pdate=:pdate,
position=:position,
lattitude=:lattitude,
longittude=:longittude,
speed=:speed,
dmg=:dmg,
tdmg=:tdmg,
dtg=:dtg,
local_time=:local_time,
eta=:eta,
fo=:fo,
cons_fo=:cons_fo,
do=:do,
cons_do=:cons_do,
lsfo=:lsfo,
cons_lsfo=:cons_lsfo,
lsdo=:lsdo,
cons_lsdo=:cons_lsdo,
mco=:mco,
cons_mco=:cons_mco,
smo=:smo,
cons_smo=:cons_smo,
ae_lo=:ae_lo,
cons_aelo=:cons_aelo,
fresh_water=:fresh_water,
cons_fw=:cons_fw,
ho=:ho,
cons_ho=:cons_ho,
draft=:draft,
remarks=:remarks,
modified_by=:modified_by,
modified_date=now() 
	WHERE id=:id");

$statement->execute(array(':modified_by'=>$dev->username,
//
':position'=>$c->position,
':lattitude'=>$c->lattitude,
':longittude'=>$c->longittude,
':speed'=>$c->speed,
':dmg'=>$c->dmg,
':tdmg'=>$c->tdmg,
':dtg'=>$c->dtg,
':local_time'=>$c->local_time,
':eta'=>$c->eta,
':fo'=>$c->fo,
':cons_fo'=>$c->cons_fo,
':do'=>$c->do,
':cons_do'=>$c->cons_do,
':lsfo'=>$c->lsfo,
':cons_lsfo'=>$c->cons_lsfo,
':lsdo'=>$c->lsdo,
':cons_lsdo'=>$c->cons_lsdo,
':mco'=>$c->mco,
':cons_mco'=>$c->cons_mco,
':smo'=>$c->smo,
':cons_smo'=>$c->cons_smo,
':ae_lo'=>$c->ae_lo,
':cons_aelo'=>$c->cons_aelo,
':fresh_water'=>$c->fresh_water,
':cons_fw'=>$c->cons_fw,
':ho'=>$c->ho,
':cons_ho'=>$c->cons_ho,
':draft'=>$c->draft,
':remarks'=>$c->remarks,
':pdate'=>$c->pdate,
//
':id'=>$c->id
));

if ($statement->rowCount()){
  $data["status"]=1;
} else{
  $data["status"]=0;
}

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function save_ne($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$temp_code=uniqid($dev->uid);

$statement = $db->prepare("INSERT into mt_vessel_noon_entry(vessel,voyage,position,lattitude,longittude,speed,dmg,tdmg,dtg,local_time,eta,fo,cons_fo,do,cons_do,lsfo,cons_lsfo,lsdo,cons_lsdo,mco,cons_mco,smo,cons_smo,ae_lo,cons_aelo,fresh_water,cons_fw,ho,cons_ho,draft,
remarks,
ip,created_by,ua,ekey,created_date,
temp_code,company_id,location_id,pdate) 
values(:vessel,:voyage,:position,:lattitude,:longittude,:speed,:dmg,:tdmg,:dtg,:local_time,:eta,:fo,:cons_fo,:do,:cons_do,:lsfo,:cons_lsfo,:lsdo,:cons_lsdo,:mco,:cons_mco,:smo,:cons_smo,:ae_lo,:cons_aelo,:fresh_water,:cons_fw,:ho,:cons_ho,:draft,:remarks,
:ip,:created_by,
:ua,:ekey,now(),:temp_code,:company_id,:location_id,:pdate)");

$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->username,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,
//
':vessel'=>$c->vessel,
':voyage'=>$c->voyage,
':position'=>$c->position,
':lattitude'=>$c->lattitude,
':longittude'=>$c->longittude,
':speed'=>$c->speed,
':dmg'=>$c->dmg,
':tdmg'=>$c->tdmg,
':dtg'=>$c->dtg,
':local_time'=>$c->local_time,
':eta'=>$c->eta,
':fo'=>$c->fo,
':cons_fo'=>$c->cons_fo,
':do'=>$c->do,
':cons_do'=>$c->cons_do,
':lsfo'=>$c->lsfo,
':cons_lsfo'=>$c->cons_lsfo,
':lsdo'=>$c->lsdo,
':cons_lsdo'=>$c->cons_lsdo,
':mco'=>$c->mco,
':cons_mco'=>$c->cons_mco,
':smo'=>$c->smo,
':cons_smo'=>$c->cons_smo,
':ae_lo'=>$c->ae_lo,
':cons_aelo'=>$c->cons_aelo,
':fresh_water'=>$c->fresh_water,
':cons_fw'=>$c->cons_fw,
':ho'=>$c->ho,
':cons_ho'=>$c->cons_ho,
':draft'=>$c->draft,
':remarks'=>$c->remarks,
':pdate'=>$c->pdate,
//
':company_id'=>$dev->company,
':location_id'=>$dev->location,
':temp_code'=>$temp_code
));

if ($statement->rowCount()){
  $data["status"]=1;
} else{
  $data["status"]=0;
}

$statement = $db->prepare("SELECT id from mt_vessel_noon_entry where created_by=:uid and temp_code=:temp_code");
$statement->execute(array(':temp_code'=>$temp_code,
  ':uid'=>$dev->username));
$data["id"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function save_quote_route($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$temp_code=uniqid($dev->uid);

$statement = $db->prepare("INSERT into mt_vessel_quote_route(route_mode,provider,origin,destination,transit1,duration,currency,buying_rate,selling_rate,terms,type,quote_id,
ip,created_by ,ua,ekey,created_date,temp_code) 
values(
:route_mode,:provider,:origin,:destination,:transit1,:duration,:currency,:buying_rate,:selling_rate,:terms,:type,:quote_id,
:ip ,:created_by ,
:ua ,:ekey,now(),:temp_code)");
if($c->buying_rate=="")
{
  $c->buying_rate=null;
}
if($c->selling_rate=="")
{
  $c->selling_rate=null;
}
$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->uid ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,

':route_mode'=>$c->route_mode,
':provider'=>$c->provider,
':origin'=>$c->origin,
':destination'=>$c->destination,
':transit1'=>$c->transit1,
':duration'=>$c->duration,
':currency'=>$c->currency,
':buying_rate'=>$c->buying_rate,
':selling_rate'=>$c->selling_rate,
':terms'=>$c->terms,
':type'=>$c->type,

':quote_id'=>$c->quote_id,
':temp_code'=>$temp_code
));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
  /*

  */
} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}

$statement = $db->prepare("SELECT id from mt_vessel_quote_route where created_by=:uid and temp_code=:temp_code and quote_id=:quote_id");
$statement->execute(array(':temp_code'=>$temp_code,
  ':uid'=>$dev->uid,':quote_id'=>$c->quote_id));
$data["id"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function save_quote($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$temp_code=uniqid($dev->uid);

$statement = $db->prepare("INSERT into mt_vessel_quote(
ch_agr_no,
prepared_by,
quote_date,
valid_to,
requested_by,
address,
base_currency,
sales_ops_ref,
ip,created_by ,ua,ekey,created_date,temp_code,
company_id,location_id,job_type,notes) 
values(
:ch_agr_no,
:prepared_by,
:quote_date,
:valid_to,
:requested_by,
:address,
:base_currency,
:sales_ops_ref,
:ip,:created_by ,
:ua,:ekey,now(),:temp_code,
:company_id,:location_id,:job_type,:notes)");

$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->username ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,
//
':ch_agr_no'=>$c->ch_agr_no,
':prepared_by'=>$c->prepared_by,
':quote_date'=>$c->quote_date,
':valid_to'=>$c->valid_to,
':requested_by'=>$c->requested_by,
':address'=>$c->address,
':base_currency'=>$c->base_currency,
':sales_ops_ref'=>$c->sales_ops_ref,

//
':temp_code'=>$temp_code,
':company_id'=>$dev->company,
':location_id'=>$dev->location,
':job_type'=>$c->job_type,
':notes'=>$c->notes
));

if ($statement->rowCount()){
  $data["status"]=1;

} else{
  $data["status"]=0;
}
$data["temp_code"]=$temp_code;

$statement = $db->prepare("SELECT id from mt_vessel_quote where created_by=:uid and temp_code=:temp_code");
$statement->execute(array(':temp_code'=>$temp_code,':uid'=>$dev->username));
$op=$statement->fetchAll(PDO::FETCH_ASSOC);

$data["id"]=$op;
$qid=$op[0]["id"];

$fid=self::setFourDigit($op[0]["id"]);

$on="JOB/".date("Y")."/".date('m')."/".$fid;

 $statement = $db->prepare("UPDATE mt_vessel_quote 
  SET quote_no=:ond where id=:id");
  $statement->execute(array(':id'=>$op[0]["id"],':ond'=>$on));
  
    if ($statement->rowCount()){
    $data["qid_status"]=1;
      //echo 'Success: At least 1 row was affected.';
  } else{
    $data["qid_status"]=0;
      //echo 'Failure: 0 rows were affected.';
  }

$data["quote_no"]=$on;

//check if proforma is choosen
if($c->job_type=='PROFORMA')
{

  //check charges already fetched
  $statement = $db->prepare("SELECT id from mt_vessel_quote_rate where quote_id=(SELECT id from mt_vessel_quote where ch_agr_no=:ch_agr_no and job_type='ESTIMATE' limit 1) and copied=0");
$statement->execute(array(':ch_agr_no'=>$c->ch_agr_no));
$op=$statement->fetchAll(PDO::FETCH_ASSOC);
  //if not fetched then copy it
if(count($op)!=0)
{
  //insert 
  $statement = $db->prepare("INSERT into mt_vessel_quote_rate(rate_provider,rate_type,charge_description,pay_at_location,basis_type,rate,base_unit,commodity,currency,qty,ex_rate,foreign_amount,local_amount,quote_id,
ip,created_by ,ua,ekey,created_date,temp_code)
SELECT rate_provider,rate_type,charge_description,pay_at_location,basis_type,rate,base_unit,commodity,currency,qty,ex_rate,foreign_amount,local_amount,'$qid',
'$dev->ip','$dev->username','$dev->ua','$dev->ekey',now(),temp_code from mt_vessel_quote_rate where quote_id=(SELECT id from mt_vessel_quote where ch_agr_no=:ch_agr_no and job_type='ESTIMATE' limit 1) and copied=0");
$statement->execute(array(':ch_agr_no'=>$c->ch_agr_no));
  if ($statement->rowCount()){
  $data["copy_status"]=1;
  } else{
  $data["copy_status"]=0;
  }
  //update

  $statement = $db->prepare("UPDATE mt_vessel_quote_rate SET copied=1 where quote_id=(SELECT id from mt_vessel_quote 
    where ch_agr_no=:ch_agr_no and job_type='ESTIMATE' limit 1) 
    and copied=0");
$statement->execute(array(':ch_agr_no'=>$c->ch_agr_no));

  if ($statement->rowCount()){
  $data["update_status"]=1;
  } else{
  $data["update_status"]=0;
  }

}

}
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}



public static function update_quote_rate($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();


$statement = $db->prepare("UPDATE mt_vessel_quote_rate SET 
  rate_provider=:rate_provider,
rate_type=:rate_type,
charge_description=:charge_description,
pay_at_location=:pay_at_location,
basis_type=:basis_type,
rate=:rate,
base_unit=:base_unit,
commodity=:commodity,
currency=:currency,
qty=:qty,
ex_rate=:ex_rate,
foreign_amount=:foreign_amount,
local_amount=:local_amount,
  ip=:ip,created_by=:created_by,ua=:ua,ekey=:ekey,created_date= now() where id=:id and quote_id=:quote_id and invoiced=0");

$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->uid ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,

':rate_provider'=>$c->rate_provider,
':rate_type'=>$c->rate_type,
':charge_description'=>$c->charge_description,
':pay_at_location'=>$c->pay_at_location,
':basis_type'=>$c->basis_type,
':rate'=>$c->rate,
':base_unit'=>$c->base_unit,
':commodity'=>$c->commodity,
':currency'=>$c->currency,
':qty'=>$c->qty,
':ex_rate'=>$c->ex_rate,
':foreign_amount'=>$c->foreign_amount,
':local_amount'=>$c->local_amount,

':quote_id'=>$c->quote_id,
':id'=>$c->id
));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';

} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}




public static function copy_quote($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$temp_code=uniqid($dev->uid);

$statement = $db->prepare("INSERT into mt_vessel_quote(
ch_agr_no,
prepared_by,
quote_date,
valid_to,
requested_by,
address,
base_currency,
sales_ops_ref,
location_id,
company_id,
ip,created_by ,ua,ekey,created_date,temp_code,copy_quote) 

SELECT
'$c->ch_agr_no',
prepared_by,
CURDATE(),
NULL,
requested_by,
address,
base_currency,
sales_ops_ref,
'$dev->location',
'$dev->company',
'$dev->ip','$dev->username','$dev->ua','$dev->ekey',now(),
'$temp_code',quote_no from mt_vessel_quote where id=:id");
$statement->execute(array(':id'=>$c->id));

if ($statement->rowCount()){
  $data["status"]=1;

} else{
  $data["status"]=0;
}

$data["temp_code"]=$temp_code;

$statement = $db->prepare("SELECT id from mt_vessel_quote where created_by=:uid and temp_code=:temp_code");
$statement->execute(array(':temp_code'=>$temp_code,':uid'=>$dev->username));
$op=$statement->fetchAll(PDO::FETCH_ASSOC);

$data["id"]=$op;

$fid=self::setFourDigit($op[0]["id"]);

$on="JOB/".date("Y")."/".date('m')."/".$fid;

 $statement = $db->prepare("UPDATE mt_vessel_quote 
  SET quote_no=:ond where id=:id");
  $statement->execute(array(':id'=>$op[0]["id"],':ond'=>$on));
  
    if ($statement->rowCount()){
    $data["qid_status"]=1;
      //echo 'Success: At least 1 row was affected.';
  } else{
    $data["qid_status"]=0;
      //echo 'Failure: 0 rows were affected.';
  }

$data["quote_no"]=$on;

$quote_id=$fid;


//copy route

$statement = $db->prepare("INSERT into mt_vessel_quote_route(route_mode,provider,origin,destination,transit1,duration,currency,buying_rate,selling_rate,terms,type,quote_id,
ip,created_by ,ua,ekey,created_date) 
SELECT route_mode,provider,origin,destination,transit1,duration,currency,buying_rate,selling_rate,terms,type,$quote_id,
'$dev->ip','$dev->username','$dev->ua','$dev->ekey',now() from mt_vessel_quote_route where quote_id=:id");

$statement->execute(array(':id'=>$c->id));
    if ($statement->rowCount()){
    $data["route_status"]=1;
      //echo 'Success: At least 1 row was affected.';
  } else{
    $data["route_status"]=0;
      //echo 'Failure: 0 rows were affected.';
  }

//copy rate

$statement = $db->prepare("INSERT into mt_vessel_quote_rate(rate_provider,rate_type,charge_description,pay_at_location,basis_type,rate,base_unit,commodity,currency,qty,ex_rate,foreign_amount,local_amount,quote_id,
ip,created_by ,ua,ekey,created_date) 
SELECT rate_provider,rate_type,charge_description,pay_at_location,basis_type,rate,base_unit,commodity,currency,qty,ex_rate,foreign_amount,local_amount,$quote_id,
'$dev->ip','$dev->username','$dev->ua','$dev->ekey',now() from mt_vessel_quote_rate where quote_id=:id");

$statement->execute(array(':id'=>$c->id));
    if ($statement->rowCount()){
    $data["rate_status"]=1;
      //echo 'Success: At least 1 row was affected.';
  } else{
    $data["rate_status"]=0;
      //echo 'Failure: 0 rows were affected.';
  }

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function update_quote($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();


$statement = $db->prepare("UPDATE mt_vessel_quote SET 
prepared_by=:prepared_by,
quote_date=:quote_date,
valid_to=:valid_to,
requested_by=:requested_by,
address=:address,
base_currency=:base_currency,
sales_ops_ref=:sales_ops_ref,
modified_by=:modified_by,
modified_date=now(),
notes=:notes,
job_type=:job_type where id=:id");

$statement->execute(array(
':modified_by'=>$dev->username,
//
':prepared_by'=>$c->prepared_by,
':quote_date'=>$c->quote_date,
':valid_to'=>$c->valid_to,
':requested_by'=>$c->requested_by,
':address'=>$c->address,
':base_currency'=>$c->base_currency,
':sales_ops_ref'=>$c->sales_ops_ref,
//
':id'=>$c->id,
':job_type'=>$c->job_type,
':notes'=>$c->notes

));

if ($statement->rowCount()){
  $data["status"]=1;
} else{
  $data["status"]=0;
}
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function delete_quote_rate($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$statement = $db->prepare("DELETE FROM mt_vessel_quote_rate 
  where id=:id and invoiced=0");
$statement->execute(array(':id'=>$c));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  return $data;
}

public static function delete_quote_route($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$statement = $db->prepare("DELETE FROM mt_vessel_quote_route 
  where id=:id");
$statement->execute(array(':id'=>$c));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  return $data;
}

public static function get_quote_rate_list($dev,$code)
{

$data=array();
try
{
$db = Factory::getConnection();

$statement = $db->prepare("SELECT id,quote_id,
rate_provider,rate_type,charge_description,pay_at_location,
basis_type,rate,base_unit,commodity,currency,qty,
ex_rate,foreign_amount,local_amount,
'0' edit,invoiced,'' selected  
from mt_vessel_quote_rate where invoiced=0 and quote_id=(SELECT id from mt_vessel_quote where quote_no=:quote_id)");
$statement->execute(array(':quote_id'=>$code->quote_no));
$data["rate"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function get_quote_info($dev,$code)
{

$data=false;
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT id,quote_no,
prepared_by,
quote_date,
valid_to,
requested_by,
address,
base_currency,
sales_ops_ref,
temp_code,ch_agr_no,copy_quote,job_type,
notes    
from mt_vessel_quote where id=:id");

$statement->execute(array(':id'=>$code));

$data["info"]=$statement->fetchAll(PDO::FETCH_ASSOC);

if(count($data["info"])>0)
{
$qid=$data["info"][0]["id"];

$statement = $db->prepare("SELECT id,quote_id,
route_mode,provider,origin,destination,transit1,duration,currency,
buying_rate,selling_rate,terms,type,'0' edit 
from mt_vessel_quote_route where quote_id=:quote_id");
$statement->execute(array(':quote_id'=>$qid));
$data["route"]=$statement->fetchAll(PDO::FETCH_ASSOC);


$statement = $db->prepare("SELECT id,quote_id,
rate_provider,rate_type,charge_description,pay_at_location,
basis_type,rate,base_unit,commodity,currency,qty,
ex_rate,foreign_amount,local_amount,
'0' edit 
from mt_vessel_quote_rate where quote_id=:quote_id");
$statement->execute(array(':quote_id'=>$qid));
$data["rate"]=$statement->fetchAll(PDO::FETCH_ASSOC);

}

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function search_pda_fda_list($dev,$q)
{
$data=false;
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT id,
quote_no,
ch_agr_no,
fda_date,
f_amt,
l_amt,
status,
customer,
currency,
created_date,created_by,
modified_by,modified_date
  from mt_vessel_fda where quote_no like ? or 
  ch_agr_no like ?  or customer like ? or 
  status like ? or fda_no like ? 
   order by id limit 20");

$statement ->bindValue(1, "%$q%", PDO::PARAM_STR);
$statement ->bindValue(2, "%$q%", PDO::PARAM_STR);
$statement ->bindValue(3, "%$q%", PDO::PARAM_STR);
$statement ->bindValue(4, "%$q%", PDO::PARAM_STR);
$statement ->bindValue(5, "%$q%", PDO::PARAM_STR);

$statement->execute();
$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_pda_fda_info($dev,$code)
{
$data=array();
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT id,
quote_no,
ch_agr_no,
fda_date,
fda_no,
f_amt,
l_amt,
status,
customer,
'' currency,
'' from_date,'' to_date,'' quote_date,'' order_no,temp_code     
  from mt_vessel_fda where id=:id");
$statement->execute(array(':id'=>$code));
$data["info"]=$statement->fetchAll(PDO::FETCH_ASSOC);
$fda_no=$data["info"][0]["fda_no"];

$statement = $db->prepare("SELECT id,qr_id,
provider rate_provider, type rate_type, charge_desc charge_description,pay_at_location,
basis_type,rate,base_uom base_unit,commodity,currency,qty,
ex_rate,foreign_amount,local_amount,
'0' edit,'1' invoiced,'1' selected  
from mt_vessel_fda_details where fda_no=:fda_no");
$statement->execute(array(':fda_no'=>$fda_no));
$data["rates"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function get_ne_list($dev,$code)
{
$data=array();
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT id,pdate,vessel,voyage,position,lattitude,longittude,speed,dmg,tdmg,dtg,local_time,eta,fo,cons_fo,do,cons_do,lsfo,cons_lsfo,lsdo,cons_lsdo,mco,cons_mco,smo,cons_smo,ae_lo,cons_aelo,fresh_water,cons_fw,ho,cons_ho,draft,remarks,'0' edit 
	from mt_vessel_noon_entry where voyage=:voyage");
$statement->execute(array(':voyage'=>$code->voyage));
$data["info"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_pda_fda_list($dev,$code)
{
$data=false;
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT id,
quote_no,
ch_agr_no,
fda_date,
fda_no,
f_amt,
l_amt,
status,
customer,
created_date,created_by,
modified_by,modified_date
  from mt_vessel_fda order by id desc limit :sta,100");
$statement->bindValue(':sta',(int) $code, PDO::PARAM_INT); 
$statement->execute();
$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}



public static function get_quote_list($dev,$code)
{
$data=false;
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT id,quote_no,
prepared_by,
quote_date,
valid_to,
requested_by,
address,
base_currency,
sales_ops_ref,created_date,created_by,
modified_by,modified_date,job_type,ch_agr_no 
  from mt_vessel_quote order by id desc limit :sta,100");
$statement->bindValue(':sta',(int) $code, PDO::PARAM_INT); 
$statement->execute();
$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function search_quote_pda($dev,$q)
{
$data=false;
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT id,quote_no,ch_agr_no,requested_by,base_currency,quote_date 
from mt_vessel_quote where quote_no like ? 
   order by id limit 20");

$statement ->bindValue(1, "%$q%", PDO::PARAM_STR);

$statement->execute();
$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function search_quote_no1($dev,$q)
{
$data=false;
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT id,quote_no
from mt_vessel_quote where quote_no like ? 
   order by id limit 20");

$statement ->bindValue(1, "%$q%", PDO::PARAM_STR);

$statement->execute();
$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function search_quote_list($dev,$q)
{
$data=false;
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT id,quote_no,
prepared_by,
quote_date,
valid_to,
requested_by,
address,
base_currency,
sales_ops_ref,created_date,created_by,
modified_by,modified_date,job_type,ch_agr_no
  from mt_vessel_quote where quote like ? or 
  requested_by like ?  or base_currency like ? or 
  prepared_by like ?
   order by id limit 20");

$statement ->bindValue(1, "%$q%", PDO::PARAM_STR);
$statement ->bindValue(2, "%$q%", PDO::PARAM_STR);
$statement ->bindValue(3, "%$q%", PDO::PARAM_STR);
$statement ->bindValue(4, "%$q%", PDO::PARAM_STR);

$statement->execute();
$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function get_vessel_list($dev,$code)
{
$data=false;
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT 
id,
vessel_name,
vessel_type,active_from,active_to,created_date,created_by,
modified_by,modified_date,ch_agr_no 
  from mt_vessel_ops order by id desc limit :sta,100");
$statement->bindValue(':sta',(int) $code, PDO::PARAM_INT); 
$statement->execute();
$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function search_vessel_list($dev,$q)
{
$data=false;
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT 
id,
vessel_name,
vessel_type,active_from,active_to,created_date,created_by,
modified_by,modified_date,ch_agr_no 
  from mt_vessel_ops where vessel_name like ? or 
  vessel_type like ?  or flag like ? or year_built like ?
   order by id limit 20");

$statement ->bindValue(1, "%$q%", PDO::PARAM_STR);
$statement ->bindValue(2, "%$q%", PDO::PARAM_STR);
$statement ->bindValue(3, "%$q%", PDO::PARAM_STR);
$statement ->bindValue(4, "%$q%", PDO::PARAM_STR);

$statement->execute();
$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}



}

?>