<?php


require("../config/dbconn.php");

class BookingDao

{


public static function save_page_views($dev,$pname,$method)
{
$data=0;
try
{
$db = Factory::getConnection();


$statement = $db->prepare("INSERT into page_views(
ip ,uid ,ua,ekey,esecret,method,page,tz) 
values(:ip ,:uid ,
:ua ,:ekey ,:esecret ,:method ,:page,:tz)");
$statement->execute(array(':ip'=>$dev->ip,':uid'=>$dev->uid ,
':ua'=>$dev->ua,
':tz'=>$dev->tz ,
':method'=>$method ,':esecret'=>$dev->esecret,':ekey'=>$dev->ekey,
':page'=>$pname));


$data=1;
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function getFinancialYear()
{
//$year = ( date('m') > 4) ? date('Y') + 1 : date('Y');
$year=date('Y');
return $year;
}


public static function get_invoice_list($c)
{

$data=false;
try
{
$db = Factory::getConnection();

$statement = $db->prepare("SELECT sub_ar_doc_number invoice_no,total_local_amt amt from mt_ship_ar_header 
  where sub_ar_status !='CANCELLED' and INSTR(order_no, '$c->order_no') > 0
  UNION 

  SELECT sub_ar_doc_number invoice_no,total_local_amt amt from mt_order_ar_header 
  where sub_ar_status !='CANCELLED' and INSTR(order_no, '$c->order_no') > 0
  ");

$statement->execute();
$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function getFinancialPeriod($doc_date)
{

//$year = ( date('m') > 4) ? date('Y') + 1 : date('Y');
//$period=4;
//return $period;
$data=false;
try
{
$db = Factory::getConnection();

//$aq=self::getRestrictionQuery($dev);
//$doc_date="2019-12-15";
$date=date_create($doc_date);
$m= date_format($date,"F");
$y= date_format($date,"Y");

$statement = $db->prepare("SELECT enumber from mt_period 
  where period=:period and year=:year and open_max='OPEN'");

$statement->execute(array(':period'=>$m,':year'=>$y));
$data=$statement->fetchAll(PDO::FETCH_ASSOC);
//var_dump($statement->debugDumpParams());
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  $p=-10;
  if(count($data)==1)
  {
    $p=$data[0]["enumber"];
  }
  return $p;
}

public static function setFourDigit($v)
{
  $len=strlen($v);

if($len==1)
{
  $v="000".$v;
}else if($len==2)
{
  $v="00".$v;
}else if($len==3)
{
  $v="0".$v;
}

return $v;
}

//generating sequence no for voucher doc type
public static function generate_voucher_no($dev,$table,$temp_code)
{
$data=array();
$result=0;
try
{
$db = Factory::getConnection();
//$temp_code=uniqid($dev->uid);
$table=strtolower($table);
$statement = $db->prepare("INSERT into ".$table."(
  created_by,created_date,temp_code) 
values(:created_by,now(),:temp_code)");
$statement->execute(array(
  ':created_by'=>$dev->username ,
':temp_code'=>$temp_code
));

if ($statement->rowCount()){
  $data["status"]=1;
} else{
  $data["status"]=0;
}

$statement = $db->prepare("SELECT id from $table where created_by=:created_by and temp_code=:temp_code ");
$statement->execute(array(':temp_code'=>$temp_code,
  ':created_by'=>$dev->username));
$data["id"]=$statement->fetchAll(PDO::FETCH_ASSOC);
$result=$data["id"][0]["id"];
//echo "es====".$result;
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $result;
}

public static function save_voucher_preparation_payable($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();
$info=$c->info;
$vpds=$c->cd;
$h=$vpds[0];

$customer_code=$info->party_name;

$temp_code=uniqid($dev->uid);
$statement = $db->prepare("SELECT limit_amount,credit_days from mt_bp_credit where account_type in('ACCOUNTS PAYABLE','BOTH') and bp_id=(SELECT id from mt_business_partner 
  where code=:customer_code)");
$statement->execute(array(':customer_code'=>$customer_code));
$cls=$statement->fetchAll(PDO::FETCH_ASSOC);

$due_date=date('Y-m-d');
$lc=0;
if(count($cls)==1)
{
$due_date= date('Y-m-d', strtotime("+".$cls[0]["credit_days"]." day", strtotime($info->doc_date)));
$lc=$cls[0]["limit_amount"];
}

//$due_date=$doc_date+$cls[0]["credit_days"];
//1
$statement = $db->prepare("INSERT into mt_ap_header 
(aph_company,aph_code,aph_group,aph_document_base,aph_document_type,aph_limit_base,aph_document_date,aph_gl_date,aph_due_date,aph_other_reference,aph_currency,aph_exchange_rate,aph_foreign_amount,aph_local_amount,aph_narration,aph_post_date,aph_status,aph_notes,aph_loc_reference,
  ip,created_by ,ua,ekey,created_date,temp_code,company_id,location_id,child,lpo_order) 
VALUES
( :company,:customer_code,:activity,:voucher_type,:doc_type,
  :limit_amount,
  :doc_date,:doc_date,:due_date,:ref,:currency,:ex_rate,:base_amt_dr,:local_amt_dr,:narration,:doc_date,'POSTED','',:ref_date,
  :ip ,:created_by ,:ua ,:ekey,now(),:temp_code,:company_id,:location_id,:child,:lpo_order)");

if($h->ex_rate=="")
{
  $h->ex_rate=null;
}
if($h->rate_cost=="")
{
  $h->rate_cost=null;
}
if($h->cost_base_amount=="")
{
  $h->cost_base_amount=null;
}

if($info->famt=="")
{
  $info->famt=null;
}

if($info->lamt=="")
{
  $info->lamt=null;
}


$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->username ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,

':company'=>$dev->company,
':customer_code'=>$customer_code,
':activity'=>'',
':voucher_type'=>'ACCOUNTS PAYABLE',
':doc_type'=>'DEBIT NOTE',

':limit_amount'=>$lc,
':doc_date'=>$info->doc_date,
':due_date'=>$due_date,
':ref'=>$info->ref,
':ref_date'=>$info->doc_date,
':currency'=>$h->currency,
':ex_rate'=>$h->ex_rate,
':base_amt_dr'=>$info->famt*(-1),
':local_amt_dr'=>$info->lamt*(-1),
':narration'=>$info->narration,

':temp_code'=>$temp_code,
':company_id'=>$dev->company,
':location_id'=>$dev->location,
':child'=>json_encode($vpds),
':lpo_order'=>$info->order_no
));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}

$statement = $db->prepare("SELECT id from mt_ap_header where created_by=:uid and temp_code=:temp_code");
$statement->execute(array(':temp_code'=>$temp_code,
  ':uid'=>$dev->username));
$op=$statement->fetchAll(PDO::FETCH_ASSOC);

$data["id"]=$op;

//set doc number
$fid=self::setFourDigit($op[0]["id"]);
$vgen=self::generate_voucher_no($dev,'LPO',$temp_code);
$fid=self::setFourDigit($vgen);
$fid2=$op[0]["id"];

$vtype="LPO";


$on=$vtype."/".date("Y")."/".date('m')."/".$fid;

 $statement = $db->prepare("UPDATE mt_ap_header 
  SET aph_document_number=:ond where id=:id");
  $statement->execute(array(':id'=>$op[0]["id"],':ond'=>$on));
  
    if ($statement->rowCount()){
    $data["docid_status"]=1;
      //echo 'Success: At least 1 row was affected.';
  } else{
    $data["docid_status"]=0;
      //echo 'Failure: 0 rows were affected.';
  }

$data["doc_no"]=$on;

$doc_no=$on;


//query 2
for($i=0;$i<count($vpds);$i++)
{

$r=$vpds[$i];
$temp_code=uniqid($dev->uid);
$q="";
$qv="";
$r->allocation='SHIP';
if($r->order_type=="SEA IMPORT" or $r->order_type=="SEA EXPORT")
{
  $r->allocation="ORDER";
}
//if order type sea order/ agency ship


if($r->allocation=="SHIP")
{
  $statement = $db->prepare("SELECT t1.voyage,t1.vessel,t1.liner,bl_no,t2.manifest_type,t1.port from mt_voyage t1, mt_manifest_entry t2 WHERE
  t1.voyage=t2.voyage and t2.order_no=:order_no");
  $statement->execute(array(':order_no'=>$info->order_no));
$bls=$statement->fetchAll(PDO::FETCH_ASSOC);
  
  if(count($bls)==1)
  {
    $ai=(object)$bls[0];
  $q="voyage,vessel,liner,bl_no,ship_activity";
  $qv="'$ai->voyage','$ai->vessel','$ai->liner','$ai->bl_no',''";
  }else{
      $q="voyage,vessel,liner,bl_no,ship_activity";
  $qv="'','','','',''";
  }
  
 //insert in the ship trans
  $fy=self::getFinancialYear();
  $fp=self::getFinancialPeriod($info->doc_date);

$statement = $db->prepare("INSERT into mt_ship_trans
( st_company,st_doc_type,st_doc_number,st_serial,st_doc_base,st_date,st_gl_date,st_dp_date,st_age_date,st_year,st_period,st_carrier,st_vessel,st_voyage,st_port,st_bl,st_bl_type,st_charge,st_other_reference,st_currency,st_exchange,st_foreign,st_local,st_narration,st_status,
  st_posted_on,
  ip,created_by ,ua,ekey,created_date,temp_code) 
  VALUES
('$dev->company','LPO','$doc_no','1','ACCOUNTS PAYABLE','$info->doc_date','$info->doc_date',
  '$info->doc_date','$info->doc_date','$fy','$fp','$ai->liner',
  '$ai->vessel','$ai->voyage','$ai->port','$ai->bl_no',
  '$ai->manifest_type','$r->charge_desc','$info->order_no',
  '$r->currency',
  '$r->ex_rate','-$r->rate_cost',
  '$r->cost_base_amount','$info->narration',
  'P',now(),
  '$dev->ip',
  '$dev->username','$dev->ua',
  '$dev->ekey',now(),'$temp_code')");

$statement->execute();
}

if($r->allocation=="ORDER")
{
  
  $q="order_type,order_no,order_activity";
  $qv="'$r->order_type','$info->order_no',''";
}

/*

if($r->allocation=="ACCOUNTS PAYABLE")
{
  $ai=$r->add_info;
  $q="ap_customer,ap_activity,ap_cust_address";
  $qv="'$ai->customer_name','$ai->activity','$ai->customer_address'";
}

if($r->allocation=="BANK")
{
  $ai=$r->add_info;
  $q="bank,cheque_no,cheque_date";
  $qv="'$ai->bank_name','$ai->cheque_no','$ai->cheque_date'";
}

if($r->allocation=="INCOME")
{
  $ai=$r->add_info;
  $q="income_gl";
  $qv="'$ai->income'";
}

if($r->allocation=="LIABILITY")
{
  $ai=$r->add_info;
  $q="liability";
  $qv="'$ai->liability'";
}

if($r->allocation=="EXPENSES")
{
  $ai=$r->add_info;
  $q="expense_gl";
  $qv="'$ai->expense'";
}
if($r->base_amt_cr=="")
{
  $r->base_amt_cr=null;
}
if($r->local_amt_cr=="")
{
  $r->local_amt_cr=null;
}

*/





if($r->ex_rate=="")
{
  $r->ex_rate=null;
}

$statement = $db->prepare("INSERT into mt_ap_allocation_details 
(aloc_company,aloc_base_doc,aloc_doc_type,aloc_doc_number,aloc_allocation_type,aloc_foreign_amount,aloc_local_amount,
  aloc_narration,aloc_currency,aloc_ex_rate,
  reference,ref_date,
  $q,
ip,created_by ,ua,ekey,created_date,temp_code)
VALUES
(:company,:voucher_type,:doc_type,:doc_no,:allocation,
  :base_amt_cr,:local_amt_cr,
  :narration,:currency,:ex_rate,
:reference,:ref_date,$qv,
  :ip ,:created_by ,:ua ,:ekey,now(),:temp_code)");

$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->username ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,
':temp_code'=>$temp_code,

':company'=>$dev->company,
':voucher_type'=>'ACCOUNTS PAYABLE',
':doc_type'=>'DEBIT NOTE',
':doc_no'=>$doc_no,

':allocation'=>$r->allocation,
':base_amt_cr'=>$r->cost_base_amount*(-1), //cot base amt
':local_amt_cr'=>$r->rate_cost*(-1), //cost
':narration'=>$r->charge_desc, //charge desc
':currency'=>$r->currency,
':ex_rate'=>$r->ex_rate,

':reference'=>$info->ref,
':ref_date'=>$info->doc_date

));

if ($statement->rowCount()){
  $data["ahd_status-".($i+1)]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data["ahd_status-".($i+1)]=0;
    //echo 'Failure: 0 rows were affected.';
}

if($data["ahd_status-".($i+1)]==1)
{
  $statement = $db->prepare("UPDATE mt_order_cost set inv_pay_no=:doc_no where id=:id");
  $statement->execute(array(':doc_no'=>$doc_no,':id'=>$r->id));
  if ($statement->rowCount()){
  $data["cost_ahd_status-".($i+1)]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data["cost_ahd_status-".($i+1)]=0;
    //echo 'Failure: 0 rows were affected.';
}
}

}
//query 2 ends


//query 3
$statement = $db->prepare("INSERT into mt_ap_trans 
(apt_company,apt_code,apt_type,apt_number,apt_serial,apt_group,
apt_base_type,apt_internal,apt_other_reference,apt_doc_date,
apt_gl_date,apt_year,apt_period,apt_age_date,
apt_dp_date,apt_currency,apt_ex_rate,apt_foreign_amount,
apt_local_amount,apt_foreign_balance,
apt_local_balance,apt_balance_status,
apt_description,apt_notes,
ip,created_by ,ua,ekey,created_date,temp_code,
company_id,location_id)
SELECT aph_company,aph_code,aph_document_type,aph_document_number,
aph_internal_number,aph_group,aph_document_base,aph_internal_number,
aph_other_reference,aph_document_date,aph_gl_date,".self::getFinancialYear().",".self::getFinancialPeriod($info->doc_date).",
aph_age_date,aph_due_date,aph_currency,aph_exchange_rate,
aph_foreign_amount,aph_local_amount,aph_foreign_amount,
aph_local_amount,'A',
aph_narration,aph_notes,
ip,created_by,ua ,ekey,now(),'$temp_code',
'$dev->company','$dev->location'   
FROM mt_ap_header where id=:id");

$statement->execute(array(':id'=>$fid2));

if ($statement->rowCount()){
  $data["ap_trans_status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data["ap_trans_status"]=0;
    //echo 'Failure: 0 rows were affected.';
}
//query 3 ends


//query 4 part1 header
$statement = $db->prepare("INSERT into mt_ap_gl_details
(pre_glt_company,pre_glt_code,pre_glt_doc_base,pre_glt_doc_type,
  pre_glt_doc_number,pre_glt_serial,pre_glt_doc_date,
  pre_glt_gl_date,pre_glt_year,pre_glt_period,
  pre_glt_other_reference,pre_glt_currency,
  pre_glt_ex_rate,pre_glt_foreign_amount,
  pre_glt_local_amount,pre_glt_narration,
ip,created_by ,ua,ekey,created_date,temp_code)
SELECT aph_company,
(SELECT id from mt_gl_link where account_type='PAYABLE' limit 1),
aph_document_base,aph_document_type,
aph_document_number,aph_internal_number,aph_document_date,
aph_gl_date,".self::getFinancialYear().",".
self::getFinancialPeriod($info->doc_date).",aph_other_reference,aph_currency,
aph_exchange_rate,aph_foreign_amount,
aph_local_amount,aph_narration,
ip,created_by,ua ,ekey,now(),'$temp_code'  
FROM mt_ap_header where id=:id
");

$statement->execute(array(':id'=>$fid2));

if ($statement->rowCount()){
  $data["ah_gl_status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data["ah_gl_status"]=0;
    //echo 'Failure: 0 rows were affected.';
}
//query 4 ends


//query 4 part2 child
$statement = $db->prepare("INSERT into mt_ap_gl_details
(pre_glt_company,pre_glt_code,pre_glt_doc_base,pre_glt_doc_type,
  pre_glt_doc_number,pre_glt_serial,pre_glt_doc_date,
  pre_glt_gl_date,pre_glt_year,pre_glt_period,
  pre_glt_other_reference,pre_glt_currency,
  pre_glt_ex_rate,pre_glt_foreign_amount,
  pre_glt_local_amount,pre_glt_narration,
  pre_glt_allocation_code,pre_glt_detail_1,
  pre_glt_detail_2,pre_glt_detail_3,
ip,created_by ,ua,ekey,created_date,temp_code)
SELECT aloc_company,'',
aloc_base_doc,aloc_doc_type,
aloc_doc_number,aloc_serial,'$info->doc_date',
'$info->doc_date',".self::getFinancialYear().",".
self::getFinancialPeriod($info->doc_date).",aloc_narration,aloc_currency,
aloc_ex_rate,aloc_foreign_amount,
aloc_local_amount,aloc_narration,
aloc_allocation_type,aloc_detail_1,
aloc_detail_2,aloc_detail_3,
ip,created_by,ua ,ekey,now(),'$temp_code'  
FROM mt_ap_allocation_details where aloc_doc_number=:id
");

$statement->execute(array(':id'=>$doc_no));

if ($statement->rowCount()){
  $data["ah_gl_status2"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data["ah_gl_status2"]=0;
    //echo 'Failure: 0 rows were affected.';
}
//query 4 part2 ends


//query 5
$statement = $db->prepare("INSERT into mt_ap_trans_balance
(apdm_company,apdm_code,apdm_doc_type,apdm_doc_number,
  apdm_serial,apdm_other_reference,apdm_date,apdm_currency,
  apdm_ex_rate,apdm_of_amount,apdm_ol_amount,apdm_bf_amount,
  apdm_bl_amount,apdm_pf_amount,apdm_pl_amount,apdm_status,
ip,created_by ,ua,ekey,created_date,temp_code,company_id,location_id)
SELECT apt_company,apt_code,apt_type,apt_number,
apt_serial,apt_other_reference,apt_gl_date,apt_currency,
apt_ex_rate,apt_foreign_amount,apt_local_amount,
apt_foreign_balance,apt_local_balance,
0,0,'PENDING',ip,created_by,ua,ekey,now(),'$temp_code',
'$dev->company','$dev->location'  
 from mt_ap_trans where apt_number=:doc_no
");

$statement->execute(array(':doc_no'=>$doc_no));

if ($statement->rowCount()){
  $data["tb_status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data["tb_status"]=0;
    //echo 'Failure: 0 rows were affected.';
}
//query 5 ends

//query 6
$statement = $db->prepare("INSERT into mt_ap_balance
( apb_company,apb_code,apb_year,apb_period,apb_debit,apb_credit,
  ip,created_by ,ua,ekey,
  created_date,temp_code,
  company_id,location_id) 
SELECT '$dev->company','$customer_code',".self::getFinancialYear().",".
self::getFinancialPeriod($info->doc_date).",sum(apt_local_amount),sum(apt_local_amount),
'$dev->ip','$dev->username' ,'$dev->ua','$dev->ekey',
now(),'$temp_code',
'$dev->company','$dev->location' 
 from mt_ap_trans where apt_number=:doc_no");

$statement->execute(array(':doc_no'=>$doc_no));

if ($statement->rowCount()){
  $data["ab_status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data["ab_status"]=0;
    //echo 'Failure: 0 rows were affected.';
}
//query 6 ends

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function delete_erc_equip($c)
{
$data=array();
try
{
$db = Factory::getConnection();

$statement = $db->prepare("DELETE from mt_erc_equip_detail 
 where id=:id ");

$statement->execute(array(
':id'=>$c
));

if ($statement->rowCount()){
  $data["status"]=1;
} else{
  $data["status"]=0;
}

if($data["status"]==1)
{

  $statement = $db->prepare("DELETE from mt_order_landingcraft_detail  
 where erc_id=:id ");

$statement->execute(array(
':id'=>$c
));

if ($statement->rowCount()){
  $data["lc_status"]=1;
} else{
  $data["lc_status"]=0;
}

}


$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function update_erc_equip($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$statement = $db->prepare("UPDATE mt_erc_equip_detail SET 
equipment_type=:equipment_type,
qty=:qty,
status=:status,
remarks=:remarks
,ip=:ip,created_by=:created_by,ua=:ua,ekey=:ekey,created_date= now() where id=:id and erc_id=:erc_id");

$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->uid ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,

':equipment_type'=>$c->equipment_type,
':qty'=>$c->qty,
':status'=>$c->status,
':remarks'=>$c->remarks,

':erc_id'=>$c->erc_id,
':id'=>$c->id
));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';

} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}


$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}



public static function save_erc_equip($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$temp_code=uniqid($dev->uid);

$statement = $db->prepare("INSERT into mt_erc_equip_detail(equipment_type,qty,status,remarks,erc_id,created_by,created_date,ip,ua,ekey,temp_code) 
values(:equipment_type,:qty,:status,:remarks,:erc_id,
:created_by,now(),:ip,:ua,:ekey,
:temp_code)");

$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->uid ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,

':equipment_type'=>$c->equipment_type,
':qty'=>$c->qty,
':status'=>$c->status,
':remarks'=>$c->remarks,
':erc_id'=>$c->erc_id,

':temp_code'=>$temp_code
));

if ($statement->rowCount()){
  $data["status"]=1;
} else{
  $data["status"]=0;
}

$statement = $db->prepare("SELECT id from mt_erc_equip_detail where created_by=:uid and temp_code=:temp_code and erc_id=:erc_id");
$statement->execute(array(':temp_code'=>$temp_code,
	':uid'=>$dev->uid,':erc_id'=>$c->erc_id));
$data["id"]=$statement->fetchAll(PDO::FETCH_ASSOC);

if($data["status"]==1)
{

  //insert to the order lc
$statement = $db->prepare("INSERT into mt_order_landingcraft_detail(cargo_type,vehicle_type,vin_no,gr_wgt,nt_wgt,tt_wgt,
  commodity,reefer,oog,order_id,
  created_by,created_date,ip,ua,ekey,temp_code,erc_id) 
VALUES
('RORO',:container_type,:container_no,:gross_weight,
:net_weight,:tare_weight,:commodity,:reefer,:oog,
(SELECT id from mt_order_entry where order_no=:eorder),
:created_by,now(),:ip,:ua,:ekey,:temp_code,:erc_id)");
$cd=$c->cd;
$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->username,
  ':ua'=>$dev->ua,':ekey'=>$dev->ekey,
  ':temp_code'=>$temp_code,

':container_no'=>$cd->container_no,
':container_type'=>$cd->container_type,

':gross_weight'=>$cd->gross_weight,
':tare_weight'=>$cd->tare_weight,
':net_weight'=>$cd->net_weight,

':commodity'=>$cd->commodity,
':eorder'=>$c->eorder,

':oog'=>$cd->oog,
':reefer'=>$cd->reefer,
':erc_id'=>$data["id"][0]["id"]
)); 

if ($statement->rowCount()){
  $data["lc_status"]=1;
} else{
  $data["lc_status"]=0;
}

}

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function search_lpo($c)
{

$data=array();
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT id,(SELECT order_type from mt_order_entry where order_no=:order_no) order_type,
  charge_desc,basis_type,basis_uom,qty,
  currency,ex_rate,rate_cost,cost_base_amount 
from mt_order_cost 
WHERE billing_party=:billing_party and type='COST' and 
order_id=(SELECT id from mt_order_entry WHERE order_no=:order_no) and 
inv_pay_no is null");

$statement->execute(array(
':order_no'=>$c->order_no,
':billing_party'=>$c->vendor));

$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function get_lpo_info($code)
{

$data=array();
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT id, aph_document_number doc_no,aph_code code,aph_document_date doc_date,
aph_local_amount lamt,aph_narration narration,created_by,created_date,child,
(SELECT order_no from mt_order_entry where id=(SELECT order_id from mt_order_cost where inv_pay_no=aph_document_number limit 1)) order_no,aph_loc_reference ref,aph_foreign_amount famt,temp_code FROM mt_ap_header where id=:no");


$statement->execute(array(':no'=>$code));

$data["info"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function search_lpo_list($v)
{

$data=array();
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT id, aph_document_number doc_no,aph_code code,aph_document_date doc_date,
aph_local_amount lamt,aph_narration narration, created_by,created_date,
(SELECT order_no from mt_order_entry where id=(SELECT order_id from mt_order_cost where inv_pay_no=aph_document_number limit 1)) order_no
 FROM mt_ap_header where aph_document_number like'LPO%' and 
(aph_code like ? or aph_document_number like ?) order by id desc limit 50");

$statement ->bindValue(1, "%$v%", PDO::PARAM_STR);
$statement ->bindValue(2, "%$v%", PDO::PARAM_STR);

$statement->execute();
$data=$statement->fetchAll(PDO::FETCH_ASSOC);
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function get_lpo_list($code)
{

$data=array();
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT id,aph_status status, aph_document_number doc_no,aph_code code,aph_document_date doc_date,
aph_local_amount lamt,aph_narration narration, created_by,created_date,
(SELECT order_no from mt_order_entry where id=(SELECT order_id from mt_order_cost where inv_pay_no=aph_document_number limit 1)) order_no1,lpo_order order_no FROM mt_ap_header where aph_document_number like'LPO%' order by id desc limit :sta,50");

$statement->bindValue(':sta',(int) $code->start, PDO::PARAM_INT); 
$statement->execute();
$data=$statement->fetchAll(PDO::FETCH_ASSOC);
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function get_erc_info($code)
{

$data=array();
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT id,service_order,order_no,doc_date,valid_till,release_from,return_to,cut_off_date,van_location,van_date,instructions,additional_detail,send_mail,send_to,cc,temp_code from mt_erc where id=:id");

$statement->execute(array(':id'=>$code));

$data["info"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT id,erc_id,equipment_type,qty,status,remarks, '0' edit  
	from mt_erc_equip_detail
	where erc_id=:id");
$statement->execute(array(':id'=>$code));
$data["equip"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_container_acceptance_list()
{

$data=false;
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT container_no,event_code FROM mt_event_updation WHERE event_code='EIC' and cmove_event_code='CURRENT' order by id limit 50");

$statement->execute();
$data=$statement->fetchAll(PDO::FETCH_ASSOC);
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_erc_list($code)
{

$data=false;
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT id,service_order,order_no,valid_till,created_date,created_by,
modified_by,modified_date from mt_erc order by id limit :sta,50");

$statement->bindValue(':sta',(int) $code, PDO::PARAM_INT); 
$statement->execute();

$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function search_erc_list($v)
{

$data=false;
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT id,service_order,order_no,valid_till from mt_erc where service_order like ? or order_no like ? or valid_till like ? order by id limit 50");

$statement ->bindValue(1, "%$v%", PDO::PARAM_STR);
$statement ->bindValue(2, "%$v%", PDO::PARAM_STR);
$statement ->bindValue(3, "%$v%", PDO::PARAM_STR);

$statement->execute();

$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function save_erc($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$temp_code=uniqid($dev->uid);

$statement = $db->prepare("INSERT into mt_erc(service_order,order_no,doc_date,valid_till,release_from,return_to,cut_off_date,van_location,van_date,instructions,additional_detail,send_mail,send_to,cc,created_by,created_date,ip,ua,ekey,temp_code,company_id,location_id) 
values(:service_order,:order_no,:doc_date,:valid_till,:release_from,:return_to,:cut_off_date,:van_location,:van_date,:instructions,:additional_detail,:send_mail,:send_to,:cc,:created_by,now(),:ip,:ua,:ekey,
:temp_code,'$dev->company','$dev->location')");

$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->uid ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,

':service_order'=>$c->service_order,
':order_no'=>$c->order_no,
':doc_date'=>$c->doc_date,
':valid_till'=>$c->valid_till,
':release_from'=>$c->release_from,
':return_to'=>$c->return_to,
':cut_off_date'=>$c->cut_off_date,
':van_location'=>$c->van_location,
':van_date'=>$c->van_date,
':instructions'=>$c->instructions,
':additional_detail'=>$c->additional_detail,
':send_mail'=>$c->send_mail,
':send_to'=>$c->send_to,
':cc'=>$c->cc,


':temp_code'=>$temp_code
));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
  /*

  */
} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}

$statement = $db->prepare("SELECT id from mt_erc where created_by=:uid and temp_code=:temp_code");
$statement->execute(array(':temp_code'=>$temp_code,':uid'=>$dev->uid));
$data["id"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function update_erc($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$statement = $db->prepare("UPDATE mt_erc SET 
service_order=:service_order,
order_no=:order_no,
doc_date=:doc_date,
valid_till=:valid_till,
release_from=:release_from,
return_to=:return_to,
cut_off_date=:cut_off_date,
van_location=:van_location,
van_date=:van_date,
instructions=:instructions,
additional_detail=:additional_detail,
send_mail=:send_mail,
send_to=:send_to,
cc=:cc,
modified_by=:modified_by,
modified_date=now() 
where id=:id");

$statement->execute(array(':modified_by'=>$dev->uid ,

':service_order'=>$c->service_order,
':order_no'=>$c->order_no,
':doc_date'=>$c->doc_date,
':valid_till'=>$c->valid_till,
':release_from'=>$c->release_from,
':return_to'=>$c->return_to,
':cut_off_date'=>$c->cut_off_date,
':van_location'=>$c->van_location,
':van_date'=>$c->van_date,
':instructions'=>$c->instructions,
':additional_detail'=>$c->additional_detail,
':send_mail'=>$c->send_mail,
':send_to'=>$c->send_to,
':cc'=>$c->cc,

':id'=>$c->id
));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
  /*

  */
} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


}

?>