<?php

error_reporting(E_ALL);
ini_set('display_errors', 1);

header("Access-Control-Allow-Origin: *");
header('Access-Control-Allow-Credentials: true');
header("Access-Control-Allow-Methods: GET, POST, OPTIONS");
header("Access-Control-Allow-Headers: Content-Type");
require("../dao/gl-dao.php");


//excel
//excel import
require '../excellib/vendor/autoload.php';
use PhpOffice\PhpSpreadsheet\Spreadsheet;
use PhpOffice\PhpSpreadsheet\Writer\Xlsx;

require("../jwt-verify.php");
require("../obts.php");
$pname="get-gl-list";

if($_SERVER['REQUEST_METHOD']=="POST")
{

$postdata = file_get_contents("php://input");
$request = json_decode($postdata);

if (isset($request->dsp) && !empty($request->dsp)) {

$dev=$request->dsp;
$tz=$request->tz;

//verifying credentials
$auth=authenticate($dev->token);


if($auth["isAuthorized"] & $auth["decoded"]->data->utype=="nvocc_user")
{
$d=$auth["decoded"];

$dev2=$d->data;


$code=$request->code;

$uid=$dev2->uid;


$ip=$_SERVER['REMOTE_ADDR'];

$dev2->ip=$_SERVER['REMOTE_ADDR'];
$dev2->ua=objToString();
$dev2->tz=$tz;

FinanceDao::save_page_views($dev2,$pname,"post");

$result=FinanceDao::download_coa($dev2);

//excel writing
$spreadsheet = new Spreadsheet();
$hsheet = $spreadsheet->getActiveSheet();
$hsheet->setTitle("CHART OF ACCOUNTS");

$column_names=array('Main Account',"Group","SubGroup","Code","Account Description","Type");
$column_labels=array("A","B","C","D","E","F");
$column_names_db=array("account_type","account_group","account_sub_group","code","ac_description","type");
//add column names
for($i=0;$i<count($column_names);$i++)
{

$hsheet->setCellValue($column_labels[$i]."1",$column_names[$i]);

}

//write data to excel
for($j=0;$j<count($result);$j++)
{

  $row=$result[$j];

    for($i=0;$i<count($column_labels);$i++)
    {
    //echo json_encode($row);
    //break;
    $hsheet->setCellValue($column_labels[$i].($j+2),$row[$column_names_db[$i]]);

    }

    //break;

}

$writer = new \PhpOffice\PhpSpreadsheet\Writer\Xlsx($spreadsheet);

$data=array();
$data["file_url"]='files/coa/chart-of-accounts'. date("Y-m-d-H-i-s").'.xlsx';
$writer->save("../".$data["file_url"]);

echo json_encode($data);


}
else
{


$dev=new stdClass();
    $kv='';
  foreach($_POST as $key => $value){
    $kv=$kv.":".$key . "-" . $value;
  }

  $dev->ip=$_SERVER['REMOTE_ADDR'];
  $dev->ua=$_SERVER['HTTP_USER_AGENT'];
  $dev->ekey=$kv;
  $dev->esecret=0;
  $dev->uid=0;
  $dev->tz=$gtz;
FinanceDao::save_page_views($dev,$pname."_illegal",'post');
  $ec=new stdClass();
  $ec->code=1003;
  $ec->desc="Invalid Credentials";
  echo json_encode($ec);
}

}
else
{
$dev=new stdClass();
    $kv='';
  foreach($_GET as $key => $value){
    $kv=$kv.":".$key . "-" . $value;
  }

  $dev->ip=$_SERVER['REMOTE_ADDR'];
  $dev->ua=$_SERVER['HTTP_USER_AGENT'];
  $dev->ekey=$kv;
  $dev->esecret=0;
  $dev->uid=0;
  $dev->tz=$gtz;
  FinanceDao::save_page_views($dev,$pname."_invalid",'post');
  $ec=new stdClass();
  $ec->code=1002;
  $ec->desc="Invalid Params List";
  echo json_encode($ec);
}//end of param check

}//end of post check

else
{
  $dev=new stdClass();
  $kv='';
  foreach($_GET as $key => $value){
    $kv=$kv.":".$key . "-" . $value;
  }

  $dev->ip=$_SERVER['REMOTE_ADDR'];
  $dev->ua=$_SERVER['HTTP_USER_AGENT'];
  $dev->ekey=$kv;
  $dev->esecret=0;
  $dev->uid=0;
  $dev->tz=$gtz;
  FinanceDao::save_page_views($dev,$pname."_invalid",'get');
    $ec=new stdClass();
  $ec->code=1001;
  $ec->desc="Requested Method Not Allowed";
  echo json_encode($ec);
}
?>