<?php
error_reporting(E_ALL);
ini_set('display_errors', 1);

require("pdf-dao.php");

//$temp_code=$_GET["temp_code"];
$cust=$_GET["cust"];
$voyage=$_GET["voyage"];

if(strlen($cust)==0)
{
   $cust='%';
}

if(strlen($voyage)!=0 )
{

$data=PDFDao::get_bulkcargo_discharge($voyage,$cust);

if(count($data["info"])>=1)
{
$c=$data["info"][0];
$c0=$data["qty_kpi"][0];
$c1=$data["ata_kpi"][0];
$c11=$data["atd_kpi"][0];
$c2=date_create($data["min_disc"][0]["discharge_datetime"]);
$c3=date_create($data["max_disc"][0]["discharge_datetime"]);

$diff=date_diff($c2,$c3);

$vdata='';
for($i=0;$i<count($data["info"]);$i++)
{
    $d=$data["info"][$i];
    $d2=date_create($d["discharge_datetime"]);

    $vdata=$vdata.'<tr>
            <td colspan="2">'.$d["vessel"].'</td>
            <td colspan="2">'.$d["voyage"].'</td>
            <td colspan="2">'.$d["bl_no"].'</td>
            <td colspan="2">'.$d["customer"].'</td>
            <td colspan="2">'.$d["commodity"].'</td>
            <td colspan="2">'.$d["pkg_type"].'</td>
            <td colspan="2">'.number_format($d["dis_qty"],0).'</td>
            <td colspan="2">'.number_format($d["bal_qty"],0).'</td>
            <td colspan="2">'.date_format($d2,"Y-m-d H:i:s").'</td>
        </tr>';
}

//Balance BLs
for($j=0;$j<count($data["balance_bl"]);$j++)
{
    $d1=$data["balance_bl"][$j];

    $vdata=$vdata.'<tr>
            <td colspan="2">'.$d1["vessel"].'</td>
            <td colspan="2">'.$d1["voyage"].'</td>
            <td colspan="2">'.$d1["bl_no"].'</td>
            <td colspan="2">'.$d1["customer"].'</td>
            <td colspan="2">'.$d1["commodity"].'</td>
            <td colspan="2">'.$d1["pkg_type"].'</td>
            <td colspan="2">0</td>
            <td colspan="2">'.number_format($d1["bal_qty"],0).'</td>
            <td colspan="2"></td>
        </tr>';
}

//CALC BAL QTY
$c01=$data["bal_bl_qty_kpi"][0];
$calc_bal_qty=(float)$c0["bal_qty"]+(float)$c01["bal_bl_qty"];

$html = '<html>

<head>
    <style>
        body {
            font-family: sans-serif;
            font-size: 8pt;
        }

        p {
            margin: 0pt;
        }

        table.items {
            border: 0.1mm solid #000000;

        }

        td {
            vertical-align: top;
        }

        .items td {
            border-left: 0.1mm solid #000000;
            border-right: 0.1mm solid #000000;
            border-bottom: 0.1mm solid #000000;
        }

        table thead td {
            background-color: #3f495c;
            text-align: center;
            border: 0.1mm solid #000000;
            color: white
        }

        .items td.blanktotal {
            background-color: #EEEEEE;
            border: 0.1mm solid #000000;
            background-color: #FFFFFF;
            border: 0mm none #000000;
            border-top: 0.1mm solid #000000;
            border-right: 0.1mm solid #000000;
        }

        .items td.totals {
            text-align: right;
            border: 0.1mm solid #000000;
        }

        .items td.cost {
            text-align: right;
        }

        table.bdr {
            border: 0.1mm solid #000000;
        }

        table.hdr {
            background: #DCDCDC;
            font-weight: bold !important;
        }

        tr.hdr {
            background: #DCDCDC;
        }

        td.hdr {
            font-weight: bold !important;
        }

        .tdmiddle {
            text-align: center;
            vertical-align: middle;
        }
    </style>
</head>

<body>
 <div>
       <h1>
             Bulk Cargo Discharge Report
       </h1>
      
    </div>

    <table width="100%" class="items" style="font-size: 9pt; border-collapse: collapse; " cellpadding="5">

        <thead>
            <tr>
                <td colspan="2">Vessel</td>
                <td colspan="2">Voyage</td>
                <td colspan="2">BL No.</td>
                <td colspan="2">Customer</td>
                <td colspan="2">Commodity</td>
                <td colspan="2">Pkg Type</td>
                <td colspan="2">Disch. Qty</td>
                <td colspan="2">Bal. Qty</td>
                <td colspan="2">Discharge Date/Time</td>
            </tr>
        </thead>
        '.$vdata.'

    </table>
    <div>
       <h4>
             Quality KPIs
       </h4>
      
    </div>
    <table width="40%" class="items" style="font-size: 9pt; border-collapse: collapse; " cellpadding="5">

        <tr>
            <td >Balance Qty. </td>
            <td >'.number_format($calc_bal_qty,0).'</td>
        </tr>

        <tr>
            <td >Berthing Date/Time </td>
            <td >'.$c1["eta"].'</td>
        </tr>

        <tr>
            <td>Discharge Start Date/Time</td>
            <td >'.date_format($c2,"Y-m-d H:i:s").'</td>

        </tr>
        <tr>
            <td>Discharge Finished Date/Time</td>
            <td >'.date_format($c3,"Y-m-d H:i:s").'</td>

        </tr>
        
        <tr>
            <td >Sailout Date/Time</td>
            <td >'.$c1["etd"].'</td>

        </tr>
        <tr>
            <td >Total Discharge Time Taken</td>
            <td >'.$diff->format("%a days, %H Hours %I Minutes.").'</td>

        </tr>
        

    </table>
</body>

</html>


';

require_once 'vendor/autoload.php';
$mpdf = new \Mpdf\Mpdf([
  'margin_left' => 5,
  'margin_right' => 5,
  'margin_top' => 5,
  'margin_bottom' => 5,
  'margin_header' => 2,
  'margin_footer' => 2,
  'tempDir' => 'tmp',
  'format'=> 'A4-L'
]);

$mpdf->SetProtection(array('print'));
$mpdf->SetTitle("Falcon International Shipping");
$mpdf->SetAuthor("Falcon");
$mpdf->SetWatermarkText("");
$mpdf->showWatermarkText = true;
$mpdf->watermark_font = 'DejaVuSansCondensed';
$mpdf->watermarkTextAlpha = 0.1;
$mpdf->SetDisplayMode('fullpage');
$mpdf->WriteHTML($html);
$mpdf->Output();

}else{
  echo "Invalid credentials........";
}

}
else{
  echo "Please enter valid credentials.....";
}

?>