<?php


require("../config/dbconn.php");

class GSTReportDao

{



public static function save_page_views($dev,$pname,$method)
{
$data=0;
try
{
$db = Factory::getConnection();


$statement = $db->prepare("INSERT into page_views(
ip ,uid ,ua,ekey,esecret,method,page,tz) 
values(:ip ,:uid ,
:ua ,:ekey ,:esecret ,:method ,:page,:tz)");
$statement->execute(array(':ip'=>$dev->ip,':uid'=>$dev->uid ,
':ua'=>$dev->ua,
':tz'=>$dev->tz ,
':method'=>$method ,':esecret'=>$dev->esecret,':ekey'=>$dev->ekey,
':page'=>$pname));


$data=1;
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function get_output_gst_report($dev,$from_date,$to_date,$username)
{
$data=array();
try
{
$db = Factory::getConnection();

//Get Location
$statement = $db->prepare("SELECT location from user_master
where username=:username ");
$statement->execute(array(':username'=>$username));
$data["location"]=$statement->fetchAll(PDO::FETCH_ASSOC);
$location_id=$data["location"][0]["location"];

$statement = $db->prepare(" 
SELECT sub_ar_date,order_no,sub_ar_doc_number,sub_ar_code,gstin,
  tax_lamt_5,tax_lamt_18,cgst_25,sgst_25,igst_5,cgst_9,sgst_9,igst_18,
  ROUND(CAST( (sub_ar_l_amount+igst_5+sgst_25+cgst_25+igst_18+cgst_9+sgst_9) 
    AS DECIMAL(10,4)),2)
  final_total FROM 
(SELECT sub_ar_date,REPLACE(order_no,',','') order_no,sub_ar_doc_number,(SELECT name from mt_business_partner where code=sub_ar_code) sub_ar_code,(SELECT gstin from mt_business_partner where code=sub_ar_code limit 1)  gstin, sub_ar_l_amount, gst_percent,(sub_ar_l_amount-ofrt_amount) tax_lamt_18,ofrt_amount tax_lamt_5,
igst igst_18,cgst cgst_9,sgst sgst_9,
CASE WHEN is_igst=1 THEN ROUND(CAST( (ofrt_amount*5)/100 AS DECIMAL(10,4)),2) ELSE 0 END igst_5,
CASE WHEN is_igst=0 THEN ROUND(CAST( (ofrt_amount*2.5)/100 AS DECIMAL(10,4)),2) ELSE 0 END cgst_25,
CASE WHEN is_igst=0 THEN ROUND(CAST( (ofrt_amount*2.5)/100 AS DECIMAL(10,4)),2) ELSE 0 END sgst_25,
round(sub_ar_l_amount+igst+sgst+cgst,2) total from mt_order_ar_header  
where sub_ar_date between :from_date and :to_date 
 and sub_ar_status!='CANCELLED' 
 and location_id=:location_id ) t1

     ");
$statement->execute(array(':from_date'=>$from_date, ':to_date'=>$to_date,':location_id'=>$location_id));
$data["dList"]=$statement->fetchAll(PDO::FETCH_ASSOC);

  if ($statement->rowCount()){
    $data["status"]=1;
  } else{
    $data["status"]=0;
  }
  
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function get_input_gst_report($dev,$from_date,$to_date,$username)
{
$data=array();
try
{
$db = Factory::getConnection();

//Get Location
$statement = $db->prepare("SELECT location from user_master
where username=:username ");
$statement->execute(array(':username'=>$username));
$data["location"]=$statement->fetchAll(PDO::FETCH_ASSOC);
$location_id=$data["location"][0]["location"];

$statement = $db->prepare("CREATE TEMPORARY TABLE input_gst_header as 
SELECT aph_document_date,aph_document_number,(SELECT name from mt_business_partner where code=aph_code) aph_code,(SELECT gstin from mt_business_partner where code=aph_code limit 1)  gstin, aph_local_amount,lpo_order order_no
 from mt_ap_header  
where aph_document_date  between :from_date and :to_date 
 and aph_status!='CANCELLED' and aph_document_number LIKE 'SIN%'
  and location_id=:location_id");
$statement->execute(array(':from_date'=>$from_date, ':to_date'=>$to_date,':location_id'=>$location_id));

$statement = $db->prepare("CREATE TEMPORARY TABLE input_gst_child as 
  SELECT sum(tax_lamt_5) tax_lamt_5,sum(tax_lamt_18) tax_lamt_18,aloc_doc_number FROM
  (SELECT 
  CASE WHEN tax_percentage=5 THEN sum(aloc_local_amount) ELSE 0 END tax_lamt_5,
  CASE WHEN tax_percentage=18 THEN sum(aloc_local_amount) ELSE 0 END tax_lamt_18,
  aloc_doc_number FROM `mt_ap_allocation_details` WHERE `aloc_doc_number` in(SELECT aph_document_number FROM input_gst_header) GROUP BY aloc_doc_number,tax_percentage) t1
  GROUP BY aloc_doc_number");
$data["table_created"]=$statement->execute();

$statement = $db->prepare("SELECT order_no,sub_ar_date,sub_ar_doc_number,sub_ar_code,gstin,sub_ar_l_amount,tax_lamt_5,tax_lamt_18,igst_5,cgst_25,sgst_25,igst_18,cgst_9,sgst_9,round(cast((tax_lamt_5+tax_lamt_18+igst_5+cgst_25+sgst_25+igst_18+cgst_9+sgst_9) AS DECIMAL(10,2)),2) final_total FROM
  (SELECT order_no,aph_document_date sub_ar_date,aph_document_number sub_ar_doc_number,aph_code sub_ar_code,gstin, aph_local_amount sub_ar_l_amount,tax_lamt_5,tax_lamt_18,
  CASE WHEN substring(gstin,1,2)!=33 THEN round( cast(tax_lamt_5*5/100 AS DECIMAL(10,4)),2) ELSE 0 END igst_5,
  CASE WHEN substring(gstin,1,2)=33 THEN round( cast(tax_lamt_5*2.5/100 AS DECIMAL(10,4)),2) ELSE 0 END cgst_25,
  CASE WHEN substring(gstin,1,2)=33 THEN round( cast(tax_lamt_5*2.5/100 AS DECIMAL(10,4)),2) ELSE 0 END sgst_25,
  CASE WHEN substring(gstin,1,2)!=33 THEN round( cast(tax_lamt_18*18/100 AS DECIMAL(10,4)),2) ELSE 0 END igst_18,
  CASE WHEN substring(gstin,1,2)=33 THEN round( cast(tax_lamt_18*9/100 AS DECIMAL(10,4)),2) ELSE 0 END cgst_9,
  CASE WHEN substring(gstin,1,2)=33 THEN round( cast(tax_lamt_18*9/100 AS DECIMAL(10,4)),2) ELSE 0 END sgst_9
   FROM input_gst_header t1, input_gst_child t2
WHERE t2.aloc_doc_number=t1.aph_document_number) bt1");
$statement->execute();
$data["dList"]=$statement->fetchAll(PDO::FETCH_ASSOC); 
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

}
?>