<?php

error_reporting(E_ALL);
ini_set('display_errors', 1);

//mpdf memory problem solution
ini_set('memory_limit','5120M');
ini_set('max_execution_time', '3600');
ini_set("pcre.backtrack_limit", "5000000");

header("Access-Control-Allow-Origin: *");
header('Access-Control-Allow-Credentials: true');
header("Access-Control-Allow-Methods: GET, POST, OPTIONS");
header("Access-Control-Allow-Headers: Content-Type");
require("gst-report-dao.php");
//require("column-names-list-gst-report.php");


//excel
//excel import
require '../excellib/vendor/autoload.php';
use PhpOffice\PhpSpreadsheet\Spreadsheet;
use PhpOffice\PhpSpreadsheet\Writer\Xlsx;

require("../jwt-verify.php");
require("../obts.php");
$pname="input-gst-report";

if($_SERVER['REQUEST_METHOD']=="POST")
{

$postdata = file_get_contents("php://input");
$request = json_decode($postdata);

if (isset($request->dsp) && !empty($request->dsp)) {

$dev=$request->dsp;
$tz=$request->tz;

//verifying credentials
$auth=authenticate($dev->token);


if($auth["isAuthorized"] & $auth["decoded"]->data->utype=="nvocc_user")
{
$d=$auth["decoded"];

$dev2=$d->data;

$uid=$dev2->uid;


$ip=$_SERVER['REMOTE_ADDR'];

$dev2->ip=$_SERVER['REMOTE_ADDR'];
$dev2->ua=objToString();
$dev2->tz=$tz;

GSTReportDao::save_page_views($dev2,$pname,"post");
$code=$request->code;
$from_date=$code->from_date;
$to_date=$code->to_date;
$username=$code->username;
//$username='sibi';
$column_names=array('sub_ar_date','order_no','sub_ar_doc_number','sub_ar_code','gstin',
  'tax_lamt_5','tax_lamt_18','cgst_25','sgst_25','igst_5','cgst_9','sgst_9','igst_18',
  'final_total');

$column_names_label=array('Doc Date','Order No','Doc Number','Customer','GSTIN','Taxable 5%','Taxable 18%','CGST 2.5%','SGST 2.5%','IGST 5%','CGST 9%','SGST 9%','IGST 18%','Total');

$column_labels=array('A','B','C','D','E','F','G','H','I','J','K','L','M','N');

$output=GSTReportDao::get_input_gst_report($dev2,$from_date,$to_date,$username);

$result=$output["dList"];
//excel writing
//var_dump($result);

$spreadsheet = new Spreadsheet();
$sheet = $spreadsheet->getActiveSheet();

for($i=0;$i<count($column_names);$i++)
{

$sheet->setCellValue($column_labels[$i]."1",$column_names_label[$i]);

}

for($j=0;$j<count($result);$j++)
{

  $row=$result[$j];

    for($i=0;$i<count($column_labels);$i++)
    {
    //echo json_encode($row);
    //break;
    $sheet->setCellValue($column_labels[$i].($j+2),$row[$column_names[$i]]);

    }

    //break;

}

$writer = new \PhpOffice\PhpSpreadsheet\Writer\Xlsx($spreadsheet);

$data=array();
$data["file_url"]='files/gst-report/Input-GST-Report-'. date("Y-m-d-H-i-s").'.xlsx';
$writer->save("../".$data["file_url"]);

echo json_encode($data);

//


}
else
{


$dev=new stdClass();
    $kv='';
  foreach($_POST as $key => $value){
    $kv=$kv.":".$key . "-" . $value;
  }

  $dev->ip=$_SERVER['REMOTE_ADDR'];
  $dev->ua=$_SERVER['HTTP_USER_AGENT'];
  $dev->ekey=$kv;
  $dev->esecret=0;
  $dev->uid=0;
  $dev->tz=$gtz;
GSTReportDao::save_page_views($dev,$pname."_illegal",'post');
  $ec=new stdClass();
  $ec->code=1003;
  $ec->desc="Invalid Credentials";
  echo json_encode($ec);
}

}
else
{
$dev=new stdClass();
    $kv='';
  foreach($_GET as $key => $value){
    $kv=$kv.":".$key . "-" . $value;
  }

  $dev->ip=$_SERVER['REMOTE_ADDR'];
  $dev->ua=$_SERVER['HTTP_USER_AGENT'];
  $dev->ekey=$kv;
  $dev->esecret=0;
  $dev->uid=0;
  $dev->tz=$gtz;
  GSTReportDao::save_page_views($dev,$pname."_invalid",'post');
  $ec=new stdClass();
  $ec->code=1002;
  $ec->desc="Invalid Params List";
  echo json_encode($ec);
}//end of param check

}//end of post check

else
{
  $dev=new stdClass();
  $kv='';
  foreach($_GET as $key => $value){
    $kv=$kv.":".$key . "-" . $value;
  }

  $dev->ip=$_SERVER['REMOTE_ADDR'];
  $dev->ua=$_SERVER['HTTP_USER_AGENT'];
  $dev->ekey=$kv;
  $dev->esecret=0;
  $dev->uid=0;
  $dev->tz=$gtz;
  GSTReportDao::save_page_views($dev,$pname."_invalid",'get');
    $ec=new stdClass();
  $ec->code=1001;
  $ec->desc="Requested Method Not Allowed";
  echo json_encode($ec);
}
?>