<?php


require("../config/dbconn.php");

class PDFDao

{



public static function save_page_views($dev,$pname,$method)
{
$data=0;
try
{
$db = Factory::getConnection();


$statement = $db->prepare("INSERT into page_views(
ip ,uid ,ua,ekey,esecret,method,page,tz) 
values(:ip ,:uid ,
:ua ,:ekey ,:esecret ,:method ,:page,:tz)");
$statement->execute(array(':ip'=>$dev->ip,':uid'=>$dev->uid ,
':ua'=>$dev->ua,
':tz'=>$dev->tz ,
':method'=>$method ,':esecret'=>$dev->esecret,':ekey'=>$dev->ekey,
':page'=>$pname));


$data=1;
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

 
public static function get_tb_summary($fc,$tc,$fy,$fp)
{
$data=array();
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT pre_glt_code,
(select ac_description from mt_general_ledger where code=t1.pre_glt_code) ac_desc,
sum(debit) debit,
sum(credit) credit 
FROM 
(SELECT pre_glt_code,case when pre_glt_local_amount>=0 then pre_glt_local_amount else 0 end debit,
case when pre_glt_local_amount<0 then abs(pre_glt_local_amount) else 0 end credit 
 FROM mt_pre_gl_view_all 
  where pre_glt_year=:fy and pre_glt_period=:fp and (pre_glt_code between :fc and :tc )) t1 GROUP by pre_glt_code ");

$statement->execute(array(':fc'=>$fc,':tc'=>$tc,
  ':fy'=>$fy,':fp'=>$fp));
$data["info"]=$statement->fetchAll(PDO::FETCH_ASSOC);
}
catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_cb_summary($fc,$status,$from_date,$to_date,$username)
{
$data=array();
try
{
$db = Factory::getConnection();

//Get Location
$statement = $db->prepare("SELECT location, company from user_master
where username=:username ");
$statement->execute(array(':username'=>$username));
$data["location"]=$statement->fetchAll(PDO::FETCH_ASSOC);
$location_id=$data["location"][0]["location"];

$statement = $db->prepare("SELECT 
cb_company,
cb_doc_type,
cb_doc_number,
cb_base_doc_type,
cb_code,
(SELECT description FROM mt_bank_list where bank_code=cb_code limit 1 ) bank_description,
(SELECT gl_code FROM mt_bank_list where bank_code=cb_code limit 1 ) bank_glcode,
cb_doc_date,
cb_gl_date,
cb_year,
cb_period,
cb_currency,
cb_ex_rate,
cb_foreign_amount,
cb_local_amount,
cb_cheque_number,
cb_cheque_date,
cb_account,
cb_status,
cb_narration 
  FROM mt_cash_book_details where (cb_doc_date between :from_date and :to_date) and cb_code=:fc 
and cb_status!='CANCELLED' 
order by cb_doc_date asc ");

$statement->execute(array(':fc'=>$fc,
  ':from_date'=>$from_date,':to_date'=>$to_date));
$data["info"]=$statement->fetchAll(PDO::FETCH_ASSOC);
}
catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_ap_summary($fc,$tc,$from_date,$to_date)
{
$data=array();
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT apdm_code,(select name from mt_business_partner where code=apdm_code) name,sum(debit) debit,sum(credit) credit FROM (SELECT apdm_code,0 opening_balance, case when apdm_ol_amount>=0 then apdm_ol_amount else 0 end debit, case when apdm_ol_amount<0 then abs(apdm_ol_amount) else 0 end credit FROM mt_ap_trans_balance where (apdm_date between :from_date and :to_date) and (apdm_code between :fc and :tc) ) t1 GROUP by apdm_code");

$statement->execute(array(':fc'=>$fc,':tc'=>$tc,
  ':from_date'=>$from_date,':to_date'=>$to_date));
$data["info"]=$statement->fetchAll(PDO::FETCH_ASSOC);
}
catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_ar_summary($fc,$tc,$from_date,$to_date)
{
$data=array();
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT ardm_code,(select name from mt_business_partner where code=ardm_code) name,sum(debit) debit,sum(credit) credit FROM (SELECT ardm_code,0 opening_balance, case when ardm_ol_amount>=0 then ardm_ol_amount else 0 end debit, case when ardm_ol_amount<0 then abs(ardm_ol_amount) else 0 end credit FROM mt_ar_trans_balance where (ardm_date between :from_date and :to_date) and (ardm_code between :fc and :tc) ) t1 GROUP by ardm_code");

$statement->execute(array(':fc'=>$fc,':tc'=>$tc,
  ':from_date'=>$from_date,':to_date'=>$to_date));
$data["info"]=$statement->fetchAll(PDO::FETCH_ASSOC);
}
catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function get_cb_statement($fc,$tc,$from_date,$to_date)
{
$data=array();
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT cb_doc_date,cb_gl_date,cb_code,cb_doc_type,cb_doc_number,cb_cheque_number,cb_cheque_date,'' clr_date,cb_foreign_amount,cb_local_amount,cb_Foreignt_amount,cb_local_amount from mt_cash_book_details where cb_code=:code and cb_doc_date between :from_date and :to_date");

$statement->execute(array(':fc'=>$fc,
  ':from_date'=>$from_date,':to_date'=>$to_date));
$data["info"]=$statement->fetchAll(PDO::FETCH_ASSOC);


  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function get_jv_print_info($from_doc_no,$to_doc_no)
{

$data=array();
try
{
$db = Factory::getConnection();

$voucher_list=array(
array("c1"=>"RCH","c2"=>"RECEIPT"),
array("c1"=>"RBC","c2"=>"RECEIPT"),
array("c1"=>"ROT","c2"=>"RECEIPT"),
array("c1"=>"RCT","c2"=>"RECEIPT"),
array("c1"=>"PTC","c2"=>"PAYMENT"),
array("c1"=>"PBC","c2"=>"PAYMENT"),
array("c1"=>"PCT","c2"=>"PAYMENT"),
array("c1"=>"POT","c2"=>"PAYMENT"),
array("c1"=>"PGN","c2"=>"AP"),
array("c1"=>"PDN","c2"=>"AP"),
array("c1"=>"PCN","c2"=>"AP"),
array("c1"=>"RGN","c2"=>"AR"),
array("c1"=>"RDN","c2"=>"AR"),
array("c1"=>"RCN","c2"=>"AR")
);
$table_type='';
$child="";

for($i=0;$i<count($voucher_list);$i++)
{
  if(substr($from_doc_no,0,3)==$voucher_list[$i]["c1"])
  {
    $table_type=$voucher_list[$i]["c2"];
    $data["c1"]=$voucher_list[$i]["c1"];
    $data["c2"]=$voucher_list[$i]["c2"];

    break;
  }
}

if($table_type=="RECEIPT")
{
  $child="mt_receipt_gl_details";
  $statement = $db->prepare("SELECT id,
rh_doc_number doc_no,
rh_base_doc_type base_doc,
rh_doc_type doc_type,
rh_doc_date doc_date,
rh_gl_date gl_date,
rh_narration narration,
rh_currency currency,
rh_exchange_rate ex_rate,
rh_foreign_amount famt,
rh_local_amount lamt,
rh_status status,
location_id,
company_id,
created_by,
created_date 
 from mt_receipt_header where rh_doc_number=:from_doc_no");

$statement->execute(array(
':from_doc_no'=>$from_doc_no
));
$data["header"]=$statement->fetchAll(PDO::FETCH_ASSOC);

}


$statement = $db->prepare("SELECT 
pre_glt_code,
pre_glt_doc_number doc_no,
(SELECT ac_description FROM mt_general_ledger WHERE code=pre_glt_code) ac_description,
(SELECT name FROM mt_business_partner WHERE code=pre_glt_detail_3 limit 1) aloc_detail_3_name,
pre_glt_ex_rate,
pre_glt_detail_2 aloc_detail_2,
pre_glt_detail_1 aloc_detail_1,
pre_glt_detail_3 aloc_detail_3,
pre_glt_narration,
pre_glt_local_amount aloc_amount,
pre_glt_narration aloc_narration,
location_id,
company_id,
created_by,
created_date 
FROM $child 
where pre_glt_doc_number=:from_doc_no");

$statement->execute(array(
':from_doc_no'=>$from_doc_no
));
$data["details"]=$statement->fetchAll(PDO::FETCH_ASSOC);


$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  return $data;
}

public static function get_jv_info($id,$temp_code)
{

$data=array();
try
{
$db = Factory::getConnection();

$statement = $db->prepare("SELECT 
aloc_doc_number,
aloc_amount,
aloc_currency,
aloc_ex_rate,
aloc_local_amount,
aloc_narration,
aloc_detail_1,
aloc_detail_2,
(SELECT name from mt_business_partner where code=aloc_detail_3 limit 1) aloc_detail_3_name,
aloc_detail_3,
location_id,
company_id,
created_by,
created_date 
FROM mt_jv_allocation_details 
where aloc_doc_number=(SELECT jvh_doc_number from mt_jv_header where id=:id and temp_code=:temp_code limit 1) ");

$statement->execute(array(
':id'=>$id,
':temp_code'=>$temp_code
));
$data["details"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT id,
jvh_doc_number,
jvh_base_doc,
jvh_doc_type,
jvh_date,
jvh_gl_date,
jvh_narration,
jvh_currency,
jvh_ex_rate,
jvh_foreign_amount,
jvh_local_amount,
jvh_status,
location_id,
company_id,
created_by,
created_date 
 from mt_jv_header where id=:id and temp_code=:temp_code limit 1 ");

$statement->execute(array(
':id'=>$id,
':temp_code'=>$temp_code
));
$data["header"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  return $data;
}


public static function get_pv_info($id,$temp_code)
{

$data=array();
try
{
$db = Factory::getConnection();

$statement = $db->prepare("SELECT 
aloc_doc_number,
aloc_foreign_amount,
aloc_currency,
aloc_ex_rate,
aloc_local_amount,
aloc_narration,
aloc_other_reference,
aloc_detail_1,
aloc_detail_2,
(SELECT name from mt_business_partner where code=aloc_detail_3 limit 1) aloc_detail_3_name,
aloc_detail_3,
location_id,
company_id,
created_by,
created_date 
FROM mt_ap_allocation_details 
where aloc_doc_number=(SELECT aph_document_number from mt_ap_header where id=:id and temp_code=:temp_code limit 1) ");

$statement->execute(array(
':id'=>$id,
':temp_code'=>$temp_code
));
$data["details"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT id,
aph_code,
(SELECT name from mt_business_partner where code=aph_code) customer,
(SELECT address from mt_bp_address where bp_id=(SELECT id from mt_business_partner where code=aph_code)) c_add1,
(SELECT address2 from mt_bp_address where bp_id=(SELECT id from mt_business_partner where code=aph_code)) c_add2,
(SELECT address3 from mt_bp_address where bp_id=(SELECT id from mt_business_partner where code=aph_code)) c_add3,
(SELECT gstin from mt_business_partner where code=aph_code) c_gstin,
(SELECT pan from mt_business_partner where code=aph_code) c_pan,
(SELECT city from mt_bp_address where bp_id=(SELECT id from mt_business_partner where code=aph_code)) c_city,
(SELECT zip from mt_bp_address where bp_id=(SELECT id from mt_business_partner where code=aph_code)) c_zip,
aph_document_number,
aph_document_type,
aph_document_date,
aph_other_reference,
aph_currency,
aph_local_amount,
aph_narration,
aph_status,
location_id,
company_id,
created_by,
created_date 
 from mt_ap_header where id=:id and temp_code=:temp_code limit 1 ");

$statement->execute(array(
':id'=>$id,
':temp_code'=>$temp_code
));
$data["header"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  return $data;
}


public static function get_rv_info($id,$temp_code)
{

$data=array();
try
{
$db = Factory::getConnection();

$statement = $db->prepare("SELECT 
aloc_doc_number,
aloc_foreign_amount,
aloc_currency,
aloc_ex_rate,
aloc_local_amount,
aloc_narration,
aloc_other_reference,
aloc_detail_1,
aloc_detail_2,
(SELECT name from mt_business_partner where code=aloc_detail_3 limit 1) aloc_detail_3_name,
aloc_detail_3,
location_id,
company_id,
created_by,
created_date 
FROM mt_ar_allocation_details 
where aloc_doc_number=(SELECT arh_document_number from mt_ar_header where id=:id and temp_code=:temp_code limit 1) ");

$statement->execute(array(
':id'=>$id,
':temp_code'=>$temp_code
));
$data["details"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT id,
arh_code,
(SELECT name from mt_business_partner where code=arh_code) customer,
(SELECT address from mt_bp_address where bp_id=(SELECT id from mt_business_partner where code=arh_code)) c_add1,
(SELECT address2 from mt_bp_address where bp_id=(SELECT id from mt_business_partner where code=arh_code)) c_add2,
(SELECT address3 from mt_bp_address where bp_id=(SELECT id from mt_business_partner where code=arh_code)) c_add3,
(SELECT gstin from mt_business_partner where code=arh_code) c_gstin,
(SELECT pan from mt_business_partner where code=arh_code) c_pan,
(SELECT city from mt_bp_address where bp_id=(SELECT id from mt_business_partner where code=arh_code)) c_city,
(SELECT zip from mt_bp_address where bp_id=(SELECT id from mt_business_partner where code=arh_code)) c_zip,
arh_document_number,
arh_document_type,
arh_document_date,
arh_other_reference,
arh_currency,
arh_local_amount,
arh_narration,
arh_status,
location_id,
company_id,
created_by,
created_date 
 from mt_ar_header where id=:id and temp_code=:temp_code limit 1 ");

$statement->execute(array(
':id'=>$id,
':temp_code'=>$temp_code
));
$data["header"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  return $data;
}


public static function get_rptv_info($id,$temp_code)
{

$data=array();
try
{
$db = Factory::getConnection();

$statement = $db->prepare("SELECT 
aloc_doc_number,
aloc_foreign_amount,
aloc_currency,
aloc_ex_rate,
aloc_local_amount,
aloc_narration,
aloc_detail_1,
aloc_detail_2,
(SELECT name from mt_business_partner where code=aloc_detail_3) customer,
(SELECT address from mt_bp_address where bp_id=(SELECT id from mt_business_partner where code=aloc_detail_3)) c_add1,
(SELECT address2 from mt_bp_address where bp_id=(SELECT id from mt_business_partner where code=aloc_detail_3)) c_add2,
(SELECT address3 from mt_bp_address where bp_id=(SELECT id from mt_business_partner where code=aloc_detail_3)) c_add3,
(SELECT gstin from mt_business_partner where code=aloc_detail_3) c_gstin,
(SELECT pan from mt_business_partner where code=aloc_detail_3) c_pan,
(SELECT city from mt_bp_address where bp_id=(SELECT id from mt_business_partner where code=aloc_detail_3)) c_city,
(SELECT zip from mt_bp_address where bp_id=(SELECT id from mt_business_partner where code=aloc_detail_3)) c_zip,
aloc_detail_3,
location_id,
company_id,
created_by,
created_date 
FROM mt_receipt_allocation_details 
where aloc_doc_number=(SELECT rh_doc_number from mt_receipt_header where id=:id and temp_code=:temp_code limit 1) 
and length(aloc_detail_3)>0 ");

$statement->execute(array(
':id'=>$id,
':temp_code'=>$temp_code
));
$data["details"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT id,
rh_cash_bank_code,
(SELECT description FROM mt_bank_list where bank_code=rh_cash_bank_code limit 1 ) bank_description,
rh_gl_account,
rh_base_doc_type,
rh_doc_number,
rh_doc_type,
rh_doc_date,
rh_currency,
rh_local_amount,
rh_cheque_number,
rh_cheque_date,
rh_other_reference,
rh_narration,
rh_status,
name,
mobile,
email,
location_id,
company_id,
created_by,
created_date 
 from mt_receipt_header where id=:id and temp_code=:temp_code limit 1 ");

$statement->execute(array(
':id'=>$id,
':temp_code'=>$temp_code
));
$data["header"]=$statement->fetchAll(PDO::FETCH_ASSOC);


$statement = $db->prepare("SELECT 
aloc_doc_number,
aloc_foreign_amount,
aloc_currency,
aloc_ex_rate,
aloc_local_amount,
aloc_narration,
aloc_detail_1,
aloc_detail_2,
(SELECT name from mt_business_partner where code=aloc_detail_3) customer,
(SELECT address from mt_bp_address where bp_id=(SELECT id from mt_business_partner where code=aloc_detail_3)) c_add1,
(SELECT address2 from mt_bp_address where bp_id=(SELECT id from mt_business_partner where code=aloc_detail_3)) c_add2,
(SELECT address3 from mt_bp_address where bp_id=(SELECT id from mt_business_partner where code=aloc_detail_3)) c_add3,
(SELECT gstin from mt_business_partner where code=aloc_detail_3) c_gstin,
(SELECT pan from mt_business_partner where code=aloc_detail_3) c_pan,
(SELECT city from mt_bp_address where bp_id=(SELECT id from mt_business_partner where code=aloc_detail_3)) c_city,
(SELECT zip from mt_bp_address where bp_id=(SELECT id from mt_business_partner where code=aloc_detail_3)) c_zip,
aloc_detail_3,
location_id,
company_id,
created_by,
created_date 
FROM mt_receipt_allocation_details 
where aloc_doc_number=(SELECT rh_doc_number from mt_receipt_header where id=:id and temp_code=:temp_code limit 1) 
");

$statement->execute(array(
':id'=>$id,
':temp_code'=>$temp_code
));
$data["details2"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  return $data;
}


public static function get_pmtv_info($id,$temp_code)
{

$data=array();
try
{
$db = Factory::getConnection();

$statement = $db->prepare("SELECT 
aloc_doc_number,
aloc_foreign_amount,
aloc_currency,
aloc_ex_rate,
aloc_local_amount,
aloc_narration,
aloc_detail_1,
aloc_detail_2,
(SELECT name from mt_business_partner where code=aloc_detail_3) customer,
(SELECT address from mt_bp_address where bp_id=(SELECT id from mt_business_partner where code=aloc_detail_3)) c_add1,
(SELECT address2 from mt_bp_address where bp_id=(SELECT id from mt_business_partner where code=aloc_detail_3)) c_add2,
(SELECT address3 from mt_bp_address where bp_id=(SELECT id from mt_business_partner where code=aloc_detail_3)) c_add3,
(SELECT gstin from mt_business_partner where code=aloc_detail_3) c_gstin,
(SELECT pan from mt_business_partner where code=aloc_detail_3) c_pan,
(SELECT city from mt_bp_address where bp_id=(SELECT id from mt_business_partner where code=aloc_detail_3)) c_city,
(SELECT zip from mt_bp_address where bp_id=(SELECT id from mt_business_partner where code=aloc_detail_3)) c_zip,
aloc_detail_3,
location_id,
company_id,
created_by,
created_date 
FROM mt_payment_allocation_details 
where aloc_doc_number=(SELECT ph_doc_number from mt_payment_header where id=:id and temp_code=:temp_code limit 1) 
and length(aloc_detail_3)>0 ");

$statement->execute(array(
':id'=>$id,
':temp_code'=>$temp_code
));
$data["details"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT id,
ph_cash_bank_code,
(SELECT description FROM mt_bank_list where bank_code=ph_cash_bank_code limit 1 ) bank_description,
ph_gl_account,
ph_base_doc_type,
ph_doc_number,
ph_doc_type,
ph_doc_date,
ph_currency,
ph_local_amount,
ph_cheque_number,
ph_cheque_date,
ph_other_reference,
ph_narration,
ph_status,
name,
mobile,
email,
location_id,
company_id,
created_by,
created_date 
 from mt_payment_header where id=:id and temp_code=:temp_code limit 1 ");

$statement->execute(array(
':id'=>$id,
':temp_code'=>$temp_code
));
$data["header"]=$statement->fetchAll(PDO::FETCH_ASSOC);


$statement = $db->prepare("SELECT 
aloc_doc_number,
aloc_foreign_amount,
aloc_currency,
aloc_ex_rate,
aloc_local_amount,
aloc_narration,
aloc_detail_1,
aloc_detail_2,
(SELECT name from mt_business_partner where code=aloc_detail_3) customer,
(SELECT address from mt_bp_address where bp_id=(SELECT id from mt_business_partner where code=aloc_detail_3)) c_add1,
(SELECT address2 from mt_bp_address where bp_id=(SELECT id from mt_business_partner where code=aloc_detail_3)) c_add2,
(SELECT address3 from mt_bp_address where bp_id=(SELECT id from mt_business_partner where code=aloc_detail_3)) c_add3,
(SELECT gstin from mt_business_partner where code=aloc_detail_3) c_gstin,
(SELECT pan from mt_business_partner where code=aloc_detail_3) c_pan,
(SELECT city from mt_bp_address where bp_id=(SELECT id from mt_business_partner where code=aloc_detail_3)) c_city,
(SELECT zip from mt_bp_address where bp_id=(SELECT id from mt_business_partner where code=aloc_detail_3)) c_zip,
aloc_detail_3,
location_id,
company_id,
created_by,
created_date 
FROM mt_payment_allocation_details 
where aloc_doc_number=(SELECT ph_doc_number from mt_payment_header where id=:id and temp_code=:temp_code limit 1) 
");

$statement->execute(array(
':id'=>$id,
':temp_code'=>$temp_code
));
$data["details2"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  return $data;
}


public static function get_b2btv_info($id,$temp_code)
{

$data=array();
try
{
$db = Factory::getConnection();

$statement = $db->prepare("SELECT 
aloc_doc_number,
aloc_currency,
aloc_ex_rate,
aloc_local_amount,
aloc_narration,
aloc_detail_1,
aloc_detail_2,
(SELECT name from mt_business_partner where code=aloc_detail_3 limit 1) aloc_detail_3_name,
aloc_detail_3,
location_id,
company_id,
created_by,
created_date 
FROM mt_b2b_allocation_details 
where aloc_doc_number=(SELECT ph_doc_number from mt_b2b_header where id=:id and temp_code=:temp_code limit 1) 
and length(aloc_detail_3)>0 ");

$statement->execute(array(
':id'=>$id,
':temp_code'=>$temp_code
));
$data["details"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT id,
ph_cash_bank_code,
(SELECT description FROM mt_bank_list where bank_code=ph_cash_bank_code limit 1 ) bank_description,
ph_gl_account,
ph_base_doc_type,
ph_doc_number,
ph_doc_type,
ph_doc_date,
ph_currency,
ph_local_amount,
ph_cheque_number,
ph_cheque_date,
ph_other_reference,
ph_narration,
ph_status,
name,
mobile,
email,
location_id,
company_id,
created_by,
created_date 
 from mt_b2b_header where id=:id and temp_code=:temp_code limit 1 ");

$statement->execute(array(
':id'=>$id,
':temp_code'=>$temp_code
));
$data["header"]=$statement->fetchAll(PDO::FETCH_ASSOC);


$statement = $db->prepare("SELECT 
aloc_doc_number,
aloc_foreign_amount,
aloc_currency,
aloc_ex_rate,
aloc_local_amount,
aloc_narration,
aloc_detail_1,
aloc_detail_2,
(SELECT name from mt_business_partner where code=aloc_detail_3) customer,
(SELECT address from mt_bp_address where bp_id=(SELECT id from mt_business_partner where code=aloc_detail_3)) c_add1,
(SELECT address2 from mt_bp_address where bp_id=(SELECT id from mt_business_partner where code=aloc_detail_3)) c_add2,
(SELECT address3 from mt_bp_address where bp_id=(SELECT id from mt_business_partner where code=aloc_detail_3)) c_add3,
(SELECT gstin from mt_business_partner where code=aloc_detail_3) c_gstin,
(SELECT pan from mt_business_partner where code=aloc_detail_3) c_pan,
(SELECT city from mt_bp_address where bp_id=(SELECT id from mt_business_partner where code=aloc_detail_3)) c_city,
(SELECT zip from mt_bp_address where bp_id=(SELECT id from mt_business_partner where code=aloc_detail_3)) c_zip,
aloc_detail_3,
location_id,
company_id,
created_by,
created_date 
FROM mt_b2b_allocation_details 
where aloc_doc_number=(SELECT ph_doc_number from mt_b2b_header where id=:id and temp_code=:temp_code limit 1) 
");

$statement->execute(array(
':id'=>$id,
':temp_code'=>$temp_code
));
$data["details2"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  return $data;
}



public static function get_outstanding_notifywise()
{

$data=array();
try
{
$db = Factory::getConnection();

$statement = $db->prepare("SELECT *   
FROM MT_CUSTOMER_INVOICES_BY_NOTIFY ");

$statement->execute(array());
$data["info"]=$statement->fetchAll(PDO::FETCH_ASSOC);

//var_dump($statement->debugDumpParams());
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  return $data;
}


public static function get_voyage_kpis($vessel,$voyage)
{

$data=array();
try
{
$db = Factory::getConnection();

$statement = $db->prepare(" SELECT ata,atd
FROM mt_voyage
where vessel=:vessel and voyage=:voyage");
$statement->execute(array(':vessel'=>$vessel,':voyage'=>$voyage));
$data["kpi1"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare(" SELECT min(event_date) dsdate, max(event_date) dcdate FROM mt_event_updation
where event_code='EQD' and voyage=(select line_voyage from mt_voyage where voyage=:voyage limit 1)");
$statement->execute(array(':voyage'=>$voyage));
$data["kpi2"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare(" SELECT min(event_date) lsdate, max(event_date) lcdate FROM mt_event_updation 
where event_code='EQL' and voyage=:voyage ");
$statement->execute(array(':voyage'=>$voyage));
$data["kpi3"]=$statement->fetchAll(PDO::FETCH_ASSOC);


$statement = $db->prepare(" SELECT lstart lsdate, lcomplete lcdate,
dstart dsdate,dcomplete dcdate FROM mt_voyage 
where voyage=:voyage ");
$statement->execute(array(':voyage'=>$voyage));
$data["kpi4"]=$statement->fetchAll(PDO::FETCH_ASSOC);

//var_dump($statement->debugDumpParams());
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  return $data;
}

}
?>