<?php
error_reporting(E_ALL);
ini_set('display_errors', 1);

require("pdf-dao2.php");
require("number-to-word.php");
require('get-address.php');

$temp_code=$_GET["temp_code"];
$id=$_GET["id"];

function getFractionAsText($total_amt)
{
$whole = (int)$total_amt;      // 1
$fraction = $total_amt - $whole;
$fv='';

if($fraction!=0)
{
$fraction=abs(number_format($fraction,2))*100;
$fv=' AND '.strtoupper(convertNumberToWord($fraction)).' FILS ';
} 
return $fv;

}

$data=array();
if(strlen($id)!=0 and strlen($temp_code)!=0 )
{

$data=PDFDao::get_pv_info($id,$temp_code);

if(count($data["header"])==1)
{
  $d=$data["header"][0];

  $charge_details='';
  $total_amt=0;
  $display_type='PAYABLE INVOICE';

  if($d["aph_document_type"]=="CREDIT NOTE"){
  $display_type='PAYABLE CREDIT NOTE';
  }

  $water_mark='';
  if($d["aph_status"]=="CANCELLED")
  {
    $water_mark='CANCELLED';
  }
  
  for($i=0;$i<count($data["details"]);$i++)
  {

    $cd=$data["details"][$i];
    $charge_details=$charge_details.'<tr>
    <td>'.strtoupper($cd["aloc_detail_2"]).'</td>
    <td style="text-align:center">'.$cd["aloc_currency"].'</td>
    <td style="text-align:right">'.number_format(abs($cd["aloc_local_amount"]),2).'</td>
    </tr>';
    $total_amt=$total_amt+(float)$cd["aloc_local_amount"];
  }

$add2_3='';
if(strlen($d["c_add2"])!=0){
  $add2_3=$d["c_add2"].'<br>';
}
if(strlen($d["c_add3"])!=0){
  $add2_3=$add2_3.$d["c_add3"];
}


$logo=getBranchLogo($d["company_id"],$d["location_id"]);
$address=getAddress($d["company_id"],$d["location_id"]);
$company_name=getCompanyName($d["company_id"],$d["location_id"]);
$bank_detail_txt=getBankDetail($d["aph_currency"]);           
$amt_word_txt=getAmtWordTxt($d["aph_currency"],abs($total_amt)); 


$html = '
<html>
<head>
<style>
body {font-family: verdana;
  font-size: 9pt;
}

table.items2 {
  border: 0.1mm solid #ffffff;
}

table.items {
  border: 0.1mm solid #000000;
}
table.items1 {
  border: 0.1mm solid #000000;
}
.items td {
  border-left: 0.1mm solid #000000;
  border-right: 0.1mm solid #000000;
    border-bottom: 0.1mm solid #000000;
}

table thead td { background-color: #3f495c;
  text-align: center;
  border: 0.1mm solid #000000;
    color: white;
    font-weight:bold !important; 
}

td.hdr {
    font-weight:bold !important; 
}
.pghead
{
font-size: 14pt; color: #555555; font-family: verdana; vertical-align: middle;
}
.btxt {
    font-weight:bold !important; 
}
.butxt {
    font-weight:bold !important; 
    text-decoration:underline;
}
</style>
</head>
<body>

<table class="items2" width="100%" style="font-family: verdana;" cellpadding="0">
    <tr>
        <td >
            '.$address.'
        </td>
        <td >
            <span style="width: 200px">
                <img '.$logo.'>
            </span>
        </td>  
    </tr>
</table>
<table class="items2" width="100%" style="font-family: verdana;" cellpadding="0">
    <tr>
        <td align="center">
            <span style="font-size: 24pt; color: #555555; font-family: verdana; vertical-align: middle;">
               <h3 class="pghead">'.$display_type.'</h3>
            </span>
        </td>
    </tr>
</table>

<table class="items1" width="100%" style="font-family: verdana;" cellpadding="0">
        <tr>
            <td width="53%" style="vertical-align:top">
                  <table style="font-family: verdana;" cellpadding="2">
                  <tr>
                  <td width="22%" style="vertical-align:top">
                    <span class="btxt">Customer : </span>
                  </td>
                  <td width="78%" style="vertical-align:top">
                  '.$d["customer"].' <br>
                  '.$d["c_add1"].'<br> 
                  '.$add2_3.' '.$d["c_city"].' '.$d["c_zip"].'<br>
                  GSTIN:'.$d["c_gstin"].'<br>
                  PAN:'.$d["c_pan"].'
                  </td>
                  </tr>
                  </table>
            </td>
            <td style="vertical-align:top">
                  <table style="font-family: verdana;" cellpadding="2">
                  <tr>
                  <td width="45%" style="vertical-align:top">
                  <span class="btxt"> Document No. : </span>
                  </td>
                  <td style="vertical-align:top">
                  '.$d["aph_document_number"].' <span class="btxt">
                  </td> 
                  </tr>
                  <tr>
                  <td> <span class="btxt">Document Date : </span></td>
                  <td>'.$d["aph_document_date"].'</td>  
                  </tr>
                  <tr>
                  <td> <span class="btxt">Currency : </span></td>
                  <td>'.$d["aph_currency"].'</td>
                  </tr>
                  <tr>
                  <td> <span class="btxt">Narration : </span> </td>
                  <td>'.$d["aph_narration"].'</td>
                  </tr>
                  </table>  
            </td>         
        </tr>
</table>
<table class="items" style="width:100%; border-collapse: collapse; " cellpadding="5" frame="void" rules="all">
<thead>
<tr >
      <td class="bdr" width="50%">
        Description
      </td>
      <td class="bdr" width="20%">
      Currency
      </td>
     <td class="bdr" width="30%">
      Amount
      </td> 
</tr>
</thead>
'.$charge_details.'
  <tr>
    <td class="bdr" colspan="2" style="text-align: right">
    <span class="btxt">TOTAL AMOUNT ('.$d["aph_currency"].') </span>
    </td>
    <td class="bdr" style="text-align:right">
    <span class="btxt">'.number_format(abs($total_amt),2).'</span>
    </td>
  </tr>
  <tr>
    <td colspan="3" style="text-align:center"> 
    <span class="btxt">AMOUNT IN WORDS : '.$amt_word_txt.'</span>
    </td>
  </tr>
</table>

<table class="items1" width="100%" style="font-family: verdana;" cellpadding="2">
<tr>
<td>
<span class="butxt">Terms & Conditions:</span><br>
1. Payment to be made by Crossed/DD in favour of <span class="btxt">'.$company_name.'</span><br>
2. In case of any discrepancies, Please contact us within 7 days from the date of this invoice.<br>

</td>
</tr>
</table>
<table class="items1" width="100%" style="font-family: verdana;" cellpadding="0">
        <tr>
            <td width="60%" style="vertical-align:top">
                  <table style="font-family: verdana;" cellpadding="2">
                  <tr>
                  <td colspan="2" style="vertical-align:top">
                    <span class="butxt">Bank Account Details:</span>
                  </td>
                  </tr>
                  '.$bank_detail_txt.'

                  </table>
            </td>
            <td style="vertical-align:bottom" align="right" >
                  <table style="font-family: verdana;" cellpadding="2">
                  <tr>
                  <td align="right" style="vertical-align:top">
                  <span class="btxt"> For '.$company_name.'</span>
                  <br>
                  <br>
                  <br>
                  <br>
                  <br>
                  <br>
                  <br>
                  
                  </td>
                  </tr>
                  </table>  
            </td>         
        </tr>
</table>
<table class="items1" width="100%" style="font-family: verdana;" cellpadding="0">
        <tr>
        <td align="center">This is a Computer Generated Invoice. No Signature is required.</td>
        </tr>
</table>


</body>
</html>
';
 
require_once 'vendor/autoload.php';
$mpdf = new \Mpdf\Mpdf([
  'margin_left' => 10,
  'margin_right' => 10,
  'margin_top' => 10,
  'margin_bottom' => 10, 
  'margin_header' => 5,
  'margin_footer' => 5,
  'tempDir' => 'tmp'
]);


//invalid input chars
$mpdf->allow_charset_conversion=true;
$mpdf->charset_in='UTF-8';
$html=mb_convert_encoding($html, 'UTF-8', 'UTF-8');

//
$mpdf->shrink_tables_to_fit = 1;
$mpdf->SetProtection(array('print','copy'));
$mpdf->SetTitle($display_type);
$mpdf->SetAuthor("");
$mpdf->SetWatermarkText($water_mark);
$mpdf->showWatermarkText = true;
$mpdf->watermark_font = 'DejaVuSansCondensed';
$mpdf->watermarkTextAlpha = 0.1;
$mpdf->SetDisplayMode('fullpage');
$mpdf->WriteHTML($html);
$mpdf->Output();

}else{
  echo "Invalid credentials........";
}

}
else{
  echo "Please enter valid credentials.....";
}

?>
