<?php


require("../config/dbconn.php");

class TDSReportDao

{



public static function save_page_views($dev,$pname,$method)
{
$data=0;
try
{
$db = Factory::getConnection();


$statement = $db->prepare("INSERT into page_views(
ip ,uid ,ua,ekey,esecret,method,page,tz) 
values(:ip ,:uid ,
:ua ,:ekey ,:esecret ,:method ,:page,:tz)");
$statement->execute(array(':ip'=>$dev->ip,':uid'=>$dev->uid ,
':ua'=>$dev->ua,
':tz'=>$dev->tz ,
':method'=>$method ,':esecret'=>$dev->esecret,':ekey'=>$dev->ekey,
':page'=>$pname));


$data=1;
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

//TDS PAYABLE
public static function get_output_tds_report($dev,$from_date,$to_date,$username)
{
$data=array();
try
{
$db = Factory::getConnection();

//Get Location
$statement = $db->prepare("SELECT location from user_master
where username=:username ");
$statement->execute(array(':username'=>$username));
$data["location"]=$statement->fetchAll(PDO::FETCH_ASSOC);
$location_id=$data["location"][0]["location"];

$statement = $db->prepare("CREATE TEMPORARY TABLE input_tds as SELECT pre_glt_doc_number,pre_glt_doc_date,pre_glt_local_amount,pre_glt_narration 
  FROM mt_receipt_gl_details t1 WHERE location_id=:location_id and pre_glt_code LIKE '1-10-004-0004' and pre_glt_status IS NULL and pre_glt_gl_date BETWEEN :from_date and :to_date");

$data["tds_created"]=$statement->execute(array(':from_date'=>$from_date, 
  ':to_date'=>$to_date,':location_id'=>$location_id));


$statement = $db->prepare("CREATE TEMPORARY TABLE input_tds_wc as SELECT pre_glt_doc_number,pre_glt_detail_3,pre_glt_local_amount FROM `mt_receipt_gl_details` t1 WHERE pre_glt_status IS NULL and location_id=:location_id and pre_glt_detail_2='ACCOUNTS RECEIVABLE' and pre_glt_gl_date BETWEEN :from_date and :to_date");

$data["tds_created2"]=$statement->execute(array(':from_date'=>$from_date, 
  ':to_date'=>$to_date,':location_id'=>$location_id));

$statement = $db->prepare("CREATE TEMPORARY TABLE fin_tds as SELECT t1.pre_glt_doc_number,t1.pre_glt_doc_date,t1.pre_glt_local_amount,t1.pre_glt_narration,t2.pre_glt_detail_3 FROM input_tds t1,input_tds_wc t2 WHERE t1.pre_glt_doc_number=t2.pre_glt_doc_number and abs(t1.pre_glt_local_amount)=abs(t2.pre_glt_local_amount)");
$data["tds_created2"]=$statement->execute();

$statement=$db->prepare("SELECT @rownum := 0;");
$statement->execute();

$statement=$db->prepare("SELECT @rownum+1 sno,pre_glt_doc_number doc_no,pre_glt_doc_date doc_date,abs(pre_glt_local_amount) lamt,(SELECT round(sum(abs(aloc_local_amount)),2) total_amt FROM `mt_receipt_allocation_details` WHERE aloc_doc_number=pre_glt_doc_number and aloc_detail_2='ACCOUNTS RECEIVABLE') total_amt,pre_glt_narration narration,pre_glt_detail_3 party_code,name,pan,gstin FROM fin_tds t1,mt_business_partner t2 WHERE t1.pre_glt_detail_3=t2.code");
$statement->execute();
$data["dList"]=$statement->fetchAll(PDO::FETCH_ASSOC);
  
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_input_tds_report($dev,$from_date,$to_date,$username)
{
$data=array();
try
{
$db = Factory::getConnection();

//Get Location
$statement = $db->prepare("SELECT location from user_master
where username=:username ");
$statement->execute(array(':username'=>$username));
$data["location"]=$statement->fetchAll(PDO::FETCH_ASSOC);
$location_id=$data["location"][0]["location"];

$statement = $db->prepare("CREATE TEMPORARY TABLE input_tds as SELECT pre_glt_doc_number,pre_glt_doc_date,pre_glt_local_amount,pre_glt_narration 
  FROM mt_payment_gl_details t1 WHERE location_id=:location_id and pre_glt_code LIKE '2-10-001-0006' and pre_glt_gl_date BETWEEN :from_date and :to_date");

$data["tds_created"]=$statement->execute(array(':from_date'=>$from_date, 
  ':to_date'=>$to_date,':location_id'=>$location_id));


$statement = $db->prepare("CREATE TEMPORARY TABLE input_tds_wc as SELECT pre_glt_doc_number,pre_glt_detail_3,pre_glt_local_amount FROM `mt_payment_gl_details` t1 WHERE location_id=:location_id and pre_glt_detail_2='ACCOUNTS PAYABLE' and pre_glt_gl_date BETWEEN :from_date and :to_date");

$data["tds_created2"]=$statement->execute(array(':from_date'=>$from_date, 
  ':to_date'=>$to_date,':location_id'=>$location_id));

$statement = $db->prepare("CREATE TEMPORARY TABLE fin_tds as SELECT t1.pre_glt_doc_number,t1.pre_glt_doc_date,t1.pre_glt_local_amount,t1.pre_glt_narration,t2.pre_glt_detail_3 FROM input_tds t1,input_tds_wc t2 WHERE t1.pre_glt_doc_number=t2.pre_glt_doc_number and abs(t1.pre_glt_local_amount)=abs(t2.pre_glt_local_amount)");
$data["tds_created2"]=$statement->execute();

$statement=$db->prepare("SELECT @rownum := 0;");
$statement->execute();

$statement=$db->prepare("SELECT @rownum+1 sno,pre_glt_doc_number doc_no,pre_glt_doc_date doc_date,abs(pre_glt_local_amount) lamt,pre_glt_narration narration,pre_glt_detail_3 party_code,name,pan,gstin FROM fin_tds t1,mt_business_partner t2 WHERE t1.pre_glt_detail_3=t2.code");
$statement->execute();
$data["dList"]=$statement->fetchAll(PDO::FETCH_ASSOC);
  
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

}
?>