<?php


require("../config/dbconn.php");
require('../booking/get-currency.php');
require("func-list.php");
require("insert-gst.php");


class LinerAccountingDao

{


public static function save_page_views($dev,$pname,$method)
{
$data=0;
try
{
$db = Factory::getConnection();


$statement = $db->prepare("INSERT into page_views(
ip ,uid ,ua,ekey,esecret,method,page,tz) 
values(:ip ,:uid ,
:ua ,:ekey ,:esecret ,:method ,:page,:tz)");
$statement->execute(array(':ip'=>$dev->ip,':uid'=>$dev->uid ,
':ua'=>$dev->ua,
':tz'=>$dev->tz ,
':method'=>$method ,':esecret'=>$dev->esecret,':ekey'=>$dev->ekey,
':page'=>$pname));

$data=1;
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

//GET LPO RAISED
public static function get_lpo_raised($order_no,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

//check sea freight there or not
//FRT-S
if (strpos($c, 'FRT-S')) {
//found frt-s
//check for cost and lpo raised
  $statement = $db->prepare("SELECT count(*) lc FROM mt_order_cost 
  WHERE order_id in (SELECT id from mt_order_entry where order_no 
  in ($order_no)) and type='COST' and inv_pay_no is not null 
  and charge_desc in ('FRT-S')");

$statement->execute();

$data["fcheck"]=$statement->fetchAll(PDO::FETCH_ASSOC);

if($data["fcheck"][0]["lc"]==0)
{
  $data["status"]=0;
  $data["msg"]="Please raise LPO for Sea Freight first. Then try to invoice.";
}else{
  //check charges have cost and lpo raised

$statement = $db->prepare("SELECT count(*) lc FROM mt_order_cost 
  WHERE order_id in (SELECT id from mt_order_entry where order_no 
  in ($order_no)) and type='COST' and inv_pay_no is null 
  and charge_desc in ($c)");

$statement->execute();

$data["lc"]=$statement->fetchAll(PDO::FETCH_ASSOC);
  if($data["lc"][0]["lc"]>=1)
{
$data["status"]=0;
$data["msg"]="Please raise LPO first. Then try to invoice.";

}else{
$data["status"]=1;  
}


}

}else{
  //check charges have cost and lpo raised
  $statement = $db->prepare("SELECT count(*) lc FROM mt_order_cost 
  WHERE order_id in (SELECT id from mt_order_entry where order_no 
  in ($order_no)) and type='COST' and inv_pay_no is null 
  and charge_desc in ($c)");

$statement->execute();

$data["lc2"]=$statement->fetchAll(PDO::FETCH_ASSOC);

 if($data["lc2"][0]["lc"]>=1)
{
$data["status"]=0;
$data["msg"]="Please raise LPO first. Then try to invoice.";

}else{
$data["status"]=1;  
}

}

/*
if ($statement->rowCount()){
  $data["status"]=1;
   
} else{
  $data["status"]=0;
}
*/

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function getUniqueString($src)
{
$sv=explode(',',$src);
$uv=array_unique($sv);
return implode(',',$uv);
}

public static function save_invoice_printdesc($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$temp_code=uniqid($dev->uid);

$statement = $db->prepare("INSERT into mt_invoice_printdescriptions(
 invoice_no, description, qty, rate,  
ip,created_by ,ua,ekey,created_date,temp_code) 
values(
:invoice_no, :description, :qty, :rate,
:ip ,:created_by , :ua ,:ekey,now(),:temp_code)");

$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->uid ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,

':description'=>$c->description,
':qty'=>$c->qty,
':rate'=>$c->rate,

':invoice_no'=>$c->invoice_no,
':temp_code'=>$temp_code
));

if ($statement->rowCount()){
  $data["status"]=1;
} else{
  $data["status"]=0;
}

$statement = $db->prepare("SELECT id from mt_invoice_printdescriptions where created_by=:uid and temp_code=:temp_code and invoice_no=:invoice_no");
$statement->execute(array(':temp_code'=>$temp_code,
  ':uid'=>$dev->uid,':invoice_no'=>$c->invoice_no));
$data["id"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}



public static function update_order_reopen_status($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$statement = $db->prepare("UPDATE mt_order_entry SET 
 status='OPEN',
 re_open_date=:rdate,
 re_open_by=:rby,
 re_open_reason=:reason
 where id=:id
  ");

$statement->execute(array(
  ':id'=>$c->id,
  ':rdate'=>$c->re_open_date ,
':rby'=>$c->re_open_by,
':reason'=>$c->re_open_reason

));

if ($statement->rowCount()){
  $data["status"]=1;
   
} else{
  $data["status"]=0;
}


$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function update_invoice_printdesc($dev,$c)
{
$data=array();
try
{
$db = Factory::getConnection();

$statement = $db->prepare("UPDATE mt_invoice_printdescriptions SET 
 
  description=:description,
qty=:qty,
rate=:rate,
  ip=:ip,created_by=:created_by,ua=:ua,ekey=:ekey,created_date= now() where id=:id and invoice_no=:invoice_no
  ");

$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->uid ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,

':description'=>$c->description,
':qty'=>$c->qty,
':rate'=>$c->rate,

':invoice_no'=>$c->invoice_no,
':id'=>$c->id
));

if ($statement->rowCount()){
  $data["status"]=1;
   
} else{
  $data["status"]=0;
}


$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function delete_invoice_printdesc($c)
{
$data=array();
try
{
$db = Factory::getConnection();


$statement = $db->prepare("DELETE FROM mt_invoice_printdescriptions 
  where id=:id");

$statement->execute(array(':id'=>$c));

if ($statement->rowCount()){
  $data["status"]=1;
    
} else{
  $data["status"]=0;
}


$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function get_voyage_summary_list($code) 
{
$data=false;
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT 
t1.id,
t1.voyage,
t1.bl_no,
t1.cargo_type,
(select party_name from mt_manifest_entry_party where party_type='CONSIGNEE' and mnf_entry_pk=t1.id) consignee, 
(select sum(cost_base_amount) from mt_manifest_entry_rate where type='INCOME' and mnf_entry_pk=t1.id) income,
(select sum(cost_base_amount) from mt_manifest_entry_rate where type='COST' and mnf_entry_pk=t1.id) cost,
t1.order_no,
(select status from mt_order_entry where order_no=t1.order_no limit 1) estatus,
t2.poo,
t2.pol,
t2.pod,
t2.pof,
(select party_name from mt_manifest_entry_party where party_type='NOTIFY PARTY' and mnf_entry_pk=t1.id) notify,
t1.manifest_type,
t1.bl_classification,
t1.shipment_terms,
t1.bl_date,
t1.to_order,
t1.master_bl_no,
t1.created_date,
t1.created_by,
t1.modified_by,
t1.modified_date 
  from mt_manifest_entry t1 LEFT JOIN mt_manifest_entry_route t2  ON (t1.manifest_type in('AGENCY IMPORT','SEA IMPORT')   and t1.id=t2.mnf_entry_pk ) 
  order by created_date desc limit :sta,100");
$statement->bindValue(':sta',(int) $code, PDO::PARAM_INT);
$statement->execute();
$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}



public static function get_delivery_order_info($code)
{

$data=array();
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT 
id,do_no,order_no,bl_no,poo,pol,pod,pof,shipper,consignee,notify,do_party,do_takenby,do_paidby,endorsement_party,do_date,do_validity_date,remarks,narration,
  temp_code,total,advance_do,auto_invoice from mt_delivery_order t1 where id=:id");
/*
,
  (SELECT inv_pay_no from mt_order_cost where order_id =(select id from mt_order_entry where order_no=t1.order_no) limit 1) inv
*/
$statement->execute(array(':id'=>$code));

$data["info"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT 
id,do_pk,payment_mode,bank_code,bank_name,credit_cheque_no,card_cheque_expiry_date,currency,foreign_amount,local_amount,cheque_clear_date,notes, '0' edit 
from mt_delivery_order_payment where do_pk=:do_pk");
$statement->execute(array(':do_pk'=>$code));
$data["pay"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_inv_no($code)
{

$data=false;
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT inv_pay_no from mt_order_cost 
  where order_id =(select id from mt_order_entry 
  where order_no=:order_no) and charge_desc='DOF'");

$statement->execute(array(':order_no'=>$code));
$data=$statement->fetchAll(PDO::FETCH_ASSOC);
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_delivery_order_search_list($code)
{

$data=array();
try
{
$db = Factory::getConnection();

 $q="";
$ar=array();

if(strlen($code->bl_no)!=0)
{
$q=$q." and t1.bl_no=:bl_no ";
$ar[':bl_no']=$code->bl_no;

}

if(strlen($code->order_no)!=0)
{
$q=$q."  and t1.order_no=:order_no ";
$ar[':order_no']=$code->order_no;
}

if(strlen($code->voyage)!=0)
{
$q=$q."  and t1.voyage=:voyage ";
$ar[':voyage']=$code->voyage;

}
/*
if(strlen($code->customer)!=0)
{
$q=$q."  and t1.consignee=:consignee ";
$ar[':consignee']=$code->customer;

}
*/
$statement = $db->prepare("SELECT '' selected,
  t1.order_no,t1.bl_no,t2.poo,t2.pol,t2.pod,t2.pof,
(select party_name from mt_manifest_entry_party where party_type='SHIPPER' and mnf_entry_pk=t1.id) shipper,
(select party_name from mt_manifest_entry_party where party_type='CONSIGNEE' and mnf_entry_pk=t1.id) consignee, 
(select party_name from mt_manifest_entry_party where party_type='NOTIFY PARTY' and mnf_entry_pk=t1.id) notify,
t1.manifest_type,
t2.vessel,
t2.voyage,
t1.status,
t2.eline,
t2.port 
 from mt_manifest_entry t1, mt_manifest_entry_route t2 where t1.id=t2.mnf_entry_pk  and 1=(select 1 from mt_order_entry where order_no=t1.order_no and do_status='UNFREEZE') ".$q);

$statement->execute($ar);
$data["orders"]=$statement->fetchAll(PDO::FETCH_ASSOC);
$advance_do="";
if($code->advance_do==true)
{
  $advance_do=" and charge_desc='DOF' ";
}

if(strlen($code->customer)!=0)
{
$cusq=explode("|",$code->customer)[0];
if(strlen($advance_do)>0)
{
$advance_do=" and billing_party='$cusq' ";
}else{
$advance_do=" billing_party='$cusq' ";

}

}


if(count($data["orders"])>=1)
{
$order_no=$data["orders"][0]["order_no"];
//echo $advance_do."----".$order_no;

$statement = $db->prepare("SELECT sum(selling_base_amount) local_amount from mt_order_cost where ( invoiced is null) and type='INCOME' and order_id=(SELECT id from mt_order_entry where order_no=:order_no and do_status='UNFREEZE') $advance_do");
$statement->execute(array(':order_no'=>$order_no));
$data["order_cost"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT id,charge_desc,selling_base_amount,qty from mt_order_cost where (invoiced is null) and type='INCOME' and order_id=(SELECT id from mt_order_entry where order_no=:order_no and do_status='UNFREEZE') $advance_do");
$statement->execute(array(':order_no'=>$order_no));
$data["charges_list"]=$statement->fetchAll(PDO::FETCH_ASSOC);

}
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function get_delivery_order_list($dev,$code)
{

$data=false;
try
{
$db = Factory::getConnection();
$aq=Factory::getRestrictionQuery($dev);
$statement = $db->prepare("SELECT t1.id,t1.do_no,t1.order_no,t1.bl_no, t1.poo,t1.pol,t1.pod,t1.pof,t1.do_date,t1.do_validity_date, (select sum(local_amount) from mt_delivery_order_payment where do_pk=t1.id) do_amount, shipper,consignee,notify,created_by, created_date from mt_delivery_order t1 where $aq order by id desc limit :sta,50");
  
$statement->bindValue(':sta',(int) $code, PDO::PARAM_INT); 
$statement->execute();

$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function search_delivery_order_list($v)
{

$data=false;
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT t1.id,t1.do_no,t1.order_no,t1.bl_no, t1.poo,t1.pol,t1.pod,t1.pof,t1.do_date,t1.do_validity_date, (select sum(local_amount) from mt_delivery_order_payment where do_pk=t1.id) do_amount, shipper,consignee,notify,created_by, created_date from mt_delivery_order t1 
  where t1.do_no like ? or order_no like ? or bl_no like ? or 
  pol like ? or 
  pod like ? or 
  consignee like ? order by id limit 50");

$statement ->bindValue(1, "%$v%", PDO::PARAM_STR);
$statement ->bindValue(2, "%$v%", PDO::PARAM_STR);
$statement ->bindValue(3, "%$v%", PDO::PARAM_STR);
$statement ->bindValue(4, "%$v%", PDO::PARAM_STR);
$statement ->bindValue(5, "%$v%", PDO::PARAM_STR);
$statement ->bindValue(6, "%$v%", PDO::PARAM_STR);


$statement->execute();

$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function search_order_list($v)
{

$data=false;
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT t1.id,t1.order_no,t1.order_type,t1.customer,t1.status,t1.expected_date, t1.order_executive, t1.shipment_from, t1.shipment_to, t1.bl_no, t1.cargo_type, (select count(container_no) from  mt_order_container_detail where order_id=t1.id) units, t3.provider, t3.transport_reference, (select sum(selling_base_amount) from mt_order_cost where order_id=t1.id) tot_revenue,t1.created_by,t1.created_date,
t1.modified_date,t1.modified_by 
  from mt_order_entry t1 
  LEFT JOIN
  ( SELECT order_id, GROUP_CONCAT(provider) provider,
  GROUP_CONCAT(transport_reference) transport_reference FROM mt_order_route GROUP BY order_id) t3
  ON t1.id=t3.order_id
  WHERE to_invoice=1 and (order_no like ? or customer like ? or status like ? or order_type like ?) 
   order by t1.id desc limit 50");

$statement ->bindValue(1, "%$v%", PDO::PARAM_STR);
$statement ->bindValue(2, "%$v%", PDO::PARAM_STR);
$statement ->bindValue(3, "%$v%", PDO::PARAM_STR);
$statement ->bindValue(4, "%$v%", PDO::PARAM_STR);


$statement->execute();

$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function get_unbilled_invoice_list($code)
{ 

$data=false;
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT t1.id,t1.order_no,t1.order_type,t1.customer,t1.status,t1.expected_date, t1.order_executive, t1.shipment_from, t1.shipment_to, t1.bl_no, t1.cargo_type, (select count(container_no) from  mt_order_container_detail where order_id=t1.id) units, t3.provider, t3.transport_reference, (select sum(selling_base_amount) from mt_order_cost where order_id=t1.id) tot_revenue,t1.created_by,t1.created_date,
t1.modified_date,t1.modified_by   
  from mt_order_entry t1 LEFT JOIN
  ( SELECT order_id, GROUP_CONCAT(provider) provider,
  GROUP_CONCAT(transport_reference) transport_reference FROM mt_order_route GROUP BY order_id) t3
  ON t1.id=t3.order_id where t1.to_invoice=1 and t1.status !='CLOSED' 
  order by t1.id desc limit :sta,100");
$statement->bindValue(':sta',(int) $code->start, PDO::PARAM_INT); 
$statement->execute();
$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_doc_type_list($code)
{

$data=false;
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT id,code, description from mt_document_type order by id");

$statement->execute();
$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_invoice_entry_info_forward($dev,$code)
{

$data=array();
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT id,sub_ar_doc_type,sub_ar_doc_number,sub_ar_doc_base,sub_ar_gl_date,sub_ar_due_date,sub_ar_date,sub_ar_other_reference,sub_ar_currency,sub_ar_ex_rate,sub_place_off_supply,sub_place_off_supply_date,sub_ar_narration,sub_ar_notes,sub_ar_code,sub_ar_status, 
  sub_ar_other_reference_date,temp_code,total_local_amt,order_no,gst_percent,charge_type from mt_order_ar_header where id=:id");

$statement->execute(array(':id'=>$code));

$data["info"]=$statement->fetchAll(PDO::FETCH_ASSOC);


$statement = $db->prepare("SELECT sub_ard_company,sub_ard_doc_type,sub_ard_doc_number,sub_ard_serial,
  sub_ard_currency currency,
  sub_ard_ex_rate ex_rate,
  sub_ard_foreign_amount,
  sub_ard_local_amount net_amt,
  sub_ard_narration remarks,sub_ard_notes,
  sub_ard_detail_1 order_no,
  sub_ard_detail_2 order_date,
  sub_ard_detail_3 order_type,
  sub_ard_detail_4 bl_no,
  sub_ard_detail_5 customer,sub_ard_detail_6,
  sub_ard_basis basis_uom,
  sub_ard_rate selling_amount,
  sub_ard_quantity qty,
  charge_desc,basis_type,taxable,total_tax_amt,total_amt,
  inv_status from mt_order_ar_details 
  where sub_ard_doc_number=(SELECT sub_ar_doc_number from mt_order_ar_header where id=:id 
  and sub_ard_detail_6 !='ADDITIONAL')");

$statement->execute(array(':id'=>$code));

$data["charge"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT sub_ard_company,sub_ard_doc_type,sub_ard_doc_number,sub_ard_serial,
  sub_ard_currency currency,
  sub_ard_ex_rate ex_rate,
  sub_ard_foreign_amount,
  sub_ard_local_amount net_amt,
  sub_ard_narration remarks,sub_ard_notes,
  sub_ard_detail_1 order_no,
  sub_ard_detail_2 order_date,
  sub_ard_detail_3 order_type,
  sub_ard_detail_4 bl_no,
  sub_ard_detail_5 customer,sub_ard_detail_6,
  sub_ard_basis basis_uom,
  sub_ard_rate selling_amount,
  sub_ard_quantity qty,
  charge_desc,basis_type,taxable,total_tax_amt,total_amt,
  inv_status,'0' edit,id from mt_order_ar_details 
  where sub_ard_doc_number=(SELECT sub_ar_doc_number from mt_order_ar_header where id=:id 
  and sub_ard_detail_6 ='ADDITIONAL')");

$statement->execute(array(':id'=>$code));

$data["add_charge"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT 
id,invoice_no, description, qty, rate, '0' edit   
 from mt_invoice_printdescriptions 
where invoice_no=(SELECT sub_ar_doc_number from mt_order_ar_header where id=:id)");

$statement->execute(array(':id'=>$code));

$data["printdesc"]=$statement->fetchAll(PDO::FETCH_ASSOC);

//FETCH USER RIGHTS
$view_type="";

$statement = $db->prepare(" SELECT view_type FROM user_master 
WHERE username=:username ");
$statement->execute(array(':username'=>$dev->username));
$op=$statement->fetchAll(PDO::FETCH_ASSOC);

$view_type=$op[0]["view_type"];
$data["view_type"]=$view_type;

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_invoice_entry_info($dev,$code)
{

$data=array();
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT id,sub_ar_doc_type,sub_ar_doc_number,sub_ar_doc_base,sub_ar_gl_date,sub_ar_due_date,sub_ar_date,sub_ar_other_reference,sub_ar_currency,sub_ar_ex_rate,sub_place_off_supply,sub_place_off_supply_date,sub_ar_narration,sub_ar_notes,sub_ar_code,sub_ar_status, 
  sub_ar_other_reference_date,temp_code,total_local_amt,order_no from mt_ship_ar_header where id=:id");

$statement->execute(array(':id'=>$code));

$data["info"]=$statement->fetchAll(PDO::FETCH_ASSOC);


$statement = $db->prepare("SELECT sub_ard_company,sub_ard_doc_type,sub_ard_doc_number,sub_ard_serial,
  sub_ard_currency currency,
  sub_ard_ex_rate ex_rate,
  sub_ard_foreign_amount,
  sub_ard_local_amount net_amt,
  sub_ard_narration remarks,sub_ard_notes,
  sub_ard_detail_1 order_no,
  sub_ard_detail_2 order_date,
  sub_ard_detail_3 order_type,
  sub_ard_detail_4 bl_no,
  sub_ard_detail_5 customer,sub_ard_detail_6,
  sub_ard_basis basis_uom,
  sub_ard_rate selling_amount,
  sub_ard_quantity qty,
  charge_desc,basis_type,taxable,total_tax_amt,total_amt,
  inv_status from mt_ship_ar_details 
  where sub_ard_doc_number=(SELECT sub_ar_doc_number from mt_ship_ar_header where id=:id 
  and sub_ard_detail_6 !='ADDITIONAL')");

$statement->execute(array(':id'=>$code));

$data["charge"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT sub_ard_company,sub_ard_doc_type,sub_ard_doc_number,sub_ard_serial,
  sub_ard_currency currency,
  sub_ard_ex_rate ex_rate,
  sub_ard_foreign_amount,
  sub_ard_local_amount net_amt,
  sub_ard_narration remarks,sub_ard_notes,
  sub_ard_detail_1 order_no,
  sub_ard_detail_2 order_date,
  sub_ard_detail_3 order_type,
  sub_ard_detail_4 bl_no,
  sub_ard_detail_5 customer,sub_ard_detail_6,
  sub_ard_basis basis_uom,
  sub_ard_rate selling_amount,
  sub_ard_quantity qty,
  charge_desc,basis_type,taxable,total_tax_amt,total_amt,
  inv_status,'0' edit,id from mt_ship_ar_details 
  where sub_ard_doc_number=(SELECT sub_ar_doc_number from mt_ship_ar_header where id=:id 
  and sub_ard_detail_6 ='ADDITIONAL')");

$statement->execute(array(':id'=>$code));

$data["add_charge"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement = $db->prepare("SELECT 
id,invoice_no, description, qty, rate, '0' edit   
 from mt_invoice_printdescriptions 
where invoice_no=(SELECT sub_ar_doc_number from mt_ship_ar_header where id=:id)");

$statement->execute(array(':id'=>$code));

$data["printdesc"]=$statement->fetchAll(PDO::FETCH_ASSOC);

//FETCH USER RIGHTS
$view_type="";

$statement = $db->prepare(" SELECT view_type FROM user_master 
WHERE username=:username ");
$statement->execute(array(':username'=>$dev->username));
$op=$statement->fetchAll(PDO::FETCH_ASSOC);

$view_type=$op[0]["view_type"];
$data["view_type"]=$view_type;

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function get_invoice_cancelled_list($dev,$code)
{

$data=false;
try
{
$db = Factory::getConnection();
$dev=get_user_data($db,$dev);

$aq=Factory::getRestrictionQuery($dev);
$statement = $db->prepare("
SELECT 'green' bg,'forward' inv_type,t1.id,t1.sub_ar_doc_type doc_type, t1.sub_ar_doc_number doc_no,(SELECT name from mt_business_partner where code=t1.sub_ar_code limit 1)  customer,
    t1.sub_ar_code customer_code,
  (SELECT GROUP_CONCAT(DISTINCT sub_ard_detail_1 SEPARATOR ', ') 
  from mt_order_ar_details 
  where sub_ard_doc_number=t1.sub_ar_doc_number)  order_no,
    (SELECT GROUP_CONCAT(DISTINCT sub_ard_detail_4 SEPARATOR ', ') 
  from mt_order_ar_details 
  where sub_ard_doc_number=t1.sub_ar_doc_number)  bl_no,
  t1.sub_ar_date doc_date, t1.sub_ar_gl_date gl_date, t1.sub_ar_other_reference reference, t1.sub_ar_currency currency, t1.sub_ar_l_amount local_amount, t1.sub_ar_status estatus,t1.created_date,
  created_by,modified_date,modified_by from mt_order_ar_header t1 
  where $aq and sub_ar_status='CANCELLED'
  order by id desc limit :sta,50
  ");





$statement->bindValue(':sta',(int) $code, PDO::PARAM_INT); 
$statement->execute();

$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

public static function get_invoice_entry_list($dev,$code)
{

$data=false;
try
{
$db = Factory::getConnection();
$dev=get_user_data($db,$dev);

$aq=Factory::getRestrictionQuery($dev);
$statement = $db->prepare("SELECT * FROM (

  (SELECT 'red' bg, '' inv_type,id,''  doc_type,'TO BE BILLED' doc_no,
    (SELECT name from mt_business_partner where code=customer limit 1) customer, 
    customer customer_code,
    order_no, bl_no,
  expected_date doc_date, '' gl_date, order_type reference, '' currency, '' local_amount, 
   case when status ='P' then
    'POSTED'
    else
      status 
    end as estatus,
  created_date,created_by,modified_date,modified_by 
  from mt_order_entry 
  where $aq and id in (select order_id from mt_order_cost 
  where invoiced is null and type='INCOME') 
  and to_invoice=1 order by id desc limit :sta,50) 

  UNION 

  (SELECT 'green' bg,'agency' inv_type,t1.id,t1.sub_ar_doc_type doc_type, t1.sub_ar_doc_number doc_no,(SELECT name from mt_business_partner where code=t1.sub_ar_code limit 1)   customer,
    t1.sub_ar_code customer_code,
  ifnull(order_no,
  (SELECT GROUP_CONCAT(DISTINCT sub_ard_detail_1 SEPARATOR ', ') 
  from mt_ship_ar_details 
  where sub_ard_doc_number=t1.sub_ar_doc_number))  order_no,
   IFNULL(bl_no,(SELECT GROUP_CONCAT(DISTINCT sub_ard_detail_4 SEPARATOR ', ') 
  from mt_ship_ar_details 
  where sub_ard_doc_number=t1.sub_ar_doc_number))  bl_no,
  t1.sub_ar_date doc_date, t1.sub_ar_gl_date gl_date, t1.sub_ar_other_reference reference, t1.sub_ar_currency currency, t1.sub_ar_l_amount local_amount, 
  case when t1.sub_ar_status ='P' then
  'POSTED'
  else
    t1.sub_ar_status  
  end as estatus,
  t1.created_date,created_by,modified_date,modified_by from mt_ship_ar_header t1 where $aq 
  order by id desc limit :sta,50)

  UNION 
  
  (SELECT 'green' bg,'forward' inv_type,t1.id,t1.sub_ar_doc_type doc_type, t1.sub_ar_doc_number doc_no,(SELECT name from mt_business_partner where code=t1.sub_ar_code limit 1)  customer,
    t1.sub_ar_code customer_code,
  (SELECT GROUP_CONCAT(DISTINCT sub_ard_detail_1 SEPARATOR ', ') 
  from mt_order_ar_details 
  where sub_ard_doc_number=t1.sub_ar_doc_number)  order_no,
    (SELECT GROUP_CONCAT(DISTINCT sub_ard_detail_4 SEPARATOR ', ') 
  from mt_order_ar_details 
  where sub_ard_doc_number=t1.sub_ar_doc_number)  bl_no,
  t1.sub_ar_date doc_date, t1.sub_ar_gl_date gl_date, t1.sub_ar_other_reference reference, t1.sub_ar_currency currency, t1.sub_ar_l_amount local_amount, 
  case when t1.sub_ar_status ='P' then
  'POSTED'
  else
    t1.sub_ar_status  
  end as estatus,
  t1.created_date,
  created_by,modified_date,modified_by from mt_order_ar_header t1 
  where $aq and sub_ar_status!='CANCELLED'
  order by id desc limit :sta,50)
  ) t1 order by created_date desc
  ");





$statement->bindValue(':sta',(int) $code, PDO::PARAM_INT); 
$statement->execute();

$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function search_orders($code)
{

$data=array();
try
{
$db = Factory::getConnection();

$q="";
$ar=array();

if(strlen($code->btype)!=0)
{
$q=$q." and t1.order_type=:order_type ";
$ar[':order_type']=$code->btype;
}

if(strlen($code->from_date)!=0)
{
$q=$q." and t1.expected_date>=:expected_date1 ";
$ar[':expected_date1']=$code->from_date;
}

if(strlen($code->to_date)!=0)
{
$q=$q." and t1.expected_date<=:expected_date2 ";
$ar[':expected_date2']=$code->to_date;
}

if(strlen($code->bl_no)!=0)
{
$q=$q." and t1.bl_no=:bl_no ";
$ar[':bl_no']=$code->bl_no;
}

if(strlen($code->order_no)!=0)
{
$q=$q." and t1.order_no=:order_no ";
$ar[':order_no']=$code->order_no;
}
$cq="";
if(strlen($code->customer)!=0)
{
$cq=" and (billing_party=:customer or billing_party=(SELECT code FROM mt_business_partner WHERE name=:customer limit 1)) ";
$ar[":customer"]=$code->customer;

}

$statement = $db->prepare("SELECT '' selected,t1.id,t1.order_type,t1.order_no,t1.expected_date,
t1.customer,t1.bl_no,t1.shipment_from,t1.shipment_to,'' grp,'' parcel_detail,t1.status,
t4.liner,
t4.port,
t4.import_start_calc_date,
t4.voyage,
t4.vessel  
 from mt_order_entry t1 LEFT JOIN (SELECT t3.liner,
t3.port,
t3.import_start_calc_date,
t2.voyage,
t3.vessel,t2.bl_no from mt_manifest_entry t2 ,mt_voyage t3 where t2.voyage=t3.voyage) t4 ON t1.bl_no=t4.bl_no 
  WHERE to_invoice=1 and id in (SELECT distinct order_id from mt_order_cost where 
    type='INCOME' $cq) and 
  t1.status in ('OPEN','PART INVOICED','INVOICED') ".$q);
$statement->execute($ar);
$data["order"]=$statement->fetchAll(PDO::FETCH_ASSOC);

//CHECK IF JOB IS READY FOR INVOICING 
$statement = $db->prepare("SELECT *    
from mt_order_entry t1
where order_no=:order_no and to_invoice=1 ");
$statement->execute(array(':order_no'=>$code->order_no));
$data["order_invoice_ready"]=$statement->fetchAll(PDO::FETCH_ASSOC);
$olen=count($data["order_invoice_ready"]);

if($olen==0)
{
  $data["status"]=3;
  $data["msg"]="Job ".$code->order_no." is NOT READY for Invoicing. Please click Send To Invoice for this Job.";
}


$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function search_orders_copy_old($code)
{

$data=array();
try
{
$db = Factory::getConnection();

$q="";
$ar=array();

if(strlen($code->btype)!=0)
{
$q=$q." and t1.order_type=:order_type ";
$ar[':order_type']=$code->btype;
}

if(strlen($code->from_date)!=0)
{
$q=$q." and t1.expected_date>=:expected_date ";
$ar[':expected_date']=$code->from_date;
}

if(strlen($code->to_date)!=0)
{
$q=$q." and t1.expected_date<=:expected_date ";
$ar[':expected_date']=$code->to_date;
}
$isSea=false;
if(strlen($code->order_no)!=0)
{
$q=$q." and t1.order_no=:order_no ";
$ar[':order_no']=$code->order_no;

$statement = $db->prepare("SELECT '' selected,t1.id,order_type,t1.order_no,expected_date,
customer,'' bl_no,shipment_from,shipment_to,'' grp,'' parcel_detail,t1.status,
'' liner,
'' port,
'' import_start_calc_date,
'' voyage,
'' vessel  
 from mt_order_entry t1 
  WHERE order_no=:order_no and order_type 
  in('SEA IMPORT','SEA EXPORT') and 1=(SELECT 1 from mt_order_cost where order_id=t1.id and billing_party=:customer and type='INCOME' limit 1) ");
$statement->execute(array(':order_no'=>$code->order_no,
  ':customer'=>$code->customer));
$ndatas=$statement->fetchAll(PDO::FETCH_ASSOC);
if(count($ndatas)==1)
{
$isSea=true;
}
}

/*
if(strlen($code->customer)!=0)
{
$q=$q." and t1.customer=:customer ";
$ar[':customer']=$code->customer;
} */

if(strlen($code->voyage)!=0)
{
$q=$q." and t2.voyage=:voyage ";
$ar[':voyage']=$code->voyage;

}

if(strlen($code->bl_no)!=0)
{
$q=$q." and t2.bl_no=:bl_no ";
$ar[':bl_no']=$code->bl_no;

}

if($isSea)
{


$data=$ndatas;

}else{

$ar[":customer"]=$code->customer;

$query="SELECT '' selected,t1.id,order_type,t1.order_no,expected_date,
customer,t2.bl_no,shipment_from,shipment_to,'' grp,'' parcel_detail,t1.status,
t3.liner,
t3.port,
t3.import_start_calc_date,
t2.voyage,
t3.vessel  
 from mt_order_entry t1, mt_manifest_entry t2 ,mt_voyage t3 
  where  1=(SELECT 1 from mt_order_cost where order_id=t1.id and billing_party=:customer and type='INCOME' limit 1) and t1.status in ('OPEN','PART INVOICED') and t1.order_no=t2.order_no and t2.voyage=t3.voyage ".$q;

//echo "---".$query;
$statement = $db->prepare($query);
$statement->execute($ar);
$data=$statement->fetchAll(PDO::FETCH_ASSOC);
}

//another case : search orders by customers
if(count($data)==0)
{
  if(strlen($code->customer)!=0)
  {

  //getting sea data

    $q="";
$ar=array();

if(strlen($code->btype)!=0)
{
$q=$q." and t1.order_type=:order_type ";
$ar[':order_type']=$code->btype;
}

if(strlen($code->from_date)!=0)
{
$q=$q." and t1.expected_date>=:expected_date ";
$ar[':expected_date']=$code->from_date;
}

if(strlen($code->to_date)!=0)
{
$q=$q." and t1.expected_date<=:expected_date ";
$ar[':expected_date']=$code->to_date;
}

$ar[":customer"]=$code->customer;

$statement = $db->prepare("SELECT '' selected,t1.id,order_type,t1.order_no,expected_date,
customer,'' bl_no,shipment_from,shipment_to,'' grp,'' parcel_detail,t1.status,
'' liner,
'' port,
'' import_start_calc_date,
'' voyage,
'' vessel  
 from mt_order_entry t1 
  WHERE  id in (SELECT distinct order_id from mt_order_cost where 
   billing_party=:customer and type='INCOME') and 
  t1.status in ('OPEN','PART INVOICED') ".$q);
$statement->execute($ar);
$data["orders"]=$statement->fetchAll(PDO::FETCH_ASSOC);
$data["part2"]="part2";

  //getting agency data
/*
  $query="SELECT '' selected,t1.id,order_type,t1.order_no,expected_date,
customer,t2.bl_no,shipment_from,shipment_to,'' grp,'' parcel_detail,t1.status,
t3.liner,
t3.port,
t3.import_start_calc_date,
t2.voyage,
t3.vessel  
 from mt_order_entry t1, mt_manifest_entry t2 ,mt_voyage t3 
  where  t1.id in (SELECT distinct order_id from mt_order_cost where 
  billing_party=:customer and type='INCOME' ) and 
  t1.status in ('OPEN','PART INVOICED') ".$q;

//echo "---".$query;
$statement = $db->prepare($query);
$statement->execute($ar);
$data2=$statement->fetchAll(PDO::FETCH_ASSOC);

$data=array_merge($data1,$data2); */
  }
}
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function save_det_calc_info($dev,$code)
{
$data=array();
try
{
$db = Factory::getConnection();

//order starts
for($i=0;$i<count($code);$i++)
{

$c=$code[$i];

$statement = $db->prepare("SELECT container_no,type,last_det_calc_amt from mt_manifest_entry_container where mnf_entry_pk=(SELECT id from mt_manifest_entry where order_no=:order_no)");
  $statement->execute(array(":order_no"=>$c->order_no));
$containers=$statement->fetchAll(PDO::FETCH_ASSOC);

//container starts
for($i=0;$i<count($containers);$i++)
{
  $ind_con=$containers[$i];
  //$nr=$c[$i];
  $nr=$c;
  $nr->type=$ind_con["type"];
  $nr->manifest_type=$ind_con["order_type"];
  $nr->chargetype='DETENTION';
  $nr->container_no=$ind_con["container_no"];
  $nr->last_det_calc_amt=$ind_con["last_det_calc_amt"];

  $statement = $db->prepare("SELECT free_days FROM mt_freedays t1, mt_freedays_detail t2 
WHERE t2.freedays_pk=t1.id and voyage=:voyage and bl_no=:bl_no 
and ctype=:ctype and charge_type='DETENTION' and 
manifest_type=:manifest_type and liner=:liner and location=:loc");
  $statement->execute(array(
  ':voyage'=>$nr->voyage,
  ':bl_no'=>$nr->bl_no,
  ':ctype'=>$nr->type,
  ':manifest_type'=>$nr->manifest_type,
  ':liner'=>$nr->liner,
  ':loc'=>$nr->port
));
//var_dump($statement->debugDumpParams());
$fds=$statement->fetchAll(PDO::FETCH_ASSOC);
//var_dump($fds);
if(count($fds)!=0)
{
  $nr->diff_days=$nr->diff_days-$fds[0]["free_days"];
}

if($nr->diff_days>0)
{
  $statement = $db->prepare("SELECT slab_order,slab_from,slab_to,rate from mt_rates_detention_slabs where detention_id=( SELECT id FROM mt_rates_detention WHERE location=:loc and charge_type='DETENTION' and liner=:liner) and slab_from<=:diff_days and ctype=:ctype"); 


$statement->execute(array(':loc'=>$nr->port,
  ':diff_days'=>$nr->diff_days,
  ':liner'=>$nr->liner,
  ':ctype'=>$nr->type
));
$slab_data=$statement->fetchAll(PDO::FETCH_ASSOC);
//calculating det cost
$total_cost=0;
$last_slab_to=0;
//var_dump($slab_data);
$cv='';
$total_len=count($slab_data);
$total_days=0;
for($j=0;$j<$total_len;$j++)
{
$nslab=$slab_data[$j];
if($j+1==$total_len)
{
  $mul=($nr->diff_days-$total_days);
  $total_cost=$total_cost+($nslab["rate"]*$mul);
  //$total_days=$total_days+$mul;
}else{
  $mul=($nslab["slab_to"]-$nslab["slab_from"])+1;
  $total_cost=$total_cost+($nslab["rate"]*$mul);
  $total_days=$total_days+$mul;

}

}
if(!is_null($nr->last_det_calc_amt))
{
  $total_cost=abs($total_cost-$nr->last_det_calc_amt);
}
//save det cost to order cost

$temp_code=uniqid($dev->uid);

$order_id=0;
$statement = $db->prepare("SELECT id from mt_order_entry where order_no=:order_no");

$statement->execute(array(':order_no'=>$nr->order_no));

$temp=$statement->fetchAll(PDO::FETCH_ASSOC);

$order_id=$temp[0]["id"];

$base_currency=getCurrency($dev);

$statement = $db->prepare("INSERT into mt_order_cost(
  qty,
order_id,
charge_desc,

basis_type,
ex_rate,
type,
rate_cost,
rate_selling,
cost_amount,
cost_base_amount,
pay_at_location,
mode_of_pay,
currency,


selling_amount,
selling_base_amount,
remarks,
created_by,
created_date,
ip,
ua,
ekey,
temp_code) 
values(
1,
:order_id,
:charge_desc,

:basis_type,
1,
'INCOME',
:selling_amount,
:selling_amount,
:selling_amount,
:selling_amount,
:pay_at_location,
'COLLECT',
'$base_currency',

:selling_amount,
:selling_base_amount,
:remarks,
:created_by,
now(),
:ip,
:ua,
:ekey,:temp_code)");

$statement->execute(array(':ip'=>$dev->ip,
':created_by'=>$dev->uid,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,

':order_id'=>$order_id,
':charge_desc'=>$nr->chargetype,
':selling_amount'=>$total_cost,
':selling_base_amount'=>$total_cost,
':remarks'=>$nr->container_no,

':basis_type'=>$nr->type,
':pay_at_location'=>$nr->port,

':temp_code'=>$temp_code
));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}

$statement = $db->prepare("UPDATE mt_manifest_entry_container set last_det_calc_amt=:amt, last_det_calc_date=CURDATE() where id=:id");

$statement->execute(array(':id'=>$nr->id,':amt'=>$total_cost));



if ($statement->rowCount()){
  $data["ld_status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data["ld_status"]=0;
    //echo 'Failure: 0 rows were affected.';
}

}else{
  $data["status"]=20;
}

}
//container ends
}

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}



public static function get_order_charges($c)
{

$data=false;
$code=$c->ids;
try
{
  $q="";
  $data=$code;
$len=count($data);
for($i=0;$i<$len;$i++)
{
  if($i+1==$len)
  {
    $q=$q." ".$data[$i];
  }else{
  $q=$q." ".$data[$i].",";
  }
  
}

$db = Factory::getConnection();
$statement = $db->prepare("SELECT id,billing_party,order_id,charge_desc,
  basis_type, basis_uom, currency,qty,
rate_selling selling_amount,selling_amount famt,ex_rate,selling_base_amount net_amt,'' taxable,'' total_tax_amt,selling_base_amount total_amt,remarks,
invoiced,
CASE
    WHEN invoiced =1 THEN 'INVOICED' 
    WHEN invoiced =2 THEN 'PROFORMA' 
    ELSE ''
END inv_status 
 from mt_order_cost where (billing_party=:bp or billing_party=(SELECT code FROM mt_business_partner WHERE name=:bp limit 1)) and type='INCOME' and order_id in ($q) ");

$statement->execute(array(':bp'=>$c->customer));

$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function search_invoice_entry_list($dev,$code)
{

$data=false;
try
{
$db = Factory::getConnection();
$dev=get_user_data($db,$dev);

$aq=Factory::getRestrictionQuery($dev);

$saq='';
$query='';
if(is_object($code))
{
  if($code->cancelled)
  {
  $saq="sub_ar_status='CANCELLED' and ";
  }else{
  $saq="sub_ar_status!='CANCELLED' and ";
  }
  $query=$code->q;
}else{
  $saq="sub_ar_status!='CANCELLED' and ";
  $query=$code;
}

$statement = $db->prepare("SELECT * FROM (

  (SELECT 'red' bg, '' inv_type,id,''  doc_type,'TO BE BILLED' doc_no,
  (SELECT name from mt_business_partner where code=customer limit 1) customer, 
  customer customer_code, 
  order_no, bl_no,
  expected_date doc_date, '' gl_date, order_type reference, '' currency, '' local_amount, 
   case when status ='P' then
    'POSTED'
    else
      status 
    end as estatus,  
  created_date,created_by,modified_date,modified_by 
  from mt_order_entry 
  where $aq and id in (select order_id from mt_order_cost 
  where invoiced is null and type='INCOME') 
  and to_invoice=1 and (bl_no like ? or  order_no like ? or order_type like ? ) order by id desc limit 20) 

  UNION 

  (SELECT 'green' bg,'agency' inv_type,t1.id,t1.sub_ar_doc_type doc_type, t1.sub_ar_doc_number doc_no, 
  (SELECT name from mt_business_partner where code=t1.sub_ar_code limit 1)   customer,
  t1.sub_ar_code customer_code,
  (SELECT GROUP_CONCAT(DISTINCT sub_ard_detail_1 SEPARATOR ', ') 
  from mt_ship_ar_details 
  where sub_ard_doc_number=t1.sub_ar_doc_number)  order_no,
    (SELECT GROUP_CONCAT(DISTINCT sub_ard_detail_4 SEPARATOR ', ') 
  from mt_ship_ar_details 
  where sub_ard_doc_number=t1.sub_ar_doc_number)  bl_no,
  t1.sub_ar_date doc_date, t1.sub_ar_gl_date gl_date, t1.sub_ar_other_reference reference, t1.sub_ar_currency currency, t1.sub_ar_l_amount local_amount, 
  case when t1.sub_ar_status ='P' then
  'POSTED'
  else
    t1.sub_ar_status  
  end as estatus,  
  t1.created_date,created_by,modified_date,modified_by from mt_ship_ar_header t1 
  where $aq and (sub_ar_doc_type like ? or 
sub_ar_doc_number like ? or 
sub_ar_code like ? or 
order_no like ? or bl_no like ? )
  order by id desc limit 20)

  UNION 
  
  (SELECT 'green' bg,'forward' inv_type,t1.id,t1.sub_ar_doc_type doc_type, t1.sub_ar_doc_number doc_no, 
  (SELECT name from mt_business_partner where code=t1.sub_ar_code limit 1)   customer,
  t1.sub_ar_code customer_code,
  (SELECT GROUP_CONCAT(DISTINCT sub_ard_detail_1 SEPARATOR ', ') 
  from mt_order_ar_details 
  where sub_ard_doc_number=t1.sub_ar_doc_number)  order_no,
    (SELECT GROUP_CONCAT(DISTINCT sub_ard_detail_4 SEPARATOR ', ') 
  from mt_order_ar_details 
  where sub_ard_doc_number=t1.sub_ar_doc_number)  bl_no,
  t1.sub_ar_date doc_date, t1.sub_ar_gl_date gl_date, t1.sub_ar_other_reference reference, t1.sub_ar_currency currency, t1.sub_ar_l_amount local_amount, 
  case when t1.sub_ar_status ='P' then
  'POSTED'
  else
    t1.sub_ar_status  
  end as estatus,
  t1.created_date,
  created_by,modified_date,modified_by from mt_order_ar_header t1
  where $saq $aq and (sub_ar_doc_type like ? or 
sub_ar_doc_number like ? or 
sub_ar_code like ? or 
order_no like ? or bl_no like ? )
  order by id desc limit 20)
  ) t1 order by created_date desc

");

/*
SELECT t1.id,t1.sub_ar_doc_type doc_type, t1.sub_ar_doc_number doc_no, t1.sub_ar_code customer, t2.sub_ard_detail_1 order_no, t2.sub_ard_detail_4 bl_no, t1.sub_ar_date doc_date, t1.sub_ar_gl_date gl_date, t1.sub_ar_other_reference reference, t1.sub_ar_currency currency, t1.sub_ar_l_amount local_amount, t1.sub_ar_status estatus from mt_ship_ar_header t1, mt_ship_ar_details t2 
  where t1.sub_ar_doc_number=t2.sub_ard_doc_number and (sub_ar_doc_type like ? or 
sub_ar_doc_number like ? or 
sub_ar_code like ?)
 order by id limit 50
*/
 $j=0;
 $v=$query;
$statement ->bindValue(1, "%$v%", PDO::PARAM_STR);
$statement ->bindValue(2, "%$v%", PDO::PARAM_STR);
$statement ->bindValue(3, "%$v%", PDO::PARAM_STR);

$statement ->bindValue(4, "%$v%", PDO::PARAM_STR);
$statement ->bindValue(5, "%$v%", PDO::PARAM_STR);
$statement ->bindValue(6, "%$v%", PDO::PARAM_STR);

$statement ->bindValue(7, "%$v%", PDO::PARAM_STR);
$statement ->bindValue(8, "%$v%", PDO::PARAM_STR);
$statement ->bindValue(9, "%$v%", PDO::PARAM_STR);
$statement ->bindValue(10, "%$v%", PDO::PARAM_STR);

$statement ->bindValue(11, "%$v%", PDO::PARAM_STR);
$statement ->bindValue(12, "%$v%", PDO::PARAM_STR);
$statement ->bindValue(13, "%$v%", PDO::PARAM_STR);


$statement->execute();

$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function save_delivery_order($dev,$code)
{
$data=array();
try
{
$db = Factory::getConnection();
$db->beginTransaction();

$c=$code->info;
$do=$code->do;


$temp_code=uniqid($dev->uid);

$fy=self::getFinancialYear();
$fp=self::getFinancialPeriod($do->do_date);

$statement = $db->prepare("INSERT into mt_delivery_order(order_no, bl_no, poo, pol, pod, pof, shipper, consignee, notify , do_party , do_takenby , do_paidby , endorsement_party , do_date , do_validity_date, remarks, narration,
  created_by,created_date,ip,ua,ekey,temp_code,company_id,location_id,
  total,advance_do,auto_invoice) 
values(:order_no, :bl_no, :poo, :pol, :pod, :pof, :shipper, :consignee, :notify , :do_party , :do_takenby , :do_paidby , :endorsement_party , :do_date , :do_validity_date, :remarks, :narration,
:created_by,now(),:ip,:ua,:ekey,
:temp_code,:company_id,:location_id,:total,:advance_do,:auto_invoice)");

$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->uid ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,

':order_no'=>$c->order_no,
':bl_no'=>$c->bl_no,
':poo'=>$c->poo,
':pol'=>$c->pol,
':pod'=>$c->pod,
':pof'=>$c->pof,
':shipper'=>$c->shipper,
':consignee'=>$c->consignee,
':notify'=>$c->notify ,
':do_party'=>$do->do_party ,
':do_takenby'=>$do->do_takenby ,
':do_paidby'=>$do->do_paidby ,
':endorsement_party'=>$do->endorsement_party ,
':do_date'=>$do->do_date ,
':do_validity_date'=>$do->do_validity_date,
':remarks'=>$do->remarks,
':narration'=>$do->narration,

':temp_code'=>$temp_code,

':company_id'=>$dev->company,
':location_id'=>$dev->location,
':total'=>$code->total,
':advance_do'=>$code->advance_do,
':auto_invoice'=>$code->auto_invoice
));

if ($statement->rowCount()){
  $data["status"]=1;
} else{
  $data["status"]=0;
  $data["status11"]=0;

}
$data["temp_code"]=$temp_code;

$statement = $db->prepare("SELECT id from mt_delivery_order where created_by=:uid and temp_code=:temp_code");
$statement->execute(array(':temp_code'=>$temp_code,
  ':uid'=>$dev->uid));
$op=$statement->fetchAll(PDO::FETCH_ASSOC);


$data["id"]=$op;

$fid=gen_no_for_do($db,$dev,$c->order_no,$c->bl_no);

$do_no='DO/'.date('Y').'/'.date('m').'/'.$c->pod.'/'.$fid;


   $statement = $db->prepare("UPDATE mt_delivery_order 
  SET do_no=:do_no,modified_date=now(),modified_by=:modified_by
   where id=:id");
  $statement->execute(array(':id'=>$op[0]["id"],':do_no'=>$do_no,
':modified_by'=>$dev->username));
  
    if ($statement->rowCount()){
    $data["doid_status"]=1;
    $data["do_no"]=$do_no;
  } else{
    $data["doid_status"]=0;
  }

  //update manifest entry

   $statement = $db->prepare("UPDATE mt_manifest_entry 
  SET status='DO ISSUED',modified_by=:modified_by,modified_date=now() 
  where bl_no=:bl_no");
  $statement->execute(array(':bl_no'=>$c->bl_no,':modified_by'=>$dev->username));
  
    if ($statement->rowCount()){
    $data["mnf_status"]=1;
  } else{
    $data["mnf_status"]=0;
  }

if($data["status"]==1 && $data["doid_status"]==1 && $data["mnf_status"]==1)
{
  $db->commit();
  $data["msg"]="Saved";
}else{
    $db->rollBack();
    $data["status"]=0;
    $data["msg"]="Unable to save. Please try again";
}

$statement=null;
  }
  catch (Exception $e) {
    //print $e->getMessage();
    $data["emsg"]=$e->getMessage();
    $db->rollBack();
    $data["status"]=0;
    $data["msg"]="Unable to save. Exception. Please try again";
  }
  
  return $data;
}


public static function get_gl_Link($code)
{

$data=false;
try
{
$db = Factory::getConnection();
$statement = $db->prepare("SELECT code,gl_link from mt_charge_group_detail where code=:code");

//$statement->bindValue(':sta',(int) $code, PDO::PARAM_INT); 
$statement->execute(array(':code'=>$code));

$data=$statement->fetchAll(PDO::FETCH_ASSOC);

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;

}
public static function setFourDigit($v)
{
  $len=strlen($v);

if($len==1)
{
  $v="000".$v;
}else if($len==2)
{
  $v="00".$v;
}else if($len==3)
{
  $v="0".$v;
}

return $v;
}


public static function getFinancialYear()
{
//$year = ( date('m') > 4) ? date('Y') + 1 : date('Y');
$year=date('Y');
return $year;
}

public static function getFinancialPeriod($doc_date)
{

//$year = ( date('m') > 4) ? date('Y') + 1 : date('Y');
//$period=4;
//return $period;
$data=false;
try
{
$db = Factory::getConnection();

//$aq=self::getRestrictionQuery($dev);
//$doc_date="2019-12-15";
$date=date_create($doc_date);
$m= date_format($date,"F");
$y= date_format($date,"Y");

$statement = $db->prepare("SELECT enumber from mt_period 
  where period=:period and year=:year and open_max='OPEN'");

$statement->execute(array(':period'=>$m,':year'=>$y));
$data=$statement->fetchAll(PDO::FETCH_ASSOC);
//var_dump($statement->debugDumpParams());
$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  $p=-10;
  if(count($data)==1)
  {
    $p=$data[0]["enumber"];
  }
  return $p;
}


public static function update_invoice_entry_sea($dev,$code)
{
$data=array();

try
{
$db = Factory::getConnection();
$db->beginTransaction();
$temp_code=uniqid($dev->uid);


$c=$code->inv;

//check finance posted
$statement = $db->prepare("SELECT * from mt_ar_trans  
  where art_number=:art_number");

$statement->execute(array(':art_number'=>$c->sub_ar_doc_number));
$fin_posted=$statement->fetchAll(PDO::FETCH_ASSOC);
$is_fin_posted=0;
if(count($fin_posted)!=0)
{
  $is_fin_posted=1;
}
$data["is_fin_posted"]=$is_fin_posted;
if($c->sub_ar_doc_type=="PRO-INV" && $is_fin_posted==0)
{
$code->order_no=$c->order_no;
$inv_alphabet=array('A','B','C','D','E','F','G','H','I','J','K','L','M','N','O','P','Q','R','S','T','U','V','W','X','Y','Z');
$can_proceed1=false;
$data["order_no1"]=$code->order_no;
$data["ex_inv"]=self::get_inv($db,$c->order_no);
$data["order_no"]=str_replace(",","",trim($c->order_no));

$ex_inv_no='';
$new_inv_prefix='';
$ex_inv_count=count($data["ex_inv"]);
if($ex_inv_count>=1)
{
  if($c->charge_type=='FREIGHT CHARGE')
  {
    $can_proceed1=false;
    $data["msg"]="Please choose right invoice category";
    $data["status"]=0;
  }else{
    $can_proceed1=true;
    $ex_inv_no=$data["ex_inv"][0]["sub_ar_doc_number"];
    $new_inv_prefix=$inv_alphabet[$ex_inv_count-1];
  }
}else{
  $can_proceed1=true;
}

//override previous rule and seq number
$can_proceed1=true;


if($can_proceed1)
{
//START GST CALC
//Get gstin detail
$statement = $db->prepare("SELECT pan, gstin 
  from mt_business_partner    
  where code=:sub_ar_code ");
$statement->execute(array(':sub_ar_code'=>$c->sub_ar_code ));
$data["cngList"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$r=$data["cngList"][0];  
$consignee_pan_no=$r["pan"];
$billparty_gstin=$r["gstin"];

//check state
$startString="33";
$len = strlen($startString);
$cgst=0;
$sgst=0;
$igst=0;

//taxable
/*
$statement = $db->prepare("SELECT sum(sub_ard_foreign_amount) taxable from mt_ship_ar_details 
where sub_ard_doc_number=:sub_ard_doc_number 
and charge_desc!='OFRT' ");
$statement->execute(array(':sub_ard_doc_number'=>$c->sub_ar_doc_number));
$taxds=$statement->fetchAll(PDO::FETCH_ASSOC);
$rate=$taxds[0]["taxable"];
$data["taxds"]=$taxds;
*/

$rate_total=0;
$cds=$code->cd;
$total_local_amt1=0;
for($i=0;$i<count($cds);$i++)
  {
    $cd=$cds[$i];
    if($cd->charge_desc!='OFRT')
    {
    $rate_total=$rate_total+$cd->total_amt;
    }
    $total_local_amt1=$total_local_amt1+$cd->total_amt;
  }
$rate=$rate_total;

//$rate=$c->total_local_amt;
#gst perc
$gst_percent=(float)$c->gst_percent;

$is_isgt=0;

//$state_cond=(substr($billparty_gstin, 0, $len) === $startString);
if($gst_percent!=0){

  if(substr($billparty_gstin, 0, $len)==$startString)
  {
      $tp=$gst_percent/2;
      $tv=($rate*$tp)/100;
      $cgst=round($tv,2);
      $sgst=round($tv,2);
      $is_isgt=0;

  }else{
      $igst=round(($rate*$gst_percent)/100,2);
      $is_isgt=1;

  }
}
$data["igst"]=$igst;
//END GST CALC

$igst_gl_code='';
$cgst_gl_code='';
$sgst_gl_code='';
$data["tax_gl_found"]=0;
if($is_isgt==1)
{
  if($gst_percent==18)
  {
    $igst_gl_code='2-10-002-0001';
    $data["tax_gl_found"]=1;
  }
}else{

  if($gst_percent==18)
  {
    $cgst_gl_code='2-10-002-0002';
    $sgst_gl_code='2-10-002-0003';
    $data["tax_gl_found"]=1;
  }else if($gst_percent==5)
  {
    $cgst_gl_code='2-10-002-0004';
    $sgst_gl_code='2-10-002-0005';
    $data["tax_gl_found"]=1;
  }
}

if($gst_percent==0)
{
$data["tax_gl_found"]=1;
$data["tax_gl_found_add_msg"]="GST IS ZERO";

}

//END GST CALC
$data["cgst"]=$cgst;
$data["igst"]=$igst;
$data["sgst"]=$sgst;

//get bl no from performa
$statement = $db->prepare("SELECT bl_no FROM mt_order_ar_header 
  where sub_ar_doc_number=:sub_ar_doc_number");
$statement->execute(array(':sub_ar_doc_number'=>$c->sub_ar_doc_number));
$op11s=$statement->fetchAll(PDO::FETCH_ASSOC);
$code->bl_no=explode(",",$op11s[0]["bl_no"])[0];
//split by comma
//get vessel voyage info
$statement = $db->prepare("SELECT vessel,voyage,port,liner 
  FROM mt_voyage WHERE voyage=
  (SELECT voyage FROM mt_manifest_entry 
  WHERE bl_no=:bl_no)");
$statement->execute(array(':bl_no'=>$code->bl_no));
$op11s=$statement->fetchAll(PDO::FETCH_ASSOC);

$code->voyage='';
$code->vessel='';
$code->liner='';
$code->port='';

if(count($op11s)>=1)
{
$op11=$op11s[0];
$code->voyage=$op11["voyage"];
$code->vessel=$op11["vessel"];
$code->liner=$op11["liner"];
$code->port=$op11["port"];
}

//list($first) = explode("/", $c->sub_ar_doc_number);
//$no=str_replace($first,$c->sub_ar_doc_type,$c->sub_ar_doc_number);

$no='';
$no=gen_no_for_invoice($db,$dev,$code->order_no,$c->sub_ar_doc_base);

/*if(strlen($ex_inv_no)==0)
{
  $no=gen_no_for_invoice($db,$dev,$code->order_no,$c->sub_ar_doc_base);
}else{
  $no=$ex_inv_no.$new_inv_prefix;
}*/

$statement = $db->prepare("UPDATE mt_order_ar_header  
  set sub_ar_doc_type=:sub_ar_doc_type,
   sub_ar_doc_number=:sub_ar_doc_number,
   charge_type=:charge_type,
  modified_by=:modified_by,modified_date=now() where id=:id");
$statement->execute(array(
':modified_by'=>$dev->username,
':id'=>$c->id,
':sub_ar_doc_type'=>$c->sub_ar_doc_type,
':sub_ar_doc_number'=>$no,
':charge_type'=>$c->charge_type
));

if ($statement->rowCount()){
  $data["status"]=1;
  $data["msg"]="Saved";

} else{
  $data["status"]=0;
  $data["msg"]="Unable to save. Please try again";

}
$data["doc_no"]=$no;

$india_total_local_amount=$total_local_amt1+$igst+$cgst+$sgst;

//for sea

  //MT_AR_TRANS table
//mt_order_trans table created using mt_ar_trans
//FINANCIAL YEAR AND PERIOD IS PENDING
$fy=self::getFinancialYear();
$fp=self::getFinancialPeriod($c->sub_ar_date);

$statement = $db->prepare("INSERT into mt_order_trans (
  ordt_company,ordt_code,ordt_doc_type,ordt_doc_number,ordt_serial,ordt_group,ordt_doc_base,ordt_internal,ordt_other_reference,ordt_doc_date,ordt_gl_date,ordt_year,ordt_period,ordt_age_date,ordt_dp_date,ordt_currency,ordt_ex_rate,ordt_foreign_amount,ordt_local_amount,ordt_foreign_balance,ordt_local_balance,ordt_balance_status,ordt_description,ordt_notes,ordt_detail_2,ordt_detail_3,ordt_detail_4,ordt_posted_on,ip,created_by ,ua,ekey,created_date,
  company_id,location_id) 

SELECT sub_ar_company,
sub_ar_code,
sub_ar_doc_type,
sub_ar_doc_number,
sub_ar_internal_number,
sub_ar_group,
sub_ar_doc_base,
sub_ar_internal_number,
sub_ar_other_reference,
sub_ar_date,
sub_ar_gl_date,
'$fy',
'$fp',
sub_ar_age_date,
sub_ar_due_date,
sub_ar_currency,
sub_ar_ex_rate,
'$india_total_local_amount',
'$india_total_local_amount',
'$india_total_local_amount',
'$india_total_local_amount',
'A',
sub_ar_narration,
sub_ar_notes,
sub_place_off_supply,
sub_place_off_supply_date,
sub_ar_other_reference_date,
now(),
'$dev->ip','$dev->username' ,'$dev->ua','$dev->ekey',
now(),'$dev->company','$dev->location'  
FROM mt_order_ar_header WHERE sub_ar_doc_number=:temp_code");

$statement->execute(array(':temp_code'=>$no));

if ($statement->rowCount()){
  $data["odtrans_status"]=1;
} else{
  $data["odtrans_status"]=0;
}

// update order cost to invoiced from proforma
$charge_query="UPDATE mt_order_cost set invoiced=1,inv_pay_no=:doc_no,modified_by=:modified_by,modified_date=now() where proforma=:id and invoiced!=1";
$statement = $db->prepare($charge_query);
$statement->execute(array(':id'=>$c->sub_ar_doc_number,
  ':doc_no'=>$no,':modified_by'=>$dev->username));

if ($statement->rowCount()){
  $data["cost_status"]=1;
} else{
  $data["cost_status"]=0;
}

$statement = $db->prepare("SELECT distinct order_id from mt_order_cost where proforma=:proforma");
$statement->execute(array(':proforma'=>$c->sub_ar_doc_number));

$ocs=$statement->fetchAll(PDO::FETCH_ASSOC);
//update order status to part invoiced or invoiced
$ocs_count=0;
for($i=0;$i<count($ocs);$i++)
{
$cd=$ocs[$i];
$oq="UPDATE mt_order_entry set modified_date=now(),modified_by=:modified_by,status=(SELECT CASE WHEN (SELECT count(*) FROM `mt_order_cost` WHERE invoiced is null and type='INCOME' and order_id=:id)=0 THEN 'INVOICED'
    ELSE 'PART INVOICED'
        END)
      WHERE id=:id";

 $statement = $db->prepare($oq);
 $statement->execute(array(':id'=>$cd["order_id"],':modified_by'=>$dev->username));

  if ($statement->rowCount()){
  $data["order_status-".$cd["order_id"]]=1;
  $ocs_count+=1;

} else{
  $data["order_status-".$cd["order_id"]]=0;
}
}

//update cost details to invoiced
 $statement = $db->prepare("UPDATE mt_order_ar_details set inv_status='INVOICED' where sub_ard_doc_number=:doc_no");
 $statement->execute(array(':doc_no'=>$c->sub_ar_doc_number));

  if ($statement->rowCount()){
  $data["detail_status"]=1;
} else{
  $data["detail_status"]=0;
}

//update order ar details id

$statement = $db->prepare("UPDATE mt_order_ar_details  
  set
   sub_ard_doc_number=:sub_ar_doc_number where sub_ard_doc_number=:id");
$statement->execute(array(
':id'=>$c->sub_ar_doc_number,
':sub_ar_doc_number'=>$no
));

if ($statement->rowCount()){
  $data["ar_detail_docno_status"]=1;
} else{
  $data["ar_detail_docno_status"]=0;
}

 //ship gl details
$temp_code=uniqid($dev->uid);

$multiple_order_no='';
$code->order_no=substr_replace($code->order_no, "", -1);
$sa=explode(',', $code->order_no);
$strLength=count($sa);
for ($i = 0; $i < $strLength; $i++) {

  if($i+1==$strLength)
  {
    $multiple_order_no=$multiple_order_no."'$sa[$i]'";
  }else{
    $multiple_order_no=$multiple_order_no."'$sa[$i]',";
  }

}
$on=$no;


//4
$temp_code=uniqid($dev->uid);
//$gds=self::get_gl_Link();
$statement = $db->prepare("INSERT into mt_order_trans
( ordt_company,ordt_doc_type,ordt_doc_number,ordt_serial,ordt_doc_base,ordt_doc_date,ordt_gl_date,ordt_dp_date,ordt_age_date,ordt_year,ordt_period,ordt_carrier,ordt_vessel,ordt_voyage,ordt_port,ordt_bl,ordt_bl_type,ordt_charge,ordt_other_reference,ordt_currency,ordt_ex_rate,ordt_foreign_amount,ordt_local_amount,ordt_narration,ordt_status,
ordt_posted_on,
  ip,created_by ,ua,ekey,created_date,temp_code,ordt_code) 

  SELECT '$dev->company','INV','$on','0','ORDER','$c->sub_ar_date',
  '$c->sub_ar_date',
  '$c->sub_ar_date','$c->sub_ar_date','$fy','$fp','$code->liner',
  '$code->vessel','$code->voyage','$code->port','$code->bl_no',
  '$c->sub_ar_doc_base',charge_desc,'$code->order_no'
  ,currency,ex_rate,-selling_amount,
  -selling_base_amount,remarks,
  status,now(),
  '$dev->ip',
  '$dev->uid','$dev->ua','$dev->ekey',now(),'$temp_code','$c->sub_ar_code'
  from mt_order_cost 
  where proforma='$c->sub_ar_doc_number'
");
$statement->execute();
    if ($statement->rowCount()){
    $data["sht_status"]=1;
  } else{
    $data["sht_status"]=0;
  }

//query 5 ar trans

//MT_AR_TRANS table
//FINANCIAL YEAR AND PERIOD IS PENDING
$statement = $db->prepare("INSERT into mt_ar_trans (
  art_company,art_code,art_type,art_number,art_serial,art_group,art_base_type,art_internal,art_other_reference,art_doc_date,art_gl_date,art_year,art_period,art_age_date,art_dp_date,art_currency,art_ex_rate,art_foreign_amount,art_local_amount,art_foreign_balance,art_local_balance,art_balance_status,art_description,art_notes,art_detail_2,art_detail_3,art_detail_4,art_posted_on,ip,created_by ,ua,ekey,created_date,
  company_id,location_id) 

SELECT sub_ar_company,
sub_ar_code,
sub_ar_doc_type,
sub_ar_doc_number,
sub_ar_internal_number,
sub_ar_group,
sub_ar_doc_base,
sub_ar_internal_number,
sub_ar_other_reference,
sub_ar_date,
sub_ar_gl_date,
'$fy',
'$fp',
sub_ar_age_date,
sub_ar_due_date,
sub_ar_currency,
sub_ar_ex_rate,
'$india_total_local_amount',
'$india_total_local_amount',
'$india_total_local_amount',
'$india_total_local_amount',
'A',
sub_ar_narration,
sub_ar_notes,
sub_place_off_supply,
sub_place_off_supply_date,
sub_ar_other_reference_date,
now(),
'$dev->ip','$dev->username' ,'$dev->ua','$dev->ekey',
now(),'$dev->company','$dev->location' 
FROM mt_order_ar_header WHERE sub_ar_doc_number=:temp_code");

$statement->execute(array(':temp_code'=>$no));

if ($statement->rowCount()){
  $data["ar_trans_status"]=1;
} else{
  $data["ar_trans_status"]=0;
}

//TAX STARTS

//OUTPUT CGST - 2-30-001-0012
      if($cgst!=0){
        $statement = $db->prepare("INSERT into gst_trans (
          art_company,art_code,art_type,art_number,art_serial,art_group,
          art_base_type,art_internal,art_other_reference,art_doc_date,art_gl_date,art_year,
          art_period,art_age_date,art_dp_date,art_currency,art_ex_rate,art_foreign_amount,
          art_local_amount,art_foreign_balance,art_local_balance,art_balance_status,
          art_description,art_notes,art_detail_2,art_detail_3,art_detail_4,art_posted_on,
          ip,created_by ,ua,ekey,created_date,
          company_id,location_id) 
        values 
        ('$dev->company',:art_code,'OUTPUT CGST',:art_number,'1',:art_group,
        'OUTPUT CGST', '0', '', '$c->sub_ar_date','$c->sub_ar_date','$fy',
        '$fp','$c->sub_ar_date','$c->sub_ar_date', 
        'INR','1',:art_foreign_amount, 
        :art_local_amount,:art_foreign_balance,:art_local_balance,'A',
        :art_description,'','','','', now(),
        '$dev->ip','$dev->username' ,'$dev->ua','$dev->ekey', now(),
        '$dev->company','$dev->location') ");

        $statement->execute(array(':art_code'=>$c->sub_ar_code, 
          ':art_number'=>$on, 
          ':art_group'=>$cgst_gl_code, 
          ':art_foreign_amount'=>$cgst, 
          ':art_local_amount'=>$cgst, 
          ':art_foreign_balance'=>$cgst, 
          ':art_local_balance'=>$cgst, 
          ':art_description'=>'OUTPUT CGST '.($gst_percent/2).'%' ));

        if ($statement->rowCount()){
          $data["cgst_status"]=1;
        } else{
          $data["cgst_status"]=0;
        }
    }
    //OUTPUT SGST - 2-30-001-0016
      if($sgst!=0){
        $statement = $db->prepare("INSERT into gst_trans (
          art_company,art_code,art_type,art_number,art_serial,art_group,
          art_base_type,art_internal,art_other_reference,art_doc_date,art_gl_date,art_year,
          art_period,art_age_date,art_dp_date,art_currency,art_ex_rate,art_foreign_amount,
          art_local_amount,art_foreign_balance,art_local_balance,art_balance_status,
          art_description,art_notes,art_detail_2,art_detail_3,art_detail_4,art_posted_on,
          ip,created_by ,ua,ekey,created_date,
          company_id,location_id) 
        values 
        ('$dev->company',:art_code,'OUTPUT SGST',:art_number,'1',:art_group,
        'OUTPUT SGST', '0', '','$c->sub_ar_date','$c->sub_ar_date','$fy',
        '$fp','$c->sub_ar_date','$c->sub_ar_date', 
        'INR','1',:art_foreign_amount, 
        :art_local_amount,:art_foreign_balance,:art_local_balance,'A',
        :art_description,'','','','', now(),
        '$dev->ip','$dev->username' ,'$dev->ua','$dev->ekey', now(),
        '$dev->company','$dev->location') ");

        $statement->execute(array(':art_code'=>$c->sub_ar_code, 
          ':art_number'=>$on, 
          ':art_group'=>$sgst_gl_code, 
          ':art_foreign_amount'=>$sgst, 
          ':art_local_amount'=>$sgst, 
          ':art_foreign_balance'=>$sgst, 
          ':art_local_balance'=>$sgst, 
          ':art_description'=>'OUTPUT SGST '.($gst_percent/2).'%' ));

        if ($statement->rowCount()){
          $data["sgst_status"]=1;
        } else{
          $data["sgst_status"]=0;
        }
    }
    //OUTPUT IGST - 2-30-001-0015
      if($igst!=0){
        $statement = $db->prepare("INSERT into gst_trans (
          art_company,art_code,art_type,art_number,art_serial,art_group,
          art_base_type,art_internal,art_other_reference,art_doc_date,art_gl_date,art_year,
          art_period,art_age_date,art_dp_date,art_currency,art_ex_rate,art_foreign_amount,
          art_local_amount,art_foreign_balance,art_local_balance,art_balance_status,
          art_description,art_notes,art_detail_2,art_detail_3,art_detail_4,art_posted_on,
          ip,created_by ,ua,ekey,created_date,
          company_id,location_id) 
        values 
        ('$dev->company',:art_code,'OUTPUT IGST',:art_number,'1',:art_group,
        'OUTPUT IGST', '0', '','$c->sub_ar_date','$c->sub_ar_date','$fy',
        '$fp','$c->sub_ar_date','$c->sub_ar_date',
        'INR','1',:art_foreign_amount, 
        :art_local_amount,:art_foreign_balance,:art_local_balance,'A',
        :art_description,'','','','', now(),
        '$dev->ip','$dev->username' ,'$dev->ua','$dev->ekey', now(),
        '$dev->company','$dev->location') ");

        $statement->execute(array(':art_code'=>$c->sub_ar_code, 
          ':art_number'=>$on, 
          ':art_group'=>$igst_gl_code, 
          ':art_foreign_amount'=>$igst, 
          ':art_local_amount'=>$igst, 
          ':art_foreign_balance'=>$igst, 
          ':art_local_balance'=>$igst, 
          ':art_description'=>'OUTPUT IGST '.$gst_percent.'%' ));

        if ($statement->rowCount()){
          $data["igst_status"]=1;
        } else{
          $data["igst_status"]=0;
        }
    }

//TAX ENDS

// query 6
$temp_code=uniqid($dev->uid);
$statement = $db->prepare("INSERT into mt_ar_trans_balance
(ardm_company,ardm_code,ardm_doc_type,ardm_doc_number,
  ardm_serial,ardm_other_reference,ardm_date,ardm_currency,
  ardm_ex_rate,ardm_of_amount,ardm_ol_amount,
  ardm_bf_amount,ardm_bl_amount,
  ardm_pf_amount,ardm_pl_amount,ardm_status,
ip,created_by,ua,ekey,created_date,temp_code,company_id,location_id)

SELECT art_company,art_code,art_type,art_number,
art_serial,art_other_reference,art_gl_date,art_currency,
art_ex_rate,art_foreign_amount,art_local_amount,
art_foreign_balance,art_local_balance,
0,0,'PENDING',
ip,created_by,ua,ekey,now(),'$temp_code',
'$dev->company','$dev->location'  
 from mt_ar_trans where art_number=:doc_no
");

$statement->execute(array(':doc_no'=>$no));
//var_dump($statement->debugDumpParams());
if ($statement->rowCount()){
  $data["tb_status"]=1;
} else{
  $data["tb_status"]=0;
}


//gl starts

  //gl header posting
  //Add IMP-INV,EXP-INV entries to GL detail table
  $statement = $db->prepare("INSERT into mt_order_gl_details 
  ( pre_glt_company, pre_glt_code,
  pre_glt_doc_base,pre_glt_doc_type,
  pre_glt_doc_number,pre_glt_serial,
  pre_glt_doc_date,pre_glt_gl_date,pre_glt_year,pre_glt_period,
  pre_glt_other_reference,pre_glt_currency,pre_glt_ex_rate,
  pre_glt_foreign_amount,pre_glt_local_amount,pre_glt_narration,
  pre_glt_module,pre_glt_detail_1,pre_glt_detail_2,pre_glt_detail_3,
  pre_glt_detail_4,pre_glt_detail_5,pre_glt_detail_6,
  pre_glt_detail_7,pre_glt_detail_8,pre_glt_detail_9,
  ip,created_by ,ua,ekey,created_date,temp_code,pre_glt_created,
  location_id,company_id)

  SELECT art_company,art_group,
  art_type,art_base_type,
  art_number, art_serial,
  art_gl_date,art_gl_date,'$fy','$fp',
  art_other_reference,art_currency,art_ex_rate,
  art_foreign_amount,art_local_amount,art_description,
  'ORDER',
  art_group,
  'RECEIVABLE',
  '$c->sub_ar_code',  
  '$c->order_no','$c->bl_no','$c->sub_ar_date',
  '$c->sub_ar_code',art_group,art_description,
  ip,created_by,ua,ekey,now(),'$temp_code',now(),
  '$dev->company','$dev->location'    
   from mt_ar_trans where art_number=:doc_no and art_type 
   in ('IMP-INV','EXP-INV','PRO-INV') ");

  $statement->execute(array(':doc_no'=>$on));
      if ($statement->rowCount()){
      $data["gld_header_status"]=1;
    } else{
      $data["gld_header_status"]=0;
    }


$statement = $db->prepare("INSERT into mt_order_gl_details 
( pre_glt_company,pre_glt_code,pre_glt_doc_base,pre_glt_doc_type,pre_glt_doc_number,pre_glt_serial,pre_glt_doc_date,pre_glt_gl_date,pre_glt_year,pre_glt_period,pre_glt_other_reference,pre_glt_currency,pre_glt_ex_rate,pre_glt_foreign_amount,pre_glt_local_amount,pre_glt_narration,pre_glt_module,pre_glt_detail_1,pre_glt_detail_2,pre_glt_detail_3,pre_glt_detail_4,pre_glt_detail_5,pre_glt_detail_6,pre_glt_detail_7,pre_glt_detail_8,pre_glt_detail_9,
  ip,created_by ,ua,ekey,created_date,temp_code, 
  location_id,company_id)
  SELECT '$dev->company',
  (SELECT income_gl from mt_charge_group_detail 
  where code=charge_desc limit 1),'ORDER','INV','$on','0',
  '$c->sub_ar_date','$c->sub_ar_date','$fy','$fp','$c->bl_no',
  currency,ex_rate,-selling_amount,-selling_base_amount,remarks,
  'ORDER',
  (SELECT income_gl from mt_charge_group_detail 
  where code=charge_desc limit 1),
  charge_desc,'',
  '$c->order_no','$c->sub_ar_date','$c->sub_ar_doc_base',
  '$c->bl_no',
  '$c->sub_ar_code',charge_desc,'$dev->ip',
  '$dev->username','$dev->ua','$dev->ekey',now(),'$temp_code',
  '$dev->company','$dev->location' from mt_order_cost 
  where id in(SELECT charge_id FROM mt_order_ar_details WHERE sub_ard_doc_number=:doc_no) and type='INCOME'");


    $statement->execute(array(':doc_no'=>$on));
    if ($statement->rowCount()){
    $data["gld_status"]=1;
  } else{
    $data["gld_status"]=0;
    $data["gld_status_add"]="NE";
  }

    //Add GST entries to GL detail table
  $statement = $db->prepare("INSERT into mt_order_gl_details 
  ( pre_glt_company, pre_glt_code,
  pre_glt_doc_base,pre_glt_doc_type,
  pre_glt_doc_number,pre_glt_serial,
  pre_glt_doc_date,pre_glt_gl_date,pre_glt_year,pre_glt_period,
  pre_glt_other_reference,pre_glt_currency,pre_glt_ex_rate,
  pre_glt_foreign_amount,pre_glt_local_amount,pre_glt_narration,
  pre_glt_module,pre_glt_detail_1,pre_glt_detail_2,pre_glt_detail_3,
  pre_glt_detail_4,pre_glt_detail_5,pre_glt_detail_6,
  pre_glt_detail_7,pre_glt_detail_8,pre_glt_detail_9,
  ip,created_by ,ua,ekey,created_date,temp_code,pre_glt_created,
  location_id,company_id)

  SELECT art_company,art_group,
  art_type,art_base_type,
  art_number, art_serial,
  art_gl_date,art_gl_date,'$fy','$fp',
  art_other_reference,art_currency,art_ex_rate,
  -art_foreign_amount,-art_local_amount,art_description,
  'ORDER',
  art_group,
  art_description,
  '$c->sub_ar_code',
  '$c->order_no','$c->bl_no','$c->sub_ar_date',
  '$c->sub_ar_code',art_group,art_description,
  ip,created_by,ua,ekey,now(),'$temp_code',now(),
  '$dev->company','$dev->location'    
   from gst_trans where art_number=:doc_no and art_type in ('OUTPUT IGST','OUTPUT SGST','OUTPUT CGST') ");

  $statement->execute(array(':doc_no'=>$on));
      if ($statement->rowCount()){
      $data["gld_header2_status"]=1;
    } else{
      $data["gld_header2_status"]=0;
    }    
  //ship gl ends

//gl ends

//$data["status"]=0;

$gst_status=0;
if($igst!=0)
{
  $gst_status=$data["igst_status"];
}else{

  if($data["cgst"]==0 && $data["sgst"]==0 && $data["igst"]==0)
  {
    $gst_status=1;
  }
  else if($data["cgst_status"]==1 && $data["sgst_status"]==1)
  {
    $gst_status=1;
  }else{
    $gst_status=0;
  }
}

if($data["odtrans_status"]==1 && $data["status"]==1  && count($ocs)==$ocs_count && $data["detail_status"]==1 && $data["ar_detail_docno_status"]==1 && $data["sht_status"]==1 && $data["gld_status"]==1 && $data["gld_header_status"]==1 && $data["ar_trans_status"]==1 && $data["tb_status"]==1 && $gst_status==1)
{
  $db->commit();
}else{
  $db->rollBack();
  $data["status"]=0;
  $data["msg"]="Unable to save. Please try again";
}

}

}else{

  if($dev->username=='prachi_accounts')
  {
    $statement = $db->prepare("UPDATE mt_order_ar_header  
  set sub_ar_doc_type=:sub_ar_doc_type,
  sub_ar_doc_base=:sub_ar_doc_base,
  sub_ar_code=:sub_ar_code,
  sub_ar_date=:sub_ar_date,

  sub_ar_gl_date=:sub_ar_gl_date,
  sub_ar_due_date=:sub_ar_due_date,
  sub_ar_age_date=:sub_ar_date,
  sub_ar_currency=:sub_ar_currency,
  sub_ar_ex_rate=:sub_ar_ex_rate,
  sub_ar_narration=:sub_ar_narration,
  sub_ar_notes=:sub_ar_notes,

  sub_ar_other_reference=:sub_ar_other_reference,
  sub_place_off_supply=:sub_place_off_supply,
  sub_place_off_supply_date=:sub_place_off_supply_date,
  sub_ar_other_reference_date=:sub_ar_other_reference_date,
  gst_percent=:gst_percent,charge_type=:charge_type,

  modified_by=:modified_by,modified_date=now() where id=:id");
$statement->execute(array(
':modified_by'=>$dev->username,
':id'=>$c->id,

':sub_ar_doc_type'=>$c->sub_ar_doc_type,
':sub_ar_doc_base'=>$c->sub_ar_doc_base,
':sub_ar_code'=>$c->sub_ar_code,
':sub_ar_date'=>$c->sub_ar_date,

':sub_ar_gl_date'=>$c->sub_ar_gl_date,
':sub_ar_due_date'=>$c->sub_ar_due_date,

':sub_ar_currency'=>$c->sub_ar_currency,
':sub_ar_ex_rate'=>$c->sub_ar_ex_rate,
':sub_ar_narration'=>$c->sub_ar_narration,
':sub_ar_notes'=>$c->sub_ar_notes,

':sub_ar_other_reference'=>$c->sub_ar_other_reference,
':sub_place_off_supply'=>$c->sub_place_off_supply,
':sub_place_off_supply_date'=>$c->sub_place_off_supply_date,
':sub_ar_other_reference_date'=>$c->sub_ar_other_reference_date,
':charge_type'=>$c->charge_type,


':gst_percent'=>$c->gst_percent,

));

if ($statement->rowCount()){
  $data["status"]=1;
  $data["msg"]="Updated";

} else{
  $data["status"]=0;
}
$data["doc_no"]=$c->sub_ar_doc_number;

//$data["status"]=0;
if($data["status"]==1 )
{
  $db->commit();
}else{
  $db->rollBack();
  $data["status"]=0;
  $data["msg"]="Unable to save. Please try again";
}
  }else{
    $data["status"]=0;
  $data["msg"]="Not allowed to update.";
  }

}
//



$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
    $db->rollBack();
    $data["status"]=0;
    $data["msg"]="Unable to save. Please try again";
  }
  
  return $data;

}

//agency invoice entry
public static function update_invoice_entry($dev,$code)
{
$data=array();

try
{
$db = Factory::getConnection();


$c=$code;
if($c->sub_ar_doc_type=="PRO-INV")
{

//get bl no from performa
$statement = $db->prepare("SELECT bl_no FROM mt_ship_ar_header 
  where sub_ar_doc_number=:sub_ar_doc_number");
$statement->execute(array(':sub_ar_doc_number'=>$c->sub_ar_doc_number));
$op11s=$statement->fetchAll(PDO::FETCH_ASSOC);
$code->bl_no=explode(",",$op11s[0]["bl_no"])[0];
//split by comma
//get vessel voyage info
$statement = $db->prepare("SELECT vessel,voyage,port,liner 
  FROM mt_voyage WHERE voyage=
  (SELECT voyage FROM mt_manifest_entry 
  WHERE bl_no=:bl_no)");
$statement->execute(array(':bl_no'=>$code->bl_no));
$op11s=$statement->fetchAll(PDO::FETCH_ASSOC);
if(count($op11s)>=1)
{
$op11=$op11s[0];
$code->voyage=$op11["voyage"];
$code->vessel=$op11["vessel"];
$code->liner=$op11["liner"];
$code->port=$op11["port"];
}

list($first) = explode("/", $c->sub_ar_doc_number);
$no=str_replace($first,$c->sub_ar_doc_type,$c->sub_ar_doc_number);

$statement = $db->prepare("UPDATE mt_ship_ar_header 
  set sub_ar_doc_type=:sub_ar_doc_type,
   sub_ar_doc_number=:sub_ar_doc_number,
  modified_by=:modified_by,modified_date=now() where id=:id");
$statement->execute(array(
':modified_by'=>$dev->username,
':id'=>$c->id,
':sub_ar_doc_type'=>$c->sub_ar_doc_type,
':sub_ar_doc_number'=>$no
));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';

} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}
$data["doc_no"]=$no;


//addition entry
$fy=self::getFinancialYear();
$fp=self::getFinancialPeriod($c->sub_ar_date);

//MT_AR_TRANS table
//FINANCIAL YEAR AND PERIOD IS PENDING
$statement = $db->prepare("INSERT into mt_ar_trans (
  art_company,art_code,art_type,art_number,art_serial,art_group,art_base_type,art_internal,art_other_reference,art_doc_date,art_gl_date,art_year,art_period,art_age_date,art_dp_date,art_currency,art_ex_rate,art_foreign_amount,art_local_amount,art_foreign_balance,art_local_balance,art_balance_status,art_description,art_notes,art_detail_2,art_detail_3,art_detail_4,art_posted_on,ip,created_by ,ua,ekey,created_date,
  company_id,location_id) 

SELECT sub_ar_company,
sub_ar_code,
sub_ar_doc_type,
sub_ar_doc_number,
sub_ar_internal_number,
sub_ar_group,
sub_ar_doc_base,
sub_ar_internal_number,
sub_ar_other_reference,
sub_ar_date,
sub_ar_gl_date,
'$fy',
'$fp',
sub_ar_age_date,
sub_ar_due_date,
sub_ar_currency,
sub_ar_ex_rate,
sub_ar_f_amount,
sub_ar_l_amount,
sub_ar_f_amount,
sub_ar_l_amount,
'A',
sub_ar_narration,
sub_ar_notes,
sub_place_off_supply,
sub_place_off_supply_date,
sub_ar_other_reference_date,
now(),
'$dev->ip','$dev->username' ,'$dev->ua','$dev->ekey',
now(),'$dev->company','$dev->location' 
FROM mt_ship_ar_header WHERE sub_ar_doc_number=:temp_code");

$statement->execute(array(':temp_code'=>$no));

if ($statement->rowCount()){
  $data["AR_TRANS_status"]=1;
} else{
  $data["AR_TRANS_status"]=0;
}

//trans balance query

//query 5

$temp_code=uniqid($dev->uid);
$statement = $db->prepare("INSERT into mt_ar_trans_balance
(ardm_company,ardm_code,ardm_doc_type,ardm_doc_number,
  ardm_serial,ardm_other_reference,ardm_date,ardm_currency,
  ardm_ex_rate,ardm_of_amount,ardm_ol_amount,
  ardm_bf_amount,ardm_bl_amount,
  ardm_pf_amount,ardm_pl_amount,ardm_status,
ip,created_by,ua,ekey,created_date,temp_code,company_id,location_id)

SELECT art_company,art_code,art_type,art_number,
art_serial,art_other_reference,art_gl_date,art_currency,
art_ex_rate,art_foreign_amount,art_local_amount,
art_foreign_balance,art_local_balance,
0,0,'PENDING',
ip,created_by,ua,ekey,now(),'$temp_code',
'$dev->company','$dev->location'  
 from mt_ar_trans where art_number=:doc_no
");

$statement->execute(array(':doc_no'=>$no));
//var_dump($statement->debugDumpParams());
if ($statement->rowCount()){
  $data["tb_status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data["tb_status"]=0;
    //echo 'Failure: 0 rows were affected.';
}

$order_id=0;

// update order cost to invoiced from proforma
$charge_query="UPDATE mt_order_cost set invoiced=1,
inv_pay_no=:doc_no where proforma=:id";
$statement = $db->prepare($charge_query);
$statement->execute(array(':id'=>$c->sub_ar_doc_number,
':doc_no'=>$no));

if ($statement->rowCount()){
  $data["cost_status"]=1;
} else{
  $data["cost_status"]=0;
}

$statement = $db->prepare("SELECT distinct order_id from mt_order_cost where proforma=:proforma");
$statement->execute(array(':proforma'=>$c->sub_ar_doc_number));

$ocs=$statement->fetchAll(PDO::FETCH_ASSOC);
//update order status to part invoiced or invoiced
for($i=0;$i<count($ocs);$i++)
{
$cd=$ocs[$i];
$oq="UPDATE mt_order_entry set status=(SELECT CASE WHEN (SELECT count(*) FROM `mt_order_cost` WHERE invoiced is null and type='INCOME' and order_id=:id)=0 THEN 'INVOICED'
    ELSE 'PART INVOICED'
        END)
      WHERE id=:id";

 $statement = $db->prepare($oq);
 $statement->execute(array(':id'=>$cd["order_id"]));

  if ($statement->rowCount()){
  $data["order_status-".$cd["order_id"]]=1;
} else{
  $data["order_status-".$cd["order_id"]]=0;
}
}

//update cost details to invoiced
 $statement = $db->prepare("UPDATE mt_ship_ar_details set inv_status='INVOICED' where sub_ard_doc_number=:doc_no");
 $statement->execute(array(':doc_no'=>$c->sub_ar_doc_number));

  if ($statement->rowCount()){
  $data["detail_status"]=1;
} else{
  $data["detail_status"]=0;
}

$statement = $db->prepare("UPDATE mt_ship_ar_details  
  set
   sub_ard_doc_number=:sub_ar_doc_number where sub_ard_doc_number=:id");
$statement->execute(array(
':id'=>$c->sub_ar_doc_number,
':sub_ar_doc_number'=>$no
));

if ($statement->rowCount()){
  $data["ar_detail_status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data["ar_detail_status"]=0;
    //echo 'Failure: 0 rows were affected.';
}

//ship gl details
$temp_code=uniqid($dev->uid);

$multiple_order_no='';
$code->order_no=substr_replace($code->order_no, "", -1);
$sa=explode(',', $code->order_no);
$strLength=count($sa);
for ($i = 0; $i < $strLength; $i++) {

  if($i+1==$strLength)
  {
    $multiple_order_no=$multiple_order_no."'$sa[$i]'";
  }else{
    $multiple_order_no=$multiple_order_no."'$sa[$i]',";
  }

}
$on=$no;

$statement = $db->prepare("INSERT into ship_gl_details 
( pre_glt_company,pre_glt_code,pre_glt_doc_base,pre_glt_doc_type,pre_glt_doc_number,pre_glt_serial,pre_glt_doc_date,pre_glt_gl_date,pre_glt_year,pre_glt_period,pre_glt_other_reference,pre_glt_currency,pre_glt_ex_rate,pre_glt_foreign_amount,pre_glt_local_amount,pre_glt_narration,pre_glt_module,pre_glt_detail_1,pre_glt_detail_2,pre_glt_detail_3,pre_glt_detail_4,pre_glt_detail_5,pre_glt_detail_6,
  ip,created_by ,ua,ekey,created_date,temp_code)


  SELECT '$dev->company',(
IFNULL((SELECT income_gl from mt_charge_group_detail 
  where code=charge_desc),(SELECT gl_receivable_pdc from mt_gl_link where name= (select liner from mt_voyage where voyage=(select voyage from mt_manifest_entry where bl_no='$code->bl_no'))))
  ),'SHIP','INV','$on','0',
  '$c->sub_ar_date','$c->sub_ar_date','$fy','$fp','$code->bl_no',
  currency,ex_rate,-selling_amount,-selling_base_amount,remarks,
  'RCT','$code->order_no','$c->sub_ar_date','$c->sub_ar_doc_base',
  '$code->bl_no',
  '$c->sub_ar_code',charge_desc,'$dev->ip',
  '$dev->uid','$dev->ua','$dev->ekey',now(),'$temp_code' from mt_order_cost 
  where proforma='$c->sub_ar_doc_number'");


$statement->execute();
    if ($statement->rowCount()){
    $data["gld_status"]=1;
      //echo 'Success: At least 1 row was affected.';
  } else{
    $data["gld_status"]=0;
      //echo 'Failure: 0 rows were affected.';
  }

//gl header
//get sum values

$statement = $db->prepare("SELECT sum(selling_amount) samt,sum(selling_base_amount) sbamt from mt_order_cost 
  where proforma='$c->sub_ar_doc_number'");
$statement->execute();

$svs=$statement->fetchAll(PDO::FETCH_ASSOC);
$sv=$svs[0];

$base_currency=getCurrency($dev);

$statement = $db->prepare("INSERT into ship_gl_details 
( pre_glt_company,pre_glt_code,pre_glt_doc_base,pre_glt_doc_type,pre_glt_doc_number,pre_glt_serial,pre_glt_doc_date,pre_glt_gl_date,pre_glt_year,pre_glt_period,pre_glt_other_reference,pre_glt_currency,pre_glt_ex_rate,pre_glt_foreign_amount,pre_glt_local_amount,pre_glt_narration,pre_glt_module,pre_glt_detail_1,pre_glt_detail_2,pre_glt_detail_3,pre_glt_detail_4,pre_glt_detail_5,pre_glt_detail_6,
  ip,created_by ,ua,ekey,created_date,temp_code,pre_glt_created)

  VALUES('$dev->company',(select gl_account from mt_gl_link where name='RECEIVABLE' limit 1),'SHIP','INV','$no',1,
  '$c->sub_ar_date','$c->sub_ar_date','$fy','$fp','$code->bl_no',
  '$base_currency',1,:samt,:sbamt,'remarks',
  'SHIP','$code->order_no','$c->sub_ar_date','$c->sub_ar_doc_base',
  '$code->bl_no',
  '$c->sub_ar_code','charge_desc','$dev->ip',
  '$dev->uid','$dev->ua','$dev->ekey',now(),'$temp_code',now())");

$statement->execute(array(':samt'=>$sv["samt"],':sbamt'=>$sv["sbamt"]));
    if ($statement->rowCount()){
    $data["gld_header_status"]=1;
      //echo 'Success: At least 1 row was affected.';
  } else{
    $data["gld_header_status"]=0;
      //echo 'Failure: 0 rows were affected.';
  }

  //ship gl ends

//4
$temp_code=uniqid($dev->uid);
//$gds=self::get_gl_Link();
$statement = $db->prepare("INSERT into mt_ship_trans
( st_company,st_doc_type,st_doc_number,st_serial,st_doc_base,st_date,st_gl_date,st_dp_date,st_age_date,st_year,st_period,st_carrier,st_vessel,st_voyage,st_port,st_bl,st_bl_type,st_charge,st_other_reference,st_currency,st_exchange,st_foreign,st_local,st_narration,st_status,
  st_posted_on,
  ip,created_by ,ua,ekey,created_date,temp_code) 

  SELECT '$dev->company','INV','$on','0','SHIP','$c->sub_ar_date',
  '$c->sub_ar_date',
  '$c->sub_ar_date','$c->sub_ar_date','$fy','$fp','$code->liner',
  '$code->vessel','$code->voyage','$code->port','$code->bl_no',
  '$c->sub_ar_doc_base',charge_desc,'$code->order_no'
  ,currency,ex_rate,-selling_amount,
  -selling_base_amount,remarks,
  status,now(),
  '$dev->ip',
  '$dev->uid','$dev->ua','$dev->ekey',now(),'$temp_code' from mt_order_cost 
  where proforma='$c->sub_ar_doc_number'");
$statement->execute();
    if ($statement->rowCount()){
    $data["sht_status"]=1;
      //echo 'Success: At least 1 row was affected.';
  } else{
    $data["sht_status"]=0;
      //echo 'Failure: 0 rows were affected.';
  }

}else{
  //updating pro details
  $statement = $db->prepare("UPDATE mt_ship_ar_header  
  set sub_ar_doc_type=:sub_ar_doc_type,
sub_ar_other_reference=:sub_ar_other_reference,
sub_ar_currency=:sub_ar_currency,
sub_ar_ex_rate=:sub_ar_ex_rate,
sub_place_off_supply=:sub_place_off_supply,
sub_ar_narration=:sub_ar_narration,
sub_ar_notes=:sub_ar_notes,
sub_ar_code=:sub_ar_code,
modified_by=:modified_by,modified_date=now() where id=:id");
$statement->execute(array(
':modified_by'=>$dev->username,
':id'=>$c->id,
':sub_ar_doc_type'=>$c->sub_ar_doc_type,

':sub_ar_other_reference'=>$c->sub_ar_other_reference,
':sub_ar_currency'=>$c->sub_ar_currency,
':sub_ar_ex_rate'=>$c->sub_ar_ex_rate,
':sub_place_off_supply'=>$c->sub_place_off_supply,
':sub_ar_narration'=>$c->sub_ar_narration,
':sub_ar_notes'=>$c->sub_ar_notes,
':sub_ar_code'=>$c->sub_ar_code
));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';

} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}
$data["doc_no"]=$c->sub_ar_doc_number;
}

//addition entry ends

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;

}


public static function save_invoice_entry_pro($dev,$code)
{
$data=array();

try
{
$db = Factory::getConnection();

$temp_code=uniqid($dev->uid);

$c=$code->inv;

//START GST CALC
//Get gstin detail
$statement = $db->prepare("SELECT pan, gstin 
  from mt_business_partner    
  where code=:sub_ar_code ");
$statement->execute(array(':sub_ar_code'=>$c->sub_ar_code ));
$data["cngList"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$r=$data["cngList"][0];  
$consignee_pan_no=$r["pan"];
$billparty_gstin=$r["gstin"];

//check state
$startString="33";
$len = strlen($startString);
$cgst=0;
$sgst=0;
$igst=0;

//taxable
/*
$statement = $db->prepare("SELECT sum(selling_base_amount) taxable from mt_order_cost  
where order_id=(select id from mt_order_entry where order_no=REPLACE(:order_no, ',', '') limit 1)
and charge_desc!='OFRT'  and invoiced !=1 ");
$statement->execute(array(':order_no'=>$code->order_no));
$taxds=$statement->fetchAll(PDO::FETCH_ASSOC);
*/
$rate_total=0;
$cds=$code->cd;
for($i=0;$i<count($cds);$i++)
  {
    $cd=$cds[$i];
    if($cd->charge_desc!='OFRT')
    {
    $rate_total=$rate_total+$cd->total_amt;
    }
  }
$rate=$rate_total;
//$rate=($rate_total*18)/100;
//$rate=round($rate,2);
//$rate=$taxds[0]["taxable"];
//$data["taxds"]=$taxds;
$data["taxds"]=$rate;

//$rate=$c->total_local_amt;
#gst perc
$gst_percent=(float)$c->gst_percent;


//$state_cond=(substr($billparty_gstin, 0, $len) === $startString);
$data["billparty_gstin"]=$billparty_gstin;
$data["startString"]=$startString;

if($gst_percent!=0){

  if(substr($billparty_gstin, 0, $len)==$startString)
  {
      $tp=$gst_percent/2;
      $tv=($rate*$tp)/100;
      $cgst=round($tv,2);
      $sgst=round($tv,2);
      $data["cgst"]=$cgst;
      $data["sgst"]=$sgst;
      $data["tv"]=$tv;
      $data["tp"]=$tp;
      $data["rate"]=$rate;
      $data["tp"]=$tp;

  }else{
      $igst=round(($rate*$gst_percent)/100,2);
      $data["igst"]=$igst;
      $data["rate"]=$rate;
      $data["gst_percent"]=$gst_percent;
  }
}
//END GST CALC

$statement = $db->prepare("INSERT into mt_ship_ar_header(sub_ar_company,
  sub_ar_doc_type,sub_ar_doc_number,sub_ar_doc_base,sub_ar_gl_date,sub_ar_due_date,sub_ar_age_date,sub_ar_date,sub_ar_other_reference,sub_ar_currency,sub_ar_ex_rate,sub_place_off_supply,sub_place_off_supply_date,sub_ar_narration,sub_ar_notes,sub_ar_code,
  sub_ar_group,
  sub_ar_status, 
  sub_ar_other_reference_date,
  ip,created_by ,ua,ekey,created_date,temp_code,total_local_amt,order_no,
  bl_no,sub_ar_user,sub_ar_f_amount,sub_ar_l_amount,
  gst_percent, igst, cgst, sgst,
  company_id,location_id) 
values(:company_id,:sub_ar_doc_type,:sub_ar_doc_number,:sub_ar_doc_base,:sub_ar_gl_date,:sub_ar_due_date,:sub_ar_age_date,:sub_ar_date,:sub_ar_other_reference,:sub_ar_currency,:sub_ar_ex_rate,:sub_place_off_supply,:sub_place_off_supply_date,:sub_ar_narration,:sub_ar_notes,:sub_ar_code,
'ACCOUNTS RECEIVABLE',
:sub_ar_status,
:sub_ar_other_reference_date,
:ip ,:created_by ,
:ua ,:ekey,now(),:temp_code,:total_local_amt,:order_no,
  :bl_no,:sub_ar_user,:total_local_amt,:total_local_amt,
  :gst_percent, :igst, :cgst, :sgst,
:company_id,:location_id)");

if($c->sub_ar_due_date=="")
{
  $c->sub_ar_due_date=null;
}

if($c->sub_ar_other_reference_date=="")
{
  $c->sub_ar_other_reference_date=null;
}

if($c->sub_ar_ex_rate=="")
{
  $c->sub_ar_ex_rate=null;
}

$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->username ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,

':company_id'=>$dev->company,
':sub_ar_doc_type'=>$c->sub_ar_doc_type,
':sub_ar_doc_number'=>$c->sub_ar_doc_number,
':sub_ar_doc_base'=>$c->sub_ar_doc_base,
':sub_ar_gl_date'=>$c->sub_ar_gl_date,
':sub_ar_due_date'=>$c->sub_ar_due_date,
':sub_ar_age_date'=>$c->sub_ar_date,
':sub_ar_date'=>$c->sub_ar_date,
':sub_ar_other_reference'=>$c->sub_ar_other_reference,
':sub_ar_currency'=>$c->sub_ar_currency,
':sub_ar_ex_rate'=>$c->sub_ar_ex_rate,
':sub_place_off_supply'=>$c->sub_place_off_supply,
':sub_place_off_supply_date'=>$c->sub_place_off_supply_date,
':sub_ar_narration'=>$c->sub_ar_narration,
':sub_ar_notes'=>$c->sub_ar_notes,
':sub_ar_code'=>$c->sub_ar_code,
':sub_ar_status'=>'A', // means PROFORMA
':sub_ar_other_reference_date'=>$c->sub_ar_other_reference_date,

':temp_code'=>$temp_code,
':total_local_amt'=>$c->total_local_amt,
':order_no'=>$code->order_no,
':bl_no'=>$code->bl_no,
':sub_ar_user'=>$dev->username,

':gst_percent'=>$gst_percent,
':igst'=>$igst,
':cgst'=>$cgst,
':sgst'=>$sgst,

':company_id'=>$dev->company,
':location_id'=>$dev->location
));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';

} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}


$rate_total=0;
$cds=$code->cd;
for($i=0;$i<count($cds);$i++)
  {
    $cd=$cds[$i];
    $rate_total=$rate_total+$cd->selling_amount;
  }
$rate=($rate_total*18)/100;
$rate=round($rate,2);
$data["taxds"]=$rate;

//generate doc number

$data["temp_code"]=$temp_code;

$statement = $db->prepare("SELECT id from mt_ship_ar_header where created_by=:created_by and temp_code=:temp_code");
$statement->execute(array(':temp_code'=>$temp_code,
  ':created_by'=>$dev->username));
$op=$statement->fetchAll(PDO::FETCH_ASSOC);

$data["id"]=$op;

$fid=self::setFourDigit($op[0]["id"]);

$on=$c->sub_ar_doc_type."/".date("Y")."/".date('m')."/".$c->sub_place_off_supply."/".$fid;

 $statement = $db->prepare("UPDATE mt_ship_ar_header 
  SET sub_ar_doc_number=:ond where id=:id");
  $statement->execute(array(':id'=>$op[0]["id"],':ond'=>$on));
  
    if ($statement->rowCount()){
    $data["invid_status"]=1;
      //echo 'Success: At least 1 row was affected.';
  } else{
    $data["invid_status"]=0;
      //echo 'Failure: 0 rows were affected.';
  }

$data["doc_no"]=$on;


//doc number ends


$order_id=0; 
if($data["status"]==1)
{
  $cds=$code->cd;
  $ocds=$code->ocd;

  $q="INSERT into mt_ship_ar_details(
      sub_ard_company,sub_ard_doc_type,sub_ard_doc_number,sub_ard_serial,sub_ard_currency,sub_ard_ex_rate,sub_ard_foreign_amount,sub_ard_local_amount,sub_ard_narration,sub_ard_notes,sub_ard_detail_1,sub_ard_detail_2,sub_ard_detail_3,sub_ard_detail_4,sub_ard_detail_5,sub_ard_detail_6,sub_ard_basis,sub_ard_rate,sub_ard_quantity,ip,created_by ,ua,ekey,created_date,charge_desc,basis_type,taxable,total_tax_amt,total_amt,inv_status,sub_ard_detail_7,sub_ard_detail_8,sub_ard_detail_9,sub_ard_detail_10) 
      VALUES(:sub_ard_company,:sub_ard_doc_type,:sub_ard_doc_number,:sub_ard_serial,:sub_ard_currency,:sub_ard_ex_rate,:sub_ard_foreign_amount,:sub_ard_local_amount,:sub_ard_narration,:sub_ard_notes,:sub_ard_detail_1,:sub_ard_detail_2,:sub_ard_detail_3,:sub_ard_detail_4,:sub_ard_detail_5,:sub_ard_detail_6,:sub_ard_basis,:sub_ard_rate,:sub_ard_quantity,:ip ,:created_by ,
:ua ,:ekey,now(),:charge_desc,:basis_type,:taxable,:total_tax_amt,:total_amt,:inv_status,'$code->liner','$code->vessel','$code->voyage','$code->port')";
$charge_query="UPDATE mt_order_cost set invoiced=2,proforma=:doc_no where id=:id";
$i=0;
$c->sub_ar_doc_number = $on;

  for(;$i<count($cds);$i++)
  {
    $cd=$cds[$i];
    $statement = $db->prepare($q);
    $ar=self::setChargeDetails('MANIFEST',$cd,$dev,$c,$i);
    $ar[':inv_status']='PROFORMA';
    $statement->execute($ar);

    $statement = $db->prepare($charge_query);
    $statement->execute(array(':id'=>$cd->id,':doc_no'=>$on));
}
}


$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}
//for auto invoice from do

public static function save_invoice_entry_fordo($dev,$code)
{
$data=array();

try
{
$db = Factory::getConnection();

$temp_code=uniqid($dev->uid);

$c=$code->info;

//get do fee info
$statement = $db->prepare("SELECT id,charge_desc,type,basis_type,
  basis_uom,qty,currency,ex_rate,rate_selling,selling_amount,selling_base_amount from mt_order_cost where invoiced is null and type='INCOME' and charge_desc='DOF' and order_id=(SELECT id from mt_order_entry where order_no=:order_no)");
$statement->execute(array(':order_no'=>$c->order_no));
$orders_info=$statement->fetchAll(PDO::FETCH_ASSOC);
$order_cost=0;
$c->total_local_amt=225;
if(count($orders_info)!=0)
{
$order_cost=$orders_info[0];
$c->total_local_amt=$order_cost["selling_amount"];

$statement = $db->prepare("INSERT into mt_ship_ar_header(sub_ar_company,
  sub_ar_doc_type,sub_ar_doc_number,sub_ar_doc_base,sub_ar_gl_date,sub_ar_due_date,sub_ar_age_date,sub_ar_date,sub_ar_other_reference,sub_ar_currency,sub_ar_ex_rate,sub_place_off_supply,sub_place_off_supply_date,sub_ar_narration,sub_ar_notes,sub_ar_code,
  sub_ar_group,
  sub_ar_status, 
  sub_ar_other_reference_date,
  ip,created_by ,ua,ekey,created_date,temp_code,total_local_amt,order_no,
  bl_no,sub_ar_user,sub_ar_f_amount,sub_ar_l_amount,
  company_id,location_id) 
values(:company_id,:sub_ar_doc_type,:sub_ar_doc_number,:sub_ar_doc_base,:sub_ar_gl_date,:sub_ar_due_date,:sub_ar_age_date,:sub_ar_date,:sub_ar_other_reference,:sub_ar_currency,:sub_ar_ex_rate,:sub_place_off_supply,:sub_place_off_supply_date,:sub_ar_narration,:sub_ar_notes,:sub_ar_code,
'ACCOUNTS RECEIVABLE',
:sub_ar_status,
:sub_ar_other_reference_date,
:ip ,:created_by ,
:ua ,:ekey,now(),:temp_code,:total_local_amt,:order_no,
  :bl_no,:sub_ar_user,:total_local_amt,:total_local_amt,
:company_id,:location_id)");

$do=$code->do;
$c->sub_ar_due_date=$do->do_date;
$c->sub_ar_other_reference_date=$do->do_date;
$c->sub_ar_gl_date=$do->do_date;
$c->sub_ar_date=$do->do_date;

$c->sub_ar_ex_rate=$order_cost["ex_rate"];;
$c->sub_ar_other_reference='';
$c->sub_ar_currency=$order_cost["currency"];
$c->sub_place_off_supply=$dev->location;
$c->sub_place_off_supply_date=$do->do_date;
$c->sub_ar_narration=$do->narration;
$c->sub_ar_notes=$do->remarks;
$c->sub_ar_code=$c->consignee;

$c->order_no=$c->order_no;
$c->bl_no=$c->bl_no;

$c->vessel=$c->vessel;
$c->voyage=$c->voyage;
$c->port=$c->pof;
$c->liner=$c->eline;

$c->sub_ar_doc_type="IMP-INV";
$c->sub_ar_doc_base="AGENCY IMPORT";
$c->sub_ar_doc_number='';

$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->username ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,

':company_id'=>$dev->company,
':sub_ar_doc_type'=>$c->sub_ar_doc_type,
':sub_ar_doc_number'=>$c->sub_ar_doc_number,
':sub_ar_doc_base'=>$c->sub_ar_doc_base,
':sub_ar_gl_date'=>$c->sub_ar_gl_date, //do date
':sub_ar_due_date'=>$c->sub_ar_due_date,
':sub_ar_age_date'=>$c->sub_ar_date,
':sub_ar_date'=>$c->sub_ar_date,
':sub_ar_other_reference'=>$c->sub_ar_other_reference, //empty
':sub_ar_currency'=>$c->sub_ar_currency, // 
':sub_ar_ex_rate'=>$c->sub_ar_ex_rate, //1
':sub_place_off_supply'=>$c->sub_place_off_supply, //dev-location
':sub_place_off_supply_date'=>$c->sub_place_off_supply_date,
':sub_ar_narration'=>$c->sub_ar_narration, //narration
':sub_ar_notes'=>$c->sub_ar_notes, //remarks
':sub_ar_code'=>$c->sub_ar_code, // consignee
':sub_ar_status'=>'P', // means POSTED
':sub_ar_other_reference_date'=>$c->sub_ar_other_reference_date,

':temp_code'=>$temp_code,
':total_local_amt'=>$c->total_local_amt, // do fee 225
':order_no'=>$c->order_no,
':bl_no'=>$c->bl_no,
':sub_ar_user'=>$dev->username,

':company_id'=>$dev->company,
':location_id'=>$dev->location
));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';

} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}

//generate doc number

$data["temp_code"]=$temp_code;

$statement = $db->prepare("SELECT id from mt_ship_ar_header where created_by=:created_by and temp_code=:temp_code");
$statement->execute(array(':temp_code'=>$temp_code,
  ':created_by'=>$dev->username));
$op=$statement->fetchAll(PDO::FETCH_ASSOC);

$data["id"]=$op;

$fid=self::setFourDigit($op[0]["id"]);

$on=$c->sub_ar_doc_type."/".date("Y")."/".date('m')."/".$c->sub_place_off_supply."/".$fid;

 $statement = $db->prepare("UPDATE mt_ship_ar_header 
  SET sub_ar_doc_number=:ond where id=:id");
  $statement->execute(array(':id'=>$op[0]["id"],':ond'=>$on));
  
    if ($statement->rowCount()){
    $data["invid_status"]=1;
      //echo 'Success: At least 1 row was affected.';
  } else{
    $data["invid_status"]=0;
      //echo 'Failure: 0 rows were affected.';
  }

$data["doc_no"]=$on;

$fy=self::getFinancialYear();
$fp=self::getFinancialPeriod($c->sub_ar_date);
//doc number ends

//MT_AR_TRANS table
//FINANCIAL YEAR AND PERIOD IS PENDING
$statement = $db->prepare("INSERT into mt_ar_trans (
  art_company,art_code,art_type,art_number,art_serial,art_group,art_base_type,art_internal,art_other_reference,art_doc_date,art_gl_date,art_year,art_period,art_age_date,art_dp_date,art_currency,art_ex_rate,art_foreign_amount,art_local_amount,art_foreign_balance,art_local_balance,art_balance_status,art_description,art_notes,art_detail_2,art_detail_3,art_detail_4,art_posted_on,ip,created_by ,ua,ekey,created_date,
  company_id,location_id) 

SELECT sub_ar_company,
sub_ar_code,
sub_ar_doc_type,
sub_ar_doc_number,
sub_ar_internal_number,
sub_ar_group,
sub_ar_doc_base,
sub_ar_internal_number,
sub_ar_other_reference,
sub_ar_date,
sub_ar_gl_date,
'$fy',
'$fp',
sub_ar_age_date,
sub_ar_due_date,
sub_ar_currency,
sub_ar_ex_rate,
sub_ar_f_amount,
sub_ar_l_amount,
sub_ar_f_amount,
sub_ar_l_amount,
'A',
sub_ar_narration,
sub_ar_notes,
sub_place_off_supply,
sub_place_off_supply_date,
sub_ar_other_reference_date,
now(),
'$dev->ip','$dev->username' ,'$dev->ua','$dev->ekey',
now(),'$dev->company','$dev->location'  
FROM mt_ship_ar_header WHERE temp_code=:temp_code");

$statement->execute(array(':temp_code'=>$temp_code));

if ($statement->rowCount()){
  $data["AR_TRANS_status"]=1;
} else{
  $data["AR_TRANS_status"]=0;
}

//trans balance


// query 6
$temp_code=uniqid($dev->uid);
$statement = $db->prepare("INSERT into mt_ar_trans_balance
(ardm_company,ardm_code,ardm_doc_type,ardm_doc_number,
  ardm_serial,ardm_other_reference,ardm_date,ardm_currency,
  ardm_ex_rate,ardm_of_amount,ardm_ol_amount,
  ardm_bf_amount,ardm_bl_amount,
  ardm_pf_amount,ardm_pl_amount,ardm_status,
ip,created_by,ua,ekey,created_date,temp_code,company_id,location_id)

SELECT art_company,art_code,art_type,art_number,
art_serial,art_other_reference,art_gl_date,art_currency,
art_ex_rate,art_foreign_amount,art_local_amount,
art_foreign_balance,art_local_balance,
0,0,'PENDING',
ip,created_by,ua,ekey,now(),'$temp_code',
'$dev->company','$dev->location'  
 from mt_ar_trans where art_number=:doc_no
");

$statement->execute(array(':doc_no'=>$on));
//var_dump($statement->debugDumpParams());
if ($statement->rowCount()){
  $data["tb_status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data["tb_status"]=0;
    //echo 'Failure: 0 rows were affected.';
}

//trans balance ends
$order_id=0;
if($data["status"]==1)
{
  

  $q="INSERT into mt_ship_ar_details(
      sub_ard_company,sub_ard_doc_type,sub_ard_doc_number,sub_ard_serial,sub_ard_currency,sub_ard_ex_rate,sub_ard_foreign_amount,sub_ard_local_amount,sub_ard_narration,sub_ard_notes,sub_ard_detail_1,sub_ard_detail_2,sub_ard_detail_3,sub_ard_detail_4,sub_ard_detail_5,sub_ard_detail_6,sub_ard_basis,sub_ard_rate,sub_ard_quantity,ip,created_by ,ua,ekey,created_date,charge_desc,basis_type,taxable,total_tax_amt,total_amt,inv_status,sub_ard_detail_7,sub_ard_detail_8,sub_ard_detail_9,sub_ard_detail_10) 
      VALUES(:sub_ard_company,:sub_ard_doc_type,:sub_ard_doc_number,:sub_ard_serial,:sub_ard_currency,:sub_ard_ex_rate,:sub_ard_foreign_amount,:sub_ard_local_amount,:sub_ard_narration,:sub_ard_notes,:sub_ard_detail_1,:sub_ard_detail_2,:sub_ard_detail_3,:sub_ard_detail_4,:sub_ard_detail_5,:sub_ard_detail_6,:sub_ard_basis,:sub_ard_rate,:sub_ard_quantity,:ip ,:created_by ,
:ua ,:ekey,now(),:charge_desc,:basis_type,:taxable,:total_tax_amt,:total_amt,:inv_status,'$c->eline',
  '$c->vessel','$c->voyage','$c->pof')";
$charge_query="UPDATE mt_order_cost 
set invoiced=1,inv_pay_no=:docno where id=:id";
$i=0;
$c->sub_ar_doc_number = $on;
$order_cost_ids=$order_cost["id"];

//$order_cost_ids=$order_cost_ids."'".$cd->id."',";

$statement = $db->prepare($q);
$ar=array(':ip'=>$dev->ip,':created_by'=>$dev->uid ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,

':sub_ard_company'=>$dev->company,
':sub_ard_doc_type'=>$c->sub_ar_doc_type, //IMP_INV
':sub_ard_doc_number'=>$c->sub_ar_doc_number,
':sub_ard_serial'=>$i+1,
':sub_ard_currency'=>$c->sub_ar_currency,
':sub_ard_ex_rate'=>$c->sub_ar_ex_rate,
':sub_ard_foreign_amount'=>$order_cost["selling_amount"], 
':sub_ard_local_amount'=>$order_cost["selling_base_amount"],
':sub_ard_narration'=>$do->narration, 
':sub_ard_notes'=>$do->remarks, //remarks
':sub_ard_detail_1'=>$c->order_no,
':sub_ard_detail_2'=>$do->do_date, //do date
':sub_ard_detail_3'=>'AGENCT IMPORT', //AGENCT IMPORT
':sub_ard_detail_4'=>$c->bl_no,
':sub_ard_detail_5'=>$c->consignee, //consignee
':sub_ard_detail_6'=>'MANIFEST', //MANIFEST
':sub_ard_basis'=>'', //
':sub_ard_rate'=>$order_cost["selling_amount"], //225
':sub_ard_quantity'=>$order_cost["qty"], //1
':charge_desc'=>'DOF', //DOF
':basis_type'=>$order_cost["basis_type"],
':taxable'=>'',

':total_tax_amt'=>'',
':total_amt'=>$order_cost["selling_amount"],
':inv_status'=>'INVOICED'
);
    $statement->execute($ar);

    $statement = $db->prepare($charge_query);
    $statement->execute(array(':id'=>$order_cost_ids,
      ':docno'=>$on));

      //update order status
  $oq="UPDATE mt_order_entry t1 set modified_date=now(),status=CASE WHEN (SELECT count(*) FROM `mt_order_cost` WHERE invoiced is null and order_id=t1.id 
  and type='INCOME')=0 THEN 'INVOICED'
    ELSE 'PART INVOICED'
        END 
      WHERE order_no=:id";

      $statement = $db->prepare($oq);
      $statement->execute(array(':id'=>$c->order_no));
      
      if ($statement->rowCount()){
  $data["ord_inv_status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data["ord_inv_status"]=0;
    //echo 'Failure: 0 rows were affected.';
}
 

//$order_cost_ids=substr_replace($order_cost_ids,"",-1);

  //ship gl details
$temp_code=uniqid($dev->uid);
/*
$multiple_order_no='';
$sa=explode(',', $code->order_no);
$strLength=count($sa);
for ($i = 0; $i < $strLength; $i++) {

  if($i+1==$strLength)
  {
    $multiple_order_no=$multiple_order_no."'$sa[$i]'";
  }else{
    $multiple_order_no=$multiple_order_no."'$sa[$i]',";
  }

}*/

$statement = $db->prepare("INSERT into ship_gl_details 
( pre_glt_company,pre_glt_code,pre_glt_doc_base,pre_glt_doc_type,pre_glt_doc_number,pre_glt_serial,pre_glt_doc_date,pre_glt_gl_date,pre_glt_year,pre_glt_period,pre_glt_other_reference,pre_glt_currency,pre_glt_ex_rate,pre_glt_foreign_amount,pre_glt_local_amount,pre_glt_narration,pre_glt_module,pre_glt_detail_1,pre_glt_detail_2,pre_glt_detail_3,pre_glt_detail_4,pre_glt_detail_5,pre_glt_detail_6,
  ip,created_by ,ua,ekey,created_date,temp_code)


  SELECT '$dev->company',(
  IFNULL((SELECT income_gl from mt_charge_group_detail 
  where code=charge_desc),(SELECT gl_receivable_pdc from mt_gl_link where name= (select liner from mt_voyage where voyage=(select voyage from mt_manifest_entry where bl_no='$c->bl_no'))))
  ),'SHIP','INV','$on','0',
  '$c->sub_ar_date','$c->sub_ar_date','$fy','$fp','$c->bl_no',
  currency,ex_rate,-selling_amount,-selling_base_amount,remarks,
  'SHIP','$c->order_no','$c->sub_ar_date','$c->sub_ar_doc_base',
  '$c->bl_no',
  '$c->sub_ar_code',charge_desc,'$dev->ip',
  '$dev->uid','$dev->ua','$dev->ekey',now(),'$temp_code' from mt_order_cost 
  where id ='$order_cost_ids' and type='INCOME' 
  and charge_desc='DOF'");
//charge desc DOF

$statement->execute();
    if ($statement->rowCount()){
    $data["gld_status"]=1;
      //echo 'Success: At least 1 row was affected.';
  } else{
    $data["gld_status"]=0;
      //echo 'Failure: 0 rows were affected.';
  }

//gl header
//get sum values

$statement = $db->prepare("SELECT sum(selling_amount) samt,sum(selling_base_amount) sbamt from mt_order_cost 
  where id='$order_cost_ids' and charge_desc='DOF'
   and type='INCOME'");
$statement->execute();

$svs=$statement->fetchAll(PDO::FETCH_ASSOC);
$sv=$svs[0];

$base_currency=getCurrency($dev);

$statement = $db->prepare("INSERT into ship_gl_details 
( pre_glt_company,pre_glt_code,pre_glt_doc_base,pre_glt_doc_type,pre_glt_doc_number,pre_glt_serial,pre_glt_doc_date,pre_glt_gl_date,pre_glt_year,pre_glt_period,pre_glt_other_reference,pre_glt_currency,pre_glt_ex_rate,pre_glt_foreign_amount,pre_glt_local_amount,pre_glt_narration,pre_glt_module,pre_glt_detail_1,pre_glt_detail_2,pre_glt_detail_3,pre_glt_detail_4,pre_glt_detail_5,pre_glt_detail_6,
  ip,created_by ,ua,ekey,created_date,temp_code,pre_glt_created)

  VALUES('$dev->company',(select gl_account from mt_gl_link where name='RECEIVABLE' limit 1),'SHIP','INV','$on',1,
  '$c->sub_ar_date','$c->sub_ar_date','$fy','$fp','$c->bl_no',
  '$base_currency',1,:samt,:sbamt,'remarks',
  'SHIP','$c->order_no','$c->sub_ar_date','$c->sub_ar_doc_base',
  '$c->bl_no',
  '$c->sub_ar_code','charge_desc','$dev->ip',
  '$dev->uid','$dev->ua','$dev->ekey',now(),'$temp_code',now())");

$statement->execute(array(':samt'=>$sv["samt"],':sbamt'=>$sv["sbamt"]));
    if ($statement->rowCount()){
    $data["gld_header_status"]=1;
      //echo 'Success: At least 1 row was affected.';
  } else{
    $data["gld_header_status"]=0;
      //echo 'Failure: 0 rows were affected.';
  }

  //ship gl ends

//4
$temp_code=uniqid($dev->uid);
//$gds=self::get_gl_Link();
$statement = $db->prepare("INSERT into mt_ship_trans
( st_company,st_doc_type,st_doc_number,st_serial,st_doc_base,st_date,st_gl_date,st_dp_date,st_age_date,st_year,st_period,st_carrier,st_vessel,st_voyage,st_port,st_bl,st_bl_type,st_charge,st_other_reference,st_currency,st_exchange,st_foreign,st_local,st_narration,st_status,
  st_posted_on,
  ip,created_by ,ua,ekey,created_date,temp_code,st_detail_1) 

  SELECT '$dev->company','INV','$on','0','SHIP','$c->sub_ar_date',
  '$c->sub_ar_date',
  '$c->sub_ar_date','$c->sub_ar_date','$fy','$fp','$c->eline',
  '$c->vessel','$c->voyage','$c->pof','$c->bl_no',
  '$c->sub_ar_doc_base',charge_desc,'$c->order_no'
  ,currency,ex_rate,-selling_amount,
  -selling_base_amount,remarks,
  status,now(),
  '$dev->ip',
  '$dev->uid','$dev->ua','$dev->ekey',now(),'$temp_code','$c->sub_ar_code' from mt_order_cost 
  where id='$order_cost_ids' and charge_desc='DOF'
   and type='INCOME'
");
$statement->execute();
    if ($statement->rowCount()){
    $data["sht_status"]=1;
      //echo 'Success: At least 1 row was affected.';
  } else{
    $data["sht_status"]=0;
      //echo 'Failure: 0 rows were affected.';
  }


}
}
//end of if conditions


$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}

//end of auto invoice do
public static function save_invoice_entry($dev,$code)
{
$data=array();

try
{
$db = Factory::getConnection();

$temp_code=uniqid($dev->uid);

$c=$code->inv;

$statement = $db->prepare("INSERT into mt_ship_ar_header(sub_ar_company,
  sub_ar_doc_type,sub_ar_doc_number,sub_ar_doc_base,sub_ar_gl_date,sub_ar_due_date,sub_ar_age_date,sub_ar_date,sub_ar_other_reference,sub_ar_currency,sub_ar_ex_rate,sub_place_off_supply,sub_place_off_supply_date,sub_ar_narration,sub_ar_notes,sub_ar_code,
  sub_ar_group,
  sub_ar_status, 
  sub_ar_other_reference_date,
  ip,created_by ,ua,ekey,created_date,temp_code,total_local_amt,order_no,
  bl_no,sub_ar_user,sub_ar_f_amount,sub_ar_l_amount,
  company_id,location_id) 
values(:company_id,:sub_ar_doc_type,:sub_ar_doc_number,:sub_ar_doc_base,:sub_ar_gl_date,:sub_ar_due_date,:sub_ar_age_date,:sub_ar_date,:sub_ar_other_reference,:sub_ar_currency,:sub_ar_ex_rate,:sub_place_off_supply,:sub_place_off_supply_date,:sub_ar_narration,:sub_ar_notes,:sub_ar_code,
'ACCOUNTS RECEIVABLE',
:sub_ar_status,
:sub_ar_other_reference_date,
:ip ,:created_by ,
:ua ,:ekey,now(),:temp_code,:total_local_amt,:order_no,
  :bl_no,:sub_ar_user,:total_local_amt,:total_local_amt,
:company_id,:location_id)");

if($c->sub_ar_due_date=="")
{
  $c->sub_ar_due_date=null;
}

if($c->sub_ar_other_reference_date=="")
{
  $c->sub_ar_other_reference_date=null;
}

if($c->sub_ar_ex_rate=="")
{
  $c->sub_ar_ex_rate=null;
}

$code->order_no=substr_replace($code->order_no,"", -1);
$code->bl_no=substr_replace($code->bl_no,"", -1);

$code->vessel=substr_replace($code->vessel,"", -1);
$code->voyage=substr_replace($code->voyage,"", -1);
$code->port=substr_replace($code->port,"", -1);
$code->liner=substr_replace($code->liner,"", -1);


//get unique values
$code->vessel=self::getUniqueString($code->vessel);
$code->voyage=self::getUniqueString($code->voyage);
$code->port=self::getUniqueString($code->port);
$code->liner=self::getUniqueString($code->liner);

$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->username ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,

':company_id'=>$dev->company,
':sub_ar_doc_type'=>$c->sub_ar_doc_type,
':sub_ar_doc_number'=>$c->sub_ar_doc_number,
':sub_ar_doc_base'=>$c->sub_ar_doc_base,
':sub_ar_gl_date'=>$c->sub_ar_gl_date,
':sub_ar_due_date'=>$c->sub_ar_due_date,
':sub_ar_age_date'=>$c->sub_ar_date,
':sub_ar_date'=>$c->sub_ar_date,
':sub_ar_other_reference'=>$c->sub_ar_other_reference,
':sub_ar_currency'=>$c->sub_ar_currency,
':sub_ar_ex_rate'=>$c->sub_ar_ex_rate,
':sub_place_off_supply'=>$c->sub_place_off_supply,
':sub_place_off_supply_date'=>$c->sub_place_off_supply_date,
':sub_ar_narration'=>$c->sub_ar_narration,
':sub_ar_notes'=>$c->sub_ar_notes,
':sub_ar_code'=>$c->sub_ar_code,
':sub_ar_status'=>'P', // means POSTED
':sub_ar_other_reference_date'=>$c->sub_ar_other_reference_date,

':temp_code'=>$temp_code,
':total_local_amt'=>$c->total_local_amt,
':order_no'=>$code->order_no,
':bl_no'=>$code->bl_no,
':sub_ar_user'=>$dev->username,

':company_id'=>$dev->company,
':location_id'=>$dev->location
));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';

} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}

//generate doc number

$data["temp_code"]=$temp_code;

$statement = $db->prepare("SELECT id from mt_ship_ar_header where created_by=:created_by and temp_code=:temp_code");
$statement->execute(array(':temp_code'=>$temp_code,
  ':created_by'=>$dev->username));
$op=$statement->fetchAll(PDO::FETCH_ASSOC);

$data["id"]=$op;

$fid=self::setFourDigit($op[0]["id"]);

$on=$c->sub_ar_doc_type."/".date("Y")."/".date('m')."/".$c->sub_place_off_supply."/".$fid;

 $statement = $db->prepare("UPDATE mt_ship_ar_header 
  SET sub_ar_doc_number=:ond where id=:id");
  $statement->execute(array(':id'=>$op[0]["id"],':ond'=>$on));
  
    if ($statement->rowCount()){
    $data["invid_status"]=1;
      //echo 'Success: At least 1 row was affected.';
  } else{
    $data["invid_status"]=0;
      //echo 'Failure: 0 rows were affected.';
  }

$data["doc_no"]=$on;

$fy=self::getFinancialYear();
$fp=self::getFinancialPeriod($c->sub_ar_date);
//doc number ends

//MT_AR_TRANS table
//FINANCIAL YEAR AND PERIOD IS PENDING
$statement = $db->prepare("INSERT into mt_ar_trans (
  art_company,art_code,art_type,art_number,art_serial,art_group,art_base_type,art_internal,art_other_reference,art_doc_date,art_gl_date,art_year,art_period,art_age_date,art_dp_date,art_currency,art_ex_rate,art_foreign_amount,art_local_amount,art_foreign_balance,art_local_balance,art_balance_status,art_description,art_notes,art_detail_2,art_detail_3,art_detail_4,art_posted_on,ip,created_by ,ua,ekey,created_date,
  company_id,location_id) 

SELECT sub_ar_company,
sub_ar_code,
sub_ar_doc_type,
sub_ar_doc_number,
sub_ar_internal_number,
sub_ar_group,
sub_ar_doc_base,
sub_ar_internal_number,
sub_ar_other_reference,
sub_ar_date,
sub_ar_gl_date,
'$fy',
'$fp',
sub_ar_age_date,
sub_ar_due_date,
sub_ar_currency,
sub_ar_ex_rate,
sub_ar_f_amount,
sub_ar_l_amount,
sub_ar_f_amount,
sub_ar_l_amount,
'A',
sub_ar_narration,
sub_ar_notes,
sub_place_off_supply,
sub_place_off_supply_date,
sub_ar_other_reference_date,
now(),
'$dev->ip','$dev->username' ,'$dev->ua','$dev->ekey',
now(),'$dev->company','$dev->location'  
FROM mt_ship_ar_header WHERE temp_code=:temp_code");

$statement->execute(array(':temp_code'=>$temp_code));

if ($statement->rowCount()){
  $data["AR_TRANS_status"]=1;
} else{
  $data["AR_TRANS_status"]=0;
}

//trans balance


// query 6
$temp_code=uniqid($dev->uid);
$statement = $db->prepare("INSERT into mt_ar_trans_balance
(ardm_company,ardm_code,ardm_doc_type,ardm_doc_number,
  ardm_serial,ardm_other_reference,ardm_date,ardm_currency,
  ardm_ex_rate,ardm_of_amount,ardm_ol_amount,
  ardm_bf_amount,ardm_bl_amount,
  ardm_pf_amount,ardm_pl_amount,ardm_status,
ip,created_by,ua,ekey,created_date,temp_code,company_id,location_id)

SELECT art_company,art_code,art_type,art_number,
art_serial,art_other_reference,art_gl_date,art_currency,
art_ex_rate,art_foreign_amount,art_local_amount,
art_foreign_balance,art_local_balance,
0,0,'PENDING',
ip,created_by,ua,ekey,now(),'$temp_code',
'$dev->company','$dev->location' 
 from mt_ar_trans where art_number=:doc_no
");

$statement->execute(array(':doc_no'=>$on));
//var_dump($statement->debugDumpParams());
if ($statement->rowCount()){
  $data["tb_status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data["tb_status"]=0;
    //echo 'Failure: 0 rows were affected.';
}

//trans balance ends
$order_id=0;
if($data["status"]==1)
{
  $cds=$code->cd;
  $ocds=$code->ocd;

  $q="INSERT into mt_ship_ar_details(
      sub_ard_company,sub_ard_doc_type,sub_ard_doc_number,sub_ard_serial,sub_ard_currency,sub_ard_ex_rate,sub_ard_foreign_amount,sub_ard_local_amount,sub_ard_narration,sub_ard_notes,sub_ard_detail_1,sub_ard_detail_2,sub_ard_detail_3,sub_ard_detail_4,sub_ard_detail_5,sub_ard_detail_6,sub_ard_basis,sub_ard_rate,sub_ard_quantity,ip,created_by ,ua,ekey,created_date,charge_desc,basis_type,taxable,total_tax_amt,total_amt,inv_status,sub_ard_detail_7,sub_ard_detail_8,sub_ard_detail_9,sub_ard_detail_10) 
      VALUES(:sub_ard_company,:sub_ard_doc_type,:sub_ard_doc_number,:sub_ard_serial,:sub_ard_currency,:sub_ard_ex_rate,:sub_ard_foreign_amount,:sub_ard_local_amount,:sub_ard_narration,:sub_ard_notes,:sub_ard_detail_1,:sub_ard_detail_2,:sub_ard_detail_3,:sub_ard_detail_4,:sub_ard_detail_5,:sub_ard_detail_6,:sub_ard_basis,:sub_ard_rate,:sub_ard_quantity,:ip ,:created_by ,
:ua ,:ekey,now(),:charge_desc,:basis_type,:taxable,:total_tax_amt,:total_amt,:inv_status,'$code->liner',
  '$code->vessel','$code->voyage','$code->port')";
$charge_query="UPDATE mt_order_cost set invoiced=1,
inv_pay_no=:doc_no where id=:id";
$i=0;
$c->sub_ar_doc_number = $on;
$order_cost_ids='';

  for(;$i<count($cds);$i++)
  {
    $cd=$cds[$i];
$order_cost_ids=$order_cost_ids."'".$cd->id."',";

    $statement = $db->prepare($q);
    $ar=self::setChargeDetails('MANIFEST',$cd,$dev,$c,$i);
    $statement->execute($ar);

    $statement = $db->prepare($charge_query);
    $statement->execute(array(':id'=>$cd->id,':doc_no'=>$on));

      //update order status
  $oq="UPDATE mt_order_entry set status=(SELECT CASE WHEN (SELECT count(*) FROM `mt_order_cost` WHERE invoiced is null and order_id=:id 
  and type='INCOME')=0 THEN 'INVOICED'
    ELSE 'PART INVOICED'
        END)
      WHERE id=:id";

      $statement = $db->prepare($oq);
      $statement->execute(array(':id'=>$cd->order_id));
  }
    for($j=0;$j<count($ocds);$j++)
  {
    $ocd=$ocds[$j];
    $statement = $db->prepare($q);
    $ar=self::setChargeDetails('ADDITIONAL',$ocd,$dev,$c,$i+$j);
    $statement->execute($ar);

  }

$order_cost_ids=substr_replace($order_cost_ids,"",-1);

  //ship gl details
$temp_code=uniqid($dev->uid);

$multiple_order_no='';
$sa=explode(',', $code->order_no);
$strLength=count($sa);
for ($i = 0; $i < $strLength; $i++) {

  if($i+1==$strLength)
  {
    $multiple_order_no=$multiple_order_no."'$sa[$i]'";
  }else{
    $multiple_order_no=$multiple_order_no."'$sa[$i]',";
  }

}

$statement = $db->prepare("INSERT into ship_gl_details 
( pre_glt_company,pre_glt_code,pre_glt_doc_base,pre_glt_doc_type,pre_glt_doc_number,pre_glt_serial,pre_glt_doc_date,pre_glt_gl_date,pre_glt_year,pre_glt_period,pre_glt_other_reference,pre_glt_currency,pre_glt_ex_rate,pre_glt_foreign_amount,pre_glt_local_amount,pre_glt_narration,pre_glt_module,pre_glt_detail_1,pre_glt_detail_2,pre_glt_detail_3,pre_glt_detail_4,pre_glt_detail_5,pre_glt_detail_6,
  ip,created_by ,ua,ekey,created_date,temp_code)


  SELECT '$dev->company',(
  IFNULL((SELECT income_gl from mt_charge_group_detail 
  where code=charge_desc),(SELECT gl_receivable_pdc from mt_gl_link where name= (select liner from mt_voyage where voyage=(select voyage from mt_manifest_entry where bl_no='$code->bl_no'))))
  ),'SHIP','INV','$on','0',
  '$c->sub_ar_date','$c->sub_ar_date','$fy','$fp','$code->bl_no',
  currency,ex_rate,-selling_amount,-selling_base_amount,remarks,
  'SHIP','$code->order_no','$c->sub_ar_date','$c->sub_ar_doc_base',
  '$code->bl_no',
  '$c->sub_ar_code',charge_desc,'$dev->ip',
  '$dev->uid','$dev->ua','$dev->ekey',now(),'$temp_code' from mt_order_cost 
  where id in($order_cost_ids) and order_id in (SELECT id from mt_order_entry 
  where order_no in($multiple_order_no)) and type='INCOME' 
  ");


$statement->execute();
    if ($statement->rowCount()){
    $data["gld_status"]=1;
      //echo 'Success: At least 1 row was affected.';
  } else{
    $data["gld_status"]=0;
      //echo 'Failure: 0 rows were affected.';
  }

//gl header
//get sum values

$statement = $db->prepare("SELECT sum(selling_amount) samt,sum(selling_base_amount) sbamt from mt_order_cost 
  where id in($order_cost_ids) and order_id in (SELECT id from mt_order_entry 
  where order_no in($multiple_order_no)) and type='INCOME'");
$statement->execute();

$svs=$statement->fetchAll(PDO::FETCH_ASSOC);
$sv=$svs[0];

$base_currency=getCurrency($dev);

$statement = $db->prepare("INSERT into ship_gl_details 
( pre_glt_company,pre_glt_code,pre_glt_doc_base,pre_glt_doc_type,pre_glt_doc_number,pre_glt_serial,pre_glt_doc_date,pre_glt_gl_date,pre_glt_year,pre_glt_period,pre_glt_other_reference,pre_glt_currency,pre_glt_ex_rate,pre_glt_foreign_amount,pre_glt_local_amount,pre_glt_narration,pre_glt_module,pre_glt_detail_1,pre_glt_detail_2,pre_glt_detail_3,pre_glt_detail_4,pre_glt_detail_5,pre_glt_detail_6,
  ip,created_by ,ua,ekey,created_date,temp_code,pre_glt_created)

  VALUES('$dev->company',(select gl_account from mt_gl_link where name='RECEIVABLE' limit 1),'SHIP','INV','$on',1,
  '$c->sub_ar_date','$c->sub_ar_date','$fy','$fp','$code->bl_no',
  '$base_currency',1,:samt,:sbamt,'remarks',
  'SHIP','$code->order_no','$c->sub_ar_date','$c->sub_ar_doc_base',
  '$code->bl_no',
  '$c->sub_ar_code','charge_desc','$dev->ip',
  '$dev->uid','$dev->ua','$dev->ekey',now(),'$temp_code',now())");

$statement->execute(array(':samt'=>$sv["samt"],':sbamt'=>$sv["sbamt"]));
    if ($statement->rowCount()){
    $data["gld_header_status"]=1;
      //echo 'Success: At least 1 row was affected.';
  } else{
    $data["gld_header_status"]=0;
      //echo 'Failure: 0 rows were affected.';
  }

  //ship gl ends

//4
$temp_code=uniqid($dev->uid);
//$gds=self::get_gl_Link();
$statement = $db->prepare("INSERT into mt_ship_trans
( st_company,st_doc_type,st_doc_number,st_serial,st_doc_base,st_date,st_gl_date,st_dp_date,st_age_date,st_year,st_period,st_carrier,st_vessel,st_voyage,st_port,st_bl,st_bl_type,st_charge,st_other_reference,st_currency,st_exchange,st_foreign,st_local,st_narration,st_status,
  st_posted_on,
  ip,created_by ,ua,ekey,created_date,temp_code,st_detail_1) 

  SELECT '$dev->company','INV','$on','0','SHIP','$c->sub_ar_date',
  '$c->sub_ar_date',
  '$c->sub_ar_date','$c->sub_ar_date','$fy','$fp','$code->liner',
  '$code->vessel','$code->voyage','$code->port','$code->bl_no',
  '$c->sub_ar_doc_base',charge_desc,'$code->order_no'
  ,currency,ex_rate,-selling_amount,
  -selling_base_amount,remarks,
  status,now(),
  '$dev->ip',
  '$dev->uid','$dev->ua','$dev->ekey',now(),'$temp_code','$c->sub_ar_code' from mt_order_cost 
  where id in($order_cost_ids) and 
  order_id in (SELECT id from mt_order_entry 
  where order_no in($multiple_order_no)) and type='INCOME'
");
$statement->execute();
    if ($statement->rowCount()){
    $data["sht_status"]=1;
      //echo 'Success: At least 1 row was affected.';
  } else{
    $data["sht_status"]=0;
      //echo 'Failure: 0 rows were affected.';
  }


}


$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;
}


public static function save_invoice_entry_sea_pro($dev,$code)
{
$data=array();

try
{
$db = Factory::getConnection();
$db->beginTransaction();

$temp_code=uniqid($dev->uid);

$c=$code->inv;

//START GST CALC
//Get gstin detail
$statement = $db->prepare("SELECT pan, gstin 
  from mt_business_partner    
  where code=:sub_ar_code ");
$statement->execute(array(':sub_ar_code'=>$c->sub_ar_code ));
$data["cngList"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$r=$data["cngList"][0];  
$consignee_pan_no=$r["pan"];
$billparty_gstin=$r["gstin"];

//check state
$startString="33";
$len = strlen($startString);
$cgst=0;
$sgst=0;
$igst=0;

//taxable
/*
$statement = $db->prepare("SELECT sum(selling_base_amount) taxable from mt_order_cost  
where order_id=(select id from mt_order_entry where order_no=REPLACE(:order_no, ',', '') limit 1)
and charge_desc!='OFRT'  and invoiced !=1 ");
$statement->execute(array(':order_no'=>$code->order_no));
$taxds=$statement->fetchAll(PDO::FETCH_ASSOC);
*/
$rate_total=0;
$cds=$code->cd;
for($i=0;$i<count($cds);$i++)
  {
    $cd=$cds[$i];
    if($cd->charge_desc!='OFRT')
    {
    $rate_total=$rate_total+$cd->total_amt;
    }
  }
$rate=$rate_total;
//$rate=($rate_total*18)/100;
//$rate=round($rate,2);
//$rate=$taxds[0]["taxable"];
//$data["taxds"]=$taxds;
$data["taxds"]=$rate;

//$rate=$c->total_local_amt;
#gst perc
$gst_percent=(float)$c->gst_percent;


//$state_cond=(substr($billparty_gstin, 0, $len) === $startString);
$data["billparty_gstin"]=$billparty_gstin;
$data["startString"]=$startString;

if($gst_percent!=0){

  if(substr($billparty_gstin, 0, $len)==$startString)
  {
      $tp=$gst_percent/2;
      $tv=($rate*$tp)/100;
      $cgst=round($tv,2);
      $sgst=round($tv,2);
      $data["cgst"]=$cgst;
      $data["sgst"]=$sgst;
      $data["tv"]=$tv;
      $data["tp"]=$tp;
      $data["rate"]=$rate;
      $data["tp"]=$tp;

  }else{
      $igst=round(($rate*$gst_percent)/100,2);
      $data["igst"]=$igst;
      $data["rate"]=$rate;
      $data["gst_percent"]=$gst_percent;
  }
}
//END GST CALC

$statement = $db->prepare("INSERT into 
  mt_order_ar_header(sub_ar_company,
  sub_ar_doc_type,sub_ar_doc_number,sub_ar_doc_base,sub_ar_gl_date,sub_ar_due_date,sub_ar_age_date,sub_ar_date,sub_ar_other_reference,sub_ar_currency,sub_ar_ex_rate,sub_place_off_supply,sub_place_off_supply_date,sub_ar_narration,sub_ar_notes,sub_ar_code,
  sub_ar_group,
  sub_ar_status, 
  sub_ar_other_reference_date,
  ip,created_by ,ua,ekey,created_date,temp_code,total_local_amt,order_no,
  bl_no,sub_ar_user,sub_ar_f_amount,sub_ar_l_amount,
  gst_percent, igst, cgst, sgst,
  company_id,location_id,charge_type) 
values(:company_id,:sub_ar_doc_type,:sub_ar_doc_number,:sub_ar_doc_base,:sub_ar_gl_date,:sub_ar_due_date,:sub_ar_age_date,:sub_ar_date,:sub_ar_other_reference,:sub_ar_currency,:sub_ar_ex_rate,:sub_place_off_supply,:sub_place_off_supply_date,:sub_ar_narration,:sub_ar_notes,:sub_ar_code,
(select gl_account from mt_gl_link where name='RECEIVABLE' limit 1),
:sub_ar_status,
:sub_ar_other_reference_date,
:ip ,:created_by ,
:ua ,:ekey,now(),:temp_code,:total_local_amt,:order_no,
  :bl_no,:sub_ar_user,:total_local_amt,:total_local_amt,
  :gst_percent, :igst, :cgst, :sgst,
:company_id,:location_id,:charge_type)");

if($c->sub_ar_due_date=="")
{
  $c->sub_ar_due_date=null;
}

if($c->sub_ar_other_reference_date=="")
{
  $c->sub_ar_other_reference_date=null;
}

if($c->sub_ar_ex_rate=="")
{
  $c->sub_ar_ex_rate=null;
}

$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->username ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,

':company_id'=>$dev->company,
':sub_ar_doc_type'=>$c->sub_ar_doc_type,
':sub_ar_doc_number'=>$c->sub_ar_doc_number,
':sub_ar_doc_base'=>$c->sub_ar_doc_base,
':sub_ar_gl_date'=>$c->sub_ar_gl_date,
':sub_ar_due_date'=>$c->sub_ar_due_date,
':sub_ar_age_date'=>$c->sub_ar_date,
':sub_ar_date'=>$c->sub_ar_date,
':sub_ar_other_reference'=>$c->sub_ar_other_reference,
':sub_ar_currency'=>$c->sub_ar_currency,
':sub_ar_ex_rate'=>$c->sub_ar_ex_rate,
':sub_place_off_supply'=>$c->sub_place_off_supply,
':sub_place_off_supply_date'=>$c->sub_place_off_supply_date,
':sub_ar_narration'=>$c->sub_ar_narration,
':sub_ar_notes'=>$c->sub_ar_notes,
':sub_ar_code'=>$c->sub_ar_code,
':sub_ar_status'=>'P',
':sub_ar_other_reference_date'=>$c->sub_ar_other_reference_date,
':charge_type'=>$c->charge_type,

':temp_code'=>$temp_code,
':total_local_amt'=>$c->total_local_amt,
':order_no'=>$code->order_no,
':bl_no'=>$code->bl_no,
':sub_ar_user'=>$dev->username,

':gst_percent'=>$gst_percent,
':igst'=>$igst,
':cgst'=>$cgst,
':sgst'=>$sgst,

':company_id'=>$dev->company,
':location_id'=>$dev->location
));

if ($statement->rowCount()){
  $data["status"]=1;
  $data["msg"]="Saved";
} else{
  $data["status"]=0;
  $data["msg"]="Unable to save. Please try again";

}

//generate doc number

$data["temp_code"]=$temp_code;

$statement = $db->prepare("SELECT id from mt_order_ar_header where created_by=:created_by and temp_code=:temp_code");
$statement->execute(array(':temp_code'=>$temp_code,
  ':created_by'=>$dev->username));
$op=$statement->fetchAll(PDO::FETCH_ASSOC);

//get count id

//insert id 
$statement = $db->prepare("INSERT INTO mt_order_ar_header_pro(created_by,temp_code,created_date) VALUES(:created_by,:temp_code,now())");
$statement->execute(array(':temp_code'=>$temp_code,
  ':created_by'=>$dev->username));
$data["ainv_insert"]="TEST";
$statement = $db->prepare("SELECT COUNT(*)+1 rid FROM mt_order_ar_header_pro where id<(SELECT id from mt_order_ar_header_pro where created_by=:created_by and temp_code=:temp_code)");
/*$statement = $db->prepare("SELECT COUNT(*)+1 rid FROM mt_order_ar_header where id<(SELECT id from mt_order_ar_header where created_by=:created_by and temp_code=:temp_code)");
*/
$statement->execute(array(':temp_code'=>$temp_code,
  ':created_by'=>$dev->username));
$row_ids=$statement->fetchAll(PDO::FETCH_ASSOC);
$row_id=$row_ids[0]["rid"];
//
$data["id"]=$op;

//$fid=self::setFourDigit($op[0]["id"]);
$fid=self::setFourDigit($row_id);

$on=$c->sub_ar_doc_type."/".date("Y")."/".date('m')."/".$c->sub_place_off_supply."/".$fid;

 $statement = $db->prepare("UPDATE mt_order_ar_header 
  SET sub_ar_doc_number=:ond where id=:id");
  $statement->execute(array(':id'=>$op[0]["id"],':ond'=>$on));
  
  if ($statement->rowCount()){
    $data["invid_status"]=1;
  } else{
    $data["invid_status"]=0;
  }

$data["doc_no"]=$on;


//doc number ends


$order_id=0;
$order_details_insert_count=0;
$order_cost_update_count=0;

if($data["status"]==1)
{
  $cds=$code->cd;
  $ocds=$code->ocd;

  $q="INSERT into mt_order_ar_details(
      sub_ard_company,sub_ard_doc_type,sub_ard_doc_number,sub_ard_serial,sub_ard_currency,sub_ard_ex_rate,sub_ard_foreign_amount,sub_ard_local_amount,sub_ard_narration,sub_ard_notes,sub_ard_detail_1,sub_ard_detail_2,sub_ard_detail_3,sub_ard_detail_4,sub_ard_detail_5,sub_ard_detail_6,sub_ard_basis,sub_ard_rate,sub_ard_quantity,ip,created_by ,ua,ekey,created_date,charge_desc,basis_type,taxable,total_tax_amt,total_amt,
      inv_status,charge_id) 
      VALUES(:sub_ard_company,:sub_ard_doc_type,:sub_ard_doc_number,:sub_ard_serial,:sub_ard_currency,:sub_ard_ex_rate,:sub_ard_foreign_amount,:sub_ard_local_amount,:sub_ard_narration,:sub_ard_notes,:sub_ard_detail_1,:sub_ard_detail_2,:sub_ard_detail_3,:sub_ard_detail_4,:sub_ard_detail_5,:sub_ard_detail_6,:sub_ard_basis,:sub_ard_rate,:sub_ard_quantity,:ip ,:created_by ,
:ua ,:ekey,now(),:charge_desc,:basis_type,:taxable,:total_tax_amt,:total_amt,
:inv_status,:charge_id)";
$charge_query="UPDATE mt_order_cost set invoiced=2,proforma=:doc_no, modified_by=:modified_by,modified_date=now() where id=:id";
$i=0;
$c->sub_ar_doc_number = $on;

  for(;$i<count($cds);$i++)
  {
    $cd=$cds[$i];
    $statement = $db->prepare($q);
    $ar=self::setChargeDetails('MANIFEST',$cd,$dev,$c,$i);
    $ar[':inv_status']='PROFORMA';
    $statement->execute($ar);

  if ($statement->rowCount()){
    $order_details_insert_count+=1;
  }
    $statement = $db->prepare($charge_query);
    $statement->execute(array(':id'=>$cd->id,
      ':doc_no'=>$on,':modified_by'=>$dev->username));

  if ($statement->rowCount()){
    $order_cost_update_count+=1;
  }
 
  }
 


}
//$data["status"]=0;
if($data["invid_status"]==1 && $data["status"]==1 && count($cds)==$order_details_insert_count && count($cds)==$order_cost_update_count)
{
  $db->commit();
}else{
  $db->rollBack();
  $data["status"]=0;
  $data["msg"]="Unable to save. Please try again";
}

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
    $db->rollBack();

  $data["status"]=0;
  $data["msg"]="Unable to save. Please try again";

  }
  
  return $data;
}


public static function get_inv($db,$order_no)
{
$data=array();
try
{

$order_no=str_replace(",","",trim($order_no));

$statement = $db->prepare("SELECT sub_ar_doc_number,bl_no,order_no 
  from mt_order_ar_header 
WHERE sub_ar_status='P' and sub_ar_doc_number not like 'PRO/%' and order_no like ? order by id");
$statement ->bindValue(1, "%$order_no%", PDO::PARAM_STR);
$statement->execute();
$data=$statement->fetchAll(PDO::FETCH_ASSOC);
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  return $data;
}

public static function save_invoice_entry_sea($dev,$code)
{
$data=array();

try
{
$db = Factory::getConnection();
$db->beginTransaction();

$temp_code=uniqid($dev->uid);

$c=$code->inv;

//get invoice number
$inv_alphabet=array('A','B','C','D','E','F','G','H','I','J','K','L','M','N','O','P','Q','R','S','T','U','V','W','X','Y','Z');
$can_proceed1=false;
$data["order_no1"]=$code->order_no;
$data["ex_inv"]=self::get_inv($db,$code->order_no);
$data["order_no"]=str_replace(",","",trim($code->order_no));

$ex_inv_no='';
$new_inv_prefix='';
$ex_inv_count=count($data["ex_inv"]);
if($ex_inv_count>=1)
{
  if($c->charge_type=='FREIGHT CHARGE')
  {
    $can_proceed1=false;
    $data["msg"]="Please choose right invoice category";
    $data["status"]=0;
  }else{
    $can_proceed1=true;
    $ex_inv_no=$data["ex_inv"][0]["sub_ar_doc_number"];
    $new_inv_prefix=$inv_alphabet[$ex_inv_count-1];
  }
}else{
  $can_proceed1=true;
}

//override rule
$can_proceed1=1;

if($can_proceed1)
{
//START GST CALC
//Get gstin detail
$statement = $db->prepare("SELECT pan, gstin,code,name 
  from mt_business_partner    
  where code=:sub_ar_code or name=:sub_ar_code");
$statement->execute(array(':sub_ar_code'=>$c->sub_ar_code ));
$data["cngList"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$r=$data["cngList"][0];  
$consignee_pan_no=$r["pan"];
$billparty_gstin=$r["gstin"];
$c->sub_ar_name=$c->sub_ar_code;
$c->sub_ar_code=$r["code"];

//check state
$startString="33";
$len = strlen($startString);
$cgst=0;
$sgst=0;
$igst=0;

//taxable
/*
$statement = $db->prepare("SELECT sum(sub_ard_foreign_amount) taxable from mt_ship_ar_details 
where sub_ard_doc_number=:sub_ard_doc_number 
and charge_desc!='OFRT' ");
$statement->execute(array(':sub_ard_doc_number'=>$c->sub_ar_doc_number));
$taxds=$statement->fetchAll(PDO::FETCH_ASSOC);
$rate=$taxds[0]["taxable"];
$data["taxds"]=$taxds;
*/
$ofrt_total=0;
$ofrt_tax_amt=0;
$ofrt_tax_percent=5;

$rate_total=0;
$cds=$code->cd;
for($i=0;$i<count($cds);$i++)
  {
    $cd=$cds[$i];
    if($cd->charge_desc!='OFRT')
    {
    $rate_total=$rate_total+$cd->total_amt;
    }else{
      $ofrt_total+=$cd->total_amt;
    }
  }
$rate=$rate_total;

//$rate=$c->total_local_amt;
#gst perc
$gst_percent=(float)$c->gst_percent;


//$state_cond=(substr($billparty_gstin, 0, $len) === $startString);
$is_igst=0;
if($gst_percent!=0){

  if(substr($billparty_gstin, 0, $len)==$startString)
  {
      $tp=$gst_percent/2;
      $tv=($rate*$tp)/100;
      $cgst=round($tv,2);
      $sgst=round($tv,2);
      $is_igst=0;

  }else{
      $igst=round(($rate*$gst_percent)/100,2);
      $is_igst=1;

  }
}

$igst_gl_code='';
$cgst_gl_code='';
$sgst_gl_code='';

$igst_gl_code_ofrt='';
$cgst_gl_code_ofrt='';
$sgst_gl_code_ofrt='';

if($ofrt_total!=0)
{
  $ofrt_tax_amt=round($ofrt_total*5/100,2);
}

$data["tax_gl_found"]=0;
if($is_igst==1)
{
  if($gst_percent==18)
  {
    $igst_gl_code='2-10-002-0001';
    $data["tax_gl_found"]=1;
  }

  if($ofrt_total!=0)
  {
  $igst_gl_code_ofrt='2-10-002-0008';
  }

}else{

  if($gst_percent==18)
  {
    $cgst_gl_code='2-10-002-0002';
    $sgst_gl_code='2-10-002-0003';
    $data["tax_gl_found"]=1;
  }else if($gst_percent==5)
  {
    $cgst_gl_code='2-10-002-0004';
    $sgst_gl_code='2-10-002-0005';
    $data["tax_gl_found"]=1;
  }

    if($ofrt_total!=0)
    {
    $cgst_gl_code_ofrt='2-10-002-0004';
    $sgst_gl_code_ofrt='2-10-002-0005';
    }
}

if($gst_percent==0)
{
$data["tax_gl_found"]=1;
$data["tax_gl_found_add_msg"]="GST IS ZERO";

}


//END GST CALC
$data["cgst"]=$cgst;
$data["igst"]=$igst;
$data["sgst"]=$sgst;
$data["ofrt_total"]=$ofrt_total;
$data["ofrt_tax_amt"]=$ofrt_tax_amt;

$statement = $db->prepare("INSERT into 
  mt_order_ar_header(sub_ar_company,
  sub_ar_doc_type,sub_ar_doc_number,sub_ar_doc_base,sub_ar_gl_date,sub_ar_due_date,sub_ar_age_date,sub_ar_date,sub_ar_other_reference,sub_ar_currency,sub_ar_ex_rate,sub_place_off_supply,sub_place_off_supply_date,sub_ar_narration,sub_ar_notes,sub_ar_code,
  sub_ar_group,
  sub_ar_status, 
  sub_ar_other_reference_date,
  ip,created_by ,ua,ekey,created_date,temp_code,total_local_amt,order_no,
  bl_no,sub_ar_user,sub_ar_f_amount,sub_ar_l_amount,gst_percent,
  igst,cgst,sgst,
  company_id,location_id,charge_type,ex_inv_no,
  ofrt_amount,ofrt_tax_percent,is_igst) 
values(:company_id,:sub_ar_doc_type,:sub_ar_doc_number,:sub_ar_doc_base,:sub_ar_gl_date,:sub_ar_due_date,:sub_ar_age_date,:sub_ar_date,:sub_ar_other_reference,:sub_ar_currency,:sub_ar_ex_rate,:sub_place_off_supply,:sub_place_off_supply_date,:sub_ar_narration,:sub_ar_notes,:sub_ar_code,
(select gl_account from mt_gl_link where name='RECEIVABLE' limit 1),
:sub_ar_status,
:sub_ar_other_reference_date,
:ip ,:created_by ,
:ua ,:ekey,now(),:temp_code,:total_local_amt,:order_no,
  :bl_no,:sub_ar_user,:total_local_amt,:total_local_amt,
  :gst_percent,:igst,:cgst,:sgst,
:company_id,:location_id,:charge_type,:ex_inv_no,
:ofrt_amount,:ofrt_tax_percent,:is_igst)");

if($c->sub_ar_due_date=="")
{
  $c->sub_ar_due_date=null;
}

if($c->sub_ar_other_reference_date=="")
{
  $c->sub_ar_other_reference_date=null;
}

if($c->sub_ar_ex_rate=="")
{
  $c->sub_ar_ex_rate=null;
}

$code->order_no=substr_replace($code->order_no,",", -1);
$code->bl_no=substr_replace($code->bl_no,"", -1);

$code->vessel=substr_replace($code->vessel,"", -1);
$code->voyage=substr_replace($code->voyage,"", -1);
$code->port=substr_replace($code->port,"", -1);
$code->liner=substr_replace($code->liner,"", -1);

$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->username ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,

':company_id'=>$dev->company,
':sub_ar_doc_type'=>$c->sub_ar_doc_type,
':sub_ar_doc_number'=>$c->sub_ar_doc_number,
':sub_ar_doc_base'=>$c->sub_ar_doc_base,
':sub_ar_gl_date'=>$c->sub_ar_gl_date,
':sub_ar_due_date'=>$c->sub_ar_due_date,
':sub_ar_age_date'=>$c->sub_ar_date,
':sub_ar_date'=>$c->sub_ar_date,
':sub_ar_other_reference'=>$c->sub_ar_other_reference,
':sub_ar_currency'=>$c->sub_ar_currency,
':sub_ar_ex_rate'=>$c->sub_ar_ex_rate,
':sub_place_off_supply'=>$c->sub_place_off_supply, //$billparty_gstin
':sub_place_off_supply_date'=>$c->sub_place_off_supply_date,
':sub_ar_narration'=>$c->sub_ar_narration,
':sub_ar_notes'=>$c->sub_ar_notes,
':sub_ar_code'=>$c->sub_ar_code,
':sub_ar_status'=>'P', // means POSTED
':sub_ar_other_reference_date'=>$c->sub_ar_other_reference_date,
':charge_type'=>$c->charge_type,
':ex_inv_no'=>$ex_inv_no,

':temp_code'=>$temp_code,
':total_local_amt'=>$c->total_local_amt,
':order_no'=>$code->order_no,
':bl_no'=>$code->bl_no,
':sub_ar_user'=>$dev->username,

':gst_percent'=>$gst_percent,
':igst'=>$igst,
':cgst'=>$cgst,
':sgst'=>$sgst,

':ofrt_amount'=>$ofrt_total,
':ofrt_tax_percent'=>$ofrt_tax_percent,
':is_igst'=>$is_igst,


':company_id'=>$dev->company,
':location_id'=>$dev->location
));

if ($statement->rowCount()){
  $data["status"]=1;
  $data["msg"]="Saved";

} else{
  $data["status"]=0;
  $data["msg"]="Unable to save. Please try again";

}

//generate doc number

$data["temp_code"]=$temp_code;

$statement = $db->prepare("SELECT id from mt_order_ar_header where created_by=:created_by and temp_code=:temp_code");
$statement->execute(array(':temp_code'=>$temp_code,
  ':created_by'=>$dev->username));
$op=$statement->fetchAll(PDO::FETCH_ASSOC);

$data["id"]=$op;

$on='';
$on=gen_no_for_invoice($db,$dev,$code->order_no,$c->sub_ar_doc_base);

/*if(strlen($ex_inv_no)==0)
{
  $on=gen_no_for_invoice($db,$dev,$code->order_no,$c->sub_ar_doc_base);
}else
{
  $on=$ex_inv_no.$new_inv_prefix;
}*/


 $statement = $db->prepare("UPDATE mt_order_ar_header 
  SET sub_ar_doc_number=:ond where id=:id");
  $statement->execute(array(':id'=>$op[0]["id"],':ond'=>$on));
  
    if ($statement->rowCount()){
    $data["invid_status"]=1;
  } else{
    $data["invid_status"]=0;
  }

$data["doc_no"]=$on;

//get financial data
$fy=self::getFinancialYear();
$fp=self::getFinancialPeriod($c->sub_ar_gl_date);

//doc number ends
$india_total_local_amount=$c->total_local_amt+$igst+$cgst+$sgst+$ofrt_tax_amt;

//MT_AR_TRANS table
//mt_order_trans table created using mt_ar_trans
//FINANCIAL YEAR AND PERIOD IS PENDING
$statement = $db->prepare("INSERT into mt_ar_trans (
  art_company,art_code,art_type,art_number,art_serial,art_group,
  art_base_type,art_internal,art_other_reference,art_doc_date,art_gl_date,art_year,art_period,art_age_date,art_dp_date,art_currency,art_ex_rate,art_foreign_amount,art_local_amount,art_foreign_balance,art_local_balance,art_balance_status,art_description,art_notes,art_detail_2,art_detail_3,art_detail_4,art_posted_on,
  ip,created_by ,ua,ekey,created_date,
  company_id,location_id) 

SELECT sub_ar_company,
sub_ar_code,
sub_ar_doc_type,
sub_ar_doc_number,
sub_ar_internal_number,
sub_ar_group,
sub_ar_doc_base,
sub_ar_internal_number,
sub_ar_other_reference,
sub_ar_date,
sub_ar_gl_date,
'$fy',
'$fp',
sub_ar_age_date,
sub_ar_due_date,
sub_ar_currency,
sub_ar_ex_rate,
'$india_total_local_amount',
'$india_total_local_amount',
'$india_total_local_amount',
'$india_total_local_amount',
'A',
sub_ar_narration,
sub_ar_notes,
sub_place_off_supply,
sub_place_off_supply_date,
sub_ar_other_reference_date,
now(),
'$dev->ip','$dev->username' ,'$dev->ua','$dev->ekey',
now(),'$dev->company','$dev->location'  
FROM mt_order_ar_header WHERE temp_code=:temp_code");

$statement->execute(array(':temp_code'=>$temp_code));

if ($statement->rowCount()){
  $data["ar_trans_status"]=1;
} else{
  $data["ar_trans_status"]=0;
}


//TAX STARTS

//OUTPUT CGST - 2-30-001-0012
      if($cgst!=0){
        $statement = $db->prepare("INSERT into gst_trans (
          art_company,art_code,art_type,art_number,art_serial,art_group,
          art_base_type,art_internal,art_other_reference,art_doc_date,art_gl_date,art_year,
          art_period,art_age_date,art_dp_date,art_currency,art_ex_rate,art_foreign_amount,
          art_local_amount,art_foreign_balance,art_local_balance,art_balance_status,
          art_description,art_notes,art_detail_2,art_detail_3,art_detail_4,art_posted_on,
          ip,created_by ,ua,ekey,created_date,
          company_id,location_id) 
        values 
        ('$dev->company',:art_code,'OUTPUT CGST',:art_number,'1',:art_group,
        'OUTPUT CGST', '0', '','$c->sub_ar_date','$c->sub_ar_date','$fy',
        '$fp','$c->sub_ar_date','$c->sub_ar_date',
         'INR','1',:art_foreign_amount, 
        :art_local_amount,:art_foreign_balance,:art_local_balance,'A',
        :art_description,'','','','', now(),
        '$dev->ip','$dev->username' ,'$dev->ua','$dev->ekey', now(),
        '$dev->company','$dev->location') ");

        $statement->execute(array(':art_code'=>$c->sub_ar_code, 
          ':art_number'=>$on, 
          ':art_group'=>$cgst_gl_code, 
          ':art_foreign_amount'=>$cgst, 
          ':art_local_amount'=>$cgst, 
          ':art_foreign_balance'=>$cgst, 
          ':art_local_balance'=>$cgst, 
          ':art_description'=>'OUTPUT CGST '.($gst_percent/2).'%' ));

        if ($statement->rowCount()){
          $data["cgst_status"]=1;
        } else{
          $data["cgst_status"]=0;
        }
    }
    //OUTPUT SGST - 2-30-001-0016
      if($sgst!=0){
        $statement = $db->prepare("INSERT into gst_trans (
          art_company,art_code,art_type,art_number,art_serial,art_group,
          art_base_type,art_internal,art_other_reference,art_doc_date,art_gl_date,art_year,
          art_period,art_age_date,art_dp_date,art_currency,art_ex_rate,art_foreign_amount,
          art_local_amount,art_foreign_balance,art_local_balance,art_balance_status,
          art_description,art_notes,art_detail_2,art_detail_3,art_detail_4,art_posted_on,
          ip,created_by ,ua,ekey,created_date,
          company_id,location_id) 
        values 
        ('$dev->company',:art_code,'OUTPUT SGST',:art_number,'1',:art_group,
        'OUTPUT SGST', '0', '','$c->sub_ar_date','$c->sub_ar_date','$fy',
        '$fp','$c->sub_ar_date','$c->sub_ar_date','INR','1',:art_foreign_amount, 
        :art_local_amount,:art_foreign_balance,:art_local_balance,'A',
        :art_description,'','','','', now(),
        '$dev->ip','$dev->username' ,'$dev->ua','$dev->ekey', now(),
        '$dev->company','$dev->location') ");

        $statement->execute(array(':art_code'=>$c->sub_ar_code, 
          ':art_number'=>$on, 
          ':art_group'=>$sgst_gl_code, 
          ':art_foreign_amount'=>$sgst, 
          ':art_local_amount'=>$sgst, 
          ':art_foreign_balance'=>$sgst, 
          ':art_local_balance'=>$sgst, 
          ':art_description'=>'OUTPUT SGST '.($gst_percent/2).'%' ));

        if ($statement->rowCount()){
          $data["sgst_status"]=1;
        } else{
          $data["sgst_status"]=0;
        }
    }
    //OUTPUT IGST - 2-30-001-0015
      if($igst!=0){
        $statement = $db->prepare("INSERT into gst_trans (
          art_company,art_code,art_type,art_number,art_serial,art_group,
          art_base_type,art_internal,art_other_reference,art_doc_date,art_gl_date,art_year,
          art_period,art_age_date,art_dp_date,art_currency,art_ex_rate,art_foreign_amount,
          art_local_amount,art_foreign_balance,art_local_balance,art_balance_status,
          art_description,art_notes,art_detail_2,art_detail_3,art_detail_4,art_posted_on,
          ip,created_by ,ua,ekey,created_date,
          company_id,location_id) 
        values 
        ('$dev->company',:art_code,'OUTPUT IGST',:art_number,'1',:art_group,
        'OUTPUT IGST', '0', '','$c->sub_ar_date','$c->sub_ar_date','$fy',
        '$fp','$c->sub_ar_date','$c->sub_ar_date','INR','1',:art_foreign_amount, 
        :art_local_amount,:art_foreign_balance,:art_local_balance,'A',
        :art_description,'','','','', now(),
        '$dev->ip','$dev->username' ,'$dev->ua','$dev->ekey', now(),
        '$dev->company','$dev->location') ");

        $statement->execute(array(':art_code'=>$c->sub_ar_code, 
          ':art_number'=>$on, 
          ':art_group'=>$igst_gl_code, 
          ':art_foreign_amount'=>$igst, 
          ':art_local_amount'=>$igst, 
          ':art_foreign_balance'=>$igst, 
          ':art_local_balance'=>$igst, 
          ':art_description'=>'OUTPUT IGST '.$gst_percent.'%' ));

        if ($statement->rowCount()){
          $data["igst_status"]=1;
        } else{
          $data["igst_status"]=0;
        }
    }

    if($ofrt_total!=0)
    {
      if($is_igst==1)
      {
        $data["ofrt_igst"]=insert_igst($db,$dev,$on,$igst_gl_code_ofrt,$ofrt_tax_amt,$ofrt_tax_percent,$c,$fy,$fp);
      }else{
        $ofrt_tax_amt_n1=round($ofrt_tax_amt/2,2);
       $data["ofrt_cgst"]=insert_cgst($db,$dev,$on,$cgst_gl_code_ofrt,$ofrt_tax_amt_n1,$ofrt_tax_percent,$c,$fy,$fp);
       $data["ofrt_sgst"]=insert_sgst($db,$dev,$on,$sgst_gl_code_ofrt,$ofrt_tax_amt_n1,$ofrt_tax_percent,$c,$fy,$fp);
      }
    }

//TAX ENDS

//trans balance


// query 6
$temp_code=uniqid($dev->uid);
$statement = $db->prepare("INSERT into mt_ar_trans_balance
(ardm_company,ardm_code,ardm_doc_type,ardm_doc_number,
  ardm_serial,ardm_other_reference,ardm_date,ardm_currency,
  ardm_ex_rate,ardm_of_amount,ardm_ol_amount,
  ardm_bf_amount,ardm_bl_amount,
  ardm_pf_amount,ardm_pl_amount,ardm_status,
ip,created_by,ua,ekey,created_date,temp_code,company_id,location_id)

SELECT art_company,art_code,art_type,art_number,
art_serial,art_other_reference,art_gl_date,art_currency,
art_ex_rate,art_foreign_amount,art_local_amount,
art_foreign_balance,art_local_balance,
0,0,'PENDING',
ip,created_by,ua,ekey,now(),'$temp_code',
'$dev->company','$dev->location'  
 from mt_ar_trans where art_number=:doc_no
");

$statement->execute(array(':doc_no'=>$on));
//var_dump($statement->debugDumpParams());
if ($statement->rowCount()){
  $data["tb_status"]=1;
} else{
  $data["tb_status"]=0;
}

//trans balance ends


$order_id=0;
$order_details_insert_count=0;
$order_cost_update_count=0;

if($data["status"]==1)
{
  $cds=$code->cd;
  $ocds=$code->ocd;

  $q="INSERT into mt_order_ar_details(
      sub_ard_company,sub_ard_doc_type,sub_ard_doc_number,sub_ard_serial,sub_ard_currency,sub_ard_ex_rate,sub_ard_foreign_amount,sub_ard_local_amount,sub_ard_narration,sub_ard_notes,sub_ard_detail_1,sub_ard_detail_2,sub_ard_detail_3,sub_ard_detail_4,sub_ard_detail_5,sub_ard_detail_6,sub_ard_basis,sub_ard_rate,sub_ard_quantity,ip,created_by ,ua,ekey,created_date,charge_desc,basis_type,taxable,total_tax_amt,total_amt,
      inv_status,charge_id) 
      VALUES(:sub_ard_company,:sub_ard_doc_type,:sub_ard_doc_number,:sub_ard_serial,:sub_ard_currency,:sub_ard_ex_rate,:sub_ard_foreign_amount,:sub_ard_local_amount,:sub_ard_narration,:sub_ard_notes,:sub_ard_detail_1,:sub_ard_detail_2,:sub_ard_detail_3,:sub_ard_detail_4,:sub_ard_detail_5,:sub_ard_detail_6,:sub_ard_basis,:sub_ard_rate,:sub_ard_quantity,:ip ,:created_by ,
:ua ,:ekey,now(),:charge_desc,:basis_type,:taxable,:total_tax_amt,:total_amt,
:inv_status,:charge_id)";
$charge_query="UPDATE mt_order_cost set invoiced=1,
inv_pay_no=:doc_no,modified_by=:modified_by,modified_date=now() 
where id=:id and invoiced is NULL";
$i=0;
$c->sub_ar_doc_number = $on;
$order_ids=array();
$order_cost_ids='';
  for(;$i<count($cds);$i++)
  {
    $cd=$cds[$i];
    $order_cost_ids=$order_cost_ids."'".$cd->id."',";
    array_push($order_ids,$cd->order_id);

    $statement = $db->prepare($q);
    $ar=self::setChargeDetails('MANIFEST',$cd,$dev,$c,$i);
    $statement->execute($ar);

      if ($statement->rowCount()){
          $order_details_insert_count+=1;
        }

    $statement = $db->prepare($charge_query);
    $statement->execute(array(':id'=>$cd->id,':doc_no'=>$on,
      ':modified_by'=>$dev->username));

      if ($statement->rowCount()){
          $order_cost_update_count+=1;
        }

  
  }

$order_ids_unique=array_unique($order_ids);
$order_entry_status_count=0;

for ($i = 0; $i < count($order_ids_unique); $i++) {

   //update order status
  $oq="UPDATE mt_order_entry set modified_date=now(),modified_by=:modified_by, status=(SELECT CASE WHEN (SELECT count(*) FROM `mt_order_cost` WHERE invoiced is null and order_id=:id and type='INCOME')=0 THEN 'INVOICED'
    ELSE 'PART INVOICED'
        END) WHERE id=:id";

      $statement = $db->prepare($oq);
      $statement->execute(array(':id'=>$order_ids_unique[$i],
        ':modified_by'=>$dev->username));

        if ($statement->rowCount()){
          $data["order_entry_status"]=1;
          $order_entry_status_count+=1;
        }else{
          $data["order_entry_status"]=0;
        }

}

     

  //gl starts

  //gl header posting
  //Add IMP-INV,EXP-INV entries to GL detail table
  $statement = $db->prepare("INSERT into mt_order_gl_details 
  ( pre_glt_company, pre_glt_code,
  pre_glt_doc_base,pre_glt_doc_type,
  pre_glt_doc_number,pre_glt_serial,
  pre_glt_doc_date,pre_glt_gl_date,pre_glt_year,pre_glt_period,
  pre_glt_other_reference,pre_glt_currency,pre_glt_ex_rate,
  pre_glt_foreign_amount,pre_glt_local_amount,pre_glt_narration,
  pre_glt_module,pre_glt_detail_1,pre_glt_detail_2,pre_glt_detail_3,
  pre_glt_detail_4,pre_glt_detail_5,pre_glt_detail_6,
  pre_glt_detail_7,pre_glt_detail_8,pre_glt_detail_9,
  ip,created_by ,ua,ekey,created_date,temp_code,pre_glt_created,
  location_id,company_id)

  SELECT art_company,art_group,
  art_type,art_base_type,
  art_number, art_serial,
  art_gl_date,art_gl_date,'$fy','$fp',
  art_other_reference,art_currency,art_ex_rate,
  art_foreign_amount,art_local_amount,art_description,
  'ORDER',
  art_group,
  'RECEIVABLE',
  '$c->sub_ar_code',
  '$code->order_no','$code->bl_no','$c->sub_ar_date',
  '$c->sub_ar_code',art_group,art_description,
  ip,created_by,ua,ekey,now(),'$temp_code',now(),
  '$dev->company','$dev->location'    
   from mt_ar_trans where art_number=:doc_no and art_type in ('IMP-INV','EXP-INV') ");

  $statement->execute(array(':doc_no'=>$on));
      if ($statement->rowCount()){
      $data["gld_header_status"]=1;
    } else{
      $data["gld_header_status"]=0;
    }

  for($j=0;$j<count($ocds);$j++)
  {
    $ocd=$ocds[$j];
    $statement = $db->prepare($q);
    $ar=setChargeDetails('ADDITIONAL',$ocd,$dev,$c,$i+$j);
    $statement->execute($ar);

  }

$order_cost_ids=substr_replace($order_cost_ids,"",-1);
$data["order_cost_ids"]=$order_cost_ids;
  //ship gl details
$temp_code=uniqid($dev->uid);

$multiple_order_no='';
$sa=explode(',', $code->order_no);
$strLength=count($sa);
for ($i = 0; $i < $strLength; $i++) {

  if(strlen($sa[$i])!=0)
  {
      $multiple_order_no=$multiple_order_no."'$sa[$i]',";
  }
}
$multiple_order_no=substr_replace($multiple_order_no,"",-1);
$multiple_order_no="(".$multiple_order_no.")";
$data["multiple_order_no"]=$multiple_order_no;

$data["cq"]="SELECT '$dev->company',
  (SELECT income_gl from mt_charge_group_detail 
  where code=charge_desc limit 1),'ORDER','INV','$on','0',
  '$c->sub_ar_date','$c->sub_ar_date','$fy','$fp','$code->bl_no',
  currency,ex_rate,-selling_amount,-selling_base_amount,remarks,
  'SHIP',
  (SELECT income_gl from mt_charge_group_detail 
  where code=charge_desc limit 1),
  charge_desc,'',
  '$code->order_no','$c->sub_ar_date','$c->sub_ar_doc_base',
  '$code->bl_no',
  '$c->sub_ar_code',charge_desc,'$dev->ip',
  '$dev->uid','$dev->ua','$dev->ekey',now(),'$temp_code',
  '$dev->company','$dev->location' from mt_order_cost 
  where id in($order_cost_ids) and order_id in (SELECT id from mt_order_entry 
  where order_no in $multiple_order_no) and type='INCOME' and invoiced is NULL";

$statement = $db->prepare("INSERT into mt_order_gl_details 
( pre_glt_company,pre_glt_code,pre_glt_doc_base,pre_glt_doc_type,pre_glt_doc_number,pre_glt_serial,pre_glt_doc_date,pre_glt_gl_date,pre_glt_year,pre_glt_period,pre_glt_other_reference,pre_glt_currency,pre_glt_ex_rate,pre_glt_foreign_amount,pre_glt_local_amount,pre_glt_narration,pre_glt_module,pre_glt_detail_1,pre_glt_detail_2,pre_glt_detail_3,pre_glt_detail_4,pre_glt_detail_5,pre_glt_detail_6,pre_glt_detail_7,pre_glt_detail_8,pre_glt_detail_9,
  ip,created_by ,ua,ekey,created_date,temp_code, 
  location_id,company_id)
  SELECT '$dev->company',
  (SELECT income_gl from mt_charge_group_detail 
  where code=charge_desc limit 1),'ORDER','INV','$on','0',
  '$c->sub_ar_date','$c->sub_ar_date','$fy','$fp','$code->bl_no',
  currency,ex_rate,-selling_amount,-selling_base_amount,remarks,
  'ORDER',
  (SELECT income_gl from mt_charge_group_detail 
  where code=charge_desc limit 1),
  charge_desc,'',
  '$code->order_no','$c->sub_ar_date','$c->sub_ar_doc_base',
  '$code->bl_no',
  '$c->sub_ar_code',charge_desc,'$dev->ip',
  '$dev->username','$dev->ua','$dev->ekey',now(),'$temp_code',
  '$dev->company','$dev->location' from mt_order_cost 
  where id in($order_cost_ids) and order_id in (SELECT id from mt_order_entry 
  where order_no in $multiple_order_no) and type='INCOME'");


    $statement->execute();
    if ($statement->rowCount()){
    $data["gld_status"]=1;
  } else{
    $data["gld_status"]=0;
    $data["gld_status_add"]="NE";
  }



//Add GST entries to GL detail table
  $statement = $db->prepare("INSERT into mt_order_gl_details 
  ( pre_glt_company, pre_glt_code,
  pre_glt_doc_base,pre_glt_doc_type,
  pre_glt_doc_number,pre_glt_serial,
  pre_glt_doc_date,pre_glt_gl_date,pre_glt_year,pre_glt_period,
  pre_glt_other_reference,pre_glt_currency,pre_glt_ex_rate,
  pre_glt_foreign_amount,pre_glt_local_amount,pre_glt_narration,
  pre_glt_module,pre_glt_detail_1,pre_glt_detail_2,pre_glt_detail_3,
  pre_glt_detail_4,pre_glt_detail_5,pre_glt_detail_6,
  pre_glt_detail_7,pre_glt_detail_8,pre_glt_detail_9,
  ip,created_by ,ua,ekey,created_date,temp_code,pre_glt_created,
  location_id,company_id)

  SELECT art_company,art_group,
  art_type,art_base_type,
  art_number, art_serial,
  art_gl_date,art_gl_date,'$fy','$fp',
  art_other_reference,art_currency,art_ex_rate,
  -art_foreign_amount,-art_local_amount,art_description,
  'ORDER',
  art_group,
  art_description,
  '$c->sub_ar_code',
  '$code->order_no','$code->bl_no','$c->sub_ar_date',
  '$c->sub_ar_code',art_group,art_description,
  ip,created_by,ua,ekey,now(),'$temp_code',now(),
  '$dev->company','$dev->location'    
   from gst_trans where art_number=:doc_no and art_type in ('OUTPUT IGST','OUTPUT SGST','OUTPUT CGST') ");

  $statement->execute(array(':doc_no'=>$on));
      if ($statement->rowCount()){
      $data["gld_header2_status"]=1;
    } else{
      $data["gld_header2_status"]=0;
    }    
  //ship gl ends

//gl ends




//4
$temp_code=uniqid($dev->uid);
//$gds=self::get_gl_Link();
$statement = $db->prepare("INSERT into mt_order_trans
( ordt_company,ordt_doc_type,ordt_doc_number,ordt_serial,ordt_doc_base,ordt_doc_date,ordt_gl_date,ordt_dp_date,ordt_age_date,ordt_year,ordt_period,ordt_carrier,ordt_vessel,ordt_voyage,ordt_port,ordt_bl,ordt_bl_type,ordt_charge,ordt_other_reference,ordt_currency,ordt_ex_rate,ordt_foreign_amount,ordt_local_amount,ordt_narration,ordt_status,
ordt_posted_on,
  ip,created_by ,ua,ekey,created_date,temp_code,ordt_code,ordt_activity) 

  SELECT '$dev->company','INV','$on','0','ORDER','$c->sub_ar_date',
  '$c->sub_ar_date',
  '$c->sub_ar_date','$c->sub_ar_date','$fy','$fp','$code->liner',
  '$code->vessel','$code->voyage','$code->port','$code->bl_no',
  '$c->sub_ar_doc_base',charge_desc,'$code->order_no'
  ,currency,ex_rate,-selling_amount,
  -selling_base_amount,remarks,
  status,now(),
  '$dev->ip',
  '$dev->uid','$dev->ua','$dev->ekey',now(),'$temp_code','$c->sub_ar_code',
  charge_desc
  from mt_order_cost 
  where id in($order_cost_ids) and order_id in (SELECT id from mt_order_entry 
  where order_no in($multiple_order_no)) and type='INCOME'
");
$data["idc"]="id in($order_cost_ids)";
$statement->execute();
    if ($statement->rowCount()){
    $data["odtrans_status"]=1;
  } else{
    $data["odtrans_status"]=0;
  }


}

$gst_status=0;
if($igst!=0)
{
  $gst_status=$data["igst_status"];
}else{

  if($data["cgst"]==0 && $data["sgst"]==0 && $data["igst"]==0)
  {
    $gst_status=1;
  }
  else if($data["cgst_status"]==1 && $data["sgst_status"]==1)
  {
    $gst_status=1;
  }else{
    $gst_status=0;
  }
}

if($gst_percent==0)
{
  $data["gld_header2_status"]=1;
  $data["gld_header2_status_add_msg"]="GST IS ZERO";

}

//$data["status"]=0;
if($data["invid_status"]==1 && $data["status"]==1 && count($cds)==$order_details_insert_count && count($cds)==$order_cost_update_count && $data["ar_trans_status"]==1 && $data["tb_status"]==1 && count($order_ids_unique)==$order_entry_status_count && $data["gld_status"]==1 && $data["gld_header_status"]==1 && $data["gld_header2_status"]==1 && $data["tax_gl_found"]==1 && $data["odtrans_status"]==1 && $gst_status==1)
{
  $db->commit();
}else{
  $db->rollBack();
  $data["status"]=0;
  $data["msg"]="Unable to save. Please try again";
}

$statement=null;
}
  }
  catch (Exception $e) {
    $data["emsg"]=$e->getMessage();
    $db->rollBack();
    $data["status"]=0;
    $data["msg"]="Unable to save. Exception. Please try again";

  }
  
  return $data;
}


public static function setChargeDetails($type,$cd,$dev,$c,$i)
{

    $cd_id=0;
  if(property_exists($cd,'id'))
  {
  $cd_id=$cd->id;
  }

  $ar=array(':ip'=>$dev->ip,':created_by'=>$dev->uid ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,

':sub_ard_company'=>$dev->company,
':sub_ard_doc_type'=>$c->sub_ar_doc_type,
':sub_ard_doc_number'=>$c->sub_ar_doc_number,
':sub_ard_serial'=>$i+1,
':sub_ard_currency'=>$cd->currency,
':sub_ard_ex_rate'=>$cd->ex_rate,
':sub_ard_foreign_amount'=>$cd->famt,
':sub_ard_local_amount'=>$cd->net_amt,
':sub_ard_narration'=>$cd->remarks,
':sub_ard_notes'=>$c->sub_ar_notes,
':sub_ard_detail_1'=>$cd->order_no,
':sub_ard_detail_2'=>$cd->order_date,
':sub_ard_detail_3'=>$cd->order_type,
':sub_ard_detail_4'=>$cd->bl_no,
':sub_ard_detail_5'=>$cd->customer,
':sub_ard_detail_6'=>$type,
':sub_ard_basis'=>$cd->basis_uom,
':sub_ard_rate'=>$cd->selling_amount,
':sub_ard_quantity'=>$cd->qty,
':charge_desc'=>$cd->charge_desc,
':basis_type'=>$cd->basis_type,
':taxable'=>$cd->taxable,

':total_tax_amt'=>$cd->total_tax_amt,
':total_amt'=>$cd->total_amt,
':inv_status'=>'INVOICED',
':charge_id'=>$cd_id

);

return $ar;
}


public static function save_invoice_entry_ac($dev,$code)
{
$cd=$code->cd;
$c=$code->c;

$data=array();
try
{
$db = Factory::getConnection();
$temp_code=uniqid($dev->uid);

  $q="INSERT into mt_ship_ar_details(
      sub_ard_company,sub_ard_doc_type,sub_ard_doc_number,sub_ard_serial,sub_ard_currency,sub_ard_ex_rate,sub_ard_foreign_amount,sub_ard_local_amount,sub_ard_narration,sub_ard_notes,sub_ard_detail_1,sub_ard_detail_2,sub_ard_detail_3,sub_ard_detail_4,sub_ard_detail_5,sub_ard_detail_6,sub_ard_basis,sub_ard_rate,sub_ard_quantity,ip,created_by ,ua,ekey,created_date,charge_desc,basis_type,taxable,total_tax_amt,total_amt,inv_status,temp_code) 
      VALUES(:sub_ard_company,:sub_ard_doc_type,:sub_ard_doc_number,:sub_ard_serial,:sub_ard_currency,:sub_ard_ex_rate,:sub_ard_foreign_amount,:sub_ard_local_amount,:sub_ard_narration,:sub_ard_notes,:sub_ard_detail_1,:sub_ard_detail_2,:sub_ard_detail_3,:sub_ard_detail_4,:sub_ard_detail_5,:sub_ard_detail_6,:sub_ard_basis,:sub_ard_rate,:sub_ard_quantity,:ip ,:created_by ,
:ua ,:ekey,now(),:charge_desc,:basis_type,:taxable,:total_tax_amt,:total_amt,:inv_status,:temp_code)";
$statement = $db->prepare($q);

if($cd->ex_rate=="")
{
  $cd->ex_rate=null;
}

if($cd->net_amt=="")
{
  $cd->net_amt=null;
}

$statement->execute(array(

':ip'=>$dev->ip,
':created_by'=>$dev->username ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,

':sub_ard_company'=>$dev->company,
':sub_ard_doc_type'=>$c->sub_ar_doc_type,
':sub_ard_doc_number'=>$c->sub_ar_doc_number,
':sub_ard_serial'=>'0',
':sub_ard_currency'=>$cd->currency,
':sub_ard_ex_rate'=>$cd->ex_rate,
':sub_ard_foreign_amount'=>0,
':sub_ard_local_amount'=>$cd->net_amt,
':sub_ard_narration'=>$cd->remarks,
':sub_ard_notes'=>$c->sub_ar_notes,
':sub_ard_detail_1'=>$cd->order_no,
':sub_ard_detail_2'=>$cd->order_date,
':sub_ard_detail_3'=>$cd->order_type,
':sub_ard_detail_4'=>$cd->bl_no,
':sub_ard_detail_5'=>$cd->customer,
':sub_ard_detail_6'=>'ADDITIONAL',

':sub_ard_basis'=>$cd->basis_uom,
':sub_ard_rate'=>$cd->selling_amount,
':sub_ard_quantity'=>$cd->qty,
':charge_desc'=>$cd->charge_desc,
':basis_type'=>$cd->basis_type,
':taxable'=>$cd->taxable,

':total_tax_amt'=>$cd->total_tax_amt,
':total_amt'=>$cd->total_amt,
':inv_status'=>'INVOICED',
':temp_code'=>$temp_code
));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}

$statement = $db->prepare("SELECT id from mt_ship_ar_details where created_by=:uid and temp_code=:temp_code and sub_ard_doc_number=:sub_ard_doc_number");
$statement->execute(array(':temp_code'=>$temp_code,
  ':uid'=>$dev->username,
  ':sub_ard_doc_number'=>$c->sub_ar_doc_number));
$data["id"]=$statement->fetchAll(PDO::FETCH_ASSOC);
$acid=$data["id"][0]["id"];

//insert in the order cost
$statement = $db->prepare("INSERT INTO mt_order_cost
(
order_id,
type,
charge_desc,
basis_type,
basis_uom,
qty,
currency,
ex_rate,
rate_selling,
selling_base_amount,
remarks,
billing_party,
ip,ua,ekey,created_by,created_date,acid
)
VALUES
(
(SELECT id from mt_order_entry where order_no='$order_no'),
'INCOME',
:charge_desc,
:basis_type,
:basis_uom,
:qty,
:currency,
:ex_rate,
:selling_amount,
:selling_amount,
:remarks,
:customer,
:ip,:ua,:ekey,:created_by,now(),$acid)");
$statement->execute(array(':ip'=>$dev->ip,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,
':created_by'=>$dev->username,

':charge_desc'=>$cd->charge_desc,
':basis_type'=>$cd->basis_type,
':basis_uom'=>$cd->basis_uom,
':qty'=>$cd->qty,
':currency'=>$cd->currency,
':ex_rate'=>$cd->ex_rate,

':selling_amount'=>$cd->selling_amount,
':remarks'=>$cd->remarks,
':customer'=>$cd->customer
));
if ($statement->rowCount()){
  $data["oc_status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data["oc_status"]=0;
    //echo 'Failure: 0 rows were affected.';
}

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;

}


public static function update_invoice_entry_ac($dev,$cd)
{

$data=array();
try
{
$db = Factory::getConnection();
$temp_code=uniqid($dev->uid);

  $q="UPDATE mt_ship_ar_details SET
  sub_ard_currency=:sub_ard_currency,
  sub_ard_ex_rate=:sub_ard_ex_rate,
  sub_ard_local_amount=:sub_ard_local_amount,
  sub_ard_narration=:sub_ard_narration,
  sub_ard_basis=:sub_ard_basis,
  sub_ard_rate=:sub_ard_rate,
  sub_ard_quantity=:sub_ard_quantity,
  charge_desc=:charge_desc,
  basis_type=:basis_type,
  taxable=:taxable,
  total_tax_amt=:total_tax_amt,
  total_amt=:total_amt 
  where id=:id";
$statement = $db->prepare($q);

if($cd->ex_rate=="")
{
  $cd->ex_rate=null;
}

if($cd->net_amt=="")
{
  $cd->net_amt=null;
}

$statement->execute(array(


':sub_ard_currency'=>$cd->currency,
':sub_ard_ex_rate'=>$cd->ex_rate,

':sub_ard_local_amount'=>$cd->net_amt,
':sub_ard_narration'=>$cd->remarks,

':sub_ard_basis'=>$cd->basis_uom,
':sub_ard_rate'=>$cd->selling_amount,
':sub_ard_quantity'=>$cd->qty,
':charge_desc'=>$cd->charge_desc,
':basis_type'=>$cd->basis_type,
':taxable'=>$cd->taxable,

':total_tax_amt'=>$cd->total_tax_amt,
':total_amt'=>$cd->total_amt,
':id'=>$cd->id,

));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}



//insert in the order cost
$statement = $db->prepare("UPDATE mt_order_cost
SET charge_desc,
basis_type,
basis_uom,
qty,
currency,
ex_rate,
rate_selling=:selling_amount,
selling_base_amount=:selling_amount,
remarks=:remarks,

where acid=id");
$statement->execute(array(
':charge_desc'=>$cd->charge_desc,
':basis_type'=>$cd->basis_type,
':basis_uom'=>$cd->basis_uom,
':qty'=>$cd->qty,
':currency'=>$cd->currency,
':ex_rate'=>$cd->ex_rate,

':selling_amount'=>$cd->selling_amount,
':remarks'=>$cd->remarks,
':id'=>$cd->id
));
if ($statement->rowCount()){
  $data["oc_status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data["oc_status"]=0;
    //echo 'Failure: 0 rows were affected.';
}

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;

}

public static function delete_invoice_entry_ac($dev,$code)
{

$data=array();
try
{
$db = Factory::getConnection();

$q="DELETE from mt_ship_ar_details where id=:id";
$statement = $db->prepare($q);

$statement->execute(array(
':id'=>$code
));

if ($statement->rowCount()){
  $data["status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data["status"]=0;
    //echo 'Failure: 0 rows were affected.';
}

$q="DELETE from mt_order_cost where acid=:id";
$statement = $db->prepare($q);

$statement->execute(array(
':id'=>$code
));

if ($statement->rowCount()){
  $data["cost_status"]=1;
    //echo 'Success: At least 1 row was affected.';
} else{
  $data["cost_status"]=0;
    //echo 'Failure: 0 rows were affected.';
}

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
  }
  
  return $data;

}



public static function save_invoice_entry_sea_draft($dev,$code)
{
$data=array();

try
{
$db = Factory::getConnection();
$db->beginTransaction();

$temp_code=uniqid($dev->uid);

$c=$code->inv;

//START GST CALC
//Get gstin detail
$statement = $db->prepare("SELECT pan,code, gstin 
  from mt_business_partner    
  where code=:sub_ar_code or name=:sub_ar_code");
$statement->execute(array(':sub_ar_code'=>$c->sub_ar_code ));
$data["cngList"]=$statement->fetchAll(PDO::FETCH_ASSOC);

$r=$data["cngList"][0];  
$consignee_pan_no=$r["pan"];
$billparty_gstin=$r["gstin"];
$c->sub_ar_code_name=$c->sub_ar_code;
$c->sub_ar_code=$r["code"];


//check state
$startString="33";
$len = strlen($startString);
$cgst=0;
$sgst=0;
$igst=0;

//taxable
/*
$statement = $db->prepare("SELECT sum(selling_base_amount) taxable from mt_order_cost  
where order_id=(select id from mt_order_entry where order_no=REPLACE(:order_no, ',', '') limit 1)
and charge_desc!='OFRT'  and invoiced !=1 ");
$statement->execute(array(':order_no'=>$code->order_no));
$taxds=$statement->fetchAll(PDO::FETCH_ASSOC);
*/
$rate_total=0;
$cds=$code->cd;
for($i=0;$i<count($cds);$i++)
  {
    $cd=$cds[$i];
    if($cd->charge_desc!='OFRT')
    {
    $rate_total=$rate_total+$cd->total_amt;
    }
  }
$rate=$rate_total;
//$rate=($rate_total*18)/100;
//$rate=round($rate,2);
//$rate=$taxds[0]["taxable"];
//$data["taxds"]=$taxds;
$data["taxds"]=$rate;

//$rate=$c->total_local_amt;
#gst perc
$gst_percent=(float)$c->gst_percent;


//$state_cond=(substr($billparty_gstin, 0, $len) === $startString);
$data["billparty_gstin"]=$billparty_gstin;
$data["startString"]=$startString;

if($gst_percent!=0){

  if(substr($billparty_gstin, 0, $len)==$startString)
  {
      $tp=$gst_percent/2;
      $tv=($rate*$tp)/100;
      $cgst=round($tv,2);
      $sgst=round($tv,2);
      $data["cgst"]=$cgst;
      $data["sgst"]=$sgst;
      $data["tv"]=$tv;
      $data["tp"]=$tp;
      $data["rate"]=$rate;
      $data["tp"]=$tp;

  }else{
      $igst=round(($rate*$gst_percent)/100,2);
      $data["igst"]=$igst;
      $data["rate"]=$rate;
      $data["gst_percent"]=$gst_percent;
  }
}
//END GST CALC


$statement = $db->prepare("INSERT into 
  mt_order_ar_header_draft(sub_ar_company,
  sub_ar_doc_type,sub_ar_doc_number,sub_ar_doc_base,sub_ar_gl_date,sub_ar_due_date,sub_ar_age_date,sub_ar_date,sub_ar_other_reference,sub_ar_currency,sub_ar_ex_rate,sub_place_off_supply,sub_place_off_supply_date,sub_ar_narration,sub_ar_notes,sub_ar_code,
  sub_ar_group,
  sub_ar_status, 
  sub_ar_other_reference_date,
  ip,created_by ,ua,ekey,created_date,temp_code,total_local_amt,order_no,
  bl_no,sub_ar_user,sub_ar_f_amount,sub_ar_l_amount,
  gst_percent, igst, cgst, sgst,
  company_id,location_id) 
values(:company_id,:sub_ar_doc_type,:sub_ar_doc_number,:sub_ar_doc_base,:sub_ar_gl_date,:sub_ar_due_date,:sub_ar_age_date,:sub_ar_date,:sub_ar_other_reference,:sub_ar_currency,:sub_ar_ex_rate,:sub_place_off_supply,:sub_place_off_supply_date,:sub_ar_narration,:sub_ar_notes,:sub_ar_code,
(select gl_account from mt_gl_link where name='RECEIVABLE' limit 1),
:sub_ar_status,
:sub_ar_other_reference_date,
:ip ,:created_by ,
:ua ,:ekey,now(),:temp_code,:total_local_amt,:order_no,
  :bl_no,:sub_ar_user,:total_local_amt,:total_local_amt,
  :gst_percent, :igst, :cgst, :sgst,
:company_id,:location_id)");

if($c->sub_ar_due_date=="")
{
  $c->sub_ar_due_date=null;
}

if($c->sub_ar_other_reference_date=="")
{
  $c->sub_ar_other_reference_date=null;
}

if($c->sub_ar_ex_rate=="")
{
  $c->sub_ar_ex_rate=null;
}

$statement->execute(array(':ip'=>$dev->ip,':created_by'=>$dev->username ,
':ua'=>$dev->ua,
':ekey'=>$dev->ekey,

':company_id'=>$dev->company,
':sub_ar_doc_type'=>$c->sub_ar_doc_type,
':sub_ar_doc_number'=>$c->sub_ar_doc_number,
':sub_ar_doc_base'=>$c->sub_ar_doc_base,
':sub_ar_gl_date'=>$c->sub_ar_gl_date,
':sub_ar_due_date'=>$c->sub_ar_due_date,
':sub_ar_age_date'=>$c->sub_ar_date,
':sub_ar_date'=>$c->sub_ar_date,
':sub_ar_other_reference'=>$c->sub_ar_other_reference,
':sub_ar_currency'=>$c->sub_ar_currency,
':sub_ar_ex_rate'=>$c->sub_ar_ex_rate,
':sub_place_off_supply'=>$c->sub_place_off_supply,
':sub_place_off_supply_date'=>$c->sub_place_off_supply_date,
':sub_ar_narration'=>$c->sub_ar_narration,
':sub_ar_notes'=>$c->sub_ar_notes,
':sub_ar_code'=>$c->sub_ar_code,
':sub_ar_status'=>'P',
':sub_ar_other_reference_date'=>$c->sub_ar_other_reference_date,
':igst'=>$igst,

':temp_code'=>$temp_code,
':total_local_amt'=>$c->total_local_amt,
':order_no'=>$code->order_no,
':bl_no'=>$code->bl_no,
':sub_ar_user'=>$dev->username,

':gst_percent'=>$gst_percent,
':igst'=>$igst,
':cgst'=>$cgst,
':sgst'=>$sgst,

':company_id'=>$dev->company,
':location_id'=>$dev->location
));

if ($statement->rowCount()){
  $data["status"]=1;
  $data["msg"]="Saved";
} else{
  $data["status"]=0;
  $data["msg"]="Unable to save. Please try again";

}

//generate doc number

$data["temp_code"]=$temp_code;

$statement = $db->prepare("SELECT id from mt_order_ar_header_draft where created_by=:created_by and temp_code=:temp_code");
$statement->execute(array(':temp_code'=>$temp_code,
  ':created_by'=>$dev->username));
$op=$statement->fetchAll(PDO::FETCH_ASSOC);

$data["id"]=$op;

$fid=self::setFourDigit($op[0]["id"]);

$on="DRAFT/".$fid;

 $statement = $db->prepare("UPDATE mt_order_ar_header_draft 
  SET sub_ar_doc_number=:ond where id=:id");
  $statement->execute(array(':id'=>$op[0]["id"],':ond'=>$on));
  
  if ($statement->rowCount()){
    $data["invid_status"]=1;
  } else{
    $data["invid_status"]=0;
  }

$data["doc_no"]=$on;

//doc number ends

$order_id=0;
$order_details_insert_count=0;

if($data["status"]==1)
{
  $cds=$code->cd;
  $ocds=$code->ocd;

$q="INSERT into mt_order_ar_details_draft(
      sub_ard_company,sub_ard_doc_type,sub_ard_doc_number,sub_ard_serial,sub_ard_currency,sub_ard_ex_rate,sub_ard_foreign_amount,sub_ard_local_amount,sub_ard_narration,sub_ard_notes,sub_ard_detail_1,sub_ard_detail_2,sub_ard_detail_3,sub_ard_detail_4,sub_ard_detail_5,sub_ard_detail_6,sub_ard_basis,sub_ard_rate,sub_ard_quantity,ip,created_by ,ua,ekey,created_date,charge_desc,basis_type,taxable,total_tax_amt,total_amt,
      inv_status,charge_id) 
      VALUES(:sub_ard_company,:sub_ard_doc_type,:sub_ard_doc_number,:sub_ard_serial,:sub_ard_currency,:sub_ard_ex_rate,:sub_ard_foreign_amount,:sub_ard_local_amount,:sub_ard_narration,:sub_ard_notes,:sub_ard_detail_1,:sub_ard_detail_2,:sub_ard_detail_3,:sub_ard_detail_4,:sub_ard_detail_5,:sub_ard_detail_6,:sub_ard_basis,:sub_ard_rate,:sub_ard_quantity,:ip ,:created_by ,
:ua ,:ekey,now(),:charge_desc,:basis_type,:taxable,:total_tax_amt,:total_amt,
:inv_status,:charge_id)";


$i=0;
$c->sub_ar_doc_number = $on;

  for(;$i<count($cds);$i++)
  {
    $cd=$cds[$i];
    $statement = $db->prepare($q);
    $ar=self::setChargeDetails('MANIFEST',$cd,$dev,$c,$i);
    $ar[':inv_status']='PROFORMA';
    $statement->execute($ar);

    if ($statement->rowCount())
    {
      $order_details_insert_count+=1;
    }
  }
}

//$data["status"]=0;
if($data["invid_status"]==1 && $data["status"]==1 && count($cds)==$order_details_insert_count)
{
  $db->commit();
}else{
  $db->rollBack();
  $data["status"]=0;
  $data["msg"]="Unable to save. Please try again";
}

$statement=null;
  }
  catch (PDOException $e) {
    print $e->getMessage();
    $db->rollBack();

  $data["status"]=0;
  $data["msg"]="Unable to save. Please try again";

  }
  
  return $data;
}


}

?>